/**
 * @license almond 0.3.0 Copyright (c) 2011-2014, The Dojo Foundation All Rights Reserved.
 * Available via the MIT or new BSD license.
 * see: http://github.com/jrburke/almond for details
 */

/*
 * Copyright (C) 2014 United States Government as represented by the Administrator of the
 * National Aeronautics and Space Administration. All Rights Reserved.
 */

/*
 * Copyright (C) 2015 United States Government as represented by the Administrator of the
 * National Aeronautics and Space Administration. All Rights Reserved.
 */

/*
 * @license
 * Copyright 2000, Silicon Graphics, Inc. All Rights Reserved.
 * Copyright 2014, Google Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice including the dates of first publication and
 * either this permission notice or a reference to http://oss.sgi.com/projects/FreeB/
 * shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * SILICON GRAPHICS, INC. BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
 * IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * Original Code. The Original Code is: OpenGL Sample Implementation,
 * Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
 * Inc. The Original Code is Copyright (c) 1991-2000 Silicon Graphics, Inc.
 * Copyright in any portions created by third parties is as indicated
 * elsewhere herein. All Rights Reserved.
 */

/*!
 * @overview es6-promise - a tiny implementation of Promises/A+.
 * @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
 * @license   Licensed under MIT license
 *            See https://raw.githubusercontent.com/jakearchibald/es6-promise/master/LICENSE
 * @version   3.0.2
 */

/*!

JSZip - A Javascript class for generating and reading zip files
<http://stuartk.com/jszip>

(c) 2009-2014 Stuart Knightley <stuart [at] stuartk.com>
Dual licenced under the MIT license or GPLv3. See https://raw.github.com/Stuk/jszip/master/LICENSE.markdown.

JSZip uses the library pako released under the MIT license :
https://github.com/nodeca/pako/blob/master/LICENSE
*/

/**
 * The following functions come from pako, from pako/lib/utils/strings
 * released under the MIT license, see pako https://github.com/nodeca/pako/
 */

!function(t,e){"object"==typeof exports?module.exports=e():"function"==typeof define&&define.amd?define([],e):t.WorldWind=e()}(this,function(){var t,e,i;!function(r){function n(t,e){return v.call(t,e)}function o(t,e){var i,r,n,o,s,a,l,h,u,c,d,p=e&&e.split("/"),f=y.map,g=f&&f["*"]||{};if(t&&"."===t.charAt(0))if(e){for(p=p.slice(0,p.length-1),t=t.split("/"),s=t.length-1,y.nodeIdCompat&&S.test(t[s])&&(t[s]=t[s].replace(S,"")),t=p.concat(t),u=0;u<t.length;u+=1)if(d=t[u],"."===d)t.splice(u,1),u-=1;else if(".."===d){if(1===u&&(".."===t[2]||".."===t[0]))break;u>0&&(t.splice(u-1,2),u-=2)}t=t.join("/")}else 0===t.indexOf("./")&&(t=t.substring(2));if((p||g)&&f){for(i=t.split("/"),u=i.length;u>0;u-=1){if(r=i.slice(0,u).join("/"),p)for(c=p.length;c>0;c-=1)if(n=f[p.slice(0,c).join("/")],n&&(n=n[r])){o=n,a=u;break}if(o)break;!l&&g&&g[r]&&(l=g[r],h=u)}!o&&l&&(o=l,a=h),o&&(i.splice(0,a,o),t=i.join("/"))}return t}function s(t,e){return function(){var i=b.call(arguments,0);return"string"!=typeof i[0]&&1===i.length&&i.push(null),p.apply(r,i.concat([t,e]))}}function a(t){return function(e){return o(e,t)}}function l(t){return function(e){m[t]=e}}function h(t){if(n(E,t)){var e=E[t];delete E[t],_[t]=!0,d.apply(r,e)}if(!n(m,t)&&!n(_,t))throw new Error("No "+t);return m[t]}function u(t){var e,i=t?t.indexOf("!"):-1;return i>-1&&(e=t.substring(0,i),t=t.substring(i+1,t.length)),[e,t]}function c(t){return function(){return y&&y.config&&y.config[t]||{}}}var d,p,f,g,m={},E={},y={},_={},v=Object.prototype.hasOwnProperty,b=[].slice,S=/\.js$/;f=function(t,e){var i,r=u(t),n=r[0];return t=r[1],n&&(n=o(n,e),i=h(n)),n?t=i&&i.normalize?i.normalize(t,a(e)):o(t,e):(t=o(t,e),r=u(t),n=r[0],t=r[1],n&&(i=h(n))),{f:n?n+"!"+t:t,n:t,pr:n,p:i}},g={require:function(t){return s(t)},exports:function(t){var e=m[t];return"undefined"!=typeof e?e:m[t]={}},module:function(t){return{id:t,uri:"",exports:m[t],config:c(t)}}},d=function(t,e,i,o){var a,u,c,d,p,y,v=[],b=typeof i;if(o=o||t,"undefined"===b||"function"===b){for(e=!e.length&&i.length?["require","exports","module"]:e,p=0;p<e.length;p+=1)if(d=f(e[p],o),u=d.f,"require"===u)v[p]=g.require(t);else if("exports"===u)v[p]=g.exports(t),y=!0;else if("module"===u)a=v[p]=g.module(t);else if(n(m,u)||n(E,u)||n(_,u))v[p]=h(u);else{if(!d.p)throw new Error(t+" missing "+u);d.p.load(d.n,s(o,!0),l(u),{}),v[p]=m[u]}c=i?i.apply(m[t],v):void 0,t&&(a&&a.exports!==r&&a.exports!==m[t]?m[t]=a.exports:c===r&&y||(m[t]=c))}else t&&(m[t]=i)},t=e=p=function(t,e,i,n,o){if("string"==typeof t)return g[t]?g[t](e):h(f(t,e).f);if(!t.splice){if(y=t,y.deps&&p(y.deps,y.callback),!e)return;e.splice?(t=e,e=i,i=null):t=r}return e=e||function(){},"function"==typeof i&&(i=n,n=o),n?d(r,t,e,i):setTimeout(function(){d(r,t,e,i)},4),p},p.config=function(t){return p(t)},t._defined=m,i=function(t,e,i){e.splice||(i=e,e=[]),n(m,t)||n(E,t)||(E[t]=[t,e,i])},i.amd={jQuery:!0}}(),i("../tools/almond",function(){}),i("error/AbstractError",[],function(){"use strict";var t=function(t,e){this.name=t,this.message=e};return t.prototype.toString=function(){var t=this.name+": "+this.message;return this.stack&&(t+="\n"+this.stack.toString()),t},t}),i("geom/Angle",[],function(){"use strict";var t={DEGREES_TO_RADIANS:Math.PI/180,RADIANS_TO_DEGREES:180/Math.PI,TWO_PI:2*Math.PI,HALF_PI:Math.PI/2,normalizedDegrees:function(t){var e=t%360;return e>180?e-360:e<-180?360+e:e},normalizedDegreesLatitude:function(t){var e=t%180;return e>90?180-e:e<-90?-180-e:e},normalizedDegreesLongitude:function(t){var e=t%360;return e>180?e-360:e<-180?360+e:e},normalizedRadians:function(t){var e=t%this.TWO_PI;return e>Math.PI?e-this.TWO_PI:e<-Math.PI?this.TWO_PI+e:e},normalizedRadiansLatitude:function(t){var e=t%Math.PI;return e>this.HALF_PI?Math.PI-e:e<-this.HALF_PI?-Math.PI-e:e},normalizedRadiansLongitude:function(t){var e=t%this.TWO_PI;return e>Math.PI?e-this.TWO_PI:e<-Math.PI?this.TWO_PI+e:e},isValidLatitude:function(t){return t>=-90&&t<=90},isValidLongitude:function(t){return t>=-180&&t<=180},toString:function(t){return t.toString()+"°"},toDecimalDegreesString:function(t){return t.toString()+"°"},toDMSString:function(t){var e,i,r,n,o;return e=t<0?-1:1,i=e*t,r=Math.floor(i),i=60*(i-r),n=Math.floor(i),i=60*(i-n),o=Math.round(i),60==o&&(n++,o=0),60==n&&(r++,n=0),(e==-1?"-":"")+r+"° "+n+"’ "+o+"”"},toDMString:function(t){var e,i,r,n,o,s;return e=t<0?-1:1,i=e*t,r=Math.floor(i),i=60*(i-r),n=Math.floor(i),i=60*(i-n),o=Math.round(i),60==o&&(n++,o=0),60==n&&(r++,n=0),s=0==o?n:n+o/60,(e==-1?"-":"")+r+"° "+s+"’"}};return t}),i("util/Logger",[],function(){"use strict";var t={LEVEL_NONE:0,LEVEL_SEVERE:1,LEVEL_WARNING:2,LEVEL_INFO:3,setLoggingLevel:function(t){e=t},getLoggingLevel:function(){return e},log:function(i,r){r&&i>0&&i<=e&&(i===t.LEVEL_SEVERE?console.error(r):i===t.LEVEL_WARNING?console.warn(r):i===t.LEVEL_INFO?console.info(r):console.log(r))},makeMessage:function(t,e,i){var r=this.messageTable[i]?this.messageTable[i]:i;return t+"."+e+": "+r},logMessage:function(t,e,i,r){var n=this.makeMessage(e,i,r);return this.log(t,n),n},messageTable:{abstractInvocation:"The function called is abstract and must be overridden in a subclass.",indexOutOfRange:"The specified index is out of range.",invalidHeight:"The specified height is zero or negative.",invalidWidth:"The specified width is zero or negative.",invalidSize:"The specified size is zero or negative.",missingAltitudeMode:"The specified altitude mode is null or undefined.",missingAttributeName:"The specified DBase attribute file name is null or undefined.",missingArray:"The specified array is null, undefined or of insufficient length.",missingBoundaries:"The specified boundaries array is null or undefined.",missingBuffer:"The specified buffer descriptor is null or undefined.",missingColor:"The specified color is null or undefined.",missingDc:"The specified draw context is null or undefined.",missingDomElement:"The specified DOM element is null or undefined.",missingEntry:"The specified entry is null or undefined.",missingFont:"The specified font is null or undefined.",missingFrustum:"The specified frustum is null or undefined.",missingFunction:"The specified function is null or undefined.",missingGlContext:"The specified WebGL rendering context is null or undefined.",missingGlobe:"The specified globe is null or undefined.",missingImage:"The specified image is null or undefined.",missingIndices:"The specified indices array is null or undefined.",missingKey:"The specified key is null or undefined.",missingLevel:"The specified level is null or undefined.",missingLine:"The specified line is null or undefined.",missingList:"The specified list is null or undefined.",missingListener:"The specified listener is null or undefined",missingLocation:"The specified location is null or undefined.",missingMatrix:"The specified matrix is null or undefined.",missingNavigatorState:"The specified navigator state is null or undefined.",missingOffset:"The specified offset is null or undefined.",missingPath:"The specified path is null or undefined.",missingPlacename:"The specified place name is null or undefined.",missingPlane:"The specified plane is null or undefined.",missingPoint:"The specified point is null or undefined.",missingPoints:"The specified points array is null or undefined.",missingPosition:"The specified position is null or undefined.",missingPositions:"The specified positions array is null or undefined.",missingProgram:"The specified program is null or undefined.",missingProjection:"The specified projection is null or undefined.",missingRectangle:"The specified rectangle is null or undefined.",missingRenderable:"The specified renderable is null or undefined.",missingResource:"The specified resource is null or undefined.",missingResult:"The specified result variable is null or undefined.",missingResults:"The specified results array is null or undefined.",missingSector:"The specified sector is null or undefined.",missingShapeType:"The specified shape type is null or undefined.",missingSize:"The specified size is null or undefined.",missingText:"The specified text is null or undefined.",missingTexture:"The specified texture is null or undefined.",missingTile:"The specified tile is null or undefined.",missingType:"The specified type is null or undefined.",missingUrl:"The specified URL is null or undefined",missingVector:"The specified vector is null or undefined.",missingVertex:"The specified vertex is null or undefined.",missingViewport:"The specified viewport is null or undefined.",missingWorldWindow:"The specified World Window is null or undefined.",notYetImplemented:"This function is not yet implemented"}},e=1;return t}),i("util/Color",["../util/Logger"],function(t){"use strict";var e=function(t,e,i,r){this.red=t,this.green=e,this.blue=i,this.alpha=r};return e.WHITE=new e(1,1,1,1),e.BLACK=new e(0,0,0,1),e.RED=new e(1,0,0,1),e.GREEN=new e(0,1,0,1),e.BLUE=new e(0,0,1,1),e.CYAN=new e(0,1,1,1),e.YELLOW=new e(1,1,0,1),e.MAGENTA=new e(1,0,1,1),e.LIGHT_GRAY=new e(.75,.75,.75,1),e.MEDIUM_GRAY=new e(.5,.5,.5,1),e.DARK_GRAY=new e(.25,.25,.25,1),e.TRANSPARENT=new e(0,0,0,0),e.prototype.set=function(t,e,i,r){return this.red=t,this.green=e,this.blue=i,this.alpha=r,this},e.prototype.copy=function(e){if(!e)throw new ArgumentError(t.logMessage(t.LEVEL_SEVERE,"Color","copy","missingColor"));return this.red=e.red,this.green=e.green,this.blue=e.blue,this.alpha=e.alpha,this},e.prototype.clone=function(){return new e(this.red,this.green,this.blue,this.alpha)},e.prototype.premultipliedComponents=function(t){var e=this.alpha;return t[0]=this.red*e,t[1]=this.green*e,t[2]=this.blue*e,t[3]=e,t},e.colorFromByteArray=function(t){return new e(t[0]/255,t[1]/255,t[2]/255,t[3]/255)},e.colorFromBytes=function(t,i,r,n){return new e(t/255,i/255,r/255,n/255)},e.colorFromHex=function(t){var i=parseInt(t.substring(0,2),16),r=parseInt(t.substring(2,4),16),n=parseInt(t.substring(4,6),16),o=parseInt(t.substring(6,8),16);return e.colorFromBytes(i,r,n,o)},e.colorFromKmlHex=function(t){return t=t.split("").reverse().join(""),e.colorFromHex(t)},e.prototype.nextColor=function(){var t=Math.round(255*this.red),e=Math.round(255*this.green),i=Math.round(255*this.blue);return t<255?this.red=(t+1)/255:e<255?(this.red=0,this.green=(e+1)/255):i<255?(this.red=0,this.green=0,this.blue=(i+1)/255):(this.red=1/255,this.green=0,this.blue=0),this},e.prototype.equals=function(t){var e=Math.round(255*this.red),i=Math.round(255*this.green),r=Math.round(255*this.blue),n=Math.round(255*this.alpha),o=Math.round(255*t.red),s=Math.round(255*t.green),a=Math.round(255*t.blue),l=Math.round(255*t.alpha);return e===o&&i===s&&r===a&&n===l},e.prototype.equalsBytes=function(t){var e=Math.round(255*this.red),i=Math.round(255*this.green),r=Math.round(255*this.blue),n=Math.round(255*this.alpha);return e===t[0]&&i===t[1]&&r===t[2]&&n===t[3]},e.prototype.toByteString=function(){var t=Math.round(255*this.red),e=Math.round(255*this.green),i=Math.round(255*this.blue),r=Math.round(255*this.alpha);return"("+t+","+e+","+i+","+r+")"},e.prototype.toHexString=function(t){var e=Math.ceil(255*this.red).toString(16),i=Math.ceil(255*this.green).toString(16),r=Math.ceil(255*this.blue).toString(16),n=Math.ceil(255*this.alpha).toString(16),o="#";return o+=e.length<2?"0"+e:e,o+=i.length<2?"0"+i:i,o+=r.length<2?"0"+r:r,t&&(o+=n.length<2?"0"+n:n),o},e.prototype.toRGBAString=function(){var t=Math.floor(255*this.red),e=Math.floor(255*this.green),i=Math.floor(255*this.blue);return"rgba("+t+" ,"+e+" ,"+i+" ,"+this.alpha+")"},e}),i("error/ArgumentError",["../error/AbstractError"],function(t){"use strict";var e=function(e){t.call(this,"ArgumentError",e);var i;try{throw new Error}catch(t){i=t.stack}this.stack=i};return e.prototype=Object.create(t.prototype),e}),i("util/Font",["../error/ArgumentError","../util/Color","../util/Logger"],function(t,e,i){"use strict";var r=function(e,r,n,o,s,a){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Font","constructor","missingSize"));if(e<=0)throw new t(i.logMessage(i.LEVEL_SEVERE,"Font","constructor","invalidSize"));this._size=e,this.style=r||"normal",this.variant=n||"normal",this.weight=o||"normal",this.family=s||"sans-serif",this.horizontalAlignment=a||"center"};return Object.defineProperties(r.prototype,{size:{get:function(){return this._size},set:function(t){this._fontString=null,this._size=t}},style:{get:function(){return this._style},set:function(t){this._fontString=null,this._style=t}},variant:{get:function(){return this._variant},set:function(t){this._fontString=null,this._variant=t}},weight:{get:function(){return this._weight},set:function(t){this._fontString=null,this._weight=t}},family:{get:function(){return this._family},set:function(t){this._fontString=null,this._family=t}},horizontalAlignment:{get:function(){return this._horizontalAlignment},set:function(t){this._toString=null,this._horizontalAlignment=t}},fontString:{get:function(){return this._fontString||(this._fontString=this._style+" "+this.variant+" "+this._weight+" "+this._size.toString()+"px "+this._family),this._fontString}}}),r.prototype.toString=function(){return this._toString&&this._fontString||(this._toString=this.fontString+" "+this.horizontalAlignment),this._toString},r}),i("util/Insets",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i,r,n,o){if(4!==arguments.length)throw new t(e.logMessage(e.LEVEL_SEVERE,"Insets","constructor","invalidArgumentCount"));this._top=i,this._left=r,this._bottom=n,this._right=o};return i.prototype.set=function(t,e,i,r){this._top=t,this._left=e,this._bottom=i,this._right=r},i.prototype.clone=function(){return new i(this._top,this._left,this._bottom,this._right)},i.prototype.toString=function(){return this._top+" "+this._left+" "+this._bottom+" "+this._right},Object.defineProperties(i.prototype,{top:{get:function(){return this._top},set:function(t){this._top=t}},left:{get:function(){return this._left},set:function(t){this._left=t}},bottom:{get:function(){return this._bottom},set:function(t){this._bottom=t}},right:{get:function(){return this._right},set:function(t){this._right=t}}}),i}),i("geom/Vec3",["../util/Logger","../error/ArgumentError"],function(t,e){"use strict";var i=function(t,e,i){this[0]=t,this[1]=e,this[2]=i};return i.prototype=new Float64Array(3),i.ZERO=new i(0,0,0),i.average=function(i,r){if(!i||i.length<1)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","average","missingArray"));if(!r)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","average","missingResult"));var n,o=i.length;r[0]=0,r[1]=0,r[2]=0;for(var s=0,a=i.length;s<a;s++)n=i[s],r[0]+=n[0]/o,r[1]+=n[1]/o,r[2]+=n[2]/o;return r},i.averageOfBuffer=function(i,r){if(!i||i.length<1)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","averageBuffer","missingArray"));if(!r)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","averageBuffer","missingResult"));var n=i.length/3;r[0]=0,r[1]=0,r[2]=0;for(var o=0;o<n;o++)r[0]+=i[3*o]/n,r[1]+=i[3*o+1]/n,r[2]+=i[3*o+2]/n;return r},i.areColinear=function(i,r,n){if(!i||!r||!n)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","areColinear","missingVector"));var o=r.subtract(i).normalize(),s=n.subtract(r).normalize();return Math.abs(o.dot(s))>.999},i.computeTriangleNormal=function(r,n,o){if(!r||!n||!o)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","areColinear","missingVector"));var s=(n[1]-r[1])*(o[2]-r[2])-(n[2]-r[2])*(o[1]-r[1]),a=(n[2]-r[2])*(o[0]-r[0])-(n[0]-r[0])*(o[2]-r[2]),l=(n[0]-r[0])*(o[1]-r[1])-(n[1]-r[1])*(o[0]-r[0]),h=s*s+a*a+l*l;return 0===h?new i(s,a,l):(h=Math.sqrt(h),new i(s/h,a/h,l/h))},i.findThreeIndependentVertices=function(t,e){var r=e&&e>0?e:3;if(!t||t.length<3*r)return null;for(var n=new i(t[0],t[1],t[2]),o=null,s=null,a=r;a<t.length&&(o=new i(t[a],t[a+1],t[a+2]),o[0]===n[0]&&o[1]===n[1]&&o[2]===n[2]);a+=r)o=null;if(!o)return null;for(a+=r;a<t.length&&(s=new i(t[a],t[a+1],t[a+2]),s[0]===n[0]&&s[1]===n[1]&&s[2]===n[2]||s[0]===o[0]&&s[1]===o[1]&&s[2]===o[2]||i.areColinear(n,o,s));a+=r)s=null;return s?[n,o,s]:null},i.computeBufferNormal=function(t,e){var r=i.findThreeIndependentVertices(t,e);return r?i.computeTriangleNormal(r[0],r[1],r[2]):null},i.prototype.set=function(t,e,i){return this[0]=t,this[1]=e,this[2]=i,this},i.prototype.copy=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","copy","missingVector"));return this[0]=i[0],this[1]=i[1],this[2]=i[2],this},i.prototype.equals=function(t){return this[0]===t[0]&&this[1]===t[1]&&this[2]===t[2]},i.prototype.add=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","add","missingVector"));return this[0]+=i[0],this[1]+=i[1],this[2]+=i[2],this},i.prototype.subtract=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","subtract","missingVector"));return this[0]-=i[0],this[1]-=i[1],this[2]-=i[2],this},i.prototype.multiply=function(t){return this[0]*=t,this[1]*=t,this[2]*=t,this},i.prototype.divide=function(t){return this[0]/=t,this[1]/=t,this[2]/=t,this},i.prototype.multiplyByMatrix=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","multiplyByMatrix","missingMatrix"));var r=i[0]*this[0]+i[1]*this[1]+i[2]*this[2]+i[3],n=i[4]*this[0]+i[5]*this[1]+i[6]*this[2]+i[7],o=i[8]*this[0]+i[9]*this[1]+i[10]*this[2]+i[11],s=i[12]*this[0]+i[13]*this[1]+i[14]*this[2]+i[15];return this[0]=r/s,this[1]=n/s,this[2]=o/s,this},i.prototype.mix=function(i,r){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","mix","missingVector"));var n=1-r,o=r;return this[0]=this[0]*n+i[0]*o,this[1]=this[1]*n+i[1]*o,this[2]=this[2]*n+i[2]*o,this},i.prototype.negate=function(){return this[0]=-this[0],this[1]=-this[1],this[2]=-this[2],this},i.prototype.dot=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","dot","missingVector"));return this[0]*i[0]+this[1]*i[1]+this[2]*i[2]},i.prototype.cross=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","cross","missingVector"));var r=this[1]*i[2]-this[2]*i[1],n=this[2]*i[0]-this[0]*i[2],o=this[0]*i[1]-this[1]*i[0];return this[0]=r,this[1]=n,this[2]=o,this},i.prototype.magnitudeSquared=function(){return this.dot(this)},i.prototype.magnitude=function(){return Math.sqrt(this.magnitudeSquared())},i.prototype.normalize=function(){var t=this.magnitude(),e=1/t;return this[0]*=e,this[1]*=e,this[2]*=e,this},i.prototype.distanceToSquared=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","distanceToSquared","missingVector"));var r=this[0]-i[0],n=this[1]-i[1],o=this[2]-i[2];return r*r+n*n+o*o},i.prototype.distanceTo=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec3","distanceTo","missingVector"));return Math.sqrt(this.distanceToSquared(i))},i.prototype.swap=function(t){var e=this[0];return this[0]=t[0],t[0]=e,e=this[1],this[1]=t[1],t[1]=e,e=this[2],this[2]=t[2],t[2]=e,this},i.prototype.toString=function(){return"("+this[0]+", "+this[1]+", "+this[2]+")"},i}),i("geom/Vec2",["../util/Logger","../error/ArgumentError","../geom/Vec3"],function(t,e,i){"use strict";var r=function(t,e){this[0]=t,this[1]=e};return r.prototype=new Float64Array(2),r.prototype.set=function(t,e){return this[0]=t,this[1]=e,this},r.prototype.copy=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","copy","missingVector"));return this[0]=i[0],this[1]=i[1],this},r.prototype.equals=function(t){return this[0]===t[0]&&this[1]===t[1]},r.average=function(i,r){if(!i||i.length<1)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","average","missingArray"));if(!r)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","average","missingResult"));var n,o=i.length;r[0]=0,r[1]=0;for(var s=0,a=i.length;s<a;s++)n=i[s],r[0]+=n[0]/o,r[1]+=n[1]/o;return r},r.prototype.add=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","add","missingVector"));return this[0]+=i[0],this[1]+=i[1],this},r.prototype.subtract=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","subtract","missingVector"));return this[0]-=i[0],this[1]-=i[1],this},r.prototype.multiply=function(t){return this[0]*=t,this[1]*=t,this},r.prototype.divide=function(t){return this[0]/=t,this[1]/=t,this},r.prototype.mix=function(i,r){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","mix","missingVector"));var n=1-r,o=r;return this[0]=this[0]*n+i[0]*o,this[1]=this[1]*n+i[1]*o,this},r.prototype.negate=function(){return this[0]=-this[0],this[1]=-this[1],this},r.prototype.dot=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","dot","missingVector"));return this[0]*i[0]+this[1]*i[1]},r.prototype.magnitudeSquared=function(){return this.dot(this)},r.prototype.magnitude=function(){return Math.sqrt(this.magnitudeSquared())},r.prototype.normalize=function(){var t=this.magnitude(),e=1/t;return this[0]*=e,this[1]*=e,this},r.prototype.distanceToSquared=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","distanceToSquared","missingVector"));var r=this[0]-i[0],n=this[1]-i[1];return r*r+n*n},r.prototype.distanceTo=function(i){if(!i)throw new e(t.logMessage(t.LEVEL_SEVERE,"Vec2","distanceTo","missingVector"));return Math.sqrt(this.distanceToSquared(i))},r.prototype.toVec3=function(){return new i(this[0],this[1],0)},r.prototype.swap=function(t){var e=this[0];return this[0]=t[0],t[0]=e,e=this[1],this[1]=t[1],t[1]=e,this},r.prototype.toString=function(){return"("+this[0]+", "+this[1]+")"},r}),i("util/Offset",["../geom/Vec2"],function(t){"use strict";var e=function(t,e,i,r){this.x=e,this.y=r,this.xUnits=t,this.yUnits=i};return e.prototype.clone=function(){return new e(this.xUnits,this.x,this.yUnits,this.y)},e.prototype.offsetForSize=function(e,i){var r,n;return r=this.xUnits==WorldWind.OFFSET_FRACTION?e*this.x:this.xUnits==WorldWind.OFFSET_INSET_PIXELS?e-this.x:this.x,n=this.yUnits==WorldWind.OFFSET_FRACTION?i*this.y:this.yUnits==WorldWind.OFFSET_INSET_PIXELS?i-this.y:this.y,new t(r,n)},e.prototype.toString=function(){return this.xUnits+" "+this.x+" "+this.yUnits+" "+this.y},e}),i("shapes/TextAttributes",["../util/Color","../util/Font","../util/Offset"],function(t,e,i){"use strict";var r=function(r){this._color=r?r._color:new t(1,1,1,1),this._font=r?r._font:new e(14),this._offset=r?r._offset:new i(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,0),this._scale=r?r._scale:1,this._depthTest=!!r&&r._depthTest,this.stateKeyInvalid=!0};return r.prototype.computeStateKey=function(){return"c "+this._color.toHexString(!0)+" f "+this._font.toString()+" o "+this._offset.toString()+" s "+this._scale+" dt "+this._depthTest},Object.defineProperties(r.prototype,{stateKey:{get:function(){return this.stateKeyInvalid&&(this._stateKey=this.computeStateKey(),this.stateKeyInvalid=!1),this._stateKey}},color:{get:function(){return this._color},set:function(t){this._color=t,this.stateKeyInvalid=!0}},font:{get:function(){return this._font},set:function(t){this._font=t,this.stateKeyInvalid=!0}},offset:{get:function(){return this._offset},set:function(t){this._offset=t,this.stateKeyInvalid=!0}},scale:{get:function(){return this._scale},set:function(t){this._scale=t,this.stateKeyInvalid=!0}},depthTest:{get:function(){return this._depthTest},set:function(t){this._depthTest=t,this.stateKeyInvalid=!0}}}),r}),i("shapes/AnnotationAttributes",["../util/Color","../util/Font","../util/Insets","../shapes/TextAttributes"],function(t,e,i,r){"use strict";var n=function(e){this._cornerRadius=e?e._cornerRadius:0,this._insets=e?e._insets:new i(0,0,0,0),this._backgroundColor=e?e._backgroundColor:t.WHITE,this._leaderGapWidth=e?e._leaderGapWidth:40,this._leaderGapHeight=e?e._leaderGapHeight:30,this._opacity=e?e._opacity:1,this._scale=e?e._scale:1,this._drawLeader=!e||e._drawLeader,this._width=e?e._width:200,this._height=e?e._height:100,this._textAttributes=e?e._textAttributes:new r(null),this.stateKeyInvalid=!0};return n.prototype.computeStateKey=function(){return"wi "+this._width+" he "+this._height+" cr "+this._cornerRadius+" in "+this._insets.toString()+" bg "+this.backgroundColor.toHexString(!0)+" dl "+this.drawLeader+" lgw "+this.leaderGapWidth+" lgh "+this.leaderGapHeight+" op "+this.opacity+" ta "+this._textAttributes.stateKey+" sc "+this.scale},Object.defineProperties(n.prototype,{width:{get:function(){return this._width},set:function(t){this._width=t,this.stateKeyInvalid=!0}},height:{get:function(){return this._height},set:function(t){this._height=t,this.stateKeyInvalid=!0}},cornerRadius:{get:function(){return this._cornerRadius},set:function(t){this._cornerRadius=t,this.stateKeyInvalid=!0}},insets:{get:function(){return this._insets},set:function(t){this._insets=t,this.stateKeyInvalid=!0}},backgroundColor:{get:function(){return this._backgroundColor},set:function(t){this._backgroundColor=t,this.stateKeyInvalid=!0}},textAttributes:{get:function(){return this._textAttributes},set:function(t){this._textAttributes=t,this.stateKeyInvalid=!0}},drawLeader:{get:function(){return this._drawLeader},set:function(t){this._drawLeader=t,this.stateKeyInvalid=!0}},leaderGapWidth:{get:function(){return this._leaderGapWidth},set:function(t){this._leaderGapWidth=t,this.stateKeyInvalid=!0}},leaderGapHeight:{get:function(){return this._leaderGapHeight},set:function(t){this._leaderGapHeight=t,this.stateKeyInvalid=!0}},opacity:{get:function(){return this._opacity},set:function(t){this._opacity=t,this.stateKeyInvalid=!0}},scale:{get:function(){return this._scale},set:function(t){this._scale=t,this.stateKeyInvalid=!0}},stateKey:{get:function(){return this.stateKeyInvalid&&(this._stateKey=this.computeStateKey(),this.stateKeyInvalid=!1),this._stateKey}}}),n}),i("shaders/GpuShader",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i,r,n){if(r!==i.VERTEX_SHADER&&r!==i.FRAGMENT_SHADER)throw new t(e.logMessage(e.LEVEL_SEVERE,"GpuShader","constructor","The specified shader type is unrecognized."));if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"GpuShader","constructor","The specified shader source is null or undefined."));var o=i.createShader(r);if(!o)throw new t(e.logMessage(e.LEVEL_SEVERE,"GpuShader","constructor","Unable to create shader of type "+(r==i.VERTEX_SHADER?"VERTEX_SHADER.":"FRAGMENT_SHADER.")));if(!this.compile(i,o,r,n)){var s=i.getShaderInfoLog(o);throw i.deleteShader(o),new t(e.logMessage(e.LEVEL_SEVERE,"GpuShader","constructor","Unable to compile shader: "+s))}this.shaderId=o};return i.prototype.compile=function(t,e,i,r){return t.shaderSource(e,r),t.compileShader(e),t.getShaderParameter(e,t.COMPILE_STATUS)},i.prototype.dispose=function(t){this.shaderId&&(t.deleteShader(this.shaderId),delete this.shaderId)},i}),i("shaders/GpuProgram",["../error/ArgumentError","../util/Color","../shaders/GpuShader","../util/Logger"],function(t,e,i,r){"use strict";var n=function(e,n,o,s){if(!n||!o)throw new t(r.logMessage(r.LEVEL_SEVERE,"GpuProgram","constructor","The specified shader source is null or undefined."));var a,l,h;try{l=new i(e,e.VERTEX_SHADER,n),h=new i(e,e.FRAGMENT_SHADER,o)}catch(t){throw l&&l.dispose(e),h&&h.dispose(e),t}if(a=e.createProgram(),!a)throw new t(r.logMessage(r.LEVEL_SEVERE,"GpuProgram","constructor","Unable to create shader program."));if(e.attachShader(a,l.shaderId),e.attachShader(a,h.shaderId),s)for(var u=0,c=s.length;u<c;u++)e.bindAttribLocation(a,u,s[u]);if(!this.link(e,a)){var d=e.getProgramInfoLog(a);throw e.detachShader(a,l.shaderId),e.detachShader(a,h.shaderId),e.deleteProgram(a),l.dispose(e),h.dispose(e),new t(r.logMessage(r.LEVEL_SEVERE,"GpuProgram","constructor","Unable to link shader program: "+d))}this.programId=a,this.attributeLocations={},this.uniformLocations={},this.vertexShader=l,this.fragmentShader=h,this.size=n.length+o.length,this.scratchArray=new Float32Array(16)};return n.prototype.dispose=function(t){this.programId&&(this.vertexShader&&t.detachShader(this.programId,this.vertexShader.shaderId),this.fragmentShader&&t.detachShader(this.programId,this.fragmentShader.shaderId),t.deleteProgram(this.programId),delete this.programId),this.vertexShader&&(this.vertexShader.dispose(t),delete this.vertexShader),this.fragmentShader&&(this.fragmentShader.dispose(t),delete this.fragmentShader),this.attributeLocations={},this.uniformLocations={}},n.prototype.attributeLocation=function(e,i){if(!i||0==i.length)throw new t(r.logMessage(r.LEVEL_SEVERE,"GpuProgram","attributeLocation","The specified attribute name is null, undefined or empty."));var n=this.attributeLocations[i];return n||(n=e.getAttribLocation(this.programId,i),this.attributeLocations[i]=n),n},n.prototype.uniformLocation=function(e,i){if(!i||0==i.length)throw new t(r.logMessage(r.LEVEL_SEVERE,"GpuProgram","uniformLocation","The specified uniform name is null, undefined or empty."));var n=this.uniformLocations[i];return n||(n=e.getUniformLocation(this.programId,i),this.uniformLocations[i]=n),n},n.prototype.link=function(t,e){return t.linkProgram(e),t.getProgramParameter(e,t.LINK_STATUS)},n.prototype.loadUniformMatrix=function(e,i,n){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"GpuProgram","loadUniformMatrix","missingMatrix"));var o=i.columnMajorComponents(this.scratchArray);e.uniformMatrix4fv(n,!1,o)},n.prototype.loadUniformColor=function(e,i,n){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"GpuProgram","loadUniformColor","missingColor"));var o=i.premultipliedComponents(this.scratchArray);e.uniform4f(n,o[0],o[1],o[2],o[3])},n.prototype.loadUniformColorComponents=function(t,e,i,r,n,o){t.uniform4f(o,e*n,i*n,r*n,n)},n}),i("shaders/BasicTextureProgram",["../error/ArgumentError","../util/Color","../shaders/GpuProgram","../util/Logger"],function(t,e,i,r){"use strict";var n=function(t){var e="attribute vec4 vertexPoint;\nattribute vec4 vertexTexCoord;\nattribute vec4 normalVector;\nuniform mat4 mvpMatrix;\nuniform mat4 mvInverseMatrix;\nuniform mat4 texCoordMatrix;\nuniform bool applyLighting;\nvarying vec2 texCoord;\nvarying vec4 normal;\nvoid main() {gl_Position = mvpMatrix * vertexPoint;\ntexCoord = (texCoordMatrix * vertexTexCoord).st;\nif (applyLighting) {normal = mvInverseMatrix * normalVector;}\n}",r="precision mediump float;\nuniform float opacity;\nuniform vec4 color;\nuniform bool enableTexture;\nuniform bool modulateColor;\nuniform sampler2D textureSampler;\nuniform bool applyLighting;\nvarying vec2 texCoord;\nvarying vec4 normal;\nvoid main() {\nvec4 textureColor = texture2D(textureSampler, texCoord);\nfloat ambient = 0.15; vec4 lightDirection = vec4(0, 0, 1, 0);\nif (enableTexture && !modulateColor)\n    gl_FragColor = textureColor * color * opacity;\nelse if (enableTexture && modulateColor)\n    gl_FragColor = color * floor(textureColor.a + 0.5);\nelse\n    gl_FragColor = color * opacity;\nif (gl_FragColor.a == 0.0) {discard;}\nif (applyLighting) {\n    vec4 n = normal * (gl_FrontFacing ? 1.0 : -1.0);\n    gl_FragColor.rgb *= clamp(ambient + dot(lightDirection, n), 0.0, 1.0);\n}\n}",n=["vertexPoint","normalVector","vertexTexCoord"];i.call(this,t,e,r,n),this.vertexPointLocation=this.attributeLocation(t,"vertexPoint"),this.normalVectorLocation=this.attributeLocation(t,"normalVector"),this.vertexTexCoordLocation=this.attributeLocation(t,"vertexTexCoord"),this.mvpMatrixLocation=this.uniformLocation(t,"mvpMatrix"),this.mvInverseMatrixLocation=this.uniformLocation(t,"mvInverseMatrix"),this.colorLocation=this.uniformLocation(t,"color"),this.textureEnabledLocation=this.uniformLocation(t,"enableTexture"),this.modulateColorLocation=this.uniformLocation(t,"modulateColor"),this.textureUnitLocation=this.uniformLocation(t,"textureSampler"),this.textureMatrixLocation=this.uniformLocation(t,"texCoordMatrix"),this.opacityLocation=this.uniformLocation(t,"opacity"),this.applyLightingLocation=this.uniformLocation(t,"applyLighting")};return n.key="WorldWindGpuBasicTextureProgram",n.prototype=Object.create(i.prototype),n.prototype.loadModelviewInverse=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"BasicTextureProgram","loadModelviewInverse","missingMatrix"));this.loadUniformMatrix(e,i,this.mvInverseMatrixLocation)},n.prototype.loadModelviewProjection=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"BasicTextureProgram","loadModelviewProjection","missingMatrix"));this.loadUniformMatrix(e,i,this.mvpMatrixLocation);
},n.prototype.loadColor=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"BasicTextureProgram","loadColor","missingColor"));this.loadUniformColor(e,i,this.colorLocation)},n.prototype.loadTextureEnabled=function(t,e){t.uniform1i(this.textureEnabledLocation,e?1:0)},n.prototype.loadModulateColor=function(t,e){t.uniform1i(this.modulateColorLocation,e?1:0)},n.prototype.loadTextureUnit=function(t,e){t.uniform1i(this.textureUnitLocation,e-t.TEXTURE0)},n.prototype.loadTextureMatrix=function(t,e){this.loadUniformMatrix(t,e,this.textureMatrixLocation)},n.prototype.loadOpacity=function(t,e){t.uniform1f(this.opacityLocation,e)},n.prototype.loadApplyLighting=function(t,e){t.uniform1i(this.applyLightingLocation,e)},n}),i("geom/Line",["../error/ArgumentError","../util/Logger","../geom/Vec3"],function(t,e,i){"use strict";var r=function(i,r){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"Line","constructor","Origin is null or undefined."));if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"Line","constructor","Direction is null or undefined."));this.origin=i,this.direction=r};return r.fromSegment=function(n,o){if(!n||!o)throw new t(e.logMessage(e.LEVEL_SEVERE,"Line","fromSegment","missingPoint"));var s=new i(n[0],n[1],n[2]),a=new i(o[0]-n[0],o[1]-n[1],o[2]-n[2]);return new r(s,a)},r.prototype.pointAt=function(i,r){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"Line","pointAt","missingResult."));return r[0]=this.origin[0]+this.direction[0]*i,r[1]=this.origin[1]+this.direction[1]*i,r[2]=this.origin[2]+this.direction[2]*i,r},r}),i("geom/Plane",["../error/ArgumentError","../geom/Line","../util/Logger","../geom/Vec3"],function(t,e,i,r){"use strict";var n=function(t,e,i,n){this.normal=new r(t,e,i),this.distance=n};return n.fromPoints=function(e,o,s){if(!e||!o||!s)throw new t(i.logMessage(i.LEVEL_SEVERE,"Plane","fromPoints","missingVector"));var a=new r(o[0],o[1],o[2]);a.subtract(e);var l=new r(s[0],s[1],s[2]);l.subtract(e),a.cross(l),a.normalize();var h=-a.dot(e);return new n(a[0],a[1],a[2],h)},n.prototype.dot=function(e){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Plane","dot","missingVector"));return this.normal.dot(e)+this.distance},n.prototype.distanceToPoint=function(t){return this.dot(t)},n.prototype.transformByMatrix=function(e){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Plane","transformByMatrix","missingMatrix"));var r=e[0]*this.normal[0]+e[1]*this.normal[1]+e[2]*this.normal[2]+e[3]*this.distance,n=e[4]*this.normal[0]+e[5]*this.normal[1]+e[6]*this.normal[2]+e[7]*this.distance,o=e[8]*this.normal[0]+e[9]*this.normal[1]+e[10]*this.normal[2]+e[11]*this.distance,s=e[12]*this.normal[0]+e[13]*this.normal[1]+e[14]*this.normal[2]+e[15]*this.distance;return this.normal[0]=r,this.normal[1]=n,this.normal[2]=o,this.distance=s,this},n.prototype.normalize=function(){var t=this.normal.magnitude();return 0===t?this:(this.normal.divide(t),this.distance/=t,this)},n.prototype.intersectsSegment=function(t,e){var i=this.dot(t),r=this.dot(e);return i*r<=0},n.prototype.intersectsSegmentAt=function(t,e,i){var r=this.dot(t),n=this.dot(e);if(0===r&&0===n)return i[0]=t[0],i[1]=t[1],i[2]=t[2],!0;if(r===n)return!1;var o=-r/(n-r),s=1-o;return i[0]=o*t[0]+s*e[0],i[1]=o*t[1]+s*e[1],i[2]=o*t[2]+s*e[2],r*n<=0},n.prototype.onSameSide=function(e,r){if(!e||!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"Plane","onSameSide","missingPoint"));var n=this.distanceToPoint(e),o=this.distanceToPoint(r);return n<0&&o<0?-1:n>0&&o>0?1:0},n.prototype.clip=function(n,o){if(!n||!o)throw new t(i.logMessage(i.LEVEL_SEVERE,"Plane","clip","missingPoint"));if(n.equals(o))return null;var s,a,l,h=e.fromSegment(n,o),u=this.normal.dot(h.direction);return 0===u?(s=this.dot(h.origin),0===s?[n,o]:null):(a=-this.dot(h.origin)/u,a<0||a>1?null:(l=h.pointAt(a,new r(0,0,0)),u>0?[l,o]:[n,l]))},n}),i("geom/Rectangle",["../util/Logger"],function(t){"use strict";var e=function(t,e,i,r){this.x=t,this.y=e,this.width=i,this.height=r};return e.prototype.set=function(t,e,i,r){this.x=t,this.y=e,this.width=i,this.height=r},e.prototype.getMinX=function(){return this.x},e.prototype.getMinY=function(){return this.y},e.prototype.getMaxX=function(){return this.x+this.width},e.prototype.getMaxY=function(){return this.y+this.height},e.prototype.containsPoint=function(t){return t[0]>=this.x&&t[0]<=this.x+this.width&&t[1]>=this.y&&t[1]<=this.y+this.height},e.prototype.intersects=function(t){return!(t.x+t.width<this.x)&&(!(t.x>this.x+this.width)&&(!(t.y+t.height<this.y)&&!(t.y>this.y+this.height)))},e.prototype.intersectsRectangles=function(t){if(t)for(var e=0;e<t.length;e++)if(this.intersects(t[e]))return!0;return!1},e.prototype.toString=function(){return this.x+", "+this.y+", "+this.width+", "+this.height},e}),i("util/WWMath",["../geom/Angle","../error/ArgumentError","../geom/Line","../util/Logger","../geom/Rectangle","../geom/Vec3"],function(t,e,i,r,n,o){"use strict";var s={clamp:function(t,e,i){return t<e?e:t>i?i:t},interpolate:function(t,e,i){return(1-t)*e+t*i},cbrt:function(t){return"function"==typeof Math.cbrt?Math.cbrt(t):Math.pow(t,1/3)},computeEllipsoidalGlobeIntersection:function(t,i,n,o){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeEllipsoidalGlobeIntersection","missingLine"));if(!o)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeEllipsoidalGlobeIntersection","missingResult"));var s,a=t.direction[0],l=t.direction[1],h=t.direction[2],u=t.origin[0],c=t.origin[1],d=t.origin[2],p=i/n,f=p*p,g=i*i,m=a*a+f*l*l+h*h,E=2*(u*a+f*c*l+d*h),y=u*u+f*c*c+d*d-g,_=E*E-4*m*y;return!(_<0)&&(s=(-E-Math.sqrt(_))/(2*m),o[0]=u+a*s,o[1]=c+l*s,o[2]=d+h*s,!0)},computeTriangleIntersection:function(t,i,n,o,s){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeTriangleIntersection","missingLine"));if(!i||!n||!o)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeTriangleIntersection","missingVertex"));if(!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeTriangleIntersection","missingResult"));var a=t.direction[0],l=t.direction[1],h=t.direction[2],u=t.origin[0],c=t.origin[1],d=t.origin[2],p=1e-5,f=n[0]-i[0],g=n[1]-i[1],m=n[2]-i[2],E=o[0]-i[0],y=o[1]-i[1],_=o[2]-i[2],v=l*_-h*y,b=h*E-a*_,S=a*y-l*E,T=f*v+g*b+m*S;if(T>-p&&T<p)return!1;var L=1/T,w=u-i[0],x=c-i[1],R=d-i[2],M=L*(w*v+x*b+R*S);if(M<-p||M>1+p)return!1;var C=x*m-R*g,A=R*f-w*m,P=w*g-x*f,O=L*(a*C+l*A+h*P);if(O<-p||M+O>1+p)return!1;var I=L*(E*C+y*A+_*P);return!(I<0)&&(s[0]=u+a*I,s[1]=c+l*I,s[2]=d+h*I,!0)},computeIndexedTrianglesIntersection:function(t,i,n,a){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeIndexedTrianglesIntersection","missingLine"));if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeIndexedTrianglesIntersection","missingPoints"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeIndexedTrianglesIntersection","missingIndices"));if(!a)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeIndexedTrianglesIntersection","missingResults"));for(var l=new o(0,0,0),h=new o(0,0,0),u=new o(0,0,0),c=new o(0,0,0),d=0,p=n.length;d<p;d+=3){var f=3*n[d],g=3*n[d+1],m=3*n[d+2];l[0]=i[f],l[1]=i[f+1],l[2]=i[f+2],h[0]=i[g],h[1]=i[g+1],h[2]=i[g+2],u[0]=i[m],u[1]=i[m+1],u[2]=i[m+2],s.computeTriangleIntersection(t,l,h,u,c)&&(a.push(c),c=new o(0,0,0))}return a.length>0},computeTriStripIntersections:function(t,i,n,s){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeTriStripIntersections","missingLine"));if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeTriStripIntersections","missingPoints"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeTriStripIntersections","missingIndices"));if(!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","computeTriStripIntersections","missingResults"));var a,l,h,u,c,d,p,f,g,m,E,y,_,v,b,S,T,L,w,x,R,M,C,A,P,O,I,N,D,V,k=t.direction[0],F=t.direction[1],G=t.direction[2],W=t.origin[0],B=t.origin[1],U=t.origin[2],j=1e-5;V=3*n[0],u=i[V++],c=i[V++],d=i[V],V=3*n[1],p=i[V++],f=i[V++],g=i[V];for(var K=2,z=n.length;K<z;K++)a=u,l=c,h=d,u=p,c=f,d=g,V=3*n[K],p=i[V++],f=i[V++],g=i[V],m=u-a,E=c-l,y=d-h,_=p-a,v=f-l,b=g-h,S=F*b-G*v,T=G*_-k*b,L=k*v-F*_,N=m*S+E*T+y*L,N>-j&&N<j||(D=1/N,w=W-a,x=B-l,R=U-h,P=D*(w*S+x*T+R*L),P<-j||P>1+j||(M=x*y-R*E,C=R*m-w*y,A=w*E-x*m,O=D*(k*M+F*C+G*A),O<-j||P+O>1+j||(I=D*(_*M+v*C+b*A),I>=0&&s.push(new o(W+k*I,B+F*I,U+G*I)))))},fabs:function(t){return t>=0?t:-t},fmod:function(t,e){return 0===e?0:t-Math.floor(t/e)*e},fract:function(t){return t-Math.floor(t)},mod:function(t,e){return(t%e+e)%e},max:function(t,e){return t>e?t:e},localCoordinateAxesAtPoint:function(t,i,n,o,s){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","localCoordinateAxesAtPoint","missingVector"));if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","localCoordinateAxesAtPoint","missingGlobe"));if(!n||!o||!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","localCoordinateAxesAtPoint","missingResult"));var a=t[0],l=t[1],h=t[2];i.surfaceNormalAtPoint(a,l,h,s),i.northTangentAtPoint(a,l,h,o),n.set(o[0],o[1],o[2]),n.cross(s),n.normalize(),o.set(s[0],s[1],s[2]),o.cross(n),o.normalize()},horizonDistanceForGlobeRadius:function(t,i){if(t<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","horizontalDistanceForGlobeRadius","The specified globe radius is negative."));return t>0&&i>0?Math.sqrt(i*(2*t+i)):0},perspectiveNearDistanceForFarDistance:function(t,i,n){if(t<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveNearDistanceForFarDistance","The specified distance is negative."));if(i<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveNearDistanceForFarDistance","The specified resolution is negative."));if(n<1)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveNearDistanceForFarDistance","The specified depth bits is negative."));var o=(1<<n)-1;return t/(o/(1-i/t)-o+1)},perspectiveNearDistance:function(t,i,n){if(t<=0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveNearDistance","invalidWidth"));if(i<=0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveNearDistance","invalidHeight"));if(n<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveNearDistance","The specified distance is negative."));var o=i/t;return 2*n/Math.sqrt(o*o+5)},perspectiveFrustumRectangle:function(t,i,o){if(t<=0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveFrustumRectangle","invalidWidth"));if(i<=0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveFrustumRectangle","invalidHeight"));if(o<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectiveFrustumRectangle","The specified distance is negative."));var s=o,a=o*i/t;return new n(-s/2,-a/2,s,a)},perspectivePixelSize:function(t,i,n){if(t<=0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectivePixelSize","invalidWidth"));if(i<=0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectivePixelSize","invalidHeight"));if(n<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","perspectivePixelSize","The specified distance is negative."));var o=s.perspectiveFrustumRectangle(t,i,n).height;return o/i},boundingRectForUnitQuad:function(t){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"WWMath","boundingRectForUnitQuad","missingMatrix"));var i=t,o=i[3],s=i[7],a=i[0]+i[3],l=i[4]+i[7],h=i[1]+i[3],u=i[5]+i[7],c=i[0]+i[1]+i[3],d=i[4]+i[5]+i[7],p=Math.min(Math.min(o,a),Math.min(h,c)),f=Math.max(Math.max(o,a),Math.max(h,c)),g=Math.min(Math.min(s,l),Math.min(u,d)),m=Math.max(Math.max(s,l),Math.max(u,d));return new n(p,g,f-p,m-g)},isPowerOfTwo:function(t){return 0!=t&&0===(t&t-1)},signum:function(t){return t>0?1:t<0?-1:0},gudermannianInverse:function(e){return Math.log(Math.tan(Math.PI/4+e*t.DEGREES_TO_RADIANS/2))/Math.PI},epsg3857ToEpsg4326:function(e,i){var r=6378100,n=Math.PI/2-2*Math.atan(Math.exp(-i/r)),o=e/r;return[s.clamp(n*t.RADIANS_TO_DEGREES,-90,90),s.clamp(o*t.RADIANS_TO_DEGREES,-180,180)]},powerOfTwoFloor:function(t){var e=Math.floor(Math.log(t)/Math.log(2));return Math.pow(2,e)}};return s}),i("geom/Location",["../geom/Angle","../error/ArgumentError","../util/Logger","../geom/Plane","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o){"use strict";var s=function(t,e){this.latitude=t,this.longitude=e};return s.ZERO=new s(0,0),s.fromRadians=function(e,i){return new s(e*t.RADIANS_TO_DEGREES,i*t.RADIANS_TO_DEGREES)},s.prototype.copy=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","copy","missingLocation"));return this.latitude=t.latitude,this.longitude=t.longitude,this},s.prototype.set=function(t,e){return this.latitude=t,this.longitude=e,this},s.prototype.equals=function(t){return t&&t.latitude===this.latitude&&t.longitude===this.longitude},s.interpolateAlongPath=function(t,r,n,o,s){if(!n||!o)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateAlongPath","missingLocation"));if(!s)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateAlongPath","missingResult"));return t===WorldWind.GREAT_CIRCLE?this.interpolateGreatCircle(r,n,o,s):t&&t===WorldWind.RHUMB_LINE?this.interpolateRhumb(r,n,o,s):this.interpolateLinear(r,n,o,s)},s.interpolateGreatCircle=function(t,r,n,s){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateGreatCircle","missingLocation"));if(!s)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateGreatCircle","missingResult"));if(r.equals(n))return s.latitude=r.latitude,s.longitude=r.longitude,s;var a=o.clamp(t,0,1),l=this.greatCircleAzimuth(r,n),h=this.greatCircleDistance(r,n);return this.greatCircleLocation(r,l,a*h,s)},s.greatCircleAzimuth=function(r,n){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","greatCircleAzimuth","missingLocation"));var o,s,a,l=r.latitude*t.DEGREES_TO_RADIANS,h=n.latitude*t.DEGREES_TO_RADIANS,u=r.longitude*t.DEGREES_TO_RADIANS,c=n.longitude*t.DEGREES_TO_RADIANS;return l==h&&u==c?0:u==c?l>h?180:0:(s=Math.cos(h)*Math.sin(c-u),o=Math.cos(l)*Math.sin(h)-Math.sin(l)*Math.cos(h)*Math.cos(c-u),a=Math.atan2(s,o),isNaN(a)?0:a*t.RADIANS_TO_DEGREES)},s.greatCircleDistance=function(r,n){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","greatCircleDistance","missingLocation"));var o,s,a,l,h=r.latitude*t.DEGREES_TO_RADIANS,u=n.latitude*t.DEGREES_TO_RADIANS,c=r.longitude*t.DEGREES_TO_RADIANS,d=n.longitude*t.DEGREES_TO_RADIANS;return h==u&&c==d?0:(o=Math.sin((u-h)/2),s=Math.sin((d-c)/2),a=o*o+Math.cos(h)*Math.cos(u)*s*s,l=2*Math.asin(Math.sqrt(a)),isNaN(l)?0:l)},s.greatCircleLocation=function(r,n,o,s){if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","greatCircleLocation","missingLocation"));if(!s)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","greatCircleLocation","missingResult"));if(0==o)return s.latitude=r.latitude,s.longitude=r.longitude,s;var a,l,h=r.latitude*t.DEGREES_TO_RADIANS,u=r.longitude*t.DEGREES_TO_RADIANS,c=n*t.DEGREES_TO_RADIANS;return a=Math.asin(Math.sin(h)*Math.cos(o)+Math.cos(h)*Math.sin(o)*Math.cos(c)),l=u+Math.atan2(Math.sin(o)*Math.sin(c),Math.cos(h)*Math.cos(o)-Math.sin(h)*Math.sin(o)*Math.cos(c)),isNaN(a)||isNaN(l)?(s.latitude=r.latitude,s.longitude=r.longitude):(s.latitude=t.normalizedDegreesLatitude(a*t.RADIANS_TO_DEGREES),s.longitude=t.normalizedDegreesLongitude(l*t.RADIANS_TO_DEGREES)),s},s.interpolateRhumb=function(t,r,n,s){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateRhumb","missingLocation"));if(!s)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateRhumb","missingResult"));if(r.equals(n))return s.latitude=r.latitude,s.longitude=r.longitude,s;var a=o.clamp(t,0,1),l=this.rhumbAzimuth(r,n),h=this.rhumbDistance(r,n);return this.rhumbLocation(r,l,a*h,s)},s.rhumbAzimuth=function(r,n){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","rhumbAzimuth","missingLocation"));var s,a,l,h=r.latitude*t.DEGREES_TO_RADIANS,u=n.latitude*t.DEGREES_TO_RADIANS,c=r.longitude*t.DEGREES_TO_RADIANS,d=n.longitude*t.DEGREES_TO_RADIANS;return h==u&&c==d?0:(s=d-c,a=Math.log(Math.tan(u/2+Math.PI/4)/Math.tan(h/2+Math.PI/4)),o.fabs(s)>Math.PI&&(s=s>0?-(2*Math.PI-s):2*Math.PI+s),l=Math.atan2(s,a),isNaN(l)?0:l*t.RADIANS_TO_DEGREES)},s.rhumbDistance=function(r,n){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","rhumbDistance","missingLocation"));var s,a,l,h,u,c=r.latitude*t.DEGREES_TO_RADIANS,d=n.latitude*t.DEGREES_TO_RADIANS,p=r.longitude*t.DEGREES_TO_RADIANS,f=n.longitude*t.DEGREES_TO_RADIANS;return c==d&&p==f?0:(s=d-c,a=f-p,l=Math.log(Math.tan(d/2+Math.PI/4)/Math.tan(c/2+Math.PI/4)),h=s/l,(isNaN(l)||isNaN(h))&&(h=Math.cos(c)),o.fabs(a)>Math.PI&&(a=a>0?-(2*Math.PI-a):2*Math.PI+a),u=Math.sqrt(s*s+h*h*a*a),isNaN(u)?0:u)},s.rhumbLocation=function(r,n,s,a){if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","rhumbLocation","missingLocation"));if(!a)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","rhumbLocation","missingResult"));if(0==s)return a.latitude=r.latitude,a.longitude=r.longitude,a;var l,h,u=r.latitude*t.DEGREES_TO_RADIANS,c=r.longitude*t.DEGREES_TO_RADIANS,d=n*t.DEGREES_TO_RADIANS,p=u+s*Math.cos(d),f=Math.log(Math.tan(p/2+Math.PI/4)/Math.tan(u/2+Math.PI/4)),g=(p-u)/f;return(isNaN(f)||isNaN(g)||!isFinite(g))&&(g=Math.cos(u)),l=s*Math.sin(d)/g,o.fabs(p)>Math.PI/2&&(p=p>0?Math.PI-p:-Math.PI-p),h=o.fmod(c+l+Math.PI,2*Math.PI)-Math.PI,isNaN(p)||isNaN(h)?(a.latitude=r.latitude,a.longitude=r.longitude):(a.latitude=t.normalizedDegreesLatitude(p*t.RADIANS_TO_DEGREES),a.longitude=t.normalizedDegreesLongitude(h*t.RADIANS_TO_DEGREES)),a},s.interpolateLinear=function(t,r,n,s){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateLinear","missingLocation"));if(!s)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","interpolateLinear","missingResult"));if(r.equals(n))return s.latitude=r.latitude,s.longitude=r.longitude,s;var a=o.clamp(t,0,1),l=this.linearAzimuth(r,n),h=this.linearDistance(r,n);return this.linearLocation(r,l,a*h,s)},s.linearAzimuth=function(r,n){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","linearAzimuth","missingLocation"));var s,a,l,h=r.latitude*t.DEGREES_TO_RADIANS,u=n.latitude*t.DEGREES_TO_RADIANS,c=r.longitude*t.DEGREES_TO_RADIANS,d=n.longitude*t.DEGREES_TO_RADIANS;return h==u&&c==d?0:(s=d-c,a=u-h,o.fabs(s)>Math.PI&&(s=s>0?-(2*Math.PI-s):2*Math.PI+s),l=Math.atan2(s,a),isNaN(l)?0:l*t.RADIANS_TO_DEGREES)},s.linearDistance=function(r,n){if(!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","linearDistance","missingLocation"));var s,a,l,h=r.latitude*t.DEGREES_TO_RADIANS,u=n.latitude*t.DEGREES_TO_RADIANS,c=r.longitude*t.DEGREES_TO_RADIANS,d=n.longitude*t.DEGREES_TO_RADIANS;return h==u&&c==d?0:(s=u-h,a=d-c,o.fabs(a)>Math.PI&&(a=a>0?-(2*Math.PI-a):2*Math.PI+a),l=Math.sqrt(s*s+a*a),isNaN(l)?0:l)},s.linearLocation=function(r,n,s,a){if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","linearLocation","missingLocation"));if(!a)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","linearLocation","missingResult"));if(0==s)return a.latitude=r.latitude,a.longitude=r.longitude,a;var l,h=r.latitude*t.DEGREES_TO_RADIANS,u=r.longitude*t.DEGREES_TO_RADIANS,c=n*t.DEGREES_TO_RADIANS,d=h+s*Math.cos(c);return o.fabs(d)>Math.PI/2&&(d=d>0?Math.PI-d:-Math.PI-d),l=o.fmod(u+s*Math.sin(c)+Math.PI,2*Math.PI)-Math.PI,isNaN(d)||isNaN(l)?(a.latitude=r.latitude,a.longitude=r.longitude):(a.latitude=t.normalizedDegreesLatitude(d*t.RADIANS_TO_DEGREES),a.longitude=t.normalizedDegreesLongitude(l*t.RADIANS_TO_DEGREES)),a},s.locationsCrossDateLine=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","locationsCrossDateline","missingLocation"));for(var r=null,n=0,s=t.length;n<s;n+=1){var a=t[n];if(null!=r&&o.signum(r.longitude)!=o.signum(a.longitude)){var l=Math.abs(r.longitude-a.longitude);if(l>180&&l<360)return!0}r=a}return!1},s.greatCircleArcExtremeLocations=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","greatCircleArcExtremeLocations","missingLocation"));for(var r=null,n=null,o=null,a=0,l=t.length;a<l;a+=1){var h=t[a];if(null!=o){var u=s.greatCircleArcExtremeForTwoLocations(o,h);if(null==u)continue;(null==r||r.latitude>u[0].latitude)&&(r=u[0]),(null==n||n.latitude<u[1].latitude)&&(n=u[1])}o=h}return[r,n]},s.greatCircleArcExtremeForTwoLocations=function(t,r){if(!t||!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","greatCircleArcExtremeForTwoLocations","missingLocation"));var n,a,l,h=null,u=null,c=90,d=-90,p=[t,r];for(n=0,a=p.length;n<a;n+=1)l=p[n],c>=l.latitude&&(c=l.latitude,h=l),d<=l.latitude&&(d=l.latitude,u=l);var f=s.greatCircleAzimuth(t,r),g=s.greatCircleDistance(t,r),m=s.greatCircleExtremeLocationsUsingAzimuth(t,f);for(n=0,a=m.length;n<a;n+=1){l=m[n];var E=s.greatCircleAzimuth(t,l),y=s.greatCircleDistance(t,l);o.signum(E)==o.signum(f)&&y>=0&&y<=g&&(c>=l.latitude&&(c=l.latitude,h=l),d<=l.latitude&&(d=l.latitude,u=l))}return[h,u]},s.greatCircleExtremeLocationsUsingAzimuth=function(r,n){if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Location","greatCircleArcExtremeLocationsUsingAzimuth","missingLocation"));var o=r.latitude,a=n*t.DEGREES_TO_RADIANS,l=-Math.tan(o)/Math.cos(a),h=Math.atan(l),u=h+Math.PI/2,c=h-Math.PI/2;return[s.greatCircleLocation(r,n,u,new s(0,0)),s.greatCircleLocation(r,n,c,new s(0,0))]},s.intersectionWithMeridian=function(t,e,i,o){var s=o.computePointFromLocation(t.latitude,t.longitude,new n(0,0,0)),a=o.computePointFromLocation(e.latitude,e.longitude,new n(0,0,0)),l=o.computePointFromLocation(90,i,new n(0,0,0)),h=o.computePointFromLocation(0,i,new n(0,0,0)),u=r.fromPoints(l,h,n.ZERO),c=new n(0,0,0);if(!u.intersectsSegmentAt(s,a,c))return null;var d=new WorldWind.Position(0,0,0);return o.computePositionFromPoint(c[0],c[1],c[2],d),d.latitude},s.poles={NONE:0,NORTH:1,SOUTH:2},s}),i("geom/Position",["../geom/Angle","../error/ArgumentError","../geom/Location","../util/Logger","../util/WWMath"],function(t,e,i,r,n){"use strict";var o=function(t,e,i){this.latitude=t,this.longitude=e,this.altitude=i};return o.ZERO=new o(0,0,0),o.fromRadians=function(e,i,r){return new o(e*t.RADIANS_TO_DEGREES,i*t.RADIANS_TO_DEGREES,r)},o.prototype.copy=function(t){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"Position","copy","missingPosition"));return this.latitude=t.latitude,this.longitude=t.longitude,this.altitude=t.altitude,this},o.prototype.equals=function(t){return t&&t.latitude===this.latitude&&t.longitude===this.longitude&&t.altitude===this.altitude},o.interpolateGreatCircle=function(t,o,s,a){if(!o||!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"Position","interpolateGreatCircle","missingPosition"));if(!a)throw new e(r.logMessage(r.LEVEL_SEVERE,"Position","interpolateGreatCircle","missingResult"));var l=n.clamp(t,0,1);return a.altitude=n.interpolate(l,o.altitude,s.altitude),i.interpolateGreatCircle(l,o,s,a),a},o.interpolateRhumb=function(t,o,s,a){if(!o||!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"Position","interpolateRhumb","missingPosition"));if(!a)throw new e(r.logMessage(r.LEVEL_SEVERE,"Position","interpolateRhumb","missingResult"));var l=n.clamp(t,0,1);return a.altitude=n.interpolate(l,o.altitude,s.altitude),i.interpolateRhumb(l,o,s,a),a},o.interpolateLinear=function(t,o,s,a){if(!o||!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"Position","interpolateLinear","missingPosition"));if(!a)throw new e(r.logMessage(r.LEVEL_SEVERE,"Position","interpolateLinear","missingResult"));var l=n.clamp(t,0,1);return a.altitude=n.interpolate(l,o.altitude,s.altitude),i.interpolateLinear(l,o,s,a),a},o.prototype.toString=function(){return"("+this.latitude.toString()+"°, "+this.longitude.toString()+"°, "+this.altitude.toString()},o}),i("render/Texture",["../error/ArgumentError","../util/Logger","../util/WWMath"],function(t,e,i){"use strict";var r=function(r,n,o){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"Texture","constructor","missingGlContext"));if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"Texture","constructor","missingImage"));o||(o=r.CLAMP_TO_EDGE);var s=r.createTexture(),a=i.isPowerOfTwo(n.width)&&i.isPowerOfTwo(n.height);this.originalImageWidth=n.width,this.originalImageHeight=n.height,o!==r.REPEAT||a||(n=this.resizeImage(n),a=!0),this.imageWidth=n.width,this.imageHeight=n.height,this.size=n.width*n.height*4,r.bindTexture(r.TEXTURE_2D,s),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,a?r.LINEAR_MIPMAP_LINEAR:r.LINEAR),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,o),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,o);var l=r.getExtension("EXT_texture_filter_anisotropic")||r.getExtension("WEBKIT_EXT_texture_filter_anisotropic");l&&r.texParameteri(r.TEXTURE_2D,l.TEXTURE_MAX_ANISOTROPY_EXT,4),r.pixelStorei(r.UNPACK_PREMULTIPLY_ALPHA_WEBGL,1),r.texImage2D(r.TEXTURE_2D,0,r.RGBA,r.RGBA,r.UNSIGNED_BYTE,n),r.pixelStorei(r.UNPACK_PREMULTIPLY_ALPHA_WEBGL,0),a&&r.generateMipmap(r.TEXTURE_2D),this.textureId=s,this.creationTime=new Date};return r.prototype.dispose=function(t){t.deleteTexture(this.textureId),delete this.textureId},r.prototype.bind=function(t){return t.currentGlContext.bindTexture(t.currentGlContext.TEXTURE_2D,this.textureId),t.frameStatistics.incrementTextureLoadCount(1),!0},r.prototype.resizeImage=function(t){var e=document.createElement("canvas");e.width=i.powerOfTwoFloor(t.width),e.height=i.powerOfTwoFloor(t.height);var r=e.getContext("2d");return r.drawImage(t,0,0,e.width,e.height),e},r}),i("geom/Matrix",["../geom/Angle","../error/ArgumentError","../util/Logger","../geom/Plane","../geom/Position","../geom/Rectangle","../render/Texture","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g){this[0]=t,this[1]=e,this[2]=i,this[3]=r,this[4]=n,this[5]=o,this[6]=s,this[7]=a,this[8]=l,this[9]=h,this[10]=u,this[11]=c,this[12]=d,this[13]=p,this[14]=f,this[15]=g};return h.prototype=new Float64Array(16),h.fromIdentity=function(){return new h(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)},h.principalAxesFromPoints=function(t,r,n,o){if(!t||t.length<1)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","principalAxesFromPoints","missingPoints"));if(!r||!n||!o)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","principalAxesFromPoints","An axis argument is null or undefined."));var s=h.fromIdentity();s.setToCovarianceOfPoints(t),s.eigensystemFromSymmetricMatrix(r,n,o),r.normalize(),n.normalize(),o.normalize()},h.prototype.set=function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g){return this[0]=t,this[1]=e,this[2]=i,this[3]=r,this[4]=n,this[5]=o,this[6]=s,this[7]=a,this[8]=l,this[9]=h,this[10]=u,this[11]=c,this[12]=d,this[13]=p,this[14]=f,this[15]=g,this},h.prototype.setToIdentity=function(){this[0]=1,this[1]=0,this[2]=0,this[3]=0,this[4]=0,this[5]=1,this[6]=0,this[7]=0,this[8]=0,this[9]=0,this[10]=1,this[11]=0,this[12]=0,this[13]=0,this[14]=0,this[15]=1},h.prototype.copy=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","copy","missingMatrix"));this[0]=t[0],this[1]=t[1],this[2]=t[2],this[3]=t[3],this[4]=t[4],this[5]=t[5],this[6]=t[6],this[7]=t[7],this[8]=t[8],this[9]=t[9],this[10]=t[10],this[11]=t[11],this[12]=t[12],this[13]=t[13],this[14]=t[14],this[15]=t[15]},h.prototype.equals=function(t){return t&&this[0]==t[0]&&this[1]==t[1]&&this[2]==t[2]&&this[3]==t[3]&&this[4]==t[4]&&this[5]==t[5]&&this[6]==t[6]&&this[7]==t[7]&&this[8]==t[8]&&this[9]==t[9]&&this[10]==t[10]&&this[11]==t[11]&&this[12]==t[12]&&this[13]==t[13]&&this[14]==t[14]&&this[15]==t[15]},h.prototype.columnMajorComponents=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","columnMajorComponents","missingResult"));return t[0]=this[0],t[1]=this[4],t[2]=this[8],t[3]=this[12],t[4]=this[1],t[5]=this[5],t[6]=this[9],t[7]=this[13],t[8]=this[2],t[9]=this[6],t[10]=this[10],t[11]=this[14],t[12]=this[3],t[13]=this[7],t[14]=this[11],t[15]=this[15],t},h.prototype.setToTranslation=function(t,e,i){return this[0]=1,this[1]=0,this[2]=0,this[3]=t,this[4]=0,this[5]=1,this[6]=0,this[7]=e,this[8]=0,this[9]=0,this[10]=1,this[11]=i,this[12]=0,this[13]=0,this[14]=0,this[15]=1,this},h.prototype.setTranslation=function(t,e,i){return this[3]=t,this[7]=e,this[11]=i,this},h.prototype.setToScale=function(t,e,i){return this[0]=t,this[1]=0,this[2]=0,this[3]=0,this[4]=0,this[5]=e,this[6]=0,this[7]=0,this[8]=0,this[9]=0,this[10]=i,this[11]=0,this[12]=0,this[13]=0,this[14]=0,this[15]=1,this},h.prototype.setScale=function(t,e,i){return this[0]=t,this[5]=e,this[10]=i,this},h.prototype.setToTransposeOfMatrix=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToTransposeOfMatrix","missingMatrix"));return this[0]=t[0],this[1]=t[4],this[2]=t[8],this[3]=t[12],this[4]=t[1],this[5]=t[5],this[6]=t[9],this[7]=t[13],this[8]=t[2],this[9]=t[6],this[10]=t[10],this[11]=t[14],this[12]=t[3],this[13]=t[7],this[14]=t[11],this[15]=t[15],this},h.prototype.setToMultiply=function(t,r){if(!t||!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToMultiply","missingMatrix"));var n=t,o=r;return this[0]=n[0]*o[0]+n[1]*o[4]+n[2]*o[8]+n[3]*o[12],this[1]=n[0]*o[1]+n[1]*o[5]+n[2]*o[9]+n[3]*o[13],this[2]=n[0]*o[2]+n[1]*o[6]+n[2]*o[10]+n[3]*o[14],this[3]=n[0]*o[3]+n[1]*o[7]+n[2]*o[11]+n[3]*o[15],this[4]=n[4]*o[0]+n[5]*o[4]+n[6]*o[8]+n[7]*o[12],this[5]=n[4]*o[1]+n[5]*o[5]+n[6]*o[9]+n[7]*o[13],this[6]=n[4]*o[2]+n[5]*o[6]+n[6]*o[10]+n[7]*o[14],this[7]=n[4]*o[3]+n[5]*o[7]+n[6]*o[11]+n[7]*o[15],this[8]=n[8]*o[0]+n[9]*o[4]+n[10]*o[8]+n[11]*o[12],this[9]=n[8]*o[1]+n[9]*o[5]+n[10]*o[9]+n[11]*o[13],this[10]=n[8]*o[2]+n[9]*o[6]+n[10]*o[10]+n[11]*o[14],this[11]=n[8]*o[3]+n[9]*o[7]+n[10]*o[11]+n[11]*o[15],this[12]=n[12]*o[0]+n[13]*o[4]+n[14]*o[8]+n[15]*o[12],this[13]=n[12]*o[1]+n[13]*o[5]+n[14]*o[9]+n[15]*o[13],this[14]=n[12]*o[2]+n[13]*o[6]+n[14]*o[10]+n[15]*o[14],this[15]=n[12]*o[3]+n[13]*o[7]+n[14]*o[11]+n[15]*o[15],this},h.prototype.setToCovarianceOfPoints=function(t){if(!t||t.length<1)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToCovarianceOfPoints","missingArray"));var r,n,o,s,l=0,h=0,u=0,c=0,d=0,p=0,f=0,g=new a(0,0,0);r=a.averageOfBuffer(t,new a(0,0,0));for(var m=0,E=t.length/3;m<E;m++)g[0]=t[3*m],g[1]=t[3*m+1],g[2]=t[3*m+2],n=g[0]-r[0],o=g[1]-r[1],s=g[2]-r[2],++l,h+=n*n,u+=o*o,c+=s*s,d+=n*o,p+=n*s,f+=o*s;return this[0]=h/l,this[1]=d/l,this[2]=p/l,this[3]=0,this[4]=d/l,this[5]=u/l,this[6]=f/l,this[7]=0,this[8]=p/l,this[9]=f/l,this[10]=c/l,this[11]=0,this[12]=0,this[13]=0,this[14]=0,this[15]=0,this},h.prototype.multiplyByTranslation=function(t,e,i){return this.multiply(1,0,0,t,0,1,0,e,0,0,1,i,0,0,0,1),this},h.prototype.multiplyByRotation=function(e,i,r,n){var o=Math.cos(n*t.DEGREES_TO_RADIANS),s=Math.sin(n*t.DEGREES_TO_RADIANS);return this.multiply(o+(1-o)*e*e,(1-o)*e*i-s*r,(1-o)*e*r+s*i,0,(1-o)*e*i+s*r,o+(1-o)*i*i,(1-o)*i*r-s*e,0,(1-o)*e*r-s*i,(1-o)*i*r+s*e,o+(1-o)*r*r,0,0,0,0,1),this},h.prototype.multiplyByScale=function(t,e,i){return this.multiply(t,0,0,0,0,e,0,0,0,0,i,0,0,0,0,1),this},h.prototype.setToUnitYFlip=function(){return this[0]=1,this[1]=0,this[2]=0,this[3]=0,this[4]=0,this[5]=-1,this[6]=0,this[7]=1,this[8]=0,this[9]=0,this[10]=1,this[11]=0,this[12]=0,this[13]=0,this[14]=0,this[15]=1,this},h.prototype.multiplyByLocalCoordinateTransform=function(t,r){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByLocalCoordinateTransform","Origin vector is null or undefined"));if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByLocalCoordinateTransform","missingGlobe"));var n=new a(0,0,0),o=new a(0,0,0),s=new a(0,0,0);return l.localCoordinateAxesAtPoint(t,r,n,o,s),this.multiply(n[0],o[0],s[0],t[0],n[1],o[1],s[1],t[1],n[2],o[2],s[2],t[2],0,0,0,1),this},h.prototype.multiplyByTextureTransform=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByTextureTransform","missingTexture"));var r=t.originalImageWidth/t.imageWidth,n=t.originalImageHeight/t.imageHeight;return this.multiply(r,0,0,0,0,-n,0,n,0,0,1,0,0,0,0,1),this},h.prototype.extractTranslation=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","extractTranslation","missingResult"));return t[0]=this[3],t[1]=this[7],t[2]=this[11],t},h.prototype.extractRotationAngles=function(r){if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","extractRotationAngles","missingResult"));var n=Math.atan2(this[6],this[10]),o=Math.atan2(-this[2],Math.sqrt(this[0]*this[0]+this[1]*this[1])),s=Math.cos(n),a=Math.sin(n),l=Math.atan2(a*this[8]-s*this[4],s*this[5]-a*this[9]);
return r[0]=n*t.RADIANS_TO_DEGREES,r[1]=o*t.RADIANS_TO_DEGREES,r[2]=l*t.RADIANS_TO_DEGREES,r},h.prototype.multiplyByFirstPersonModelview=function(r,n,o,s,h){if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByFirstPersonModelview","missingPosition"));if(!h)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByFirstPersonModelview","missingGlobe"));var u,c,d,p,f,g,m,E,y,_,v,b,S,T,L=new a(0,0,0),w=new a(0,0,0),x=new a(0,0,0),R=new a(0,0,0);return u=Math.cos(s*t.DEGREES_TO_RADIANS),c=Math.sin(s*t.DEGREES_TO_RADIANS),this.multiply(u,c,0,0,-c,u,0,0,0,0,1,0,0,0,0,1),u=Math.cos(o*t.DEGREES_TO_RADIANS),c=Math.sin(o*t.DEGREES_TO_RADIANS),this.multiply(1,0,0,0,0,u,c,0,0,-c,u,0,0,0,0,1),u=Math.cos(n*t.DEGREES_TO_RADIANS),c=Math.sin(n*t.DEGREES_TO_RADIANS),this.multiply(u,-c,0,0,c,u,0,0,0,0,1,0,0,0,0,1),h.computePointFromPosition(r.latitude,r.longitude,r.altitude,L),d=L[0],p=L[1],f=L[2],l.localCoordinateAxesAtPoint(L,h,w,x,R),g=w[0],m=w[1],E=w[2],y=x[0],_=x[1],v=x[2],b=R[0],S=R[1],T=R[2],this.multiply(g,m,E,-g*d-m*p-E*f,y,_,v,-y*d-_*p-v*f,b,S,T,-b*d-S*p-T*f,0,0,0,1),this},h.prototype.multiplyByLookAtModelview=function(t,r,n,o,s,a){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByLookAtModelview","missingPosition"));if(r<0)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByLookAtModelview","Range is less than zero"));if(!a)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyByLookAtModelview","missingGlobe"));return this.multiplyByTranslation(0,0,-r),this.multiplyByFirstPersonModelview(t,n,o,s,a),this},h.prototype.setToPerspectiveProjection=function(t,r,n,o){if(t<=0)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToPerspectiveProjection","invalidWidth"));if(r<=0)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToPerspectiveProjection","invalidHeight"));if(n===o)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToPerspectiveProjection","Near and far distance are the same."));if(n<=0||o<=0)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToPerspectiveProjection","Near or far distance is less than or equal to zero."));var s=l.perspectiveFrustumRectangle(t,r,n),a=s.getMinX(),h=s.getMaxX(),u=s.getMinY(),c=s.getMaxY();return this[0]=2*n/(h-a),this[1]=0,this[2]=(h+a)/(h-a),this[3]=0,this[4]=0,this[5]=2*n/(c-u),this[6]=(c+u)/(c-u),this[7]=0,this[8]=0,this[9]=0,this[10]=-(o+n)/(o-n),this[11]=-2*n*o/(o-n),this[12]=0,this[13]=0,this[14]=-1,this[15]=0,this},h.prototype.setToScreenProjection=function(t,r){if(t<=0)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToScreenProjection","invalidWidth"));if(r<=0)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","setToScreenProjection","invalidHeight"));return this[0]=2/t,this[1]=0,this[2]=0,this[3]=-1,this[4]=0,this[5]=2/r,this[6]=0,this[7]=-1,this[8]=0,this[9]=0,this[10]=2,this[11]=-1,this[12]=0,this[13]=0,this[14]=0,this[15]=1,this},h.prototype.extractEyePoint=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","extractEyePoint","missingResult"));return t[0]=-(this[0]*this[3])-this[4]*this[7]-this[8]*this[11],t[1]=-(this[1]*this[3])-this[5]*this[7]-this[9]*this[11],t[2]=-(this[2]*this[3])-this[6]*this[7]-this[10]*this[11],t},h.prototype.extractForwardVector=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","extractForwardVector","missingResult"));return t[0]=-this[8],t[1]=-this[9],t[2]=-this[10],t},h.prototype.extractViewingParameters=function(r,o,s,a){if(!r)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","extractViewingParameters","The specified origin is null or undefined."));if(!s)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","extractViewingParameters","missingGlobe"));if(!a)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","extractViewingParameters","missingResult"));var l,u,c,d,p,f,g,m,E,y=new n(0,0,0),_=h.fromIdentity();return s.computePositionFromPoint(r[0],r[1],r[2],y),_.copy(this),_.multiplyByLocalCoordinateTransform(r,s),l=-_[11],u=_[10],c=Math.sqrt(_[2]*_[2]+_[6]*_[6]),d=Math.atan2(c,u)*t.RADIANS_TO_DEGREES,p=Math.cos(o*t.DEGREES_TO_RADIANS),f=Math.sin(o*t.DEGREES_TO_RADIANS),g=p*_[0]-f*_[4],m=f*_[5]-p*_[1],E=Math.atan2(m,g)*t.RADIANS_TO_DEGREES,a.origin=y,a.range=l,a.heading=E,a.tilt=d,a.roll=o,a},h.prototype.offsetProjectionDepth=function(t){return this[10]*=1+t,this},h.prototype.multiplyMatrix=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","multiplyMatrix","missingMatrix"));var r,n,o,s,a=this,l=t;return r=a[0],n=a[1],o=a[2],s=a[3],a[0]=r*l[0]+n*l[4]+o*l[8]+s*l[12],a[1]=r*l[1]+n*l[5]+o*l[9]+s*l[13],a[2]=r*l[2]+n*l[6]+o*l[10]+s*l[14],a[3]=r*l[3]+n*l[7]+o*l[11]+s*l[15],r=a[4],n=a[5],o=a[6],s=a[7],a[4]=r*l[0]+n*l[4]+o*l[8]+s*l[12],a[5]=r*l[1]+n*l[5]+o*l[9]+s*l[13],a[6]=r*l[2]+n*l[6]+o*l[10]+s*l[14],a[7]=r*l[3]+n*l[7]+o*l[11]+s*l[15],r=a[8],n=a[9],o=a[10],s=a[11],a[8]=r*l[0]+n*l[4]+o*l[8]+s*l[12],a[9]=r*l[1]+n*l[5]+o*l[9]+s*l[13],a[10]=r*l[2]+n*l[6]+o*l[10]+s*l[14],a[11]=r*l[3]+n*l[7]+o*l[11]+s*l[15],r=a[12],n=a[13],o=a[14],s=a[15],a[12]=r*l[0]+n*l[4]+o*l[8]+s*l[12],a[13]=r*l[1]+n*l[5]+o*l[9]+s*l[13],a[14]=r*l[2]+n*l[6]+o*l[10]+s*l[14],a[15]=r*l[3]+n*l[7]+o*l[11]+s*l[15],this},h.prototype.multiply=function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g){var m,E,y,_,v=this;return m=v[0],E=v[1],y=v[2],_=v[3],v[0]=m*t+E*n+y*l+_*d,v[1]=m*e+E*o+y*h+_*p,v[2]=m*i+E*s+y*u+_*f,v[3]=m*r+E*a+y*c+_*g,m=v[4],E=v[5],y=v[6],_=v[7],v[4]=m*t+E*n+y*l+_*d,v[5]=m*e+E*o+y*h+_*p,v[6]=m*i+E*s+y*u+_*f,v[7]=m*r+E*a+y*c+_*g,m=v[8],E=v[9],y=v[10],_=v[11],v[8]=m*t+E*n+y*l+_*d,v[9]=m*e+E*o+y*h+_*p,v[10]=m*i+E*s+y*u+_*f,v[11]=m*r+E*a+y*c+_*g,m=v[12],E=v[13],y=v[14],_=v[15],v[12]=m*t+E*n+y*l+_*d,v[13]=m*e+E*o+y*h+_*p,v[14]=m*i+E*s+y*u+_*f,v[15]=m*r+E*a+y*c+_*g,this},h.prototype.invertMatrix=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","invertMatrix","missingMatrix"));var r=[[],[],[],[]];r[0][0]=t[0],r[0][1]=t[1],r[0][2]=t[2],r[0][3]=t[3],r[1][0]=t[4],r[1][1]=t[5],r[1][2]=t[6],r[1][3]=t[7],r[2][0]=t[8],r[2][1]=t[9],r[2][2]=t[10],r[2][3]=t[11],r[3][0]=t[12],r[3][1]=t[13],r[3][2]=t[14],r[3][3]=t[15];var n,o,s=[],a=h.ludcmp(r,s);for(n=0;n<4;n+=1)a*=r[n][n];if(Math.abs(a)<1e-8)return null;var l=[[],[],[],[]],u=[];for(o=0;o<4;o+=1){for(n=0;n<4;n+=1)u[n]=0;for(u[o]=1,h.lubksb(r,s,u),n=0;n<4;n+=1)l[n][o]=u[n]}return this[0]=l[0][0],this[1]=l[0][1],this[2]=l[0][2],this[3]=l[0][3],this[4]=l[1][0],this[5]=l[1][1],this[6]=l[1][2],this[7]=l[1][3],this[8]=l[2][0],this[9]=l[2][1],this[10]=l[2][2],this[11]=l[2][3],this[12]=l[3][0],this[13]=l[3][1],this[14]=l[3][2],this[15]=l[3][3],this},h.lubksb=function(t,e,i){var r,n,o,s=-1;for(r=0;r<4;r+=1){var a=e[r];if(o=i[a],i[a]=i[r],s!=-1)for(n=s;n<=r-1;n+=1)o-=t[r][n]*i[n];else 0!=o&&(s=r);i[r]=o}for(r=3;r>=0;r-=1){for(o=i[r],n=r+1;n<4;n+=1)o-=t[r][n]*i[n];i[r]=o/t[r][r]}},h.ludcmp=function(t,e){var i,r,n,o,s,a,l,h,u=1e-20,c=[],d=1;for(r=0;r<4;r+=1){for(s=0,n=0;n<4;n+=1)(i=Math.abs(t[r][n]))>s&&(s=i);if(0==s)return 0;c[r]=1/s}for(n=0;n<4;n+=1){for(r=0;r<n;r+=1){for(a=t[r][n],o=0;o<r;o+=1)a-=t[r][o]*t[o][n];t[r][n]=a}for(s=0,l=-1,r=n;r<4;r+=1){for(a=t[r][n],o=0;o<n;o++)a-=t[r][o]*t[o][n];t[r][n]=a,(h=c[r]*Math.abs(a))>=s&&(s=h,l=r)}if(n!=l){for(o=0;o<4;o+=1)h=t[l][o],t[l][o]=t[n][o],t[n][o]=h;d=-d,c[l]=c[n]}if(e[n]=l,0==t[n][n]&&(t[n][n]=u),3!=n)for(h=1/t[n][n],r=n+1;r<4;r+=1)t[r][n]*=h}return d},h.prototype.invertOrthonormalMatrix=function(t){if(!t)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","invertOrthonormalMatrix","missingMatrix"));var r=t;return this[0]=r[0],this[1]=r[4],this[2]=r[8],this[3]=0-r[0]*r[3]-r[4]*r[7]-r[8]*r[11],this[4]=r[1],this[5]=r[5],this[6]=r[9],this[7]=0-r[1]*r[3]-r[5]*r[7]-r[9]*r[11],this[8]=r[2],this[9]=r[6],this[10]=r[10],this[11]=0-r[2]*r[3]-r[6]*r[7]-r[10]*r[11],this[12]=0,this[13]=0,this[14]=0,this[15]=1,this},h.prototype.eigensystemFromSymmetricMatrix=function(t,r,n){if(!t||!r||!n)throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","eigensystemFromSymmetricMatrix","missingResult"));if(this[1]!=this[4]||this[2]!=this[8]||this[6]!=this[9])throw new e(i.logMessage(i.LEVEL_SEVERE,"Matrix","eigensystemFromSymmetricMatrix","Matrix is not symmetric"));for(var o,s,a,h,u,c,d,p,f,g,m,E=1e-10,y=this[0],_=this[1],v=this[2],b=this[5],S=this[6],T=this[10],L=[[1,0,0],[0,1,0],[0,0,1]],w=32,x=0;x<w&&!(l.fabs(_)<E&&l.fabs(v)<E&&l.fabs(S)<E);x++){if(0!=_)for(o=.5*(b-y)/_,s=o*o,a=s+1,h=a!=s?(o<0?-1:1)*(Math.sqrt(a)-l.fabs(o)):.5/o,u=1/Math.sqrt(h*h+1),c=u*h,y-=h*_,b+=h*_,_=0,d=u*v-c*S,S=c*v+u*S,v=d,p=0;p<3;p++)d=u*L[p][0]-c*L[p][1],L[p][1]=c*L[p][0]+u*L[p][1],L[p][0]=d;if(0!=v)for(o=.5*(T-y)/v,s=o*o,a=s+1,h=a!=s?(o<0?-1:1)*(Math.sqrt(a)-l.fabs(o)):.5/o,u=1/Math.sqrt(h*h+1),c=u*h,y-=h*v,T+=h*v,v=0,d=u*_-c*S,S=c*_+u*S,_=d,p=0;p<3;p++)d=u*L[p][0]-c*L[p][2],L[p][2]=c*L[p][0]+u*L[p][2],L[p][0]=d;if(0!=S)for(o=.5*(T-b)/S,s=o*o,a=s+1,h=a!=s?(o<0?-1:1)*(Math.sqrt(a)-l.fabs(o)):.5/o,u=1/Math.sqrt(h*h+1),c=u*h,b-=h*S,T+=h*S,S=0,d=u*_-c*v,v=c*_+u*v,_=d,p=0;p<3;p++)d=u*L[p][1]-c*L[p][2],L[p][2]=c*L[p][1]+u*L[p][2],L[p][1]=d}f=0,g=1,m=2,y<b&&(d=y,y=b,b=d,d=f,f=g,g=d),b<T&&(d=b,b=T,T=d,d=g,g=m,m=d),y<b&&(d=y,y=b,b=d,d=f,f=g,g=d),t[0]=L[0][f],t[1]=L[1][f],t[2]=L[2][f],r[0]=L[0][g],r[1]=L[1][g],r[2]=L[2][g],n[0]=L[0][m],n[1]=L[1][m],n[2]=L[2][m],t.normalize(),r.normalize(),n.normalize(),t.multiply(y),r.multiply(b),n.multiply(T)},h.prototype.upper3By3=function(){var t=h.fromIdentity();return t[0]=this[0],t[1]=this[1],t[2]=this[2],t[4]=this[4],t[5]=this[5],t[6]=this[6],t[8]=this[8],t[9]=this[9],t[10]=this[10],t},h}),i("pick/PickedObject",[],function(){"use strict";var t=function(t,e,i,r,n){this.color=t,this.userObject=e,this.position=i,this.parentLayer=r,this.isTerrain=n,this.isOnTop=!1};return t}),i("error/UnsupportedOperationError",["../error/AbstractError"],function(t){"use strict";var e=function(e){t.call(this,"UnsupportedOperationError",e);var i;try{throw new Error}catch(t){i=t.stack}this.stack=i};return e.prototype=Object.create(t.prototype),e}),i("render/Renderable",["../util/Logger","../error/UnsupportedOperationError"],function(t,e){"use strict";var i=function(){this.displayName="Renderable",this.enabled=!0,this.pickDelegate=null,this.userProperties={}};return i.prototype.render=function(i){throw new e(t.logMessage(t.LEVEL_SEVERE,"Renderable","render","abstractInvocation"))},i}),i("shapes/Annotation",["../shapes/AnnotationAttributes","../error/ArgumentError","../shaders/BasicTextureProgram","../util/Color","../util/Font","../util/Insets","../util/Logger","../geom/Matrix","../util/Offset","../pick/PickedObject","../render/Renderable","../shapes/TextAttributes","../geom/Vec2","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f){"use strict";var g=function(i,r){if(!i)throw new e(s.logMessage(s.LEVEL_SEVERE,"Annotation","constructor","missingPosition"));u.call(this),this.position=i,this.attributes=r?r:new t(null),this.altitudeMode=WorldWind.ABSOLUTE,this.layer=null,this.lastStateKey=null,this.calloutTransform=a.fromIdentity(),this.calloutOffset=new WorldWind.Offset(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,0),this.label="",this.labelTexture=null,this.labelTransform=a.fromIdentity(),this.placePoint=new p(0,0,0),this.depthOffset=-2.05,this.calloutPoints=null};return g.matrix=a.fromIdentity(),g.screenPoint=new p(0,0,0),g.scratchPoint=new p(0,0,0),g.prototype=Object.create(u.prototype),Object.defineProperties(g.prototype,{text:{get:function(){return this.label},set:function(t){this.label=t,this.lastStateKey=null}}}),g.prototype.renderOrdered=function(t){if(this.drawOrderedAnnotation(t),t.pickingMode){var e=new h(this.pickColor.clone(),this,this.position,this.layer,!1);t.pickPoint&&this.labelBounds.containsPoint(t.navigatorState.convertPointToViewport(t.pickPoint,g.scratchPoint))&&(e.labelPicked=!0),t.resolvePick(e)}},g.prototype.clone=function(){var t=new g(this.position);return t.copy(this),t.pickDelegate=this.pickDelegate?this.pickDelegate:this,t},g.prototype.copy=function(t){return this.position=t.position,this.enabled=t.enabled,this.attributes=t.attributes,this.label=t.label,this.altitudeMode=t.altitudeMode,this.pickDelegate=t.pickDelegate,this.depthOffset=t.depthOffset,this},g.prototype.render=function(t){if(this.enabled&&t.accumulateOrderedRenderables&&(!t.globe.projectionLimits||t.globe.projectionLimits.containsLocation(this.position.latitude,this.position.longitude))){var e;if(this.lastFrameTime!==t.timestamp)e=this.makeOrderedRenderable(t);else{var i=this.clone();e=i.makeOrderedRenderable(t)}e&&(e.layer=t.currentLayer,this.lastFrameTime=t.timestamp,t.addOrderedRenderable(e))}},g.prototype.drawOrderedAnnotation=function(t){this.beginDrawing(t);try{this.doDrawOrderedAnnotation(t)}finally{this.endDrawing(t)}},g.prototype.makeOrderedRenderable=function(t){var e,i,r,n,o,s,a,l,h;if(this.label=t.textSupport.wrap(this.label,this.attributes.width,this.attributes.height,this.attributes.textAttributes.font),t.surfacePointForMode(this.position.latitude,this.position.longitude,this.position.altitude,this.altitudeMode,this.placePoint),this.eyeDistance=t.navigatorState.eyePoint.distanceTo(this.placePoint),!t.navigatorState.projectWithDepth(this.placePoint,this.depthOffset,g.screenPoint))return null;var u=this.attributes.textAttributes.font,c=this.label+u.toString();this.labelTexture=t.gpuResourceCache.resourceForKey(c),this.labelTexture||(this.labelTexture=t.textSupport.createTexture(t,this.label,u,!1),t.gpuResourceCache.putResource(c,this.labelTexture,this.labelTexture.size)),e=this.labelTexture.imageWidth,i=this.labelTexture.imageHeight,r=this.attributes.scale,n=this.attributes.insets.left,o=this.attributes.insets.right,s=this.attributes.insets.top,a=this.attributes.insets.bottom,h=this.attributes.leaderGapHeight,l=this.calloutOffset.offsetForSize((e+n+o)*r,(i+s+a)*r),this.calloutTransform.setTranslation(g.screenPoint[0]-l[0],g.screenPoint[1]+h,g.screenPoint[2]),this.labelTransform.setTranslation(g.screenPoint[0]-l[0]+n*r,g.screenPoint[1]+h+a*r,g.screenPoint[2]),this.labelTransform.setScale(e*r,i*r,1),this.labelBounds=f.boundingRectForUnitQuad(this.labelTransform);var d=(e+n+o)*r,p=(i+s+a)*r,m=d/2,E=-h;return this.attributes.drawLeader||(E=0),this.attributes.stateKey!=this.lastStateKey&&(this.calloutPoints=this.createCallout(d,p,m,E,this.attributes.leaderGapWidth,this.attributes.cornerRadius)),this},g.prototype.beginDrawing=function(t){var e,r=t.currentGlContext;t.findAndBindProgram(i),e=t.currentProgram,r.enableVertexAttribArray(e.vertexPointLocation),r.enableVertexAttribArray(e.vertexTexCoordLocation),e.loadModulateColor(r,t.pickingMode)},g.prototype.endDrawing=function(t){var e=t.currentGlContext,i=t.currentProgram;e.disableVertexAttribArray(i.vertexPointLocation),e.disableVertexAttribArray(i.vertexTexCoordLocation),t.bindProgram(null)},g.prototype.drawCorner=function(t,e,i,r,n,o,s,a){if(i<1)return a;for(var l=(n-r)/(o-1),h=1;h<o-1;h++){var u=r+l*h,c=t+Math.cos(u)*i,d=e+Math.sin(u)*i;s[a++]=c,s[a++]=d}return a},g.prototype.createCallout=function(t,e,i,r,n,o){var s=16,a=2*(12+(o<1?0:4*(s-2))),l=new Float32Array(a),h=0;return l[h++]=t/2+n/2,l[h++]=0,l[h++]=t-o,l[h++]=0,h=this.drawCorner(t-o,o,o,-Math.PI/2,0,s,l,h),l[h++]=t,l[h++]=o,l[h++]=t,l[h++]=e-o,h=this.drawCorner(t-o,e-o,o,0,Math.PI/2,s,l,h),l[h++]=t-o,l[h++]=e,l[h++]=o,l[h++]=e,h=this.drawCorner(o,e-o,o,Math.PI/2,Math.PI,s,l,h),l[h++]=0,l[h++]=e-o,l[h++]=0,l[h++]=o,h=this.drawCorner(o,o,o,Math.PI,1.5*Math.PI,s,l,h),l[h++]=o,l[h++]=0,l[h++]=t/2-n/2,l[h++]=0,l[h++]=i,l[h++]=r,l[h++]=t/2+n/2,l[h]=0,l},g.prototype.doDrawOrderedAnnotation=function(t){var e,i=t.currentGlContext,r=t.currentProgram,n=!1;t.pickingMode&&(this.pickColor=t.uniquePickColor()),r.loadOpacity(i,this.attributes.opacity);var o=this.attributes.stateKey!=this.lastStateKey;this.calloutCacheKey&&!o||(this.calloutCacheKey=t.gpuResourceCache.generateCacheKey());var s=t.gpuResourceCache.resourceForKey(this.calloutCacheKey);s||(s=i.createBuffer(),t.gpuResourceCache.putResource(this.calloutCacheKey,s,4*this.calloutPoints.length),n=!0),o&&this.calloutCacheKey&&t.gpuResourceCache.removeResource(this.calloutCacheKey),this.lastStateKey=this.attributes.stateKey,g.matrix.copy(t.screenProjection),g.matrix.multiplyMatrix(this.calloutTransform),r.loadModelviewProjection(i,g.matrix),i.bindBuffer(i.ARRAY_BUFFER,s),n&&(i.bufferData(i.ARRAY_BUFFER,this.calloutPoints,i.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1)),r.loadColor(i,t.pickingMode?this.pickColor:this.attributes.backgroundColor),r.loadTextureEnabled(i,!1),i.vertexAttribPointer(r.vertexPointLocation,2,i.FLOAT,!1,0,0),i.vertexAttribPointer(r.vertexTexCoordLocation,2,i.FLOAT,!1,0,0),i.drawArrays(i.TRIANGLE_FAN,0,this.calloutPoints.length/2),g.matrix.copy(t.screenProjection),g.matrix.multiplyMatrix(this.labelTransform),r.loadModelviewProjection(i,g.matrix),r.loadColor(i,t.pickingMode?this.pickColor:this.attributes.textAttributes.color),e=this.labelTexture.bind(t),r.loadTextureEnabled(i,e),i.bindBuffer(i.ARRAY_BUFFER,t.unitQuadBuffer3()),i.vertexAttribPointer(r.vertexPointLocation,3,i.FLOAT,!1,0,0),i.bindBuffer(i.ARRAY_BUFFER,t.unitQuadBuffer()),i.vertexAttribPointer(r.vertexTexCoordLocation,2,i.FLOAT,!1,0,0),i.drawArrays(i.TRIANGLE_STRIP,0,4)},g}),i("shaders/AtmosphereProgram",["../error/ArgumentError","../shaders/GpuProgram","../util/Logger"],function(t,e,i){"use strict";var r=function(t,i,r,n){e.call(this,t,i,r,n),this.FRAGMODE_SKY=1,this.FRAGMODE_GROUND_PRIMARY=2,this.FRAGMODE_GROUND_SECONDARY=3,this.FRAGMODE_GROUND_PRIMARY_TEX_BLEND=4,this.altitude=16e4,this.rayleighScaleDepth=.25,this.fragModeLocation=this.uniformLocation(t,"fragMode"),this.mvpMatrixLocation=this.uniformLocation(t,"mvpMatrix"),this.texCoordMatrixLocation=this.uniformLocation(t,"texCoordMatrix"),this.vertexOriginLocation=this.uniformLocation(t,"vertexOrigin"),this.eyePointLocation=this.uniformLocation(t,"eyePoint"),this.eyeMagnitudeLocation=this.uniformLocation(t,"eyeMagnitude"),this.eyeMagnitude2Location=this.uniformLocation(t,"eyeMagnitude2"),this.lightDirectionLocation=this.uniformLocation(t,"lightDirection"),this.atmosphereRadiusLocation=this.uniformLocation(t,"atmosphereRadius"),this.atmosphereRadius2Location=this.uniformLocation(t,"atmosphereRadius2"),this.globeRadiusLocation=this.uniformLocation(t,"globeRadius"),this.scaleLocation=this.uniformLocation(t,"scale"),this.scaleDepthLocation=this.uniformLocation(t,"scaleDepth"),this.scaleOverScaleDepthLocation=this.uniformLocation(t,"scaleOverScaleDepth"),this.scratchArray9=new Float32Array(9)};return r.key="WorldWindGpuAtmosphereProgram",r.prototype=Object.create(e.prototype),r.prototype.getAltitude=function(){return this.altitude},r.prototype.loadFragMode=function(e,r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"AtmosphereProgram","loadFragMode","missingFragMode"));e.uniform1i(this.fragModeLocation,r)},r.prototype.loadModelviewProjection=function(e,r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"AtmosphereProgram","loadModelviewProjection","missingMatrix"));this.loadUniformMatrix(e,r,this.mvpMatrixLocation)},r.prototype.loadVertexOrigin=function(e,r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"AtmosphereProgram","loadVertexOrigin","missingVector"));e.uniform3f(this.vertexOriginLocation,r[0],r[1],r[2])},r.prototype.loadLightDirection=function(e,r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"AtmosphereProgram","loadLightDirection","missingVector"));e.uniform3f(this.lightDirectionLocation,r[0],r[1],r[2])},r.prototype.loadEyePoint=function(e,r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"AtmosphereProgram","loadEyePoint","missingVector"));e.uniform3f(this.eyePointLocation,r[0],r[1],r[2]),e.uniform1f(this.eyeMagnitudeLocation,r.magnitude()),e.uniform1f(this.eyeMagnitude2Location,r.magnitudeSquared())},r.prototype.loadGlobeRadius=function(e,r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"AtmosphereProgram","loadGlobeRadius","missingGlobeRadius"));var n=r,o=n+this.altitude;e.uniform1f(this.globeRadiusLocation,n),e.uniform1f(this.atmosphereRadiusLocation,o),e.uniform1f(this.atmosphereRadius2Location,o*o)},r.prototype.setScale=function(t){t.uniform1f(this.scaleLocation,1/this.getAltitude()),t.uniform1f(this.scaleDepthLocation,this.rayleighScaleDepth),t.uniform1f(this.scaleOverScaleDepthLocation,1/this.getAltitude()/this.rayleighScaleDepth)},r.prototype.loadTexMatrix=function(e,r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"AtmosphereProgram","loadTexMatrix","missingMatrix"));r.columnMajorComponents(this.scratchArray9),e.uniformMatrix3fv(this.texCoordMatrixLocation,!1,this.scratchArray9)},r}),i("shaders/GroundProgram",["../shaders/AtmosphereProgram"],function(t){"use strict";var e=function(e){var i="precision mediump int;\nconst int FRAGMODE_GROUND_PRIMARY_TEX_BLEND = 4;\nconst int SAMPLE_COUNT = 2;\nconst float SAMPLES = 2.0;\nconst float PI = 3.141592653589;\nconst float Kr = 0.0025;\nconst float Kr4PI = Kr * 4.0 * PI;\nconst float Km = 0.0015;\nconst float Km4PI = Km * 4.0 * PI;\nconst float ESun = 15.0;\nconst float KmESun = Km * ESun;\nconst float KrESun = Kr * ESun;\nconst vec3 invWavelength = vec3(5.60204474633241, 9.473284437923038, 19.643802610477206);\nconst float rayleighScaleDepth = 0.25;\nuniform int fragMode;\nuniform mat4 mvpMatrix;\nuniform mat3 texCoordMatrix;\nuniform vec3 vertexOrigin;\nuniform vec3 eyePoint;\nuniform float eyeMagnitude;\nuniform float eyeMagnitude2;\nuniform vec3 lightDirection;\nuniform float atmosphereRadius;\nuniform float atmosphereRadius2;\nuniform float globeRadius;\nuniform float scale;\nuniform float scaleDepth;\nuniform float scaleOverScaleDepth;\nattribute vec4 vertexPoint;\nattribute vec2 vertexTexCoord;\nvarying vec3 primaryColor;\nvarying vec3 secondaryColor;\nvarying vec2 texCoord;\nfloat scaleFunc(float cos) {\n    float x = 1.0 - cos;\n    return scaleDepth * exp(-0.00287 + x*(0.459 + x*(3.83 + x*(-6.80 + x*5.25))));\n}\nvoid sampleGround() {\n    vec3 point = vertexPoint.xyz + vertexOrigin;\n    vec3 ray = point - eyePoint;\n    float far = length(ray);\n    ray /= far;\n    vec3 start;\n    if (eyeMagnitude < atmosphereRadius) {\n        start = eyePoint;\n    } else {\n        float B = 2.0 * dot(eyePoint, ray);\n        float C = eyeMagnitude2 - atmosphereRadius2;\n        float det = max(0.0, B*B - 4.0 * C);\n        float near = 0.5 * (-B - sqrt(det));\n        start = eyePoint + ray * near;\n        far -= near;\n}\n    float depth = exp((globeRadius - atmosphereRadius) / scaleDepth);\n    float eyeAngle = dot(-ray, point) / length(point);\n    float lightAngle = dot(lightDirection, point) / length(point);\n    float eyeScale = scaleFunc(eyeAngle);\n    float lightScale = scaleFunc(lightAngle);\n    float eyeOffset = depth*eyeScale;\n    float temp = (lightScale + eyeScale);\n    float sampleLength = far / SAMPLES;\n    float scaledLength = sampleLength * scale;\n    vec3 sampleRay = ray * sampleLength;\n    vec3 samplePoint = start + sampleRay * 0.5;\n    vec3 frontColor = vec3(0.0, 0.0, 0.0);\n    vec3 attenuate = vec3(0.0, 0.0, 0.0);\n    for(int i=0; i<SAMPLE_COUNT; i++)\n    {\n        float height = length(samplePoint);\n        float depth = exp(scaleOverScaleDepth * (globeRadius - height));\n        float scatter = depth*temp - eyeOffset;\n        attenuate = exp(-scatter * (invWavelength * Kr4PI + Km4PI));\n        frontColor += attenuate * (depth * scaledLength);\n        samplePoint += sampleRay;\n    }\n    primaryColor = frontColor * (invWavelength * KrESun + KmESun);\n    secondaryColor = attenuate;\n}\nvoid main()\n {\n    sampleGround();\n    gl_Position = mvpMatrix * vertexPoint;\n    if (fragMode == FRAGMODE_GROUND_PRIMARY_TEX_BLEND) {\n        texCoord = (texCoordMatrix * vec3(vertexTexCoord, 1.0)).st;\n    }\n}",r="precision mediump float;\nprecision mediump int;\nconst int FRAGMODE_GROUND_PRIMARY = 2;\nconst int FRAGMODE_GROUND_SECONDARY = 3;\nconst int FRAGMODE_GROUND_PRIMARY_TEX_BLEND = 4;\nuniform int fragMode;\nuniform sampler2D texSampler;\nvarying vec3 primaryColor;\nvarying vec3 secondaryColor;\nvarying vec2 texCoord;\nvoid main (void)\n{\n    if (fragMode == FRAGMODE_GROUND_PRIMARY) {\n        gl_FragColor = vec4(primaryColor, 1.0);\n    } else if (fragMode == FRAGMODE_GROUND_SECONDARY) {\n        gl_FragColor = vec4(secondaryColor, 1.0);\n    } else if (fragMode == FRAGMODE_GROUND_PRIMARY_TEX_BLEND) {\n        vec4 texColor = texture2D(texSampler, texCoord);\n        gl_FragColor = vec4(primaryColor + texColor.rgb * (1.0 - secondaryColor), 1.0);\n    }\n}";t.call(this,e,i,r,["vertexPoint","vertexTexCoord"])};return e.key="WorldWindGroundProgram",e.prototype=Object.create(t.prototype),e}),i("layer/Layer",["../util/Logger"],function(t){"use strict";var e=function(t){this.displayName=t?t:"Layer",this.enabled=!0,this.pickEnabled=!0,this.opacity=1,this.minActiveAltitude=-Number.MAX_VALUE,this.maxActiveAltitude=Number.MAX_VALUE,this.inCurrentFrame=!1,this.time=null};return e.prototype.refresh=function(){},e.prototype.render=function(t){this.inCurrentFrame=!1,this.enabled&&(t.pickingMode&&!this.pickEnabled||this.withinActiveAltitudes(t)&&this.isLayerInView(t)&&this.doRender(t))},e.prototype.doRender=function(t){},e.prototype.withinActiveAltitudes=function(t){var e=t.eyePosition;return!!e&&(e.altitude>=this.minActiveAltitude&&e.altitude<=this.maxActiveAltitude)},e.prototype.isLayerInView=function(t){return!0},e}),i("geom/Matrix3",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(t,e,i,r,n,o,s,a,l){this[0]=t,this[1]=e,this[2]=i,this[3]=r,this[4]=n,this[5]=o,this[6]=s,this[7]=a,this[8]=l};return i.prototype=new Float64Array(9),i.fromIdentity=function(){return new i(1,0,0,0,1,0,0,0,1)},i.prototype.setToUnitYFlip=function(){return this[0]=1,this[1]=0,this[2]=0,this[3]=0,this[4]=-1,this[5]=1,this[6]=0,this[7]=0,this[8]=1,this},i.prototype.multiplyMatrix=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"Matrix3","multiplyMatrix","missingMatrix"));var r,n,o,s=this,a=i;return r=s[0],n=s[1],o=s[2],s[0]=r*a[0]+n*a[3]+o*a[6],s[1]=r*a[1]+n*a[4]+o*a[7],s[2]=r*a[2]+n*a[5]+o*a[8],r=s[3],n=s[4],o=s[5],s[3]=r*a[0]+n*a[3]+o*a[6],s[4]=r*a[1]+n*a[4]+o*a[7],s[5]=r*a[2]+n*a[5]+o*a[8],r=s[6],n=s[7],o=s[8],s[6]=r*a[0]+n*a[3]+o*a[6],s[7]=r*a[1]+n*a[4]+o*a[7],s[8]=r*a[2]+n*a[5]+o*a[8],this},i.prototype.multiplyByTileTransform=function(t,e){var i=t.deltaLatitude(),r=t.deltaLongitude(),n=e.deltaLatitude(),o=e.deltaLongitude(),s=r/o,a=i/n,l=(t.minLongitude-e.minLongitude)/o,h=(t.minLatitude-e.minLatitude)/n,u=this;return u[2]+=u[0]*l+u[1]*h,u[5]+=u[3]*l+u[4]*h,u[8]+=u[6]*l+u[6]*h,u[0]*=s,u[1]*=a,u[3]*=s,u[4]*=a,u[6]*=s,u[7]*=a,this},i.prototype.columnMajorComponents=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"Matrix3","columnMajorComponents","missingResult"));return i[0]=this[0],i[1]=this[3],i[2]=this[6],i[3]=this[1],i[4]=this[4],i[5]=this[7],i[6]=this[2],i[7]=this[5],i[8]=this[8],i},i}),i("geom/Sector",["../geom/Angle","../error/ArgumentError","../geom/Location","../util/Logger","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o){"use strict";var s=function(t,e,i,r){this.minLatitude=t,this.maxLatitude=e,this.minLongitude=i,this.maxLongitude=r};return s.ZERO=new s(0,0,0,0),s.FULL_SPHERE=new s(-90,90,-180,180),s.prototype.copy=function(t){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"Sector","copy","missingSector"));return this.minLatitude=t.minLatitude,this.maxLatitude=t.maxLatitude,this.minLongitude=t.minLongitude,this.maxLongitude=t.maxLongitude,this},s.prototype.isEmpty=function(){return this.minLatitude===this.maxLatitude&&this.minLongitude===this.maxLongitude},s.prototype.deltaLatitude=function(){return this.maxLatitude-this.minLatitude},s.prototype.deltaLongitude=function(){return this.maxLongitude-this.minLongitude},s.prototype.centroidLatitude=function(){return.5*(this.minLatitude+this.maxLatitude)},s.prototype.centroidLongitude=function(){return.5*(this.minLongitude+this.maxLongitude)},s.prototype.centroid=function(t){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"Sector","centroid","missingResult"));return t.latitude=this.centroidLatitude(),t.longitude=this.centroidLongitude(),t},s.prototype.minLatitudeRadians=function(){return this.minLatitude*t.DEGREES_TO_RADIANS},s.prototype.maxLatitudeRadians=function(){return this.maxLatitude*t.DEGREES_TO_RADIANS},s.prototype.minLongitudeRadians=function(){return this.minLongitude*t.DEGREES_TO_RADIANS},s.prototype.maxLongitudeRadians=function(){return this.maxLongitude*t.DEGREES_TO_RADIANS},s.prototype.setToBoundingSector=function(t){if(!t||t.length<2)throw new e(r.logMessage(r.LEVEL_SEVERE,"Sector","setToBoundingSector","missingArray"));for(var i=90,n=-90,o=180,s=-180,a=0,l=t.length;a<l;a+=1){var h=t[a];h&&(i=Math.min(i,h.latitude),n=Math.max(n,h.latitude),o=Math.min(o,h.longitude),s=Math.max(s,h.longitude))}return this.minLatitude=i,this.maxLatitude=n,this.minLongitude=o,this.maxLongitude=s,this},s.splitBoundingSectors=function(t){if(!t||t.length<2)throw new e(r.logMessage(r.LEVEL_SEVERE,"Sector","splitBoundingSectors","missingArray"));for(var i=90,n=180,a=-90,l=-180,h=null,u=0,c=t.length;u<c;u+=1){var d=t[u],p=d.latitude;p<i&&(i=p),p>a&&(a=p);var f=d.longitude;if(f>=0&&f<n&&(n=f),f<=0&&f>l&&(l=f),null!=h){var g=h.longitude;o.signum(f)!=o.signum(g)&&Math.abs(f-g)<180&&(l=0,n=0)}h=d}return i===a&&n===l?null:[new s(i,a,n,180),new s(i,a,-180,l)]},s.prototype.intersects=function(t){return t&&this.minLongitude<=t.maxLongitude&&this.maxLongitude>=t.minLongitude&&this.minLatitude<=t.maxLatitude&&this.maxLatitude>=t.minLatitude},s.prototype.overlaps=function(t){return t&&this.minLongitude<t.maxLongitude&&this.maxLongitude>t.minLongitude&&this.minLatitude<t.maxLatitude&&this.maxLatitude>t.minLatitude},s.prototype.contains=function(t){return t&&this.minLatitude<=t.minLatitude&&this.maxLatitude>=t.maxLatitude&&this.minLongitude<=t.minLongitude&&this.maxLongitude>=t.maxLongitude},s.prototype.containsLocation=function(t,e){return this.minLatitude<=t&&this.maxLatitude>=t&&this.minLongitude<=e&&this.maxLongitude>=e},s.prototype.intersection=function(t){if(!t instanceof s)throw new e(r.logMessage(r.LEVEL_SEVERE,"Sector","intersection","missingSector"));return this.minLatitude<t.minLatitude&&(this.minLatitude=t.minLatitude),this.maxLatitude>t.maxLatitude&&(this.maxLatitude=t.maxLatitude),this.minLongitude<t.minLongitude&&(this.minLongitude=t.minLongitude),this.maxLongitude>t.maxLongitude&&(this.maxLongitude=t.maxLongitude),this.maxLatitude<this.minLatitude&&(this.maxLatitude=this.minLatitude),this.maxLongitude<this.minLongitude&&(this.maxLongitude=this.minLongitude),this},s.prototype.union=function(t){if(!t instanceof s)throw new e(r.logMessage(r.LEVEL_SEVERE,"Sector","union","missingSector"));return this.minLatitude>t.minLatitude&&(this.minLatitude=t.minLatitude),this.maxLatitude<t.maxLatitude&&(this.maxLatitude=t.maxLatitude),this.minLongitude>t.minLongitude&&(this.minLongitude=t.minLongitude),this.maxLongitude<t.maxLongitude&&(this.maxLongitude=t.maxLongitude),this},s}),i("shaders/SkyProgram",["../shaders/AtmosphereProgram"],function(t){"use strict";var e=function(e){var i="precision mediump int;\nconst int SAMPLE_COUNT = 2;\nconst float SAMPLES = 2.0;\nconst float PI = 3.141592653589;\nconst float Kr = 0.0025;\nconst float Kr4PI = Kr * 4.0 * PI;\nconst float Km = 0.0015;\nconst float Km4PI = Km * 4.0 * PI;\nconst float ESun = 15.0;\nconst float KmESun = Km * ESun;\nconst float KrESun = Kr * ESun;\nconst vec3 invWavelength = vec3(5.60204474633241, 9.473284437923038, 19.643802610477206);\nconst float rayleighScaleDepth = 0.25;\nuniform mat4 mvpMatrix;\nuniform vec3 vertexOrigin;\nuniform vec3 eyePoint;\nuniform float eyeMagnitude;\nuniform float eyeMagnitude2;\nuniform mediump vec3 lightDirection;\nuniform float atmosphereRadius;\nuniform float atmosphereRadius2;\nuniform float globeRadius;\nuniform float scale;\nuniform float scaleDepth;\nuniform float scaleOverScaleDepth;\nattribute vec4 vertexPoint;\nvarying vec3 primaryColor;\nvarying vec3 secondaryColor;\nvarying vec3 direction;\nfloat scaleFunc(float cos)\n{\n    float x = 1.0 - cos;\n    return scaleDepth * exp(-0.00287 + x*(0.459 + x*(3.83 + x*(-6.80 + x*5.25))));\n}\nvoid sampleSky() {\n    vec3 point = vertexPoint.xyz + vertexOrigin;\n    vec3 ray = point - eyePoint;\n    float far = length(ray);\n    ray /= far;\n    vec3 start;\n    float startOffset;\n    if (eyeMagnitude < atmosphereRadius) {\n        start = eyePoint;\n        float height = length(start);\n        float depth = exp(scaleOverScaleDepth * (globeRadius - eyeMagnitude));\n        float startAngle = dot(ray, start) / height;\n        startOffset = depth*scaleFunc(startAngle);\n    } else {\n        float B = 2.0 * dot(eyePoint, ray);\n        float C = eyeMagnitude2 - atmosphereRadius2;\n        float det = max(0.0, B*B - 4.0 * C);\n        float near = 0.5 * (-B - sqrt(det));\n        start = eyePoint + ray * near;\n        far -= near;\n        float startAngle = dot(ray, start) / atmosphereRadius;\n        float startDepth = exp(-1.0 / scaleDepth);\n        startOffset = startDepth*scaleFunc(startAngle);\n    }\n    float sampleLength = far / SAMPLES;\n    float scaledLength = sampleLength * scale;\n    vec3 sampleRay = ray * sampleLength;\n    vec3 samplePoint = start + sampleRay * 0.5;\n    vec3 frontColor = vec3(0.0, 0.0, 0.0);\n    for(int i=0; i<SAMPLE_COUNT; i++)\n    {\n       float height = length(samplePoint);\n       float depth = exp(scaleOverScaleDepth * (globeRadius - height));\n       float lightAngle = dot(lightDirection, samplePoint) / height;\n       float cameraAngle = dot(ray, samplePoint) / height;\n       float scatter = (startOffset + depth*(scaleFunc(lightAngle) - scaleFunc(cameraAngle)));\n       vec3 attenuate = exp(-scatter * (invWavelength * Kr4PI + Km4PI));\n       frontColor += attenuate * (depth * scaledLength);\n       samplePoint += sampleRay;\n    }\n    primaryColor = frontColor * (invWavelength * KrESun);\n    secondaryColor = frontColor * KmESun;\n    direction = eyePoint - point;\n}\nvoid main()\n{\n    sampleSky();\n    gl_Position = mvpMatrix * vertexPoint;\n}",r="#ifdef GL_FRAGMENT_PRECISION_HIGH\nprecision highp float;\n#else\nprecision mediump float;\n#endif\nconst float g = -0.95;\nconst float g2 = g * g;\nuniform mediump vec3 lightDirection;\nvarying vec3 primaryColor;\nvarying vec3 secondaryColor;\nvarying vec3 direction;\nvoid main (void)\n{\n    float cos = dot(lightDirection, direction) / length(direction);\n    float rayleighPhase = 0.75 * (1.0 + cos * cos);\n    float miePhase = 1.5 * ((1.0 - g2) / (2.0 + g2)) * (1.0 + cos*cos) /         pow(1.0 + g2 - 2.0*g*cos, 1.5);\n    const float exposure = 2.0;\n    vec3 color = primaryColor * rayleighPhase + secondaryColor * miePhase;\n    color = vec3(1.0) - exp(-exposure * color);\n    gl_FragColor = vec4(color, color.b);\n}";
t.call(this,e,i,r,["vertexPoint"])};return e.key="WorldWindSkyProgram",e.prototype=Object.create(t.prototype),e}),i("util/WWUtil",["../error/ArgumentError","../geom/Line","../util/Logger","../geom/Rectangle","../geom/Vec3"],function(t,e,i,r,n){"use strict";var o={latLonRegex:/^(\-?\d+(\.\d+)?),\s*(\-?\d+(\.\d+)?)$/,suffixForMimeType:function(t){return"image/png"===t?"png":"image/jpeg"===t?"jpg":"application/bil16"===t?"bil":"application/bil32"===t?"bil":null},currentUrlSansFilePart:function(){for(var t=window.location.protocol,e=window.location.host,i=window.location.pathname,r=i.split("/"),n="",o=0,s=r.length;o<s-1;o++)r[o].length>0&&(n=n+"/"+r[o]);return t+"//"+e+n},worldwindlibLocation:function(){for(var t=document.getElementsByTagName("script"),e="/worldwindlib.",i=0;i<t.length;i++){var r=t[i].src.indexOf(e);if(r>=0)return t[i].src.substring(0,r)+"/"}return null},urlPath:function(t){if(!t)return"";for(var e=t.split("/"),i="",r=0,n=e.length;r<n;r++){var o=e[r];o&&0!==o.length&&o.indexOf(":")==-1&&"."!==o&&".."!==o&&"null"!==o&&"undefined"!==o&&(0!==i.length&&(i+="/"),i+=o)}return i},fillArray:function(t,e){if(t)for(var i=0,r=t.length;i<r;i++)t[i]=e},multiplyArray:function(t,e){if(t)for(var i=0,r=t.length;i<r;i++)t[i]*=e},jsonpCounter:0,jsonp:function(t,e,i){var r="gov_nasa_worldwind_jsonp_"+o.jsonpCounter++;window[r]=function(t){delete window[r],i(t)};var n=t+(t.indexOf("?")===-1?"?":"&");n+=e+"="+r;var s=document.createElement("script");s.async=!0,s.src=n;var a=document.getElementsByTagName("head")[0],l=function(){s.onload=void 0,s.onerror=void 0,a.removeChild(s)};s.onload=l,s.onerror=l,a.appendChild(s)},arrayEquals:function(t,e){return t.length==e.length&&t.every(function(t,i){return t===e[i]||t.equals&&t.equals(e[i])})},transformToBoolean:function(t){return 0!=t&&"0"!=t&&"false"!=t&&Boolean(t)},clone:function(t){var e,i={},r=Object.keys(t);for(e=0;e<r.length;e++)i[r[e]]=t[r[e]];return i},guid:function(){function t(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)}return t()+t()+"-"+t()+"-"+t()+"-"+t()+"-"+t()+t()+t()},date:function(t){return new Date(t)}};return o}),i("layer/AtmosphereLayer",["../error/ArgumentError","../shaders/GroundProgram","../layer/Layer","../util/Logger","../geom/Matrix","../geom/Matrix3","../geom/Sector","../shaders/SkyProgram","../geom/Vec3","../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h){"use strict";var u=function(t){i.call(this,"Atmosphere"),this.pickEnabled=!1,this._nightImageSource=t||WorldWind.configuration.baseUrl+"images/dnb_land_ocean_ice_2012.png",this._lightLocation=null,this._activeLightDirection=new l(0,0,0),this._fullSphereSector=s.FULL_SPHERE,this._skyData={},this._skyWidth=128,this._skyHeight=128,this._numIndices=0,this._texMatrix=o.fromIdentity(),this._activeTexture=null};return u.prototype=Object.create(i.prototype),Object.defineProperties(u.prototype,{lightLocation:{get:function(){return this._lightLocation},set:function(t){this._lightLocation=t}},nightImageSource:{get:function(){return this._nightImageSource},set:function(t){this._nightImageSource=t}}}),u.prototype.doRender=function(t){t.globe.is2D()||(this.determineLightDirection(t),this.drawSky(t),this.drawGround(t))},u.prototype.applySkyVertices=function(t){var e,i,r=t.currentGlContext,n=t.currentProgram,o=this._skyData;o.verticesVboCacheKey||(o.verticesVboCacheKey=t.gpuResourceCache.generateCacheKey()),i=t.gpuResourceCache.resourceForKey(o.verticesVboCacheKey),i?(r.bindBuffer(r.ARRAY_BUFFER,i),r.vertexAttribPointer(0,3,r.FLOAT,!1,0,0)):(e=this.assembleVertexPoints(t,this._skyHeight,this._skyWidth,n.getAltitude()),i=r.createBuffer(),r.bindBuffer(r.ARRAY_BUFFER,i),r.bufferData(r.ARRAY_BUFFER,e,r.STATIC_DRAW),r.vertexAttribPointer(0,3,r.FLOAT,!1,0,0),t.gpuResourceCache.putResource(o.verticesVboCacheKey,i,4*e.length),t.frameStatistics.incrementVboLoadCount(1))},u.prototype.applySkyIndices=function(t){var e,i,r=t.currentGlContext,n=this._skyData;n.indicesVboCacheKey||(n.indicesVboCacheKey=t.gpuResourceCache.generateCacheKey()),i=t.gpuResourceCache.resourceForKey(n.indicesVboCacheKey),i?r.bindBuffer(r.ELEMENT_ARRAY_BUFFER,i):(e=this.assembleTriStripIndices(this._skyWidth,this._skyHeight),i=r.createBuffer(),r.bindBuffer(r.ELEMENT_ARRAY_BUFFER,i),r.bufferData(r.ELEMENT_ARRAY_BUFFER,e,r.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),t.gpuResourceCache.putResource(n.indicesVboCacheKey,i,2*e.length))},u.prototype.drawSky=function(t){var e=t.currentGlContext,i=t.findAndBindProgram(a);i.loadGlobeRadius(e,t.globe.equatorialRadius),i.loadEyePoint(e,t.navigatorState.eyePoint),i.loadVertexOrigin(e,l.ZERO),i.loadModelviewProjection(e,t.navigatorState.modelviewProjection),i.loadLightDirection(e,this._activeLightDirection),i.setScale(e),this.applySkyVertices(t),this.applySkyIndices(t),e.depthMask(!1),e.frontFace(e.CW),e.enableVertexAttribArray(0),e.drawElements(e.TRIANGLE_STRIP,this._numIndices,e.UNSIGNED_SHORT,0),e.depthMask(!0),e.frontFace(e.CCW),e.disableVertexAttribArray(0)},u.prototype.drawGround=function(t){var i,r=t.currentGlContext,n=t.findAndBindProgram(e),o=t.terrain;n.loadGlobeRadius(r,t.globe.equatorialRadius),n.loadEyePoint(r,t.navigatorState.eyePoint),n.loadLightDirection(r,this._activeLightDirection),n.setScale(r),this.nightImageSource&&this.lightLocation&&(this._activeTexture=t.gpuResourceCache.resourceForKey(this.nightImageSource),this._activeTexture||(this._activeTexture=t.gpuResourceCache.retrieveTexture(r,this.nightImageSource)),i=this._activeTexture&&this._activeTexture.bind(t)),o.beginRendering(t);for(var s=0,a=o.surfaceGeometry.length;s<a;s++){var l=o.surfaceGeometry[s],h=l.referencePoint;n.loadVertexOrigin(r,h),i&&(this._texMatrix.setToUnitYFlip(),this._texMatrix.multiplyByTileTransform(l.sector,this._fullSphereSector),n.loadTexMatrix(r,this._texMatrix)),o.beginRenderingTile(t,l),n.loadFragMode(r,n.FRAGMODE_GROUND_SECONDARY),r.blendFunc(r.DST_COLOR,r.ZERO),o.renderTile(t,l);var u=i?n.FRAGMODE_GROUND_PRIMARY_TEX_BLEND:n.FRAGMODE_GROUND_PRIMARY;n.loadFragMode(r,u),r.blendFunc(r.ONE,r.ONE),o.renderTile(t,l),o.endRenderingTile(t,l)}o.endRendering(t),r.blendFunc(r.ONE,r.ONE_MINUS_SRC_ALPHA),this._activeTexture=null},u.prototype.assembleVertexPoints=function(t,e,i,r){var n=e*i,o=new Array(n);h.fillArray(o,r);var s=new Float32Array(3*n);return t.globe.computePointsForGrid(this._fullSphereSector,e,i,o,l.ZERO,s)},u.prototype.assembleTriStripIndices=function(t,e){for(var i=[],r=0,n=0;n<t-1;n++){for(var o=0;o<e;o++)r=o+n*e,i.push(r+e),i.push(r);n<t-2&&(i.push(r),i.push((n+2)*e))}return this._numIndices=i.length,new Uint16Array(i)},u.prototype.determineLightDirection=function(t){null!=this.lightLocation?t.globe.computePointFromLocation(this.lightLocation.latitude,this.lightLocation.longitude,this._activeLightDirection):this._activeLightDirection.copy(t.navigatorState.eyePoint),this._activeLightDirection.normalize()},u}),i("shaders/BasicProgram",["../error/ArgumentError","../util/Color","../shaders/GpuProgram","../util/Logger"],function(t,e,i,r){"use strict";var n=function(t){var e="attribute vec4 vertexPoint;\nuniform mat4 mvpMatrix;\nvoid main() {gl_Position = mvpMatrix * vertexPoint;}",r="precision mediump float;\nuniform vec4 color;\nvoid main() {gl_FragColor = color;}";i.call(this,t,e,r),this.vertexPointLocation=this.attributeLocation(t,"vertexPoint"),this.mvpMatrixLocation=this.uniformLocation(t,"mvpMatrix"),this.colorLocation=this.uniformLocation(t,"color")};return n.key="WorldWindGpuBasicProgram",n.prototype=Object.create(i.prototype),n.prototype.loadModelviewProjection=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"BasicProgram","loadModelviewProjection","missingMatrix"));this.loadUniformMatrix(e,i,this.mvpMatrixLocation)},n.prototype.loadColor=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"BasicProgram","loadColor","missingColor"));this.loadUniformColor(e,i,this.colorLocation)},n.prototype.loadColorComponents=function(t,e,i,r,n){this.loadUniformColorComponents(t,e,i,r,n,this.colorLocation)},n}),i("util/BasicTimeSequence",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i){if(!i&&i.length<2)throw new t(e.logMessage(e.LEVEL_SEVERE,"BasicTimeSequence","constructor","missingDates"));this.dates=i,this.currentIndex=0,this.currentTime=i[0]};return Object.defineProperties(i.prototype,{scaleForCurrentTime:{get:function(){return this.currentTime?this.currentIndex/this.dates.length:1}}}),i.prototype.next=function(){return this.currentIndex>=this.dates.length-1?null:(this.currentIndex++,this.currentTime=this.dates[this.currentIndex],this.currentTime)},i.prototype.previous=function(){return this.currentIndex<=0?null:(this.currentIndex--,this.currentTime=this.dates[this.currentIndex],this.currentTime)},i.prototype.reset=function(){this.currentIndex=-1,this.currentTime=null},i.prototype.getTimeForScale=function(t){return t<=0?this.currentIndex=0:t>=1?this.currentIndex=this.dates.length-1:this.currentIndex=Math.floor(this.dates.length*t),this.currentTime=this.dates[this.currentIndex],this.currentTime},i}),i("util/AbsentResourceList",[],function(){"use strict";var t=function(t,e){this.maxTrys=t,this.minCheckInterval=e,this.tryAgainInterval=6e4,this.possiblyAbsent={}};return t.prototype.isResourceAbsent=function(t){var e=this.possiblyAbsent[t];if(!e)return!1;if(e.permanent)return!0;var i=Date.now()-e.timeOfLastMark;return i>this.tryAgainInterval?(delete this.possiblyAbsent[t],!1):i<this.minCheckInterval||e.numTrys>this.maxTrys},t.prototype.markResourceAbsent=function(t){var e=this.possiblyAbsent[t];e||(e={timeOfLastMark:Date.now(),numTrys:0},this.possiblyAbsent[t]=e),e.numTrys=e.numTrys+1,e.timeOfLastMark=Date.now()},t.prototype.markResourceAbsentPermanently=function(t){var e=this.possiblyAbsent[t];e||(e={timeOfLastMark:Date.now(),numTrys:0},this.possiblyAbsent[t]=e),e.numTrys=e.numTrys+1,e.timeOfLastMark=Date.now(),e.permanent=!0},t.prototype.unmarkResourceAbsent=function(t){var e=this.possiblyAbsent[t];e&&delete this.possiblyAbsent[t]},t}),i("geom/Frustum",["../error/ArgumentError","../geom/Matrix","../geom/Plane","../util/Logger"],function(t,e,i,r){"use strict";var n=function(e,i,n,o,s,a){if(!(e&&i&&n&&o&&s&&a))throw new t(r.logMessage(r.LEVEL_SEVERE,"Frustum","constructor","missingPlane"));this._left=e,this._right=i,this._bottom=n,this._top=o,this._near=s,this._far=a,this._planes=[this._left,this._right,this._top,this._bottom,this._near,this._far]};return Object.defineProperties(n.prototype,{left:{get:function(){return this._left}},right:{get:function(){return this._right}},bottom:{get:function(){return this._bottom}},top:{get:function(){return this._top}},near:{get:function(){return this._near}},far:{get:function(){return this._far}}}),n.prototype.transformByMatrix=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"Frustum","transformByMatrix","missingMatrix"));return this._left.transformByMatrix(e),this._right.transformByMatrix(e),this._bottom.transformByMatrix(e),this._top.transformByMatrix(e),this._near.transformByMatrix(e),this._far.transformByMatrix(e),this},n.prototype.normalize=function(){return this._left.normalize(),this._right.normalize(),this._bottom.normalize(),this._top.normalize(),this._near.normalize(),this._far.normalize(),this},n.unitFrustum=function(){return new n(new i(1,0,0,1),new i(-1,0,0,1),new i(0,1,1,1),new i(0,-1,0,1),new i(0,0,-1,1),new i(0,0,1,1))},n.fromProjectionMatrix=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"Frustum","fromProjectionMatrix","missingMatrix"));var o,s,a,l,h,u,c,d,p,f,g;return o=e[12]+e[0],s=e[13]+e[1],a=e[14]+e[2],l=e[15]+e[3],h=Math.sqrt(o*o+s*s+a*a),u=new i(o/h,s/h,a/h,l/h),o=e[12]-e[0],s=e[13]-e[1],a=e[14]-e[2],l=e[15]-e[3],h=Math.sqrt(o*o+s*s+a*a),c=new i(o/h,s/h,a/h,l/h),o=e[12]+e[4],s=e[13]+e[5],a=e[14]+e[6],l=e[15]+e[7],h=Math.sqrt(o*o+s*s+a*a),p=new i(o/h,s/h,a/h,l/h),o=e[12]-e[4],s=e[13]-e[5],a=e[14]-e[6],l=e[15]-e[7],h=Math.sqrt(o*o+s*s+a*a),d=new i(o/h,s/h,a/h,l/h),o=e[12]+e[8],s=e[13]+e[9],a=e[14]+e[10],l=e[15]+e[11],h=Math.sqrt(o*o+s*s+a*a),f=new i(o/h,s/h,a/h,l/h),o=e[12]-e[8],s=e[13]-e[9],a=e[14]-e[10],l=e[15]-e[11],h=Math.sqrt(o*o+s*s+a*a),g=new i(o/h,s/h,a/h,l/h),new n(u,c,p,d,f,g)},n.prototype.containsPoint=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"Frustum","containsPoint","missingPoint"));return!(this._far.dot(e)<=0)&&(!(this._left.dot(e)<=0)&&(!(this._right.dot(e)<=0)&&(!(this._top.dot(e)<=0)&&(!(this._bottom.dot(e)<=0)&&!(this._near.dot(e)<=0)))))},n.prototype.intersectsSegment=function(e,i){if(!e||!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"Frustum","containsPoint","missingPoint"));if(this.containsPoint(e)||this.containsPoint(i))return!0;if(e.equals(i))return!1;for(var n=0,o=this._planes.length;n<o;n++){if(this._planes[n].onSameSide(e,i)<0)return!1;if(null!=this._planes[n].clip(e,i))return!0}return!1},n}),i("error/NotYetImplementedError",["../error/AbstractError"],function(t){"use strict";var e=function(e){t.call(this,"NotYetImplementedError",e);var i;try{throw new Error}catch(t){i=t.stack}this.stack=i};return e.prototype=Object.create(t.prototype),e}),i("geom/BoundingBox",["../error/ArgumentError","../shaders/BasicProgram","../geom/Frustum","../util/Logger","../geom/Matrix","../error/NotYetImplementedError","../geom/Plane","../geom/Sector","../geom/Vec3","../util/WWMath","../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h,u){"use strict";var c=function(){this.center=new l(0,0,0),this.bottomCenter=new l(-.5,0,0),this.topCenter=new l(.5,0,0),this.r=new l(1,0,0),this.s=new l(0,1,0),this.t=new l(0,0,1),this.radius=Math.sqrt(3),this.tmp1=new l(0,0,0),this.tmp2=new l(0,0,0),this.tmp3=new l(0,0,0),this.scratchElevations=new Float64Array(9),this.scratchPoints=new Float64Array(3*this.scratchElevations.length)};return c.scratchMatrix=n.fromIdentity(),c.prototype.setToPoints=function(e){if(!e||e.length<3)throw new t(r.logMessage(r.LEVEL_SEVERE,"BoundingBox","setToPoints","missingArray"));var i,o,s,a,h,u,c,d,p,f,g,m,E,y,_,v=+Number.MAX_VALUE,b=-Number.MAX_VALUE,S=+Number.MAX_VALUE,T=-Number.MAX_VALUE,L=+Number.MAX_VALUE,w=-Number.MAX_VALUE,x=this.r,R=this.s,M=this.t,C=new l(0,0,0);n.principalAxesFromPoints(e,x,R,M);for(var A=0,P=e.length/3;A<P;A++)C[0]=e[3*A],C[1]=e[3*A+1],C[2]=e[3*A+2],i=C.dot(x),v>i&&(v=i),b<i&&(b=i),o=C.dot(R),S>o&&(S=o),T<o&&(T=o),s=C.dot(M),L>s&&(L=s),w<s&&(w=s);return b===v&&(b=v+1),T===S&&(T=S+1),w===L&&(w=L+1),a=b-v,h=T-S,u=w-L,c=b+v,d=T+S,p=w+L,f=.5*x[0]*a,g=.5*x[1]*a,m=.5*x[2]*a,E=.5*(x[0]*c+R[0]*d+M[0]*p),y=.5*(x[1]*c+R[1]*d+M[1]*p),_=.5*(x[2]*c+R[2]*d+M[2]*p),this.center[0]=E,this.center[1]=y,this.center[2]=_,this.topCenter[0]=E+f,this.topCenter[1]=y+g,this.topCenter[2]=_+m,this.bottomCenter[0]=E-f,this.bottomCenter[1]=y-g,this.bottomCenter[2]=_-m,x.multiply(a),R.multiply(h),M.multiply(u),this.radius=.5*Math.sqrt(a*a+h*h+u*u),this},c.prototype.setToSector=function(e,i,n,o){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"BoundingBox","setToSector","missingSector"));if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"BoundingBox","setToSector","missingGlobe"));var s=this.scratchElevations,a=this.scratchPoints;u.fillArray(s,o),s[0]=s[2]=s[6]=s[8]=n,i.computePointsForGrid(e,3,3,s,l.ZERO,a);var c=12;this.tmp1.set(a[c],a[c+1],a[c+2]),h.localCoordinateAxesAtPoint(this.tmp1,i,this.r,this.s,this.t);for(var d=[Number.POSITIVE_INFINITY,Number.NEGATIVE_INFINITY],p=[Number.POSITIVE_INFINITY,Number.NEGATIVE_INFINITY],f=[Number.POSITIVE_INFINITY,Number.NEGATIVE_INFINITY],g=0,m=a.length;g<m;g+=3)this.tmp1.set(a[g],a[g+1],a[g+2]),this.adjustExtremes(this.r,d,this.s,p,this.t,f,this.tmp1);d[1]-d[0]<p[1]-p[0]&&this.swapAxes(this.r,d,this.s,p),p[1]-p[0]<f[1]-f[0]&&this.swapAxes(this.s,p,this.t,f),d[1]-d[0]<p[1]-p[0]&&this.swapAxes(this.r,d,this.s,p);var E=d[1]-d[0],y=p[1]-p[0],_=f[1]-f[0],v=d[1]+d[0],b=p[1]+p[0],S=f[1]+f[0],T=.5*(this.r[0]*v+this.s[0]*b+this.t[0]*S),L=.5*(this.r[1]*v+this.s[1]*b+this.t[1]*S),w=.5*(this.r[2]*v+this.s[2]*b+this.t[2]*S),x=.5*this.r[0]*E,R=.5*this.r[1]*E,M=.5*this.r[2]*E;return this.center.set(T,L,w),this.topCenter.set(T+x,L+R,w+M),this.bottomCenter.set(T-x,L-R,w-M),this.r.multiply(E),this.s.multiply(y),this.t.multiply(_),this.radius=.5*Math.sqrt(E*E+y*y+_*_),this},c.prototype.translate=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"BoundingBox","translate","missingVector"));return this.bottomCenter.add(e),this.topCenter.add(e),this.center.add(e),this},c.prototype.distanceTo=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"BoundingBox","distanceTo","missingPoint"));var i=this.center.distanceTo(e)-this.radius;return i>=0?i:-i},c.prototype.effectiveRadius=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"BoundingBox","effectiveRadius","missingPlane"));var i=e.normal;return.5*(h.fabs(this.r.dot(i))+h.fabs(this.s.dot(i))+h.fabs(this.t.dot(i)))},c.prototype.intersectsFrustum=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"BoundingBox","intersectsFrustum","missingFrustum"));return this.tmp1.copy(this.bottomCenter),this.tmp2.copy(this.topCenter),!(this.intersectionPoint(e.near)<0)&&(!(this.intersectionPoint(e.far)<0)&&(!(this.intersectionPoint(e.left)<0)&&(!(this.intersectionPoint(e.right)<0)&&(!(this.intersectionPoint(e.top)<0)&&!(this.intersectionPoint(e.bottom)<0)))))},c.prototype.intersectionPoint=function(t){var e=t.normal,i=.5*(Math.abs(this.s.dot(e))+Math.abs(this.t.dot(e)));return this.intersectsAt(t,i,this.tmp1,this.tmp2)},c.prototype.intersectsAt=function(t,e,i,r){var n=t.dot(i),o=n<=-e,s=t.dot(r),a=s<=-e;if(o&&a)return-1;if(o==a)return 0;this.tmp3.copy(i),this.tmp3.subtract(r);var l=(e+n)/t.normal.dot(this.tmp3);return this.tmp3.copy(r),this.tmp3.subtract(i),this.tmp3.multiply(l),this.tmp3.add(i),o?i.copy(this.tmp3):r.copy(this.tmp3),l},c.prototype.adjustExtremes=function(t,e,i,r,n,o,s){var a=s.dot(t);e[0]>a&&(e[0]=a),e[1]<a&&(e[1]=a);var l=s.dot(i);r[0]>l&&(r[0]=l),r[1]<l&&(r[1]=l);var h=s.dot(n);o[0]>h&&(o[0]=h),o[1]<h&&(o[1]=h)},c.prototype.swapAxes=function(t,e,i,r){t.swap(i);var n=e[0];e[0]=r[0],r[0]=n,n=e[1],e[1]=r[1],r[1]=n},c.prototype.render=function(t){var i=t.currentGlContext,r=c.scratchMatrix,n=t.findAndBindProgram(e);try{r.copy(t.navigatorState.modelviewProjection),r.multiply(this.r[0],this.s[0],this.t[0],this.center[0],this.r[1],this.s[1],this.t[1],this.center[1],this.r[2],this.s[2],this.t[2],this.center[2],0,0,0,1),r.multiplyByTranslation(-.5,-.5,-.5),n.loadModelviewProjection(i,r),i.disable(i.CULL_FACE),i.bindBuffer(i.ARRAY_BUFFER,t.unitCubeBuffer()),i.bindBuffer(i.ELEMENT_ARRAY_BUFFER,t.unitCubeElements()),i.enableVertexAttribArray(n.vertexPointLocation),i.vertexAttribPointer(n.vertexPointLocation,3,i.FLOAT,!1,0,0),n.loadColorComponents(i,0,1,0,.6),i.drawElements(i.LINES,24,i.UNSIGNED_SHORT,72),n.loadColorComponents(i,1,1,1,.3),i.drawElements(i.TRIANGLES,36,i.UNSIGNED_SHORT,0)}finally{i.enable(i.CULL_FACE),i.bindBuffer(i.ARRAY_BUFFER,null),i.bindBuffer(i.ELEMENT_ARRAY_BUFFER,null)}},c}),i("util/Tile",["../error/ArgumentError","../geom/BoundingBox","../util/Logger","../geom/Sector","../geom/Vec3","../util/WWUtil"],function(t,e,i,r,n,o){"use strict";var s=function(e,r,n,o){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","constructor","missingSector"));if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","constructor","The specified level is null or undefined."));if(n<0||o<0)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","constructor","The specified row or column is less than zero."));this.sector=e,this.level=r,this.row=n,this.column=o,this.tileWidth=r.tileWidth,this.tileHeight=r.tileHeight,this.texelSize=r.texelSize,this.tileKey=r.levelNumber.toString()+"."+n.toString()+"."+o.toString(),this.extent=null,this.referencePoint=null,this.opacity=1,this.samplePoints=null,this.sampleElevations=null,this.updateTimestamp=null,this.updateVerticalExaggeration=null,this.updateGlobeStateKey=null};return s.prototype.isEqual=function(t){return!!t&&(!!t.tileKey&&this.tileKey==t.tileKey)},s.prototype.size=function(){return 828},s.prototype.distanceTo=function(e){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","distanceTo","missingVector"));for(var r,n,o,s=e[0],a=e[1],l=e[2],h=this.samplePoints,u=Number.POSITIVE_INFINITY,c=0,d=h.length;c<d;c+=3)r=s-h[c],n=a-h[c+1],o=l-h[c+2],u=Math.min(u,r*r+n*n+o*o);return Math.sqrt(u)},s.prototype.subdivide=function(e,n){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","subdivide","The specified level is null or undefined."));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","subdivide","The specified tile factory is null or undefined."));var o,s,a,l=this.sector.minLatitude,h=this.sector.maxLatitude,u=this.sector.centroidLatitude(),c=this.sector.minLongitude,d=this.sector.maxLongitude,p=this.sector.centroidLongitude(),f=[];return o=2*this.row,s=2*this.column,a=new r(l,u,c,p),f.push(n.createTile(a,e,o,s)),o=2*this.row,s=2*this.column+1,a=new r(l,u,p,d),f.push(n.createTile(a,e,o,s)),o=2*this.row+1,s=2*this.column,a=new r(u,h,c,p),f.push(n.createTile(a,e,o,s)),o=2*this.row+1,s=2*this.column+1,a=new r(u,h,p,d),f.push(n.createTile(a,e,o,s)),f},s.prototype.subdivideToCache=function(e,r,n){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","subdivideToCache","The specified level is null or undefined."));if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","subdivideToCache","The specified tile factory is null or undefined."));var o=n?n.entryForKey(this.tileKey):null;return o||(o=this.subdivide(e,r),o&&n&&n.putEntry(this.tileKey,o,4*o[0].size())),o},s.prototype.mustSubdivide=function(t,e){var i=t.globe.equatorialRadius*this.texelSize,r=this.distanceTo(t.navigatorState.eyePoint),n=t.navigatorState.pixelSizeAtDistance(r);return i>Math.max(e*n,.5)},s.prototype.update=function(t){var e=t.globe.elevationTimestamp(),i=t.verticalExaggeration,r=t.globeStateKey;this.updateTimestamp==e&&this.updateVerticalExaggeration==i&&this.updateGlobeStateKey==r||(this.doUpdate(t),t.frameStatistics.incrementTileUpdateCount(1),this.updateTimestamp=e,this.updateVerticalExaggeration=i,this.updateGlobeStateKey=r)},s.prototype.doUpdate=function(t){var i=t.globe,r=t.verticalExaggeration,s=i.minAndMaxElevationsForSector(this.sector),a=s?s[0]*r:0,l=s?s[1]*r:0;a==l&&(a=l+10),this.extent||(this.extent=new e),this.extent.setToSector(this.sector,i,a,l),this.samplePoints||(this.sampleElevations=new Float64Array(9),this.samplePoints=new Float64Array(3*this.sampleElevations.length)),o.fillArray(this.sampleElevations,.5*(a+l)),i.computePointsForGrid(this.sector,3,3,this.sampleElevations,n.ZERO,this.samplePoints),this.referencePoint||(this.referencePoint=new n(0,0,0)),i.computePointFromPosition(this.sector.centroidLatitude(),this.sector.centroidLongitude(),0,this.referencePoint)},s.computeRow=function(t,e){var i=Math.floor((e+90)/t);return 90==e&&(i-=1),i},s.computeColumn=function(t,e){var i=Math.floor((e+180)/t);return 180==e&&(i-=1),i},s.computeLastRow=function(t,e){var i=Math.ceil((e+90)/t-1);return e+90<t&&(i=0),i},s.computeLastColumn=function(t,e){var i=Math.ceil((e+180)/t-1);return e+180<t&&(i=0),i},s.computeSector=function(e,n,o){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","computeSector","missingLevel"));if(n<0||o<0)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","computeSector","The specified row or column is less than zero."));var s=e.tileDelta.latitude,a=e.tileDelta.longitude,l=-90+n*s,h=-180+o*a,u=l+s,c=h+a;return new r(l,u,h,c)},s.createTilesForLevel=function(e,n,o){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","createTilesForLevel","missingLevel"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","createTilesForLevel","The specified tile factory is null or undefined"));if(!o)throw new t(i.logMessage(i.LEVEL_SEVERE,"Tile","createTilesForLevel","missingResult"));for(var a,l,h,u=e.tileDelta.latitude,c=e.tileDelta.longitude,d=e.sector,p=s.computeRow(u,d.minLatitude),f=s.computeRow(u,d.maxLatitude),g=s.computeColumn(c,d.minLongitude),m=s.computeColumn(c,d.maxLongitude),E=-90+p*u,y=-180+g*c,_=E,v=p;v<=f;v+=1){l=_+u,a=y;for(var b=g;b<=m;b+=1){h=a+c;var S=new r(_,l,a,h),T=n.createTile(S,e,v,b);o.push(T),a=h}_=l}},s}),i("render/TextureTile",["../error/ArgumentError","../util/Logger","../util/Tile"],function(t,e,i){"use strict";var r=function(t,e,r,n){i.call(this,t,e,r,n),this.gpuCacheKey=null};return r.prototype=Object.create(i.prototype),r.prototype.size=function(){return i.prototype.size.call(this)},r.prototype.bind=function(t){var e=t.gpuResourceCache.resourceForKey(this.gpuCacheKey);return!!e&&e.bind(t)},r.prototype.applyInternalTransform=function(t,e){},r}),i("render/ImageTile",["../error/ArgumentError","../util/Logger","../render/TextureTile","../util/Tile"],function(t,e,i,r){"use strict";var n=function(r,n,o,s,a){if(!a||a.length<1)throw new t(e.logMessage(e.LEVEL_SEVERE,"ImageTile","constructor","The specified image path is null, undefined or zero length."));i.call(this,r,n,o,s),this.imagePath=a,this.fallbackTile=null,this.gpuCacheKey=a};return n.prototype=Object.create(i.prototype),n.prototype.size=function(){return this.__proto__.__proto__.size.call(this)+this.imagePath.length+8},n.prototype.bind=function(t){var e=this.__proto__.__proto__.bind.call(this,t);return!!e||!!this.fallbackTile&&this.fallbackTile.bind(t)},n.prototype.applyInternalTransform=function(t,e){this.fallbackTile&&!t.gpuResourceCache.resourceForKey(this.imagePath)&&this.applyFallbackTransform(e)},n.prototype.applyFallbackTransform=function(t){var e=this.level.levelNumber-this.fallbackTile.level.levelNumber;if(!(e<=0)){var i=this.fallbackTile.sector.deltaLatitude(),r=this.fallbackTile.sector.deltaLongitude(),n=this.sector.deltaLongitude()/r,o=this.sector.deltaLatitude()/i,s=(this.sector.minLongitude-this.fallbackTile.sector.minLongitude)/r,a=(this.sector.minLatitude-this.fallbackTile.sector.minLatitude)/i;t.multiply(n,0,0,s,0,o,0,a,0,0,1,0,0,0,0,1)}},n}),i("util/Level",["../geom/Angle","../error/ArgumentError","../geom/Location","../util/Logger"],function(t,e,i,r){"use strict";var n=function(i,n,o){if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"Level","constructor","The specified tile delta is null or undefined"));if(!o)throw new e(r.logMessage(r.LEVEL_SEVERE,"Level","constructor","The specified parent level set is null or undefined"));this.levelNumber=i,this.tileDelta=n,this.parent=o,this.texelSize=n.latitude*t.DEGREES_TO_RADIANS/o.tileHeight,this.tileWidth=o.tileWidth,this.tileHeight=o.tileHeight,this.sector=o.sector};return n.prototype.isFirstLevel=function(){return this.parent.firstLevel()==this},n.prototype.isLastLevel=function(){return this.parent.lastLevel()==this},n.prototype.previousLevel=function(){return this.parent.level(this.levelNumber-1)},n.prototype.nextLevel=function(){return this.parent.level(this.levelNumber+1)},n.prototype.compare=function(t){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"Level","compare","The specified level is null or undefined"));return this.levelNumber<t.levelNumber?-1:this.levelNumber>t.levelNumber?1:0},n}),i("util/LevelSet",["../error/ArgumentError","../util/Level","../geom/Location","../util/Logger"],function(t,e,i,r){"use strict";var n=function(n,o,s,a,l){if(!n)throw new t(r.logMessage(r.LEVEL_SEVERE,"LevelSet","constructor","missingSector"));if(!o)throw new t(r.logMessage(r.LEVEL_SEVERE,"LevelSet","constructor","The specified level zero delta is null or undefined"));if(o.latitude<=0||o.longitude<=0)throw new t(r.logMessage(r.LEVEL_SEVERE,"LevelSet","constructor","The specified level zero delta is less than or equal to zero."));if(s<1)throw new t(r.logMessage(r.LEVEL_SEVERE,"LevelSet","constructor","The specified number of levels is less than one."));if(a<1||l<1)throw new t(r.logMessage(r.LEVEL_SEVERE,"LevelSet","constructor","The specified tile width or tile height is less than one."));this.sector=n,this.levelZeroDelta=o,this.numLevels=s,this.tileWidth=a,this.tileHeight=l,this.levels=[];for(var h=0;h<s;h+=1){var u=Math.pow(2,h),c=o.latitude/u,d=o.longitude/u,p=new i(c,d),f=new e(h,p,this);this.levels[h]=f}};return n.prototype.level=function(t){return t<0||t>=this.levels.length?null:this.levels[t]},n.prototype.levelForTexelSize=function(t){var e=this.lastLevel();if(e.texelSize>=t)return e;for(var i=0,r=this.levels.length;i<r;i+=1){var n=this.levels[i];if(n.texelSize<=t)return n}return e},n.prototype.firstLevel=function(){return this.levels[0]},n.prototype.lastLevel=function(){return this.levels[this.levels.length-1]},n}),i("cache/MemoryCache",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i,r){if(!i||i<1)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","constructor","The specified capacity is undefined, zero or negative"));if(!r||r>=i||r<0)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","constructor","The specified low-water value is undefined, greater than or equal to the capacity, or less than 1"));this._capacity=i,this._lowWater=r,this.usedCapacity=0,this.freeCapacity=i,this.entries={},this.listeners=[]};return Object.defineProperties(i.prototype,{capacity:{get:function(){return this._capacity},set:function(i){if(!i||i<1)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","capacity","Specified cache capacity is undefined, 0 or negative."));var r=this._capacity;this._capacity=i,this._capacity<=this.lowWater&&(this._lowWater=.85*this._capacity),this._capacity<r&&this.makeSpace(0)}},lowWater:{get:function(){return this._lowWater},set:function(i){if(!i||i>=this._capacity||i<0)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","lowWater","Specified cache low-water value is undefined, negative or not less than the current capacity."));this._lowWater=i}}}),i.prototype.entryForKey=function(t){if(!t)return null;var e=this.entries[t];return e?(e.lastUsed=Date.now(),e.entry):null},i.prototype.putEntry=function(i,r,n){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","putEntry","missingKey."));if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","putEntry","missingEntry."));if(n<1)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","putEntry","The specified entry size is less than 1."));var o,s=this.entries[i];s&&this.removeEntry(i),this.usedCapacity+n>this._capacity&&this.makeSpace(n),this.usedCapacity+=n,this.freeCapacity=this._capacity-this.usedCapacity,o={key:i,entry:r,size:n,lastUsed:Date.now()},this.entries[i]=o},i.prototype.clear=function(t){if(t)for(var e in this.entries)this.entries.hasOwnProperty(e)&&this.removeCacheEntry(e);this.entries={},this.freeCapacity=this._capacity,this.usedCapacity=0},i.prototype.removeEntry=function(t){if(t){var e=this.entries[t];e&&this.removeCacheEntry(e)}},i.prototype.removeCacheEntry=function(t){delete this.entries[t.key],this.usedCapacity-=t.size,this.freeCapacity=this._capacity-this.usedCapacity;for(var e=0,i=this.listeners.length;e<i;e++)try{this.listeners[e].entryRemoved(t.key,t.entry)}catch(i){this.listeners[e].removalError(i,t.key,t.entry)}},i.prototype.containsKey=function(t){return t&&this.entries[t]},i.prototype.addCacheListener=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","addCacheListener","missingListener"));if("function"!=typeof i.entryRemoved||"function"!=typeof i.removalError)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","addCacheListener","The specified listener does not implement the required functions."));this.listeners.push(i)},i.prototype.removeCacheListener=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"MemoryCache","removeCacheListener","missingListener"));var r=this.listeners.indexOf(i);r>-1&&this.listeners.splice(r,1)},i.prototype.makeSpace=function(t){var e=[];this.usedCapacity;for(var i in this.entries)this.entries.hasOwnProperty(i)&&e.push(this.entries[i]);e.sort(function(t,e){return t.lastUsed-e.lastUsed});for(var r=0,n=e.length;r<n&&(this.usedCapacity>this._lowWater||this.freeCapacity<t);r++)this.removeCacheEntry(e[r])},i}),i("layer/TiledImageLayer",["../util/AbsentResourceList","../error/ArgumentError","../render/ImageTile","../layer/Layer","../util/LevelSet","../util/Logger","../cache/MemoryCache","../render/Texture","../util/Tile","../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h){
"use strict";var u=function(i,a,l,h,u,c,d){if(!i)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","constructor","missingSector"));if(!a)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","constructor","The specified level-zero delta is null or undefined."));if(!h)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","constructor","The specified image format is null or undefined."));if(!u)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","constructor","The specified cache path is null or undefined."));if(!l||l<1)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","constructor","The specified number of levels is less than one."));if(!c||!d||c<1||d<1)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","constructor","The specified tile width or height is less than one."));r.call(this,"Tiled Image Layer"),this.retrievalImageFormat=h,this.cachePath=u,this.levels=new n(i,a,l,c,d),this.detailControl=1.75,this.expiration=null,this.currentTiles=[],this.currentTilesInvalid=!0,this.tileCache=new s(5e5,4e5),this.currentRetrievals=[],this.absentResourceList=new t(3,5e4),this.pickEnabled=!1};return u.prototype=Object.create(r.prototype),u.prototype.refresh=function(){this.expiration=new Date,this.currentTilesInvalid=!0},u.prototype.prePopulate=function(t){if(!t)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","prePopulate","missingWorldWindow"));var i=t.drawContext;this.topLevelTiles&&0!==this.topLevelTiles.length||this.createTopLevelTiles(i);for(var r=0;r<this.topLevelTiles.length;r++){var n=this.topLevelTiles[r];this.isTileTextureInMemory(i,n)||this.retrieveTileImage(i,n,!0)}},u.prototype.prePopulateCurrentTiles=function(t){if(!t)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","prePopulate","missingWorldWindow"));var i=t.drawContext;this.assembleTiles(i);for(var r=0,n=this.currentTiles.length;r<n;r++){var s=this.currentTiles[r];this.isTileTextureInMemory(i,s)||this.retrieveTileImage(i,s,!0)}},u.prototype.isPrePopulated=function(t){if(!t)throw new e(o.logMessage(o.LEVEL_SEVERE,"TiledImageLayer","isPrePopulated","missingWorldWindow"));for(var i=0;i<this.topLevelTiles.length;i++)if(!this.isTileTextureInMemory(t.drawContext,this.topLevelTiles[i]))return!1;return!0},u.prototype.createTile=function(t,e,r,n){var o=this.cachePath+"-layer/"+e.levelNumber+"/"+r+"/"+r+"_"+n+"."+h.suffixForMimeType(this.retrievalImageFormat);return new i(t,e,r,n,o)},u.prototype.doRender=function(t){if(t.terrain){if(this.currentTilesInvalid||!this.lasTtMVP||!t.navigatorState.modelviewProjection.equals(this.lasTtMVP)||t.globeStateKey!=this.lastGlobeStateKey)if(this.currentTilesInvalid=!1,t.surfaceOpacity>=1&&this.opacity>=1){this.previousTiles={};for(var e=0;e<this.currentTiles.length;e++)this.previousTiles[this.currentTiles[e].imagePath]=this.currentTiles[e];this.assembleTiles(t),this.fadeOutgoingTiles(t)}else this.assembleTiles(t);this.lasTtMVP=t.navigatorState.modelviewProjection,this.lastGlobeStateKey=t.globeStateKey,this.currentTiles.length>0&&(t.surfaceTileRenderer.renderTiles(t,this.currentTiles,this.opacity,t.surfaceOpacity>=1),t.frameStatistics.incrementImageTileCount(this.currentTiles.length),this.inCurrentFrame=!0)}},u.prototype.fadeOutgoingTiles=function(t){for(var e=(t.timestamp-t.previousRedrawTimestamp)/t.fadeTime,i={},r=0;r<this.currentTiles.length;r++){var n=this.currentTiles[r];i[n.imagePath]=n}for(var o in this.previousTiles)this.previousTiles.hasOwnProperty(o)&&(n=this.previousTiles[o],n.opacity>0&&!i[n.imagePath]&&(n.opacity=Math.max(0,n.opacity-e),n.opacity>0&&(this.currentTiles.push(n),this.currentTilesInvalid=!0,t.redrawRequested=!0)))},u.prototype.isLayerInView=function(t){return t.terrain&&t.terrain.sector&&t.terrain.sector.intersects(this.levels.sector)},u.prototype.createTopLevelTiles=function(t){this.topLevelTiles=[],l.createTilesForLevel(this.levels.firstLevel(),this,this.topLevelTiles)},u.prototype.assembleTiles=function(t){this.currentTiles=[],this.topLevelTiles&&0!==this.topLevelTiles.length||this.createTopLevelTiles(t);for(var e=0,i=this.topLevelTiles.length;e<i;e++){var r=this.topLevelTiles[e];r.update(t),this.currentAncestorTile=null,this.isTileVisible(t,r)&&this.addTileOrDescendants(t,r)}},u.prototype.addTileOrDescendants=function(t,e){if(this.tileMeetsRenderingCriteria(t,e))return void this.addTile(t,e);var i=null;try{(this.isTileTextureInMemory(t,e)||0===e.level.levelNumber)&&(i=this.currentAncestorTile,this.currentAncestorTile=e);for(var r=this.levels.level(e.level.levelNumber+1),n=e.subdivideToCache(r,this,this.tileCache),o=0,s=n.length;o<s;o++){var a=n[o];a.update(t),this.levels.sector.intersects(a.sector)&&this.isTileVisible(t,a)&&this.addTileOrDescendants(t,a)}}finally{i&&(this.currentAncestorTile=i)}},u.prototype.addTile=function(t,e){e.fallbackTile=null;var i=t.gpuResourceCache.resourceForKey(e.imagePath);return i?(e.opacity=1,this.currentTiles.push(e),void(this.expiration&&this.isTextureExpired(i)&&this.retrieveTileImage(t,e))):(this.retrieveTileImage(t,e),void(this.currentAncestorTile&&this.isTileTextureInMemory(t,this.currentAncestorTile)&&(e.fallbackTile=this.currentAncestorTile,e.fallbackTile.opacity=1,this.currentTiles.push(e))))},u.prototype.isTileVisible=function(t,e){return!(t.globe.projectionLimits&&!e.sector.overlaps(t.globe.projectionLimits))&&e.extent.intersectsFrustum(t.navigatorState.frustumInModelCoordinates)},u.prototype.tileMeetsRenderingCriteria=function(t,e){var i=this.detailControl;return(e.sector.minLatitude>=75||e.sector.maxLatitude<=-75)&&(i*=1.2),e.level.isLastLevel()||!e.mustSubdivide(t,i)},u.prototype.isTileTextureInMemory=function(t,e){return t.gpuResourceCache.containsResource(e.imagePath)},u.prototype.isTextureExpired=function(t){return this.expiration&&t.creationTime.getTime()<=this.expiration.getTime()},u.prototype.retrieveTileImage=function(t,e,i){if(this.currentRetrievals.indexOf(e.imagePath)<0){if(this.absentResourceList.isResourceAbsent(e.imagePath))return;var r=this.resourceUrlForTile(e,this.retrievalImageFormat),n=new Image,s=e.imagePath,a=t.gpuResourceCache,l=t.currentGlContext.canvas,h=this;if(!r)return void(this.currentTilesInvalid=!0);n.onload=function(){o.log(o.LEVEL_INFO,"Image retrieval succeeded: "+r);var u=h.createTexture(t,e,n);if(h.removeFromCurrentRetrievals(s),u&&(a.putResource(s,u,u.size),h.currentTilesInvalid=!0,h.absentResourceList.unmarkResourceAbsent(s),!i)){var c=document.createEvent("Event");c.initEvent(WorldWind.REDRAW_EVENT_TYPE,!0,!0),l.dispatchEvent(c)}},n.onerror=function(){h.removeFromCurrentRetrievals(s),h.absentResourceList.markResourceAbsent(s),o.log(o.LEVEL_WARNING,"Image retrieval failed: "+r)},this.currentRetrievals.push(s),n.crossOrigin="anonymous",n.src=r}},u.prototype.createTexture=function(t,e,i){return new a(t.currentGlContext,i)},u.prototype.removeFromCurrentRetrievals=function(t){var e=this.currentRetrievals.indexOf(t);e>-1&&this.currentRetrievals.splice(e,1)},u.prototype.resourceUrlForTile=function(t,e){return this.urlBuilder?this.urlBuilder.urlForTile(t,e):null},u}),i("layer/MercatorTiledImageLayer",["../util/Color","../geom/Sector","../layer/TiledImageLayer","../geom/Vec2","../util/WWMath"],function(t,e,i,r,n){"use strict";var o=function(t,e,n,o,s,a,l){i.call(this,t,e,n,o,s,a,l),this.detectBlankImages=!1,this.testPixels=[new r(20,20),new r(235,20),new r(20,235),new r(235,235)],this.destCanvas=document.createElement("canvas"),this.destContext=this.destCanvas.getContext("2d")};return o.prototype=Object.create(i.prototype),o.prototype.createTile=function(t,r,o,s){var a,l,h,u,c,d,p=this.mapSizeForLevel(r.levelNumber),f=n.clamp(s*this.imageSize,0,p),g=n.clamp(o*this.imageSize,0,p),m=n.clamp(f+this.imageSize,0,p),E=n.clamp(g+this.imageSize,0,p);return a=f/p-.5,l=.5-E/p,h=90-360*Math.atan(Math.exp(2*-l*Math.PI))/Math.PI,u=360*a,a=m/p-.5,l=.5-g/p,c=90-360*Math.atan(Math.exp(2*-l*Math.PI))/Math.PI,d=360*a,t=new e(h,c,u,d),i.prototype.createTile.call(this,t,r,o,s)},o.prototype.createTexture=function(t,e,r){var o,s,a,l,h,u,c,d,p=t.canvas2D,f=t.ctx2D,g=this.destCanvas,m=this.destContext,E=m.createImageData(r.width,r.height),y=e.sector,_=n.gudermannianInverse(y.minLatitude),v=n.gudermannianInverse(y.maxLatitude);if(p.width=r.width,p.height=r.height,g.width=r.width,g.height=r.height,f.drawImage(r,0,0,r.width,r.height),o=f.getImageData(0,0,r.width,r.height),this.detectBlankImages&&this.isBlankImage(r,o))return this.absentResourceList.markResourceAbsentPermanently(e.imagePath),null;for(var b=0;b<1;b++)for(var S=0;S<r.height;S++){c=1-S/(r.height-1),s=c*y.deltaLatitude()+y.minLatitude,a=n.gudermannianInverse(s),d=1-(a-_)/(v-_),d=n.clamp(d,0,1),l=Math.floor(d*(r.height-1));for(var T=0;T<r.width;T++)h=4*(T+l*r.width),u=4*(T+S*r.width),E.data[u]=o.data[h],E.data[u+1]=o.data[h+1],E.data[u+2]=o.data[h+2],E.data[u+3]=o.data[h+3]}return m.putImageData(E,0,0),i.prototype.createTexture.call(this,t,e,g)},o.prototype.isBlankImage=function(t,e){for(var i,r,n=null,o=0,s=this.testPixels.length;o<s;o++)if(i=this.testPixels[o],r=4*(i[0]+i[1]*t.width),n){if(e.data[r]!=n[0]||e.data[r+1]!=n[1]||e.data[r+2]!=n[2])return!1}else n=[e.data[r],e.data[r+1],e.data[r+2]];return!0},o}),i("layer/BingTiledImageLayer",["../geom/Angle","../geom/Location","../geom/Sector","../layer/MercatorTiledImageLayer"],function(t,e,i,r){"use strict";var n=function(t){this.imageSize=256,r.call(this,new i(-85.05,85.05,-180,180),new e(85.05,180),23,"image/jpeg",t,this.imageSize,this.imageSize),this.displayName=t,this.pickEnabled=!1,this.detectBlankImages=!0,this.creditImage=WorldWind.configuration.baseUrl+"images/powered-by-bing.png"};return n.prototype=Object.create(r.prototype),n.prototype.doRender=function(t){r.prototype.doRender.call(this,t),this.inCurrentFrame&&t.screenCreditController.addImageCredit(this.creditImage)},n.prototype.createTopLevelTiles=function(t){this.topLevelTiles=[],this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),0,0)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),0,1)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),1,0)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),1,1))},n.prototype.mapSizeForLevel=function(t){return 256<<t+1},n}),i("util/BingImageryUrlBuilder",["../error/ArgumentError","../util/Logger","../util/WWUtil"],function(t,e,i){"use strict";var r=function(t,e){var i="AkttWCS8p6qzxvx5RH3qUcCPgwG9nRJ7IwlpFGb14B0rBorB5DvmXr2Y_eCUNIxH";e||(this.bingMapsKey=WorldWind.BingMapsKey,e||(this.bingMapsKey=i),e===i&&(this.bingMapsKey=i,r.showBingMapsKeyWarning())),this.imagerySet=t};return r.showBingMapsKeyWarning=function(){r.keyMessagePrinted||(r.keyMessagePrinted=!0,e.log(e.LEVEL_WARNING,"WARNING: You are using a limited use, non-production Bing Maps key.\nIf you are developing an app or a web page this violates the Bing Terms of Use.\nPlease visit https://www.microsoft.com/maps/choose-your-bing-maps-API.aspx to obtain your own key for your application.\nSpecify that key to World Wind by setting the WorldWind.BingMapsKey property to your key prior to creating any Bing Maps layers.\n"))},r.prototype.requestMetadata=function(){if(!this.metadataRetrievalInProcess){this.metadataRetrievalInProcess=!0;var t="http://dev.virtualearth.net/REST/V1/Imagery/Metadata/"+this.imagerySet+"/0,0?zl=1&key="+this.bingMapsKey,e=this;i.jsonp(t,"jsonp",function(t){e.imageUrl=t.resourceSets[0].resources[0].imageUrl;var i=document.createEvent("Event");i.initEvent(WorldWind.REDRAW_EVENT_TYPE,!0,!0),window.dispatchEvent(i),e.metadataRetrievalInProcess=!1})}},r.prototype.urlForTile=function(i,r){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"BingImageryUrlBuilder","urlForTile","missingTile"));if(!this.imageUrl)return this.requestMetadata(),null;var n,o=this.quadKeyFromLevelRowColumn(i.level.levelNumber,i.row,i.column);return"Aerial"===this.imagerySet?n=this.imageUrl.replace(/a3/,"a"+o):"AerialWithLabels"===this.imagerySet?n=this.imageUrl.replace(/h3/,"h"+o):"Road"===this.imagerySet&&(n=this.imageUrl.replace(/r3/,"r"+o)),n},r.prototype.quadKeyFromLevelRowColumn=function(t,e,i){for(var r,n,o="",s=t+1;s>0;s--)r=0,n=1<<s-1,0!=(i&n)&&(r+=1),0!=(e&n)&&(r+=2),o+=r.toString();return o},r}),i("layer/BingAerialLayer",["../geom/Location","../geom/Sector","../layer/BingTiledImageLayer","../util/BingImageryUrlBuilder"],function(t,e,i,r){"use strict";var n=function(t){i.call(this,"Bing Aerial"),this.urlBuilder=new r("Aerial",t)};return n.prototype=Object.create(i.prototype),n}),i("layer/BingAerialWithLabelsLayer",["../geom/Location","../geom/Sector","../layer/BingTiledImageLayer","../util/BingImageryUrlBuilder"],function(t,e,i,r){"use strict";var n=function(t){i.call(this,"Bing Aerial with Labels"),this.urlBuilder=new r("AerialWithLabels",t)};return n.prototype=Object.create(i.prototype),n}),i("layer/BingRoadsLayer",["../geom/Location","../geom/Sector","../layer/BingTiledImageLayer","../util/BingImageryUrlBuilder"],function(t,e,i,r){"use strict";var n=function(t){i.call(this,"Bing Roads"),this.urlBuilder=new r("Road",t),this.detectBlankImages=!1};return n.prototype=Object.create(i.prototype),n}),i("util/WmsUrlBuilder",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i,r,n,o,s){if(!i||0===i.length)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsUrlBuilder","constructor","The WMS service address is missing."));if(!r||0===r.length)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsUrlBuilder","constructor","The WMS layer names are not specified."));this.serviceAddress=i,this.layerNames=r,this.styleNames=n?n:"",this.transparent=!0,this.wmsVersion=o&&o.length>0?o:"1.3.0",this.isWms130OrGreater=this.wmsVersion>="1.3.0",this.crs="EPSG:4326",this.timeString=s};return i.prototype.urlForTile=function(r,n){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsUrlBuilder","urlForTile","missingTile"));if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsUrlBuilder","urlForTile","The image format is null or undefined."));var o=r.sector,s=i.fixGetMapString(this.serviceAddress);return s.search(/service=wms/i)<0&&(s+="service=WMS"),s+="&request=GetMap",s=s+"&version="+this.wmsVersion,s=s+"&transparent="+(this.transparent?"TRUE":"FALSE"),s=s+"&layers="+this.layerNames,s=s+"&styles="+this.styleNames,s=s+"&format="+n,s=s+"&width="+r.tileWidth,s=s+"&height="+r.tileHeight,this.timeString&&(s=s+"&time="+this.timeString),this.isWms130OrGreater?(s=s+"&crs="+this.crs,s+="&bbox=","CRS:84"===this.crs?(s=s+o.minLongitude+","+o.minLatitude+",",s=s+o.maxLongitude+","+o.maxLatitude):(s=s+o.minLatitude+","+o.minLongitude+",",s=s+o.maxLatitude+","+o.maxLongitude)):(s=s+"&srs="+this.crs,s+="&bbox=",s=s+o.minLongitude+","+o.minLatitude+",",s=s+o.maxLongitude+","+o.maxLatitude),s=s.replace(" ","%20")},i.fixGetMapString=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsUrlBuilder","fixGetMapString","The specified service address is null or undefined."));var r=i.indexOf("?");return r<0?i+="?":r!==i.length-1&&(r=i.search(/&$/),r<0&&(i+="&")),i},i}),i("layer/BingWMSLayer",["../geom/Location","../geom/Sector","../layer/TiledImageLayer","../util/WmsUrlBuilder"],function(t,e,i,r){"use strict";var n=function(){i.call(this,e.FULL_SPHERE,new t(45,45),16,"image/png","BingWMS",256,256),this.displayName="Bing WMS",this.pickEnabled=!1,this.maxActiveAltitude=1e4,this.urlBuilder=new r(location.protocol+"//worldwind27.arc.nasa.gov/wms/virtualearth","ve","","1.3.0")};return n.prototype=Object.create(i.prototype),n}),i("util/PeriodicTimeSequence",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(r){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"PeriodicTimeSequence","constructor","missingString"));var n=r.split("/");if(3!==n.length)throw new t(e.logMessage(e.LEVEL_SEVERE,"PeriodicTimeSequence","constructor","The interval string "+r+" does not contain 3 elements."));this.sequenceString=r,this.startTime=new Date(n[0]),this.endTime=new Date(n[1]),this.intervalMilliseconds=this.endTime.getTime()-this.startTime.getTime(),this._currentTime=this.startTime,this.infiniteInterval=this.startTime.getTime()==this.endTime.getTime(),this.period=i.parsePeriodString(n[2],!1)};return Object.defineProperties(i.prototype,{currentTime:{get:function(){return this._currentTime},set:function(t){this._currentTime=t}},scaleForCurrentTime:{get:function(){return this.currentTime?(this.currentTime.getTime()-this.startTime.getTime())/this.intervalMilliseconds:1}}}),i.prototype.next=function(){return this.currentTime?this.currentTime.getTime()>=this.endTime.getTime()&&!this.infiniteInterval?this.currentTime=null:this.currentTime=i.incrementTime(this.currentTime,this.period):this.currentTime=this.startTime,this.currentTime},i.prototype.previous=function(){return this.currentTime?this.currentTime.getTime()===this.startTime.getTime()?this.currentTime=null:this.currentTime=this.getTimeForScale(.9999*this.scaleForCurrentTime):this.currentTime=this.endTime,this.currentTime},i.prototype.reset=function(){this.currentTime=null},i.prototype.getTimeForScale=function(t){if(t<=0)return this.startTime;if(t>=1)return this.endTime;var e=new Date(this.startTime.getTime()),r=e,n=0;for(n=0;n<t;n=(e.getTime()-this.startTime.getTime())/this.intervalMilliseconds)r=e,e=i.incrementTime(e,this.period);return r},i.incrementTime=function(t,e){var r=new Date(t.getTime());return 0!=e[0]&&r.setUTCFullYear(r.getUTCFullYear()+e[0]),0!=e[1]&&i.addMonths(r,e[1]),0!=e[2]&&r.setUTCDate(r.getUTCDate()+7*e[2]),0!=e[3]&&r.setUTCDate(r.getUTCDate()+e[3]),0!=e[4]&&r.setUTCHours(r.getUTCHours()+e[4]),0!=e[5]&&r.setUTCMinutes(r.getUTCMinutes()+e[5]),0!=e[6]&&r.setUTCSeconds(r.getUTCSeconds()+e[6]),r},i.isLeapYear=function(t){return t%4===0&&t%100!==0||t%400===0},i.getDaysInMonth=function(t,e){return[31,i.isLeapYear(t)?29:28,31,30,31,30,31,31,30,31,30,31][e]},i.addMonths=function(t,e){var r=t.getUTCDate();return t.setUTCDate(1),t.setUTCMonth(t.getUTCMonth()+e),t.setUTCDate(Math.min(r,i.getDaysInMonth(t.getUTCFullYear(),t.getUTCMonth()))),t},i.parsePeriodString=function(i,r){var n,o=!!r&&r,s=[2,3,4,5,7,8,9],a=[0,0,0,0,0,0,0],l=[0,12,4,7,24,60,60];if(i=i.toUpperCase(),!i)return a;if("string"!=typeof i)throw new t(e.logMessage(e.LEVEL_SEVERE,"PeriodicTimeSequence","parsePeriodString","Invalid ISO8601 period string '"+i+"'"));if(!(n=/^P((\d+Y)?(\d+M)?(\d+W)?(\d+D)?)?(T(\d+H)?(\d+M)?(\d+S)?)?$/.exec(i)))throw new t(e.logMessage(e.LEVEL_SEVERE,"PeriodicTimeSequence","parsePeriodString","String '"+i+"' is not a valid ISO8601 period."));for(var h=0;h<s.length;h++){var u=s[h];a[h]=n[u]?+n[u].replace(/[A-Za-z]+/g,""):0}if(o)for(h=a.length-1;h>0;h--)a[h]>=l[h]&&(a[h-1]=a[h-1]+Math.floor(a[h]/l[h]),a[h]=a[h]%l[h]);return a},i}),i("util/LevelRowColumnUrlBuilder",["../error/ArgumentError","../util/Logger","../util/WWUtil"],function(t,e,i){"use strict";var r=function(t,e){this.serverAddress=t,t&&0!==t.length||(this.serverAddress=i.currentUrlSansFilePart()),this.pathToData=e};return r.prototype.urlForTile=function(r,n){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsUrlBuilder","urlForTile","missingTile"));if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsUrlBuilder","urlForTile","The image format is null or undefined."));var o=this.serverAddress;return this.pathToData&&(o=o+"/"+this.pathToData),o=o+"/"+r.level.levelNumber.toString(),o=o+"/"+r.row.toString(),o=o+"/"+r.row.toString()+"_"+r.column.toString(),o=o+"."+i.suffixForMimeType(n),o=o.replace(" ","%20")},r}),i("layer/RestTiledImageLayer",["../error/ArgumentError","../geom/Location","../util/Logger","../geom/Sector","../layer/TiledImageLayer","../util/LevelRowColumnUrlBuilder","../util/WWUtil"],function(t,e,i,r,n,o,s){"use strict";var a=function(t,i,a,l){var h=s.urlPath(t+"/"+i);n.call(this,l&&l.sector||r.FULL_SPHERE,l&&l.levelZeroTileDelta||new e(45,45),l&&l.numLevels||5,l&&l.imageFormat||"image/jpeg",h,l&&l.tileWidth||256,l&&l.tileHeight||256),this.displayName=a,this.pickEnabled=!1,this.urlBuilder=new o(t,i)};return a.prototype=Object.create(n.prototype),a}),i("layer/BlueMarbleLayer",["../error/ArgumentError","../layer/Layer","../util/Logger","../util/PeriodicTimeSequence","../layer/RestTiledImageLayer"],function(t,e,i,r,n){"use strict";var o=function(t,i,n){e.call(this,t||"Blue Marble"),this.time=i||new Date("2004-01"),this.configuration=n,this.pickEnabled=!1,this.layers={},this.layerNames=[{month:"BlueMarble-200401",time:o.availableTimes[0]},{month:"BlueMarble-200402",time:o.availableTimes[1]},{month:"BlueMarble-200403",time:o.availableTimes[2]},{month:"BlueMarble-200404",time:o.availableTimes[3]},{month:"BlueMarble-200405",time:o.availableTimes[4]},{month:"BlueMarble-200406",time:o.availableTimes[5]},{month:"BlueMarble-200407",time:o.availableTimes[6]},{month:"BlueMarble-200408",time:o.availableTimes[7]},{month:"BlueMarble-200409",time:o.availableTimes[8]},{month:"BlueMarble-200410",time:o.availableTimes[9]},{month:"BlueMarble-200411",time:o.availableTimes[10]},{month:"BlueMarble-200412",time:o.availableTimes[11]}],this.timeSequence=new r("2004-01-01/2004-12-01/P1M"),this.serverAddress=null,this.pathToData="../standalonedata/Earth/BlueMarble256/"};return o.prototype=Object.create(e.prototype),o.availableTimes=[new Date("2004-01"),new Date("2004-02"),new Date("2004-03"),new Date("2004-04"),new Date("2004-05"),new Date("2004-06"),new Date("2004-07"),new Date("2004-08"),new Date("2004-09"),new Date("2004-10"),new Date("2004-11"),new Date("2004-12")],o.prototype.prePopulate=function(e){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"BlueMarbleLayer","prePopulate","missingWorldWindow"));for(var r=0;r<this.layerNames.length;r++){var n=this.layerNames[r].month;this.layers[n]||this.createSubLayer(n),this.layers[n].prePopulate(e)}},o.prototype.isPrePopulated=function(t){for(var e=0;e<this.layerNames.length;e++){var i=this.layers[this.layerNames[e].month];if(!i||!i.isPrePopulated(t))return!1}return!0},o.prototype.doRender=function(t){var e=this.nearestLayer(this.time);e.opacity=this.opacity,this.detailControl&&(e.detailControl=this.detailControl),e.doRender(t),this.inCurrentFrame=e.inCurrentFrame},o.prototype.nearestLayer=function(t){var e=this.nearestLayerName(t);return this.layers[e]||this.createSubLayer(e),this.layers[e]},o.prototype.createSubLayer=function(t){var e=this.pathToData+t;this.layers[t]=new n(this.serverAddress,e,this.displayName,this.configuration)},o.prototype.nearestLayerName=function(t){var e=t.getTime();if(e<=this.layerNames[0].time.getTime())return this.layerNames[0].month;if(e>=this.layerNames[11].time.getTime())return this.layerNames[11].month;for(var i=0;i<this.layerNames.length-1;i++){var r=this.layerNames[i].time.getTime(),n=this.layerNames[i+1].time.getTime();if(e>=r&&e<=n){var o=e-r,s=n-e;return o<s?this.layerNames[i].month:this.layerNames[i+1].month}}},o}),i("layer/BMNGLandsatLayer",["../geom/Location","../geom/Sector","../layer/TiledImageLayer","../util/WmsUrlBuilder"],function(t,e,i,r){"use strict";var n=function(){i.call(this,e.FULL_SPHERE,new t(45,45),10,"image/jpeg","BMNGLandsat256",256,256),this.displayName="Blue Marble & Landsat",this.pickEnabled=!1,this.urlBuilder=new r(location.protocol+"//worldwind25.arc.nasa.gov/wms","BlueMarble-200405,esat","","1.3.0")};return n.prototype=Object.create(i.prototype),n}),i("layer/BMNGLayer",["../geom/Location","../geom/Sector","../layer/TiledImageLayer","../util/WmsUrlBuilder"],function(t,e,i,r){"use strict";var n=function(n){i.call(this,e.FULL_SPHERE,new t(45,45),5,"image/jpeg",n||"BMNG256",256,256),this.displayName="Blue Marble",this.pickEnabled=!1,this.urlBuilder=new r(location.protocol+"//worldwind25.arc.nasa.gov/wms",n||"BlueMarble-200405","","1.3.0")};return n.prototype=Object.create(i.prototype),n}),i("layer/RenderableLayer",["../error/ArgumentError","../layer/Layer","../util/Logger"],function(t,e,i){"use strict";var r=function(t){e.call(this,t),this.renderables=[]};return r.prototype=Object.create(e.prototype),r.prototype.addRenderable=function(e){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"RenderableLayer","addRenderable","missingRenderable"));this.renderables.push(e)},r.prototype.addRenderables=function(e){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"RenderableLayer","addRenderables","The renderables array is null or undefined."));for(var r=0,n=e.length;r<n;r++)this.addRenderable(e[r])},r.prototype.removeRenderable=function(t){var e=this.renderables.indexOf(t);e>=0&&this.renderables.splice(e,1)},r.prototype.removeAllRenderables=function(){this.renderables=[]},r.prototype.doRender=function(t){for(var e=t.orderedRenderables.length,r=0,n=this.renderables.length;r<n;r++)try{this.renderables[r].render(t)}catch(t){i.logMessage(i.LEVEL_SEVERE,"RenderableLayer","doRender","Error while rendering shape "+this.renderables[r].displayName+".\n"+t.toString())}t.orderedRenderables.length>e&&(this.inCurrentFrame=!0)},r}),i("render/SurfaceTile",["../error/ArgumentError","../util/Logger","../geom/Matrix","../geom/Sector","../error/UnsupportedOperationError"],function(t,e,i,r,n){"use strict";var o=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfaceTile","constructor","missingSector"));this.sector=i};return o.prototype.bind=function(t){throw new n(e.logMessage(e.LEVEL_SEVERE,"SurfaceTile","bind","abstractInvocation"))},o.prototype.applyInternalTransform=function(t,i){throw new n(e.logMessage(e.LEVEL_SEVERE,"SurfaceTile","applyInternalTransform","abstractInvocation"))},o}),i("shapes/SurfaceImage",["../error/ArgumentError","../util/Logger","../pick/PickedObject","../render/SurfaceTile"],function(t,e,i,r){"use strict";var n=function(i,n){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfaceImage","constructor","missingSector"));if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfaceImage","constructor","missingImage"));r.call(this,i),this.enabled=!0,this._imageSource=n,this.opacity=1,this.displayName="Surface Image",this.imageSourceWasUpdated=!0};return n.prototype=Object.create(r.prototype),Object.defineProperties(n.prototype,{imageSource:{get:function(){return this._imageSource},set:function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfaceImage","imageSource","missingImage"));this._imageSource=i,this.imageSourceWasUpdated=!0}}}),n.prototype.bind=function(t){var e=t.gpuResourceCache.resourceForKey(this._imageSource);return e&&!this.imageSourceWasUpdated?e.bind(t):(e=t.gpuResourceCache.retrieveTexture(t.currentGlContext,this._imageSource),this.imageSourceWasUpdated=!1,e?e.bind(t):void 0)},n.prototype.applyInternalTransform=function(t,e){},n.prototype.render=function(t){if(this.enabled&&this.sector.overlaps(t.terrain.sector)){if(t.pickingMode&&(this.pickColor=t.uniquePickColor()),t.surfaceTileRenderer.renderTiles(t,[this],this.opacity*t.currentLayer.opacity),t.pickingMode){var e=new i(this.pickColor.clone(),this.pickDelegate?this.pickDelegate:this,null,this.layer,!1);t.resolvePick(e)}t.currentLayer.inCurrentFrame=!0}},n}),i("layer/BMNGOneImageLayer",["../layer/RenderableLayer","../geom/Sector","../shapes/SurfaceImage","../util/WWUtil"],function(t,e,i,r){"use strict";var n=function(){t.call(this,"Blue Marble Image");var r=new i(e.FULL_SPHERE,WorldWind.configuration.baseUrl+"images/BMNG_world.topo.bathy.200405.3.2048x1024.jpg");this.addRenderable(r),this.pickEnabled=!1,this.minActiveAltitude=3e6};return n.prototype=Object.create(t.prototype),n}),i("gesture/Touch",[],function(){"use strict";var t=function(t,e,i){this.identifier=t,this._clientX=e,this._clientY=i,this._clientStartX=e,this._clientStartY=i};return Object.defineProperties(t.prototype,{clientX:{get:function(){return this._clientX},set:function(t){this._clientX=t}},clientY:{get:function(){return this._clientY},set:function(t){this._clientY=t}},translationX:{get:function(){return this._clientX-this._clientStartX},set:function(t){this._clientStartX=this._clientX-t}},translationY:{get:function(){return this._clientY-this._clientStartY},set:function(t){this._clientStartY=this._clientY-t}}}),t}),i("gesture/GestureRecognizer",["../error/ArgumentError","../util/Logger","../gesture/Touch"],function(t,e,i){"use strict";var r=function(i,n){function o(t){s.handleEvent(t)}if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"GestureRecognizer","constructor","missingTarget"));this.target=i,this.enabled=!0,this._state=WorldWind.POSSIBLE,this._nextState=null,this._clientX=0,this._clientY=0,this._clientStartX=0,this._clientStartY=0,this._translationX=0,this._translationY=0,this._translationWeight=.4,this._mouseButtonMask=0,this._touches=[],this._touchCentroidShiftX=0,this._touchCentroidShiftY=0,this._gestureCallbacks=[],this._canRecognizeWith=[],this._requiresFailureOf=[],this._requiredToFailBy=[],n&&this._gestureCallbacks.push(n),r.allRecognizers.push(this);var s=this;window.PointerEvent?(i.addEventListener("pointerdown",o,!1),window.addEventListener("pointermove",o,!1),window.addEventListener("pointercancel",o,!1),window.addEventListener("pointerup",o,!1)):(i.addEventListener("mousedown",o,!1),window.addEventListener("mousemove",o,!1),window.addEventListener("mouseup",o,!1),i.addEventListener("touchstart",o,!1),i.addEventListener("touchmove",o,!1),i.addEventListener("touchend",o,!1),i.addEventListener("touchcancel",o,!1))};return r.allRecognizers=[],Object.defineProperties(r.prototype,{state:{get:function(){return this._state},set:function(t){this.transitionToState(t)}},clientX:{get:function(){return this._clientX},set:function(t){this._clientX=t}},clientY:{get:function(){return this._clientY},set:function(t){this._clientY=t}},translationX:{get:function(){return this._translationX},set:function(t){this._translationX=t,this._clientStartX=this._clientX,this._touchCentroidShiftX=0}},translationY:{get:function(){return this._translationY},set:function(t){this._translationY=t,this._clientStartY=this._clientY,this._touchCentroidShiftY=0}},mouseButtonMask:{get:function(){return this._mouseButtonMask}},touchCount:{get:function(){return this._touches.length}},gestureCallbacks:{get:function(){return this._gestureCallbacks}}}),r.prototype.touch=function(i){if(i<0||i>=this._touches.length)throw new t(e.logMessage(e.LEVEL_SEVERE,"GestureRecognizer","touch","indexOutOfRange"));return this._touches[i]},r.prototype.recognizeSimultaneouslyWith=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"GestureRecognizer","recognizeSimultaneouslyWith","The specified gesture recognizer is null or undefined."));var r=this._canRecognizeWith.indexOf(i);r==-1&&(this._canRecognizeWith.push(i),i._canRecognizeWith.push(this))},r.prototype.canRecognizeSimultaneouslyWith=function(t){var e=this._canRecognizeWith.indexOf(t);return e!=-1},r.prototype.requireRecognizerToFail=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"GestureRecognizer","requireRecognizerToFail","The specified gesture recognizer is null or undefined"));var r=this._requiresFailureOf.indexOf(i);r==-1&&(this._requiresFailureOf.push(i),i._requiredToFailBy.push(this))},r.prototype.requiresRecognizerToFail=function(t){var e=this._requiresFailureOf.indexOf(t);return e!=-1},r.prototype.requiredToFailByRecognizer=function(t){var e=this._requiredToFailBy.indexOf(t);return e!=-1},r.prototype.reset=function(){this._state=WorldWind.POSSIBLE,this._nextState=null,this._clientX=0,this._clientY=0,this._clientStartX=0,this._clientStartY=0,this._translationX=0,this._translationY=0,this._mouseButtonMask=0,this._touches=[],this._touchCentroidShiftX=0,this._touchCentroidShiftY=0},r.prototype.prepareToRecognize=function(){},r.prototype.mouseDown=function(t){},r.prototype.mouseMove=function(t){},r.prototype.mouseUp=function(t){},r.prototype.touchStart=function(t){},r.prototype.touchMove=function(t){},r.prototype.touchCancel=function(t){},r.prototype.touchEnd=function(t){},r.prototype.transitionToState=function(t){this._nextState=null,t==WorldWind.FAILED?(this._state=t,this.updateRecognizersWaitingForFailure(),this.resetIfEventsEnded()):t==WorldWind.RECOGNIZED?(this.tryToRecognize(t),this._state==t&&(this.prepareToRecognize(),this.callGestureCallbacks(),this.resetIfEventsEnded())):t==WorldWind.BEGAN?(this.tryToRecognize(t),
this._state==t&&(this.prepareToRecognize(),this.callGestureCallbacks())):t==WorldWind.CHANGED?(this._state=t,this.callGestureCallbacks()):t==WorldWind.CANCELLED?(this._state=t,this.callGestureCallbacks(),this.resetIfEventsEnded()):t==WorldWind.ENDED&&(this._state=t,this.callGestureCallbacks(),this.resetIfEventsEnded())},r.prototype.updateRecognizersWaitingForFailure=function(){for(var t=0,e=this._requiredToFailBy.length;t<e;t++){var i=this._requiredToFailBy[t];null!=i._nextState&&i.transitionToState(i._nextState)}},r.prototype.tryToRecognize=function(t){if(r.allRecognizers.some(this.canBePreventedByRecognizer,this))return void this.transitionToState(WorldWind.FAILED);if(r.allRecognizers.some(this.isWaitingForRecognizerToFail,this))return void(this._nextState=t);for(var e=r.allRecognizers.filter(this.canPreventRecognizer,this),i=0,n=e.length;i<n;i++)e[i].transitionToState(WorldWind.FAILED);this._state=t},r.prototype.canPreventRecognizer=function(t){return this!=t&&this.target==t.target&&t.state==WorldWind.POSSIBLE&&(this.requiredToFailByRecognizer(t)||!this.canRecognizeSimultaneouslyWith(t))},r.prototype.canBePreventedByRecognizer=function(t){return this!=t&&this.target==t.target&&t.state==WorldWind.RECOGNIZED&&(this.requiresRecognizerToFail(t)||!this.canRecognizeSimultaneouslyWith(t))},r.prototype.isWaitingForRecognizerToFail=function(t){return this!=t&&this.target==t.target&&t.state==WorldWind.POSSIBLE&&this.requiresRecognizerToFail(t)},r.prototype.callGestureCallbacks=function(){for(var t=0,e=this._gestureCallbacks.length;t<e;t++)this._gestureCallbacks[t](this)},r.prototype.handleEvent=function(t){if(this.enabled&&(!t.defaultPrevented||this.state!=WorldWind.POSSIBLE)){var i,r;try{if("mousedown"==t.type)this.handleMouseDown(t);else if("mousemove"==t.type)this.handleMouseMove(t);else if("mouseup"==t.type)this.handleMouseUp(t);else if("touchstart"==t.type)for(i=0,r=t.changedTouches.length;i<r;i++)this.handleTouchStart(t.changedTouches.item(i));else if("touchmove"==t.type)for(i=0,r=t.changedTouches.length;i<r;i++)this.handleTouchMove(t.changedTouches.item(i));else if("touchcancel"==t.type)for(i=0,r=t.changedTouches.length;i<r;i++)this.handleTouchCancel(t.changedTouches.item(i));else if("touchend"==t.type)for(i=0,r=t.changedTouches.length;i<r;i++)this.handleTouchEnd(t.changedTouches.item(i));else"pointerdown"==t.type&&"mouse"==t.pointerType?this.handleMouseDown(t):"pointermove"==t.type&&"mouse"==t.pointerType?this.handleMouseMove(t):"pointercancel"==t.type&&"mouse"==t.pointerType||("pointerup"==t.type&&"mouse"==t.pointerType?this.handleMouseUp(t):"pointerdown"==t.type&&"touch"==t.pointerType?this.handleTouchStart(t):"pointermove"==t.type&&"touch"==t.pointerType?this.handleTouchMove(t):"pointercancel"==t.type&&"touch"==t.pointerType?this.handleTouchCancel(t):"pointerup"==t.type&&"touch"==t.pointerType?this.handleTouchEnd(t):e.logMessage(e.LEVEL_INFO,"GestureRecognizer","handleEvent","Unrecognized event type: "+t.type))}catch(t){e.logMessage(e.LEVEL_SEVERE,"GestureRecognizer","handleEvent","Error handling event.\n"+t.toString())}}},r.prototype.handleMouseDown=function(t){if(!("mousedown"==t.type&&this._touches.length>0)){var e=1<<t.button;e&0!=this._mouseButtonMask||(0==this._mouseButtonMask&&(this._clientX=t.clientX,this._clientY=t.clientY,this._clientStartX=t.clientX,this._clientStartY=t.clientY,this._translationX=0,this._translationY=0),this._mouseButtonMask|=e,this.mouseDown(t))}},r.prototype.handleMouseMove=function(t){if(0!=this._mouseButtonMask&&(this._clientX!=t.clientX||this._clientY!=t._clientY)){var e=t.clientX-this._clientStartX,i=t.clientY-this._clientStartY,r=this._translationWeight;this._clientX=t.clientX,this._clientY=t.clientY,this._translationX=this._translationX*(1-r)+e*r,this._translationY=this._translationY*(1-r)+i*r,this.mouseMove(t)}},r.prototype.handleMouseUp=function(t){var e=1<<t.button;e&0==this._mouseButtonMask||(this._mouseButtonMask&=~e,this.mouseUp(t),0==this._mouseButtonMask&&this.resetIfEventsEnded())},r.prototype.handleTouchStart=function(t){var e=new i(t.identifier||t.pointerId,t.clientX,t.clientY);this._touches.push(e),1==this._touches.length?(this._clientX=t.clientX,this._clientY=t.clientY,this._clientStartX=t.clientX,this._clientStartY=t.clientY,this._translationX=0,this._translationY=0,this._touchCentroidShiftX=0,this._touchCentroidShiftY=0):this.touchesAddedOrRemoved(),this.touchStart(e)},r.prototype.handleTouchMove=function(t){var e=this.indexOfTouchWithId(t.identifier||t.pointerId);if(e!=-1){var i=this._touches[e];if(i.clientX!=t.clientX||i.clientY!=t.clientY){i.clientX=t.clientX,i.clientY=t.clientY;var r=this.touchCentroid(),n=r.clientX-this._clientStartX+this._touchCentroidShiftX,o=r.clientY-this._clientStartY+this._touchCentroidShiftY,s=this._translationWeight;this._clientX=r.clientX,this._clientY=r.clientY,this._translationX=this._translationX*(1-s)+n*s,this._translationY=this._translationY*(1-s)+o*s,this.touchMove(i)}}},r.prototype.handleTouchCancel=function(t){var e=this.indexOfTouchWithId(t.identifier||t.pointerId);if(e!=-1){var i=this._touches[e];this._touches.splice(e,1),this.touchesAddedOrRemoved(),this.touchCancel(i),this.resetIfEventsEnded()}},r.prototype.handleTouchEnd=function(t){var e=this.indexOfTouchWithId(t.identifier||t.pointerId);if(e!=-1){var i=this._touches[e];this._touches.splice(e,1),this.touchesAddedOrRemoved(),this.touchEnd(i),this.resetIfEventsEnded()}},r.prototype.resetIfEventsEnded=function(){this._state!=WorldWind.POSSIBLE&&0==this._mouseButtonMask&&0==this._touches.length&&this.reset()},r.prototype.touchesAddedOrRemoved=function(){this._touchCentroidShiftX+=this._clientX,this._touchCentroidShiftY+=this._clientY;var t=this.touchCentroid();this._clientX=t.clientX,this._clientY=t.clientY,this._touchCentroidShiftX-=this._clientX,this._touchCentroidShiftY-=this._clientY},r.prototype.touchCentroid=function(){for(var t=0,e=0,i=0,r=this._touches.length;i<r;i++){var n=this._touches[i];t+=n.clientX/r,e+=n.clientY/r}return{clientX:t,clientY:e}},r.prototype.indexOfTouchWithId=function(t){for(var e=0,i=this._touches.length;e<i;e++)if(this._touches[e].identifier==t)return e;return-1},r}),i("gesture/ClickRecognizer",["../gesture/GestureRecognizer"],function(t){"use strict";var e=function(e,i){t.call(this,e,i),this.numberOfClicks=1,this.button=0,this.maxMouseMovement=5,this.maxClickDuration=500,this.maxClickInterval=400,this.clicks=[],this.timeout=null};return e.prototype=Object.create(t.prototype),e.prototype.reset=function(){t.prototype.reset.call(this),this.clicks=[],this.cancelFailAfterDelay()},e.prototype.mouseDown=function(t){if(this.state==WorldWind.POSSIBLE)if(this.button!=t.button)this.state=WorldWind.FAILED;else{var e={clientX:this.clientX,clientY:this.clientY};this.clicks.push(e),this.failAfterDelay(this.maxClickDuration)}},e.prototype.mouseMove=function(t){if(this.state==WorldWind.POSSIBLE){var e=this.translationX,i=this.translationY,r=Math.sqrt(e*e+i*i);r>this.maxMouseMovement&&(this.state=WorldWind.FAILED)}},e.prototype.mouseUp=function(t){if(this.state==WorldWind.POSSIBLE&&0==this.mouseButtonMask){var e=this.clicks.length;e==this.numberOfClicks?(this.clientX=this.clicks[0].clientX,this.clientY=this.clicks[0].clientY,this.state=WorldWind.RECOGNIZED):this.failAfterDelay(this.maxClickInterval)}},e.prototype.touchStart=function(t){this.state==WorldWind.POSSIBLE&&(this.state=WorldWind.FAILED)},e.prototype.failAfterDelay=function(t){var e=this;e.timeout&&window.clearTimeout(e.timeout),e.timeout=window.setTimeout(function(){e.timeout=null,e.state==WorldWind.POSSIBLE&&(e.state=WorldWind.FAILED)},t)},e.prototype.cancelFailAfterDelay=function(){var t=this;t.timeout&&(window.clearTimeout(t.timeout),t.timeout=null)},e}),i("formats/collada/ColladaAsset",[],function(){"use strict";var t=function(t){this.xmlAsset=t.getElementsByTagName("asset")[0],this.asset={daeVersion:t.querySelector("COLLADA").getAttribute("version")}};return t.prototype.parse=function(){if(!this.xmlAsset)return null;for(var t=0;t<this.xmlAsset.childNodes.length;t++){var e=this.xmlAsset.childNodes.item(t);if(1===e.nodeType)switch(e.nodeName){case"contributor":var i=e.querySelector("authoring_tool");i&&(this.asset.authoring_tool=i.textContext);break;case"unit":this.asset.unit=e.getAttribute("meter");break;default:this.asset[e.localName]=e.textContent}}return this.xmlAsset=null,this.asset},t}),i("formats/collada/ColladaUtils",["../../util/Logger"],function(t){"use strict";var e={getRawValues:function(t){if(!t)return null;var e=t.textContent;return e=e.replace(/\n/gi," "),e=e.replace(/\s+/gi," "),e=e.trim(),0===e.length?null:e.split(" ")},bufferDataFloat32:function(t){var e=this.getRawValues(t);if(!e)return null;for(var i=e.length,r=new Float32Array(i),n=0;n<i;n++)r[n]=parseFloat(e[n]);return r},bufferDataUInt32:function(t){var e=this.getRawValues(t);if(!e)return null;for(var i=e.length,r=new Uint32Array(i),n=0;n<i;n++)r[n]=parseInt(e[n]);return r},getFirstChildElement:function(t,e){for(var i=t.childNodes,r=0;r<i.length;++r){var n=i.item(r);if(1===n.nodeType&&(n.nodeName&&!e||e&&e===n.nodeName))return n}return null},getFilename:function(t){var e=t.lastIndexOf("\\");return e!==-1&&(t=t.substr(e+1)),e=t.lastIndexOf("/"),e!==-1&&(t=t.substr(e+1)),t},replaceSpace:function(t){return t?t.replace(/ /g,"_"):""},querySelectorById:function(t,e){for(var i=0;i<t.length;i++){var r=t.item(i).getAttribute("id");if(r&&r.toString()===e)return t.item(i)}return null},getTextureType:function(t){for(var e=!0,i=0,r=t.length;i<r;i++)if(t[i]<0||t[i]>1){e=!1;break}return e},fetchFile:function(e,i){var r=new XMLHttpRequest;r.onload=function(){this.status>=200&&this.status<400?i(this.response):(t.log(t.LEVEL_SEVERE,"sever error: "+this.status),i(null))},r.onerror=function(e){t.log(t.LEVEL_SEVERE,"connection error: "+e),i(null)},r.open("get",e,!0),r.send()}};return e}),i("formats/collada/ColladaImage",["./ColladaUtils"],function(t){"use strict";var e=function(t,e){this.filename="",this.map=t,this.name=e,this.path=""};return e.prototype.parse=function(e){for(var i=0;i<e.childNodes.length;i++){var r=e.childNodes[i];if(1===r.nodeType)switch(r.nodeName){case"init_from":this.filename=t.getFilename(r.textContent),this.path=r.textContent}}return this},e}),i("formats/collada/ColladaMaterial",["./ColladaUtils"],function(t){"use strict";var e=function(t){this.id=t,this.newParams=[]};return e.prototype.parse=function(t){for(var e=0;e<t.childNodes.length;e++){var i=t.childNodes[e];if(1===i.nodeType)switch(i.nodeName){case"profile_COMMON":this.parseProfileCommon(i)}}return this},e.prototype.parseProfileCommon=function(t){for(var e=0;e<t.childNodes.length;e++){var i=t.childNodes[e];if(1===i.nodeType)switch(i.nodeName){case"newparam":this.parseNewparam(i);break;case"image":break;case"technique":this.parseTechnique(i)}}},e.prototype.parseNewparam=function(t){for(var e=t.getAttribute("sid"),i=0;i<t.childNodes.length;i++){var r=t.childNodes[i];if(1===r.nodeType)switch(r.nodeName){case"surface":var n=r.querySelector("init_from");n&&this.newParams.push({sid:e,type:"surface",initFrom:n.textContent});break;case"sampler2D":var o=r.querySelector("source");this.newParams.push({sid:e,type:"sampler2D",source:o.textContent});break;case"extra":}}},e.prototype.parseTechnique=function(t){for(var e=0;e<t.childNodes.length;e++){var i=t.childNodes[e];if(1===i.nodeType)switch(i.nodeName){case"constant":case"lambert":case"blinn":case"phong":this.techniqueType=i.nodeName,this.parseTechniqueType(i);break;case"extra":}}},e.prototype.parseTechniqueType=function(e){for(var i=0;i<e.childNodes.length;i++){var r=e.childNodes[i];if(1===r.nodeType&&r.nodeName){var n=r.nodeName,o=t.getFirstChildElement(r);if(o)switch(o.nodeName){case"color":this[n]=t.bufferDataFloat32(o).subarray(0,4);break;case"float":this[n]=t.bufferDataFloat32(o)[0];break;case"texture":var s=o.getAttribute("texture"),a=this.newParams.map(function(t){return t.sid}).indexOf(s),l=this.newParams[a].source;a=this.newParams.map(function(t){return t.sid}).indexOf(l);var h=this.newParams[a].initFrom;this.textures||(this.textures={}),this.textures[n]={mapId:h}}}}},e}),i("formats/collada/ColladaMesh",["./ColladaUtils"],function(t){"use strict";var e=function(t){this.filename=t||"",this.name=t||"",this.buffers=[]};return e.prototype.parse=function(e){for(var i={},r={},n={id:"",inputs:[]},o=0;o<e.childNodes.length;o++){var s=e.childNodes[o];if(1===s.nodeType)switch(s.nodeName){case"source":if(!s.querySelector)continue;var a=s.querySelector("float_array");if(!a)continue;var l=t.bufferDataFloat32(a),h=s.querySelector("accessor"),u=parseInt(h.getAttribute("stride"));i[s.getAttribute("id")]={stride:u,data:l};break;case"vertices":this.parseVertices(s,n);break;case"triangles":r=this.parsePolygons(s,i,n,3),this.buffers.push(r);break;case"polygons":r=this.parsePolygons(s,i,n,4),this.buffers.push(r);break;case"polylist":r=this.parsePolygons(s,i,n,null),this.buffers.push(r)}}return this},e.prototype.parseVertices=function(t,e){e.id=t.getAttribute("id");for(var i=t.querySelectorAll("input"),r=0;r<i.length;r++){var n=i[r],o=n.getAttribute("source").substr(1),s=n.getAttribute("semantic").toUpperCase();e.inputs.push({semantic:s,source:o})}},e.prototype.parsePolygons=function(t,e,i,r){var n=[];if(null==r){var o=t.querySelector("vcount");n=o.textContent.trim().split(" ")}var s=parseInt(t.getAttribute("count")),a=t.getAttribute("material"),l=this.parseInputs(t,e,i),h=l.inputs,u=l.maxOffset,c=t.querySelector("p"),d=[];c&&(d=c.textContent.trim().split(" "));for(var p=h.length,f=0,g={},m=[],E=0,y=!1,_=0;_<s;_++){if(n.length)var v=parseInt(n[_]);else v=r;for(var b=-1,S=-1,T=-1,L=0;L<v;L++){var w=d.slice(E,E+u).join(" ");if(T=S,g.hasOwnProperty(w))S=g[w],y=!0;else{for(var x=0;x<p;x++){var R=h[x],M=R[4],C=parseInt(d[E+M]),A=R[1],P=R[3];C*=R[2];for(var O=0;O<R[2];O++)A.push(P[C+O])}S=f,f+=1,g[w]=S}v>3&&(0===L&&(b=S),L>2*u&&(m.push(b),m.push(T))),m.push(S),E+=u}}var I={vertices:new Float32Array(h[0][1]),indexedRendering:y,material:a};return this.transformMeshInfo(I,h,m),I},e.prototype.parseInputs=function(t,e,i){for(var r=[],n=0,o=t.querySelectorAll("input"),s=0;s<o.length;s++){var a=o.item(s);if(a.getAttribute){var l=a.getAttribute("semantic").toUpperCase(),h=a.getAttribute("source").substr(1),u=parseInt(a.getAttribute("offset"));n=n<u+1?u+1:n;var c=0;if(a.getAttribute("set")&&(c=parseInt(a.getAttribute("set"))),i.id===h)for(var d=i.inputs,p=0;p<d.length;p++){var f=e[d[p].source];f&&r.push([d[p].semantic,[],f.stride,f.data,u,c])}else f=e[h],r.push([l,[],f.stride,f.data,u,c])}}return{inputs:r,maxOffset:n}},e.prototype.transformMeshInfo=function(e,i,r){for(var n={normal:"normals",texcoord:"uvs"},o=1;o<i.length;o++){var s=i[o][0].toLowerCase(),a=i[o][1];a.length&&(n[s]&&(s=n[s]),e[s]&&(s+=i[o][5]),e[s]=new Float32Array(a),"uvs"===s&&(e.isClamp=t.getTextureType(a)))}return e.indexedRendering&&(e.indices=new Uint16Array(r)),e},e}),i("formats/collada/ColladaNode",["./ColladaUtils","../../geom/Matrix","../../geom/Vec3"],function(t,e,i){"use strict";var r=function(){this.id="",this.name="",this.sid="",this.children=[],this.materials=[],this.mesh="",this.localMatrix=e.fromIdentity(),this.worldMatrix=e.fromIdentity()};return r.prototype.parse=function(t,i,n){this.id=t.getAttribute("id"),this.sid=t.getAttribute("sid"),this.name=t.getAttribute("name"),this.children=[],this.materials=[],this.mesh="",this.localMatrix=e.fromIdentity(),this.worldMatrix=e.fromIdentity(),this.setNodeTransforms(t,n);for(var o=0;o<t.childNodes.length;o++){var s=t.childNodes[o];if(1===s.nodeType)switch(s.nodeName){case"node":this.children.push((new r).parse(s,i,this.worldMatrix));break;case"instance_geometry":this.mesh=s.getAttribute("url").substr(1);for(var a=s.querySelectorAll("instance_material"),l=0;l<a.length;l++){var h=a.item(l);this.materials.push({id:h.getAttribute("target").substr(1),symbol:h.getAttribute("symbol")})}break;case"instance_node":var u=s.getAttribute("url").substr(1),c=this.getLibraryNode(i,u);c&&this.children.push((new r).parse(c,i,this.worldMatrix))}}return this},r.prototype.setNodeTransforms=function(r,n){var o=e.fromIdentity(),s=e.fromIdentity(),a=e.fromIdentity(),l=e.fromIdentity();n||(n=e.fromIdentity());for(var h=[],u=0;u<r.childNodes.length;u++){var c=r.childNodes[u];if(1===c.nodeType)switch(c.nodeName){case"matrix":var d=t.bufferDataFloat32(c);o.copy(d),h.push(o);break;case"rotate":d=t.bufferDataFloat32(c),s.multiplyByRotation(d[0],d[1],d[2],d[3]),h.push(s);break;case"translate":d=t.bufferDataFloat32(c),a.multiplyByTranslation(d[0],d[1],d[2]),h.push(a);break;case"scale":d=t.bufferDataFloat32(c),l.multiplyByScale(d[0],d[1],d[2]),h.push(l)}}for(u=0;u<h.length;u++)this.localMatrix.multiplyMatrix(h[u]);this.worldMatrix.setToMultiply(n,this.localMatrix),this.normalMatrix=e.fromIdentity();var p=new i(0,0,0);this.worldMatrix.extractRotationAngles(p),this.normalMatrix.multiplyByRotation(-1,0,0,p[0]),this.normalMatrix.multiplyByRotation(0,-1,0,p[1]),this.normalMatrix.multiplyByRotation(0,0,-1,p[2])},r.prototype.getLibraryNode=function(t,e){for(var i=0;i<t.length;i++){var r=t[i].attributes.getNamedItem("id");if(r&&r.value===e)return t[i]}return null},r}),i("formats/collada/ColladaScene",["../../error/ArgumentError","../../shaders/BasicTextureProgram","../../util/Color","../../util/Logger","../../geom/Matrix","../../geom/Position","../../pick/PickedObject","../../render/Renderable","../../geom/Vec3"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(e,i){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"ColladaScene","constructor","missingPosition"));a.call(this),this._position=e,this._nodes=[],this._meshes={},this._materials={},this._images={},this._upAxis="",this._dirPath="",this._xRotation=0,this._yRotation=0,this._zRotation=0,this._xTranslation=0,this._yTranslation=0,this._zTranslation=0,this._scale=1,this._altitudeMode=WorldWind.ABSOLUTE,this._localTransforms=!0,this._useTexturePaths=!0,this._nodesToHide=[],this._hideNodes=!1,this.setSceneData(i),this._placePoint=new l(0,0,0),this._transformationMatrix=n.fromIdentity(),this._normalMatrix=n.fromIdentity(),this._texCoordMatrix=n.fromIdentity().setToUnitYFlip(),this._activeTexture=null};return h.prototype=Object.create(a.prototype),h.prototype.constructor=h,Object.defineProperties(h.prototype,{position:{get:function(){return this._position},set:function(t){this._position=t}},nodes:{get:function(){return this._nodes},set:function(t){this._nodes=t}},meshes:{get:function(){return this._meshes},set:function(t){this._meshes=t}},materials:{get:function(){return this._materials},set:function(t){this._materials=t}},images:{get:function(){return this._images},set:function(t){this._images=t}},upAxis:{get:function(){return this._upAxis},set:function(t){this._upAxis=t}},dirPath:{get:function(){return this._dirPath},set:function(t){this._dirPath=t}},xRotation:{get:function(){return this._xRotation},set:function(t){this._xRotation=t}},yRotation:{get:function(){return this._yRotation},set:function(t){this._yRotation=t}},zRotation:{get:function(){return this._zRotation},set:function(t){this._zRotation=t}},xTranslation:{get:function(){return this._xTranslation},set:function(t){this._xTranslation=t}},yTranslation:{get:function(){return this._yTranslation},set:function(t){this._yTranslation=t}},zTranslation:{get:function(){return this._zTranslation},set:function(t){this._zTranslation=t}},scale:{get:function(){return this._scale},set:function(t){this._scale=t}},placePoint:{get:function(){return this._placePoint},set:function(t){this._placePoint=t}},altitudeMode:{get:function(){return this._altitudeMode},set:function(t){this._altitudeMode=t}},transformationMatrix:{get:function(){return this._transformationMatrix},set:function(t){this._transformationMatrix=t}},normalMatrix:{get:function(){return this._normalMatrix},set:function(t){this._normalMatrix=t}},localTransforms:{get:function(){return this._localTransforms},set:function(t){this._localTransforms=t}},useTexturePaths:{get:function(){return this._useTexturePaths},set:function(t){this._useTexturePaths=t}},nodesToHide:{get:function(){return this._nodesToHide},set:function(t){this._nodesToHide=t}},hideNodes:{get:function(){return this._hideNodes},set:function(t){this._hideNodes=t}}}),h.prototype.setSceneData=function(t){t&&(this.nodes=t.root.children,this.meshes=t.meshes,this.materials=t.materials,this.images=t.images,this.upAxis=t.metadata.up_axis,this.dirPath=t.dirPath)},h.prototype.render=function(t){var e;this.enabled&&(this.lastFrameTime!==t.timestamp&&(e=this.makeOrderedRenderable(t)),e&&(e.layer=t.currentLayer,this.lastFrameTime=t.timestamp,t.addOrderedRenderable(e)))},h.prototype.makeOrderedRenderable=function(t){return t.surfacePointForMode(this.position.latitude,this.position.longitude,this.position.altitude,this.altitudeMode,this.placePoint),this.eyeDistance=t.navigatorState.eyePoint.distanceTo(this.placePoint),this},h.prototype.renderOrdered=function(t){if(this.drawOrderedScene(t),t.pickingMode){var e=new s(this.pickColor.clone(),this,this.position,this.layer,!1);t.resolvePick(e)}},h.prototype.drawOrderedScene=function(t){this.beginDrawing(t);try{this.doDrawOrderedScene(t)}finally{this.endDrawing(t)}},h.prototype.beginDrawing=function(t){var i=t.currentGlContext;t.findAndBindProgram(e),i.enable(i.CULL_FACE),i.enable(i.DEPTH_TEST)},h.prototype.doDrawOrderedScene=function(t){t.pickingMode&&(this.pickColor=t.uniquePickColor()),this.computeTransformationMatrix(t.globe);for(var e=0,i=this.nodes.length;e<i;e++)this.traverseNodeTree(t,this.nodes[e])},h.prototype.traverseNodeTree=function(t,e){var i=this.mustRenderNode(e.id);if(i){if(e.mesh)for(var r=e.mesh,n=this.meshes[r].buffers,o=0,s=n.length;o<s;o++){for(var a=n[o].material,l=0;l<e.materials.length;l++)if(a===e.materials[l].symbol){var h=e.materials[l].id;break}var u=this.materials[h];this.draw(t,n[o],u,e.worldMatrix,e.normalMatrix)}for(var c=0;c<e.children.length;c++)this.traverseNodeTree(t,e.children[c])}},h.prototype.draw=function(t,e,i,r,n){var o=t.currentGlContext,s=t.currentProgram;this.applyVertices(t,e),s.loadTextureEnabled(o,!1),this.applyColor(t,i);var a=i&&null!=i.textures&&e.uvs&&e.uvs.length>0;a&&this.applyTexture(t,e,i);var l=null!=e.normals&&e.normals.length>0;l&&!t.pickingMode&&this.applyLighting(t,e),this.applyMatrix(t,l,a,r,n),e.indexedRendering?(this.applyIndices(t,e),o.drawElements(o.TRIANGLES,e.indices.length,o.UNSIGNED_SHORT,0)):o.drawArrays(o.TRIANGLES,0,Math.floor(e.vertices.length/3)),this.resetDraw(t,l,a)},h.prototype.applyVertices=function(t,e){var i,r=t.currentGlContext,n=t.currentProgram;e.verticesVboCacheKey||(e.verticesVboCacheKey=t.gpuResourceCache.generateCacheKey()),i=t.gpuResourceCache.resourceForKey(e.verticesVboCacheKey),i||(i=r.createBuffer(),t.gpuResourceCache.putResource(e.verticesVboCacheKey,i,e.vertices.length),e.refreshVertexBuffer=!0),r.bindBuffer(r.ARRAY_BUFFER,i),e.refreshVertexBuffer&&(r.bufferData(r.ARRAY_BUFFER,e.vertices,r.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),e.refreshVertexBuffer=!1),r.enableVertexAttribArray(n.vertexPointLocation),r.vertexAttribPointer(n.vertexPointLocation,3,r.FLOAT,!1,0,0)},h.prototype.applyColor=function(t,e){var r=t.currentGlContext,n=t.currentProgram;if(e)if("constant"===e.techniqueType)var o=e.reflective;else o=e.diffuse;var s,a=1,l=1,h=1,u=1;o&&(a=o[0],l=o[1],h=o[2],u=null!=o[3]?o[3]:1);var c=new i(a,l,h,u);s=u*t.currentLayer.opacity,r.depthMask(s>=1||t.pickingMode),n.loadColor(r,t.pickingMode?this.pickColor:c),n.loadOpacity(r,t.pickingMode?s>0?1:0:s)},h.prototype.applyTexture=function(t,e,i){var r,n,o,s=t.currentGlContext,a=t.currentProgram;if(i.textures.diffuse)var l=i.textures.diffuse.mapId;else l=i.textures.reflective.mapId;var h=this.useTexturePaths?this.images[l].path:this.images[l].filename;this._activeTexture=t.gpuResourceCache.resourceForKey(this.dirPath+h+""),this._activeTexture||(o=e.isClamp?s.CLAMP_TO_EDGE:s.REPEAT,this._activeTexture=t.gpuResourceCache.retrieveTexture(s,this.dirPath+h+"",o)),r=this._activeTexture&&this._activeTexture.bind(t),r&&(e.texCoordsVboCacheKey||(e.texCoordsVboCacheKey=t.gpuResourceCache.generateCacheKey()),n=t.gpuResourceCache.resourceForKey(e.texCoordsVboCacheKey),n||(n=s.createBuffer(),t.gpuResourceCache.putResource(e.texCoordsVboCacheKey,n,e.uvs.length),e.refreshTexCoordBuffer=!0),s.bindBuffer(s.ARRAY_BUFFER,n),e.refreshTexCoordBuffer&&(s.bufferData(s.ARRAY_BUFFER,e.uvs,s.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),e.refreshTexCoordBuffer=!1),a.loadTextureEnabled(s,!0),s.enableVertexAttribArray(a.vertexTexCoordLocation),s.vertexAttribPointer(a.vertexTexCoordLocation,2,s.FLOAT,!1,0,0),a.loadTextureUnit(s,s.TEXTURE0),a.loadModulateColor(s,t.pickingMode))},h.prototype.applyLighting=function(t,e){var i,r=t.currentGlContext,n=t.currentProgram;n.loadApplyLighting(r,!0),e.normalsVboCacheKey||(e.normalsVboCacheKey=t.gpuResourceCache.generateCacheKey()),i=t.gpuResourceCache.resourceForKey(e.normalsVboCacheKey),i||(i=r.createBuffer(),t.gpuResourceCache.putResource(e.normalsVboCacheKey,i,e.normals.length),e.refreshNormalBuffer=!0),r.bindBuffer(r.ARRAY_BUFFER,i),e.refreshNormalBuffer&&(r.bufferData(r.ARRAY_BUFFER,e.normals,r.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),e.refreshNormalBuffer=!1),r.enableVertexAttribArray(n.normalVectorLocation),r.vertexAttribPointer(n.normalVectorLocation,3,r.FLOAT,!1,0,0)},h.prototype.applyMatrix=function(t,e,i,r,o){var s=n.fromIdentity();if(s.copy(t.navigatorState.modelviewProjection),s.multiplyMatrix(this.transformationMatrix),r&&this.localTransforms&&s.multiplyMatrix(r),e&&!t.pickingMode){var a=n.fromIdentity();a.copy(t.navigatorState.modelviewNormalTransform),a.multiplyMatrix(this.normalMatrix),o&&this.localTransforms&&a.multiplyMatrix(o),t.currentProgram.loadModelviewInverse(t.currentGlContext,a)}i&&this._activeTexture&&(t.currentProgram.loadTextureMatrix(t.currentGlContext,this._texCoordMatrix),this._activeTexture=null),t.currentProgram.loadModelviewProjection(t.currentGlContext,s)},h.prototype.applyIndices=function(t,e){var i,r=t.currentGlContext;e.indicesVboCacheKey||(e.indicesVboCacheKey=t.gpuResourceCache.generateCacheKey()),i=t.gpuResourceCache.resourceForKey(e.indicesVboCacheKey),i||(i=r.createBuffer(),t.gpuResourceCache.putResource(e.indicesVboCacheKey,i,e.indices.length),e.refreshIndicesBuffer=!0),r.bindBuffer(r.ELEMENT_ARRAY_BUFFER,i),e.refreshIndicesBuffer&&(r.bufferData(r.ELEMENT_ARRAY_BUFFER,e.indices,r.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),e.refreshIndicesBuffer=!1)},h.prototype.resetDraw=function(t,e,i){var r=t.currentGlContext,n=t.currentProgram;e&&!t.pickingMode&&(n.loadApplyLighting(r,!1),r.disableVertexAttribArray(n.normalVectorLocation)),i&&r.disableVertexAttribArray(n.vertexTexCoordLocation),r.disableVertexAttribArray(n.vertexPointLocation)},h.prototype.endDrawing=function(t){t.bindProgram(null)},h.prototype.computeTransformationMatrix=function(t){this.transformationMatrix=n.fromIdentity(),this.transformationMatrix.multiplyByLocalCoordinateTransform(this.placePoint,t),this.transformationMatrix.multiplyByRotation(1,0,0,this.xRotation),this.transformationMatrix.multiplyByRotation(0,1,0,this.yRotation),this.transformationMatrix.multiplyByRotation(0,0,1,this.zRotation),this.transformationMatrix.multiplyByScale(this.scale,this.scale,this.scale),this.transformationMatrix.multiplyByTranslation(this.xTranslation,this.yTranslation,this.zTranslation),this.computeNormalMatrix()},h.prototype.computeNormalMatrix=function(){var t=new l(0,0,0);this.transformationMatrix.extractRotationAngles(t),this.normalMatrix=n.fromIdentity(),this.normalMatrix.multiplyByRotation(-1,0,0,t[0]),this.normalMatrix.multiplyByRotation(0,-1,0,t[1]),this.normalMatrix.multiplyByRotation(0,0,-1,t[2])},h.prototype.mustRenderNode=function(t){var e=!0;if(this.hideNodes){var i=this.nodesToHide.indexOf(t);e=i===-1}return e},h}),i("formats/collada/ColladaLoader",["../../error/ArgumentError","./ColladaAsset","./ColladaImage","./ColladaMaterial","./ColladaMesh","./ColladaNode","./ColladaScene","./ColladaUtils","../../util/Logger"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(e,i){if(!e)throw new t(l.logMessage(l.LEVEL_SEVERE,"ColladaLoader","constructor","missingPosition"));this.position=e,this.dirPath="/",this.init(i)};return h.prototype.init=function(t){t&&(this.dirPath=t.dirPath||"/"),this.scene={type:"SceneTree",dirPath:this.dirPath,images:{},metadata:{},materials:{},meshes:{},root:{children:[]}},this.xmlDoc=null},h.prototype.load=function(t,e){t.indexOf("://")===-1&&(t=this.dirPath+t),a.fetchFile(t,function(t){if(t)try{i=this.parse(t)}catch(t){i=null,l.log(l.LEVEL_SEVERE,"error parsing collada file: "+t)}else var i=null;e(i)}.bind(this))},h.prototype.parse=function(t){this.init();var i=new DOMParser;this.xmlDoc=i.parseFromString(t,"text/xml");var r=this.xmlDoc.querySelectorAll("library_nodes node"),n=this.xmlDoc.querySelectorAll("library_effects effect");return this.scene.metadata=new e(this.xmlDoc).parse(),this.parseLib("visual_scene",r),this.parseLib("library_geometries"),this.parseLib("library_materials",n),this.parseLib("library_images"),this.xmlDoc=null,new s(this.position,this.scene)},h.prototype.parseLib=function(t,e){var s=this.xmlDoc.getElementsByTagName(t),l=[];s&&s.length&&(l=s[0].childNodes);for(var h=0;h<l.length;h++){var u=l[h];if(1===u.nodeType)switch(u.nodeName){case"node":var c=(new o).parse(u,e);c&&this.scene.root.children.push(c);break;case"geometry":var d=u.getAttribute("id"),p=u.querySelector("mesh"),f=new n(d).parse(p);f&&(this.scene.meshes[d]=f);break;case"material":var g=u.getAttribute("id"),m=u.querySelector("instance_effect"),E=m.getAttribute("url").substr(1),y=a.querySelectorById(e,E),_=new r(g).parse(y);_&&(this.scene.materials[g]=_);break;case"image":var v=u.getAttribute("id"),b=u.getAttribute("name"),S=new i(v,b).parse(u);S&&(this.scene.images[v]=S)}}},h}),i("util/ImageSource",["../error/ArgumentError","../util/Color","../util/Logger"],function(t,e,i){"use strict";var r=function(e){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"ImageSource","constructor","missingImage"));this.image=e,this.key="ImageSource "+ ++r.keyPool};return r.keyPool=0,r}),i("shapes/ScreenImage",["../error/ArgumentError","../shaders/BasicTextureProgram","../util/Color","../util/ImageSource","../util/Logger","../geom/Matrix","../util/Offset","../pick/PickedObject","../render/Renderable","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u){"use strict";var c=function(e,r){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"ScreenImage","constructor","missingOffset"));if(!r)throw new t(n.logMessage(n.LEVEL_SEVERE,"ScreenImage","constructor","missingImage"));l.call(this),this.screenOffset=e,this._imageSource=r,this.imageColor=i.WHITE,this.imageOffset=new s(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,.5),this.imageScale=1,this.imageRotation=0,this.imageTilt=0,this.enabled=!0,this.opacity=1,this.pickDelegate=null,this.activeTexture=null,this.imageTransform=o.fromIdentity(),this.texCoordMatrix=o.fromIdentity(),this.imageBounds=null,this.layer=null};return c.matrix=o.fromIdentity(),c.prototype=Object.create(l.prototype),Object.defineProperties(c.prototype,{imageSource:{get:function(){return this._imageSource},set:function(e){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"ScreenImage","imageSource","missingImage"));this._imageSource=e,this.imageSourceWasUpdated=!0}}}),c.prototype.render=function(t){if(this.enabled&&t.accumulateOrderedRenderables){var e=null;this.lastFrameTime!==t.timestamp&&(e=this.makeOrderedRenderable(t)),e&&e.isVisible(t)&&(e.layer=t.currentLayer,this.lastFrameTime=t.timestamp,t.addOrderedRenderable(e))}},c.prototype.renderOrdered=function(t){if(this.drawOrderedScreenImage(t),t.pickingMode){var e=new a(this.pickColor.clone(),this.pickDelegate?this.pickDelegate:this,null,this.layer,!1);t.resolvePick(e)}},c.prototype.makeOrderedRenderable=function(t){var e,i,r,n,o,s,a;return this.activeTexture=this.getActiveTexture(t),this.activeTexture&&!this.imageSourceWasUpdated||(this.activeTexture=t.gpuResourceCache.retrieveTexture(t.currentGlContext,this._imageSource),
this.activeTexture)?(this.eyeDistance=0,e=this.activeTexture.imageWidth,i=this.activeTexture.imageHeight,r=this.imageScale,s=this.imageOffset.offsetForSize(e,i),n=t.navigatorState.viewport.width,o=t.navigatorState.viewport.height,a=this.screenOffset.offsetForSize(n,o),this.imageTransform.setTranslation(a[0]-s[0]*r,a[1]-s[1]*r,0),this.imageTransform.setScale(e*r,i*r,1),this.imageBounds=u.boundingRectForUnitQuad(this.imageTransform),this):null},c.prototype.getActiveTexture=function(t){return t.gpuResourceCache.resourceForKey(this._imageSource)},c.prototype.isVisible=function(t){return t.pickingMode?t.pickRectangle&&this.imageBounds.intersects(t.pickRectangle):this.imageBounds.intersects(t.navigatorState.viewport)},c.prototype.drawOrderedScreenImage=function(t){this.beginDrawing(t);try{this.doDrawOrderedScreenImage(t)}finally{this.endDrawing(t)}},c.prototype.beginDrawing=function(t){var i,r=t.currentGlContext;t.findAndBindProgram(e),i=t.currentProgram,r.bindBuffer(r.ARRAY_BUFFER,t.unitQuadBuffer()),r.vertexAttribPointer(i.vertexTexCoordLocation,2,r.FLOAT,!1,0,0),r.enableVertexAttribArray(i.vertexPointLocation),r.enableVertexAttribArray(i.vertexTexCoordLocation),i.loadTextureUnit(r,r.TEXTURE0),i.loadModulateColor(r,t.pickingMode)},c.prototype.endDrawing=function(t){var e=t.currentGlContext,i=t.currentProgram;e.disableVertexAttribArray(i.vertexPointLocation),e.disableVertexAttribArray(i.vertexTexCoordLocation),e.bindBuffer(e.ARRAY_BUFFER,null),e.bindTexture(e.TEXTURE_2D,null),e.enable(e.DEPTH_TEST)},c.prototype.doDrawOrderedScreenImage=function(t){var e=t.currentGlContext,i=t.currentProgram;e.bindBuffer(e.ARRAY_BUFFER,t.unitQuadBuffer3()),e.vertexAttribPointer(i.vertexPointLocation,3,e.FLOAT,!1,0,0),c.matrix.copy(t.screenProjection),c.matrix.multiplyMatrix(this.imageTransform),c.matrix.multiplyByTranslation(.5,.5,.5),c.matrix.multiplyByRotation(1,0,0,this.imageTilt),c.matrix.multiplyByRotation(0,0,1,this.imageRotation),c.matrix.multiplyByTranslation(-.5,-.5,0),i.loadModelviewProjection(e,c.matrix),i.loadTextureEnabled(e,!0),t.pickingMode?(this.pickColor=t.uniquePickColor(),i.loadColor(e,this.pickColor)):(i.loadColor(e,this.imageColor),i.loadOpacity(e,this.opacity*this.layer.opacity)),this.texCoordMatrix.setToIdentity(),this.texCoordMatrix.multiplyByTextureTransform(this.activeTexture),i.loadTextureMatrix(e,this.texCoordMatrix),this.activeTexture.bind(t)&&e.drawArrays(e.TRIANGLE_STRIP,0,4)},c}),i("shapes/Compass",["../error/ArgumentError","../util/Logger","../util/Offset","../shapes/ScreenImage"],function(t,e,i,r){"use strict";var n=function(t,e){var n=t?t:new i(WorldWind.OFFSET_FRACTION,1,WorldWind.OFFSET_FRACTION,1),o=e?e:WorldWind.configuration.baseUrl+"images/notched-compass.png";r.call(this,n,o),t||(this.imageOffset=new i(WorldWind.OFFSET_FRACTION,1.1,WorldWind.OFFSET_FRACTION,1.1)),this.size=.15};return n.prototype=Object.create(r.prototype),n.prototype.render=function(t){this.imageRotation=t.navigatorState.heading,this.imageTilt=t.navigatorState.tilt;var e=this.getActiveTexture(t);e&&(this.imageScale=this.size*t.currentGlContext.drawingBufferWidth/e.imageWidth),r.prototype.render.call(this,t)},n}),i("layer/CompassLayer",["../shapes/Compass","../layer/RenderableLayer"],function(t,e){"use strict";var i=function(){e.call(this,"Compass"),this._compass=new t(null,null),this.addRenderable(this._compass)};return i.prototype=Object.create(e.prototype),Object.defineProperties(i.prototype,{compass:{get:function(){return this._compass},set:function(e){e&&e instanceof t&&(this.removeAllRenderables(),this.addRenderable(e),this._compass=e)}}}),i}),i("shapes/Text",["../error/ArgumentError","../shaders/BasicTextureProgram","../util/Color","../util/Font","../util/Logger","../geom/Matrix","../pick/PickedObject","../render/Renderable","../shapes/TextAttributes","../error/UnsupportedOperationError","../geom/Vec2","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c,d){"use strict";var p=function(e){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"Text","constructor","missingText"));a.call(this),this.attributes=new l(null),this.highlightAttributes=null,this.highlighted=!1,this.enabled=!0,this.text=e,this.altitudeMode=WorldWind.ABSOLUTE,this.pickDelegate=null,this.alwaysOnTop=!1,this.targetVisibility=1,this.currentVisibility=1,this.declutterGroup=0,this.markerImageSource=WorldWind.configuration.baseUrl+"images/white-dot.png",this.markerImageScale=.1,this.activeAttributes=null,this.activeTexture=null,this.imageTransform=o.fromIdentity(),this.texCoordMatrix=o.fromIdentity(),this.imageBounds=null,this.layer=null,this.depthOffset=-.003,this.screenPoint=new c(0,0,0)};return p.matrix=o.fromIdentity(),p.glPickPoint=new c(0,0,0),p.prototype=Object.create(a.prototype),p.prototype.copy=function(t){return this.text=t.text,this.attributes=t.attributes,this.highlightAttributes=t.highlightAttributes,this.highlighted=t.highlighted,this.enabled=t.enabled,this.altitudeMode=t.altitudeMode,this.pickDelegate=t.pickDelegate,this.alwaysOnTop=t.alwaysOnTop,this.depthOffset=t.depthOffset,this.declutterGroup=t.declutterGroup,this.targetVisibility=t.targetVisibility,this.currentVisibility=t.currentVisibility,this},Object.defineProperties(p.prototype,{screenBounds:{get:function(){return this.imageBounds}}}),p.prototype.render=function(t){if(this.enabled&&this.text&&0!==this.text.length&&t.accumulateOrderedRenderables){var e;if(this.lastFrameTime!=t.timestamp)e=this.makeOrderedRenderable(t);else{var i=this.clone();e=i.makeOrderedRenderable(t)}e&&e.isVisible(t)&&(e.layer=t.currentLayer,this.lastFrameTime=t.timestamp,t.addOrderedRenderable(e))}},p.prototype.renderOrdered=function(t){if((0!==this.currentVisibility||0!==this.targetVisibility||this.markerImageSource)&&(this.drawOrderedText(t),t.pickingMode)){var e=new s(this.pickColor.clone(),this.pickDelegate?this.pickDelegate:this,this.position,this.layer,!1);t.resolvePick(e)}},p.prototype.makeOrderedRenderable=function(t){var e,i,r,n;if(this.determineActiveAttributes(t),!this.activeAttributes)return null;if(!this.computeScreenPointAndEyeDistance(t))return null;var o=this.activeAttributes.font,s=this.text+o.toString();return this.activeTexture=t.gpuResourceCache.resourceForKey(s),this.activeTexture||(this.activeTexture=t.textSupport.createTexture(t,this.text,o,!0),t.gpuResourceCache.putResource(s,this.activeTexture,this.activeTexture.size)),e=this.activeTexture.imageWidth,i=this.activeTexture.imageHeight,r=this.activeAttributes.scale,n=this.activeAttributes.offset.offsetForSize(e,i),this.imageTransform.setTranslation(this.screenPoint[0]-n[0]*r,this.screenPoint[1]-n[1]*r,this.screenPoint[2]),this.imageTransform.setScale(e*r,i*r,1),this.imageBounds=d.boundingRectForUnitQuad(this.imageTransform),this},p.prototype.computeScreenPointAndEyeDistance=function(t){throw new h(n.logMessage(n.LEVEL_SEVERE,"Renderable","render","abstractInvocation"))},p.prototype.determineActiveAttributes=function(t){this.highlighted&&this.highlightAttributes?this.activeAttributes=this.highlightAttributes:this.activeAttributes=this.attributes},p.prototype.isVisible=function(t){return t.pickingMode?t.pickRectangle&&this.imageBounds.intersects(t.pickRectangle):this.imageBounds.intersects(t.navigatorState.viewport)},p.prototype.drawOrderedText=function(t){this.beginDrawing(t);try{this.doDrawOrderedText(t),!t.pickingMode}finally{this.endDrawing(t)}},p.prototype.drawBatchOrderedText=function(t){for(var e;(e=t.peekOrderedRenderable())&&e instanceof p;){t.popOrderedRenderable();try{e.doDrawOrderedText(t)}catch(t){n.logMessage(n.LEVEL_WARNING,"Text","drawBatchOrderedText","Error occurred while rendering text using batching: "+t.message)}}},p.prototype.beginDrawing=function(t){var i,r=t.currentGlContext;t.findAndBindProgram(e),i=t.currentProgram,r.bindBuffer(r.ARRAY_BUFFER,t.unitQuadBuffer3()),r.vertexAttribPointer(i.vertexPointLocation,3,r.FLOAT,!1,0,0),r.bindBuffer(r.ARRAY_BUFFER,t.unitQuadBuffer()),r.vertexAttribPointer(i.vertexTexCoordLocation,2,r.FLOAT,!1,0,0),r.enableVertexAttribArray(i.vertexPointLocation),r.enableVertexAttribArray(i.vertexTexCoordLocation),i.loadTextureUnit(r,r.TEXTURE0),t.pickingMode&&i.loadTextureEnabled(r,!1),i.loadModulateColor(r,!1),r.depthMask(!1),p.currentTexture=null},p.prototype.endDrawing=function(t){var e=t.currentGlContext,i=t.currentProgram;e.disableVertexAttribArray(i.vertexPointLocation),e.disableVertexAttribArray(i.vertexTexCoordLocation),e.bindBuffer(e.ARRAY_BUFFER,null),e.bindTexture(e.TEXTURE_2D,null),e.depthMask(!0),p.currentTexture=null},p.prototype.doDrawOrderedText=function(t){var e,i=t.currentGlContext,r=t.currentProgram;if(t.pickingMode&&(this.pickColor=t.uniquePickColor()),!t.pickingMode&&this.currentVisibility!=this.targetVisibility){var n=(t.timestamp-t.previousRedrawTimestamp)/t.fadeTime;this.currentVisibility<this.targetVisibility?this.currentVisibility=Math.min(1,this.currentVisibility+n):this.currentVisibility=Math.max(0,this.currentVisibility-n),t.redrawRequested=!0}if(this.currentVisibility>0&&(p.matrix.copy(t.screenProjection),p.matrix.multiplyMatrix(this.imageTransform),r.loadModelviewProjection(i,p.matrix),t.pickingMode?(r.loadColor(i,this.pickColor),r.loadTextureEnabled(i,!1)):(r.loadColor(i,this.activeAttributes.color),r.loadOpacity(i,this.layer.opacity*this.currentVisibility),this.texCoordMatrix.setToIdentity(),this.activeTexture&&this.texCoordMatrix.multiplyByTextureTransform(this.activeTexture),r.loadTextureMatrix(i,this.texCoordMatrix),this.activeTexture&&this.activeTexture!=p.currentTexture&&(e=this.activeTexture.bind(t),r.loadTextureEnabled(i,e),p.currentTexture=this.activeTexture)),this.activeAttributes.depthTest||i.disable(i.DEPTH_TEST,!1),i.drawArrays(i.TRIANGLE_STRIP,0,4),this.activeAttributes.depthTest||i.disable(i.DEPTH_TEST,!0)),this.currentVisibility<1&&this.markerImageSource){var s=t.gpuResourceCache.resourceForKey(this.markerImageSource);if(!s)return void t.gpuResourceCache.retrieveTexture(t.currentGlContext,this.markerImageSource);var a=this.markerImageScale,l=o.fromIdentity();if(l.setTranslation(this.screenPoint[0]-a*s.imageWidth/2,this.screenPoint[1]-a*s.imageWidth/2,this.screenPoint[2]),l.setScale(s.imageWidth*a,s.imageHeight*a,1),p.matrix.copy(t.screenProjection),p.matrix.multiplyMatrix(l),r.loadModelviewProjection(i,p.matrix),t.pickingMode)r.loadColor(i,this.pickColor),r.loadTextureEnabled(i,!1);else{r.loadColor(i,this.activeAttributes.color),r.loadOpacity(i,this.layer.opacity*(1-this.currentVisibility));var h=o.fromIdentity();h.multiplyByTextureTransform(s),r.loadTextureMatrix(i,h),s!=p.currentTexture&&(e=s.bind(t),r.loadTextureEnabled(i,e),p.currentTexture=s)}this.activeAttributes.depthTest||i.disable(i.DEPTH_TEST,!1),i.drawArrays(i.TRIANGLE_STRIP,0,4),this.activeAttributes.depthTest||i.enable(i.DEPTH_TEST,!0)}},p}),i("shapes/ScreenText",["../error/ArgumentError","../util/Logger","../util/Offset","../shapes/Text"],function(t,e,i,r){"use strict";var n=function(i,n){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"Text","constructor","missingOffset"));r.call(this,n),this.screenOffset=i,this.altitudeMode=null};return n.prototype=Object.create(r.prototype),n.prototype.render=function(t){this.lastFrameTime!=t.timestamp&&r.prototype.render.call(this,t)},n.prototype.computeScreenPointAndEyeDistance=function(t){var e=t.currentGlContext,i=this.screenOffset.offsetForSize(e.drawingBufferWidth,e.drawingBufferHeight);return this.screenPoint[0]=i[0],this.screenPoint[1]=i[1],this.screenPoint[2]=0,this.eyeDistance=0,!0},n}),i("layer/CoordinatesDisplayLayer",["../error/ArgumentError","../util/Color","../util/Font","../layer/Layer","../util/Logger","../util/Offset","../geom/Position","../shapes/ScreenImage","../shapes/ScreenText","../shapes/TextAttributes","../geom/Vec2"],function(t,e,i,r,n,o,s,a,l,h,u){"use strict";var c=function(i){function s(t){p.handleUIEvent(t)}function u(t,e){p.handleRedraw(e)}if(!i)throw new t(n.logMessage(n.LEVEL_SEVERE,"ViewControlsLayer","constructor","missingWorldWindow"));r.call(this,"Coordinates"),this.wwd=i,this.pickEnabled=!1,this.eventType=null,this.clientX=null,this.clientY=null,this.terrainPosition=null,this.latText=new l(new o(WorldWind.OFFSET_PIXELS,0,WorldWind.OFFSET_PIXELS,0)," "),this.latText.attributes=new h(null),this.latText.attributes.color=e.YELLOW,this.lonText=new l(new o(WorldWind.OFFSET_PIXELS,0,WorldWind.OFFSET_PIXELS,0)," "),this.lonText.attributes=new h(null),this.lonText.attributes.color=e.YELLOW,this.elevText=new l(new o(WorldWind.OFFSET_PIXELS,0,WorldWind.OFFSET_PIXELS,0)," "),this.elevText.attributes=new h(null),this.elevText.attributes.color=e.YELLOW,this.eyeText=new l(new o(WorldWind.OFFSET_PIXELS,0,WorldWind.OFFSET_PIXELS,0)," "),this.eyeText.attributes=new h(null),this.eyeText.attributes.color=e.YELLOW;var c=new o(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,.5),d=WorldWind.configuration.baseUrl+"images/crosshair.png";this.crosshairImage=new a(c,d);var p=this;window.PointerEvent?(i.addEventListener("pointerdown",s),i.addEventListener("pointermove",s),i.addEventListener("pointerleave",s)):(i.addEventListener("mousedown",s),i.addEventListener("mousemove",s),i.addEventListener("mouseleave",s),i.addEventListener("touchstart",s),i.addEventListener("touchmove",s)),this.wwd.redrawCallbacks.push(u)};return c.prototype=Object.create(r.prototype),c.prototype.doRender=function(t){var e,i,r,n,s,a=this.terrainPosition,l=t.eyePosition,h=t.currentGlContext.canvas.clientWidth;h>650?(e=h/2-50,i=5,r=WorldWind.OFFSET_PIXELS,n=0):h>400?(e=60,i=5,r=WorldWind.OFFSET_INSET_PIXELS,n=1):(e=60,i=5,r=WorldWind.OFFSET_INSET_PIXELS,n=1,s=!0),this.latText.text=a?this.formatLatitude(a.latitude):null,this.latText.screenOffset=new o(WorldWind.OFFSET_PIXELS,e,r,i),this.latText.attributes.offset=new o(WorldWind.OFFSET_FRACTION,1,WorldWind.OFFSET_FRACTION,n),this.latText.render(t),e+=70,this.lonText.text=a?this.formatLongitude(a.longitude):null,this.lonText.screenOffset=new o(WorldWind.OFFSET_PIXELS,e,r,i),this.lonText.attributes.offset=new o(WorldWind.OFFSET_FRACTION,1,WorldWind.OFFSET_FRACTION,n),this.lonText.render(t),t.globe.is2D()||(e+=70,this.elevText.text=a?this.formatAltitude(a.altitude,"m"):null,this.elevText.screenOffset=new o(WorldWind.OFFSET_PIXELS,e,r,i),this.elevText.attributes.offset=new o(WorldWind.OFFSET_FRACTION,1,WorldWind.OFFSET_FRACTION,n),this.elevText.render(t)),s||(e+=40,this.eyeText.text="Eye  "+this.formatAltitude(l.altitude,l.altitude<1e3?"m":"km"),this.eyeText.screenOffset=new o(WorldWind.OFFSET_PIXELS,e,r,i),this.eyeText.attributes.offset=new o(WorldWind.OFFSET_FRACTION,0,WorldWind.OFFSET_FRACTION,n),this.eyeText.render(t)),"touch"==this.eventType&&this.crosshairImage.render(t),this.inCurrentFrame=!0},c.prototype.handleUIEvent=function(t){t.type.indexOf("pointer")!=-1?this.eventType=t.pointerType:t.type.indexOf("mouse")!=-1?this.eventType="mouse":t.type.indexOf("touch")!=-1&&(this.eventType="touch"),t.type.indexOf("leave")!=-1?(this.clientX=null,this.clientY=null):(this.clientX=t.clientX,this.clientY=t.clientY),this.wwd.redraw()},c.prototype.handleRedraw=function(t){if(t==WorldWind.BEFORE_REDRAW){var e,i;("mouse"==this.eventType||"pen"==this.eventType)&&this.clientX&&this.clientY?(e=this.wwd.canvasCoordinates(this.clientX,this.clientY),e[0]>=0&&e[0]<this.wwd.canvas.width&&e[1]>=0&&e[1]<this.wwd.canvas.height&&(i=this.wwd.pickTerrain(e).terrainObject())):"touch"==this.eventType&&(e=new u(this.wwd.canvas.width/2,this.wwd.canvas.height/2),i=this.wwd.pickTerrain(e).terrainObject()),this.terrainPosition=i?i.position:null}},c.prototype.formatLatitude=function(t){var e=t<0?"°S":"°N";return Math.abs(t).toFixed(2)+e},c.prototype.formatLongitude=function(t){var e=t<0?"°W":"°E";return Math.abs(t).toFixed(2)+e},c.prototype.formatAltitude=function(t,e){return"km"===e&&(t/=1e3),t.toFixed(0).replace(/\B(?=(\d{3})+(?!\d))/g,",")+" "+e},c}),i("util/Date",[],function(){"use strict";var t=function(t){t?this._date=new Date(t):this._date=new Date};return t.prototype=Object.create(Date.prototype),t.prototype.isAfter=function(t){return this.compare(t)==-1},t.prototype.isBefore=function(t){return 1==this.compare(t)},t.prototype.valueOf=function(){return this._date.valueOf()},t.prototype.getTime=function(){return this._date.getTime()},t.prototype.compare=function(t){var e=this._date.valueOf(),i=t.valueOf();return e>i?-1:e<i?1:0},t}),i("layer/DigitalGlobeTiledImageLayer",["../geom/Angle","../error/ArgumentError","../util/Color","../geom/Location","../util/Logger","../geom/Sector","../layer/MercatorTiledImageLayer"],function(t,e,i,r,n,o,s){"use strict";var a=function(t,i,a){if(!i)throw new e(n.logMessage(n.LEVEL_SEVERE,"DigitalGlobeTiledImageLayer","constructor","The map ID is null or undefined."));if(!a)throw new e(n.logMessage(n.LEVEL_SEVERE,"DigitalGlobeTiledImageLayer","constructor","The access token is null or undefined."));this.imageSize=256,t=t||"Digital Globe",s.call(this,new o(-85.05,85.05,-180,180),new r(85.05,180),19,"image/jpeg",t,this.imageSize,this.imageSize),this.mapId=i,this.accessToken=a,this.displayName=t,this.pickEnabled=!1,this.destCanvas=document.createElement("canvas"),this.destContext=this.destCanvas.getContext("2d"),this.requestMetadata();var l=this;this.urlBuilder={urlForTile:function(t,e){return l.metadataRetrievalInProcess?null:l.urlTemplate.replace("{z}",t.level.levelNumber+1).replace("{x}",t.column).replace("{y}",t.row)}}};return a.prototype=Object.create(s.prototype),a.prototype.requestMetadata=function(){if(!this.metadataRetrievalInProcess){this.metadataRetrievalInProcess=!0;var t="https://api.mapbox.com/v4/"+this.mapId+".json?secure&access_token="+this.accessToken,e=new XMLHttpRequest,i=this;e.onreadystatechange=function(){if(4===e.readyState&&200===e.status){var t=JSON.parse(e.responseText);i.urlTemplate=t.tiles[0];var r=document.createEvent("Event");r.initEvent(WorldWind.REDRAW_EVENT_TYPE,!0,!0),window.dispatchEvent(r),i.metadataRetrievalInProcess=!1}},e.open("GET",t,!0),e.send()}},a.prototype.doRender=function(t){s.prototype.doRender.call(this,t),this.inCurrentFrame&&t.screenCreditController.addStringCredit("© Digital Globe",i.DARK_GRAY)},a.prototype.createTopLevelTiles=function(t){this.topLevelTiles=[],this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),0,0)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),0,1)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),1,0)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),1,1))},a.prototype.mapSizeForLevel=function(t){return 256<<t+1},a}),i("gesture/DragRecognizer",["../gesture/GestureRecognizer"],function(t){"use strict";var e=function(e,i){t.call(this,e,i),this.button=0,this.interpretDistance=5};return e.prototype=Object.create(t.prototype),e.prototype.mouseMove=function(t){this.state==WorldWind.POSSIBLE?this.shouldInterpret()&&(this.shouldRecognize()?(this.translationX=0,this.translationY=0,this.state=WorldWind.BEGAN):this.state=WorldWind.FAILED):this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.CHANGED)},e.prototype.mouseUp=function(t){0==this.mouseButtonMask&&(this.state==WorldWind.POSSIBLE?this.state=WorldWind.FAILED:this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.ENDED))},e.prototype.touchStart=function(t){this.state==WorldWind.POSSIBLE&&(this.state=WorldWind.FAILED)},e.prototype.shouldInterpret=function(){var t=this.translationX,e=this.translationY,i=Math.sqrt(t*t+e*e);return i>this.interpretDistance},e.prototype.shouldRecognize=function(){var t=1<<this.button;return t==this.mouseButtonMask},e}),i("util/FrameStatistics",[],function(){"use strict";var t=function(){this.frameCount=0,this.frameTimeCumulative=0,this.frameTimeBase=0,this.frameTimeExtremes=[Number.POSITIVE_INFINITY,Number.NEGATIVE_INFINITY],this.frameTime=0,this.tessellationTime=0,this.layerRenderingTime=0,this.orderedRenderingTime=0,this.terrainTileCount=0,this.imageTileCount=0,this.renderedTileCount=0,this.tileUpdateCount=0,this.textureLoadCount=0,this.vboLoadCount=0,this.frameTimeAverage=0,this.frameRateAverage=0,this.frameTimeMin=0,this.frameTimeMax=0};return t.prototype.beginFrame=function(){this.frameTime=Date.now(),this.tessellationTime=0,this.layerRenderingTime=0,this.orderedRenderingTime=0,this.terrainTileCount=0,this.imageTileCount=0,this.renderedTileCount=0,this.tileUpdateCount=0,this.textureLoadCount=0,this.vboLoadCount=0,++this.frameCount},t.prototype.endFrame=function(){var t=Date.now();this.frameTime=t-this.frameTime,this.frameTimeCumulative+=this.frameTime,this.frameTimeExtremes[0]=Math.min(this.frameTimeExtremes[0],this.frameTime),this.frameTimeExtremes[1]=Math.max(this.frameTimeExtremes[1],this.frameTime),t-this.frameTimeBase>2e3&&(this.frameTimeAverage=this.frameTimeCumulative/this.frameCount,this.frameRateAverage=1e3*this.frameCount/(t-this.frameTimeBase),this.frameTimeMin=this.frameTimeExtremes[0],this.frameTimeMax=this.frameTimeExtremes[1],this.frameCount=0,this.frameTimeCumulative=0,this.frameTimeBase=t,this.frameTimeExtremes=[Number.POSITIVE_INFINITY,Number.NEGATIVE_INFINITY])},t.prototype.incrementRenderedTileCount=function(t){this.renderedTileCount+=t},t.prototype.setTerrainTileCount=function(t){this.terrainTileCount=t},t.prototype.incrementImageTileCount=function(t){this.imageTileCount=t},t.prototype.incrementTileUpdateCount=function(t){this.tileUpdateCount+=t},t.prototype.incrementTextureLoadCount=function(t){this.textureLoadCount+=t},t.prototype.incrementVboLoadCount=function(t){this.vboLoadCount+=t},t}),i("render/FramebufferTexture",["../error/ArgumentError","../util/Logger","../util/WWMath"],function(t,e){"use strict";var i=function(i,r,n,o){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"FramebufferTexture","constructor","missingGlContext"));if(r<0||n<0)throw new t(e.logMessage(e.LEVEL_SEVERE,"FramebufferTexture","constructor","The framebuffer width or height is less than zero."));this.width=r,this.height=n,this.depth=o,this.size=r*n*4+(o?r*n*2:0),this.framebufferId=i.createFramebuffer(),i.bindFramebuffer(i.FRAMEBUFFER,this.framebufferId),this.texture=i.createTexture(),i.bindTexture(i.TEXTURE_2D,this.texture),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.LINEAR),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,i.CLAMP_TO_EDGE),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,r,n,0,i.RGBA,i.UNSIGNED_BYTE,null),i.framebufferTexture2D(i.FRAMEBUFFER,i.COLOR_ATTACHMENT0,i.TEXTURE_2D,this.texture,0),this.depthBuffer=null,o&&(this.depthBuffer=i.createRenderbuffer(),i.bindRenderbuffer(i.RENDERBUFFER,this.depthBuffer),i.renderbufferStorage(i.RENDERBUFFER,i.DEPTH_COMPONENT16,r,n),i.framebufferRenderbuffer(i.FRAMEBUFFER,i.DEPTH_ATTACHMENT,i.RENDERBUFFER,this.depthBuffer));var s=i.checkFramebufferStatus(i.FRAMEBUFFER);s!=i.FRAMEBUFFER_COMPLETE&&(e.logMessage(e.LEVEL_WARNING,"FramebufferTexture","constructor","Error creating framebuffer: "+s),this.framebufferId=null,this.texture=null,this.depthBuffer=null),i.bindFramebuffer(i.FRAMEBUFFER,null),i.bindRenderbuffer(i.RENDERBUFFER,null),i.bindTexture(i.TEXTURE_2D,null)};return i.prototype.bind=function(t){return this.texture&&t.currentGlContext.bindTexture(gl.TEXTURE_2D,this.texture),!!this.texture},i}),i("render/FramebufferTile",["../error/ArgumentError","../render/FramebufferTexture","../util/Logger","../geom/Matrix","../geom/Rectangle","../render/TextureTile"],function(t,e,i,r,n,o){"use strict";var s=function(e,n,s,a,l){if(!l||l.length<1)throw new t(i.logMessage(i.LEVEL_SEVERE,"FramebufferTile","constructor","The specified cache name is null, undefined or zero length."));o.call(this,e,n,s,a),this.gpuCacheKey=l,this.textureTransform=r.fromIdentity().setToUnitYFlip(),this.mustClear=!0};return s.prototype=Object.create(o.prototype),s.prototype.clearFramebuffer=function(t){this.mustClear=!0},s.prototype.bindFramebuffer=function(t){var e=t.gpuResourceCache.resourceForKey(this.gpuCacheKey);return e||(e=this.createFramebuffer(t)),t.bindFramebuffer(e),this.mustClear&&(this.doClearFramebuffer(t),this.mustClear=!1),!0},s.prototype.createFramebuffer=function(t){var i=new e(t.currentGlContext,this.tileWidth,this.tileHeight,!1);return t.gpuResourceCache.putResource(this.gpuCacheKey,i,i.size),i},s.prototype.doClearFramebuffer=function(t){var e=t.currentGlContext;e.clearColor(0,0,0,0),e.clear(e.COLOR_BUFFER_BIT)},s.prototype.applyInternalTransform=function(t,e){e.multiplyMatrix(this.textureTransform)},s}),i("render/FramebufferTileController",["../error/ArgumentError","../render/FramebufferTile","../util/LevelSet","../geom/Location","../util/Logger","../cache/MemoryCache","../geom/Sector","../util/Tile"],function(t,e,i,r,n,o,s,a){"use strict";var l=function(){this.tileWidth=256,this.tileHeight=256,this.detailControl=1.75,this.levels=new i(s.FULL_SPHERE,new r(45,45),16,this.tileWidth,this.tileHeight),this.topLevelTiles=[],this.currentTiles=[],this.currentTimestamp=null,this.currentGlobeStateKey=null,this.tileCache=new o(5e5,4e5),this.key="FramebufferTileController "+ ++l.keyPool};return l.keyPool=0,l.prototype.selectTiles=function(e,i){if(!i)throw new t(n.logMessage(n.LEVEL_SEVERE,"FramebufferTileController","selectTiles","missingSector"));this.assembleTiles(e);for(var r=[],o=0,s=this.currentTiles.length;o<s;o++){var a=this.currentTiles[o];a.sector.overlaps(i)&&(a.selected=!0,r.push(a))}return r},l.prototype.render=function(t){if(0!=this.currentTiles.length){for(var e=[],i=0,r=this.currentTiles.length;i<r;i++){var n=this.currentTiles[i];n.selected&&e.push(n)}t.surfaceTileRenderer.renderTiles(t,e,1);var o=t.currentGlContext,s=t.currentFramebuffer;try{for(o.clearColor(0,0,0,0),i=0,r=e.length;i<r;i++)n=e[i],n.selected=!1,n.bindFramebuffer(t),o.clear(o.COLOR_BUFFER_BIT)}finally{t.bindFramebuffer(s)}}},l.prototype.assembleTiles=function(t){var e=t.timestamp,i=t.globeStateKey;this.currentTimestamp==e&&this.currentGlobeStateKey==i||(this.doAssembleTiles(t),this.currentTimestamp=e,this.currentGlobeStateKey=i)},l.prototype.doAssembleTiles=function(t){if(this.currentTiles=[],t.terrain){0==this.topLevelTiles.length&&this.createTopLevelTiles();for(var e=0,i=this.topLevelTiles.length;e<i;e++){var r=this.topLevelTiles[e];r.update(t),this.isTileVisible(t,r)&&this.addTileOrDescendants(t,r)}}},l.prototype.createTile=function(t,i,r,n){var o=this.key+" "+i.levelNumber+"."+r+"."+n;return new e(t,i,r,n,o)},l.prototype.createTopLevelTiles=function(){a.createTilesForLevel(this.levels.firstLevel(),this,this.topLevelTiles)},l.prototype.addTileOrDescendants=function(t,e){if(this.tileMeetsRenderingCriteria(t,e))return void this.addTile(e);for(var i=e.subdivideToCache(e.level.nextLevel(),this,this.tileCache),r=0,n=i.length;r<n;r++){var o=i[r];o.update(t),this.isTileVisible(t,o)&&this.addTileOrDescendants(t,o)}},l.prototype.addTile=function(t){this.currentTiles.push(t)},l.prototype.isTileVisible=function(t,e){return!(t.globe.projectionLimits&&!e.sector.overlaps(t.globe.projectionLimits))&&(t.pickingMode?e.extent.intersectsFrustum(t.pickFrustum):e.extent.intersectsFrustum(t.navigatorState.frustumInModelCoordinates))},l.prototype.tileMeetsRenderingCriteria=function(t,e){var i=this.detailControl;return(e.sector.minLatitude>=75||e.sector.maxLatitude<=-75)&&(i*=1.2),e.level.isLastLevel()||!e.mustSubdivide(t,i)},l}),i("globe/ElevationImage",["../error/ArgumentError","../util/Logger","../util/WWMath"],function(t,e,i){"use strict";var r=function(i,r,n,o){if(!i||i.length<1)throw new t(e.logMessage(e.LEVEL_SEVERE,"ElevationImage","constructor","The specified image path is null, undefined or zero length."));if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"ElevationImage","constructor","missingSector"));this.sector=r,this.imagePath=i,this.imageWidth=n,this.imageHeight=o,this.size=this.imageWidth*this.imageHeight};return r.prototype.pixel=function(t,e){return t<0||t>=this.imageWidth?0:e<0||e>=this.imageHeight?0:(e=this.imageHeight-e-1,this.imageData[t+e*this.imageWidth])},r.prototype.elevationAtLocation=function(t,e){var r=this.sector.maxLatitude,n=this.sector.minLongitude,o=this.sector.deltaLatitude(),s=this.sector.deltaLongitude(),a=(this.imageWidth-1)*(e-n)/s,l=(this.imageHeight-1)*(r-t)/o,h=Math.floor(i.clamp(a,0,this.imageWidth-1)),u=Math.floor(i.clamp(h+1,0,this.imageWidth-1)),c=Math.floor(i.clamp(l,0,this.imageHeight-1)),d=Math.floor(i.clamp(c+1,0,this.imageHeight-1)),p=this.imageData,f=p[h+c*this.imageWidth],g=p[u+c*this.imageWidth],m=p[h+d*this.imageWidth],E=p[u+d*this.imageWidth],y=a-h,_=l-c;return(1-y)*(1-_)*f+y*(1-_)*g+(1-y)*_*m+y*_*E},r.prototype.elevationsForGrid=function(r,n,o,s){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"ElevationImage","elevationsForSector","missingSector"));if(n<1||o<1)throw new t(e.logMessage(e.LEVEL_SEVERE,"ElevationImage","elevationsForSector","The specified number of sample points is less than 1."));if(!s)throw new t(e.logMessage(e.LEVEL_SEVERE,"ElevationImage","elevationsForSector","missingResult"));var a,l,h,u,c=this.sector.minLatitude,d=this.sector.maxLatitude,p=this.sector.minLongitude,f=this.sector.maxLongitude,g=d-c,m=f-p,E=r.minLatitude,y=r.maxLatitude,_=r.minLongitude,v=r.maxLongitude,b=(y-E)/(n>1?n-1:1),S=(v-_)/(o>1?o-1:1),T=0,L=this.imageData;for(u=0,a=E;u<n;u+=1,a+=b)if(u===n-1&&(a=y),a>=c&&a<=d){var w=(this.imageHeight-1)*(d-a)/g,x=Math.floor(i.clamp(w,0,this.imageHeight-1)),R=Math.floor(i.clamp(x+1,0,this.imageHeight-1)),M=w-x;for(h=0,l=_;h<o;h+=1,l+=S){if(h===o-1&&(l=v),l>=p&&l<=f){var C=(this.imageWidth-1)*(l-p)/m,A=Math.floor(i.clamp(C,0,this.imageWidth-1)),P=Math.floor(i.clamp(A+1,0,this.imageWidth-1)),O=C-A,I=L[A+x*this.imageWidth],N=L[P+x*this.imageWidth],D=L[A+R*this.imageWidth],V=L[P+R*this.imageWidth];s[T]=(1-O)*(1-M)*I+O*(1-M)*N+(1-O)*M*D+O*M*V}T++}}else T+=o},r.prototype.minAndMaxElevationsForSector=function(t){var e=[];if(t)if(t.contains(this.sector))e[0]>this.minElevation&&(e[0]=this.minElevation),e[1]<this.maxElevation&&(e[1]=this.maxElevation);else{var r=this.sector.maxLatitude,n=this.sector.minLongitude,o=this.sector.deltaLatitude(),s=this.sector.deltaLongitude(),a=t.minLatitude,l=t.maxLatitude,h=t.minLongitude,u=t.maxLongitude,c=Math.floor((this.imageHeight-1)*(r-l)/o),d=Math.ceil((this.imageHeight-1)*(r-a)/o),p=Math.floor((this.imageWidth-1)*(h-n)/s),f=Math.ceil((this.imageWidth-1)*(u-n)/s);c=i.clamp(c,0,this.imageHeight-1),d=i.clamp(d,0,this.imageHeight-1),p=i.clamp(p,0,this.imageWidth-1),f=i.clamp(f,0,this.imageWidth-1);for(var g=this.imageData,m=Number.MAX_VALUE,E=-m,y=c;y<=d;y++)for(var _=p;_<=f;_++){var v=g[Math.floor(_+y*this.imageWidth)];m>v&&(m=v),E<v&&(E=v)}e[0]>m&&(e[0]=m),e[1]<E&&(e[1]=E)}else e[0]=this.minElevation,e[1]=this.maxElevation;return e},r.prototype.findMinAndMaxElevation=function(){if(this.imageData&&this.imageData.length>0){this.minElevation=Number.MAX_VALUE,this.maxElevation=-this.minElevation;for(var t=this.imageData,e=this.imageWidth*this.imageHeight,i=0;i<e;i++){var r=t[i];this.minElevation>r&&(this.minElevation=r),this.maxElevation<r&&(this.maxElevation=r)}}else this.minElevation=0,this.maxElevation=0},r}),i("globe/ElevationTile",["../error/ArgumentError","../util/Logger","../util/Tile"],function(t,e,i){"use strict";var r=function(r,n,o,s,a,l){if(!a||a.length<1)throw new t(e.logMessage(e.LEVEL_SEVERE,"ElevationTile","constructor","The specified image path is null, undefined or zero length."));if(!l)throw new t(e.logMessage(e.LEVEL_SEVERE,"ElevationTile","constructor","The specified cache is null or undefined."));i.call(this,r,n,o,s),this.imagePath=a,this.memoryCache=l};return r.prototype=Object.create(i.prototype),r.prototype.size=function(){return i.prototype.size.call(this)+this.imagePath.length+8},r.prototype.image=function(){return this.memoryCache.entryForKey(this.imagePath)},r}),i("globe/ElevationModel",["../util/AbsentResourceList","../geom/Angle","../error/ArgumentError","../globe/ElevationImage","../globe/ElevationTile","../util/LevelSet","../util/Logger","../cache/MemoryCache","../geom/Sector","../util/Tile","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u){
"use strict";var c=function(e,r,n,h,u,d,p){if(!e)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","constructor","missingSector"));if(!r)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","constructor","The specified level-zero delta is null or undefined."));if(!h)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","constructor","The specified image format is null or undefined."));if(!u)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","constructor","The specified cache path is null or undefined."));if(!n||n<1)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","constructor","The specified number of levels is not greater than zero."));if(!d||!p||d<1||p<1)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","constructor","The specified tile width or height is not greater than zero."));this.coverageSector=e,this.retrievalImageFormat=h,this.cachePath=u,this.displayName="Elevations",this.timestamp=Date.now(),this.minElevation=0,this.maxElevation=0,this.pixelIsPoint=!0,this.levels=new o(this.coverageSector,r,n,d,p),this.currentTiles=[],this.currentSector=new l(0,0,0,0),this.tileCache=new a(1e6,8e5),this.imageCache=new a(1e7,8e6),this.currentRetrievals=[],this.absentResourceList=new t(3,5e3),this.id=++c.idPool,this.stateKey="elevationModel "+this.id.toString()+" "};return c.idPool=0,c.prototype.minAndMaxElevationsForSector=function(t){if(!t)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","minAndMaxElevationsForSector","missingSector"));var r=this.levels.levelForTexelSize(t.deltaLatitude()*e.DEGREES_TO_RADIANS/64);if(this.assembleTiles(r,t,!1),0==this.currentTiles.length)return null;for(var n,o,a,l=Number.MAX_VALUE,h=-l,u=[],c=0,d=this.currentTiles.length;c<d;c++){if(n=this.currentTiles[c].image(),!n)return u[0]=this.minElevation,u[1]=this.maxElevation,u;o=n.minElevation,l>o&&(l=o),a=n.maxElevation,h<a&&(h=a)}return u[0]=l,u[1]=h,u},c.prototype.elevationAtLocation=function(t,e){return this.coverageSector.containsLocation(t,e)?this.pointElevationForLocation(t,e):0},c.prototype.elevationsForGrid=function(t,e,r,n,o){if(!t)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","elevationsForSector","missingSector"));if(!o)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","elevationsForSector","missingResult"));if(!e||!r||e<1||r<1)throw new i(s.logMessage(s.LEVEL_SEVERE,"ElevationModel","constructor","The specified number of latitudinal or longitudinal positions is less than one."));var a=this.levels.levelForTexelSize(n);return this.pixelIsPoint?this.pointElevationsForGrid(t,e,r,a,o):this.areaElevationsForGrid(t,e,r,a,o)},c.prototype.pointElevationForLocation=function(t,e){for(var i,r=this.levels.lastLevel(),n=r.tileDelta.latitude,o=r.tileDelta.longitude,s=h.computeRow(n,t),a=h.computeColumn(o,e),l=null,u=r.levelNumber;u>=0;u--){if(i=this.tileCache.entryForKey(u+"."+s+"."+a),i&&(l=i.image()))return l.elevationAtLocation(t,e);s=Math.floor(s/2),a=Math.floor(a/2)}return 0},c.prototype.pointElevationsForGrid=function(t,e,i,r,n){var o,s=0;if(this.assembleTiles(r,t,!0),0===this.currentTiles.length)return 0;this.currentTiles.sort(function(t,e){return t.level.levelNumber-e.level.levelNumber});for(var a=0,l=this.currentTiles.length;a<l;a++){var h=this.currentTiles[a],u=h.image();u?(u.elevationsForGrid(t,e,i,n),o=h.level.texelSize,s<o&&(s=o)):s=Number.MAX_VALUE}return s},c.prototype.areaElevationsForGrid=function(t,e,i,r,n){var o,s,a,l,h,u,c=t.minLatitude,d=t.maxLatitude,p=t.minLongitude,f=t.maxLongitude,g=t.deltaLatitude()/(e>1?e-1:1),m=t.deltaLongitude()/(i>1?i-1:1),E=0;for(h=0,o=c;h<e;h+=1,o+=g)for(h===e-1&&(o=d),u=0,s=p;u<i;u+=1,s+=m)u===i-1&&(s=f),this.coverageSector.containsLocation(o,s)&&(a=(s+180)/360,l=(o+90)/180,this.areaElevationForCoord(a,l,r.levelNumber,n,E)),E++;return r.texelSize},c.prototype.areaElevationForCoord=function(t,e,i,r,n){for(var o,s,a,l,h,c,d,p,f,g,m,E,y,_,v,b,S=new Float64Array(4),T=i;T>=0;T--)if(o=this.levels.level(T),s=Math.round(360*o.tileWidth/o.tileDelta.longitude),a=Math.round(180*o.tileHeight/o.tileDelta.latitude),l=1/(2*a),h=1-l,c=0,d=a-1,p=s*u.fract(t),f=a*u.clamp(e,l,h),g=u.mod(Math.floor(p-.5),s),m=u.mod(g+1,s),E=u.clamp(Math.floor(f-.5),c,d),y=u.clamp(E+1,c,d),_=u.fract(p-.5),v=u.fract(f-.5),b=T==i||0==T,this.lookupPixels(g,m,E,y,o,b,S))return void(r[n]=(1-_)*(1-v)*S[0]+_*(1-v)*S[1]+(1-_)*v*S[2]+_*v*S[3])},c.prototype.lookupPixels=function(t,e,i,r,n,o,s){var a,l,h,u,c=n.levelNumber,d=n.tileWidth,p=n.tileHeight,f=Math.floor(i/p),g=Math.floor(r/p),m=Math.floor(t/d),E=Math.floor(e/d);return f==g&&f==this.cachedRow&&m==E&&m==this.cachedCol?a=l=h=u=this.cachedImage:f==g&&m==E?(a=this.lookupImage(c,f,m,o),l=h=u=a,this.cachedRow=f,this.cachedCol=m,this.cachedImage=a):(a=this.lookupImage(c,f,m,o),l=this.lookupImage(c,f,E,o),h=this.lookupImage(c,g,m,o),u=this.lookupImage(c,g,E,o)),!!(a&&l&&h&&u)&&(s[0]=a.pixel(t%d,i%p),s[1]=l.pixel(e%d,i%p),s[2]=h.pixel(t%d,r%p),s[3]=u.pixel(e%d,r%p),!0)},c.prototype.lookupImage=function(t,e,i,r){var n=this.tileForLevel(t,e,i),o=n.image();return null==o&&r&&this.retrieveTileImage(n),o},c.prototype.createTile=function(t,e,i,r){var o=this.cachePath+"/"+e.levelNumber+"/"+i+"/"+i+"_"+r+".bil";return new n(t,e,i,r,o,this.imageCache)},c.prototype.assembleTiles=function(t,e,i){if(this.currentTiles=[],this.currentSector.copy(e),this.currentSector.intersection(this.coverageSector),!this.currentSector.isEmpty())for(var r=t.tileDelta.latitude,n=t.tileDelta.longitude,o=h.computeRow(r,this.currentSector.minLatitude),s=h.computeLastRow(r,this.currentSector.maxLatitude),a=h.computeColumn(n,this.currentSector.minLongitude),l=h.computeLastColumn(n,this.currentSector.maxLongitude),u=o;u<=s;u++)for(var c=a;c<=l;c++)this.addTileOrAncestor(t,u,c,i)},c.prototype.addTileOrAncestor=function(t,e,i,r){var n=this.tileForLevel(t.levelNumber,e,i);this.isTileImageInMemory(n)?this.addToCurrentTiles(n):(r&&this.retrieveTileImage(n),t.isFirstLevel()?this.currentTiles.push(n):this.addAncestor(t,e,i,r))},c.prototype.addAncestor=function(t,e,i,r){for(var n=null,o=Math.floor(e/2),s=Math.floor(i/2),a=t.levelNumber-1;a>=0;a--){if(n=this.tileForLevel(a,o,s),this.isTileImageInMemory(n))return void this.addToCurrentTiles(n);o=Math.floor(o/2),s=Math.floor(s/2)}this.addToCurrentTiles(n),r&&this.retrieveTileImage(n)},c.prototype.addToCurrentTiles=function(t){this.currentTiles.push(t)},c.prototype.tileForLevel=function(t,e,i){var r=t+"."+e+"."+i,n=this.tileCache.entryForKey(r);if(n)return n;var o=this.levels.level(t),s=h.computeSector(o,e,i);return n=this.createTile(s,o,e,i),this.tileCache.putEntry(r,n,n.size()),n},c.prototype.isTileImageInMemory=function(t){return this.imageCache.containsKey(t.imagePath)},c.prototype.resourceUrlForTile=function(t){return this.urlBuilder.urlForTile(t,this.retrievalImageFormat)},c.prototype.retrieveTileImage=function(t){if(this.currentRetrievals.indexOf(t.imagePath)<0){var e=this.resourceUrlForTile(t,this.retrievalImageFormat),i=new XMLHttpRequest,r=this;if(!e)return;i.open("GET",e,!0),i.responseType="arraybuffer",i.onreadystatechange=function(){if(4===i.readyState){r.removeFromCurrentRetrievals(t.imagePath);var n=i.getResponseHeader("content-type");if(200===i.status)if(n===r.retrievalImageFormat||"text/plain"===n||"application/octet-stream"===n){s.log(s.LEVEL_INFO,"Elevations retrieval succeeded: "+e),r.loadElevationImage(t,i),r.absentResourceList.unmarkResourceAbsent(t.imagePath);var o=document.createEvent("Event");o.initEvent(WorldWind.REDRAW_EVENT_TYPE,!0,!0),window.dispatchEvent(o)}else"text/xml"===n?(r.absentResourceList.markResourceAbsent(t.imagePath),s.log(s.LEVEL_WARNING,"Elevations retrieval failed ("+i.statusText+"): "+e+".\n "+String.fromCharCode.apply(null,new Uint8Array(i.response)))):(r.absentResourceList.markResourceAbsent(t.imagePath),s.log(s.LEVEL_WARNING,"Elevations retrieval failed: "+e+". Unexpected content type "+n));else r.absentResourceList.markResourceAbsent(t.imagePath),s.log(s.LEVEL_WARNING,"Elevations retrieval failed ("+i.statusText+"): "+e)}},i.onerror=function(){r.removeFromCurrentRetrievals(t.imagePath),r.absentResourceList.markResourceAbsent(t.imagePath),s.log(s.LEVEL_WARNING,"Elevations retrieval failed: "+e)},i.ontimeout=function(){r.removeFromCurrentRetrievals(t.imagePath),r.absentResourceList.markResourceAbsent(t.imagePath),s.log(s.LEVEL_WARNING,"Elevations retrieval timed out: "+e)},i.send(null),this.currentRetrievals.push(t.imagePath)}},c.prototype.removeFromCurrentRetrievals=function(t){var e=this.currentRetrievals.indexOf(t);e>-1&&this.currentRetrievals.splice(e,1)},c.prototype.loadElevationImage=function(t,e){var i=new r(t.imagePath,t.sector,t.tileWidth,t.tileHeight);"application/bil16"==this.retrievalImageFormat?(i.imageData=new Int16Array(e.response),i.size=2*i.imageData.length):"application/bil32"==this.retrievalImageFormat&&(i.imageData=new Float32Array(e.response),i.size=4*i.imageData.length),i.imageData&&(i.findMinAndMaxElevation(),this.imageCache.putEntry(t.imagePath,i,i.size),this.timestamp=Date.now())},c}),i("projections/GeographicProjection",["../error/ArgumentError","../util/Logger","../geom/Sector","../error/UnsupportedOperationError"],function(t,e,i,r){"use strict";var n=function(t,e,i){this.displayName=t||"Geographic Projection",this.continuous=e,this.projectionLimits=i,this.is2D=!0};return n.prototype.geographicToCartesian=function(t,i,n,o,s,a){throw new r(e.logMessage(e.LEVEL_SEVERE,"GeographicProjection","geographicToCartesian","abstractInvocation"))},n.prototype.geographicToCartesianGrid=function(t,i,n,o,s,a,l,h){throw new r(e.logMessage(e.LEVEL_SEVERE,"GeographicProjection","geographicToCartesianGrid","abstractInvocation"))},n.prototype.cartesianToGeographic=function(t,i,n,o,s,a){throw new r(e.logMessage(e.LEVEL_SEVERE,"GeographicProjection","cartesianToGeographic","abstractInvocation"))},n.prototype.northTangentAtLocation=function(i,r,n,o){if(!o)throw new t(e.logMessage(e.LEVEL_SEVERE,"ProjectionEquirectangular","northTangentAtLocation","missingResult"));return o[0]=0,o[1]=1,o[2]=0,o},n.prototype.northTangentAtPoint=function(i,r,n,o,s,a){if(!a)throw new t(e.logMessage(e.LEVEL_SEVERE,"ProjectionEquirectangular","northTangentAtPoint","missingResult"));return a[0]=0,a[1]=1,a[2]=0,a},n.prototype.surfaceNormalAtPoint=function(i,r,n,o,s){if(!s)throw new t(e.logMessage(e.LEVEL_SEVERE,"GeographicProjection","surfaceNormalAtPoint","missingResult"));return s[0]=0,s[1]=0,s[2]=1,s},n}),i("projections/ProjectionWgs84",["../geom/Angle","../error/ArgumentError","../projections/GeographicProjection","../util/Logger","../geom/Position","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s){"use strict";var a=function(){i.call(this,"WGS84",!1,null),this.is2D=!1,this.scratchPosition=new n(0,0,0)};return a.prototype=Object.create(i.prototype),Object.defineProperties(a.prototype,{stateKey:{get:function(){return"projection wgs84 "}}}),a.prototype.geographicToCartesian=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionWgs84","geographicToCartesian","missingGlobe"));var h=Math.cos(n*t.DEGREES_TO_RADIANS),u=Math.sin(n*t.DEGREES_TO_RADIANS),c=Math.cos(o*t.DEGREES_TO_RADIANS),d=Math.sin(o*t.DEGREES_TO_RADIANS),p=i.equatorialRadius/Math.sqrt(1-i.eccentricitySquared*u*u);return l[0]=(p+s)*h*d,l[1]=(p*(1-i.eccentricitySquared)+s)*u,l[2]=(p+s)*h*c,l},a.prototype.geographicToCartesianGrid=function(i,n,s,a,l,h,u,c){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionWgs84","geographicToCartesianGrid","missingGlobe"));var d,p,f,g,m,E,y,_,v=n.minLatitude*t.DEGREES_TO_RADIANS,b=n.maxLatitude*t.DEGREES_TO_RADIANS,S=n.minLongitude*t.DEGREES_TO_RADIANS,T=n.maxLongitude*t.DEGREES_TO_RADIANS,L=(b-v)/(s>1?s-1:1),w=(T-S)/(a>1?a-1:1),x=h?h:new o(0,0,0),R=0,M=0,C=new Float64Array(a),A=new Float64Array(a);for(p=0,g=S;p<a;p++,g+=w)p===a-1&&(g=T),C[p]=Math.cos(g),A[p]=Math.sin(g);for(d=0,f=v;d<s;d++,f+=L)for(d===s-1&&(f=b),y=Math.cos(f),_=Math.sin(f),m=i.equatorialRadius/Math.sqrt(1-i.eccentricitySquared*_*_),p=0;p<a;p++)E=l[R++],c[M++]=(m+E)*y*A[p]-x[0],c[M++]=(m*(1-i.eccentricitySquared)+E)*_-x[1],c[M++]=(m+E)*y*C[p]-x[2];return c},a.prototype.cartesianToGeographic=function(i,n,o,a,l,h){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionWgs84","cartesianToGeographic","missingGlobe"));var u,c,d,p,f,g,m,E,y,_,v,b,S,T,L,w=a,x=n,R=o,M=w*w+x*x,C=Math.sqrt(M),A=i.equatorialRadius,P=1/(A*A),O=i.eccentricitySquared,I=O*O,N=M*P,D=R*R*(1-O)*P,V=(N+D-I)/6,k=8*V*V*V+I*N*D;return k>0||0!=D?(k>0?(p=Math.sqrt(k),f=Math.sqrt(I*N*D),k>10*O?(g=s.cbrt((p+f)*(p+f)),d=V+.5*g+2*V*V/g):d=V+.5*s.cbrt((p+f)*(p+f))+.5*s.cbrt((p-f)*(p-f))):(p=Math.sqrt(-k),f=Math.sqrt(-8*V*V*V),g=Math.sqrt(I*N*D),m=2*Math.atan2(g,p+f)/3,d=-4*V*Math.sin(m)*Math.cos(Math.PI/6+m)),E=Math.sqrt(d*d+I*D),y=O*(d+E-D)/(2*E),_=(d+E)/(Math.sqrt(y*y+d+E)+y),v=_*C/(_+O),b=Math.sqrt(v*v+R*R),u=(_+O-1)*b/_,c=2*Math.atan2(R,b+v)):(p=Math.sqrt(1-O),f=Math.sqrt(O-N),S=Math.sqrt(O),u=-A*p*f/S,c=f/(S*f+p*Math.sqrt(N))),L=Math.sqrt(2),T=(L-1)*x<C+w?2*Math.atan2(x,C+w):C+x<(L+1)*w?.5*-Math.PI+2*Math.atan2(w,C-x):.5*Math.PI-2*Math.atan2(w,C+x),h.latitude=t.RADIANS_TO_DEGREES*c,h.longitude=t.RADIANS_TO_DEGREES*T,h.altitude=u,h},a.prototype.northTangentAtLocation=function(e,i,r,n){var o=Math.cos(i*t.DEGREES_TO_RADIANS),s=Math.cos(r*t.DEGREES_TO_RADIANS),a=Math.sin(i*t.DEGREES_TO_RADIANS),l=Math.sin(r*t.DEGREES_TO_RADIANS);return n[0]=-a*l,n[1]=o,n[2]=-a*s,n},a.prototype.northTangentAtPoint=function(t,e,i,r,n,s){return this.cartesianToGeographic(t,e,i,r,o.ZERO,this.scratchPosition),this.northTangentAtLocation(t,this.scratchPosition.latitude,this.scratchPosition.longitude,s)},a.prototype.surfaceNormalAtPoint=function(t,i,n,o,s){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionWgs84","surfaceNormalAtPoint","missingGlobe"));var a=t.equatorialRadius*t.equatorialRadius,l=t.polarRadius*t.polarRadius;return s[0]=i/a,s[1]=n/l,s[2]=o/a,s.normalize()},a}),i("navigate/NavigatorState",["../error/ArgumentError","../geom/Frustum","../geom/Line","../util/Logger","../geom/Matrix","../geom/Rectangle","../geom/Vec2","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(t,i,r,o,s){this.modelview=t,this.projection=i,this.modelviewProjection=n.fromIdentity(),this.modelviewProjection.setToMultiply(i,t),this.viewport=r,this.heading=o,this.tilt=s,this.eyePoint=this.modelview.extractEyePoint(new a(0,0,0)),this.frustumInModelCoordinates=null;var h=n.fromIdentity();h.setToTransposeOfMatrix(this.modelview),this.frustumInModelCoordinates=e.fromProjectionMatrix(this.projection),this.frustumInModelCoordinates.transformByMatrix(h),this.frustumInModelCoordinates.normalize(),this.modelviewInv=n.fromIdentity(),this.modelviewInv.invertOrthonormalMatrix(this.modelview),this.projectionInv=n.fromIdentity(),this.projectionInv.invertMatrix(this.projection),this.modelviewProjectionInv=n.fromIdentity(),this.modelviewProjectionInv.invertMatrix(this.modelviewProjection),this.modelviewNormalTransform=n.fromIdentity().setToTransposeOfMatrix(this.modelviewInv.upper3By3());var u=new a(-1,-1,-1),c=new a(1,1,-1),d=new a(-1,-1,1),p=new a(1,1,1);u.multiplyByMatrix(this.projectionInv),c.multiplyByMatrix(this.projectionInv),d.multiplyByMatrix(this.projectionInv),p.multiplyByMatrix(this.projectionInv);var f=l.fabs(c[0]-u[0]),g=l.fabs(p[0]-d[0]),m=-u[2],E=-d[2],y=(g-f)/(E-m),_=f-y*m;this.pixelSizeScale=y/r.width,this.pixelSizeOffset=_/r.height};return h.prototype.project=function(e,i){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","project","missingPoint"));if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","project","missingResult"));var n=e[0],o=e[1],s=e[2],a=this.modelviewProjection,l=a[0]*n+a[1]*o+a[2]*s+a[3],h=a[4]*n+a[5]*o+a[6]*s+a[7],u=a[8]*n+a[9]*o+a[10]*s+a[11],c=a[12]*n+a[13]*o+a[14]*s+a[15],d=this.viewport;return 0!=c&&(l/=c,h/=c,u/=c,!(u<-1||u>1)&&(l=.5*l+.5,h=.5*h+.5,u=.5*u+.5,l=l*d.width+d.x,h=h*d.height+d.y,i[0]=l,i[1]=h,i[2]=u,!0))},h.prototype.projectWithDepth=function(e,i,n){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","projectWithDepth","missingPoint"));if(!n)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","projectWithDepth","missingResult"));var o=e[0],s=e[1],a=e[2],h=this.modelview,u=h[0]*o+h[1]*s+h[2]*a+h[3],c=h[4]*o+h[5]*s+h[6]*a+h[7],d=h[8]*o+h[9]*s+h[10]*a+h[11],p=h[12]*o+h[13]*s+h[14]*a+h[15],f=this.projection,g=f[0]*u+f[1]*c+f[2]*d+f[3]*p,m=f[4]*u+f[5]*c+f[6]*d+f[7]*p,E=f[8]*u+f[9]*c+f[10]*d+f[11]*p,y=f[12]*u+f[13]*c+f[14]*d+f[15]*p,_=this.viewport;return 0!==y&&(g/=y,m/=y,E/=y,!(E<-1||E>1)&&(E=f[8]*u+f[9]*c+f[10]*d*(1+i)+f[11]*p,E/=y,E=l.clamp(E,-1,1),g=.5*g+.5,m=.5*m+.5,E=.5*E+.5,g=g*_.width+_.x,m=m*_.height+_.y,n[0]=g,n[1]=m,n[2]=E,!0))},h.prototype.unProject=function(e,i){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","unProject","missingPoint"));if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","unProject","missingResult"));var n=e[0],o=e[1],s=e[2],a=this.viewport;if(n=(n-a.x)/a.width,o=(o-a.y)/a.height,n=2*n-1,o=2*o-1,s=2*s-1,s<-1||s>1)return!1;var l=this.modelviewProjectionInv,h=l[0]*n+l[1]*o+l[2]*s+l[3],u=l[4]*n+l[5]*o+l[6]*s+l[7],c=l[8]*n+l[9]*o+l[10]*s+l[11],d=l[12]*n+l[13]*o+l[14]*s+l[15];return 0!==d&&(i[0]=h/d,i[1]=u/d,i[2]=c/d,!0)},h.prototype.convertPointToWindow=function(e,i){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","convertPointToWindow","missingPoint"));if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","convertPointToWindow","missingResult"));return i[0]=e[0],i[1]=this.viewport.height-e[1],i},h.prototype.convertPointToViewport=function(e,i){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","convertPointToViewport","missingPoint"));if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","convertPointToViewport","missingResult"));return i[0]=e[0],i[1]=this.viewport.height-e[1],i},h.prototype.rayFromScreenPoint=function(e){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"NavigatorState","rayFromScreenPoint","missingPoint"));var n=this.convertPointToViewport(e,new a(0,0,0)),o=new a(0,0,0),s=new a(0,0,0);if(!this.unProject(n,o))return null;if(n[2]=1,!this.unProject(n,s))return null;var l=new a(this.eyePoint[0],this.eyePoint[1],this.eyePoint[2]),h=new a(s[0],s[1],s[2]);return h.subtract(o),h.normalize(),new i(l,h)},h.prototype.pixelSizeAtDistance=function(t){return this.pixelSizeScale*t+this.pixelSizeOffset},h}),i("globe/Terrain",["../error/ArgumentError","../util/Logger","../geom/Vec3"],function(t,e,i){"use strict";var r=function(t,e,i,r){this.globe=t,this.verticalExaggeration=r,this.sector=i.sector,this.tessellator=e,this.surfaceGeometry=i.tileArray,this.stateKey=t.stateKey+" ve "+r.toString()};return r.scratchPoint=new i(0,0,0),r.prototype.surfacePoint=function(i,n,o,s){if(!s)throw new t(e.logMessage(e.LEVEL_SEVERE,"Terrain","surfacePoint","missingResult"));for(var a=0,l=this.surfaceGeometry.length;a<l;a++)if(this.surfaceGeometry[a].sector.containsLocation(i,n)){if(this.surfaceGeometry[a].surfacePoint(i,n,s),o){var h=this.globe.surfaceNormalAtPoint(s[0],s[1],s[2],r.scratchPoint);s[0]+=h[0]*o,s[1]+=h[1]*o,s[2]+=h[2]*o}return s}var u=o+this.globe.elevationAtLocation(i,n)*this.verticalExaggeration;return this.globe.computePointFromPosition(i,n,u,s),s},r.prototype.surfacePointForMode=function(i,r,n,o,s){if(!s)throw new t(e.logMessage(e.LEVEL_SEVERE,"Terrain","surfacePointForMode","missingResult"));if(o||(o=WorldWind.ABSOLUTE),o===WorldWind.CLAMP_TO_GROUND)return this.surfacePoint(i,r,0,s);if(o===WorldWind.RELATIVE_TO_GROUND)return this.surfacePoint(i,r,n,s);var a=n*this.verticalExaggeration;return this.globe.computePointFromPosition(i,r,a,s),s},r.prototype.beginRendering=function(t){this.globe&&this.globe.tessellator&&this.globe.tessellator.beginRendering(t)},r.prototype.endRendering=function(t){this.globe&&this.globe.tessellator&&this.globe.tessellator.endRendering(t)},r.prototype.beginRenderingTile=function(i,r){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"Terrain","beginRenderingTile","missingTile"));this.globe&&this.globe.tessellator&&this.globe.tessellator.beginRenderingTile(i,r)},r.prototype.endRenderingTile=function(t,e){},r.prototype.renderTile=function(i,r){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"Terrain","renderTile","missingTile"));this.globe&&this.globe.tessellator&&this.globe.tessellator.renderTile(i,r)},r.prototype.pick=function(t){this.globe&&this.globe.tessellator&&this.globe.tessellator.pick(t,this.surfaceGeometry,this)},r}),i("globe/TerrainTile",["../error/ArgumentError","../util/Logger","../geom/Matrix","../util/Tile"],function(t,e,i,r){"use strict";var n=function(t,e,n,o){r.call(this,t,e,n,o),this.transformationMatrix=i.fromIdentity(),this.points=null,this.pointsStateKey=null,this.pointsVboStateKey=null,this.neighborMap={},this.neighborMap[WorldWind.NORTH]=null,this.neighborMap[WorldWind.SOUTH]=null,this.neighborMap[WorldWind.EAST]=null,this.neighborMap[WorldWind.WEST]=null,this._stateKey=null,this._elevationTimestamp=null,this.scratchArray=[]};return n.prototype=Object.create(r.prototype),Object.defineProperties(n.prototype,{stateKey:{get:function(){return this._stateKey||(this._stateKey=this.computeStateKey()),this._stateKey}}}),n.prototype.neighborLevel=function(t){return this.neighborMap[t]},n.prototype.setNeighborLevel=function(t,e){this.neighborMap[t]=e,this._stateKey=null},n.prototype.surfacePoint=function(i,r,n){if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"TerrainTile","surfacePoint","missingResult"));var o,s,a,l,h,u,c,d,p,f,g=this.sector,m=g.minLatitude,E=g.maxLatitude,y=g.minLongitude,_=g.maxLongitude,v=this.tileWidth,b=this.tileHeight;o=(r-y)/(_-y)*v,s=(i-m)/(E-m)*b,a=o<v?Math.floor(o):v-1,l=s<b?Math.floor(s):b-1,h=v+1,u=this.points,c=this.scratchArray,d=3*(a+l*h);for(var S=0;S<6;S++)c[S]=u[d+S];d=3*(a+(l+1)*h);for(var T=6;T<12;T++)c[T]=u[d+(T-6)];return p=o<v?o-Math.floor(o):1,f=s<b?s-Math.floor(s):1,p>f?(n[0]=c[0]+p*(c[3]-c[0])+f*(c[6]-c[0]),n[1]=c[1]+p*(c[4]-c[1])+f*(c[7]-c[1]),n[2]=c[2]+p*(c[5]-c[2])+f*(c[8]-c[2])):(n[0]=c[9]+(1-p)*(c[6]-c[9])+(1-f)*(c[3]-c[9]),n[1]=c[10]+(1-p)*(c[7]-c[10])+(1-f)*(c[4]-c[10]),n[2]=c[11]+(1-p)*(c[8]-c[11])+(1-f)*(c[5]-c[11])),n[0]+=this.referencePoint[0],n[1]+=this.referencePoint[1],n[2]+=this.referencePoint[2],n},n.prototype.update=function(t){r.prototype.update.call(this,t);var e=t.globe.elevationTimestamp();this._elevationTimestamp!=e&&(this._elevationTimestamp=e,this._stateKey=null)},n.prototype.computeStateKey=function(){var t=[];return t.push(this._elevationTimestamp),t.push(this.neighborMap[WorldWind.NORTH]?this.neighborMap[WorldWind.NORTH].compare(this.level):0),t.push(this.neighborMap[WorldWind.SOUTH]?this.neighborMap[WorldWind.SOUTH].compare(this.level):0),t.push(this.neighborMap[WorldWind.EAST]?this.neighborMap[WorldWind.EAST].compare(this.level):0),t.push(this.neighborMap[WorldWind.WEST]?this.neighborMap[WorldWind.WEST].compare(this.level):0),t.join(".")},n}),i("globe/TerrainTileList",["../error/ArgumentError","../util/Logger","../geom/Sector"],function(t,e,i){"use strict";var r=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"TerrainTileList","TerrainTileList","missingTessellator"));this.tessellator=i,this.sector=null,this.tileArray=[]};return Object.defineProperties(r.prototype,{length:{get:function(){return this.tileArray.length}}}),r.prototype.addTile=function(r){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"TerrainTileList","addTile","missingTile"));this.tileArray.indexOf(r)==-1&&(this.tileArray.push(r),this.sector?this.sector.union(r.sector):(this.sector=new i(0,0,0,0),this.sector.copy(r.sector)))},r.prototype.removeAllTiles=function(){this.tileArray=[],this.sector=null},r}),i("globe/Tessellator",["../error/ArgumentError","../shaders/BasicProgram","../globe/Globe","../shaders/GpuProgram","../util/Level","../util/LevelSet","../geom/Location","../util/Logger","../geom/Matrix","../cache/MemoryCache","../navigate/NavigatorState","../error/NotYetImplementedError","../pick/PickedObject","../geom/Position","../geom/Rectangle","../geom/Sector","../globe/Terrain","../globe/TerrainTile","../globe/TerrainTileList","../util/Tile","../util/WWMath","../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b){"use strict";var S=function(){this.numRowsTilesInTopLevel=4,this.numColumnsTilesInTopLevel=8,this.maximumSubdivisionDepth=15,this.tileWidth=32,this.tileHeight=32,this.detailControl=40,this.levels=new o(g.FULL_SPHERE,new s(180/this.numRowsTilesInTopLevel,360/this.numColumnsTilesInTopLevel),this.maximumSubdivisionDepth,this.tileWidth,this.tileHeight),this.topLevelTiles={},this.currentTiles=new y(this),this.tileCache=new h(5e6,4e6),this.elevationTimestamp=void 0,this.lastModelViewProjection=void 0,this.vertexPointLocation=-1,this.vertexTexCoordLocation=-1,this.texCoords=null,this.texCoordVboCacheKey="global_tex_coords",this.indices=null,this.indicesVboCacheKey="global_indices",this.baseIndices=null,this.baseIndicesOffset=null,this.numBaseIndices=null,this.indicesNorth=null,this.indicesNorthOffset=null,this.numIndicesNorth=null,this.indicesSouth=null,this.indicesSouthOffset=null,this.numIndicesSouth=null,this.indicesWest=null,this.indicesWestOffset=null,this.numIndicesWest=null,this.indicesEast=null,this.indicesEastOffset=null,this.numIndicesEast=null,this.indicesLoresNorth=null,this.indicesLoresNorthOffset=null,this.numIndicesLoresNorth=null,this.indicesLoresSouth=null,this.indicesLoresSouthOffset=null,this.numIndicesLoresSouth=null,this.indicesLoresWest=null,this.indicesLoresWestOffset=null,this.numIndicesLoresWest=null,this.indicesLoresEast=null,this.indicesLoresEastOffset=null,this.numIndicesLoresEast=null,this.outlineIndicesOffset=null,this.numOutlineIndices=null,this.wireframeIndicesOffset=null,this.numWireframeIndices=null,this.scratchMatrix=l.fromIdentity(),this.scratchElevations=null,this.scratchPrevElevations=null,this.corners={},this.tiles=[]};return S.prototype.tessellate=function(e){if(!e)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tessellator","tessellate","missingDC"));var i=e.globe.elevationTimestamp();if(this.lastGlobeStateKey===e.globeStateKey&&this.lastVerticalExaggeration===e.verticalExaggeration&&this.elevationTimestamp===i&&this.lastModelViewProjection&&e.navigatorState.modelviewProjection.equals(this.lastModelViewProjection))return this.lastTerrain;var r=e.navigatorState;this.lastModelViewProjection=r.modelviewProjection,this.lastGlobeStateKey=e.globeStateKey,this.elevationTimestamp=i,this.lastVerticalExaggeration=e.verticalExaggeration,this.currentTiles.removeAllTiles(),this.topLevelTiles[e.globeStateKey]&&0!=this.topLevelTiles[e.globeStateKey].length||this.createTopLevelTiles(e),this.corners={},this.tiles=[];for(var n=0,o=this.topLevelTiles[e.globeStateKey].length;n<o;n+=1){var s=this.topLevelTiles[e.globeStateKey][n];s.update(e),this.isTileVisible(e,s)&&this.addTileOrDescendants(e,s)}return this.refineNeighbors(e),this.finishTessellating(e),this.lastTerrain=0===this.currentTiles.length?null:new m(e.globe,this,this.currentTiles,e.verticalExaggeration),this.lastTerrain},S.prototype.createTile=function(e,i,r,n){if(!e)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tile","constructor","missingSector"));if(!i)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tile","constructor","The specified level is null or undefined."));if(r<0||n<0)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tile","constructor","The specified row or column is less than zero."));return new E(e,i,r,n)},S.prototype.beginRendering=function(t){var e=t.currentProgram;if(!e)return void a.logMessage(a.LEVEL_INFO,"Tessellator","beginRendering","Current Program is empty");this.buildSharedGeometry(),this.cacheSharedGeometryVBOs(t);var i=t.currentGlContext,r=t.gpuResourceCache;if(this.vertexPointLocation=e.attributeLocation(i,"vertexPoint"),this.vertexTexCoordLocation=e.attributeLocation(i,"vertexTexCoord"),i.enableVertexAttribArray(this.vertexPointLocation),this.vertexTexCoordLocation>=0){var n=r.resourceForKey(this.texCoordVboCacheKey);i.bindBuffer(i.ARRAY_BUFFER,n),i.vertexAttribPointer(this.vertexTexCoordLocation,2,i.FLOAT,!1,0,0),i.enableVertexAttribArray(this.vertexTexCoordLocation)}var o=r.resourceForKey(this.indicesVboCacheKey);i.bindBuffer(i.ELEMENT_ARRAY_BUFFER,o)},S.prototype.endRendering=function(t){var e=t.currentGlContext;e.bindBuffer(e.ARRAY_BUFFER,null),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null),this.vertexPointLocation>=0&&e.disableVertexAttribArray(this.vertexPointLocation),this.vertexTexCoordLocation>=0&&e.disableVertexAttribArray(this.vertexTexCoordLocation)},S.prototype.beginRenderingTile=function(e,i){if(!i)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tessellator","beginRenderingTile","missingTile"));var r=e.currentGlContext,n=e.gpuResourceCache;this.scratchMatrix.setToMultiply(e.navigatorState.modelviewProjection,i.transformationMatrix),e.currentProgram.loadModelviewProjection(r,this.scratchMatrix);var o=e.globeStateKey+i.tileKey,s=n.resourceForKey(o);s?i.pointsVboStateKey!=i.pointsStateKey?(r.bindBuffer(r.ARRAY_BUFFER,s),r.bufferSubData(r.ARRAY_BUFFER,0,i.points),i.pointsVboStateKey=i.pointsStateKey):e.currentGlContext.bindBuffer(r.ARRAY_BUFFER,s):(s=r.createBuffer(),r.bindBuffer(r.ARRAY_BUFFER,s),r.bufferData(r.ARRAY_BUFFER,i.points,r.STATIC_DRAW),e.frameStatistics.incrementVboLoadCount(1),n.putResource(o,s,4*i.points.length),i.pointsVboStateKey=i.pointsStateKey),r.vertexAttribPointer(this.vertexPointLocation,3,r.FLOAT,!1,0,0)},S.prototype.endRenderingTile=function(t,e){},S.prototype.renderTile=function(e,i){if(!i)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tessellator","renderTile","missingTile"));var r=e.currentGlContext,n=r.TRIANGLE_STRIP;r.drawElements(n,this.numBaseIndices,r.UNSIGNED_SHORT,2*this.baseIndicesOffset);var o,s=i.level;o=i.neighborLevel(WorldWind.NORTH),o&&o.compare(s)<0?r.drawElements(n,this.numIndicesLoresNorth,r.UNSIGNED_SHORT,2*this.indicesLoresNorthOffset):r.drawElements(n,this.numIndicesNorth,r.UNSIGNED_SHORT,2*this.indicesNorthOffset),o=i.neighborLevel(WorldWind.SOUTH),o&&o.compare(s)<0?r.drawElements(n,this.numIndicesLoresSouth,r.UNSIGNED_SHORT,2*this.indicesLoresSouthOffset):r.drawElements(n,this.numIndicesSouth,r.UNSIGNED_SHORT,2*this.indicesSouthOffset),o=i.neighborLevel(WorldWind.WEST),o&&o.compare(s)<0?r.drawElements(n,this.numIndicesLoresWest,r.UNSIGNED_SHORT,2*this.indicesLoresWestOffset):r.drawElements(n,this.numIndicesWest,r.UNSIGNED_SHORT,2*this.indicesWestOffset),o=i.neighborLevel(WorldWind.EAST),o&&o.compare(s)<0?r.drawElements(n,this.numIndicesLoresEast,r.UNSIGNED_SHORT,2*this.indicesLoresEastOffset):r.drawElements(n,this.numIndicesEast,r.UNSIGNED_SHORT,2*this.indicesEastOffset)},S.prototype.renderWireframeTile=function(e,i){if(!i)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tessellator","renderWireframeTile","missingTile"));var r=e.currentGlContext;this.vertexTexCoordLocation>=0&&r.disableVertexAttribArray(this.vertexTexCoordLocation),r.drawElements(r.LINES,this.numWireframeIndices,r.UNSIGNED_SHORT,2*this.wireframeIndicesOffset)},S.prototype.renderTileOutline=function(e,i){if(!i)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tessellator","renderTileOutline","missingTile"));var r=e.currentGlContext;this.vertexTexCoordLocation>=0&&r.disableVertexAttribArray(this.vertexTexCoordLocation),r.drawElements(r.LINE_LOOP,this.numOutlineIndices,r.UNSIGNED_SHORT,2*this.outlineIndicesOffset)},S.prototype.pick=function(e,i,r){if(!e)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tessellator","pick","missingDc"));if(!i)throw new t(a.logMessage(a.LEVEL_SEVERE,"Tessellator","pick","missingList"));for(var n=null,o=r||this,s=new p(0,0,0),l=[],h=0,u=i.length;h<u;h++){var c=i[h];c.extent.intersectsFrustum(e.pickFrustum)&&l.push(c)}if(e.pickTerrainOnly||(n=e.uniquePickColor(),this.drawPickTiles(e,l,n)),!e.regionPicking){var f=e.navigatorState.rayFromScreenPoint(e.pickPoint),g=this.computeNearestIntersection(f,l);g&&(e.globe.computePositionFromPoint(g[0],g[1],g[2],s),s.altitude=e.globe.elevationAtLocation(s.latitude,s.longitude),e.addPickedObject(new d(n,o,s,null,!0)))}},S.prototype.drawPickTiles=function(t,i,r){
var n=t.currentGlContext;try{t.findAndBindProgram(e),t.currentProgram.loadColor(n,r),this.beginRendering(t);for(var o=0,s=i.length;o<s;o++){var a=i[o];this.beginRenderingTile(t,a),this.renderTile(t,a),this.endRenderingTile(t,a)}}finally{this.endRendering(t)}},S.prototype.computeNearestIntersection=function(t,e){for(var i=[],r=0,n=e.length;r<n;r++)this.computeIntersections(t,e[r],i);if(0==i.length)return null;var o,s=Number.POSITIVE_INFINITY;for(r=0,n=i.length;r<n;r++){var a=t.origin.distanceToSquared(i[r]);s>a&&(s=a,o=r)}return i[o]},S.prototype.computeIntersections=function(t,e,i){var r,n,o=e.level,s=e.points,a=i.length;t.origin.subtract(e.referencePoint),this.buildSharedGeometry(e),n=this.baseIndices,v.computeTriStripIntersections(t,s,n,i),r=e.neighborLevel(WorldWind.SOUTH),n=r&&r.compare(o)<0?this.indicesLoresSouth:this.indicesSouth,v.computeTriStripIntersections(t,s,n,i),r=e.neighborLevel(WorldWind.WEST),n=r&&r.compare(o)<0?this.indicesLoresWest:this.indicesWest,v.computeTriStripIntersections(t,s,n,i),r=e.neighborLevel(WorldWind.EAST),n=r&&r.compare(o)<0?this.indicesLoresEast:this.indicesEast,v.computeTriStripIntersections(t,s,n,i),r=e.neighborLevel(WorldWind.NORTH),n=r&&r.compare(o)<0?this.indicesLoresNorth:this.indicesNorth,v.computeTriStripIntersections(t,s,n,i),t.origin.add(e.referencePoint);for(var l=a,h=i.length;l<h;l++)i[l].add(e.referencePoint)},S.prototype.createTopLevelTiles=function(t){this.topLevelTiles[t.globeStateKey]=[],_.createTilesForLevel(this.levels.firstLevel(),this,this.topLevelTiles[t.globeStateKey])},S.prototype.addTileOrDescendants=function(t,e){return this.tileMeetsRenderCriteria(t,e)?void this.addTile(t,e):void this.addTileDescendants(t,e)},S.prototype.addTileDescendants=function(t,e){for(var i=e.level.nextLevel(),r=e.subdivideToCache(i,this,this.tileCache),n=0;n<r.length;n+=1){var o=r[n];o.update(t),this.levels.sector.intersects(o.sector)&&this.isTileVisible(t,o)&&this.addTileOrDescendants(t,o)}},S.prototype.addTile=function(t,e){var i=this.tiles.length;this.tiles.push(e);var r,n=e.sector,o=[n.maxLatitude,n.maxLongitude].toString(),s=[n.minLatitude,n.maxLongitude].toString(),a=[n.maxLatitude,n.minLongitude].toString(),l=[n.minLatitude,n.minLongitude].toString();r=this.corners[l],r?r.sw=i:this.corners[l]={sw:i},r=this.corners[a],r?r.nw=i:this.corners[a]={nw:i},r=this.corners[s],r?r.se=i:this.corners[s]={se:i},r=this.corners[o],r?r.ne=i:this.corners[o]={ne:i}},S.prototype.refineNeighbors=function(t){for(var e={},i=0,r=this.tiles.length;i<r;i+=1){var n,o,i,r,s=this.tiles[i],a=s.level.levelNumber,l=s.sector,h=[l.maxLatitude,l.maxLongitude].toString(),u=[l.minLatitude,l.maxLongitude].toString(),c=[l.maxLatitude,l.minLongitude].toString(),d=[l.minLatitude,l.minLongitude].toString();n=this.corners[h],n.hasOwnProperty("se")&&(o=n.se,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0))),n.hasOwnProperty("nw")&&(o=n.nw,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0))),n=this.corners[u],n.hasOwnProperty("ne")&&(o=n.ne,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0))),n.hasOwnProperty("sw")&&(o=n.sw,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0))),n=this.corners[c],n.hasOwnProperty("ne")&&(o=n.ne,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0))),n.hasOwnProperty("sw")&&(o=n.sw,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0))),n=this.corners[d],n.hasOwnProperty("se")&&(o=n.se,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0))),n.hasOwnProperty("nw")&&(o=n.nw,this.tiles[o].level.levelNumber<a-1&&(e[o]||(e[o]=!0)))}var p=[],f=[];for(i=0,r=this.tiles.length;i<r;i+=1)s=this.tiles[i],e[i]?p.push(s):f.push(s);if(p.length>0){for(this.tiles=[],this.corners={},i=0,r=f.length;i<r;i+=1)s=f[i],this.addTile(t,s);for(i=0,r=p.length;i<r;i+=1){var s=p[i];this.addTileDescendants(t,s)}this.refineNeighbors(t)}},S.prototype.finishTessellating=function(t){for(var e=0,i=this.tiles.length;e<i;e+=1){var r=this.tiles[e];this.setNeighbors(r),this.regenerateTileGeometryIfNeeded(t,r),this.currentTiles.addTile(r)}},S.prototype.setNeighbors=function(t){var e=t.sector,i=[e.maxLatitude,e.maxLongitude].toString(),r=[e.minLatitude,e.maxLongitude].toString(),n=[e.maxLatitude,e.minLongitude].toString(),o=[e.minLatitude,e.minLongitude].toString(),s=this.corners[i],a=this.corners[r],l=this.corners[n],h=this.corners[o],u=-1,c=-1,d=-1,p=-1;s.hasOwnProperty("se")?u=s.se:l.hasOwnProperty("sw")&&(u=l.sw),a.hasOwnProperty("ne")?c=a.ne:h.hasOwnProperty("nw")&&(c=h.nw),s.hasOwnProperty("nw")?d=s.nw:a.hasOwnProperty("sw")&&(d=a.sw),l.hasOwnProperty("ne")?p=l.ne:h.hasOwnProperty("se")&&(p=h.se),t.setNeighborLevel(WorldWind.NORTH,u>=0?this.tiles[u].level:null),t.setNeighborLevel(WorldWind.SOUTH,c>=0?this.tiles[c].level:null),t.setNeighborLevel(WorldWind.EAST,d>=0?this.tiles[d].level:null),t.setNeighborLevel(WorldWind.WEST,p>=0?this.tiles[p].level:null)},S.prototype.isTileVisible=function(t,e){return!(t.globe.projectionLimits&&!e.sector.overlaps(t.globe.projectionLimits))&&e.extent.intersectsFrustum(t.navigatorState.frustumInModelCoordinates)},S.prototype.tileMeetsRenderCriteria=function(t,e){var i=this.detailControl;return(e.sector.minLatitude>=75||e.sector.maxLatitude<=-75)&&(i*=2),e.level.isLastLevel()||!e.mustSubdivide(t,i)},S.prototype.regenerateTileGeometryIfNeeded=function(t,e){var i=t.globeStateKey+e.stateKey+t.verticalExaggeration;e.points&&e.pointsStateKey==i||(this.regenerateTileGeometry(t,e),e.pointsStateKey=i)},S.prototype.regenerateTileGeometry=function(t,e){var i=e.tileHeight+1,r=e.tileWidth+1,n=e.referencePoint,o=this.scratchElevations;o||(o=new Float64Array(i*r),this.scratchElevations=o),e.points||(e.points=new Float32Array(i*r*3)),b.fillArray(o,0),t.globe.elevationsForGrid(e.sector,i,r,e.texelSize,o),this.mustAlignNeighborElevations(t,e)&&this.alignNeighborElevations(t,e,o),b.multiplyArray(o,t.verticalExaggeration),t.globe.computePointsForGrid(e.sector,i,r,o,n,e.points),e.transformationMatrix.setTranslation(n[0],n[1],n[2])},S.prototype.mustAlignNeighborElevations=function(t,e){var i=e.level,r=e.neighborLevel(WorldWind.NORTH),n=e.neighborLevel(WorldWind.SOUTH),o=e.neighborLevel(WorldWind.EAST),s=e.neighborLevel(WorldWind.WEST);return r&&r.compare(i)<0||n&&n.compare(i)<0||o&&o.compare(i)<0||s&&s.compare(i)<0},S.prototype.alignNeighborElevations=function(t,e,i){var r,n,o,s,a=e.tileHeight+1,l=e.tileWidth+1,h=e.level,u=Math.floor(a/2)+1,c=Math.floor(l/2)+1,d=h.previousLevel(),p=this.scratchPrevElevations;if(p||(p=new Float64Array(u*c),this.scratchPrevElevations=p),b.fillArray(p,0),t.globe.elevationsForGrid(e.sector,u,c,d.texelSize,p),r=e.neighborLevel(WorldWind.NORTH),r&&r.compare(h)<0)for(o=(a-1)*l,s=(u-1)*c,n=0;n<c;n++,o+=2,s+=1)i[o]=p[s],n<c-1&&(i[o+1]=.5*(p[s]+p[s+1]));if(r=e.neighborLevel(WorldWind.SOUTH),r&&r.compare(h)<0)for(o=0,s=0,n=0;n<c;n++,o+=2,s+=1)i[o]=p[s],n<c-1&&(i[o+1]=.5*(p[s]+p[s+1]));if(r=e.neighborLevel(WorldWind.EAST),r&&r.compare(h)<0)for(o=l-1,s=c-1,n=0;n<u;n++,o+=2*l,s+=c)i[o]=p[s],n<u-1&&(i[o+l]=.5*(p[s]+p[s+c]));if(r=e.neighborLevel(WorldWind.WEST),r&&r.compare(h)<0)for(o=0,s=0,n=0;n<u;n++,o+=2*l,s+=c)i[o]=p[s],n<u-1&&(i[o+l]=.5*(p[s]+p[s+c]))},S.prototype.buildSharedGeometry=function(){var t=this.levels.tileWidth,e=this.levels.tileHeight;this.texCoords||this.buildTexCoords(t,e),this.indices||this.buildIndices(t,e)},S.prototype.buildTexCoords=function(t,e){for(var i=t+1,r=e+1,n=1/t,o=1/e,s=new Float32Array(i*r*2),a=0,l=0,h=0;l<r;l++,h+=o){l==r-1&&(h=1);for(var u=0,c=0;u<i;u++,c+=n)u==i-1&&(c=1),s[a++]=c,s[a++]=h}this.texCoords=s},S.prototype.buildIndices=function(t,e){for(var i,r=e+1,n=t+1,o=2*(r-3)*(n-2)+2*(r-3),s=[],a=0,l=1;l<n-2;l+=1){for(var h=1;h<r-1;h+=1)i=l+h*n,s[a++]=i,s[a++]=i+1;s[a++]=i+1,i=l+1+1*n,s[a++]=i}for(this.baseIndicesOffset=s.length-o,this.baseIndices=new Uint16Array(s.slice(this.baseIndicesOffset)),this.numBaseIndices=o,o=2*n-2,h=r-1,l=n-1,i=l+h*n,s[a++]=i,l=n-2;l>0;l-=1)i=l+h*n,s[a++]=i,s[a++]=i-n;for(l=0,i=l+h*n,s[a++]=i,this.indicesNorthOffset=s.length-o,this.indicesNorth=new Uint16Array(s.slice(this.indicesNorthOffset)),this.numIndicesNorth=o,o=2*n-2,h=0,l=0,i=l+h*n,s[a++]=i,l=1;l<n-1;l+=1)i=l+h*n,s[a++]=i,s[a++]=i+n;for(l=n-1,i=l+h*n,s[a++]=i,this.indicesSouthOffset=s.length-o,this.indicesSouth=new Uint16Array(s.slice(this.indicesSouthOffset)),this.numIndicesSouth=o,o=2*r-2,l=0,h=r-1,i=l+h*n,s[a++]=i,h=r-2;h>0;h-=1)i=l+h*n,s[a++]=i,s[a++]=i+1;for(h=0,i=l+h*n,s[a++]=i,this.indicesWestOffset=s.length-o,this.indicesWest=new Uint16Array(s.slice(this.indicesWestOffset)),this.numIndicesWest=o,o=2*r-2,l=n-1,h=0,i=l+h*n,s[a++]=i,h=1;h<r-1;h+=1)i=l+h*n,s[a++]=i,s[a++]=i-1;for(h=r-1,i=l+h*n,s[a++]=i,this.indicesEastOffset=s.length-o,this.indicesEast=new Uint16Array(s.slice(this.indicesEastOffset)),this.numIndicesEast=o,o=2*n-2,h=r-1,l=n-1,i=l+h*n,s[a++]=i,l=n-2;l>0;l-=1)i=(l+1&-2)+h*n,s[a++]=i,i=l+(h-1)*n,s[a++]=i;for(l=0,i=l+h*n,s[a++]=i,this.indicesLoresNorthOffset=s.length-o,this.indicesLoresNorth=new Uint16Array(s.slice(this.indicesLoresNorthOffset)),this.numIndicesLoresNorth=o,o=2*n-2,h=0,l=0,i=l+h*n,s[a++]=i,l=1;l<n-1;l+=1)i=(l&-2)+h*n,s[a++]=i,i=l+(h+1)*n,s[a++]=i;for(l=n-1,i=l+h*n,s[a++]=i,this.indicesLoresSouthOffset=s.length-o,this.indicesLoresSouth=new Uint16Array(s.slice(this.indicesLoresSouthOffset)),this.numIndicesLoresSouth=o,o=2*r-2,l=0,h=r-1,i=l+h*n,s[a++]=i,h=r-2;h>0;h-=1)i=l+(h+1&-2)*n,s[a++]=i,i=l+1+h*n,s[a++]=i;for(h=0,i=l+h*n,s[a++]=i,this.indicesLoresWestOffset=s.length-o,this.indicesLoresWest=new Uint16Array(s.slice(this.indicesLoresWestOffset)),this.numIndicesLoresWest=o,o=2*r-2,l=n-1,h=0,i=l+h*n,s[a++]=i,h=1;h<r-1;h+=1)i=l+(h&-2)*n,s[a++]=i,i=l-1+h*n,s[a++]=i;h=r-1,i=l+h*n,s[a++]=i,this.indicesLoresEastOffset=s.length-o,this.indicesLoresEast=new Uint16Array(s.slice(this.indicesLoresEastOffset)),this.numIndicesLoresEast=o;var u=this.buildWireframeIndices(t,e),c=this.buildOutlineIndices(t,e);s=s.concat(u),this.wireframeIndicesOffset=s.length-this.numWireframeIndices,s=s.concat(c),this.outlineIndicesOffset=s.length-this.numOutlineIndices,this.indices=new Uint16Array(s)},S.prototype.buildWireframeIndices=function(t,e){var i,r,n,o=e+1,s=t+1,a=2*t*o+2*e*s,l=[],h=s,u=0;for(r=0;r<o;r+=1)for(i=0;i<t;i+=1)n=i+r*h,l[u]=n,l[u+1]=n+1,u+=2;for(i=0;i<s;i+=1)for(r=0;r<e;r+=1)n=i+r*h,l[u]=n,l[u+1]=n+h,u+=2;return this.numWireframeIndices=a,l},S.prototype.buildOutlineIndices=function(t,e){var i,r,n,o=e+1,s=t+1,a=2*(o-2)+2*s+1,l=[],h=0;for(r=0,i=0;i<s;i+=1)n=i+r*s,l[h]=n,h+=1;for(i=s-1,r=1;r<o;r+=1)n=i+r*s,l[h]=n,h+=1;for(r=o-1,i=s-1;i>=0;i-=1)n=i+r*s,l[h]=n,h+=1;for(i=0,r=o-1;r>=0;r-=1)n=i+r*s,l[h]=n,h+=1;return this.numOutlineIndices=a,l},S.prototype.cacheSharedGeometryVBOs=function(t){var e=t.currentGlContext,i=t.gpuResourceCache,r=i.resourceForKey(this.texCoordVboCacheKey);r||(r=e.createBuffer(),e.bindBuffer(e.ARRAY_BUFFER,r),e.bufferData(e.ARRAY_BUFFER,this.texCoords,e.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),i.putResource(this.texCoordVboCacheKey,r,4*this.texCoords.length/2));var n=i.resourceForKey(this.indicesVboCacheKey);n||(n=e.createBuffer(),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,n),e.bufferData(e.ELEMENT_ARRAY_BUFFER,this.indices,e.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),i.putResource(this.indicesVboCacheKey,n,2*this.indices.length))},S}),i("globe/Globe",["../geom/Angle","../error/ArgumentError","../geom/BoundingBox","../globe/ElevationModel","../geom/Line","../geom/Location","../util/Logger","../geom/Position","../projections/ProjectionWgs84","../geom/Sector","../globe/Tessellator","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c,d){"use strict";var p=function(t,i){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","constructor","Elevation model is null or undefined."));this.elevationModel=t,this.equatorialRadius=6378137,this.polarRadius=6356752.3,this.eccentricitySquared=.00669437999013,this.tessellator=new u,this._projection=i||new l,this._offset=0,this.offsetVector=new c(0,0,0),this.id=++p.idPool,this._stateKey="globe "+this.id.toString()+" "};return p.idPool=0,Object.defineProperties(p.prototype,{stateKey:{get:function(){return this._stateKey+this.elevationModel.stateKey+"offset "+this.offset.toString()+" "+this.projection.stateKey}},continuous:{get:function(){return this.projection.continuous}},projection:{get:function(){return this._projection},set:function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","projection","missingProjection"));this.projection!=t&&(this.tessellator=new u),this._projection=t}},projectionLimits:{get:function(){return this._projection.projectionLimits}},offset:{get:function(){return this._offset},set:function(t){this._offset=t,this.offsetVector[0]=2*t*Math.PI*this.equatorialRadius}}}),p.prototype.is2D=function(){return this.projection.is2D},p.prototype.computePointFromPosition=function(t,i,r,n){if(!n)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","computePointFromPosition","missingResult"));return this.projection.geographicToCartesian(this,t,i,r,this.offsetVector,n)},p.prototype.computePointFromLocation=function(t,i,r){if(!r)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","computePointFromLocation","missingResult"));return this.computePointFromPosition(t,i,0,r)},p.prototype.computePointsForGrid=function(t,i,r,n,o,a){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","computePointsFromPositions","missingSector"));if(i<1||r<1)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","computePointsFromPositions","Number of latitude or longitude locations is less than one."));var l=i*r;if(!n||n.length<l)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","computePointsFromPositions","Elevations array is null, undefined or insufficient length."));if(!a||a.length<l)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","computePointsFromPositions","Result array is null, undefined or insufficient length."));return this.projection.geographicToCartesianGrid(this,t,i,r,n,o,this.offsetVector,a)},p.prototype.computePositionFromPoint=function(t,i,r,n){if(!n)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","computePositionFromPoint","missingResult"));return this.projection.cartesianToGeographic(this,t,i,r,this.offsetVector,n),this.continuous&&(n.longitude<-180?n.longitude+=360:n.longitude>180&&(n.longitude-=360)),n},p.prototype.radiusAt=function(e,i){var r=Math.sin(e*t.DEGREES_TO_RADIANS),n=this.equatorialRadius/Math.sqrt(1-this.eccentricitySquared*r*r);return n*Math.sqrt(1+(this.eccentricitySquared*this.eccentricitySquared-2*this.eccentricitySquared)*r*r)},p.prototype.surfaceNormalAtLocation=function(i,r,n){if(!n)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","surfaceNormalAtLocation","missingResult"));if(this.is2D())return n[0]=0,n[1]=0,n[2]=1,n;var o=Math.cos(i*t.DEGREES_TO_RADIANS),a=Math.cos(r*t.DEGREES_TO_RADIANS),l=Math.sin(i*t.DEGREES_TO_RADIANS),h=Math.sin(r*t.DEGREES_TO_RADIANS),u=this.equatorialRadius*this.equatorialRadius,c=this.polarRadius*this.polarRadius;return n[0]=o*h/u,n[1]=(1-this.eccentricitySquared)*l/c,n[2]=o*a/u,n.normalize()},p.prototype.surfaceNormalAtPoint=function(t,i,r,n){if(!n)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","surfaceNormalAtPoint","missingResult"));if(this.projection.surfaceNormalAtPoint)return this.projection.surfaceNormalAtPoint(this,t,i,r,n);if(this.is2D())return n[0]=0,n[1]=0,n[2]=1,n;var o=this.equatorialRadius*this.equatorialRadius,a=this.polarRadius*this.polarRadius;return n[0]=t/o,n[1]=i/a,n[2]=r/o,n.normalize()},p.prototype.northTangentAtLocation=function(t,i,r){if(!r)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","northTangentAtLocation","missingResult"));return this.projection.northTangentAtLocation(this,t,i,r)},p.prototype.northTangentAtPoint=function(t,i,r,n){if(!n)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","northTangentAtPoint","missingResult"));return this.projection.northTangentAtPoint(this,t,i,r,this.offsetVector,n)},p.prototype.intersectsFrustum=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","intersectsFrustum","missingFrustum"));if(this.is2D()){var r=new i;return r.setToSector(h.FULL_SPHERE,this,this.elevationModel.minElevation,this.elevationModel.maxElevation),r.intersectsFrustum(t)}return!(t.far.distance<=this.equatorialRadius)&&(!(t.left.distance<=this.equatorialRadius)&&(!(t.right.distance<=this.equatorialRadius)&&(!(t.top.distance<=this.equatorialRadius)&&(!(t.bottom.distance<=this.equatorialRadius)&&!(t.near.distance<=this.equatorialRadius)))))},p.prototype.intersectsLine=function(t,i){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","intersectWithRay","missingLine"));if(!i)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","intersectsLine","missingResult"));if(this.is2D()){var r,n=t.direction[0],o=t.direction[1],a=t.direction[2],l=t.origin[0],h=t.origin[1],u=t.origin[2];return(0!=a||0==u)&&(r=-u/a,!(r<0)&&(i[0]=l+n*r,i[1]=h+o*r,i[2]=u+a*r,!0))}return d.computeEllipsoidalGlobeIntersection(t,this.equatorialRadius,this.polarRadius,i)},p.prototype.elevationTimestamp=function(){return this.elevationModel.timestamp},p.prototype.minElevation=function(){return this.elevationModel.minElevation},p.prototype.maxElevation=function(){return this.elevationModel.maxElevation},p.prototype.minAndMaxElevationsForSector=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","minAndMaxElevationsForSector","missingSector"));return this.elevationModel.minAndMaxElevationsForSector(t)},p.prototype.elevationAtLocation=function(t,e){return this.elevationModel.elevationAtLocation(t,e)},p.prototype.elevationsForGrid=function(t,i,r,n,o){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","elevationsForSector","missingSector"));if(i<=0||r<=0)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","elevationsForSector","numLat or numLon is less than 1"));if(!o||o.length<i*r)throw new e(s.logMessage(s.LEVEL_SEVERE,"Globe","elevationsForSector","missingArray"));return this.elevationModel.elevationsForGrid(t,i,r,n,o)},p}),i("cache/GpuResourceCache",["../util/AbsentResourceList","../error/ArgumentError","../util/ImageSource","../util/Logger","../cache/MemoryCache","../render/Texture"],function(t,e,i,r,n,o){"use strict";var s=function(i,o){if(!i||i<1)throw new e(r.logMessage(r.LEVEL_SEVERE,"GpuResourceCache","constructor","Specified cache capacity is undefined, 0 or negative."));if(!o||o<0||o>=i)throw new e(r.logMessage(r.LEVEL_SEVERE,"GpuResourceCache","constructor","Specified cache low-water value is undefined, negative or not less than the capacity."));this.entries=new n(i,o),this.cacheKeyPool=0,this.currentRetrievals={},this.absentResourceList=new t(3,6e4)};return Object.defineProperties(s.prototype,{capacity:{get:function(){return this.entries.capacity}},lowWater:{get:function(){return this.entries.lowWater}},usedCapacity:{get:function(){return this.entries.usedCapacity}},freeCapacity:{get:function(){return this.entries.freeCapacity}}}),s.prototype.generateCacheKey=function(){return"GpuResourceCache "+ ++this.cacheKeyPool},s.prototype.putResource=function(t,n,o){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"GpuResourceCache","putResource","missingKey."));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"GpuResourceCache","putResource","missingResource."));if(!o||o<1)throw new e(r.logMessage(r.LEVEL_SEVERE,"GpuResourceCache","putResource","The specified resource size is undefined or less than 1."));var s={resource:n};this.entries.putEntry(t instanceof i?t.key:t,s,o)},s.prototype.resourceForKey=function(t){var e=t instanceof i?this.entries.entryForKey(t.key):this.entries.entryForKey(t);return e?e.resource:null},s.prototype.containsResource=function(t){return this.entries.containsKey(t instanceof i?t.key:t)},s.prototype.removeResource=function(t){this.entries.removeEntry(t instanceof i?t.key:t)},s.prototype.clear=function(){this.entries.clear(!1)},s.prototype.retrieveTexture=function(t,e,n){if(!e)return null;if(e instanceof i){var s=new o(t,e.image,n);return this.putResource(e.key,s,s.size),s}if(this.currentRetrievals[e]||this.absentResourceList.isResourceAbsent(e))return null;var a=this,l=new Image;return l.onload=function(){r.log(r.LEVEL_INFO,"Image retrieval succeeded: "+e);var i=new o(t,l,n);a.putResource(e,i,i.size),delete a.currentRetrievals[e],a.absentResourceList.unmarkResourceAbsent(e);var s=document.createEvent("Event");s.initEvent(WorldWind.REDRAW_EVENT_TYPE,!0,!0),window.dispatchEvent(s)},l.onerror=function(){delete a.currentRetrievals[e],a.absentResourceList.markResourceAbsent(e),r.log(r.LEVEL_WARNING,"Image retrieval failed: "+e)},this.currentRetrievals[e]=e,l.crossOrigin="anonymous",l.src=e,null},s}),i("pick/PickedObjectList",[],function(){"use strict";var t=function(){this.objects=[]};return t.prototype.hasNonTerrainObjects=function(){return this.objects.length>1||1===this.objects.length&&null==this.terrainObject()},t.prototype.terrainObject=function(){for(var t=0,e=this.objects.length;t<e;t++)if(this.objects[t].isTerrain)return this.objects[t];return null},t.prototype.add=function(t){if(t)if(t.isTerrain){for(var e=this.objects.length,i=0,r=this.objects.length;i<r;i++)if(this.objects[i].isTerrain){e=i;break}this.objects[e]=t}else this.objects.push(t)},t.prototype.clear=function(){this.objects=[]},t.prototype.topPickedObject=function(){var t=this.objects.length;if(t>1)for(var e=0;e<t;e++)if(this.objects[[e].isOnTop])return this.objects[e];return t>0?this.objects[0]:null},t}),i("render/ScreenCreditController",["../error/ArgumentError","../shaders/BasicTextureProgram","../util/Color","../util/Font","../util/Logger","../geom/Matrix","../util/Offset","../pick/PickedObject","../render/Renderable","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u){"use strict";var c=function(){this.imageUrls=[],this.stringCredits=[],this.imageCreditSize=64,this.margin=5,this.opacity=.5,this.creditFont=new r(14)};return c.scratchMatrix=o.fromIdentity(),c.imageTransform=o.fromIdentity(),c.texCoordMatrix=o.fromIdentity(),c.prototype.clear=function(){this.imageUrls=[],this.stringCredits=[]},c.prototype.addImageCredit=function(e){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"ScreenCreditController","addImageCredit","missingUrl"));this.imageUrls.indexOf(e)===-1&&this.imageUrls.push(e)},c.prototype.addStringCredit=function(e,r){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"ScreenCreditController","addStringCredit","missingText"));if(!r)throw new t(n.logMessage(n.LEVEL_SEVERE,"ScreenCreditController","addStringCredit","missingColor"));this.stringCredits.indexOf(e)===-1&&this.stringCredits.push({text:e,color:r||i.WHITE})},c.prototype.drawCredits=function(t){if((0!==this.imageUrls.length||0!==this.stringCredits.length)&&!t.pickingMode&&t.timestamp!=this.lastFrameTimestamp){this.lastFrameTimestamp=t.timestamp,this.beginDrawingCredits(t);for(var e,i=t.navigatorState.viewport.width-(this.margin+this.imageCreditSize),r=0,n=0;n<this.imageUrls.length;n++)e=this.drawImageCredit(t,this.imageUrls[n],i,this.margin),e>0&&(i-=this.margin+this.imageCreditSize,r=u.max(e,r));for(var o=r+this.margin,s=0;s<this.stringCredits.length;s++)this.drawStringCredit(t,this.stringCredits[s],o),o+=this.margin+15;this.endDrawingCredits(t)}},c.prototype.beginDrawingCredits=function(t){var i,r=t.currentGlContext;t.findAndBindProgram(e),i=t.currentProgram,r.bindBuffer(r.ARRAY_BUFFER,t.unitQuadBuffer3()),r.vertexAttribPointer(i.vertexPointLocation,3,r.FLOAT,!1,0,0),r.bindBuffer(r.ARRAY_BUFFER,t.unitQuadBuffer()),r.vertexAttribPointer(i.vertexTexCoordLocation,2,r.FLOAT,!1,0,0),r.enableVertexAttribArray(i.vertexPointLocation),r.enableVertexAttribArray(i.vertexTexCoordLocation),i.loadTextureUnit(r,r.TEXTURE0),i.loadModulateColor(r,!1)},c.prototype.endDrawingCredits=function(t){var e=t.currentGlContext,i=t.currentProgram;e.disableVertexAttribArray(i.vertexPointLocation),e.disableVertexAttribArray(i.vertexTexCoordLocation),e.bindBuffer(e.ARRAY_BUFFER,null),e.bindTexture(e.TEXTURE_2D,null),e.enable(e.DEPTH_TEST)},c.prototype.drawImageCredit=function(t,e,r,n){var o,s,a,l,h,u;return(l=t.gpuResourceCache.resourceForKey(e))?(o=l.imageWidth,s=l.imageHeight,a=o<=this.imageCreditSize&&this.imageHeight<=this.imageCreditSize?1:o>=s?this.imageCreditSize/o:this.imageCreditSize/s,c.imageTransform.setTranslation(r,n,0),c.imageTransform.setScale(a*o,a*s,1),h=t.currentGlContext,u=t.currentProgram,c.scratchMatrix.copy(t.screenProjection),c.scratchMatrix.multiplyMatrix(c.imageTransform),u.loadModelviewProjection(h,c.scratchMatrix),u.loadTextureEnabled(h,!0),u.loadColor(h,i.WHITE),u.loadOpacity(h,this.opacity),c.texCoordMatrix.setToIdentity(),c.texCoordMatrix.multiplyByTextureTransform(l),u.loadTextureMatrix(h,c.texCoordMatrix),l.bind(t)&&h.drawArrays(h.TRIANGLE_STRIP,0,4),s):(t.gpuResourceCache.retrieveTexture(t.currentGlContext,e),0)},c.prototype.drawStringCredit=function(t,e,i){var r,n,o,s,a,l,h;return s=e.text+this.creditFont.toString(),o=t.gpuResourceCache.resourceForKey(s),o||(o=t.textSupport.createTexture(t,e.text,this.creditFont,!1),t.gpuResourceCache.putResource(s,o,o.size)),r=o.imageWidth,n=o.imageHeight,h=t.navigatorState.viewport.width-(r+this.margin),c.imageTransform.setTranslation(h,i,0),c.imageTransform.setScale(r,n,1),a=t.currentGlContext,l=t.currentProgram,c.scratchMatrix.copy(t.screenProjection),c.scratchMatrix.multiplyMatrix(c.imageTransform),l.loadModelviewProjection(a,c.scratchMatrix),l.loadTextureEnabled(a,!0),l.loadColor(a,e.color),l.loadOpacity(a,this.opacity),c.texCoordMatrix.setToIdentity(),c.texCoordMatrix.multiplyByTextureTransform(o),l.loadTextureMatrix(a,c.texCoordMatrix),o.bind(t)&&a.drawArrays(a.TRIANGLE_STRIP,0,4),!0},c}),i("shapes/ShapeAttributes",["../util/Color","../util/ImageSource"],function(t,e){"use strict";var i=function(e){this._drawInterior=!e||e._drawInterior,this._drawOutline=!e||e._drawOutline,this._enableLighting=!!e&&e._enableLighting,this._interiorColor=e?e._interiorColor:t.WHITE,this._outlineColor=e?e._outlineColor:t.RED,this._outlineWidth=e?e._outlineWidth:1,this._outlineStippleFactor=e?e._outlineStippleFactor:0,this._outlineStipplePattern=e?e._outlineStipplePattern:61680,this._imageSource=e?e._imageSource:null,this._depthTest=!e||e._depthTest,this._drawVerticals=!!e&&e._drawVerticals,this._applyLighting=!!e&&e._applyLighting,this.stateKeyInvalid=!0};return i.prototype.computeStateKey=function(){return"di "+this._drawInterior+" do "+this._drawOutline+" el "+this._enableLighting+" ic "+this._interiorColor.toHexString(!0)+" oc "+this._outlineColor.toHexString(!0)+" ow "+this._outlineWidth+" osf "+this._outlineStippleFactor+" osp "+this._outlineStipplePattern+" is "+(this._imageSource?this.imageSource instanceof e?this.imageSource.key:this.imageSource:"null")+" dt "+this._depthTest+" dv "+this._drawVerticals+" li "+this._applyLighting},Object.defineProperties(i.prototype,{stateKey:{get:function(){return this.stateKeyInvalid&&(this._stateKey=this.computeStateKey(),this.stateKeyInvalid=!1),this._stateKey}},drawInterior:{get:function(){return this._drawInterior},set:function(t){this._drawInterior=t,this.stateKeyInvalid=!0}},drawOutline:{get:function(){return this._drawOutline},set:function(t){this._drawOutline=t,this.stateKeyInvalid=!0}},enableLighting:{get:function(){return this._enableLighting},set:function(t){this._enableLighting=t,this.stateKeyInvalid=!0}},interiorColor:{get:function(){return this._interiorColor},set:function(t){this._interiorColor=t,this.stateKeyInvalid=!0}},outlineColor:{get:function(){return this._outlineColor},set:function(t){this._outlineColor=t,this.stateKeyInvalid=!0}},outlineWidth:{get:function(){return this._outlineWidth},set:function(t){this._outlineWidth=t,this.stateKeyInvalid=!0}},outlineStipplePattern:{get:function(){return this._outlineStipplePattern},set:function(t){this._outlineStipplePattern=t,this.stateKeyInvalid=!0}},outlineStippleFactor:{get:function(){return this._outlineStippleFactor},set:function(t){this._outlineStippleFactor=t,this.stateKeyInvalid=!0}},imageSource:{get:function(){return this._imageSource},set:function(t){this._imageSource=t,this.stateKeyInvalid=!0}},depthTest:{get:function(){return this._depthTest},set:function(t){this._depthTest=t,this.stateKeyInvalid=!0}},drawVerticals:{get:function(){return this._drawVerticals},set:function(t){this._drawVerticals=t,this.stateKeyInvalid=!0}},applyLighting:{get:function(){return this._applyLighting},set:function(t){this._applyLighting=t,this.stateKeyInvalid=!0}}}),i}),i("shapes/SurfaceShape",["../error/AbstractError","../geom/Angle","../error/ArgumentError","../geom/Location","../util/Logger","../error/NotYetImplementedError","../pick/PickedObject","../render/Renderable","../geom/Sector","../shapes/ShapeAttributes","../error/UnsupportedOperationError","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c){"use strict";var d=function(t){a.call(this),this._displayName="Surface Shape",this._attributes=t?t:new h(null),this._highlightAttributes=null,this._highlighted=!1,this._enabled=!0,this._pathType=WorldWind.GREAT_CIRCLE,this._maximumNumEdgeIntervals=d.DEFAULT_NUM_EDGE_INTERVALS,this._polarThrottle=d.DEFAULT_POLAR_THROTTLE,this._sector=null,this.pickDelegate=null,this._sectors=[],this._locations=null,this._boundaries=null,this._interiorGeometry=null,this._outlineGeometry=null,this._isInteriorInhibited=!1,this.stateKeyInvalid=!0,this._attributesStateKey=null,this.isPrepared=!1,this.layer=null,this.pickColor=null};return d.prototype=Object.create(a.prototype),Object.defineProperties(d.prototype,{stateKey:{get:function(){if(this._attributesStateKey){var t=null;this._highlighted?this._highlightAttributes&&(t=this._highlightAttributes.stateKey):this._attributes&&(t=this._attributes.stateKey),t!=this._attributesStateKey&&(this._attributesStateKey=t,this.stateKeyInvalid=!0)}else this._highlighted?this._highlightAttributes&&(this._attributesStateKey=this._highlightAttributes.stateKey):this._attributes&&(this._attributesStateKey=this._attributes.stateKey),this._attributesStateKey&&(this.stateKeyInvalid=!0);return this.stateKeyInvalid&&(this._stateKey=this.computeStateKey()),this._stateKey}},displayName:{get:function(){return this._displayName},set:function(t){this.stateKeyInvalid=!0,this._displayName=t}},attributes:{get:function(){return this._attributes},set:function(t){this.stateKeyInvalid=!0,this._attributes=t,this._attributesStateKey=t.stateKey}},highlightAttributes:{get:function(){return this._highlightAttributes},set:function(t){this.stateKeyInvalid=!0,this._highlightAttributes=t}},highlighted:{get:function(){return this._highlighted},set:function(t){this.stateKeyInvalid=!0,this._highlighted=t}},enabled:{get:function(){return this._enabled},set:function(t){this.stateKeyInvalid=!0,this._enabled=t}},pathType:{get:function(){return this._pathType},set:function(t){this.stateKeyInvalid=!0,this._pathType=t}},maximumNumEdgeIntervals:{get:function(){return this._maximumNumEdgeIntervals},set:function(t){this.stateKeyInvalid=!0,this._maximumNumEdgeIntervals=t}},polarThrottle:{get:function(){return this._polarThrottle},set:function(t){this.stateKeyInvalid=!0,this._polarThrottle=t}},sector:{get:function(){return this._sector}}}),d.staticStateKey=function(t){return t.stateKeyInvalid=!1,t.highlighted&&t._highlightAttributes?t._attributesStateKey=t._highlightAttributes.stateKey:t._attributes?t._attributesStateKey=t._attributes.stateKey:t._attributesStateKey=null,"dn "+t.displayName+" at "+(t._attributesStateKey?t._attributesStateKey:"null")+" hi "+t.highlighted+" en "+t.enabled+" pt "+t.pathType+" ne "+t.maximumNumEdgeIntervals+" po "+t.polarThrottle+" se ["+t.sector.minLatitude+","+t.sector.maxLatitude+","+t.sector.minLongitude+","+t.sector.maxLongitude+"]"},d.prototype.computeStateKey=function(){return d.staticStateKey(this)},d.prototype.area=function(t,e){throw new o(n.logMessage(n.LEVEL_SEVERE,"SurfaceShape","area","notYetImplemented"))},d.prototype.computeBoundaries=function(e){throw new t(n.logMessage(n.LEVEL_SEVERE,"SurfaceShape","computeBoundaries","abstractInvocation"))},d.prototype.render=function(t){this.enabled&&(this.layer=t.currentLayer,this.prepareBoundaries(t),t.surfaceShapeTileBuilder.insertSurfaceShape(this));
},d.prototype.interpolateLocations=function(t){var e,i,r,n=t[0],o=n,s=!0,a=!0,l=0,h=!0;for(this._locations=[n],i=1,r=t.length;i<r;i+=1)e=o,a=s,o=t[i],s=o.latitude==n.latitude&&o.longitude==n.longitude,h=!0,(s||a)&&(l+=1,l>2&&(h=!1)),h&&this.interpolateEdge(e,o,this._locations),this._locations.push(o),e=o;this._isInteriorInhibited||e.latitude==n.latitude&&e.longitude==n.longitude||(this.interpolateEdge(e,n,this._locations),this._locations.push(n))},d.prototype.interpolateEdge=function(t,e,i){var n,o,s=r.greatCircleDistance(t,e),a=Math.round(this._maximumNumEdgeIntervals*s/Math.PI);if(a>0){n=1/a,o=t;for(var l=this.throttledStep(n,o);l<1;l+=this.throttledStep(n,o))o=new r(0,0),r.interpolateAlongPath(this._pathType,l,t,e,o),i.push(o)}},d.prototype.throttledStep=function(t,i){var r=Math.cos(i.latitude*e.DEGREES_TO_RADIANS);r*=r;var n=this._polarThrottle/(1+this._polarThrottle);return t*(1-n+n*r)},d.prototype.prepareBoundaries=function(t){this.isPrepared||(this._boundaries||this.computeBoundaries(t),this._locations||this.interpolateLocations(this._boundaries),this.prepareGeometry(t),this.prepareSectors(),this.isPrepared=!0)},d.prototype.computeSectors=function(t){return this._sectors&&this._sectors.length>0?this._sectors:(this.prepareBoundaries(t),this._sectors)},d.prototype.prepareSectors=function(){var t=this._boundaries;if(t){this._sector=new l(-90,90,-180,180),this._sector.setToBoundingSector(t);var e=this.containsPole(t);if(e!=r.poles.NONE?(e==r.poles.NORTH?this._sector=new l(this._sector.minLatitude,90,-180,180):this._sector=new l(-90,this._sector.maxLatitude,-180,180),this._sectors=[this._sector]):r.locationsCrossDateLine(t)?this._sectors=l.splitBoundingSectors(t):this._sector.isEmpty()||(this._sectors=[this._sector]),this._sectors&&this._pathType===WorldWind.GREAT_CIRCLE)for(var i=0,n=this._sectors.length;i<n;i+=1){var o=this._sectors[i],s=r.greatCircleArcExtremeLocations(t),a=Math.min(o.minLatitude,s[0].latitude),h=Math.max(o.maxLatitude,s[1].latitude);this._sectors[i]=new l(a,h,o.minLongitude,o.maxLongitude)}}},d.prototype.prepareGeometry=function(t){var e;this._interiorGeometry=[],this._outlineGeometry=[];var i=this._locations,n=this.containsPole(i);if(n!=r.poles.NONE){var o=this.cutAlongDateLine(i,n,t.globe);this._interiorGeometry.push(o),e=this.repeatAroundDateline(i),this._outlineGeometry.push(e[0]),e.length>1&&this._outlineGeometry.push(e[1])}else r.locationsCrossDateLine(i)?(e=this.repeatAroundDateline(i),this._interiorGeometry.push(e[0]),this._interiorGeometry.push(e[1]),this._outlineGeometry.push(e[0]),this._outlineGeometry.push(e[1])):(this._interiorGeometry.push(i),this._outlineGeometry.push(i))},d.prototype.containsPole=function(t){for(var e=!1,i=90,n=-90,o=t[0],s=1,a=t.length;s<a;s+=1){var l=t[s];r.locationsCrossDateLine([o,l])&&(e=!e),i=Math.min(i,l.latitude),n=Math.max(n,l.latitude),o=l}var h=t[0];return r.locationsCrossDateLine([h,o])&&(e=!e),e?i>0?r.poles.NORTH:n<0?r.poles.SOUTH:Math.abs(n)>=Math.abs(i)?r.poles.NORTH:r.poles.SOUTH:r.poles.NONE},d.prototype.cutAlongDateLine=function(t,e,i){if(e==r.poles.NONE)return t;for(var n=[],o=e==r.poles.NORTH?90:-90,s=t[t.length-1],a=0,l=t.length;a<l;a+=1){var h=t[a];if(n.push(s),r.locationsCrossDateLine([s,h])){var u=r.intersectionWithMeridian(s,h,180,i),d=c.signum(s.longitude),p=u,f=180*d,g=-f;n.push(new r(p,f)),n.push(new r(o,f)),n.push(new r(o,g)),n.push(new r(p,g))}s=h}return n.push(s),n},d.prototype.repeatAroundDateline=function(t){var e=0,i=!1,n=[],o=t[0];n.push(o);for(var s=1,a=t.length;s<a;s+=1){var l=t[s];r.locationsCrossDateLine([o,l])&&(0==e&&(e=o.longitude<0?-360:360),i=!i),i?n.push(new r(l.latitude,l.longitude+e)):n.push(l),o=l}var h=[n];if(0!=e){var u=n;for(n=[],s=0,a=u.length;s<a;s+=1){var c=u[s];n.push(new r(c.latitude,c.longitude-e))}h.push(n)}return h},d.prototype.resetPickColor=function(){this.pickColor=null},d.prototype.renderToTexture=function(t,e,i,r,n,o){var a,l,h,u,c=[],d=t.pickingMode,p=this._highlighted?this._highlightAttributes||this._attributes:this._attributes;if(d&&!this.pickColor&&(this.pickColor=t.uniquePickColor()),!this._isInteriorInhibited&&p.drawInterior)for(e.fillStyle=d?this.pickColor.toRGBAString():p.interiorColor.toRGBAString(),a=0,l=this._interiorGeometry.length;a<l;a+=1)if(h=0,u=2*this._outlineGeometry[a].length,c.splice(0,c.length),this.transformPath(this._interiorGeometry[a],i,r,n,o,c)){for(e.beginPath(),e.moveTo(c[h++],c[h++]);h<u;)e.lineTo(c[h++],c[h++]);e.closePath(),e.fill()}if(p.drawOutline&&p.outlineWidth>0){e.lineWidth=4*p.outlineWidth,e.strokeStyle=d?this.pickColor.toRGBAString():p.outlineColor.toRGBAString();this._attributes.outlineStipplePattern,this._attributes.outlineStippleFactor;for(a=0,l=this._outlineGeometry.length;a<l;a+=1)if(c.splice(0,c.length),this.transformPath(this._outlineGeometry[a],i,r,n,o,c)){var f=c[0],g=c[1],m=f,E=g,y=f,_=g,v=!0,b=!0,S=0;for(h=2,u=c.length;h<u;)m=y,E=_,v=b,y=c[h++],_=c[h++],b=y==f&&_==g,(v||b)&&(S+=1,S>2)||(e.beginPath(),e.moveTo(m,E),e.lineTo(y,_),e.stroke())}}if(d){var T=new s(this.pickColor.clone(),this.pickDelegate?this.pickDelegate:this,null,this.layer,!1);t.resolvePick(T)}},d.prototype.transformPath=function(t,e,i,r,n,o){var s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b,S,T,L,w,x=4;for(T=0,S=t[0],u=S.longitude*e+r,c=S.latitude*i+n,b=!0,f=m=s=l=u,g=E=a=h=c,o[T++]=l,o[T++]=h,L=1,w=t.length;L<w;L+=1)S=t[L],d=l,p=h,l=S.longitude*e+r,h=S.latitude*i+n,b=l==u&&h==c,y=l-s,_=h-a,v=y*y+_*_,(b||v>=x)&&(f=Math.min(f,l),m=Math.max(m,l),g=Math.min(g,h),E=Math.max(E,h),o[T-2]==d&&o[T-1]==p||(o[T++]=d,o[T++]=p),o[T++]=l,o[T++]=h,s=l,a=h);return m-f>=2||E-g>=2},d.DEFAULT_NUM_EDGE_INTERVALS=128,d.DEFAULT_POLAR_THROTTLE=10,d}),i("shapes/SurfaceShapeTile",["../geom/Angle","../error/ArgumentError","../util/Level","../util/Logger","../geom/Sector","../render/Texture","../render/TextureTile"],function(t,e,i,r,n,o,s){"use strict";var a=function(t,e,i,r){s.call(this,t,e,i,r),this.surfaceShapes=[],this.sector=t,this.cacheKey=null,this.pickSequence=0,this.surfaceShapeStateKeys=[],this.prevSurfaceShapes=[],this.createCtx2D()};return a.prototype=Object.create(s.prototype),a.prototype.clearShapes=function(){var t=this.prevSurfaceShapes;this.prevSurfaceShapes=this.surfaceShapes,this.surfaceShapes=t,this.surfaceShapes.splice(0,this.surfaceShapes.length)},a.prototype.hasShapes=function(){return this.surfaceShapes.length>0},a.prototype.getShapes=function(){return this.surfaceShapes},a.prototype.setShapes=function(t){this.surfaceShapes=t},a.prototype.getSector=function(){return this.sector},a.prototype.addSurfaceShape=function(t){this.surfaceShapes.push(t),this.surfaceShapeStateKeys.push(t.stateKey)},a.prototype.addAllSurfaceShapes=function(t){for(var e=0,i=t.length;e<i;e+=1){var r=t[e];this.addAllSurfaceShapes(r)}},a.prototype.needsUpdate=function(t){var e,i,r,n;if(this.prevSurfaceShapes.length!=this.surfaceShapes.length)return!0;for(e=0,i=this.prevSurfaceShapes.length;e<i;e+=1)if(r=this.prevSurfaceShapes[e],this.surfaceShapes.indexOf(r)<0)return!0;for(e=0,i=this.surfaceShapes.length;e<i;e+=1)if(r=this.surfaceShapes[e],this.prevSurfaceShapes.indexOf(r)<0)return!0;for(e=0,i=this.surfaceShapes.length;e<i;e+=1)if(r=this.surfaceShapes[e],n=this.surfaceShapeStateKeys[e],n!=r.stateKey)return!0;return!this.hasTexture(t)},a.prototype.hasTexture=function(t){if(t.pickingMode)return!1;var e=t.gpuResourceCache;this.gpuCacheKey||(this.gpuCacheKey=this.getCacheKey());var i=e.resourceForKey(this.gpuCacheKey);return!!i},a.prototype.updateTexture=function(t){var e=t.currentGlContext,i=a.canvas;i.width=this.tileWidth,i.height=this.tileHeight;for(var r=a.ctx2D,n=this.tileWidth/this.sector.deltaLongitude(),s=-this.tileHeight/this.sector.deltaLatitude(),l=-this.sector.minLongitude*n,h=-this.sector.maxLatitude*s,u=0,c=this.surfaceShapes.length;u<c;u+=1){var d=this.surfaceShapes[u];this.surfaceShapeStateKeys[u]=d.stateKey,d.renderToTexture(t,r,n,s,l,h)}var p=new o(e,i),f=t.gpuResourceCache;return this.gpuCacheKey=this.getCacheKey(),f.putResource(this.gpuCacheKey,p,p.size),p},a.prototype.getCacheKey=function(){return this.cacheKey||(this.cacheKey="SurfaceShapeTile:"+this.tileKey+","+this.pickSequence.toString()),this.cacheKey},a.prototype.createCtx2D=function(){a.ctx2D||(a.canvas=document.createElement("canvas"),a.ctx2D=a.canvas.getContext("2d"))},a.canvas=null,a.ctx2D=null,a}),i("shapes/SurfaceShapeTileBuilder",["../error/ArgumentError","../render/DrawContext","../globe/Globe","../shaders/GpuProgram","../util/Level","../util/LevelSet","../geom/Location","../util/Logger","../geom/Matrix","../cache/MemoryCache","../navigate/NavigatorState","../error/NotYetImplementedError","../pick/PickedObject","../geom/Rectangle","../geom/Sector","../shapes/SurfaceShape","../shapes/SurfaceShapeTile","../globe/Terrain","../globe/TerrainTile","../globe/TerrainTileList","../render/TextureTile","../util/Tile"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b){"use strict";var S=function(){this.numRowsTilesInTopLevel=4,this.numColumnsTilesInTopLevel=8,this.maximumSubdivisionDepth=15,this.tileWidth=256,this.tileHeight=256,this.levels=new o(f.FULL_SPHERE,new s(180/this.numRowsTilesInTopLevel,360/this.numColumnsTilesInTopLevel),this.maximumSubdivisionDepth,this.tileWidth,this.tileHeight),this.surfaceShapes=[],this.surfaceShapeTiles=[],this.topLevelTiles=[],this.sector=new f(-90,90,-180,180),this.detailControl=1.25,this.tileCache=new h(5e5,4e5)};return S.prototype.clear=function(){this.surfaceShapeTiles.splice(0,this.surfaceShapeTiles.length),this.surfaceShapes.splice(0,this.surfaceShapes.length)},S.prototype.insertSurfaceShape=function(t){this.surfaceShapes.push(t)},S.prototype.doRender=function(t){if(t.pickingMode){for(var e=0,i=this.surfaceShapes.length;e<i;e+=1)this.surfaceShapes[e].resetPickColor();S.pickSequence+=1;var r=this.surfaceShapeTiles,n=this.topLevelTiles;this.surfaceShapeTiles=[],this.topLevelTiles=[],this.buildTiles(t),t.deepPicking?this.doDeepPickingRender(t):t.surfaceTileRenderer.renderTiles(t,this.surfaceShapeTiles,1),this.surfaceShapeTiles=r,this.topLevelTiles=n}else this.buildTiles(t),t.surfaceTileRenderer.renderTiles(t,this.surfaceShapeTiles,1)},S.prototype.doDeepPickingRender=function(t){var e,i,r,n,o,s,a,l,h,u=[];for(o=0,s=t.objectsAtPickPoint.objects.length;o<s;o+=1)a=t.objectsAtPickPoint.objects[o],a.userObject instanceof g&&(l=a.userObject,u.indexOf(l)<0&&(u.push(l),t.objectsAtPickPoint.objects.splice(o,1),o-=1,s-=1));if(!(u.length<=0)){var c=[];for(r=0,n=u.length;r<n;r+=1){for(l=u[r],e=0,i=this.surfaceShapeTiles.length;e<i;e+=1)h=this.surfaceShapeTiles[e],h.setShapes([l]),h.updateTexture(t);t.surfaceTileRenderer.renderTiles(t,this.surfaceShapeTiles,1);var p=t.readPickColor(t.pickPoint);p&&l.pickColor.equals(p)&&(a=new d(l.pickColor.clone(),l.pickDelegate?l.pickDelegate:l,null,l.layer,!1),c.push(a))}for(o=0,s=t.objectsAtPickPoint.objects.length;o<s;o+=1)a=t.objectsAtPickPoint.objects[o],a.userObject instanceof g&&(t.objectsAtPickPoint.objects.splice(o,1),o-=1,s-=1);for(o=0,s=c.length;o<s;o+=1)a=c[o],t.objectsAtPickPoint.objects.push(a)}},S.prototype.buildTiles=function(e){if(!e)throw new t(a.logMessage(a.LEVEL_SEVERE,"SurfaceShapeTileBuilder","buildTiles","missingDc"));if(this.surfaceShapes&&!(this.surfaceShapes.length<1)){this.assembleTiles(e),this.surfaceShapes.splice(0,this.surfaceShapes.length);for(var i=0,r=this.surfaceShapeTiles.length;i<r;i+=1){var n=this.surfaceShapeTiles[i];n.clearShapes()}}},S.prototype.assembleTiles=function(t){var e,i,r,n,o,s,a;this.topLevelTiles.length<1&&this.createTopLevelTiles();var l={};for(i=0,r=this.surfaceShapes.length;i<r;i+=1){var h=this.surfaceShapes[i],u=h.computeSectors(t);if(u)for(s=0,a=u.length;s<a;s+=1){var c=u[s];for(n=0,o=this.topLevelTiles.length;n<o;n+=1)if(e=this.topLevelTiles[n],e.sector.intersects(c)){var d=e.tileKey;l[d]=e,e.addSurfaceShape(h)}}}for(var p in l)l.hasOwnProperty(p)&&(e=l[p],this.addTileOrDescendants(t,this.levels,null,e))},S.prototype.addTileOrDescendants=function(t,e,i,r){if(!this.intersectsFrustum(t,r))return void r.clearShapes();if(null!=i&&this.addIntersectingShapes(t,i,r),r.hasShapes()){if(this.meetsRenderCriteria(t,e,r))return void this.addTile(t,r);for(var n=e.level(r.level.levelNumber+1),o=t.pickingMode?r.subdivide(n,this):r.subdivideToCache(n,this,this.tileCache),s=0,a=o.length;s<a;s+=1){var l=o[s];this.addTileOrDescendants(t,e,r,l)}r.clearShapes()}},S.prototype.addIntersectingShapes=function(t,e,i){if(e.hasShapes()&&i.sector.intersects(e.sector))if(i.getSector().contains(e.sector))i.addAllSurfaceShapes(e.getShapes());else for(var r=e.getShapes(),n=0,o=r.length;n<o;n+=1){var s=r[n],a=s.computeSectors(t);if(a)for(var l=0,h=a.length;l<h;l+=1){var u=a[l];if(i.getSector().intersects(u)){i.addSurfaceShape(s);break}}}},S.prototype.addTile=function(t,e){t.pickingMode&&(e.pickSequence=S.pickSequence),e.needsUpdate(t)&&e.updateTexture(t),this.surfaceShapeTiles.push(e)},S.prototype.createTile=function(t,e,i,r){return new m(t,e,i,r)},S.prototype.createTopLevelTiles=function(){b.createTilesForLevel(this.levels.firstLevel(),this,this.topLevelTiles)},S.prototype.intersectsFrustum=function(t,e){return!(t.globe.projectionLimits&&!e.sector.overlaps(t.globe.projectionLimits))&&(e.update(t),e.extent.intersectsFrustum(t.pickingMode?t.pickFrustum:t.navigatorState.frustumInModelCoordinates))},S.prototype.meetsRenderCriteria=function(t,e,i){return i.level.levelNumber==e.lastLevel().levelNumber||!i.mustSubdivide(t,this.detailControl)},S.pickSequence=0,S}),i("shaders/SurfaceTileRendererProgram",["../error/ArgumentError","../util/Color","../shaders/GpuProgram","../util/Logger"],function(t,e,i,r){"use strict";var n=function(t){var e="attribute vec4 vertexPoint;\nattribute vec4 vertexTexCoord;\nuniform mat4 mvpMatrix;\nuniform mat4 texSamplerMatrix;\nuniform mat4 texMaskMatrix;\nvarying vec2 texSamplerCoord;\nvarying vec2 texMaskCoord;\nvoid main() {\ngl_Position = mvpMatrix * vertexPoint;\ntexSamplerCoord = (texSamplerMatrix * vertexTexCoord).st;\ntexMaskCoord = (texMaskMatrix * vertexTexCoord).st;\n}",r="precision mediump float;\nuniform sampler2D texSampler;\nuniform float opacity;\nuniform vec4 color;\nuniform bool modulateColor;\nvarying vec2 texSamplerCoord;\nvarying vec2 texMaskCoord;\nbool isInsideTextureImage(const vec2 coord) {\n    return coord.x >= 0.0 && coord.x <= 1.0 && coord.y >= 0.0 && coord.y <= 1.0;\n}\nvoid main(void) {\nfloat mask = float(isInsideTextureImage(texMaskCoord));if (modulateColor) {\n    gl_FragColor = color * mask * floor(texture2D(texSampler, texSamplerCoord).a + 0.5);\n} else {\n    gl_FragColor = texture2D(texSampler, texSamplerCoord) * mask * opacity;\n}\n}";i.call(this,t,e,r),this.vertexPointLocation=this.attributeLocation(t,"vertexPoint"),this.vertexTexCoordLocation=this.attributeLocation(t,"vertexTexCoord"),this.mvpMatrixLocation=this.uniformLocation(t,"mvpMatrix"),this.colorLocation=this.uniformLocation(t,"color"),this.modulateColorLocation=this.uniformLocation(t,"modulateColor"),this.texSamplerMatrixLocation=this.uniformLocation(t,"texSamplerMatrix"),this.texMaskMatrixLocation=this.uniformLocation(t,"texMaskMatrix"),this.texSamplerLocation=this.uniformLocation(t,"texSampler"),this.opacityLocation=this.uniformLocation(t,"opacity"),this.vertexPointLocation=-1};return n.key="WorldWindGpuSurfaceTileRenderingProgram",n.prototype=Object.create(i.prototype),n.prototype.loadModelviewProjection=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"SurfaceTileRendererProgram","loadModelviewProjection","missingMatrix"));this.loadUniformMatrix(e,i,this.mvpMatrixLocation)},n.prototype.loadTexSamplerMatrix=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"SurfaceTileRendererProgram","loadTexSamplerMatrix","missingMatrix"));this.loadUniformMatrix(e,i,this.texSamplerMatrixLocation)},n.prototype.loadTexMaskMatrix=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"SurfaceTileRendererProgram","loadTexMaskMatrix","missingMatrix"));this.loadUniformMatrix(e,i,this.texMaskMatrixLocation)},n.prototype.loadTexSampler=function(t,e){t.uniform1i(this.texSamplerLocation,e-WebGLRenderingContext.TEXTURE0)},n.prototype.loadOpacity=function(t,e){t.uniform1f(this.opacityLocation,e)},n.prototype.loadColor=function(e,i){if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"SurfaceTileRendererProgram","loadColor","missingColor"));this.loadUniformColor(e,i,this.colorLocation)},n.prototype.loadModulateColor=function(t,e){t.uniform1i(this.modulateColorLocation,e?1:0)},n}),i("render/SurfaceTileRenderer",["../error/ArgumentError","../util/Logger","../geom/Matrix","../shapes/SurfaceShapeTile","../shaders/SurfaceTileRendererProgram"],function(t,e,i,r,n){"use strict";var o=function(){this.texMaskMatrix=i.fromIdentity(),this.texSamplerMatrix=i.fromIdentity(),this.isSurfaceShapeTileRendering=!1};return o.prototype.renderTiles=function(i,n,o,s){if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfaceTileRenderer","renderTiles","Specified surface tiles array is null or undefined."));if(!(n.length<1)){var a,l,h,u,c=i.terrain,d=i.currentGlContext,p=0,f=1;if(c){this.isSurfaceShapeTileRendering=n[0]instanceof r,o*=i.surfaceOpacity,a=this.beginRendering(i,o),c.beginRendering(i);try{for(var g=0,m=c.surfaceGeometry.length;g<m;g++){l=c.surfaceGeometry[g],h=l.sector,c.beginRenderingTile(i,l);try{for(var E=0,y=n.length;E<y;E++)u=n[E],u.sector.overlaps(h)&&u.bind(i)&&(i.pickingMode?u.pickColor&&a.loadColor(d,u.pickColor):s&&u.opacity!=f&&(a.loadOpacity(d,o*u.opacity),f=u.opacity),this.applyTileState(i,l,u),c.renderTile(i,l),++p)}catch(t){console.log(t)}finally{c.endRenderingTile(i,l)}}}catch(t){console.log(t)}finally{c.endRendering(i),this.endRendering(i),i.frameStatistics.incrementRenderedTileCount(p)}}}},o.prototype.beginRendering=function(t,e){var i=t.currentGlContext,r=t.findAndBindProgram(n);return r.loadTexSampler(i,i.TEXTURE0),t.pickingMode&&!this.isSurfaceShapeTileRendering?r.loadModulateColor(i,!0):(r.loadModulateColor(i,!1),r.loadOpacity(i,e)),r},o.prototype.endRendering=function(t){var e=t.currentGlContext;e.bindTexture(e.TEXTURE_2D,null)},o.prototype.applyTileState=function(t,e,i){var r=t.currentGlContext,n=t.currentProgram,o=e.sector,s=o.deltaLatitude(),a=o.deltaLongitude(),l=i.sector,h=l.deltaLatitude(),u=l.deltaLongitude(),c=h>0?h:1,d=u>0?u:1,p=a/d,f=s/c,g=-(l.minLongitude-o.minLongitude)/d,m=-(l.minLatitude-o.minLatitude)/c;this.texMaskMatrix.set(p,0,0,g,0,f,0,m,0,0,1,0,0,0,0,1),this.texSamplerMatrix.setToUnitYFlip(),i.applyInternalTransform(t,this.texSamplerMatrix),this.texSamplerMatrix.multiplyMatrix(this.texMaskMatrix),n.loadTexSamplerMatrix(r,this.texSamplerMatrix),n.loadTexMaskMatrix(r,this.texMaskMatrix)},o}),i("render/TextSupport",["../error/ArgumentError","../shaders/BasicTextureProgram","../util/Color","../util/Logger","../geom/Matrix","../render/Texture","../geom/Vec2"],function(t,e,i,r,n,o,s){"use strict";var a=function(){this.canvas2D=document.createElement("canvas"),this.ctx2D=this.canvas2D.getContext("2d"),this.lineSpacing=.15,this.strokeStyle="rgba(0, 0, 0, 0.5)",this.strokeWidth=4};return a.prototype.textSize=function(t,e,i){if(0===t.length)return new s(0,0);this.ctx2D.font=e.fontString;for(var r=t.split("\n"),n=r.length*(e.size*(1+this.lineSpacing)),o=0,a=0;a<r.length;a++)o=Math.max(o,this.ctx2D.measureText(r[a]).width);return i&&(o+=this.strokeWidth,n+=this.strokeWidth),new s(o,n)},a.prototype.createTexture=function(t,e,r,n){var s=t.currentGlContext,a=this.ctx2D,l=this.canvas2D,h=this.textSize(e,r,n),u=e.split("\n"),c=n?this.strokeWidth/2:0,d=t.pixelScale;l.width=Math.ceil(h[0])*d,l.height=Math.ceil(h[1])*d,a.scale(d,d),a.font=r.fontString,a.textBaseline="top",a.textAlign=r.horizontalAlignment,a.fillStyle=i.WHITE.toHexString(!1),a.strokeStyle=this.strokeStyle,a.lineWidth=this.strokeWidth,a.lineCap="round",a.lineJoin="round","left"===r.horizontalAlignment?a.translate(c,0):"right"===r.horizontalAlignment?a.translate(h[0]-c,0):a.translate(h[0]/2,0);for(var p=0;p<u.length;p++)n&&a.strokeText(u[p],0,0),a.fillText(u[p],0,0),a.translate(0,r.size*(1+this.lineSpacing)+c);return new o(s,l)},a.prototype.getMaxLineHeight=function(t){return this.textSize("_É",t,0)[1]},a.prototype.wrap=function(e,i,n,o){if(!e)throw new t(r.logMessage(r.WARNING,"TextSupport","wrap","missing text"));var s,a=e.split("\n"),l="";for(s=0;s<a.length;s++)a[s]=this.wrapLine(a[s],i,o);var h=0,u=!1,c=this.getMaxLineHeight(o);for(s=0;s<a.length&&!u;s++){for(var d=a[s].split("\n"),p=0;p<d.length&&!u;p++)n<=0||h+c<=n?(l+=d[p],h+=c+this.lineSpacing,p<d.length-1&&(l+="\n")):u=!0;s<a.length-1&&!u&&(l+="\n")}return u&&(l.length>0&&(l=l.substring(0,l.length-1)),l+="..."),l},a.prototype.wrapLine=function(t,e,i){var r="",n=t.trim(),o=this.textSize(n,i,0);if(o[0]>e){for(var s="",a=0,l=n.indexOf(" ",a+1);a<n.length;){l==-1&&(l=n.length);var h=n.substring(a,l),u=s+h;this.textSize(u,i,0)[0]<=e?s+=h:0!=s.length?(r+=s,r+="\n",s="",s+=h.trim()):s+=h.trim(),a=l,a<n.length-1&&(l=n.indexOf(" ",a+1))}r+=s}else r+=n;return r},a}),i("render/DrawContext",["../error/ArgumentError","../util/Color","../util/FrameStatistics","../render/FramebufferTexture","../render/FramebufferTileController","../geom/Frustum","../globe/Globe","../shaders/GpuProgram","../cache/GpuResourceCache","../layer/Layer","../util/Logger","../geom/Matrix","../navigate/NavigatorState","../pick/PickedObjectList","../geom/Plane","../geom/Position","../geom/Rectangle","../render/ScreenCreditController","../geom/Sector","../shapes/SurfaceShape","../shapes/SurfaceShapeTileBuilder","../render/SurfaceTileRenderer","../render/TextSupport","../geom/Vec2","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b,S,T,L,w){"use strict";var x=function(i){if(!i)throw new t(u.logMessage(u.LEVEL_SEVERE,"Texture","constructor","missingGlContext"));this.currentGlContext=i,this.canvas2D=document.createElement("canvas"),this.ctx2D=this.canvas2D.getContext("2d"),this.clearColor=e.TRANSPARENT,this.gpuResourceCache=new l(WorldWind.configuration.gpuCacheSize,.8*WorldWind.configuration.gpuCacheSize),this.surfaceTileRenderer=new b,this.surfaceShapeTileBuilder=new v,this.surfaceShapeTileController=new n,this.screenCreditController=new E,this.textSupport=new S,this.currentFramebuffer=null,this.currentProgram=null,this.surfaceRenderables=[],this.orderedRenderingMode=!1,this.orderedRenderables=[],this.screeRenderables=[],this.orderedRenderablesCounter=0,this.timestamp=Date.now(),this.previousRedrawTimestamp=this.timestamp,this.redrawRequested=!1,this.globe=null,this.globeStateKey=null,this.layers=null,this.currentLayer=null,this.navigatorState=null,this.eyePosition=new g(0,0,0),this.screenProjection=c.fromIdentity(),this.terrain=null,this.verticalExaggeration=1,this.fadeTime=500,this.surfaceOpacity=1,this.frameStatistics=null,this.pickingMode=!1,this.pickTerrainOnly=!1,this.deepPicking=!1,this.regionPicking=!1,this.pickPoint=null,this.pickRectangle=null,this.pickFramebuffer=null,this.pickFrustum=null,this.pickColor=new e(0,0,0,1),this.objectsAtPickPoint=new p,this.pixelScale=1};return x.unitCubeKey="DrawContextUnitCubeKey",x.unitCubeElementsKey="DrawContextUnitCubeElementsKey",x.unitQuadKey="DrawContextUnitQuadKey",x.unitQuadKey3="DrawContextUnitQuadKey3",x.prototype.reset=function(){this.screenCreditController.clear(),this.surfaceRenderables=[],this.orderedRenderingMode=!1,this.orderedRenderables=[],this.screenRenderables=[],this.orderedRenderablesCounter=0;var t=this.timestamp;this.timestamp=Date.now(),this.timestamp===t&&++this.timestamp,this.redrawRequested=!1,this.globe=null,this.globeStateKey=null,this.layers=null,this.currentLayer=null,this.navigatorState=null,this.terrain=null,this.verticalExaggeration=1,this.frameStatistics=null,this.accumulateOrderedRenderables=!0,this.pickingMode=!1,this.pickTerrainOnly=!1,this.deepPicking=!1,this.regionPicking=!1,this.pickPoint=null,this.pickRectangle=null,this.pickFrustum=null,this.pickColor=new e(0,0,0,1),this.objectsAtPickPoint.clear()},x.prototype.update=function(){var t=this.currentGlContext,e=this.navigatorState.eyePoint;this.globeStateKey=this.globe.stateKey,this.globe.computePositionFromPoint(e[0],e[1],e[2],this.eyePosition),this.screenProjection.setToScreenProjection(t.drawingBufferWidth,t.drawingBufferHeight)},x.prototype.contextLost=function(){this.gpuResourceCache.clear(),this.pickFramebuffer=null,this.currentFramebuffer=null,this.currentProgram=null},x.prototype.contextRestored=function(){this.gpuResourceCache.clear()},x.prototype.bindFramebuffer=function(t){this.currentFramebuffer!=t&&(this.currentGlContext.bindFramebuffer(this.currentGlContext.FRAMEBUFFER,t?t.framebufferId:null),this.currentFramebuffer=t)},x.prototype.bindProgram=function(t){this.currentProgram!=t&&(this.currentGlContext.useProgram(t?t.programId:null),this.currentProgram=t)},x.prototype.findAndBindProgram=function(e){if(!e)throw new t(u.logMessage(u.LEVEL_SEVERE,"DrawContext","findAndBindProgram","The specified program constructor is null or undefined."));var i=this.gpuResourceCache.resourceForKey(e.key);if(i)this.bindProgram(i);else try{i=new e(this.currentGlContext),this.bindProgram(i),this.gpuResourceCache.putResource(e.key,i,i.size)}catch(t){u.log(u.LEVEL_SEVERE,"Error attempting to create GPU program.")}return i},x.prototype.addSurfaceRenderable=function(t){t&&this.surfaceRenderables.push(t)},x.prototype.peekSurfaceRenderable=function(){return this.surfaceRenderables.length>0?this.surfaceRenderables[this.surfaceRenderables.length-1]:null},x.prototype.popSurfaceRenderable=function(){return this.surfaceRenderables.length>0?this.surfaceRenderables.pop():null},x.prototype.reverseSurfaceRenderables=function(){this.surfaceRenderables.reverse()},x.prototype.addOrderedRenderable=function(t,e){if(t){var i={orderedRenderable:t,insertionOrder:this.orderedRenderablesCounter++,eyeDistance:e||t.eyeDistance,globeStateKey:this.globeStateKey};this.globe.continuous&&(i.globeOffset=this.globe.offset),0===i.eyeDistance?this.screenRenderables.push(i):this.orderedRenderables.push(i)}},x.prototype.addOrderedRenderableToBack=function(t){if(t){var e={orderedRenderable:t,insertionOrder:this.orderedRenderablesCounter++,eyeDistance:Number.MAX_VALUE,globeStateKey:this.globeStateKey};this.globe.continuous&&(e.globeOffset=this.globe.offset),this.orderedRenderables.push(e)}},x.prototype.peekOrderedRenderable=function(){return this.orderedRenderables.length>0?this.orderedRenderables[this.orderedRenderables.length-1].orderedRenderable:null},x.prototype.popOrderedRenderable=function(){if(this.orderedRenderables.length>0){var t=this.orderedRenderables.pop();return this.globeStateKey=t.globeStateKey,this.globe.continuous&&(this.globe.offset=t.globeOffset),t.orderedRenderable}return null},x.prototype.nextScreenRenderable=function(){if(this.screenRenderables.length>0){var t=this.screenRenderables.shift();return this.globeStateKey=t.globeStateKey,this.globe.continuous&&(this.globe.offset=t.globeOffset),t.orderedRenderable}return null},x.prototype.sortOrderedRenderables=function(){this.orderedRenderables.sort(function(t,e){var i=t.eyeDistance,r=e.eyeDistance;if(i<r)return-1;if(i>r)return 1;var n=t.insertionOrder,o=e.insertionOrder;return n>o?-1:n<o?1:0})},x.prototype.readPickColor=function(t){var i=this.navigatorState.convertPointToViewport(t,new T(0,0)),r=new Uint8Array(4);return this.currentGlContext.readPixels(i[0],i[1],1,1,this.currentGlContext.RGBA,this.currentGlContext.UNSIGNED_BYTE,r),this.clearColor.equalsBytes(r)?null:e.colorFromByteArray(r)},x.prototype.readPickColors=function(t){var i,r=this.currentGlContext,n=new Uint8Array(t.width*t.height*4),o={},s=new e(0,0,0,0),a=r.getParameter(r.PACK_ALIGNMENT);r.pixelStorei(r.PACK_ALIGNMENT,1),this.currentGlContext.readPixels(t.x,t.y,t.width,t.height,r.RGBA,r.UNSIGNED_BYTE,n),r.pixelStorei(r.PACK_ALIGNMENT,a);for(var l=0,h=t.width*t.height;l<h;l++){var u=4*l;i=e.colorFromBytes(n[u],n[u+1],n[u+2],n[u+3]),i.equals(this.clearColor)||i.equals(s)||(o[i.toByteString()]=i)}return o},x.prototype.resolvePick=function(t){if(t.userObject instanceof _||!this.deepPicking||this.regionPicking)this.addPickedObject(t);else{var e=this.readPickColor(this.pickPoint);if(!e)return null;t.color.equals(e)&&this.addPickedObject(t)}},x.prototype.addPickedObject=function(t){t&&this.objectsAtPickPoint.add(t)},x.prototype.uniquePickColor=function(){var t=this.pickColor.nextColor().clone();return t.equals(this.clearColor)?t.nextColor():t},x.prototype.makePickFramebuffer=function(){var t=this.currentGlContext,e=t.drawingBufferWidth,i=t.drawingBufferHeight;return this.pickFramebuffer&&this.pickFramebuffer.width==e&&this.pickFramebuffer.height==i||(this.pickFramebuffer=new r(t,e,i,!0)),this.pickFramebuffer},x.prototype.makePickFrustum=function(){if(!this.pickPoint&&!this.pickRectangle)return!1;var t,e,i,r,n,s,a,l,h,u,c,d,p,g,E,y,_,v,b,S,x,R,M=new L(0,0,0),C=2,A=new L(0,0,0),P=this.pickRectangle,O=this.navigatorState.viewport;P||(R=this.navigatorState.convertPointToViewport(this.pickPoint,new T(0,0)),P=new m(R[0]-C,R[1]-C,2*C,2*C));var I=P.x,N=P.x+P.width,D=P.y,V=P.y+P.height;return!(N<0||V<0||I>O.x+O.width||D>O.y+O.height)&&(P.x=w.clamp(I,O.x,O.x+O.width),P.y=w.clamp(D,O.y,O.y+O.height),P.width=w.clamp(N,O.x,O.x+O.width)-P.x,P.height=w.clamp(V,O.y,O.y+O.height)-P.y,this.pickRectangle=P,A[0]=P.x,A[1]=P.y,A[2]=0,this.navigatorState.unProject(A,t=new L(0,0,0)),A[0]=P.x,A[1]=P.y,A[2]=1,this.navigatorState.unProject(A,e=new L(0,0,0)),A[0]=P.x+P.width,A[1]=P.y,A[2]=0,this.navigatorState.unProject(A,i=new L(0,0,0)),A[0]=P.x+P.width,A[1]=P.y,A[2]=1,this.navigatorState.unProject(A,r=new L(0,0,0)),A[0]=P.x,A[1]=P.y+P.height,A[2]=0,this.navigatorState.unProject(A,n=new L(0,0,0)),A[0]=P.x,A[1]=P.y+P.height,A[2]=1,this.navigatorState.unProject(A,s=new L(0,0,0)),A[0]=P.x+P.width,A[1]=P.y+P.height,A[2]=0,this.navigatorState.unProject(A,a=new L(0,0,0)),A[0]=P.x+P.width,A[1]=P.y+P.height,A[2]=1,this.navigatorState.unProject(A,l=new L(0,0,0)),x=new L(s[0]-t[0],s[1]-t[1],s[2]-t[2]),M.set(n[0]-e[0],n[1]-e[1],n[2]-e[2]),h=x.cross(M),E=new f(h[0],h[1],h[2],-h.dot(t)),E.normalize(),x=new L(a[0]-r[0],a[1]-r[1],a[2]-r[2]),M.set(l[0]-i[0],l[1]-i[1],l[2]-i[2]),u=x.cross(M),y=new f(u[0],u[1],u[2],-u.dot(i)),y.normalize(),x=new L(s[0]-a[0],s[1]-a[1],s[2]-a[2]),M.set(l[0]-n[0],l[1]-n[1],l[2]-n[2]),c=x.cross(M),_=new f(c[0],c[1],c[2],-c.dot(n)),_.normalize(),x=new L(r[0]-t[0],r[1]-t[1],r[2]-t[2]),M.set(e[0]-i[0],e[1]-i[1],e[2]-i[2]),d=x.cross(M),v=new f(d[0],d[1],d[2],-d.dot(i)),v.normalize(),x=new L(n[0]-i[0],n[1]-i[1],n[2]-i[2]),M.set(a[0]-t[0],a[1]-t[1],a[2]-t[2]),p=x.cross(M),b=new f(p[0],p[1],p[2],-p.dot(t)),b.normalize(),x=new L(l[0]-e[0],l[1]-e[1],l[2]-e[2]),M.set(s[0]-r[0],s[1]-r[1],s[2]-r[2]),g=x.cross(M),S=new f(g[0],g[1],g[2],-g.dot(e)),S.normalize(),this.pickFrustum=new o(E,y,v,_,b,S),!0)},x.prototype.isSmall=function(t,e){if(!t)return!1;var i=this.navigatorState.eyePoint.distanceTo(t.center),r=this.navigatorState.pixelSizeAtDistance(i);return 2*t.radius<e*r},x.prototype.unitCubeBuffer=function(){var t=this.gpuResourceCache.resourceForKey(x.unitCubeKey);if(!t){var e=this.currentGlContext,i=new Float32Array(24),r=0;i[r++]=0,i[r++]=1,i[r++]=0,i[r++]=0,i[r++]=0,i[r++]=0,i[r++]=1,i[r++]=1,i[r++]=0,i[r++]=1,i[r++]=0,i[r++]=0,i[r++]=0,i[r++]=1,i[r++]=1,i[r++]=0,i[r++]=0,i[r++]=1,i[r++]=1,i[r++]=1,i[r++]=1,i[r++]=1,i[r++]=0,i[r]=1,t=e.createBuffer(),e.bindBuffer(e.ARRAY_BUFFER,t),e.bufferData(e.ARRAY_BUFFER,i,e.STATIC_DRAW),e.bindBuffer(e.ARRAY_BUFFER,null),this.frameStatistics.incrementVboLoadCount(1),this.gpuResourceCache.putResource(x.unitCubeKey,t,4*i.length)}return t},x.prototype.unitCubeElements=function(){var t=this.gpuResourceCache.resourceForKey(x.unitCubeElementsKey);if(!t){var e=this.currentGlContext,i=new Int16Array(60),r=0;i[r++]=1,i[r++]=0,i[r++]=3,i[r++]=3,i[r++]=0,i[r++]=2,i[r++]=4,i[r++]=5,i[r++]=6,i[r++]=6,i[r++]=5,i[r++]=7,i[r++]=5,i[r++]=1,i[r++]=7,i[r++]=7,i[r++]=1,i[r++]=3,i[r++]=6,i[r++]=2,i[r++]=4,i[r++]=4,i[r++]=2,i[r++]=0,i[r++]=4,i[r++]=0,i[r++]=5,i[r++]=5,i[r++]=0,i[r++]=1,i[r++]=7,i[r++]=3,i[r++]=6,
i[r++]=6,i[r++]=3,i[r++]=2,i[r++]=0,i[r++]=1,i[r++]=1,i[r++]=3,i[r++]=3,i[r++]=2,i[r++]=2,i[r++]=0,i[r++]=4,i[r++]=5,i[r++]=5,i[r++]=7,i[r++]=7,i[r++]=6,i[r++]=6,i[r++]=4,i[r++]=0,i[r++]=4,i[r++]=5,i[r++]=1,i[r++]=2,i[r++]=6,i[r++]=7,i[r]=3,t=e.createBuffer(),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,t),e.bufferData(e.ELEMENT_ARRAY_BUFFER,i,e.STATIC_DRAW),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null),this.frameStatistics.incrementVboLoadCount(1),this.gpuResourceCache.putResource(x.unitCubeElementsKey,t,2*i.length)}return t},x.prototype.unitQuadBuffer=function(){var t=this.gpuResourceCache.resourceForKey(x.unitQuadKey);if(!t){var e=this.currentGlContext,i=new Float32Array(8);i[0]=0,i[1]=1,i[2]=0,i[3]=0,i[4]=1,i[5]=1,i[6]=1,i[7]=0,t=e.createBuffer(),e.bindBuffer(e.ARRAY_BUFFER,t),e.bufferData(e.ARRAY_BUFFER,i,e.STATIC_DRAW),e.bindBuffer(e.ARRAY_BUFFER,null),this.frameStatistics.incrementVboLoadCount(1),this.gpuResourceCache.putResource(x.unitQuadKey,t,4*i.length)}return t},x.prototype.unitQuadBuffer3=function(){var t=this.gpuResourceCache.resourceForKey(x.unitQuadKey3);if(!t){var e=this.currentGlContext,i=new Float32Array(12);i[0]=0,i[1]=1,i[2]=0,i[3]=0,i[4]=0,i[5]=0,i[6]=1,i[7]=1,i[8]=0,i[9]=1,i[10]=0,i[11]=0,t=e.createBuffer(),e.bindBuffer(e.ARRAY_BUFFER,t),e.bufferData(e.ARRAY_BUFFER,i,e.STATIC_DRAW),e.bindBuffer(e.ARRAY_BUFFER,null),this.frameStatistics.incrementVboLoadCount(1),this.gpuResourceCache.putResource(x.unitQuadKey3,t,4*i.length)}return t},x.prototype.surfacePointForMode=function(e,i,r,n,o){if(!o)throw new t(u.logMessage(u.LEVEL_SEVERE,"DrawContext","surfacePointForMode","missingResult"));if(this.terrain)this.terrain.surfacePointForMode(e,i,r,n,o);else{var s=r+this.globe.elevationAtLocation(e,i)*this.verticalExaggeration;this.globe.computePointFromPosition(e,i,s,o)}return o},x}),i("globe/EarthElevationModel",["../geom/Location","../geom/Sector","../globe/ElevationModel","../util/WmsUrlBuilder"],function(t,e,i,r){"use strict";var n=function(){i.call(this,e.FULL_SPHERE,new t(45,45),12,"application/bil16","EarthElevations256",256,256),this.displayName="Earth Elevation Model",this.minElevation=-11e3,this.maxElevation=8850,this.pixelIsPoint=!1,this.urlBuilder=new r("http://worldwind26.arc.nasa.gov/elev","GEBCO,aster_v2,USGS-NED","","1.3.0")};return n.prototype=Object.create(i.prototype),n}),i("globe/EarthRestElevationModel",["../geom/Location","../geom/Sector","../globe/ElevationModel","../util/LevelRowColumnUrlBuilder"],function(t,e,i,r){"use strict";var n=function(n,o,s){i.call(this,e.FULL_SPHERE,new t(60,60),5,"application/bil16","EarthElevations",512,512),this.displayName=s,this.minElevation=-11e3,this.maxElevation=8850,this.urlBuilder=new r(n,o)};return n.prototype=Object.create(i.prototype),n}),i("layer/FrameStatisticsLayer",["../error/ArgumentError","../util/Color","../util/Font","../layer/Layer","../util/Logger","../util/Offset","../shapes/ScreenText","../shapes/TextAttributes"],function(t,e,i,r,n,o,s,a){"use strict";var l=function(l){function h(t,e){c.handleRedraw(t,e)}if(!l)throw new t(n.logMessage(n.LEVEL_SEVERE,"FrameStatisticsLayer","constructor","missingWorldWindow"));r.call(this,"Frame Statistics"),this.pickEnabled=!1;var u=new a(null);u.color=e.GREEN,u.font=new i(12),u.offset=new o(WorldWind.OFFSET_FRACTION,0,WorldWind.OFFSET_FRACTION,1),this.frameTime=new s(new o(WorldWind.OFFSET_PIXELS,5,WorldWind.OFFSET_INSET_PIXELS,5)," "),this.frameTime.attributes=u,this.frameRate=new s(new o(WorldWind.OFFSET_PIXELS,5,WorldWind.OFFSET_INSET_PIXELS,25)," "),this.frameRate.attributes=u;var c=this;l.redrawCallbacks.push(h)};return l.prototype=Object.create(r.prototype),l.prototype.doRender=function(t){this.frameRate.render(t),this.frameTime.render(t),this.inCurrentFrame=!0},l.prototype.handleRedraw=function(t,e){if(e==WorldWind.BEFORE_REDRAW){var i=t.frameStatistics;this.frameTime.text="Frame time  "+i.frameTimeAverage.toFixed(0)+" ms  ("+i.frameTimeMin.toFixed(0)+" - "+i.frameTimeMax.toFixed(0)+")",this.frameRate.text="Frame rate  "+i.frameRateAverage.toFixed(0)+" fps"}},l}),i("shapes/AbstractShape",["../error/ArgumentError","../util/Logger","../geom/Matrix","../cache/MemoryCache","../render/Renderable","../shapes/ShapeAttributes","../error/UnsupportedOperationError","../geom/Vec3"],function(t,e,i,r,n,o,s,a){"use strict";var l=function(t){n.call(this),this._attributes=t?t:new o(null),this._highlightAttributes=null,this.highlighted=!1,this._altitudeMode=WorldWind.ABSOLUTE,this.referencePosition=null,this.shapeDataCache=new r(3,2),this.currentData=null,this.activeAttributes=null,this.expirationInterval=2e3,this.useSurfaceShapeFor2D=!1,this.scratchMatrix=i.fromIdentity()};return l.prototype=Object.create(n.prototype),Object.defineProperties(l.prototype,{attributes:{get:function(){return this._attributes},set:function(t){this._attributes=t,this.surfaceShape&&(this.surfaceShape.attributes=this._attributes)}},highlightAttributes:{get:function(){return this._highlightAttributes},set:function(t){this._highlightAttributes=t,this.surfaceShape&&(this.surfaceShape.highlightAttributes=this._highlightAttributes)}},altitudeMode:{get:function(){return this._altitudeMode},set:function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"AbstractShape","altitudeMode","missingAltitudeMode"));this._altitudeMode=i,this.reset()}}}),l.prototype.reset=function(){this.shapeDataCache.clear(!1),this.surfaceShape=null},l.prototype.updateSurfaceShape=function(){this.surfaceShape.displayName=this.displayName,this.surfaceShape.highlighted=this.highlighted,this.surfaceShape.enabled=this.enabled,this.surfaceShape.pathType=this.pathType,this.surfaceShape.pickDelegate=this.pickDelegate?this.pickDelegate:this},l.prototype.createSurfaceShape=function(){return null},l.prototype.render=function(t){if(this.enabled&&t.accumulateOrderedRenderables){if(t.globe.is2D()&&this.useSurfaceShapeFor2D&&(this.surfaceShape||(this.surfaceShape=this.createSurfaceShape(),this.surfaceShape&&(this.surfaceShape.attributes=this._attributes,this.surfaceShape.highlightAttributes=this._highlightAttributes)),this.surfaceShape))return this.updateSurfaceShape(),void this.surfaceShape.render(t);if((t.terrain||this.altitudeMode==WorldWind.ABSOLUTE)&&(this.establishCurrentData(t),(!t.globe.projectionLimits||this.isWithinProjectionLimits(t))&&(!this.currentData.extent||this.intersectsFrustum(t))&&(this.determineActiveAttributes(t),this.activeAttributes))){var e=this.makeOrderedRenderable(t);if(e){if(!this.intersectsFrustum(t))return;if(t.isSmall(this.currentData.extent,1))return;e.layer=t.currentLayer,t.addOrderedRenderable(e,this.currentData.eyeDistance)}}}},l.prototype.renderOrdered=function(t){this.currentData=this.shapeDataCache.entryForKey(t.globeStateKey),this.beginDrawing(t);try{this.doRenderOrdered(t)}finally{this.endDrawing(t)}},l.prototype.makeOrderedRenderable=function(t){var e=this.doMakeOrderedRenderable(t);return this.currentData.verticalExaggeration=t.verticalExaggeration,e},l.prototype.doMakeOrderedRenderable=function(t){throw new s(e.logMessage(e.LEVEL_SEVERE,"AbstractShape","makeOrderedRenderable","abstractInvocation"))},l.prototype.doRenderOrdered=function(t){throw new s(e.logMessage(e.LEVEL_SEVERE,"AbstractShape","doRenderOrdered","abstractInvocation"))},l.prototype.beginDrawing=function(t){},l.prototype.endDrawing=function(t){},l.prototype.intersectsFrustum=function(t){return!this.currentData||!this.currentData.extent||(t.pickingMode?this.currentData.extent.intersectsFrustum(t.pickFrustum):this.currentData.extent.intersectsFrustum(t.navigatorState.frustumInModelCoordinates))},l.prototype.establishCurrentData=function(t){this.currentData=this.shapeDataCache.entryForKey(t.globeStateKey),this.currentData||(this.currentData=this.createShapeDataObject(),this.resetExpiration(this.currentData),this.shapeDataCache.putEntry(t.globeStateKey,this.currentData,1)),this.currentData.isExpired=!this.isShapeDataCurrent(t,this.currentData)},l.prototype.createShapeDataObject=function(){return{transformationMatrix:i.fromIdentity(),referencePoint:new a(0,0,0)}},l.prototype.resetExpiration=function(t){t.expiryTime=Date.now()+this.expirationInterval+1e3*Math.random()},l.prototype.isShapeDataCurrent=function(t,e){return e.verticalExaggeration===t.verticalExaggeration&&e.expiryTime>Date.now()},l.prototype.determineActiveAttributes=function(t){this.highlighted&&this._highlightAttributes?this.activeAttributes=this.highlightAttributes:this.activeAttributes=this._attributes},l.prototype.isWithinProjectionLimits=function(t){return!0},l.prototype.applyMvpMatrix=function(t){this.scratchMatrix.copy(t.navigatorState.modelviewProjection),this.scratchMatrix.multiplyMatrix(this.currentData.transformationMatrix),t.currentProgram.loadModelviewProjection(t.currentGlContext,this.scratchMatrix)},l.prototype.applyMvpMatrixForOutline=function(t){this.scratchMatrix.copy(t.navigatorState.projection),this.scratchMatrix.offsetProjectionDepth(-.001),this.scratchMatrix.multiplyMatrix(t.navigatorState.modelview),this.scratchMatrix.multiplyMatrix(this.currentData.transformationMatrix),t.currentProgram.loadModelviewProjection(t.currentGlContext,this.scratchMatrix)},l}),i("shapes/AbstractMesh",["../shapes/AbstractShape","../error/ArgumentError","../shaders/BasicTextureProgram","../geom/BoundingBox","../util/Color","../util/ImageSource","../geom/Line","../geom/Location","../util/Logger","../geom/Matrix","../pick/PickedObject","../geom/Position","../shapes/ShapeAttributes","../geom/Vec2","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g){"use strict";var m=function(e){t.call(this,e),this.pickTransparentImagePixels=!0,this._altitudeScale=1};return m.prototype=Object.create(t.prototype),Object.defineProperties(m.prototype,{altitudeScale:{get:function(){return this._altitudeScale},set:function(t){this._altitudeScale=t,this.reset()}}}),m.prototype.mustGenerateGeometry=function(t){return!this.currentData.meshPoints||(this.currentData.drawInterior!==this.activeAttributes.drawInterior||(!(!this.activeAttributes.applyLighting||this.currentData.normals)||this.altitudeMode!==WorldWind.ABSOLUTE&&this.currentData.isExpired))},m.prototype.doMakeOrderedRenderable=function(t){if(!this.activeAttributes.drawInterior&&!this.activeAttributes.drawOutline)return null;if(!this.mustGenerateGeometry(t))return this;var e=this.currentData,i=e.referencePoint;return t.surfacePointForMode(this.referencePosition.latitude,this.referencePosition.longitude,this.referencePosition.altitude*this._altitudeScale,this._altitudeMode,i),e.transformationMatrix.setToTranslation(i[0],i[1],i[2]),e.meshPoints=this.computeMeshPoints(t,e),e.refreshVertexBuffer=!0,this.activeAttributes.imageSource&&!this.texCoords&&(this.texCoords=this.computeTexCoords(),this.texCoords&&(e.refreshTexCoordBuffer=!0)),this.meshIndices||(this.meshIndices=this.computeMeshIndices(),e.refreshMeshIndices=!0),this.meshOutlineIndices||(this.meshOutlineIndices=this.computeOutlineIndices(),this.meshOutlineIndices&&(e.refreshOutlineIndices=!0)),this.activeAttributes.applyLighting&&this.computeNormals(e),e.drawInterior=this.activeAttributes.drawInterior,this.resetExpiration(e),e.extent||(e.extent=new r),e.extent.setToPoints(e.meshPoints),e.extent.translate(e.referencePoint),this},m.prototype.computeMeshPoints=function(t,e){throw new UnsupportedOperationError(l.logMessage(l.LEVEL_SEVERE,"AbstractMesh","computeMeshPoints","abstractInvocation"))},m.prototype.computeTexCoords=function(){return null},m.prototype.computeMeshIndices=function(t){throw new UnsupportedOperationError(l.logMessage(l.LEVEL_SEVERE,"AbstractMesh","computeMeshIndices","abstractInvocation"))},m.prototype.computeOutlineIndices=function(t){},m.prototype.computeNormals=function(t){for(var e,i=new Float32Array(t.meshPoints.length),r=this.meshIndices,n=t.meshPoints,o=[],s=[new f(0,0,0),new f(0,0,0),new f(0,0,0)],a=0;a<r.length;a+=3){for(var l=0;l<3;l++)e=r[a+l],s[l].set(n[3*e],n[3*e+1],n[3*e+2]);var h=f.computeTriangleNormal(s[0],s[1],s[2]);for(l=0;l<3;l++)e=r[a+l],o[e]||(o[e]=[]),o[e].push(h)}for(h=new f(0,0,0),a=0;a<o.length;a++)o[a]?(f.average(o[a],h),h.normalize(),i[3*a]=h[0],i[3*a+1]=h[1],i[3*a+2]=h[2]):(i[3*a]=0,i[3*a+1]=0,i[3*a+2]=0);t.normals=i,t.refreshNormalsBuffer=!0},m.prototype.doRenderOrdered=function(t){var e,i,r,n,o,s=t.currentGlContext,a=t.currentProgram,l=this.currentData,h=this.texCoords&&!!this.activeAttributes.imageSource;if(t.pickingMode&&(n=t.uniquePickColor()),l.pointsVboCacheKey||(l.pointsVboCacheKey=t.gpuResourceCache.generateCacheKey()),e=t.gpuResourceCache.resourceForKey(l.pointsVboCacheKey),e||(e=s.createBuffer(),t.gpuResourceCache.putResource(l.pointsVboCacheKey,e,4*l.meshPoints.length),l.refreshVertexBuffer=!0),s.bindBuffer(s.ARRAY_BUFFER,e),l.refreshVertexBuffer&&(s.bufferData(s.ARRAY_BUFFER,l.meshPoints,s.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),l.refreshVertexBuffer=!1),s.vertexAttribPointer(a.vertexPointLocation,3,s.FLOAT,!1,0,0),a.loadTextureEnabled(s,!1),this.activeAttributes.drawInterior){var c=!t.pickingMode&&l.normals&&this.activeAttributes.applyLighting;this.applyMvpMatrix(t),l.meshIndicesVboCacheKey||(l.meshIndicesVboCacheKey=t.gpuResourceCache.generateCacheKey()),e=t.gpuResourceCache.resourceForKey(l.meshIndicesVboCacheKey),e||(e=s.createBuffer(),t.gpuResourceCache.putResource(l.meshIndicesVboCacheKey,e,2*this.meshIndices.length),l.refreshMeshIndices=!0),s.bindBuffer(s.ELEMENT_ARRAY_BUFFER,e),l.refreshMeshIndices&&(s.bufferData(s.ELEMENT_ARRAY_BUFFER,this.meshIndices,s.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),l.refreshMeshIndices=!1),r=this.activeAttributes.interiorColor,i=r.alpha*t.currentLayer.opacity,s.depthMask(i>=1||t.pickingMode),a.loadColor(s,t.pickingMode?n:r),a.loadOpacity(s,t.pickingMode?i>0?1:0:i),!h||t.pickingMode&&this.pickTransparentImagePixels||(this.activeTexture=t.gpuResourceCache.resourceForKey(this.activeAttributes.imageSource),this.activeTexture||(this.activeTexture=t.gpuResourceCache.retrieveTexture(t.currentGlContext,this.activeAttributes.imageSource)),o=this.activeTexture&&this.activeTexture.bind(t),o&&(l.texCoordsVboCacheKey||(l.texCoordsVboCacheKey=t.gpuResourceCache.generateCacheKey()),e=t.gpuResourceCache.resourceForKey(l.texCoordsVboCacheKey),e||(e=s.createBuffer(),t.gpuResourceCache.putResource(l.texCoordsVboCacheKey,e,4*this.texCoords.length),l.refreshTexCoordBuffer=!0),s.bindBuffer(s.ARRAY_BUFFER,e),l.refreshTexCoordBuffer&&(s.bufferData(s.ARRAY_BUFFER,this.texCoords,s.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),l.refreshTexCoordBuffer=!1),a.loadTextureEnabled(s,!0),s.enableVertexAttribArray(a.vertexTexCoordLocation),s.vertexAttribPointer(a.vertexTexCoordLocation,2,s.FLOAT,!1,0,0),a.loadTextureUnit(s,s.TEXTURE0),a.loadModulateColor(s,t.pickingMode))),c&&(a.loadApplyLighting(s,!0),l.normalsVboCacheKey||(l.normalsVboCacheKey=t.gpuResourceCache.generateCacheKey()),e=t.gpuResourceCache.resourceForKey(l.normalsVboCacheKey),e||(e=s.createBuffer(),t.gpuResourceCache.putResource(l.normalsVboCacheKey,e,4*l.normals.length),l.refreshNormalsBuffer=!0),s.bindBuffer(s.ARRAY_BUFFER,e),l.refreshNormalsBuffer&&(s.bufferData(s.ARRAY_BUFFER,l.normals,s.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),l.refreshNormalsBuffer=!1),s.enableVertexAttribArray(a.normalVectorLocation),s.vertexAttribPointer(a.normalVectorLocation,3,s.FLOAT,!1,0,0)),s.drawElements(s.TRIANGLES,this.meshIndices.length,s.UNSIGNED_SHORT,0),h&&s.disableVertexAttribArray(a.vertexTexCoordLocation),c&&(a.loadApplyLighting(s,!1),s.disableVertexAttribArray(a.normalVectorLocation))}if(this.activeAttributes.drawOutline&&this.meshOutlineIndices&&(a.loadTextureEnabled(s,!1),s.disableVertexAttribArray(a.vertexTexCoordLocation),this.applyMvpMatrixForOutline(t),r=this.activeAttributes.outlineColor,i=r.alpha*t.currentLayer.opacity,s.depthMask(i>=1||t.pickingMode),a.loadColor(s,t.pickingMode?n:r),a.loadOpacity(s,t.pickingMode?1:i),s.lineWidth(this.activeAttributes.outlineWidth),l.outlineIndicesVboCacheKey||(l.outlineIndicesVboCacheKey=t.gpuResourceCache.generateCacheKey()),e=t.gpuResourceCache.resourceForKey(l.outlineIndicesVboCacheKey),e||(e=s.createBuffer(),t.gpuResourceCache.putResource(l.outlineIndicesVboCacheKey,e,2*this.meshOutlineIndices.length),l.refreshOutlineIndices=!0),s.bindBuffer(s.ELEMENT_ARRAY_BUFFER,e),l.refreshOutlineIndices&&(s.bufferData(s.ELEMENT_ARRAY_BUFFER,this.meshOutlineIndices,s.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),l.refreshOutlineIndices=!1),s.drawElements(s.LINE_STRIP,this.meshOutlineIndices.length,s.UNSIGNED_SHORT,0)),t.pickingMode){var d=this.computePickPosition(t),p=new u(n,this.pickDelegate?this.pickDelegate:this,d,t.currentLayer,!1);t.resolvePick(p)}},m.prototype.computePickPosition=function(t){var e=this.currentData,i=t.navigatorState.rayFromScreenPoint(t.pickPoint),r=new f(i.origin[0],i.origin[1],i.origin[2]).subtract(e.referencePoint),n=new s(r,i.direction),o=[];if(g.computeIndexedTrianglesIntersection(n,e.meshPoints,this.meshIndices,o)){var a=o[0];if(o.length>1)for(var l=a.distanceToSquared(t.navigatorState.eyePoint),h=1;h<o.length;h++){var u=o[h].distanceToSquared(t.navigatorState.eyePoint);u<l&&(l=u,a=o[h])}var d=new c(0,0,0);return t.globe.computePositionFromPoint(a[0]+e.referencePoint[0],a[1]+e.referencePoint[1],a[2]+e.referencePoint[2],d),d.altitude/=this._altitudeScale,d}return null},m.prototype.beginDrawing=function(t){var e=t.currentGlContext;if(this.activeAttributes.drawInterior){e.disable(e.CULL_FACE),t.findAndBindProgram(i);var r=!t.pickMode&&this.currentData.normals&&this.activeAttributes.applyLighting;r&&t.currentProgram.loadModelviewInverse(e,t.navigatorState.modelviewNormalTransform)}e.enableVertexAttribArray(t.currentProgram.vertexPointLocation)},m.prototype.endDrawing=function(t){var e=t.currentGlContext;e.disableVertexAttribArray(t.currentProgram.vertexPointLocation),e.depthMask(!0),e.lineWidth(1),e.enable(e.CULL_FACE)},m}),i("shapes/SurfacePolygon",["../error/ArgumentError","../util/Logger","../shapes/ShapeAttributes","../shapes/SurfaceShape"],function(t,e,i,r){"use strict";var n=function(i,n){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfacePolygon","constructor","The specified boundary array is null or undefined."));r.call(this,n);var o=null;if(i.length>0&&void 0!==i[0].latitude)o=i.slice(0),o.push(i[0]),this._boundariesSpecifiedSimply=!0;else if(i.length>1){var s=null;o=[];for(var a=0;a<i.length;a++){for(var l=i[a][0],h=0;h<i[a].length;h++)o.push(i[a][h]);o.push(l),s?o.push(s):s=o[o.length-1]}}else 1===i.length&&(o=i[0].slice(0),o.push(i[0][0]));this._boundaries=o};return n.prototype=Object.create(r.prototype),Object.defineProperties(n.prototype,{}),n.staticStateKey=function(t){var e=r.staticStateKey(t);return e},n.prototype.computeStateKey=function(){return n.staticStateKey(this)},n}),i("shapes/GeographicMesh",["../shapes/AbstractMesh","../error/ArgumentError","../shaders/BasicTextureProgram","../geom/BoundingBox","../util/Color","../util/ImageSource","../geom/Location","../util/Logger","../geom/Matrix","../pick/PickedObject","../geom/Position","../shapes/ShapeAttributes","../shapes/SurfacePolygon","../geom/Vec2","../geom/Vec3"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f){"use strict";var g=function(i,r){if(!i)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","constructor","missingPositions"));if(i.length<2||i[0].length<2)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","constructor","Number of positions is insufficient."));if(i.length*i[0].length>65536)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","constructor","Too many positions. Must be fewer than 65536. Try using multiple meshes."));for(var n=i[0].length,o=1;o<i.length;o++)if(i[o].length!==n)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","constructor","Array lengths are inconsistent."));var s=i.length,l=i[0].length;t.call(this,r),this.pickTransparentImagePixels=!0,this._positions=i,this._altitudeScale=1,this.numRows=s,this.numColumns=l,this._textureCoordinates=null,this.referencePosition=this.determineReferencePosition(this._positions)};return g.prototype=Object.create(t.prototype),Object.defineProperties(g.prototype,{positions:{get:function(){return this._positions},set:function(t){if(!t)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","positions","missingPositions"));if(t.length<2||t[0].length<2)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","positions","Number of positions is insufficient."));for(var i=t[0].length,r=1;r<t.length;r++)if(t[r].length!==i)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","positions","Array lengths are inconsistent."));this.numRows=t.length,this.numColumns=t[0].length,this._positions=t,this.referencePosition=this.determineReferencePosition(this._positions),this.reset(),this.meshIndices=null,this.outlineIndices=null}},textureCoordinates:{get:function(){return this._textureCoordinates},set:function(t){if(t&&t.length!=this.numRows)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","textureCoordinates","Number of texture coordinate rows is inconsistent with the currently specified positions."));for(var i=0;i<this.numRows;i++)if(t[i].length!==this.numColumns)throw new e(a.logMessage(a.LEVEL_SEVERE,"GeographicMesh","textureCoordinates","Texture coordinate row lengths are inconsistent with the currently specified positions."));this._textureCoordinates=t,this.reset(),this.texCoords=null}}}),g.makeGridIndices=function(t,e){for(var i=[],r=0,n=0;n<t-1;n++)for(var o=0;o<e-1;o++){var s=n*e+o;i[r++]=s,i[r++]=s+1,i[r++]=s+e,i[r++]=s+1,i[r++]=s+1+e,i[r++]=s+e}return i},g.prototype.determineReferencePosition=function(t){return t[0][0]},g.prototype.createSurfaceShape=function(){for(var t=[],e=0;e<this.numColumns;e++)t.push(this._positions[0][e]);for(var i=1;i<this.numRows;i++)t.push(this._positions[i][this.numColumns-1]);for(e=this.numColumns-2;e>=0;e--)t.push(this._positions[this.numRows-1][e]);for(i=this.numRows-2;i>0;i--)t.push(this._positions[i][0]);return new d(t,null)},g.prototype.computeMeshPoints=function(t,e){for(var i,r,n=Number.MAX_VALUE,o=t.navigatorState.eyePoint,s=new Float32Array(this.numRows*this.numColumns*3),a=new f(0,0,0),l=0,h=0;h<this._positions.length;h++)for(var u=0,c=this._positions[h].length;u<c;u++)i=this._positions[h][u],t.surfacePointForMode(i.latitude,i.longitude,i.altitude*this._altitudeScale,this.altitudeMode,a),r=a.distanceToSquared(o),r<n&&(n=r),a.subtract(this.currentData.referencePoint),s[l++]=a[0],s[l++]=a[1],s[l++]=a[2];return e.eyeDistance=Math.sqrt(n),s},g.prototype.computeTexCoords=function(){return this._textureCoordinates?this.computeExplicitTexCoords():this.computeImplicitTexCoords()},g.prototype.computeExplicitTexCoords=function(){for(var t=new Float32Array(2*this.numRows*this.numColumns),e=0,i=0;i<this._textureCoordinates.length;i++)for(var r=0,n=this._textureCoordinates[i].length;r<n;r++){var o=this._textureCoordinates[i][r];t[e++]=o[0],t[e++]=o[1]}return t},g.prototype.computeImplicitTexCoords=function(){for(var t=new Float32Array(2*this.numRows*this.numColumns),e=1/(this.numRows-1),i=1/(this.numColumns-1),r=0,n=0;n<this._positions.length;n++)for(var o=n===this.numRows-1?1:n*e,s=0,a=this._positions[n].length;s<a;s++)t[r++]=s===this.numColumns-1?1:s*i,t[r++]=o;return t},g.prototype.computeMeshIndices=function(){for(var t=new Uint16Array((this.numRows-1)*(this.numColumns-1)*6),e=0,i=0;i<this.numRows-1;i++)for(var r=0;r<this.numColumns-1;r++){var n=i*this.numColumns+r;t[e++]=n,t[e++]=n+1,t[e++]=n+this.numColumns,t[e++]=n+1,t[e++]=n+1+this.numColumns,t[e++]=n+this.numColumns}return t},g.prototype.computeOutlineIndices=function(){for(var t=new Uint16Array(2*this.numRows+2*this.numColumns),e=0,i=0;i<this.numColumns;i++)t[e++]=i;for(var r=1;r<this.numRows;r++)t[e++]=(r+1)*this.numColumns-1;for(i=this.numRows*this.numColumns-2;i>=(this.numRows-1)*this.numColumns;i--)t[e++]=i;for(r=this.numRows-2;r>=0;r--)t[e++]=r*this.numColumns;return t},g}),i("shapes/GeographicText",["../error/ArgumentError","../util/Logger","../shapes/Text","../geom/Vec3"],function(t,e,i,r){"use strict";var n=function(r,n){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"Text","constructor","missingPosition"));i.call(this,n),this.position=r,this.declutterGroup=1};return n.placePoint=new r(0,0,0),n.prototype=Object.create(i.prototype),n.prototype.clone=function(){var t=new n(this.position,this.text);return t.copy(this),t.pickDelegate=this.pickDelegate?this.pickDelegate:this,t},n.prototype.render=function(t){t.globe.projectionLimits&&!t.globe.projectionLimits.containsLocation(this.position.latitude,this.position.longitude)||i.prototype.render.call(this,t)},n.prototype.computeScreenPointAndEyeDistance=function(t){return t.surfacePointForMode(this.position.latitude,this.position.longitude,this.position.altitude,this.altitudeMode,n.placePoint),!!t.navigatorState.frustumInModelCoordinates.containsPoint(n.placePoint)&&(this.eyeDistance=this.alwaysOnTop?0:t.navigatorState.eyePoint.distanceTo(n.placePoint),!!t.navigatorState.projectWithDepth(n.placePoint,this.depthOffset,this.screenPoint))},n}),i("formats/geojson/GeoJSONConstants",[],function(){"use strict";var t=function(){};return t.FIELD_TYPE="type",t.FIELD_CRS="crs",t.FIELD_NAME="name",t.FIELD_BBOX="bbox",t.FIELD_COORDINATES="coordinates",t.FIELD_GEOMETRIES="geometries",t.FIELD_GEOMETRY="geometry",t.FIELD_PROPERTIES="properties",t.FIELD_FEATURES="features",t.FIELD_ID="id",t.TYPE_POINT="Point",t.TYPE_MULTI_POINT="MultiPoint",t.TYPE_LINE_STRING="LineString",t.TYPE_MULTI_LINE_STRING="MultiLineString",t.TYPE_POLYGON="Polygon",t.TYPE_MULTI_POLYGON="MultiPolygon",t.TYPE_GEOMETRY_COLLECTION="GeometryCollection",t.TYPE_FEATURE="Feature",t.TYPE_FEATURE_COLLECTION="FeatureCollection",t.FIELD_CRS_NAME="name",t.FIELD_CRS_LINK="link",t.WGS84_CRS="urn:ogc:def:crs:OGC:1.3:CRS84",t.EPSG4326_CRS="EPSG:4326",t}),i("formats/geojson/GeoJSONGeometry",["./GeoJSONConstants"],function(t){"use strict";var e=function(t,e,i){if(!t)throw new ArgumentError(Logger.logMessage(Logger.LEVEL_SEVERE,"GeoJSONGeometry","constructor","missingCoordinates"));if(!e)throw new ArgumentError(Logger.logMessage(Logger.LEVEL_SEVERE,"GeoJSONGeometry","constructor","missingType"));this._coordinates=t,this._type=e,this._bbox=i?i:null};return Object.defineProperties(e.prototype,{coordinates:{get:function(){return this._coordinates}},type:{get:function(){return this._type}},bbox:{get:function(){return this._bbox}}}),e.prototype.isPointType=function(){return this.type===t.TYPE_POINT},e.prototype.isMultiPointType=function(){return this.type===t.TYPE_MULTI_POINT},e.prototype.isLineStringType=function(){return this.type===t.TYPE_LINE_STRING},e.prototype.isMultiLineStringType=function(){return this.type===t.TYPE_MULTI_LINE_STRING},e.prototype.isPolygonType=function(){return this.type===t.TYPE_POLYGON},e.prototype.isMultiPolygonType=function(){return this.type===t.TYPE_MULTI_POLYGON},e}),i("formats/geojson/GeoJSONGeometryCollection",["../../error/ArgumentError","./GeoJSONConstants","../../util/Logger"],function(t,e,i){"use strict";var r=function(e,r){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryCollection","constructor","missingGeometries"));if("[object Array]"!==Object.prototype.toString.call(e))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryCollection","constructor","invalidGeometries"));this._geometries=e,this._bbox=r};return Object.defineProperties(r.prototype,{geometries:{get:function(){return this._geometries}},bbox:{get:function(){return this._bbox}}}),r}),i("formats/geojson/GeoJSONGeometryLineString",["../../error/ArgumentError","./GeoJSONGeometry","../../util/Logger"],function(t,e,i){"use strict";var r=function(r,n,o){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryLineString","constructor","missingCoordinates"));if(r.length<2||r[0].length<2)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryLineString","constructor","invalidNumberOfCoordinates"));if("[object Array]"!==Object.prototype.toString.call(r[0])||"[object Number]"!==Object.prototype.toString.call(r[0][0]))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryLineString","constructor","invalidCoordinatesType"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryLineString","constructor","missingType"));e.call(this,r,n,o)};return r.prototype=Object.create(e.prototype),r}),i("formats/geojson/GeoJSONGeometryMultiLineString",["../../error/ArgumentError","./GeoJSONGeometry","../../util/Logger"],function(t,e,i){"use strict";var r=function(r,n,o){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryMultiLineString","constructor","missingCoordinates"));if(r[0].length<2||r[0][0].length<2)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryMultiLineString","constructor","invalidNumberOfCoordinates"));if("[object Array]"!==Object.prototype.toString.call(r[0])||"[object Array]"!==Object.prototype.toString.call(r[0][0])||"[object Number]"!==Object.prototype.toString.call(r[0][0][0]))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryMultiLineString","constructor","invalidCoordinatesType"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryLineString","constructor","missingType"));e.call(this,r,n,o)};return r.prototype=Object.create(e.prototype),r}),i("formats/geojson/GeoJSONGeometryMultiPoint",["../../error/ArgumentError","./GeoJSONGeometry","../../util/Logger"],function(t,e,i){"use strict";var r=function(r,n,o){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryMultiPoint","constructor","missingCoordinates"));if(r[0].length<2)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryMultiPoint","constructor","invalidNumberOfCoordinates"));if("[object Array]"!==Object.prototype.toString.call(r[0])||"[object Number]"!==Object.prototype.toString.call(r[0][0]))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryMultiPoint","constructor","invalidCoordinatesType"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPoint","constructor","missingType"));e.call(this,r,n,o)};return r.prototype=Object.create(e.prototype),r}),i("formats/geojson/GeoJSONGeometryMultiPolygon",["../../error/ArgumentError","./GeoJSONGeometry","../../util/Logger"],function(t,e,i){"use strict";var r=function(r,n,o){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryMultiPolygon","constructor","missingCoordinates"));if("[object Array]"!==Object.prototype.toString.call(r[0])||"[object Array]"!==Object.prototype.toString.call(r[0][0])||"[object Array]"!==Object.prototype.toString.call(r[0][0][0])||"[object Number]"!==Object.prototype.toString.call(r[0][0][0][0]))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPolygon","constructor","invalidCoordinatesType"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPolygon","constructor","missingType"));e.call(this,r,n,o)};return r.prototype=Object.create(e.prototype),r}),i("formats/geojson/GeoJSONGeometryPoint",["../../error/ArgumentError","./GeoJSONGeometry","../../util/Logger"],function(t,e,i){"use strict";var r=function(r,n,o){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPoint","constructor","missingCoordinates"));if(r.length<2)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPoint","constructor","invalidNumberOfCoordinates"));if("[object Array]"!==Object.prototype.toString.call(r)||"[object Number]"!==Object.prototype.toString.call(r[0]))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPoint","constructor","invalidCoordinatesType"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPoint","constructor","missingType"));e.call(this,r,n,o)};return r.prototype=Object.create(e.prototype),r}),i("formats/geojson/GeoJSONGeometryPolygon",["../../error/ArgumentError","./GeoJSONGeometry","../../util/Logger"],function(t,e,i){"use strict";var r=function(r,n,o){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPolygon","constructor","missingCoordinates"));if(r[0].length<2||r[0][0].length<2)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPolygon","constructor","invalidNumberOfCoordinates"));
if("[object Array]"!==Object.prototype.toString.call(r[0])||"[object Array]"!==Object.prototype.toString.call(r[0][0])||"[object Number]"!==Object.prototype.toString.call(r[0][0][0]))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPolygon","constructor","invalidCoordinatesType"));if(r[0][0]!==r[0][r.length-1])throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPolygon","constructor","invalidLinearRing"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONGeometryPolygon","constructor","missingType"));e.call(this,r,n,o)};return r.prototype=Object.create(e.prototype),r}),!function(t){if("object"==typeof exports)module.exports=t();else if("function"==typeof i&&i.amd)i("util/proj4-src",t);else{var e;"undefined"!=typeof window?e=window:"undefined"!=typeof global?e=global:"undefined"!=typeof self&&(e=self),e.proj4=t()}}(function(){return function t(i,r,n){function o(a,l){if(!r[a]){if(!i[a]){var h="function"==typeof e&&e;if(!l&&h)return h(a,!0);if(s)return s(a,!0);throw new Error("Cannot find module '"+a+"'")}var u=r[a]={exports:{}};i[a][0].call(u.exports,function(t){var e=i[a][1][t];return o(e?e:t)},u,u.exports,t,i,r,n)}return r[a].exports}for(var s="function"==typeof e&&e,a=0;a<n.length;a++)o(n[a]);return o}({1:[function(t,e,i){function r(t,e,i){if(!(this instanceof r))return new r(t,e,i);if(Array.isArray(t))this.x=t[0],this.y=t[1],this.z=t[2]||0;else if("object"==typeof t)this.x=t.x,this.y=t.y,this.z=t.z||0;else if("string"==typeof t&&"undefined"==typeof e){var n=t.split(",");this.x=parseFloat(n[0],10),this.y=parseFloat(n[1],10),this.z=parseFloat(n[2],10)||0}else this.x=t,this.y=e,this.z=i||0;console.warn("proj4.Point will be removed in version 3, use proj4.toPoint")}var n=t("mgrs");r.fromMGRS=function(t){return new r(n.toPoint(t))},r.prototype.toMGRS=function(t){return n.forward([this.x,this.y],t)},e.exports=r},{mgrs:66}],2:[function(t,e,i){function r(t,e){if(!(this instanceof r))return new r(t);e=e||function(t){if(t)throw t};var i=n(t);if("object"!=typeof i)return void e(t);var s=a(i),l=r.projections.get(s.projName);l?(o(this,s),o(this,l),this.init(),e(null,this)):e(t)}var n=t("./parseCode"),o=t("./extend"),s=t("./projections"),a=t("./deriveConstants");r.projections=s,r.projections.start(),e.exports=r},{"./deriveConstants":32,"./extend":33,"./parseCode":36,"./projections":38}],3:[function(t,e,i){e.exports=function(t,e,i){var r,n,o,s=i.x,a=i.y,l=i.z||0;for(o=0;o<3;o++)if(!e||2!==o||void 0!==i.z)switch(0===o?(r=s,n="x"):1===o?(r=a,n="y"):(r=l,n="z"),t.axis[o]){case"e":i[n]=r;break;case"w":i[n]=-r;break;case"n":i[n]=r;break;case"s":i[n]=-r;break;case"u":void 0!==i[n]&&(i.z=r);break;case"d":void 0!==i[n]&&(i.z=-r);break;default:return null}return i}},{}],4:[function(t,e,i){var r=Math.PI/2,n=t("./sign");e.exports=function(t){return Math.abs(t)<r?t:t-n(t)*Math.PI}},{"./sign":21}],5:[function(t,e,i){var r=2*Math.PI,n=3.14159265359,o=t("./sign");e.exports=function(t){return Math.abs(t)<=n?t:t-o(t)*r}},{"./sign":21}],6:[function(t,e,i){e.exports=function(t){return Math.abs(t)>1&&(t=t>1?1:-1),Math.asin(t)}},{}],7:[function(t,e,i){e.exports=function(t){return 1-.25*t*(1+t/16*(3+1.25*t))}},{}],8:[function(t,e,i){e.exports=function(t){return.375*t*(1+.25*t*(1+.46875*t))}},{}],9:[function(t,e,i){e.exports=function(t){return.05859375*t*t*(1+.75*t)}},{}],10:[function(t,e,i){e.exports=function(t){return t*t*t*(35/3072)}},{}],11:[function(t,e,i){e.exports=function(t,e,i){var r=e*i;return t/Math.sqrt(1-r*r)}},{}],12:[function(t,e,i){e.exports=function(t,e,i,r,n){var o,s;o=t/e;for(var a=0;a<15;a++)if(s=(t-(e*o-i*Math.sin(2*o)+r*Math.sin(4*o)-n*Math.sin(6*o)))/(e-2*i*Math.cos(2*o)+4*r*Math.cos(4*o)-6*n*Math.cos(6*o)),o+=s,Math.abs(s)<=1e-10)return o;return NaN}},{}],13:[function(t,e,i){var r=Math.PI/2;e.exports=function(t,e){var i=1-(1-t*t)/(2*t)*Math.log((1-t)/(1+t));if(Math.abs(Math.abs(e)-i)<1e-6)return e<0?-1*r:r;for(var n,o,s,a,l=Math.asin(.5*e),h=0;h<30;h++)if(o=Math.sin(l),s=Math.cos(l),a=t*o,n=Math.pow(1-a*a,2)/(2*s)*(e/(1-t*t)-o/(1-a*a)+.5/t*Math.log((1-a)/(1+a))),l+=n,Math.abs(n)<=1e-10)return l;return NaN}},{}],14:[function(t,e,i){e.exports=function(t,e,i,r,n){return t*n-e*Math.sin(2*n)+i*Math.sin(4*n)-r*Math.sin(6*n)}},{}],15:[function(t,e,i){e.exports=function(t,e,i){var r=t*e;return i/Math.sqrt(1-r*r)}},{}],16:[function(t,e,i){var r=Math.PI/2;e.exports=function(t,e){for(var i,n,o=.5*t,s=r-2*Math.atan(e),a=0;a<=15;a++)if(i=t*Math.sin(s),n=r-2*Math.atan(e*Math.pow((1-i)/(1+i),o))-s,s+=n,Math.abs(n)<=1e-10)return s;return-9999}},{}],17:[function(t,e,i){var r=1,n=.25,o=.046875,s=.01953125,a=.01068115234375,l=.75,h=.46875,u=.013020833333333334,c=.007120768229166667,d=.3645833333333333,p=.005696614583333333,f=.3076171875;e.exports=function(t){var e=[];e[0]=r-t*(n+t*(o+t*(s+t*a))),e[1]=t*(l-t*(o+t*(s+t*a)));var i=t*t;return e[2]=i*(h-t*(u+t*c)),i*=t,e[3]=i*(d-t*p),e[4]=i*t*f,e}},{}],18:[function(t,e,i){var r=t("./pj_mlfn"),n=1e-10,o=20;e.exports=function(t,e,i){for(var s=1/(1-e),a=t,l=o;l;--l){var h=Math.sin(a),u=1-e*h*h;if(u=(r(a,h,Math.cos(a),i)-t)*(u*Math.sqrt(u))*s,a-=u,Math.abs(u)<n)return a}return a}},{"./pj_mlfn":19}],19:[function(t,e,i){e.exports=function(t,e,i,r){return i*=e,e*=e,r[0]*t-i*(r[1]+e*(r[2]+e*(r[3]+e*r[4])))}},{}],20:[function(t,e,i){e.exports=function(t,e){var i;return t>1e-7?(i=t*e,(1-t*t)*(e/(1-i*i)-.5/t*Math.log((1-i)/(1+i)))):2*e}},{}],21:[function(t,e,i){e.exports=function(t){return t<0?-1:1}},{}],22:[function(t,e,i){e.exports=function(t,e){return Math.pow((1-t)/(1+t),e)}},{}],23:[function(t,e,i){e.exports=function(t){var e={x:t[0],y:t[1]};return t.length>2&&(e.z=t[2]),t.length>3&&(e.m=t[3]),e}},{}],24:[function(t,e,i){var r=Math.PI/2;e.exports=function(t,e,i){var n=t*i,o=.5*t;return n=Math.pow((1-n)/(1+n),o),Math.tan(.5*(r-e))/n}},{}],25:[function(t,e,i){i.wgs84={towgs84:"0,0,0",ellipse:"WGS84",datumName:"WGS84"},i.ch1903={towgs84:"674.374,15.056,405.346",ellipse:"bessel",datumName:"swiss"},i.ggrs87={towgs84:"-199.87,74.79,246.62",ellipse:"GRS80",datumName:"Greek_Geodetic_Reference_System_1987"},i.nad83={towgs84:"0,0,0",ellipse:"GRS80",datumName:"North_American_Datum_1983"},i.nad27={nadgrids:"@conus,@alaska,@ntv2_0.gsb,@ntv1_can.dat",ellipse:"clrk66",datumName:"North_American_Datum_1927"},i.potsdam={towgs84:"606.0,23.0,413.0",ellipse:"bessel",datumName:"Potsdam Rauenberg 1950 DHDN"},i.carthage={towgs84:"-263.0,6.0,431.0",ellipse:"clark80",datumName:"Carthage 1934 Tunisia"},i.hermannskogel={towgs84:"653.0,-212.0,449.0",ellipse:"bessel",datumName:"Hermannskogel"},i.ire65={towgs84:"482.530,-130.596,564.557,-1.042,-0.214,-0.631,8.15",ellipse:"mod_airy",datumName:"Ireland 1965"},i.rassadiran={towgs84:"-133.63,-157.5,-158.62",ellipse:"intl",datumName:"Rassadiran"},i.nzgd49={towgs84:"59.47,-5.04,187.44,0.47,-0.1,1.024,-4.5993",ellipse:"intl",datumName:"New Zealand Geodetic Datum 1949"},i.osgb36={towgs84:"446.448,-125.157,542.060,0.1502,0.2470,0.8421,-20.4894",ellipse:"airy",datumName:"Airy 1830"},i.s_jtsk={towgs84:"589,76,480",ellipse:"bessel",datumName:"S-JTSK (Ferro)"},i.beduaram={towgs84:"-106,-87,188",ellipse:"clrk80",datumName:"Beduaram"},i.gunung_segara={towgs84:"-403,684,41",ellipse:"bessel",datumName:"Gunung Segara Jakarta"},i.rnb72={towgs84:"106.869,-52.2978,103.724,-0.33657,0.456955,-1.84218,1",ellipse:"intl",datumName:"Reseau National Belge 1972"}},{}],26:[function(t,e,i){i.MERIT={a:6378137,rf:298.257,ellipseName:"MERIT 1983"},i.SGS85={a:6378136,rf:298.257,ellipseName:"Soviet Geodetic System 85"},i.GRS80={a:6378137,rf:298.257222101,ellipseName:"GRS 1980(IUGG, 1980)"},i.IAU76={a:6378140,rf:298.257,ellipseName:"IAU 1976"},i.airy={a:6377563.396,b:6356256.91,ellipseName:"Airy 1830"},i.APL4={a:6378137,rf:298.25,ellipseName:"Appl. Physics. 1965"},i.NWL9D={a:6378145,rf:298.25,ellipseName:"Naval Weapons Lab., 1965"},i.mod_airy={a:6377340.189,b:6356034.446,ellipseName:"Modified Airy"},i.andrae={a:6377104.43,rf:300,ellipseName:"Andrae 1876 (Den., Iclnd.)"},i.aust_SA={a:6378160,rf:298.25,ellipseName:"Australian Natl & S. Amer. 1969"},i.GRS67={a:6378160,rf:298.247167427,ellipseName:"GRS 67(IUGG 1967)"},i.bessel={a:6377397.155,rf:299.1528128,ellipseName:"Bessel 1841"},i.bess_nam={a:6377483.865,rf:299.1528128,ellipseName:"Bessel 1841 (Namibia)"},i.clrk66={a:6378206.4,b:6356583.8,ellipseName:"Clarke 1866"},i.clrk80={a:6378249.145,rf:293.4663,ellipseName:"Clarke 1880 mod."},i.clrk58={a:6378293.645208759,rf:294.2606763692654,ellipseName:"Clarke 1858"},i.CPM={a:6375738.7,rf:334.29,ellipseName:"Comm. des Poids et Mesures 1799"},i.delmbr={a:6376428,rf:311.5,ellipseName:"Delambre 1810 (Belgium)"},i.engelis={a:6378136.05,rf:298.2566,ellipseName:"Engelis 1985"},i.evrst30={a:6377276.345,rf:300.8017,ellipseName:"Everest 1830"},i.evrst48={a:6377304.063,rf:300.8017,ellipseName:"Everest 1948"},i.evrst56={a:6377301.243,rf:300.8017,ellipseName:"Everest 1956"},i.evrst69={a:6377295.664,rf:300.8017,ellipseName:"Everest 1969"},i.evrstSS={a:6377298.556,rf:300.8017,ellipseName:"Everest (Sabah & Sarawak)"},i.fschr60={a:6378166,rf:298.3,ellipseName:"Fischer (Mercury Datum) 1960"},i.fschr60m={a:6378155,rf:298.3,ellipseName:"Fischer 1960"},i.fschr68={a:6378150,rf:298.3,ellipseName:"Fischer 1968"},i.helmert={a:6378200,rf:298.3,ellipseName:"Helmert 1906"},i.hough={a:6378270,rf:297,ellipseName:"Hough"},i.intl={a:6378388,rf:297,ellipseName:"International 1909 (Hayford)"},i.kaula={a:6378163,rf:298.24,ellipseName:"Kaula 1961"},i.lerch={a:6378139,rf:298.257,ellipseName:"Lerch 1979"},i.mprts={a:6397300,rf:191,ellipseName:"Maupertius 1738"},i.new_intl={a:6378157.5,b:6356772.2,ellipseName:"New International 1967"},i.plessis={a:6376523,rf:6355863,ellipseName:"Plessis 1817 (France)"},i.krass={a:6378245,rf:298.3,ellipseName:"Krassovsky, 1942"},i.SEasia={a:6378155,b:6356773.3205,ellipseName:"Southeast Asia"},i.walbeck={a:6376896,b:6355834.8467,ellipseName:"Walbeck"},i.WGS60={a:6378165,rf:298.3,ellipseName:"WGS 60"},i.WGS66={a:6378145,rf:298.25,ellipseName:"WGS 66"},i.WGS7={a:6378135,rf:298.26,ellipseName:"WGS 72"},i.WGS84={a:6378137,rf:298.257223563,ellipseName:"WGS 84"},i.sphere={a:6370997,b:6370997,ellipseName:"Normal Sphere (r=6370997)"}},{}],27:[function(t,e,i){i.greenwich=0,i.lisbon=-9.131906111111,i.paris=2.337229166667,i.bogota=-74.080916666667,i.madrid=-3.687938888889,i.rome=12.452333333333,i.bern=7.439583333333,i.jakarta=106.807719444444,i.ferro=-17.666666666667,i.brussels=4.367975,i.stockholm=18.058277777778,i.athens=23.7163375,i.oslo=10.722916666667},{}],28:[function(t,e,i){function r(t,e,i){var r;return Array.isArray(i)?(r=a(t,e,i),3===i.length?[r.x,r.y,r.z]:[r.x,r.y]):a(t,e,i)}function n(t){return t instanceof s?t:t.oProj?t.oProj:s(t)}function o(t,e,i){t=n(t);var o,s=!1;return"undefined"==typeof e?(e=t,t=l,s=!0):("undefined"!=typeof e.x||Array.isArray(e))&&(i=e,e=t,t=l,s=!0),e=n(e),i?r(t,e,i):(o={forward:function(i){return r(t,e,i)},inverse:function(i){return r(e,t,i)}},s&&(o.oProj=e),o)}var s=t("./Proj"),a=t("./transform"),l=s("WGS84");e.exports=o},{"./Proj":2,"./transform":64}],29:[function(t,e,i){var r=Math.PI/2,n=1,o=2,s=3,a=4,l=5,h=484813681109536e-20,u=1.0026,c=.3826834323650898,d=function(t){if(!(this instanceof d))return new d(t);if(this.datum_type=a,t){if(t.datumCode&&"none"===t.datumCode&&(this.datum_type=l),t.datum_params){for(var e=0;e<t.datum_params.length;e++)t.datum_params[e]=parseFloat(t.datum_params[e]);0===t.datum_params[0]&&0===t.datum_params[1]&&0===t.datum_params[2]||(this.datum_type=n),t.datum_params.length>3&&(0===t.datum_params[3]&&0===t.datum_params[4]&&0===t.datum_params[5]&&0===t.datum_params[6]||(this.datum_type=o,t.datum_params[3]*=h,t.datum_params[4]*=h,t.datum_params[5]*=h,t.datum_params[6]=t.datum_params[6]/1e6+1))}this.datum_type=t.grids?s:this.datum_type,this.a=t.a,this.b=t.b,this.es=t.es,this.ep2=t.ep2,this.datum_params=t.datum_params,this.datum_type===s&&(this.grids=t.grids)}};d.prototype={compare_datums:function(t){return this.datum_type===t.datum_type&&(!(this.a!==t.a||Math.abs(this.es-t.es)>5e-11)&&(this.datum_type===n?this.datum_params[0]===t.datum_params[0]&&this.datum_params[1]===t.datum_params[1]&&this.datum_params[2]===t.datum_params[2]:this.datum_type===o?this.datum_params[0]===t.datum_params[0]&&this.datum_params[1]===t.datum_params[1]&&this.datum_params[2]===t.datum_params[2]&&this.datum_params[3]===t.datum_params[3]&&this.datum_params[4]===t.datum_params[4]&&this.datum_params[5]===t.datum_params[5]&&this.datum_params[6]===t.datum_params[6]:this.datum_type!==s&&t.datum_type!==s||this.nadgrids===t.nadgrids))},geodetic_to_geocentric:function(t){var e,i,n,o,s,a,l,h=t.x,u=t.y,c=t.z?t.z:0,d=0;if(u<-r&&u>-1.001*r)u=-r;else if(u>r&&u<1.001*r)u=r;else if(u<-r||u>r)return null;return h>Math.PI&&(h-=2*Math.PI),s=Math.sin(u),l=Math.cos(u),a=s*s,o=this.a/Math.sqrt(1-this.es*a),e=(o+c)*l*Math.cos(h),i=(o+c)*l*Math.sin(h),n=(o*(1-this.es)+c)*s,t.x=e,t.y=i,t.z=n,d},geocentric_to_geodetic:function(t){var e,i,n,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_=1e-12,v=_*_,b=30,S=t.x,T=t.y,L=t.z?t.z:0;if(f=!1,e=Math.sqrt(S*S+T*T),i=Math.sqrt(S*S+T*T+L*L),e/this.a<_){if(f=!0,m=0,i/this.a<_)return E=r,void(y=-this.b)}else m=Math.atan2(T,S);n=L/i,o=e/i,s=1/Math.sqrt(1-this.es*(2-this.es)*o*o),h=o*(1-this.es)*s,u=n*s,g=0;do g++,l=this.a/Math.sqrt(1-this.es*u*u),y=e*h+L*u-l*(1-this.es*u*u),a=this.es*l/(l+y),s=1/Math.sqrt(1-a*(2-a)*o*o),c=o*(1-a)*s,d=n*s,p=d*h-c*u,h=c,u=d;while(p*p>v&&g<b);return E=Math.atan(d/Math.abs(c)),t.x=m,t.y=E,t.z=y,t},geocentric_to_geodetic_noniter:function(t){var e,i,n,o,s,a,l,h,d,p,f,g,m,E,y,_,v,b=t.x,S=t.y,T=t.z?t.z:0;if(b=parseFloat(b),S=parseFloat(S),T=parseFloat(T),v=!1,0!==b)e=Math.atan2(S,b);else if(S>0)e=r;else if(S<0)e=-r;else if(v=!0,e=0,T>0)i=r;else{if(!(T<0))return i=r,void(n=-this.b);i=-r}return s=b*b+S*S,o=Math.sqrt(s),a=T*u,h=Math.sqrt(a*a+s),p=a/h,g=o/h,f=p*p*p,l=T+this.b*this.ep2*f,_=o-this.a*this.es*g*g*g,d=Math.sqrt(l*l+_*_),m=l/d,E=_/d,y=this.a/Math.sqrt(1-this.es*m*m),n=E>=c?o/E-y:E<=-c?o/-E-y:T/m+y*(this.es-1),v===!1&&(i=Math.atan(m/E)),t.x=e,t.y=i,t.z=n,t},geocentric_to_wgs84:function(t){if(this.datum_type===n)t.x+=this.datum_params[0],t.y+=this.datum_params[1],t.z+=this.datum_params[2];else if(this.datum_type===o){var e=this.datum_params[0],i=this.datum_params[1],r=this.datum_params[2],s=this.datum_params[3],a=this.datum_params[4],l=this.datum_params[5],h=this.datum_params[6],u=h*(t.x-l*t.y+a*t.z)+e,c=h*(l*t.x+t.y-s*t.z)+i,d=h*(-a*t.x+s*t.y+t.z)+r;t.x=u,t.y=c,t.z=d}},geocentric_from_wgs84:function(t){if(this.datum_type===n)t.x-=this.datum_params[0],t.y-=this.datum_params[1],t.z-=this.datum_params[2];else if(this.datum_type===o){var e=this.datum_params[0],i=this.datum_params[1],r=this.datum_params[2],s=this.datum_params[3],a=this.datum_params[4],l=this.datum_params[5],h=this.datum_params[6],u=(t.x-e)/h,c=(t.y-i)/h,d=(t.z-r)/h;t.x=u+l*c-a*d,t.y=-l*u+c+s*d,t.z=a*u-s*c+d}}},e.exports=d},{}],30:[function(t,e,i){var r=1,n=2,o=3,s=5,a=6378137,l=.006694379990141316;e.exports=function(t,e,i){function h(t){return t===r||t===n}var u,c,d;if(t.compare_datums(e))return i;if(t.datum_type===s||e.datum_type===s)return i;var p=t.a,f=t.es,g=e.a,m=e.es,E=t.datum_type;if(E===o)if(0===this.apply_gridshift(t,0,i))t.a=a,t.es=l;else{if(!t.datum_params)return t.a=p,t.es=t.es,i;for(u=1,c=0,d=t.datum_params.length;c<d;c++)u*=t.datum_params[c];if(0===u)return t.a=p,t.es=t.es,i;E=t.datum_params.length>3?n:r}return e.datum_type===o&&(e.a=a,e.es=l),(t.es!==e.es||t.a!==e.a||h(E)||h(e.datum_type))&&(t.geodetic_to_geocentric(i),h(t.datum_type)&&t.geocentric_to_wgs84(i),h(e.datum_type)&&e.geocentric_from_wgs84(i),e.geocentric_to_geodetic(i)),e.datum_type===o&&this.apply_gridshift(e,1,i),t.a=p,t.es=f,e.a=g,e.es=m,i}},{}],31:[function(t,e,i){function r(t){var e=this;if(2===arguments.length){var i=arguments[1];"string"==typeof i?"+"===i.charAt(0)?r[t]=o(arguments[1]):r[t]=s(arguments[1]):r[t]=i}else if(1===arguments.length){if(Array.isArray(t))return t.map(function(t){Array.isArray(t)?r.apply(e,t):r(t)});if("string"==typeof t){if(t in r)return r[t]}else"EPSG"in t?r["EPSG:"+t.EPSG]=t:"ESRI"in t?r["ESRI:"+t.ESRI]=t:"IAU2000"in t?r["IAU2000:"+t.IAU2000]=t:console.log(t);return}}var n=t("./global"),o=t("./projString"),s=t("./wkt");n(r),e.exports=r},{"./global":34,"./projString":37,"./wkt":65}],32:[function(t,e,i){var r=t("./constants/Datum"),n=t("./constants/Ellipsoid"),o=t("./extend"),s=t("./datum"),a=1e-10,l=.16666666666666666,h=.04722222222222222,u=.022156084656084655;e.exports=function(t){if(t.datumCode&&"none"!==t.datumCode){var e=r[t.datumCode];e&&(t.datum_params=e.towgs84?e.towgs84.split(","):null,t.ellps=e.ellipse,t.datumName=e.datumName?e.datumName:t.datumCode)}if(!t.a){var i=n[t.ellps]?n[t.ellps]:n.WGS84;o(t,i)}return t.rf&&!t.b&&(t.b=(1-1/t.rf)*t.a),(0===t.rf||Math.abs(t.a-t.b)<a)&&(t.sphere=!0,t.b=t.a),t.a2=t.a*t.a,t.b2=t.b*t.b,t.es=(t.a2-t.b2)/t.a2,t.e=Math.sqrt(t.es),t.R_A&&(t.a*=1-t.es*(l+t.es*(h+t.es*u)),t.a2=t.a*t.a,t.b2=t.b*t.b,t.es=0),t.ep2=(t.a2-t.b2)/t.b2,t.k0||(t.k0=1),t.axis||(t.axis="enu"),t.datum||(t.datum=s(t)),t}},{"./constants/Datum":25,"./constants/Ellipsoid":26,"./datum":29,"./extend":33}],33:[function(t,e,i){e.exports=function(t,e){t=t||{};var i,r;if(!e)return t;for(r in e)i=e[r],void 0!==i&&(t[r]=i);return t}},{}],34:[function(t,e,i){e.exports=function(t){t("EPSG:4326","+title=WGS 84 (long/lat) +proj=longlat +ellps=WGS84 +datum=WGS84 +units=degrees"),t("EPSG:4269","+title=NAD83 (long/lat) +proj=longlat +a=6378137.0 +b=6356752.31414036 +ellps=GRS80 +datum=NAD83 +units=degrees"),t("EPSG:3857","+title=WGS 84 / Pseudo-Mercator +proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +no_defs"),t.WGS84=t["EPSG:4326"],t["EPSG:3785"]=t["EPSG:3857"],t.GOOGLE=t["EPSG:3857"],t["EPSG:900913"]=t["EPSG:3857"],t["EPSG:102113"]=t["EPSG:3857"]}},{}],35:[function(t,e,i){var r=t("./core");r.defaultDatum="WGS84",r.Proj=t("./Proj"),r.WGS84=new r.Proj("WGS84"),r.Point=t("./Point"),r.toPoint=t("./common/toPoint"),r.defs=t("./defs"),r.transform=t("./transform"),r.mgrs=t("mgrs"),r.version=t("../package.json").version,t("./includedProjections")(r),e.exports=r},{"../package.json":67,"./Point":1,"./Proj":2,"./common/toPoint":23,"./core":28,"./defs":31,"./includedProjections":"gWUPNW","./transform":64,mgrs:66}],36:[function(t,e,i){function r(t){return"string"==typeof t}function n(t){return t in l}function o(t){var e=["GEOGCS","GEOCCS","PROJCS","LOCAL_CS"];return e.reduce(function(e,i){return e+1+t.indexOf(i)},0)}function s(t){return"+"===t[0]}function a(t){return r(t)?n(t)?l[t]:o(t)?h(t):s(t)?u(t):void 0:t}var l=t("./defs"),h=t("./wkt"),u=t("./projString");e.exports=a},{"./defs":31,"./projString":37,"./wkt":65}],37:[function(t,e,i){var r=.017453292519943295,n=t("./constants/PrimeMeridian");e.exports=function(t){var e={},i={};t.split("+").map(function(t){return t.trim()}).filter(function(t){return t}).forEach(function(t){var e=t.split("=");e.push(!0),i[e[0].toLowerCase()]=e[1]});var o,s,a,l={proj:"projName",datum:"datumCode",rf:function(t){e.rf=parseFloat(t)},lat_0:function(t){e.lat0=t*r},lat_1:function(t){e.lat1=t*r},lat_2:function(t){e.lat2=t*r},lat_ts:function(t){e.lat_ts=t*r},lon_0:function(t){e.long0=t*r},lon_1:function(t){e.long1=t*r},lon_2:function(t){e.long2=t*r},alpha:function(t){e.alpha=parseFloat(t)*r},lonc:function(t){e.longc=t*r},x_0:function(t){e.x0=parseFloat(t)},y_0:function(t){e.y0=parseFloat(t)},k_0:function(t){e.k0=parseFloat(t)},k:function(t){e.k0=parseFloat(t)},a:function(t){e.a=parseFloat(t)},b:function(t){e.b=parseFloat(t)},r_a:function(){e.R_A=!0},zone:function(t){e.zone=parseInt(t,10)},south:function(){e.utmSouth=!0},towgs84:function(t){e.datum_params=t.split(",").map(function(t){return parseFloat(t)})},to_meter:function(t){e.to_meter=parseFloat(t)},from_greenwich:function(t){e.from_greenwich=t*r},pm:function(t){e.from_greenwich=(n[t]?n[t]:parseFloat(t))*r},nadgrids:function(t){"@null"===t?e.datumCode="none":e.nadgrids=t},axis:function(t){var i="ewnsud";3===t.length&&i.indexOf(t.substr(0,1))!==-1&&i.indexOf(t.substr(1,1))!==-1&&i.indexOf(t.substr(2,1))!==-1&&(e.axis=t)}};for(o in i)s=i[o],o in l?(a=l[o],"function"==typeof a?a(s):e[a]=s):e[o]=s;return"string"==typeof e.datumCode&&"WGS84"!==e.datumCode&&(e.datumCode=e.datumCode.toLowerCase()),e}},{"./constants/PrimeMeridian":27}],38:[function(t,e,i){function r(t,e){var i=s.length;return t.names?(s[i]=t,t.names.forEach(function(t){o[t.toLowerCase()]=i}),this):(console.log(e),!0)}var n=[t("./projections/merc"),t("./projections/longlat")],o={},s=[];i.add=r,i.get=function(t){if(!t)return!1;var e=t.toLowerCase();return"undefined"!=typeof o[e]&&s[o[e]]?s[o[e]]:void 0},i.start=function(){n.forEach(r)}},{"./projections/longlat":50,"./projections/merc":51}],39:[function(t,e,i){var r=1e-10,n=t("../common/msfnz"),o=t("../common/qsfnz"),s=t("../common/adjust_lon"),a=t("../common/asinz");i.init=function(){Math.abs(this.lat1+this.lat2)<r||(this.temp=this.b/this.a,this.es=1-Math.pow(this.temp,2),this.e3=Math.sqrt(this.es),this.sin_po=Math.sin(this.lat1),this.cos_po=Math.cos(this.lat1),this.t1=this.sin_po,this.con=this.sin_po,this.ms1=n(this.e3,this.sin_po,this.cos_po),this.qs1=o(this.e3,this.sin_po,this.cos_po),this.sin_po=Math.sin(this.lat2),this.cos_po=Math.cos(this.lat2),this.t2=this.sin_po,this.ms2=n(this.e3,this.sin_po,this.cos_po),this.qs2=o(this.e3,this.sin_po,this.cos_po),this.sin_po=Math.sin(this.lat0),this.cos_po=Math.cos(this.lat0),this.t3=this.sin_po,this.qs0=o(this.e3,this.sin_po,this.cos_po),Math.abs(this.lat1-this.lat2)>r?this.ns0=(this.ms1*this.ms1-this.ms2*this.ms2)/(this.qs2-this.qs1):this.ns0=this.con,this.c=this.ms1*this.ms1+this.ns0*this.qs1,this.rh=this.a*Math.sqrt(this.c-this.ns0*this.qs0)/this.ns0)},i.forward=function(t){var e=t.x,i=t.y;this.sin_phi=Math.sin(i),this.cos_phi=Math.cos(i);var r=o(this.e3,this.sin_phi,this.cos_phi),n=this.a*Math.sqrt(this.c-this.ns0*r)/this.ns0,a=this.ns0*s(e-this.long0),l=n*Math.sin(a)+this.x0,h=this.rh-n*Math.cos(a)+this.y0;return t.x=l,t.y=h,t},i.inverse=function(t){var e,i,r,n,o,a;return t.x-=this.x0,t.y=this.rh-t.y+this.y0,this.ns0>=0?(e=Math.sqrt(t.x*t.x+t.y*t.y),r=1):(e=-Math.sqrt(t.x*t.x+t.y*t.y),r=-1),n=0,0!==e&&(n=Math.atan2(r*t.x,r*t.y)),r=e*this.ns0/this.a,this.sphere?a=Math.asin((this.c-r*r)/(2*this.ns0)):(i=(this.c-r*r)/this.ns0,a=this.phi1z(this.e3,i)),o=s(n/this.ns0+this.long0),t.x=o,t.y=a,t},i.phi1z=function(t,e){var i,n,o,s,l,h=a(.5*e);if(t<r)return h;for(var u=t*t,c=1;c<=25;c++)if(i=Math.sin(h),n=Math.cos(h),o=t*i,s=1-o*o,l=.5*s*s/n*(e/(1-u)-i/s+.5/t*Math.log((1-o)/(1+o))),h+=l,Math.abs(l)<=1e-7)return h;return null},i.names=["Albers_Conic_Equal_Area","Albers","aea"]},{"../common/adjust_lon":5,"../common/asinz":6,"../common/msfnz":15,"../common/qsfnz":20}],40:[function(t,e,i){var r=t("../common/adjust_lon"),n=Math.PI/2,o=1e-10,s=t("../common/mlfn"),a=t("../common/e0fn"),l=t("../common/e1fn"),h=t("../common/e2fn"),u=t("../common/e3fn"),c=t("../common/gN"),d=t("../common/asinz"),p=t("../common/imlfn");i.init=function(){this.sin_p12=Math.sin(this.lat0),this.cos_p12=Math.cos(this.lat0)},i.forward=function(t){var e,i,d,p,f,g,m,E,y,_,v,b,S,T,L,w,x,R,M,C,A,P,O,I=t.x,N=t.y,D=Math.sin(t.y),V=Math.cos(t.y),k=r(I-this.long0);return this.sphere?Math.abs(this.sin_p12-1)<=o?(t.x=this.x0+this.a*(n-N)*Math.sin(k),t.y=this.y0-this.a*(n-N)*Math.cos(k),t):Math.abs(this.sin_p12+1)<=o?(t.x=this.x0+this.a*(n+N)*Math.sin(k),t.y=this.y0+this.a*(n+N)*Math.cos(k),t):(R=this.sin_p12*D+this.cos_p12*V*Math.cos(k),w=Math.acos(R),x=w/Math.sin(w),t.x=this.x0+this.a*x*V*Math.sin(k),t.y=this.y0+this.a*x*(this.cos_p12*D-this.sin_p12*V*Math.cos(k)),t):(e=a(this.es),i=l(this.es),d=h(this.es),p=u(this.es),Math.abs(this.sin_p12-1)<=o?(f=this.a*s(e,i,d,p,n),g=this.a*s(e,i,d,p,N),t.x=this.x0+(f-g)*Math.sin(k),t.y=this.y0-(f-g)*Math.cos(k),t):Math.abs(this.sin_p12+1)<=o?(f=this.a*s(e,i,d,p,n),g=this.a*s(e,i,d,p,N),t.x=this.x0+(f+g)*Math.sin(k),t.y=this.y0+(f+g)*Math.cos(k),t):(m=D/V,E=c(this.a,this.e,this.sin_p12),y=c(this.a,this.e,D),_=Math.atan((1-this.es)*m+this.es*E*this.sin_p12/(y*V)),v=Math.atan2(Math.sin(k),this.cos_p12*Math.tan(_)-this.sin_p12*Math.cos(k)),M=0===v?Math.asin(this.cos_p12*Math.sin(_)-this.sin_p12*Math.cos(_)):Math.abs(Math.abs(v)-Math.PI)<=o?-Math.asin(this.cos_p12*Math.sin(_)-this.sin_p12*Math.cos(_)):Math.asin(Math.sin(k)*Math.cos(_)/Math.sin(v)),b=this.e*this.sin_p12/Math.sqrt(1-this.es),S=this.e*this.cos_p12*Math.cos(v)/Math.sqrt(1-this.es),T=b*S,L=S*S,C=M*M,A=C*M,P=A*M,O=P*M,w=E*M*(1-C*L*(1-L)/6+A/8*T*(1-2*L)+P/120*(L*(4-7*L)-3*b*b*(1-7*L))-O/48*T),t.x=this.x0+w*Math.sin(v),t.y=this.y0+w*Math.cos(v),t))},i.inverse=function(t){t.x-=this.x0,t.y-=this.y0;var e,i,f,g,m,E,y,_,v,b,S,T,L,w,x,R,M,C,A,P,O,I,N;if(this.sphere){if(e=Math.sqrt(t.x*t.x+t.y*t.y),e>2*n*this.a)return;return i=e/this.a,f=Math.sin(i),g=Math.cos(i),m=this.long0,Math.abs(e)<=o?E=this.lat0:(E=d(g*this.sin_p12+t.y*f*this.cos_p12/e),y=Math.abs(this.lat0)-n,m=r(Math.abs(y)<=o?this.lat0>=0?this.long0+Math.atan2(t.x,-t.y):this.long0-Math.atan2(-t.x,t.y):this.long0+Math.atan2(t.x*f,e*this.cos_p12*g-t.y*this.sin_p12*f))),t.x=m,t.y=E,t}return _=a(this.es),v=l(this.es),b=h(this.es),S=u(this.es),Math.abs(this.sin_p12-1)<=o?(T=this.a*s(_,v,b,S,n),e=Math.sqrt(t.x*t.x+t.y*t.y),L=T-e,E=p(L/this.a,_,v,b,S),m=r(this.long0+Math.atan2(t.x,-1*t.y)),t.x=m,t.y=E,t):Math.abs(this.sin_p12+1)<=o?(T=this.a*s(_,v,b,S,n),e=Math.sqrt(t.x*t.x+t.y*t.y),L=e-T,E=p(L/this.a,_,v,b,S),m=r(this.long0+Math.atan2(t.x,t.y)),t.x=m,t.y=E,t):(e=Math.sqrt(t.x*t.x+t.y*t.y),R=Math.atan2(t.x,t.y),w=c(this.a,this.e,this.sin_p12),M=Math.cos(R),C=this.e*this.cos_p12*M,A=-C*C/(1-this.es),P=3*this.es*(1-A)*this.sin_p12*this.cos_p12*M/(1-this.es),O=e/w,I=O-A*(1+A)*Math.pow(O,3)/6-P*(1+3*A)*Math.pow(O,4)/24,N=1-A*I*I/2-O*I*I*I/6,x=Math.asin(this.sin_p12*Math.cos(I)+this.cos_p12*Math.sin(I)*M),m=r(this.long0+Math.asin(Math.sin(R)*Math.sin(I)/Math.cos(x))),E=Math.atan((1-this.es*N*this.sin_p12/Math.sin(x))*Math.tan(x)/(1-this.es)),t.x=m,t.y=E,t)},i.names=["Azimuthal_Equidistant","aeqd"]},{"../common/adjust_lon":5,"../common/asinz":6,"../common/e0fn":7,"../common/e1fn":8,"../common/e2fn":9,"../common/e3fn":10,"../common/gN":11,"../common/imlfn":12,"../common/mlfn":14}],41:[function(t,e,i){var r=t("../common/mlfn"),n=t("../common/e0fn"),o=t("../common/e1fn"),s=t("../common/e2fn"),a=t("../common/e3fn"),l=t("../common/gN"),h=t("../common/adjust_lon"),u=t("../common/adjust_lat"),c=t("../common/imlfn"),d=Math.PI/2,p=1e-10;i.init=function(){this.sphere||(this.e0=n(this.es),this.e1=o(this.es),this.e2=s(this.es),this.e3=a(this.es),this.ml0=this.a*r(this.e0,this.e1,this.e2,this.e3,this.lat0))},i.forward=function(t){var e,i,n=t.x,o=t.y;if(n=h(n-this.long0),this.sphere)e=this.a*Math.asin(Math.cos(o)*Math.sin(n)),i=this.a*(Math.atan2(Math.tan(o),Math.cos(n))-this.lat0);else{var s=Math.sin(o),a=Math.cos(o),u=l(this.a,this.e,s),c=Math.tan(o)*Math.tan(o),d=n*Math.cos(o),p=d*d,f=this.es*a*a/(1-this.es),g=this.a*r(this.e0,this.e1,this.e2,this.e3,o);e=u*d*(1-p*c*(1/6-(8-c+8*f)*p/120)),i=g-this.ml0+u*s/a*p*(.5+(5-c+6*f)*p/24)}return t.x=e+this.x0,t.y=i+this.y0,t},i.inverse=function(t){t.x-=this.x0,t.y-=this.y0;var e,i,r=t.x/this.a,n=t.y/this.a;if(this.sphere){var o=n+this.lat0;e=Math.asin(Math.sin(o)*Math.cos(r)),i=Math.atan2(Math.tan(r),Math.cos(o))}else{var s=this.ml0/this.a+n,a=c(s,this.e0,this.e1,this.e2,this.e3);if(Math.abs(Math.abs(a)-d)<=p)return t.x=this.long0,t.y=d,n<0&&(t.y*=-1),t;var f=l(this.a,this.e,Math.sin(a)),g=f*f*f/this.a/this.a*(1-this.es),m=Math.pow(Math.tan(a),2),E=r*this.a/f,y=E*E;e=a-f*Math.tan(a)/g*E*E*(.5-(1+3*m)*E*E/24),i=E*(1-y*(m/3+(1+3*m)*m*y/15))/Math.cos(a)}return t.x=h(i+this.long0),t.y=u(e),t},i.names=["Cassini","Cassini_Soldner","cass"]},{"../common/adjust_lat":4,"../common/adjust_lon":5,"../common/e0fn":7,"../common/e1fn":8,"../common/e2fn":9,"../common/e3fn":10,"../common/gN":11,"../common/imlfn":12,"../common/mlfn":14}],42:[function(t,e,i){var r=t("../common/adjust_lon"),n=t("../common/qsfnz"),o=t("../common/msfnz"),s=t("../common/iqsfnz");i.init=function(){this.sphere||(this.k0=o(this.e,Math.sin(this.lat_ts),Math.cos(this.lat_ts)))},i.forward=function(t){var e,i,o=t.x,s=t.y,a=r(o-this.long0);if(this.sphere)e=this.x0+this.a*a*Math.cos(this.lat_ts),i=this.y0+this.a*Math.sin(s)/Math.cos(this.lat_ts);else{var l=n(this.e,Math.sin(s));e=this.x0+this.a*this.k0*a,i=this.y0+this.a*l*.5/this.k0}return t.x=e,t.y=i,t},i.inverse=function(t){t.x-=this.x0,t.y-=this.y0;var e,i;return this.sphere?(e=r(this.long0+t.x/this.a/Math.cos(this.lat_ts)),i=Math.asin(t.y/this.a*Math.cos(this.lat_ts))):(i=s(this.e,2*t.y*this.k0/this.a),e=r(this.long0+t.x/(this.a*this.k0))),t.x=e,t.y=i,t},i.names=["cea"]},{"../common/adjust_lon":5,"../common/iqsfnz":13,"../common/msfnz":15,"../common/qsfnz":20}],43:[function(t,e,i){var r=t("../common/adjust_lon"),n=t("../common/adjust_lat");i.init=function(){this.x0=this.x0||0,this.y0=this.y0||0,this.lat0=this.lat0||0,this.long0=this.long0||0,this.lat_ts=this.lat_ts||0,this.title=this.title||"Equidistant Cylindrical (Plate Carre)",this.rc=Math.cos(this.lat_ts)},i.forward=function(t){var e=t.x,i=t.y,o=r(e-this.long0),s=n(i-this.lat0);return t.x=this.x0+this.a*o*this.rc,t.y=this.y0+this.a*s,t},i.inverse=function(t){var e=t.x,i=t.y;return t.x=r(this.long0+(e-this.x0)/(this.a*this.rc)),t.y=n(this.lat0+(i-this.y0)/this.a),t},i.names=["Equirectangular","Equidistant_Cylindrical","eqc"]},{"../common/adjust_lat":4,"../common/adjust_lon":5}],44:[function(t,e,i){var r=t("../common/e0fn"),n=t("../common/e1fn"),o=t("../common/e2fn"),s=t("../common/e3fn"),a=t("../common/msfnz"),l=t("../common/mlfn"),h=t("../common/adjust_lon"),u=t("../common/adjust_lat"),c=t("../common/imlfn"),d=1e-10;i.init=function(){Math.abs(this.lat1+this.lat2)<d||(this.lat2=this.lat2||this.lat1,this.temp=this.b/this.a,this.es=1-Math.pow(this.temp,2),this.e=Math.sqrt(this.es),this.e0=r(this.es),this.e1=n(this.es),this.e2=o(this.es),this.e3=s(this.es),this.sinphi=Math.sin(this.lat1),this.cosphi=Math.cos(this.lat1),this.ms1=a(this.e,this.sinphi,this.cosphi),this.ml1=l(this.e0,this.e1,this.e2,this.e3,this.lat1),Math.abs(this.lat1-this.lat2)<d?this.ns=this.sinphi:(this.sinphi=Math.sin(this.lat2),this.cosphi=Math.cos(this.lat2),this.ms2=a(this.e,this.sinphi,this.cosphi),this.ml2=l(this.e0,this.e1,this.e2,this.e3,this.lat2),this.ns=(this.ms1-this.ms2)/(this.ml2-this.ml1)),this.g=this.ml1+this.ms1/this.ns,this.ml0=l(this.e0,this.e1,this.e2,this.e3,this.lat0),this.rh=this.a*(this.g-this.ml0))},i.forward=function(t){var e,i=t.x,r=t.y;if(this.sphere)e=this.a*(this.g-r);else{var n=l(this.e0,this.e1,this.e2,this.e3,r);e=this.a*(this.g-n)}var o=this.ns*h(i-this.long0),s=this.x0+e*Math.sin(o),a=this.y0+this.rh-e*Math.cos(o);return t.x=s,t.y=a,t},i.inverse=function(t){t.x-=this.x0,t.y=this.rh-t.y+this.y0;var e,i,r,n;this.ns>=0?(i=Math.sqrt(t.x*t.x+t.y*t.y),e=1):(i=-Math.sqrt(t.x*t.x+t.y*t.y),e=-1);var o=0;if(0!==i&&(o=Math.atan2(e*t.x,e*t.y)),this.sphere)return n=h(this.long0+o/this.ns),r=u(this.g-i/this.a),t.x=n,t.y=r,t;var s=this.g-i/this.a;return r=c(s,this.e0,this.e1,this.e2,this.e3),n=h(this.long0+o/this.ns),t.x=n,t.y=r,t},i.names=["Equidistant_Conic","eqdc"]},{"../common/adjust_lat":4,"../common/adjust_lon":5,"../common/e0fn":7,"../common/e1fn":8,"../common/e2fn":9,"../common/e3fn":10,"../common/imlfn":12,"../common/mlfn":14,"../common/msfnz":15}],45:[function(t,e,i){var r=Math.PI/4,n=t("../common/srat"),o=Math.PI/2,s=20;i.init=function(){var t=Math.sin(this.lat0),e=Math.cos(this.lat0);e*=e,this.rc=Math.sqrt(1-this.es)/(1-this.es*t*t),this.C=Math.sqrt(1+this.es*e*e/(1-this.es)),this.phic0=Math.asin(t/this.C),this.ratexp=.5*this.C*this.e,this.K=Math.tan(.5*this.phic0+r)/(Math.pow(Math.tan(.5*this.lat0+r),this.C)*n(this.e*t,this.ratexp))},i.forward=function(t){var e=t.x,i=t.y;return t.y=2*Math.atan(this.K*Math.pow(Math.tan(.5*i+r),this.C)*n(this.e*Math.sin(i),this.ratexp))-o,t.x=this.C*e,t},i.inverse=function(t){for(var e=1e-14,i=t.x/this.C,a=t.y,l=Math.pow(Math.tan(.5*a+r)/this.K,1/this.C),h=s;h>0&&(a=2*Math.atan(l*n(this.e*Math.sin(t.y),-.5*this.e))-o,
!(Math.abs(a-t.y)<e));--h)t.y=a;return h?(t.x=i,t.y=a,t):null},i.names=["gauss"]},{"../common/srat":22}],46:[function(t,e,i){var r=t("../common/adjust_lon"),n=1e-10,o=t("../common/asinz");i.init=function(){this.sin_p14=Math.sin(this.lat0),this.cos_p14=Math.cos(this.lat0),this.infinity_dist=1e3*this.a,this.rc=1},i.forward=function(t){var e,i,o,s,a,l,h,u,c=t.x,d=t.y;return o=r(c-this.long0),e=Math.sin(d),i=Math.cos(d),s=Math.cos(o),l=this.sin_p14*e+this.cos_p14*i*s,a=1,l>0||Math.abs(l)<=n?(h=this.x0+this.a*a*i*Math.sin(o)/l,u=this.y0+this.a*a*(this.cos_p14*e-this.sin_p14*i*s)/l):(h=this.x0+this.infinity_dist*i*Math.sin(o),u=this.y0+this.infinity_dist*(this.cos_p14*e-this.sin_p14*i*s)),t.x=h,t.y=u,t},i.inverse=function(t){var e,i,n,s,a,l;return t.x=(t.x-this.x0)/this.a,t.y=(t.y-this.y0)/this.a,t.x/=this.k0,t.y/=this.k0,(e=Math.sqrt(t.x*t.x+t.y*t.y))?(s=Math.atan2(e,this.rc),i=Math.sin(s),n=Math.cos(s),l=o(n*this.sin_p14+t.y*i*this.cos_p14/e),a=Math.atan2(t.x*i,e*this.cos_p14*n-t.y*this.sin_p14*i),a=r(this.long0+a)):(l=this.phic0,a=0),t.x=a,t.y=l,t},i.names=["gnom"]},{"../common/adjust_lon":5,"../common/asinz":6}],47:[function(t,e,i){var r=t("../common/adjust_lon");i.init=function(){this.a=6377397.155,this.es=.006674372230614,this.e=Math.sqrt(this.es),this.lat0||(this.lat0=.863937979737193),this.long0||(this.long0=.4334234309119251),this.k0||(this.k0=.9999),this.s45=.785398163397448,this.s90=2*this.s45,this.fi0=this.lat0,this.e2=this.es,this.e=Math.sqrt(this.e2),this.alfa=Math.sqrt(1+this.e2*Math.pow(Math.cos(this.fi0),4)/(1-this.e2)),this.uq=1.04216856380474,this.u0=Math.asin(Math.sin(this.fi0)/this.alfa),this.g=Math.pow((1+this.e*Math.sin(this.fi0))/(1-this.e*Math.sin(this.fi0)),this.alfa*this.e/2),this.k=Math.tan(this.u0/2+this.s45)/Math.pow(Math.tan(this.fi0/2+this.s45),this.alfa)*this.g,this.k1=this.k0,this.n0=this.a*Math.sqrt(1-this.e2)/(1-this.e2*Math.pow(Math.sin(this.fi0),2)),this.s0=1.37008346281555,this.n=Math.sin(this.s0),this.ro0=this.k1*this.n0/Math.tan(this.s0),this.ad=this.s90-this.uq},i.forward=function(t){var e,i,n,o,s,a,l,h=t.x,u=t.y,c=r(h-this.long0);return e=Math.pow((1+this.e*Math.sin(u))/(1-this.e*Math.sin(u)),this.alfa*this.e/2),i=2*(Math.atan(this.k*Math.pow(Math.tan(u/2+this.s45),this.alfa)/e)-this.s45),n=-c*this.alfa,o=Math.asin(Math.cos(this.ad)*Math.sin(i)+Math.sin(this.ad)*Math.cos(i)*Math.cos(n)),s=Math.asin(Math.cos(i)*Math.sin(n)/Math.cos(o)),a=this.n*s,l=this.ro0*Math.pow(Math.tan(this.s0/2+this.s45),this.n)/Math.pow(Math.tan(o/2+this.s45),this.n),t.y=l*Math.cos(a)/1,t.x=l*Math.sin(a)/1,this.czech||(t.y*=-1,t.x*=-1),t},i.inverse=function(t){var e,i,r,n,o,s,a,l,h=t.x;t.x=t.y,t.y=h,this.czech||(t.y*=-1,t.x*=-1),s=Math.sqrt(t.x*t.x+t.y*t.y),o=Math.atan2(t.y,t.x),n=o/Math.sin(this.s0),r=2*(Math.atan(Math.pow(this.ro0/s,1/this.n)*Math.tan(this.s0/2+this.s45))-this.s45),e=Math.asin(Math.cos(this.ad)*Math.sin(r)-Math.sin(this.ad)*Math.cos(r)*Math.cos(n)),i=Math.asin(Math.cos(r)*Math.sin(n)/Math.cos(e)),t.x=this.long0-i/this.alfa,a=e,l=0;var u=0;do t.y=2*(Math.atan(Math.pow(this.k,-1/this.alfa)*Math.pow(Math.tan(e/2+this.s45),1/this.alfa)*Math.pow((1+this.e*Math.sin(a))/(1-this.e*Math.sin(a)),this.e/2))-this.s45),Math.abs(a-t.y)<1e-10&&(l=1),a=t.y,u+=1;while(0===l&&u<15);return u>=15?null:t},i.names=["Krovak","krovak"]},{"../common/adjust_lon":5}],48:[function(t,e,i){var r=Math.PI/2,n=Math.PI/4,o=1e-10,s=t("../common/qsfnz"),a=t("../common/adjust_lon");i.S_POLE=1,i.N_POLE=2,i.EQUIT=3,i.OBLIQ=4,i.init=function(){var t=Math.abs(this.lat0);if(Math.abs(t-r)<o?this.mode=this.lat0<0?this.S_POLE:this.N_POLE:Math.abs(t)<o?this.mode=this.EQUIT:this.mode=this.OBLIQ,this.es>0){var e;switch(this.qp=s(this.e,1),this.mmf=.5/(1-this.es),this.apa=this.authset(this.es),this.mode){case this.N_POLE:this.dd=1;break;case this.S_POLE:this.dd=1;break;case this.EQUIT:this.rq=Math.sqrt(.5*this.qp),this.dd=1/this.rq,this.xmf=1,this.ymf=.5*this.qp;break;case this.OBLIQ:this.rq=Math.sqrt(.5*this.qp),e=Math.sin(this.lat0),this.sinb1=s(this.e,e)/this.qp,this.cosb1=Math.sqrt(1-this.sinb1*this.sinb1),this.dd=Math.cos(this.lat0)/(Math.sqrt(1-this.es*e*e)*this.rq*this.cosb1),this.ymf=(this.xmf=this.rq)/this.dd,this.xmf*=this.dd}}else this.mode===this.OBLIQ&&(this.sinph0=Math.sin(this.lat0),this.cosph0=Math.cos(this.lat0))},i.forward=function(t){var e,i,l,h,u,c,d,p,f,g,m=t.x,E=t.y;if(m=a(m-this.long0),this.sphere){if(u=Math.sin(E),g=Math.cos(E),l=Math.cos(m),this.mode===this.OBLIQ||this.mode===this.EQUIT){if(i=this.mode===this.EQUIT?1+g*l:1+this.sinph0*u+this.cosph0*g*l,i<=o)return null;i=Math.sqrt(2/i),e=i*g*Math.sin(m),i*=this.mode===this.EQUIT?u:this.cosph0*u-this.sinph0*g*l}else if(this.mode===this.N_POLE||this.mode===this.S_POLE){if(this.mode===this.N_POLE&&(l=-l),Math.abs(E+this.phi0)<o)return null;i=n-.5*E,i=2*(this.mode===this.S_POLE?Math.cos(i):Math.sin(i)),e=i*Math.sin(m),i*=l}}else{switch(d=0,p=0,f=0,l=Math.cos(m),h=Math.sin(m),u=Math.sin(E),c=s(this.e,u),this.mode!==this.OBLIQ&&this.mode!==this.EQUIT||(d=c/this.qp,p=Math.sqrt(1-d*d)),this.mode){case this.OBLIQ:f=1+this.sinb1*d+this.cosb1*p*l;break;case this.EQUIT:f=1+p*l;break;case this.N_POLE:f=r+E,c=this.qp-c;break;case this.S_POLE:f=E-r,c=this.qp+c}if(Math.abs(f)<o)return null;switch(this.mode){case this.OBLIQ:case this.EQUIT:f=Math.sqrt(2/f),i=this.mode===this.OBLIQ?this.ymf*f*(this.cosb1*d-this.sinb1*p*l):(f=Math.sqrt(2/(1+p*l)))*d*this.ymf,e=this.xmf*f*p*h;break;case this.N_POLE:case this.S_POLE:c>=0?(e=(f=Math.sqrt(c))*h,i=l*(this.mode===this.S_POLE?f:-f)):e=i=0}}return t.x=this.a*e+this.x0,t.y=this.a*i+this.y0,t},i.inverse=function(t){t.x-=this.x0,t.y-=this.y0;var e,i,n,s,l,h,u,c=t.x/this.a,d=t.y/this.a;if(this.sphere){var p,f=0,g=0;if(p=Math.sqrt(c*c+d*d),i=.5*p,i>1)return null;switch(i=2*Math.asin(i),this.mode!==this.OBLIQ&&this.mode!==this.EQUIT||(g=Math.sin(i),f=Math.cos(i)),this.mode){case this.EQUIT:i=Math.abs(p)<=o?0:Math.asin(d*g/p),c*=g,d=f*p;break;case this.OBLIQ:i=Math.abs(p)<=o?this.phi0:Math.asin(f*this.sinph0+d*g*this.cosph0/p),c*=g*this.cosph0,d=(f-Math.sin(i)*this.sinph0)*p;break;case this.N_POLE:d=-d,i=r-i;break;case this.S_POLE:i-=r}e=0!==d||this.mode!==this.EQUIT&&this.mode!==this.OBLIQ?Math.atan2(c,d):0}else{if(u=0,this.mode===this.OBLIQ||this.mode===this.EQUIT){if(c/=this.dd,d*=this.dd,h=Math.sqrt(c*c+d*d),h<o)return t.x=0,t.y=this.phi0,t;s=2*Math.asin(.5*h/this.rq),n=Math.cos(s),c*=s=Math.sin(s),this.mode===this.OBLIQ?(u=n*this.sinb1+d*s*this.cosb1/h,l=this.qp*u,d=h*this.cosb1*n-d*this.sinb1*s):(u=d*s/h,l=this.qp*u,d=h*n)}else if(this.mode===this.N_POLE||this.mode===this.S_POLE){if(this.mode===this.N_POLE&&(d=-d),l=c*c+d*d,!l)return t.x=0,t.y=this.phi0,t;u=1-l/this.qp,this.mode===this.S_POLE&&(u=-u)}e=Math.atan2(c,d),i=this.authlat(Math.asin(u),this.apa)}return t.x=a(this.long0+e),t.y=i,t},i.P00=.3333333333333333,i.P01=.17222222222222222,i.P02=.10257936507936508,i.P10=.06388888888888888,i.P11=.0664021164021164,i.P20=.016415012942191543,i.authset=function(t){var e,i=[];return i[0]=t*this.P00,e=t*t,i[0]+=e*this.P01,i[1]=e*this.P10,e*=t,i[0]+=e*this.P02,i[1]+=e*this.P11,i[2]=e*this.P20,i},i.authlat=function(t,e){var i=t+t;return t+e[0]*Math.sin(i)+e[1]*Math.sin(i+i)+e[2]*Math.sin(i+i+i)},i.names=["Lambert Azimuthal Equal Area","Lambert_Azimuthal_Equal_Area","laea"]},{"../common/adjust_lon":5,"../common/qsfnz":20}],49:[function(t,e,i){var r=1e-10,n=t("../common/msfnz"),o=t("../common/tsfnz"),s=Math.PI/2,a=t("../common/sign"),l=t("../common/adjust_lon"),h=t("../common/phi2z");i.init=function(){if(this.lat2||(this.lat2=this.lat1),this.k0||(this.k0=1),this.x0=this.x0||0,this.y0=this.y0||0,!(Math.abs(this.lat1+this.lat2)<r)){var t=this.b/this.a;this.e=Math.sqrt(1-t*t);var e=Math.sin(this.lat1),i=Math.cos(this.lat1),s=n(this.e,e,i),a=o(this.e,this.lat1,e),l=Math.sin(this.lat2),h=Math.cos(this.lat2),u=n(this.e,l,h),c=o(this.e,this.lat2,l),d=o(this.e,this.lat0,Math.sin(this.lat0));Math.abs(this.lat1-this.lat2)>r?this.ns=Math.log(s/u)/Math.log(a/c):this.ns=e,isNaN(this.ns)&&(this.ns=e),this.f0=s/(this.ns*Math.pow(a,this.ns)),this.rh=this.a*this.f0*Math.pow(d,this.ns),this.title||(this.title="Lambert Conformal Conic")}},i.forward=function(t){var e=t.x,i=t.y;Math.abs(2*Math.abs(i)-Math.PI)<=r&&(i=a(i)*(s-2*r));var n,h,u=Math.abs(Math.abs(i)-s);if(u>r)n=o(this.e,i,Math.sin(i)),h=this.a*this.f0*Math.pow(n,this.ns);else{if(u=i*this.ns,u<=0)return null;h=0}var c=this.ns*l(e-this.long0);return t.x=this.k0*(h*Math.sin(c))+this.x0,t.y=this.k0*(this.rh-h*Math.cos(c))+this.y0,t},i.inverse=function(t){var e,i,r,n,o,a=(t.x-this.x0)/this.k0,u=this.rh-(t.y-this.y0)/this.k0;this.ns>0?(e=Math.sqrt(a*a+u*u),i=1):(e=-Math.sqrt(a*a+u*u),i=-1);var c=0;if(0!==e&&(c=Math.atan2(i*a,i*u)),0!==e||this.ns>0){if(i=1/this.ns,r=Math.pow(e/(this.a*this.f0),i),n=h(this.e,r),n===-9999)return null}else n=-s;return o=l(c/this.ns+this.long0),t.x=o,t.y=n,t},i.names=["Lambert Tangential Conformal Conic Projection","Lambert_Conformal_Conic","Lambert_Conformal_Conic_2SP","lcc"]},{"../common/adjust_lon":5,"../common/msfnz":15,"../common/phi2z":16,"../common/sign":21,"../common/tsfnz":24}],50:[function(t,e,i){function r(t){return t}i.init=function(){},i.forward=r,i.inverse=r,i.names=["longlat","identity"]},{}],51:[function(t,e,i){var r=t("../common/msfnz"),n=Math.PI/2,o=1e-10,s=57.29577951308232,a=t("../common/adjust_lon"),l=Math.PI/4,h=t("../common/tsfnz"),u=t("../common/phi2z");i.init=function(){var t=this.b/this.a;this.es=1-t*t,"x0"in this||(this.x0=0),"y0"in this||(this.y0=0),this.e=Math.sqrt(this.es),this.lat_ts?this.sphere?this.k0=Math.cos(this.lat_ts):this.k0=r(this.e,Math.sin(this.lat_ts),Math.cos(this.lat_ts)):this.k0||(this.k?this.k0=this.k:this.k0=1)},i.forward=function(t){var e=t.x,i=t.y;if(i*s>90&&i*s<-90&&e*s>180&&e*s<-180)return null;var r,u;if(Math.abs(Math.abs(i)-n)<=o)return null;if(this.sphere)r=this.x0+this.a*this.k0*a(e-this.long0),u=this.y0+this.a*this.k0*Math.log(Math.tan(l+.5*i));else{var c=Math.sin(i),d=h(this.e,i,c);r=this.x0+this.a*this.k0*a(e-this.long0),u=this.y0-this.a*this.k0*Math.log(d)}return t.x=r,t.y=u,t},i.inverse=function(t){var e,i,r=t.x-this.x0,o=t.y-this.y0;if(this.sphere)i=n-2*Math.atan(Math.exp(-o/(this.a*this.k0)));else{var s=Math.exp(-o/(this.a*this.k0));if(i=u(this.e,s),i===-9999)return null}return e=a(this.long0+r/(this.a*this.k0)),t.x=e,t.y=i,t},i.names=["Mercator","Popular Visualisation Pseudo Mercator","Mercator_1SP","Mercator_Auxiliary_Sphere","merc"]},{"../common/adjust_lon":5,"../common/msfnz":15,"../common/phi2z":16,"../common/tsfnz":24}],52:[function(t,e,i){var r=t("../common/adjust_lon");i.init=function(){},i.forward=function(t){var e=t.x,i=t.y,n=r(e-this.long0),o=this.x0+this.a*n,s=this.y0+this.a*Math.log(Math.tan(Math.PI/4+i/2.5))*1.25;return t.x=o,t.y=s,t},i.inverse=function(t){t.x-=this.x0,t.y-=this.y0;var e=r(this.long0+t.x/this.a),i=2.5*(Math.atan(Math.exp(.8*t.y/this.a))-Math.PI/4);return t.x=e,t.y=i,t},i.names=["Miller_Cylindrical","mill"]},{"../common/adjust_lon":5}],53:[function(t,e,i){var r=t("../common/adjust_lon"),n=1e-10;i.init=function(){},i.forward=function(t){for(var e=t.x,i=t.y,o=r(e-this.long0),s=i,a=Math.PI*Math.sin(i),l=0;!0;l++){var h=-(s+Math.sin(s)-a)/(1+Math.cos(s));if(s+=h,Math.abs(h)<n)break}s/=2,Math.PI/2-Math.abs(i)<n&&(o=0);var u=.900316316158*this.a*o*Math.cos(s)+this.x0,c=1.4142135623731*this.a*Math.sin(s)+this.y0;return t.x=u,t.y=c,t},i.inverse=function(t){var e,i;t.x-=this.x0,t.y-=this.y0,i=t.y/(1.4142135623731*this.a),Math.abs(i)>.999999999999&&(i=.999999999999),e=Math.asin(i);var n=r(this.long0+t.x/(.900316316158*this.a*Math.cos(e)));n<-Math.PI&&(n=-Math.PI),n>Math.PI&&(n=Math.PI),i=(2*e+Math.sin(2*e))/Math.PI,Math.abs(i)>1&&(i=1);var o=Math.asin(i);return t.x=n,t.y=o,t},i.names=["Mollweide","moll"]},{"../common/adjust_lon":5}],54:[function(t,e,i){var r=484813681109536e-20;i.iterations=1,i.init=function(){this.A=[],this.A[1]=.6399175073,this.A[2]=-.1358797613,this.A[3]=.063294409,this.A[4]=-.02526853,this.A[5]=.0117879,this.A[6]=-.0055161,this.A[7]=.0026906,this.A[8]=-.001333,this.A[9]=67e-5,this.A[10]=-34e-5,this.B_re=[],this.B_im=[],this.B_re[1]=.7557853228,this.B_im[1]=0,this.B_re[2]=.249204646,this.B_im[2]=.003371507,this.B_re[3]=-.001541739,this.B_im[3]=.04105856,this.B_re[4]=-.10162907,this.B_im[4]=.01727609,this.B_re[5]=-.26623489,this.B_im[5]=-.36249218,this.B_re[6]=-.6870983,this.B_im[6]=-1.1651967,this.C_re=[],this.C_im=[],this.C_re[1]=1.3231270439,this.C_im[1]=0,this.C_re[2]=-.577245789,this.C_im[2]=-.007809598,this.C_re[3]=.508307513,this.C_im[3]=-.112208952,this.C_re[4]=-.15094762,this.C_im[4]=.18200602,this.C_re[5]=1.01418179,this.C_im[5]=1.64497696,this.C_re[6]=1.9660549,this.C_im[6]=2.5127645,this.D=[],this.D[1]=1.5627014243,this.D[2]=.5185406398,this.D[3]=-.03333098,this.D[4]=-.1052906,this.D[5]=-.0368594,this.D[6]=.007317,this.D[7]=.0122,this.D[8]=.00394,this.D[9]=-.0013},i.forward=function(t){var e,i=t.x,n=t.y,o=n-this.lat0,s=i-this.long0,a=o/r*1e-5,l=s,h=1,u=0;for(e=1;e<=10;e++)h*=a,u+=this.A[e]*h;var c,d,p=u,f=l,g=1,m=0,E=0,y=0;for(e=1;e<=6;e++)c=g*p-m*f,d=m*p+g*f,g=c,m=d,E=E+this.B_re[e]*g-this.B_im[e]*m,y=y+this.B_im[e]*g+this.B_re[e]*m;return t.x=y*this.a+this.x0,t.y=E*this.a+this.y0,t},i.inverse=function(t){var e,i,n,o=t.x,s=t.y,a=o-this.x0,l=s-this.y0,h=l/this.a,u=a/this.a,c=1,d=0,p=0,f=0;for(e=1;e<=6;e++)i=c*h-d*u,n=d*h+c*u,c=i,d=n,p=p+this.C_re[e]*c-this.C_im[e]*d,f=f+this.C_im[e]*c+this.C_re[e]*d;for(var g=0;g<this.iterations;g++){var m,E,y=p,_=f,v=h,b=u;for(e=2;e<=6;e++)m=y*p-_*f,E=_*p+y*f,y=m,_=E,v+=(e-1)*(this.B_re[e]*y-this.B_im[e]*_),b+=(e-1)*(this.B_im[e]*y+this.B_re[e]*_);y=1,_=0;var S=this.B_re[1],T=this.B_im[1];for(e=2;e<=6;e++)m=y*p-_*f,E=_*p+y*f,y=m,_=E,S+=e*(this.B_re[e]*y-this.B_im[e]*_),T+=e*(this.B_im[e]*y+this.B_re[e]*_);var L=S*S+T*T;p=(v*S+b*T)/L,f=(b*S-v*T)/L}var w=p,x=f,R=1,M=0;for(e=1;e<=9;e++)R*=w,M+=this.D[e]*R;var C=this.lat0+M*r*1e5,A=this.long0+x;return t.x=A,t.y=C,t},i.names=["New_Zealand_Map_Grid","nzmg"]},{}],55:[function(t,e,i){var r=t("../common/tsfnz"),n=t("../common/adjust_lon"),o=t("../common/phi2z"),s=Math.PI/2,a=Math.PI/4,l=1e-10;i.init=function(){this.no_off=this.no_off||!1,this.no_rot=this.no_rot||!1,isNaN(this.k0)&&(this.k0=1);var t=Math.sin(this.lat0),e=Math.cos(this.lat0),i=this.e*t;this.bl=Math.sqrt(1+this.es/(1-this.es)*Math.pow(e,4)),this.al=this.a*this.bl*this.k0*Math.sqrt(1-this.es)/(1-i*i);var o=r(this.e,this.lat0,t),s=this.bl/e*Math.sqrt((1-this.es)/(1-i*i));s*s<1&&(s=1);var a,l;if(isNaN(this.longc)){var h=r(this.e,this.lat1,Math.sin(this.lat1)),u=r(this.e,this.lat2,Math.sin(this.lat2));this.lat0>=0?this.el=(s+Math.sqrt(s*s-1))*Math.pow(o,this.bl):this.el=(s-Math.sqrt(s*s-1))*Math.pow(o,this.bl);var c=Math.pow(h,this.bl),d=Math.pow(u,this.bl);a=this.el/c,l=.5*(a-1/a);var p=(this.el*this.el-d*c)/(this.el*this.el+d*c),f=(d-c)/(d+c),g=n(this.long1-this.long2);this.long0=.5*(this.long1+this.long2)-Math.atan(p*Math.tan(.5*this.bl*g)/f)/this.bl,this.long0=n(this.long0);var m=n(this.long1-this.long0);this.gamma0=Math.atan(Math.sin(this.bl*m)/l),this.alpha=Math.asin(s*Math.sin(this.gamma0))}else a=this.lat0>=0?s+Math.sqrt(s*s-1):s-Math.sqrt(s*s-1),this.el=a*Math.pow(o,this.bl),l=.5*(a-1/a),this.gamma0=Math.asin(Math.sin(this.alpha)/s),this.long0=this.longc-Math.asin(l*Math.tan(this.gamma0))/this.bl;this.no_off?this.uc=0:this.lat0>=0?this.uc=this.al/this.bl*Math.atan2(Math.sqrt(s*s-1),Math.cos(this.alpha)):this.uc=-1*this.al/this.bl*Math.atan2(Math.sqrt(s*s-1),Math.cos(this.alpha))},i.forward=function(t){var e,i,o,h=t.x,u=t.y,c=n(h-this.long0);if(Math.abs(Math.abs(u)-s)<=l)o=u>0?-1:1,i=this.al/this.bl*Math.log(Math.tan(a+o*this.gamma0*.5)),e=-1*o*s*this.al/this.bl;else{var d=r(this.e,u,Math.sin(u)),p=this.el/Math.pow(d,this.bl),f=.5*(p-1/p),g=.5*(p+1/p),m=Math.sin(this.bl*c),E=(f*Math.sin(this.gamma0)-m*Math.cos(this.gamma0))/g;i=Math.abs(Math.abs(E)-1)<=l?Number.POSITIVE_INFINITY:.5*this.al*Math.log((1-E)/(1+E))/this.bl,e=Math.abs(Math.cos(this.bl*c))<=l?this.al*this.bl*c:this.al*Math.atan2(f*Math.cos(this.gamma0)+m*Math.sin(this.gamma0),Math.cos(this.bl*c))/this.bl}return this.no_rot?(t.x=this.x0+e,t.y=this.y0+i):(e-=this.uc,t.x=this.x0+i*Math.cos(this.alpha)+e*Math.sin(this.alpha),t.y=this.y0+e*Math.cos(this.alpha)-i*Math.sin(this.alpha)),t},i.inverse=function(t){var e,i;this.no_rot?(i=t.y-this.y0,e=t.x-this.x0):(i=(t.x-this.x0)*Math.cos(this.alpha)-(t.y-this.y0)*Math.sin(this.alpha),e=(t.y-this.y0)*Math.cos(this.alpha)+(t.x-this.x0)*Math.sin(this.alpha),e+=this.uc);var r=Math.exp(-1*this.bl*i/this.al),a=.5*(r-1/r),h=.5*(r+1/r),u=Math.sin(this.bl*e/this.al),c=(u*Math.cos(this.gamma0)+a*Math.sin(this.gamma0))/h,d=Math.pow(this.el/Math.sqrt((1+c)/(1-c)),1/this.bl);return Math.abs(c-1)<l?(t.x=this.long0,t.y=s):Math.abs(c+1)<l?(t.x=this.long0,t.y=-1*s):(t.y=o(this.e,d),t.x=n(this.long0-Math.atan2(a*Math.cos(this.gamma0)-u*Math.sin(this.gamma0),Math.cos(this.bl*e/this.al))/this.bl)),t},i.names=["Hotine_Oblique_Mercator","Hotine Oblique Mercator","Hotine_Oblique_Mercator_Azimuth_Natural_Origin","Hotine_Oblique_Mercator_Azimuth_Center","omerc"]},{"../common/adjust_lon":5,"../common/phi2z":16,"../common/tsfnz":24}],56:[function(t,e,i){var r=t("../common/e0fn"),n=t("../common/e1fn"),o=t("../common/e2fn"),s=t("../common/e3fn"),a=t("../common/adjust_lon"),l=t("../common/adjust_lat"),h=t("../common/mlfn"),u=1e-10,c=t("../common/gN"),d=20;i.init=function(){this.temp=this.b/this.a,this.es=1-Math.pow(this.temp,2),this.e=Math.sqrt(this.es),this.e0=r(this.es),this.e1=n(this.es),this.e2=o(this.es),this.e3=s(this.es),this.ml0=this.a*h(this.e0,this.e1,this.e2,this.e3,this.lat0)},i.forward=function(t){var e,i,r,n=t.x,o=t.y,s=a(n-this.long0);if(r=s*Math.sin(o),this.sphere)Math.abs(o)<=u?(e=this.a*s,i=-1*this.a*this.lat0):(e=this.a*Math.sin(r)/Math.tan(o),i=this.a*(l(o-this.lat0)+(1-Math.cos(r))/Math.tan(o)));else if(Math.abs(o)<=u)e=this.a*s,i=-1*this.ml0;else{var d=c(this.a,this.e,Math.sin(o))/Math.tan(o);e=d*Math.sin(r),i=this.a*h(this.e0,this.e1,this.e2,this.e3,o)-this.ml0+d*(1-Math.cos(r))}return t.x=e+this.x0,t.y=i+this.y0,t},i.inverse=function(t){var e,i,r,n,o,s,l,c,p;if(r=t.x-this.x0,n=t.y-this.y0,this.sphere)if(Math.abs(n+this.a*this.lat0)<=u)e=a(r/this.a+this.long0),i=0;else{s=this.lat0+n/this.a,l=r*r/this.a/this.a+s*s,c=s;var f;for(o=d;o;--o)if(f=Math.tan(c),p=-1*(s*(c*f+1)-c-.5*(c*c+l)*f)/((c-s)/f-1),c+=p,Math.abs(p)<=u){i=c;break}e=a(this.long0+Math.asin(r*Math.tan(c)/this.a)/Math.sin(i))}else if(Math.abs(n+this.ml0)<=u)i=0,e=a(this.long0+r/this.a);else{s=(this.ml0+n)/this.a,l=r*r/this.a/this.a+s*s,c=s;var g,m,E,y,_;for(o=d;o;--o)if(_=this.e*Math.sin(c),g=Math.sqrt(1-_*_)*Math.tan(c),m=this.a*h(this.e0,this.e1,this.e2,this.e3,c),E=this.e0-2*this.e1*Math.cos(2*c)+4*this.e2*Math.cos(4*c)-6*this.e3*Math.cos(6*c),y=m/this.a,p=(s*(g*y+1)-y-.5*g*(y*y+l))/(this.es*Math.sin(2*c)*(y*y+l-2*s*y)/(4*g)+(s-y)*(g*E-2/Math.sin(2*c))-E),c-=p,Math.abs(p)<=u){i=c;break}g=Math.sqrt(1-this.es*Math.pow(Math.sin(i),2))*Math.tan(i),e=a(this.long0+Math.asin(r*g/this.a)/Math.sin(i))}return t.x=e,t.y=i,t},i.names=["Polyconic","poly"]},{"../common/adjust_lat":4,"../common/adjust_lon":5,"../common/e0fn":7,"../common/e1fn":8,"../common/e2fn":9,"../common/e3fn":10,"../common/gN":11,"../common/mlfn":14}],57:[function(t,e,i){var r=t("../common/adjust_lon"),n=t("../common/adjust_lat"),o=t("../common/pj_enfn"),s=20,a=t("../common/pj_mlfn"),l=t("../common/pj_inv_mlfn"),h=Math.PI/2,u=1e-10,c=t("../common/asinz");i.init=function(){this.sphere?(this.n=1,this.m=0,this.es=0,this.C_y=Math.sqrt((this.m+1)/this.n),this.C_x=this.C_y/(this.m+1)):this.en=o(this.es)},i.forward=function(t){var e,i,n=t.x,o=t.y;if(n=r(n-this.long0),this.sphere){if(this.m)for(var l=this.n*Math.sin(o),h=s;h;--h){var c=(this.m*o+Math.sin(o)-l)/(this.m+Math.cos(o));if(o-=c,Math.abs(c)<u)break}else o=1!==this.n?Math.asin(this.n*Math.sin(o)):o;e=this.a*this.C_x*n*(this.m+Math.cos(o)),i=this.a*this.C_y*o}else{var d=Math.sin(o),p=Math.cos(o);i=this.a*a(o,d,p,this.en),e=this.a*n*p/Math.sqrt(1-this.es*d*d)}return t.x=e,t.y=i,t},i.inverse=function(t){var e,i,o,s;return t.x-=this.x0,o=t.x/this.a,t.y-=this.y0,e=t.y/this.a,this.sphere?(e/=this.C_y,o/=this.C_x*(this.m+Math.cos(e)),this.m?e=c((this.m*e+Math.sin(e))/this.n):1!==this.n&&(e=c(Math.sin(e)/this.n)),o=r(o+this.long0),e=n(e)):(e=l(t.y/this.a,this.es,this.en),s=Math.abs(e),s<h?(s=Math.sin(e),i=this.long0+t.x*Math.sqrt(1-this.es*s*s)/(this.a*Math.cos(e)),o=r(i)):s-u<h&&(o=this.long0)),t.x=o,t.y=e,t},i.names=["Sinusoidal","sinu"]},{"../common/adjust_lat":4,"../common/adjust_lon":5,"../common/asinz":6,"../common/pj_enfn":17,"../common/pj_inv_mlfn":18,"../common/pj_mlfn":19}],58:[function(t,e,i){i.init=function(){var t=this.lat0;this.lambda0=this.long0;var e=Math.sin(t),i=this.a,r=this.rf,n=1/r,o=2*n-Math.pow(n,2),s=this.e=Math.sqrt(o);this.R=this.k0*i*Math.sqrt(1-o)/(1-o*Math.pow(e,2)),this.alpha=Math.sqrt(1+o/(1-o)*Math.pow(Math.cos(t),4)),this.b0=Math.asin(e/this.alpha);var a=Math.log(Math.tan(Math.PI/4+this.b0/2)),l=Math.log(Math.tan(Math.PI/4+t/2)),h=Math.log((1+s*e)/(1-s*e));this.K=a-this.alpha*l+this.alpha*s/2*h},i.forward=function(t){var e=Math.log(Math.tan(Math.PI/4-t.y/2)),i=this.e/2*Math.log((1+this.e*Math.sin(t.y))/(1-this.e*Math.sin(t.y))),r=-this.alpha*(e+i)+this.K,n=2*(Math.atan(Math.exp(r))-Math.PI/4),o=this.alpha*(t.x-this.lambda0),s=Math.atan(Math.sin(o)/(Math.sin(this.b0)*Math.tan(n)+Math.cos(this.b0)*Math.cos(o))),a=Math.asin(Math.cos(this.b0)*Math.sin(n)-Math.sin(this.b0)*Math.cos(n)*Math.cos(o));return t.y=this.R/2*Math.log((1+Math.sin(a))/(1-Math.sin(a)))+this.y0,t.x=this.R*s+this.x0,t},i.inverse=function(t){for(var e=t.x-this.x0,i=t.y-this.y0,r=e/this.R,n=2*(Math.atan(Math.exp(i/this.R))-Math.PI/4),o=Math.asin(Math.cos(this.b0)*Math.sin(n)+Math.sin(this.b0)*Math.cos(n)*Math.cos(r)),s=Math.atan(Math.sin(r)/(Math.cos(this.b0)*Math.cos(r)-Math.sin(this.b0)*Math.tan(n))),a=this.lambda0+s/this.alpha,l=0,h=o,u=-1e3,c=0;Math.abs(h-u)>1e-7;){if(++c>20)return;l=1/this.alpha*(Math.log(Math.tan(Math.PI/4+o/2))-this.K)+this.e*Math.log(Math.tan(Math.PI/4+Math.asin(this.e*Math.sin(h))/2)),u=h,h=2*Math.atan(Math.exp(l))-Math.PI/2}return t.x=a,t.y=h,t},i.names=["somerc"]},{}],59:[function(t,e,i){var r=Math.PI/2,n=1e-10,o=t("../common/sign"),s=t("../common/msfnz"),a=t("../common/tsfnz"),l=t("../common/phi2z"),h=t("../common/adjust_lon");i.ssfn_=function(t,e,i){return e*=i,Math.tan(.5*(r+t))*Math.pow((1-e)/(1+e),.5*i)},i.init=function(){this.coslat0=Math.cos(this.lat0),this.sinlat0=Math.sin(this.lat0),this.sphere?1===this.k0&&!isNaN(this.lat_ts)&&Math.abs(this.coslat0)<=n&&(this.k0=.5*(1+o(this.lat0)*Math.sin(this.lat_ts))):(Math.abs(this.coslat0)<=n&&(this.lat0>0?this.con=1:this.con=-1),this.cons=Math.sqrt(Math.pow(1+this.e,1+this.e)*Math.pow(1-this.e,1-this.e)),1===this.k0&&!isNaN(this.lat_ts)&&Math.abs(this.coslat0)<=n&&(this.k0=.5*this.cons*s(this.e,Math.sin(this.lat_ts),Math.cos(this.lat_ts))/a(this.e,this.con*this.lat_ts,this.con*Math.sin(this.lat_ts))),this.ms1=s(this.e,this.sinlat0,this.coslat0),this.X0=2*Math.atan(this.ssfn_(this.lat0,this.sinlat0,this.e))-r,this.cosX0=Math.cos(this.X0),this.sinX0=Math.sin(this.X0))},i.forward=function(t){var e,i,o,s,l,u,c=t.x,d=t.y,p=Math.sin(d),f=Math.cos(d),g=h(c-this.long0);return Math.abs(Math.abs(c-this.long0)-Math.PI)<=n&&Math.abs(d+this.lat0)<=n?(t.x=NaN,t.y=NaN,t):this.sphere?(e=2*this.k0/(1+this.sinlat0*p+this.coslat0*f*Math.cos(g)),t.x=this.a*e*f*Math.sin(g)+this.x0,t.y=this.a*e*(this.coslat0*p-this.sinlat0*f*Math.cos(g))+this.y0,t):(i=2*Math.atan(this.ssfn_(d,p,this.e))-r,s=Math.cos(i),o=Math.sin(i),Math.abs(this.coslat0)<=n?(l=a(this.e,d*this.con,this.con*p),u=2*this.a*this.k0*l/this.cons,t.x=this.x0+u*Math.sin(c-this.long0),t.y=this.y0-this.con*u*Math.cos(c-this.long0),t):(Math.abs(this.sinlat0)<n?(e=2*this.a*this.k0/(1+s*Math.cos(g)),t.y=e*o):(e=2*this.a*this.k0*this.ms1/(this.cosX0*(1+this.sinX0*o+this.cosX0*s*Math.cos(g))),t.y=e*(this.cosX0*o-this.sinX0*s*Math.cos(g))+this.y0),t.x=e*s*Math.sin(g)+this.x0,t))},i.inverse=function(t){t.x-=this.x0,t.y-=this.y0;var e,i,o,s,a,u=Math.sqrt(t.x*t.x+t.y*t.y);if(this.sphere){var c=2*Math.atan(u/(.5*this.a*this.k0));return e=this.long0,i=this.lat0,u<=n?(t.x=e,t.y=i,t):(i=Math.asin(Math.cos(c)*this.sinlat0+t.y*Math.sin(c)*this.coslat0/u),e=h(Math.abs(this.coslat0)<n?this.lat0>0?this.long0+Math.atan2(t.x,-1*t.y):this.long0+Math.atan2(t.x,t.y):this.long0+Math.atan2(t.x*Math.sin(c),u*this.coslat0*Math.cos(c)-t.y*this.sinlat0*Math.sin(c))),t.x=e,t.y=i,t)}if(Math.abs(this.coslat0)<=n){if(u<=n)return i=this.lat0,e=this.long0,t.x=e,t.y=i,t;t.x*=this.con,t.y*=this.con,o=u*this.cons/(2*this.a*this.k0),i=this.con*l(this.e,o),e=this.con*h(this.con*this.long0+Math.atan2(t.x,-1*t.y))}else s=2*Math.atan(u*this.cosX0/(2*this.a*this.k0*this.ms1)),e=this.long0,u<=n?a=this.X0:(a=Math.asin(Math.cos(s)*this.sinX0+t.y*Math.sin(s)*this.cosX0/u),e=h(this.long0+Math.atan2(t.x*Math.sin(s),u*this.cosX0*Math.cos(s)-t.y*this.sinX0*Math.sin(s)))),i=-1*l(this.e,Math.tan(.5*(r+a)));return t.x=e,t.y=i,t},i.names=["stere"]},{"../common/adjust_lon":5,"../common/msfnz":15,"../common/phi2z":16,"../common/sign":21,"../common/tsfnz":24}],60:[function(t,e,i){var r=t("./gauss"),n=t("../common/adjust_lon");i.init=function(){r.init.apply(this),this.rc&&(this.sinc0=Math.sin(this.phic0),this.cosc0=Math.cos(this.phic0),this.R2=2*this.rc,this.title||(this.title="Oblique Stereographic Alternative"))},i.forward=function(t){var e,i,o,s;return t.x=n(t.x-this.long0),r.forward.apply(this,[t]),e=Math.sin(t.y),i=Math.cos(t.y),o=Math.cos(t.x),s=this.k0*this.R2/(1+this.sinc0*e+this.cosc0*i*o),t.x=s*i*Math.sin(t.x),t.y=s*(this.cosc0*e-this.sinc0*i*o),t.x=this.a*t.x+this.x0,t.y=this.a*t.y+this.y0,t},i.inverse=function(t){var e,i,o,s,a;if(t.x=(t.x-this.x0)/this.a,t.y=(t.y-this.y0)/this.a,t.x/=this.k0,t.y/=this.k0,a=Math.sqrt(t.x*t.x+t.y*t.y)){var l=2*Math.atan2(a,this.R2);e=Math.sin(l),i=Math.cos(l),s=Math.asin(i*this.sinc0+t.y*e*this.cosc0/a),o=Math.atan2(t.x*e,a*this.cosc0*i-t.y*this.sinc0*e)}else s=this.phic0,o=0;return t.x=o,t.y=s,r.inverse.apply(this,[t]),t.x=n(t.x+this.long0),t},i.names=["Stereographic_North_Pole","Oblique_Stereographic","Polar_Stereographic","sterea","Oblique Stereographic Alternative"]},{"../common/adjust_lon":5,"./gauss":45}],61:[function(t,e,i){var r=t("../common/e0fn"),n=t("../common/e1fn"),o=t("../common/e2fn"),s=t("../common/e3fn"),a=t("../common/mlfn"),l=t("../common/adjust_lon"),h=Math.PI/2,u=1e-10,c=t("../common/sign"),d=t("../common/asinz");i.init=function(){this.e0=r(this.es),this.e1=n(this.es),this.e2=o(this.es),this.e3=s(this.es),this.ml0=this.a*a(this.e0,this.e1,this.e2,this.e3,this.lat0)},i.forward=function(t){var e,i,r,n=t.x,o=t.y,s=l(n-this.long0),h=Math.sin(o),u=Math.cos(o);if(this.sphere){var c=u*Math.sin(s);if(Math.abs(Math.abs(c)-1)<1e-10)return 93;i=.5*this.a*this.k0*Math.log((1+c)/(1-c)),e=Math.acos(u*Math.cos(s)/Math.sqrt(1-c*c)),o<0&&(e=-e),r=this.a*this.k0*(e-this.lat0)}else{var d=u*s,p=Math.pow(d,2),f=this.ep2*Math.pow(u,2),g=Math.tan(o),m=Math.pow(g,2);e=1-this.es*Math.pow(h,2);var E=this.a/Math.sqrt(e),y=this.a*a(this.e0,this.e1,this.e2,this.e3,o);i=this.k0*E*d*(1+p/6*(1-m+f+p/20*(5-18*m+Math.pow(m,2)+72*f-58*this.ep2)))+this.x0,r=this.k0*(y-this.ml0+E*g*(p*(.5+p/24*(5-m+9*f+4*Math.pow(f,2)+p/30*(61-58*m+Math.pow(m,2)+600*f-330*this.ep2)))))+this.y0}return t.x=i,t.y=r,t},i.inverse=function(t){var e,i,r,n,o,s,a=6;if(this.sphere){var p=Math.exp(t.x/(this.a*this.k0)),f=.5*(p-1/p),g=this.lat0+t.y/(this.a*this.k0),m=Math.cos(g);e=Math.sqrt((1-m*m)/(1+f*f)),o=d(e),g<0&&(o=-o),s=0===f&&0===m?this.long0:l(Math.atan2(f,m)+this.long0)}else{var E=t.x-this.x0,y=t.y-this.y0;for(e=(this.ml0+y/this.k0)/this.a,i=e,n=0;!0&&(r=(e+this.e1*Math.sin(2*i)-this.e2*Math.sin(4*i)+this.e3*Math.sin(6*i))/this.e0-i,i+=r,!(Math.abs(r)<=u));n++)if(n>=a)return 95;if(Math.abs(i)<h){var _=Math.sin(i),v=Math.cos(i),b=Math.tan(i),S=this.ep2*Math.pow(v,2),T=Math.pow(S,2),L=Math.pow(b,2),w=Math.pow(L,2);e=1-this.es*Math.pow(_,2);var x=this.a/Math.sqrt(e),R=x*(1-this.es)/e,M=E/(x*this.k0),C=Math.pow(M,2);o=i-x*b*C/R*(.5-C/24*(5+3*L+10*S-4*T-9*this.ep2-C/30*(61+90*L+298*S+45*w-252*this.ep2-3*T))),s=l(this.long0+M*(1-C/6*(1+2*L+S-C/20*(5-2*S+28*L-3*T+8*this.ep2+24*w)))/v)}else o=h*c(y),s=this.long0}return t.x=s,t.y=o,t},i.names=["Transverse_Mercator","Transverse Mercator","tmerc"]},{"../common/adjust_lon":5,"../common/asinz":6,"../common/e0fn":7,"../common/e1fn":8,"../common/e2fn":9,"../common/e3fn":10,"../common/mlfn":14,"../common/sign":21}],62:[function(t,e,i){var r=.017453292519943295,n=t("./tmerc");i.dependsOn="tmerc",i.init=function(){this.zone&&(this.lat0=0,this.long0=(6*Math.abs(this.zone)-183)*r,this.x0=5e5,this.y0=this.utmSouth?1e7:0,this.k0=.9996,n.init.apply(this),this.forward=n.forward,this.inverse=n.inverse)},i.names=["Universal Transverse Mercator System","utm"]},{"./tmerc":61}],63:[function(t,e,i){var r=t("../common/adjust_lon"),n=Math.PI/2,o=1e-10,s=t("../common/asinz");i.init=function(){this.R=this.a},i.forward=function(t){var e,i,a=t.x,l=t.y,h=r(a-this.long0);Math.abs(l)<=o&&(e=this.x0+this.R*h,i=this.y0);var u=s(2*Math.abs(l/Math.PI));(Math.abs(h)<=o||Math.abs(Math.abs(l)-n)<=o)&&(e=this.x0,i=l>=0?this.y0+Math.PI*this.R*Math.tan(.5*u):this.y0+Math.PI*this.R*-Math.tan(.5*u));var c=.5*Math.abs(Math.PI/h-h/Math.PI),d=c*c,p=Math.sin(u),f=Math.cos(u),g=f/(p+f-1),m=g*g,E=g*(2/p-1),y=E*E,_=Math.PI*this.R*(c*(g-y)+Math.sqrt(d*(g-y)*(g-y)-(y+d)*(m-y)))/(y+d);h<0&&(_=-_),e=this.x0+_;var v=d+g;return _=Math.PI*this.R*(E*v-c*Math.sqrt((y+d)*(d+1)-v*v))/(y+d),i=l>=0?this.y0+_:this.y0-_,t.x=e,t.y=i,t},i.inverse=function(t){var e,i,n,s,a,l,h,u,c,d,p,f,g;return t.x-=this.x0,t.y-=this.y0,p=Math.PI*this.R,n=t.x/p,s=t.y/p,a=n*n+s*s,l=-Math.abs(s)*(1+a),h=l-2*s*s+n*n,u=-2*l+1+2*s*s+a*a,g=s*s/u+(2*h*h*h/u/u/u-9*l*h/u/u)/27,c=(l-h*h/3/u)/u,d=2*Math.sqrt(-c/3),p=3*g/c/d,Math.abs(p)>1&&(p=p>=0?1:-1),f=Math.acos(p)/3,i=t.y>=0?(-d*Math.cos(f+Math.PI/3)-h/3/u)*Math.PI:-(-d*Math.cos(f+Math.PI/3)-h/3/u)*Math.PI,e=Math.abs(n)<o?this.long0:r(this.long0+Math.PI*(a-1+Math.sqrt(1+2*(n*n-s*s)+a*a))/2/n),t.x=e,t.y=i,t},i.names=["Van_der_Grinten_I","VanDerGrinten","vandg"]},{"../common/adjust_lon":5,"../common/asinz":6}],64:[function(t,e,i){var r=.017453292519943295,n=57.29577951308232,o=1,s=2,a=t("./datum_transform"),l=t("./adjust_axis"),h=t("./Proj"),u=t("./common/toPoint");e.exports=function t(e,i,c){function d(t,e){return(t.datum.datum_type===o||t.datum.datum_type===s)&&"WGS84"!==e.datumCode}var p;return Array.isArray(c)&&(c=u(c)),e.datum&&i.datum&&(d(e,i)||d(i,e))&&(p=new h("WGS84"),t(e,p,c),e=p),"enu"!==e.axis&&l(e,!1,c),"longlat"===e.projName?(c.x*=r,c.y*=r):(e.to_meter&&(c.x*=e.to_meter,c.y*=e.to_meter),e.inverse(c)),e.from_greenwich&&(c.x+=e.from_greenwich),c=a(e.datum,i.datum,c),i.from_greenwich&&(c.x-=i.from_greenwich),"longlat"===i.projName?(c.x*=n,c.y*=n):(i.forward(c),i.to_meter&&(c.x/=i.to_meter,c.y/=i.to_meter)),"enu"!==i.axis&&l(i,!0,c),c}},{"./Proj":2,"./adjust_axis":3,"./common/toPoint":23,"./datum_transform":30}],65:[function(t,e,i){function r(t,e,i){t[e]=i.map(function(t){var e={};return n(t,e),e}).reduce(function(t,e){return h(t,e)},{})}function n(t,e){var i;return Array.isArray(t)?(i=t.shift(),"PARAMETER"===i&&(i=t.shift()),1===t.length?Array.isArray(t[0])?(e[i]={},n(t[0],e[i])):e[i]=t[0]:t.length?"TOWGS84"===i?e[i]=t:(e[i]={},["UNIT","PRIMEM","VERT_DATUM"].indexOf(i)>-1?(e[i]={name:t[0].toLowerCase(),convert:t[1]},3===t.length&&(e[i].auth=t[2])):"SPHEROID"===i?(e[i]={name:t[0],a:t[1],rf:t[2]},4===t.length&&(e[i].auth=t[3])):["GEOGCS","GEOCCS","DATUM","VERT_CS","COMPD_CS","LOCAL_CS","FITTED_CS","LOCAL_DATUM"].indexOf(i)>-1?(t[0]=["name",t[0]],r(e,i,t)):t.every(function(t){return Array.isArray(t)})?r(e,i,t):n(t,e[i])):e[i]=!0,void 0):void(e[t]=!0)}function o(t,e){var i=e[0],r=e[1];!(i in t)&&r in t&&(t[i]=t[r],3===e.length&&(t[i]=e[2](t[i])))}function s(t){return t*l}function a(t){function e(e){var i=t.to_meter||1;return parseFloat(e,10)*i}"GEOGCS"===t.type?t.projName="longlat":"LOCAL_CS"===t.type?(t.projName="identity",
t.local=!0):"object"==typeof t.PROJECTION?t.projName=Object.keys(t.PROJECTION)[0]:t.projName=t.PROJECTION,t.UNIT&&(t.units=t.UNIT.name.toLowerCase(),"metre"===t.units&&(t.units="meter"),t.UNIT.convert&&(t.to_meter=parseFloat(t.UNIT.convert,10))),t.GEOGCS&&(t.GEOGCS.DATUM?t.datumCode=t.GEOGCS.DATUM.name.toLowerCase():t.datumCode=t.GEOGCS.name.toLowerCase(),"d_"===t.datumCode.slice(0,2)&&(t.datumCode=t.datumCode.slice(2)),"new_zealand_geodetic_datum_1949"!==t.datumCode&&"new_zealand_1949"!==t.datumCode||(t.datumCode="nzgd49"),"wgs_1984"===t.datumCode&&("Mercator_Auxiliary_Sphere"===t.PROJECTION&&(t.sphere=!0),t.datumCode="wgs84"),"_ferro"===t.datumCode.slice(-6)&&(t.datumCode=t.datumCode.slice(0,-6)),"_jakarta"===t.datumCode.slice(-8)&&(t.datumCode=t.datumCode.slice(0,-8)),~t.datumCode.indexOf("belge")&&(t.datumCode="rnb72"),t.GEOGCS.DATUM&&t.GEOGCS.DATUM.SPHEROID&&(t.ellps=t.GEOGCS.DATUM.SPHEROID.name.replace("_19","").replace(/[Cc]larke\_18/,"clrk"),"international"===t.ellps.toLowerCase().slice(0,13)&&(t.ellps="intl"),t.a=t.GEOGCS.DATUM.SPHEROID.a,t.rf=parseFloat(t.GEOGCS.DATUM.SPHEROID.rf,10)),~t.datumCode.indexOf("osgb_1936")&&(t.datumCode="osgb36")),t.b&&!isFinite(t.b)&&(t.b=t.a);var i=function(e){return o(t,e)},r=[["standard_parallel_1","Standard_Parallel_1"],["standard_parallel_2","Standard_Parallel_2"],["false_easting","False_Easting"],["false_northing","False_Northing"],["central_meridian","Central_Meridian"],["latitude_of_origin","Latitude_Of_Origin"],["latitude_of_origin","Central_Parallel"],["scale_factor","Scale_Factor"],["k0","scale_factor"],["latitude_of_center","Latitude_of_center"],["lat0","latitude_of_center",s],["longitude_of_center","Longitude_Of_Center"],["longc","longitude_of_center",s],["x0","false_easting",e],["y0","false_northing",e],["long0","central_meridian",s],["lat0","latitude_of_origin",s],["lat0","standard_parallel_1",s],["lat1","standard_parallel_1",s],["lat2","standard_parallel_2",s],["alpha","azimuth",s],["srsCode","name"]];r.forEach(i),t.long0||!t.longc||"Albers_Conic_Equal_Area"!==t.PROJECTION&&"Lambert_Azimuthal_Equal_Area"!==t.PROJECTION||(t.long0=t.longc)}var l=.017453292519943295,h=t("./extend");e.exports=function(t,e){var i=JSON.parse((","+t).replace(/\s*\,\s*([A-Z_0-9]+?)(\[)/g,',["$1",').slice(1).replace(/\s*\,\s*([A-Z_0-9]+?)\]/g,',"$1"]').replace(/,\["VERTCS".+/,"")),r=i.shift(),o=i.shift();i.unshift(["name",o]),i.unshift(["type",r]),i.unshift("output");var s={};return n(i,s),a(s.output),h(e,s.output)}},{"./extend":33}],66:[function(t,e,i){function r(t){return t*(Math.PI/180)}function n(t){return 180*(t/Math.PI)}function o(t){var e,i,n,o,s,l,h,u,c,d=t.lat,p=t.lon,f=6378137,g=.00669438,m=.9996,E=r(d),y=r(p);c=Math.floor((p+180)/6)+1,180===p&&(c=60),d>=56&&d<64&&p>=3&&p<12&&(c=32),d>=72&&d<84&&(p>=0&&p<9?c=31:p>=9&&p<21?c=33:p>=21&&p<33?c=35:p>=33&&p<42&&(c=37)),e=6*(c-1)-180+3,u=r(e),i=g/(1-g),n=f/Math.sqrt(1-g*Math.sin(E)*Math.sin(E)),o=Math.tan(E)*Math.tan(E),s=i*Math.cos(E)*Math.cos(E),l=Math.cos(E)*(y-u),h=f*((1-g/4-3*g*g/64-5*g*g*g/256)*E-(3*g/8+3*g*g/32+45*g*g*g/1024)*Math.sin(2*E)+(15*g*g/256+45*g*g*g/1024)*Math.sin(4*E)-35*g*g*g/3072*Math.sin(6*E));var _=m*n*(l+(1-o+s)*l*l*l/6+(5-18*o+o*o+72*s-58*i)*l*l*l*l*l/120)+5e5,v=m*(h+n*Math.tan(E)*(l*l/2+(5-o+9*s+4*s*s)*l*l*l*l/24+(61-58*o+o*o+600*s-330*i)*l*l*l*l*l*l/720));return d<0&&(v+=1e7),{northing:Math.round(v),easting:Math.round(_),zoneNumber:c,zoneLetter:a(d)}}function s(t){var e=t.northing,i=t.easting,r=t.zoneLetter,o=t.zoneNumber;if(o<0||o>60)return null;var a,l,h,u,c,d,p,f,g,m,E=.9996,y=6378137,_=.00669438,v=(1-Math.sqrt(1-_))/(1+Math.sqrt(1-_)),b=i-5e5,S=e;r<"N"&&(S-=1e7),f=6*(o-1)-180+3,a=_/(1-_),p=S/E,g=p/(y*(1-_/4-3*_*_/64-5*_*_*_/256)),m=g+(3*v/2-27*v*v*v/32)*Math.sin(2*g)+(21*v*v/16-55*v*v*v*v/32)*Math.sin(4*g)+151*v*v*v/96*Math.sin(6*g),l=y/Math.sqrt(1-_*Math.sin(m)*Math.sin(m)),h=Math.tan(m)*Math.tan(m),u=a*Math.cos(m)*Math.cos(m),c=y*(1-_)/Math.pow(1-_*Math.sin(m)*Math.sin(m),1.5),d=b/(l*E);var T=m-l*Math.tan(m)/c*(d*d/2-(5+3*h+10*u-4*u*u-9*a)*d*d*d*d/24+(61+90*h+298*u+45*h*h-252*a-3*u*u)*d*d*d*d*d*d/720);T=n(T);var L=(d-(1+2*h+u)*d*d*d/6+(5-2*u+28*h-3*u*u+8*a+24*h*h)*d*d*d*d*d/120)/Math.cos(m);L=f+n(L);var w;if(t.accuracy){var x=s({northing:t.northing+t.accuracy,easting:t.easting+t.accuracy,zoneLetter:t.zoneLetter,zoneNumber:t.zoneNumber});w={top:x.lat,right:x.lon,bottom:T,left:L}}else w={lat:T,lon:L};return w}function a(t){var e="Z";return 84>=t&&t>=72?e="X":72>t&&t>=64?e="W":64>t&&t>=56?e="V":56>t&&t>=48?e="U":48>t&&t>=40?e="T":40>t&&t>=32?e="S":32>t&&t>=24?e="R":24>t&&t>=16?e="Q":16>t&&t>=8?e="P":8>t&&t>=0?e="N":0>t&&t>=-8?e="M":-8>t&&t>=-16?e="L":-16>t&&t>=-24?e="K":-24>t&&t>=-32?e="J":-32>t&&t>=-40?e="H":-40>t&&t>=-48?e="G":-48>t&&t>=-56?e="F":-56>t&&t>=-64?e="E":-64>t&&t>=-72?e="D":-72>t&&t>=-80&&(e="C"),e}function l(t,e){var i=""+t.easting,r=""+t.northing;return t.zoneNumber+t.zoneLetter+h(t.easting,t.northing,t.zoneNumber)+i.substr(i.length-5,e)+r.substr(r.length-5,e)}function h(t,e,i){var r=u(i),n=Math.floor(t/1e5),o=Math.floor(e/1e5)%20;return c(n,o,r)}function u(t){var e=t%m;return 0===e&&(e=m),e}function c(t,e,i){var r=i-1,n=E.charCodeAt(r),o=y.charCodeAt(r),s=n+t-1,a=o+e,l=!1;s>T&&(s=s-T+_-1,l=!0),(s===v||n<v&&s>v||(s>v||n<v)&&l)&&s++,(s===b||n<b&&s>b||(s>b||n<b)&&l)&&(s++,s===v&&s++),s>T&&(s=s-T+_-1),a>S?(a=a-S+_-1,l=!0):l=!1,(a===v||o<v&&a>v||(a>v||o<v)&&l)&&a++,(a===b||o<b&&a>b||(a>b||o<b)&&l)&&(a++,a===v&&a++),a>S&&(a=a-S+_-1);var h=String.fromCharCode(s)+String.fromCharCode(a);return h}function d(t){if(t&&0===t.length)throw"MGRSPoint coverting from nothing";for(var e,i=t.length,r=null,n="",o=0;!/[A-Z]/.test(e=t.charAt(o));){if(o>=2)throw"MGRSPoint bad conversion from: "+t;n+=e,o++}var s=parseInt(n,10);if(0===o||o+3>i)throw"MGRSPoint bad conversion from: "+t;var a=t.charAt(o++);if(a<="A"||"B"===a||"Y"===a||a>="Z"||"I"===a||"O"===a)throw"MGRSPoint zone letter "+a+" not handled: "+t;r=t.substring(o,o+=2);for(var l=u(s),h=p(r.charAt(0),l),c=f(r.charAt(1),l);c<g(a);)c+=2e6;var d=i-o;if(d%2!==0)throw"MGRSPoint has to have an even number \nof digits after the zone letter and two 100km letters - front \nhalf for easting meters, second half for \nnorthing meters"+t;var m,E,y,_,v,b=d/2,S=0,T=0;return b>0&&(m=1e5/Math.pow(10,b),E=t.substring(o,o+b),S=parseFloat(E)*m,y=t.substring(o+b),T=parseFloat(y)*m),_=S+h,v=T+c,{easting:_,northing:v,zoneLetter:a,zoneNumber:s,accuracy:m}}function p(t,e){for(var i=E.charCodeAt(e-1),r=1e5,n=!1;i!==t.charCodeAt(0);){if(i++,i===v&&i++,i===b&&i++,i>T){if(n)throw"Bad character: "+t;i=_,n=!0}r+=1e5}return r}function f(t,e){if(t>"V")throw"MGRSPoint given invalid Northing "+t;for(var i=y.charCodeAt(e-1),r=0,n=!1;i!==t.charCodeAt(0);){if(i++,i===v&&i++,i===b&&i++,i>S){if(n)throw"Bad character: "+t;i=_,n=!0}r+=1e5}return r}function g(t){var e;switch(t){case"C":e=11e5;break;case"D":e=2e6;break;case"E":e=28e5;break;case"F":e=37e5;break;case"G":e=46e5;break;case"H":e=55e5;break;case"J":e=64e5;break;case"K":e=73e5;break;case"L":e=82e5;break;case"M":e=91e5;break;case"N":e=0;break;case"P":e=8e5;break;case"Q":e=17e5;break;case"R":e=26e5;break;case"S":e=35e5;break;case"T":e=44e5;break;case"U":e=53e5;break;case"V":e=62e5;break;case"W":e=7e6;break;case"X":e=79e5;break;default:e=-1}if(e>=0)return e;throw"Invalid zone letter: "+t}var m=6,E="AJSAJS",y="AFAFAF",_=65,v=73,b=79,S=86,T=90;i.forward=function(t,e){return e=e||5,l(o({lat:t[1],lon:t[0]}),e)},i.inverse=function(t){var e=s(d(t.toUpperCase()));return[e.left,e.bottom,e.right,e.top]},i.toPoint=function(t){var e=i.inverse(t);return[(e[2]+e[0])/2,(e[3]+e[1])/2]}},{}],67:[function(t,e,i){e.exports={name:"proj4",version:"2.3.3",description:"Proj4js is a JavaScript library to transform point coordinates from one coordinate system to another, including datum transformations.",main:"lib/index.js",directories:{test:"test",doc:"docs"},scripts:{test:"./node_modules/istanbul/lib/cli.js test ./node_modules/mocha/bin/_mocha test/test.js"},repository:{type:"git",url:"git://github.com/proj4js/proj4js.git"},author:"",license:"MIT",jam:{main:"dist/proj4.js",include:["dist/proj4.js","README.md","AUTHORS","LICENSE.md"]},devDependencies:{"grunt-cli":"~0.1.13",grunt:"~0.4.2","grunt-contrib-connect":"~0.6.0","grunt-contrib-jshint":"~0.8.0",chai:"~1.8.1",mocha:"~1.17.1","grunt-mocha-phantomjs":"~0.4.0",browserify:"~3.24.5","grunt-browserify":"~1.3.0","grunt-contrib-uglify":"~0.3.2",curl:"git://github.com/cujojs/curl.git",istanbul:"~0.2.4",tin:"~0.4.0"},dependencies:{mgrs:"0.0.0"}}},{}],"./includedProjections":[function(t,e,i){e.exports=t("gWUPNW")},{}],gWUPNW:[function(t,e,i){var r=[t("./lib/projections/tmerc"),t("./lib/projections/utm"),t("./lib/projections/sterea"),t("./lib/projections/stere"),t("./lib/projections/somerc"),t("./lib/projections/omerc"),t("./lib/projections/lcc"),t("./lib/projections/krovak"),t("./lib/projections/cass"),t("./lib/projections/laea"),t("./lib/projections/aea"),t("./lib/projections/gnom"),t("./lib/projections/cea"),t("./lib/projections/eqc"),t("./lib/projections/poly"),t("./lib/projections/nzmg"),t("./lib/projections/mill"),t("./lib/projections/sinu"),t("./lib/projections/moll"),t("./lib/projections/eqdc"),t("./lib/projections/vandg"),t("./lib/projections/aeqd")];e.exports=function(t){r.forEach(function(e){t.Proj.projections.add(e)})}},{"./lib/projections/aea":39,"./lib/projections/aeqd":40,"./lib/projections/cass":41,"./lib/projections/cea":42,"./lib/projections/eqc":43,"./lib/projections/eqdc":44,"./lib/projections/gnom":46,"./lib/projections/krovak":47,"./lib/projections/laea":48,"./lib/projections/lcc":49,"./lib/projections/mill":52,"./lib/projections/moll":53,"./lib/projections/nzmg":54,"./lib/projections/omerc":55,"./lib/projections/poly":56,"./lib/projections/sinu":57,"./lib/projections/somerc":58,"./lib/projections/stere":59,"./lib/projections/sterea":60,"./lib/projections/tmerc":61,"./lib/projections/utm":62,"./lib/projections/vandg":63}]},{},[35])(35)}),i("formats/geojson/GeoJSONCRS",["../../error/ArgumentError","./GeoJSONConstants","../../util/Logger","../../util/proj4-src"],function(t,e,i,r){"use strict";var n=function(e,r){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONCRS","constructor","missingType"));if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONCRS","constructor","missingProperties"));this._type=e,this._properties=r,this._projectionString=null};return Object.defineProperties(n.prototype,{type:{get:function(){return this._type}},properties:{get:function(){return this._properties}},projectionString:{get:function(){return this._projectionString}}}),n.prototype.isDefault=function(){return!(!this.isNamed()||this._projectionString!==e.EPSG4326_CRS&&this._projectionString!==e.WGS84_CRS)},n.prototype.isNamed=function(){return this._type===e.FIELD_CRS_NAME},n.prototype.isLinked=function(){return this._type===e.FIELD_CRS_LINK},n.prototype.isCRSSupported=function(){try{r(this._projectionString,e.EPSG4326_CRS)}catch(t){return i.log(i.LEVEL_WARNING,"Unknown GeoJSON coordinate reference system ("+t+"): "+this._properties.name),!1}return!0},n.prototype.getLinkedCRSString=function(t,e){var r=new XMLHttpRequest;r.open("GET",t,!0),r.responseType="text",r.onreadystatechange=function(){4===r.readyState&&(200===r.status?(this._projectionString=r.response,e()):i.log(i.LEVEL_WARNING,"GeoJSON Linked CRS retrieval failed ("+r.statusText+"): "+t))}.bind(this),r.onerror=function(){i.log(i.LEVEL_WARNING,"GeoJSON Linked CRS retrieval failed: "+t)},r.ontimeout=function(){i.log(i.LEVEL_WARNING,"GeoJSON Linked CRS retrieval timed out: "+t)},r.send(null)},n.prototype.setCRSString=function(t){this.isNamed()?(this._projectionString=this._properties.name,t()):this.isLinked()&&this.getLinkedCRSString(this._properties.href,t)},n}),i("formats/geojson/GeoJSONFeature",["../../error/ArgumentError","./GeoJSONConstants","../../util/Logger"],function(t,e,i){"use strict";var r=function(r,n,o,s){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONFeature","constructor","missingGeometry"));if(!r[e.FIELD_TYPE])throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONFeature","constructor","missingFeatureGeometryType"));if(!n)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONFeature","constructor","missingProperties"));this._geometry=r,this._properties=n,this._id=o,this._bbox=s};return Object.defineProperties(r.prototype,{geometry:{get:function(){return this._geometry}},properties:{get:function(){return this._properties}},id:{get:function(){return this._id}},bbox:{get:function(){return this._bbox}}}),r}),i("formats/geojson/GeoJSONFeatureCollection",["../../error/ArgumentError","./GeoJSONConstants","../../util/Logger"],function(t,e,i){"use strict";var r=function(e,r){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONFeatureCollection","constructor","missingFeatures"));if("[object Array]"!==Object.prototype.toString.call(e))throw new t(i.logMessage(i.LEVEL_SEVERE,"GeoJSONFeatureCollection","constructor","invalidFeatures"));this._features=e,this._bbox=r};return Object.defineProperties(r.prototype,{features:{get:function(){return this._features}},bbox:{get:function(){return this._bbox}}}),r}),i("shapes/PlacemarkAttributes",["../util/Color","../util/Font","../util/Offset","../shapes/ShapeAttributes","../shapes/TextAttributes"],function(t,e,i,r,n){"use strict";var o=function(e){this._imageColor=e?e._imageColor:new t(1,1,1,1),this._imageOffset=e?e._imageOffset:new i(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,.5),this._imageScale=e?e._imageScale:1,this._imageSource=e?e._imageSource:null,this._depthTest=!e||e._depthTest,this._labelAttributes=e?e._labelAttributes:new n(null),this._drawLeaderLine=!!e&&e._drawLeaderLine,this._leaderLineAttributes=e?e._leaderLineAttributes:new r(null),this.stateKeyInvalid=!0};return o.prototype.computeStateKey=function(){return"ic "+this._imageColor.toHexString(!0)+" io "+this._imageOffset.toString()+" is "+this._imageScale+" ip "+this._imageSource+" dt "+this._depthTest+" la "+this._labelAttributes.stateKey+" dll "+this._drawLeaderLine+" lla "+this._leaderLineAttributes.stateKey},Object.defineProperties(o.prototype,{stateKey:{get:function(){return this.stateKeyInvalid&&(this._stateKey=this.computeStateKey(),this.stateKeyInvalid=!1),this._stateKey}},imageColor:{get:function(){return this._imageColor},set:function(t){this._imageColor=t,this.stateKeyInvalid=!0}},imageOffset:{get:function(){return this._imageOffset},set:function(t){this._imageOffset=t,this.stateKeyInvalid=!0}},imageScale:{get:function(){return this._imageScale},set:function(t){this._imageScale=t,this.stateKeyInvalid=!0}},imageSource:{get:function(){return this._imageSource},set:function(t){this._imageSource=t,this.stateKeyInvalid=!0}},depthTest:{get:function(){return this._depthTest},set:function(t){this._depthTest=t,this.stateKeyInvalid=!0}},labelAttributes:{get:function(){return this._labelAttributes},set:function(t){this._labelAttributes=t,this.stateKeyInvalid=!0}},drawLeaderLine:{get:function(){return this._drawLeaderLine},set:function(t){this._drawLeaderLine=t,this.stateKeyInvalid=!0}},leaderLineAttributes:{get:function(){return this._leaderLineAttributes},set:function(t){this._leaderLineAttributes=t,this.stateKeyInvalid=!0}}}),o}),i("shapes/Placemark",["../error/ArgumentError","../shaders/BasicTextureProgram","../util/Color","../util/Font","../util/Logger","../geom/Matrix","../pick/PickedObject","../shapes/PlacemarkAttributes","../render/Renderable","../geom/Vec2","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c){"use strict";var d=function(e,i,r){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"Placemark","constructor","missingPosition"));l.call(this),this.attributes=r?r:new a(null),this.highlightAttributes=null,this.highlighted=!1,this.position=e,this.eyeDistanceScaling=i,this.eyeDistanceScalingThreshold=1e6,this.eyeDistanceScalingLabelThreshold=1.5*this.eyeDistanceScalingThreshold,this.label=null,this.altitudeMode=WorldWind.ABSOLUTE,this.alwaysOnTop=!1,this.enableLeaderLinePicking=!1,this.updateImage=!0,this.declutterGroup=2,this.targetVisibility=1,this.currentVisibility=1,this.imageRotation=0,this.imageTilt=0,this.imageRotationReference=WorldWind.RELATIVE_TO_SCREEN,this.imageTiltReference=WorldWind.RELATIVE_TO_SCREEN,this.activeAttributes=null,this.activeTexture=null,this.labelTexture=null,this.placePoint=new u(0,0,0),this.groundPoint=new u(0,0,0),this.imageTransform=o.fromIdentity(),this.labelTransform=o.fromIdentity(),this.texCoordMatrix=o.fromIdentity(),this.imageBounds=null,this.layer=null,this.depthOffset=-.003};return d.screenPoint=new u(0,0,0),d.matrix=o.fromIdentity(),d.scratchPoint=new u(0,0,0),d.prototype=Object.create(l.prototype),Object.defineProperties(d.prototype,{screenBounds:{get:function(){return this.labelBounds}}}),d.prototype.copy=function(t){return this.position=t.position,this.attributes=t.attributes,this.highlightAttributes=t.highlightAttributes,this.highlighted=t.highlighted,this.enabled=t.enabled,this.label=t.label,this.altitudeMode=t.altitudeMode,this.pickDelegate=t.pickDelegate,this.alwaysOnTop=t.alwaysOnTop,this.depthOffset=t.depthOffset,this.targetVisibility=t.targetVisibility,this.currentVisibility=t.currentVisibility,this.imageRotation=t.imageRotation,this.imageTilt=t.imageTilt,this.imageRotationReference=t.imageRotationReference,this.imageTiltReference=t.imageTiltReference,this},d.prototype.clone=function(){var t=new d(this.position);return t.copy(this),t.pickDelegate=this.pickDelegate?this.pickDelegate:this,t},d.prototype.render=function(t){if(this.enabled&&t.accumulateOrderedRenderables&&(!t.globe.projectionLimits||t.globe.projectionLimits.containsLocation(this.position.latitude,this.position.longitude))){var e;if(this.lastFrameTime!==t.timestamp)e=this.makeOrderedRenderable(t);else{var i=this.clone();e=i.makeOrderedRenderable(t)}e&&e.isVisible(t)&&(e.layer=t.currentLayer,this.lastFrameTime=t.timestamp,t.addOrderedRenderable(e))}},d.prototype.renderOrdered=function(t){if(this.drawOrderedPlacemark(t),t.pickingMode){var e=new s(this.pickColor.clone(),this.pickDelegate?this.pickDelegate:this,this.position,this.layer,!1);t.pickPoint&&this.mustDrawLabel()&&this.labelBounds.containsPoint(t.navigatorState.convertPointToViewport(t.pickPoint,d.scratchPoint))&&(e.labelPicked=!0),t.resolvePick(e)}},d.prototype.makeOrderedRenderable=function(t){var e,i,r,n;if(this.determineActiveAttributes(t),!this.activeAttributes)return null;if(t.surfacePointForMode(this.position.latitude,this.position.longitude,this.position.altitude,this.altitudeMode,this.placePoint),this.eyeDistance=this.alwaysOnTop?0:t.navigatorState.eyePoint.distanceTo(this.placePoint),this.mustDrawLeaderLine(t)&&t.surfacePointForMode(this.position.latitude,this.position.longitude,0,this.altitudeMode,this.groundPoint),!t.navigatorState.projectWithDepth(this.placePoint,this.depthOffset,d.screenPoint))return null;var o=this.eyeDistanceScaling?Math.max(0,Math.min(1,this.eyeDistanceScalingThreshold/this.eyeDistance)):1;if(this.activeTexture?(e=this.activeTexture.originalImageWidth,i=this.activeTexture.originalImageHeight,r=this.activeAttributes.imageScale*o,n=this.activeAttributes.imageOffset.offsetForSize(e,i),this.imageTransform.setTranslation(d.screenPoint[0]-n[0]*r,d.screenPoint[1]-n[1]*r,d.screenPoint[2]),this.imageTransform.setScale(e*r,i*r,1)):(r=this.activeAttributes.imageScale*o,n=this.activeAttributes.imageOffset.offsetForSize(r,r),this.imageTransform.setTranslation(d.screenPoint[0]-n[0],d.screenPoint[1]-n[1],d.screenPoint[2]),this.imageTransform.setScale(r,r,1)),this.imageBounds=c.boundingRectForUnitQuad(this.imageTransform),this.mustDrawLabel()){var s=this.activeAttributes.labelAttributes.font,a=this.label+s.toString();this.labelTexture=t.gpuResourceCache.resourceForKey(a),this.labelTexture||(this.labelTexture=t.textSupport.createTexture(t,this.label,s,!0),t.gpuResourceCache.putResource(a,this.labelTexture,this.labelTexture.size)),e=this.labelTexture.imageWidth,i=this.labelTexture.imageHeight,r=this.activeAttributes.labelAttributes.scale*o,n=this.activeAttributes.labelAttributes.offset.offsetForSize(e,i),this.labelTransform.setTranslation(d.screenPoint[0]-n[0]*r,d.screenPoint[1]-n[1]*r,d.screenPoint[2]),this.labelTransform.setScale(e*r,i*r,1),this.labelBounds=c.boundingRectForUnitQuad(this.labelTransform)}return this},d.prototype.determineActiveAttributes=function(t){this.highlighted&&this.highlightAttributes?this.activeAttributes=this.highlightAttributes:this.activeAttributes=this.attributes,this.activeAttributes&&this.activeAttributes.imageSource&&(this.activeTexture=t.gpuResourceCache.resourceForKey(this.activeAttributes.imageSource),this.activeTexture&&!this.updateImage||(this.activeTexture=t.gpuResourceCache.retrieveTexture(t.currentGlContext,this.activeAttributes.imageSource),this.updateImage=!1))},d.prototype.isVisible=function(t){return t.pickingMode?t.pickRectangle&&(this.imageBounds.intersects(t.pickRectangle)||this.mustDrawLabel()&&this.labelBounds.intersects(t.pickRectangle)||this.mustDrawLeaderLine(t)&&t.pickFrustum.intersectsSegment(this.groundPoint,this.placePoint)):this.imageBounds.intersects(t.navigatorState.viewport)||this.mustDrawLabel()&&this.labelBounds.intersects(t.navigatorState.viewport)||this.mustDrawLeaderLine(t)&&t.navigatorState.frustumInModelCoordinates.intersectsSegment(this.groundPoint,this.placePoint)},d.prototype.drawOrderedPlacemark=function(t){this.beginDrawing(t);try{this.doDrawOrderedPlacemark(t),t.pickingMode||this.drawBatchOrderedPlacemarks(t)}finally{this.endDrawing(t)}},d.prototype.drawBatchOrderedPlacemarks=function(t){for(var e;(e=t.peekOrderedRenderable())&&e.doDrawOrderedPlacemark;){t.popOrderedRenderable();try{e.doDrawOrderedPlacemark(t)}catch(t){n.logMessage(n.LEVEL_WARNING,"Placemark","drawBatchOrderedPlacemarks","Error occurred while rendering placemark using batching: "+t.message)}}},d.prototype.beginDrawing=function(t){var i,r=t.currentGlContext;t.findAndBindProgram(e),i=t.currentProgram,r.bindBuffer(r.ARRAY_BUFFER,t.unitQuadBuffer()),r.vertexAttribPointer(i.vertexTexCoordLocation,2,r.FLOAT,!1,0,0),r.enableVertexAttribArray(i.vertexPointLocation),r.enableVertexAttribArray(i.vertexTexCoordLocation),i.loadTextureUnit(r,r.TEXTURE0),i.loadModulateColor(r,t.pickingMode)},d.prototype.endDrawing=function(t){var e=t.currentGlContext,i=t.currentProgram;e.disableVertexAttribArray(i.vertexPointLocation),e.disableVertexAttribArray(i.vertexTexCoordLocation),e.bindBuffer(e.ARRAY_BUFFER,null),e.bindTexture(e.TEXTURE_2D,null)},d.prototype.doDrawOrderedPlacemark=function(t){var e,i=t.currentGlContext,r=t.currentProgram,n=!0;if(t.pickingMode&&(this.pickColor=t.uniquePickColor()),this.eyeDistanceScaling&&this.eyeDistance>this.eyeDistanceScalingLabelThreshold&&(this.targetVisibility=0),!t.pickingMode&&this.mustDrawLabel()&&this.currentVisibility!=this.targetVisibility){var o=(t.timestamp-t.previousRedrawTimestamp)/t.fadeTime;this.currentVisibility<this.targetVisibility?this.currentVisibility=Math.min(1,this.currentVisibility+o):this.currentVisibility=Math.max(0,this.currentVisibility-o),t.redrawRequested=!0}if(r.loadOpacity(i,t.pickingMode?1:this.layer.opacity),this.mustDrawLeaderLine(t)){this.leaderLinePoints||(this.leaderLinePoints=new Float32Array(6)),this.leaderLinePoints[0]=this.groundPoint[0],this.leaderLinePoints[1]=this.groundPoint[1],this.leaderLinePoints[2]=this.groundPoint[2],this.leaderLinePoints[3]=this.placePoint[0],this.leaderLinePoints[4]=this.placePoint[1],this.leaderLinePoints[5]=this.placePoint[2],this.leaderLineCacheKey||(this.leaderLineCacheKey=t.gpuResourceCache.generateCacheKey());var s=t.gpuResourceCache.resourceForKey(this.leaderLineCacheKey);s||(s=i.createBuffer(),t.gpuResourceCache.putResource(this.leaderLineCacheKey,s,4*this.leaderLinePoints.length)),r.loadTextureEnabled(i,!1),r.loadColor(i,t.pickingMode?this.pickColor:this.activeAttributes.leaderLineAttributes.outlineColor),d.matrix.copy(t.navigatorState.modelviewProjection),r.loadModelviewProjection(i,d.matrix),this.activeAttributes.leaderLineAttributes.depthTest||i.disable(i.DEPTH_TEST),i.lineWidth(this.activeAttributes.leaderLineAttributes.outlineWidth),i.bindBuffer(i.ARRAY_BUFFER,s),i.bufferData(i.ARRAY_BUFFER,this.leaderLinePoints,i.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1),i.vertexAttribPointer(r.vertexPointLocation,3,i.FLOAT,!1,0,0),i.drawArrays(i.LINES,0,2)}this.activeAttributes.depthTest||(n=!1,i.disable(i.DEPTH_TEST)),i.bindBuffer(i.ARRAY_BUFFER,t.unitQuadBuffer3()),i.vertexAttribPointer(r.vertexPointLocation,3,i.FLOAT,!1,0,0),d.matrix.copy(t.screenProjection),d.matrix.multiplyMatrix(this.imageTransform);var a=this.imageRotationReference===WorldWind.RELATIVE_TO_GLOBE?t.navigatorState.heading-this.imageRotation:-this.imageRotation;d.matrix.multiplyByTranslation(.5,.5,0),d.matrix.multiplyByRotation(0,0,1,a),d.matrix.multiplyByTranslation(-.5,-.5,0);var l=this.imageTiltReference===WorldWind.RELATIVE_TO_GLOBE?t.navigatorState.tilt+this.imageTilt:this.imageTilt;d.matrix.multiplyByRotation(-1,0,0,l),r.loadModelviewProjection(i,d.matrix),r.loadTextureEnabled(i,!0),t.pickingMode?r.loadColor(i,this.pickColor):r.loadColor(i,this.activeAttributes.imageColor),this.texCoordMatrix.setToIdentity(),this.activeTexture&&this.texCoordMatrix.multiplyByTextureTransform(this.activeTexture),r.loadTextureMatrix(i,this.texCoordMatrix),this.activeTexture?(e=this.activeTexture.bind(t),r.loadTextureEnabled(i,e)):r.loadTextureEnabled(i,!1),i.drawArrays(i.TRIANGLE_STRIP,0,4),this.mustDrawLabel()&&this.currentVisibility>0&&(r.loadOpacity(i,t.pickingMode?1:this.layer.opacity*this.currentVisibility),d.matrix.copy(t.screenProjection),d.matrix.multiplyMatrix(this.labelTransform),r.loadModelviewProjection(i,d.matrix),!t.pickingMode&&this.labelTexture?(this.texCoordMatrix.setToIdentity(),this.texCoordMatrix.multiplyByTextureTransform(this.labelTexture),r.loadTextureMatrix(i,this.texCoordMatrix),r.loadColor(i,this.activeAttributes.labelAttributes.color),e=this.labelTexture.bind(t),r.loadTextureEnabled(i,e)):(r.loadTextureEnabled(i,!1),r.loadColor(i,this.pickColor)),this.activeAttributes.labelAttributes.depthTest?n||(n=!0,i.enable(i.DEPTH_TEST)):(n=!1,i.disable(i.DEPTH_TEST)),i.drawArrays(i.TRIANGLE_STRIP,0,4)),n||i.enable(i.DEPTH_TEST)},d.prototype.mustDrawLabel=function(){return this.label&&this.label.length>0&&this.activeAttributes.labelAttributes},d.prototype.mustDrawLeaderLine=function(t){return this.activeAttributes.drawLeaderLine&&this.activeAttributes.leaderLineAttributes&&(!t.pickingMode||this.enableLeaderLinePicking)},d});var r={};return r.DEBUG=!1,r.assert=function(t,e){if(r.DEBUG&&!t)throw new Error("Assertion failed"+(e?": "+e:""))},r.GLU_TESS_MAX_COORD=1e150,r.TRUE_PROJECT=!1,r.TESS_MAX_CACHE=100,r.GLU_TESS_DEFAULT_TOLERANCE=0,r.windingRule={GLU_TESS_WINDING_ODD:100130,GLU_TESS_WINDING_NONZERO:100131,GLU_TESS_WINDING_POSITIVE:100132,GLU_TESS_WINDING_NEGATIVE:100133,GLU_TESS_WINDING_ABS_GEQ_TWO:100134},r.primitiveType={GL_LINE_LOOP:2,GL_TRIANGLES:4,GL_TRIANGLE_STRIP:5,GL_TRIANGLE_FAN:6},r.errorType={GLU_TESS_MISSING_BEGIN_POLYGON:100151,GLU_TESS_MISSING_END_POLYGON:100153,GLU_TESS_MISSING_BEGIN_CONTOUR:100152,GLU_TESS_MISSING_END_CONTOUR:100154,GLU_TESS_COORD_TOO_LARGE:100155,GLU_TESS_NEED_COMBINE_CALLBACK:100156},r.gluEnum={GLU_TESS_BEGIN:100100,GLU_TESS_VERTEX:100101,GLU_TESS_END:100102,GLU_TESS_ERROR:100103,GLU_TESS_EDGE_FLAG:100104,GLU_TESS_COMBINE:100105,GLU_TESS_BEGIN_DATA:100106,GLU_TESS_VERTEX_DATA:100107,GLU_TESS_END_DATA:100108,GLU_TESS_ERROR_DATA:100109,GLU_TESS_EDGE_FLAG_DATA:100110,GLU_TESS_COMBINE_DATA:100111,GLU_TESS_MESH:100112,GLU_TESS_TOLERANCE:100142,GLU_TESS_WINDING_RULE:100140,GLU_TESS_BOUNDARY_ONLY:100141,GLU_INVALID_ENUM:100900,GLU_INVALID_VALUE:100901},r.PQHandle,r.PQKey,r.geom={},r.geom.vertEq=function(t,e){return t.s===e.s&&t.t===e.t},r.geom.vertLeq=function(t,e){return t.s<e.s||t.s===e.s&&t.t<=e.t},r.geom.edgeEval=function(t,e,i){var r=e.s-t.s,n=i.s-e.s;return r+n>0?r<n?e.t-t.t+(t.t-i.t)*(r/(r+n)):e.t-i.t+(i.t-t.t)*(n/(r+n)):0},r.geom.edgeSign=function(t,e,i){var r=e.s-t.s,n=i.s-e.s;return r+n>0?(e.t-i.t)*r+(e.t-t.t)*n:0},r.geom.transLeq=function(t,e){return t.t<e.t||t.t===e.t&&t.s<=e.s},r.geom.transEval=function(t,e,i){var r=e.t-t.t,n=i.t-e.t;return r+n>0?r<n?e.s-t.s+(t.s-i.s)*(r/(r+n)):e.s-i.s+(i.s-t.s)*(n/(r+n)):0},r.geom.transSign=function(t,e,i){var r=e.t-t.t,n=i.t-e.t;return r+n>0?(e.s-i.s)*r+(e.s-t.s)*n:0},r.geom.edgeGoesLeft=function(t){return r.geom.vertLeq(t.dst(),t.org)},r.geom.edgeGoesRight=function(t){return r.geom.vertLeq(t.org,t.dst())},r.geom.vertL1dist=function(t,e){return Math.abs(t.s-e.s)+Math.abs(t.t-e.t)},r.geom.vertCCW=function(t,e,i){return t.s*(e.t-i.t)+e.s*(i.t-t.t)+i.s*(t.t-e.t)>=0},r.geom.interpolate_=function(t,e,i,r){return t=t<0?0:t,i=i<0?0:i,t<=i?0===i?(e+r)/2:e+(r-e)*(t/(t+i)):r+(e-r)*(i/(t+i))},r.geom.edgeIntersect=function(t,e,i,n,o){var s,a,l;r.geom.vertLeq(t,e)||(l=t,t=e,e=l),r.geom.vertLeq(i,n)||(l=i,i=n,n=l),r.geom.vertLeq(t,i)||(l=t,t=i,i=l,l=e,e=n,n=l),r.geom.vertLeq(i,e)?r.geom.vertLeq(e,n)?(s=r.geom.edgeEval(t,i,e),a=r.geom.edgeEval(i,e,n),s+a<0&&(s=-s,a=-a),o.s=r.geom.interpolate_(s,i.s,a,e.s)):(s=r.geom.edgeSign(t,i,e),a=-r.geom.edgeSign(t,n,e),s+a<0&&(s=-s,a=-a),o.s=r.geom.interpolate_(s,i.s,a,n.s)):o.s=(i.s+e.s)/2,r.geom.transLeq(t,e)||(l=t,t=e,e=l),r.geom.transLeq(i,n)||(l=i,i=n,n=l),r.geom.transLeq(t,i)||(l=t,t=i,i=l,l=e,e=n,n=l),r.geom.transLeq(i,e)?r.geom.transLeq(e,n)?(s=r.geom.transEval(t,i,e),a=r.geom.transEval(i,e,n),s+a<0&&(s=-s,a=-a),o.t=r.geom.interpolate_(s,i.t,a,e.t)):(s=r.geom.transSign(t,i,e),a=-r.geom.transSign(t,n,e),s+a<0&&(s=-s,a=-a),o.t=r.geom.interpolate_(s,i.t,a,n.t)):o.t=(i.t+e.t)/2},r.mesh={},r.mesh.makeEdge=function(t){var e=r.mesh.makeEdgePair_(t.eHead);return r.mesh.makeVertex_(e,t.vHead),r.mesh.makeVertex_(e.sym,t.vHead),r.mesh.makeFace_(e,t.fHead),e},r.mesh.meshSplice=function(t,e){var i=!1,n=!1;t!==e&&(e.org!==t.org&&(n=!0,r.mesh.killVertex_(e.org,t.org)),e.lFace!==t.lFace&&(i=!0,r.mesh.killFace_(e.lFace,t.lFace)),r.mesh.splice_(e,t),n||(r.mesh.makeVertex_(e,t.org),t.org.anEdge=t),i||(r.mesh.makeFace_(e,t.lFace),t.lFace.anEdge=t))},r.mesh.deleteEdge=function(t){var e=t.sym,i=!1;t.lFace!==t.rFace()&&(i=!0,r.mesh.killFace_(t.lFace,t.rFace())),t.oNext===t?r.mesh.killVertex_(t.org,null):(t.rFace().anEdge=t.oPrev(),t.org.anEdge=t.oNext,r.mesh.splice_(t,t.oPrev()),i||r.mesh.makeFace_(t,t.lFace)),e.oNext===e?(r.mesh.killVertex_(e.org,null),r.mesh.killFace_(e.lFace,null)):(t.lFace.anEdge=e.oPrev(),e.org.anEdge=e.oNext,r.mesh.splice_(e,e.oPrev())),r.mesh.killEdge_(t)},r.mesh.addEdgeVertex=function(t){var e=r.mesh.makeEdgePair_(t),i=e.sym;return r.mesh.splice_(e,t.lNext),e.org=t.dst(),r.mesh.makeVertex_(i,e.org),e.lFace=i.lFace=t.lFace,e},r.mesh.splitEdge=function(t){var e=r.mesh.addEdgeVertex(t),i=e.sym;return r.mesh.splice_(t.sym,t.sym.oPrev()),r.mesh.splice_(t.sym,i),t.sym.org=i.org,i.dst().anEdge=i.sym,i.sym.lFace=t.rFace(),i.winding=t.winding,i.sym.winding=t.sym.winding,i},r.mesh.connect=function(t,e){var i=!1,n=r.mesh.makeEdgePair_(t),o=n.sym;return e.lFace!==t.lFace&&(i=!0,r.mesh.killFace_(e.lFace,t.lFace)),r.mesh.splice_(n,t.lNext),r.mesh.splice_(o,e),n.org=t.dst(),o.org=e.org,n.lFace=o.lFace=t.lFace,t.lFace.anEdge=o,i||r.mesh.makeFace_(n,t.lFace),n},r.mesh.zapFace=function(t){var e,i=t.anEdge,n=i.lNext;do if(e=n,n=e.lNext,e.lFace=null,null===e.rFace()){e.oNext===e?r.mesh.killVertex_(e.org,null):(e.org.anEdge=e.oNext,r.mesh.splice_(e,e.oPrev()));var o=e.sym;o.oNext===o?r.mesh.killVertex_(o.org,null):(o.org.anEdge=o.oNext,r.mesh.splice_(o,o.oPrev())),r.mesh.killEdge_(e)}while(e!==i);var s=t.prev,a=t.next;a.prev=s,s.next=a},r.mesh.meshUnion=function(t,e){var i=t.fHead,r=t.vHead,n=t.eHead,o=e.fHead,s=e.vHead,a=e.eHead;return o.next!==o&&(i.prev.next=o.next,o.next.prev=i.prev,o.prev.next=i,i.prev=o.prev),s.next!==s&&(r.prev.next=s.next,s.next.prev=r.prev,s.prev.next=r,r.prev=s.prev),a.next!==a&&(n.sym.next.sym.next=a.next,a.next.sym.next=n.sym.next,a.sym.next.sym.next=n,n.sym.next=a.sym.next),t},r.mesh.deleteMesh=function(t){},
r.mesh.makeEdgePair_=function(t){var e=new r.GluHalfEdge,i=new r.GluHalfEdge,n=t.sym.next;return i.next=n,n.sym.next=e,e.next=t,t.sym.next=i,e.sym=i,e.oNext=e,e.lNext=i,i.sym=e,i.oNext=i,i.lNext=e,e},r.mesh.splice_=function(t,e){var i=t.oNext,r=e.oNext;i.sym.lNext=e,r.sym.lNext=t,t.oNext=r,e.oNext=i},r.mesh.makeVertex_=function(t,e){var i=e.prev,n=new r.GluVertex(e,i);i.next=n,e.prev=n,n.anEdge=t;var o=t;do o.org=n,o=o.oNext;while(o!==t)},r.mesh.makeFace_=function(t,e){var i=e.prev,n=new r.GluFace(e,i);i.next=n,e.prev=n,n.anEdge=t,n.inside=e.inside;var o=t;do o.lFace=n,o=o.lNext;while(o!==t)},r.mesh.killEdge_=function(t){var e=t.next,i=t.sym.next;e.sym.next=i,i.sym.next=e},r.mesh.killVertex_=function(t,e){var i=t.anEdge,r=i;do r.org=e,r=r.oNext;while(r!==i);var n=t.prev,o=t.next;o.prev=n,n.next=o},r.mesh.killFace_=function(t,e){var i=t.anEdge,r=i;do r.lFace=e,r=r.lNext;while(r!==i);var n=t.prev,o=t.next;o.prev=n,n.next=o},r.normal={},r.normal.S_UNIT_X_=1,r.normal.S_UNIT_Y_=0,r.normal.projectPolygon=function(t){var e=!1,i=[t.normal[0],t.normal[1],t.normal[2]];0===i[0]&&0===i[1]&&0===i[2]&&(r.normal.computeNormal_(t,i),e=!0);var n=t.sUnit,o=t.tUnit,s=r.normal.longAxis_(i);if(r.TRUE_PROJECT){r.normal.normalize_(i),n[s]=0,n[(s+1)%3]=r.normal.S_UNIT_X_,n[(s+2)%3]=r.normal.S_UNIT_Y_;var a=r.normal.dot_(n,i);n[0]-=a*i[0],n[1]-=a*i[1],n[2]-=a*i[2],r.normal.normalize_(n),o[0]=i[1]*n[2]-i[2]*n[1],o[1]=i[2]*n[0]-i[0]*n[2],o[2]=i[0]*n[1]-i[1]*n[0],r.normal.normalize_(o)}else n[s]=0,n[(s+1)%3]=r.normal.S_UNIT_X_,n[(s+2)%3]=r.normal.S_UNIT_Y_,o[s]=0,o[(s+1)%3]=i[s]>0?-r.normal.S_UNIT_Y_:r.normal.S_UNIT_Y_,o[(s+2)%3]=i[s]>0?r.normal.S_UNIT_X_:-r.normal.S_UNIT_X_;for(var l=t.mesh.vHead,h=l.next;h!==l;h=h.next)h.s=r.normal.dot_(h.coords,n),h.t=r.normal.dot_(h.coords,o);e&&r.normal.checkOrientation_(t)},r.normal.dot_=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]},r.normal.normalize_=function(t){var e=t[0]*t[0]+t[1]*t[1]+t[2]*t[2];e=Math.sqrt(e),t[0]/=e,t[1]/=e,t[2]/=e},r.normal.longAxis_=function(t){var e=0;return Math.abs(t[1])>Math.abs(t[0])&&(e=1),Math.abs(t[2])>Math.abs(t[e])&&(e=2),e},r.normal.computeNormal_=function(t,e){var i,n=[-2*r.GLU_TESS_MAX_COORD,-2*r.GLU_TESS_MAX_COORD,-2*r.GLU_TESS_MAX_COORD],o=[2*r.GLU_TESS_MAX_COORD,2*r.GLU_TESS_MAX_COORD,2*r.GLU_TESS_MAX_COORD],s=[],a=[],l=t.mesh.vHead;for(i=l.next;i!==l;i=i.next)for(var h=0;h<3;++h){var u=i.coords[h];u<o[h]&&(o[h]=u,a[h]=i),u>n[h]&&(n[h]=u,s[h]=i)}var c=0;if(n[1]-o[1]>n[0]-o[0]&&(c=1),n[2]-o[2]>n[c]-o[c]&&(c=2),o[c]>=n[c])return e[0]=0,e[1]=0,void(e[2]=1);var d=0,p=a[c],f=s[c],g=[0,0,0],m=[p.coords[0]-f.coords[0],p.coords[1]-f.coords[1],p.coords[2]-f.coords[2]],E=[0,0,0];for(i=l.next;i!==l;i=i.next){E[0]=i.coords[0]-f.coords[0],E[1]=i.coords[1]-f.coords[1],E[2]=i.coords[2]-f.coords[2],g[0]=m[1]*E[2]-m[2]*E[1],g[1]=m[2]*E[0]-m[0]*E[2],g[2]=m[0]*E[1]-m[1]*E[0];var y=g[0]*g[0]+g[1]*g[1]+g[2]*g[2];y>d&&(d=y,e[0]=g[0],e[1]=g[1],e[2]=g[2])}d<=0&&(e[0]=e[1]=e[2]=0,e[r.normal.longAxis_(m)]=1)},r.normal.checkOrientation_=function(t){for(var e=0,i=t.mesh.fHead,r=i.next;r!==i;r=r.next){var n=r.anEdge;if(!(n.winding<=0))do e+=(n.org.s-n.dst().s)*(n.org.t+n.dst().t),n=n.lNext;while(n!==r.anEdge)}if(e<0){for(var o=t.mesh.vHead,s=o.next;s!==o;s=s.next)s.t=-s.t;t.tUnit[0]=-t.tUnit[0],t.tUnit[1]=-t.tUnit[1],t.tUnit[2]=-t.tUnit[2]}},r.render={},r.render.renderMesh=function(t,e,i){for(var n=!1,o=-1,s=e.fHead.prev;s!==e.fHead;s=s.prev)if(s.inside){n||(t.callBeginOrBeginData(r.primitiveType.GL_TRIANGLES),n=!0);var a=s.anEdge;do{if(i){var l=a.rFace().inside?0:1;o!==l&&(o=l,t.callEdgeFlagOrEdgeFlagData(!!o))}t.callVertexOrVertexData(a.org.data),a=a.lNext}while(a!==s.anEdge)}n&&t.callEndOrEndData()},r.render.renderBoundary=function(t,e){for(var i=e.fHead.next;i!==e.fHead;i=i.next)if(i.inside){t.callBeginOrBeginData(r.primitiveType.GL_LINE_LOOP);var n=i.anEdge;do t.callVertexOrVertexData(n.org.data),n=n.lNext;while(n!==i.anEdge);t.callEndOrEndData()}},r.sweep={},r.sweep.SENTINEL_COORD_=4*r.GLU_TESS_MAX_COORD,r.sweep.TOLERANCE_NONZERO_=!1,r.sweep.computeInterior=function(t){t.fatalError=!1,r.sweep.removeDegenerateEdges_(t),r.sweep.initPriorityQ_(t),r.sweep.initEdgeDict_(t);for(var e;null!==(e=t.pq.extractMin());){for(;;){var i=t.pq.minimum();if(null===i||!r.geom.vertEq(i,e))break;i=t.pq.extractMin(),r.sweep.spliceMergeVertices_(t,e.anEdge,i.anEdge)}r.sweep.sweepEvent_(t,e)}var n=t.dict.getMin().getKey();t.event=n.eUp.org,r.sweep.doneEdgeDict_(t),r.sweep.donePriorityQ_(t),r.sweep.removeDegenerateFaces_(t.mesh),t.mesh.checkMesh()},r.sweep.addWinding_=function(t,e){t.winding+=e.winding,t.sym.winding+=e.sym.winding},r.sweep.edgeLeq_=function(t,e,i){var n=t.event,o=e.eUp,s=i.eUp;if(o.dst()===n)return s.dst()===n?r.geom.vertLeq(o.org,s.org)?r.geom.edgeSign(s.dst(),o.org,s.org)<=0:r.geom.edgeSign(o.dst(),s.org,o.org)>=0:r.geom.edgeSign(s.dst(),n,s.org)<=0;if(s.dst()===n)return r.geom.edgeSign(o.dst(),n,o.org)>=0;var a=r.geom.edgeEval(o.dst(),n,o.org),l=r.geom.edgeEval(s.dst(),n,s.org);return a>=l},r.sweep.deleteRegion_=function(t,e){e.fixUpperEdge,e.eUp.activeRegion=null,t.dict.deleteNode(e.nodeUp),e.nodeUp=null},r.sweep.fixUpperEdge_=function(t,e){r.mesh.deleteEdge(t.eUp),t.fixUpperEdge=!1,t.eUp=e,e.activeRegion=t},r.sweep.topLeftRegion_=function(t){var e=t.eUp.org;do t=t.regionAbove();while(t.eUp.org===e);if(t.fixUpperEdge){var i=r.mesh.connect(t.regionBelow().eUp.sym,t.eUp.lNext);r.sweep.fixUpperEdge_(t,i),t=t.regionAbove()}return t},r.sweep.topRightRegion_=function(t){var e=t.eUp.dst();do t=t.regionAbove();while(t.eUp.dst()===e);return t},r.sweep.addRegionBelow_=function(t,e,i){var n=new r.ActiveRegion;return n.eUp=i,n.nodeUp=t.dict.insertBefore(e.nodeUp,n),i.activeRegion=n,n},r.sweep.isWindingInside_=function(t,e){switch(t.windingRule){case r.windingRule.GLU_TESS_WINDING_ODD:return 0!==(1&e);case r.windingRule.GLU_TESS_WINDING_NONZERO:return 0!==e;case r.windingRule.GLU_TESS_WINDING_POSITIVE:return e>0;case r.windingRule.GLU_TESS_WINDING_NEGATIVE:return e<0;case r.windingRule.GLU_TESS_WINDING_ABS_GEQ_TWO:return e>=2||e<=-2}return!1},r.sweep.computeWinding_=function(t,e){e.windingNumber=e.regionAbove().windingNumber+e.eUp.winding,e.inside=r.sweep.isWindingInside_(t,e.windingNumber)},r.sweep.finishRegion_=function(t,e){var i=e.eUp,n=i.lFace;n.inside=e.inside,n.anEdge=i,r.sweep.deleteRegion_(t,e)},r.sweep.finishLeftRegions_=function(t,e,i){for(var n=e,o=e.eUp;n!==i;){n.fixUpperEdge=!1;var s=n.regionBelow(),a=s.eUp;if(a.org!==o.org){if(!s.fixUpperEdge){r.sweep.finishRegion_(t,n);break}a=r.mesh.connect(o.lPrev(),a.sym),r.sweep.fixUpperEdge_(s,a)}o.oNext!==a&&(r.mesh.meshSplice(a.oPrev(),a),r.mesh.meshSplice(o,a)),r.sweep.finishRegion_(t,n),o=s.eUp,n=s}return o},r.sweep.addRightEdges_=function(t,e,i,n,o,s){var a=!0,l=i;do r.sweep.addRegionBelow_(t,e,l.sym),l=l.oNext;while(l!==n);null===o&&(o=e.regionBelow().eUp.rPrev());for(var h,u=e,c=o;h=u.regionBelow(),l=h.eUp.sym,l.org===c.org;)l.oNext!==c&&(r.mesh.meshSplice(l.oPrev(),l),r.mesh.meshSplice(c.oPrev(),l)),h.windingNumber=u.windingNumber-l.winding,h.inside=r.sweep.isWindingInside_(t,h.windingNumber),u.dirty=!0,!a&&r.sweep.checkForRightSplice_(t,u)&&(r.sweep.addWinding_(l,c),r.sweep.deleteRegion_(t,u),r.mesh.deleteEdge(c)),a=!1,u=h,c=l;u.dirty=!0,s&&r.sweep.walkDirtyRegions_(t,u)},r.sweep.callCombine_=function(t,e,i,n,o){var s=[e.coords[0],e.coords[1],e.coords[2]];e.data=null,e.data=t.callCombineOrCombineData(s,i,n),null===e.data&&(o?t.fatalError||(t.callErrorOrErrorData(r.errorType.GLU_TESS_NEED_COMBINE_CALLBACK),t.fatalError=!0):e.data=i[0])},r.sweep.spliceMergeVertices_=function(t,e,i){var n=[null,null,null,null],o=[.5,.5,0,0];n[0]=e.org.data,n[1]=i.org.data,r.sweep.callCombine_(t,e.org,n,o,!1),r.mesh.meshSplice(e,i)},r.sweep.vertexWeights_=function(t,e,i,n,o){var s=r.geom.vertL1dist(e,t),a=r.geom.vertL1dist(i,t),l=o,h=o+1;n[l]=.5*a/(s+a),n[h]=.5*s/(s+a),t.coords[0]+=n[l]*e.coords[0]+n[h]*i.coords[0],t.coords[1]+=n[l]*e.coords[1]+n[h]*i.coords[1],t.coords[2]+=n[l]*e.coords[2]+n[h]*i.coords[2]},r.sweep.getIntersectData_=function(t,e,i,n,o,s){var a=[0,0,0,0],l=[i.data,n.data,o.data,s.data];e.coords[0]=e.coords[1]=e.coords[2]=0,r.sweep.vertexWeights_(e,i,n,a,0),r.sweep.vertexWeights_(e,o,s,a,2),r.sweep.callCombine_(t,e,l,a,!0)},r.sweep.checkForRightSplice_=function(t,e){var i=e.regionBelow(),n=e.eUp,o=i.eUp;if(r.geom.vertLeq(n.org,o.org)){if(r.geom.edgeSign(o.dst(),n.org,o.org)>0)return!1;r.geom.vertEq(n.org,o.org)?n.org!==o.org&&(t.pq.remove(n.org.pqHandle),r.sweep.spliceMergeVertices_(t,o.oPrev(),n)):(r.mesh.splitEdge(o.sym),r.mesh.meshSplice(n,o.oPrev()),e.dirty=i.dirty=!0)}else{if(r.geom.edgeSign(n.dst(),o.org,n.org)<0)return!1;e.regionAbove().dirty=e.dirty=!0,r.mesh.splitEdge(n.sym),r.mesh.meshSplice(o.oPrev(),n)}return!0},r.sweep.checkForLeftSplice_=function(t,e){var i,n=e.regionBelow(),o=e.eUp,s=n.eUp;if(r.geom.vertLeq(o.dst(),s.dst())){if(r.geom.edgeSign(o.dst(),s.dst(),o.org)<0)return!1;e.regionAbove().dirty=e.dirty=!0,i=r.mesh.splitEdge(o),r.mesh.meshSplice(s.sym,i),i.lFace.inside=e.inside}else{if(r.geom.edgeSign(s.dst(),o.dst(),s.org)>0)return!1;e.dirty=n.dirty=!0,i=r.mesh.splitEdge(s),r.mesh.meshSplice(o.lNext,s.sym),i.rFace().inside=e.inside}return!0},r.sweep.checkForIntersect_=function(t,e){var i=e.regionBelow(),n=e.eUp,o=i.eUp,s=n.org,a=o.org,l=n.dst(),h=o.dst(),u=new r.GluVertex;if(s===a)return!1;var c=Math.min(s.t,l.t),d=Math.max(a.t,h.t);if(c>d)return!1;if(r.geom.vertLeq(s,a)){if(r.geom.edgeSign(h,s,a)>0)return!1}else if(r.geom.edgeSign(l,a,s)<0)return!1;r.geom.edgeIntersect(l,s,h,a,u),r.geom.vertLeq(u,t.event)&&(u.s=t.event.s,u.t=t.event.t);var p=r.geom.vertLeq(s,a)?s:a;if(r.geom.vertLeq(p,u)&&(u.s=p.s,u.t=p.t),r.geom.vertEq(u,s)||r.geom.vertEq(u,a))return r.sweep.checkForRightSplice_(t,e),!1;if(!r.geom.vertEq(l,t.event)&&r.geom.edgeSign(l,t.event,u)>=0||!r.geom.vertEq(h,t.event)&&r.geom.edgeSign(h,t.event,u)<=0){if(h===t.event)return r.mesh.splitEdge(n.sym),r.mesh.meshSplice(o.sym,n),e=r.sweep.topLeftRegion_(e),n=e.regionBelow().eUp,r.sweep.finishLeftRegions_(t,e.regionBelow(),i),r.sweep.addRightEdges_(t,e,n.oPrev(),n,n,!0),!0;if(l===t.event){r.mesh.splitEdge(o.sym),r.mesh.meshSplice(n.lNext,o.oPrev()),i=e,e=r.sweep.topRightRegion_(e);var f=e.regionBelow().eUp.rPrev();return i.eUp=o.oPrev(),o=r.sweep.finishLeftRegions_(t,i,null),r.sweep.addRightEdges_(t,e,o.oNext,n.rPrev(),f,!0),!0}return r.geom.edgeSign(l,t.event,u)>=0&&(e.regionAbove().dirty=e.dirty=!0,r.mesh.splitEdge(n.sym),n.org.s=t.event.s,n.org.t=t.event.t),r.geom.edgeSign(h,t.event,u)<=0&&(e.dirty=i.dirty=!0,r.mesh.splitEdge(o.sym),o.org.s=t.event.s,o.org.t=t.event.t),!1}return r.mesh.splitEdge(n.sym),r.mesh.splitEdge(o.sym),r.mesh.meshSplice(o.oPrev(),n),n.org.s=u.s,n.org.t=u.t,n.org.pqHandle=t.pq.insert(n.org),r.sweep.getIntersectData_(t,n.org,s,l,a,h),e.regionAbove().dirty=e.dirty=i.dirty=!0,!1},r.sweep.walkDirtyRegions_=function(t,e){for(var i=e.regionBelow();;){for(;i.dirty;)e=i,i=i.regionBelow();if(!e.dirty&&(i=e,e=e.regionAbove(),null===e||!e.dirty))return;e.dirty=!1;var n=e.eUp,o=i.eUp;if(n.dst()!==o.dst()&&r.sweep.checkForLeftSplice_(t,e)&&(i.fixUpperEdge?(r.sweep.deleteRegion_(t,i),r.mesh.deleteEdge(o),i=e.regionBelow(),o=i.eUp):e.fixUpperEdge&&(r.sweep.deleteRegion_(t,e),r.mesh.deleteEdge(n),e=i.regionAbove(),n=e.eUp)),n.org!==o.org)if(n.dst()===o.dst()||e.fixUpperEdge||i.fixUpperEdge||n.dst()!==t.event&&o.dst()!==t.event)r.sweep.checkForRightSplice_(t,e);else if(r.sweep.checkForIntersect_(t,e))return;n.org===o.org&&n.dst()===o.dst()&&(r.sweep.addWinding_(o,n),r.sweep.deleteRegion_(t,e),r.mesh.deleteEdge(n),e=i.regionAbove())}},r.sweep.connectRightVertex_=function(t,e,i){var n=i.oNext,o=e.regionBelow(),s=e.eUp,a=o.eUp,l=!1;if(s.dst()!==a.dst()&&r.sweep.checkForIntersect_(t,e),r.geom.vertEq(s.org,t.event)&&(r.mesh.meshSplice(n.oPrev(),s),e=r.sweep.topLeftRegion_(e),n=e.regionBelow().eUp,r.sweep.finishLeftRegions_(t,e.regionBelow(),o),l=!0),r.geom.vertEq(a.org,t.event)&&(r.mesh.meshSplice(i,a.oPrev()),i=r.sweep.finishLeftRegions_(t,o,null),l=!0),l)return void r.sweep.addRightEdges_(t,e,i.oNext,n,n,!0);var h;h=r.geom.vertLeq(a.org,s.org)?a.oPrev():s,h=r.mesh.connect(i.lPrev(),h),r.sweep.addRightEdges_(t,e,h,h.oNext,h.oNext,!1),h.sym.activeRegion.fixUpperEdge=!0,r.sweep.walkDirtyRegions_(t,e)},r.sweep.connectLeftDegenerate_=function(t,e,i){var n=e.eUp;if(r.geom.vertEq(n.org,i))return void(r.sweep.TOLERANCE_NONZERO_&&r.sweep.spliceMergeVertices_(t,n,i.anEdge));if(!r.geom.vertEq(n.dst(),i))return r.mesh.splitEdge(n.sym),e.fixUpperEdge&&(r.mesh.deleteEdge(n.oNext),e.fixUpperEdge=!1),r.mesh.meshSplice(i.anEdge,n),void r.sweep.sweepEvent_(t,i);if(r.sweep.TOLERANCE_NONZERO_){e=r.sweep.topRightRegion_(e);var o=e.regionBelow(),s=o.eUp.sym,a=s.oNext,l=a;o.fixUpperEdge&&(r.sweep.deleteRegion_(t,o),r.mesh.deleteEdge(s),s=a.oPrev()),r.mesh.meshSplice(i.anEdge,s),r.geom.edgeGoesLeft(a)||(a=null),r.sweep.addRightEdges_(t,e,s.oNext,l,a,!0)}},r.sweep.connectLeftVertex_=function(t,e){var i=new r.ActiveRegion;i.eUp=e.anEdge.sym;var n=t.dict.search(i).getKey(),o=n.regionBelow(),s=n.eUp,a=o.eUp;if(0===r.geom.edgeSign(s.dst(),e,s.org))return void r.sweep.connectLeftDegenerate_(t,n,e);var l,h=r.geom.vertLeq(a.dst(),s.dst())?n:o;if(n.inside||h.fixUpperEdge){if(h===n)l=r.mesh.connect(e.anEdge.sym,s.lNext);else{var u=r.mesh.connect(a.dNext(),e.anEdge);l=u.sym}h.fixUpperEdge?r.sweep.fixUpperEdge_(h,l):r.sweep.computeWinding_(t,r.sweep.addRegionBelow_(t,n,l)),r.sweep.sweepEvent_(t,e)}else r.sweep.addRightEdges_(t,n,e.anEdge,e.anEdge,null,!0)},r.sweep.sweepEvent_=function(t,e){t.event=e;for(var i=e.anEdge;null===i.activeRegion;)if(i=i.oNext,i===e.anEdge)return void r.sweep.connectLeftVertex_(t,e);var n=r.sweep.topLeftRegion_(i.activeRegion),o=n.regionBelow(),s=o.eUp,a=r.sweep.finishLeftRegions_(t,o,null);a.oNext===s?r.sweep.connectRightVertex_(t,n,a):r.sweep.addRightEdges_(t,n,a.oNext,s,s,!0)},r.sweep.addSentinel_=function(t,e){var i=new r.ActiveRegion,n=r.mesh.makeEdge(t.mesh);n.org.s=r.sweep.SENTINEL_COORD_,n.org.t=e,n.dst().s=-r.sweep.SENTINEL_COORD_,n.dst().t=e,t.event=n.dst(),i.eUp=n,i.windingNumber=0,i.inside=!1,i.fixUpperEdge=!1,i.sentinel=!0,i.dirty=!1,i.nodeUp=t.dict.insert(i)},r.sweep.initEdgeDict_=function(t){t.dict=new r.Dict(t,r.sweep.edgeLeq_),r.sweep.addSentinel_(t,-r.sweep.SENTINEL_COORD_),r.sweep.addSentinel_(t,r.sweep.SENTINEL_COORD_)},r.sweep.doneEdgeDict_=function(t){for(var e;null!==(e=t.dict.getMin().getKey());)!e.sentinel,r.sweep.deleteRegion_(t,e);t.dict=null},r.sweep.removeDegenerateEdges_=function(t){for(var e,i=t.mesh.eHead,n=i.next;n!==i;n=e){e=n.next;var o=n.lNext;r.geom.vertEq(n.org,n.dst())&&n.lNext.lNext!==n&&(r.sweep.spliceMergeVertices_(t,o,n),r.mesh.deleteEdge(n),n=o,o=n.lNext),o.lNext===n&&(o!==n&&(o!==e&&o!==e.sym||(e=e.next),r.mesh.deleteEdge(o)),n!==e&&n!==e.sym||(e=e.next),r.mesh.deleteEdge(n))}},r.sweep.initPriorityQ_=function(t){var e=new r.PriorityQ(r.geom.vertLeq);t.pq=e;var i,n=t.mesh.vHead;for(i=n.next;i!==n;i=i.next)i.pqHandle=e.insert(i);e.init()},r.sweep.donePriorityQ_=function(t){t.pq.deleteQ(),t.pq=null},r.sweep.removeDegenerateFaces_=function(t){for(var e,i=t.fHead.next;i!==t.fHead;i=e){e=i.next;var n=i.anEdge;n.lNext.lNext===n&&(r.sweep.addWinding_(n.oNext,n),r.mesh.deleteEdge(n))}},r.tessmono={},r.tessmono.tessellateMonoRegion_=function(t){for(var e=t.anEdge;r.geom.vertLeq(e.dst(),e.org);e=e.lPrev());for(;r.geom.vertLeq(e.org,e.dst());e=e.lNext);for(var i,n=e.lPrev();e.lNext!==n;)if(r.geom.vertLeq(e.dst(),n.org)){for(;n.lNext!==e&&(r.geom.edgeGoesLeft(n.lNext)||r.geom.edgeSign(n.org,n.dst(),n.lNext.dst())<=0);)i=r.mesh.connect(n.lNext,n),n=i.sym;n=n.lPrev()}else{for(;n.lNext!==e&&(r.geom.edgeGoesRight(e.lPrev())||r.geom.edgeSign(e.dst(),e.org,e.lPrev().org)>=0);)i=r.mesh.connect(e,e.lPrev()),e=i.sym;e=e.lNext}for(;n.lNext.lNext!==e;)i=r.mesh.connect(n.lNext,n),n=i.sym},r.tessmono.tessellateInterior=function(t){for(var e,i=t.fHead.next;i!==t.fHead;i=e)e=i.next,i.inside&&r.tessmono.tessellateMonoRegion_(i)},r.tessmono.discardExterior=function(t){for(var e,i=t.fHead.next;i!==t.fHead;i=e)e=i.next,i.inside||r.mesh.zapFace(i)},r.tessmono.setWindingNumber=function(t,e,i){for(var n,o=t.eHead.next;o!==t.eHead;o=n)n=o.next,o.rFace().inside!==o.lFace.inside?o.winding=o.lFace.inside?e:-e:i?r.mesh.deleteEdge(o):o.winding=0},r.Dict=function(t,e){this.head_=new r.DictNode,this.frame_=t,this.leq_=e},r.Dict.prototype.deleteDict_=function(){},r.Dict.prototype.insertBefore=function(t,e){do t=t.prev;while(null!==t.key&&!this.leq_(this.frame_,t.key,e));var i=new r.DictNode(e,t.next,t);return t.next.prev=i,t.next=i,i},r.Dict.prototype.insert=function(t){return this.insertBefore(this.head_,t)},r.Dict.prototype.deleteNode=function(t){t.next.prev=t.prev,t.prev.next=t.next},r.Dict.prototype.search=function(t){var e=this.head_;do e=e.next;while(null!==e.key&&!this.leq_(this.frame_,t,e.key));return e},r.Dict.prototype.getMin=function(){return this.head_.next},r.Dict.prototype.getMax=function(){return this.head_.prev},r.DictNode=function(t,e,i){this.key=t||null,this.next=e||this,this.prev=i||this},r.DictNode.prototype.getKey=function(){return this.key},r.DictNode.prototype.getSuccessor=function(){return this.next},r.DictNode.prototype.getPredecessor=function(){return this.prev},r.CachedVertex=function(){this.coords=[0,0,0],this.data=null},r.GluTesselator=function(){this.state=r.GluTesselator.tessState_.T_DORMANT,this.lastEdge_=null,this.mesh=null,this.callError_=null,this.normal=[0,0,0],this.sUnit=[0,0,0],this.tUnit=[0,0,0],this.relTolerance=r.GLU_TESS_DEFAULT_TOLERANCE,this.windingRule=r.windingRule.GLU_TESS_WINDING_ODD,this.fatalError=!1,this.dict=null,this.pq=null,this.event=null,this.callCombine_=null,this.boundaryOnly=!1,this.callBegin_=null,this.callEdgeFlag_=null,this.callVertex_=null,this.callEnd_=null,this.callMesh_=null,this.callBeginData_=null,this.callEdgeFlagData_=null,this.callVertexData_=null,this.callEndData_=null,this.callErrorData_=null,this.callCombineData_=null,this.polygonData_=null,this.emptyCache=!1,this.cacheCount=0,this.cache=new Array(r.TESS_MAX_CACHE);for(var t=0;t<r.TESS_MAX_CACHE;t++)this.cache[t]=new r.CachedVertex},r.GluTesselator.tessState_={T_DORMANT:0,T_IN_POLYGON:1,T_IN_CONTOUR:2},r.GluTesselator.prototype.gluDeleteTess=function(){this.requireState_(r.GluTesselator.tessState_.T_DORMANT)},r.GluTesselator.prototype.gluTessProperty=function(t,e){switch(t){case r.gluEnum.GLU_TESS_TOLERANCE:if(e<0||e>1)break;return void(this.relTolerance=e);case r.gluEnum.GLU_TESS_WINDING_RULE:var i=e;switch(i){case r.windingRule.GLU_TESS_WINDING_ODD:case r.windingRule.GLU_TESS_WINDING_NONZERO:case r.windingRule.GLU_TESS_WINDING_POSITIVE:case r.windingRule.GLU_TESS_WINDING_NEGATIVE:case r.windingRule.GLU_TESS_WINDING_ABS_GEQ_TWO:return void(this.windingRule=i)}break;case r.gluEnum.GLU_TESS_BOUNDARY_ONLY:return void(this.boundaryOnly=!!e);default:return void this.callErrorOrErrorData(r.gluEnum.GLU_INVALID_ENUM)}this.callErrorOrErrorData(r.gluEnum.GLU_INVALID_VALUE)},r.GluTesselator.prototype.gluGetTessProperty=function(t){switch(t){case r.gluEnum.GLU_TESS_TOLERANCE:return this.relTolerance;case r.gluEnum.GLU_TESS_WINDING_RULE:var e=this.windingRule;return e;case r.gluEnum.GLU_TESS_BOUNDARY_ONLY:return this.boundaryOnly;default:this.callErrorOrErrorData(r.gluEnum.GLU_INVALID_ENUM)}return!1},r.GluTesselator.prototype.gluTessNormal=function(t,e,i){this.normal[0]=t,this.normal[1]=e,this.normal[2]=i},r.GluTesselator.prototype.gluTessCallback=function(t,e){var i=e?e:null;switch(t){case r.gluEnum.GLU_TESS_BEGIN:return void(this.callBegin_=i);case r.gluEnum.GLU_TESS_BEGIN_DATA:return void(this.callBeginData_=i);case r.gluEnum.GLU_TESS_EDGE_FLAG:return void(this.callEdgeFlag_=i);case r.gluEnum.GLU_TESS_EDGE_FLAG_DATA:return void(this.callEdgeFlagData_=i);case r.gluEnum.GLU_TESS_VERTEX:return void(this.callVertex_=i);case r.gluEnum.GLU_TESS_VERTEX_DATA:return void(this.callVertexData_=i);case r.gluEnum.GLU_TESS_END:return void(this.callEnd_=i);case r.gluEnum.GLU_TESS_END_DATA:return void(this.callEndData_=i);case r.gluEnum.GLU_TESS_ERROR:return void(this.callError_=i);case r.gluEnum.GLU_TESS_ERROR_DATA:return void(this.callErrorData_=i);case r.gluEnum.GLU_TESS_COMBINE:return void(this.callCombine_=i);case r.gluEnum.GLU_TESS_COMBINE_DATA:return void(this.callCombineData_=i);case r.gluEnum.GLU_TESS_MESH:return void(this.callMesh_=i);default:return void this.callErrorOrErrorData(r.gluEnum.GLU_INVALID_ENUM)}},r.GluTesselator.prototype.gluTessVertex=function(t,e){var i=!1,n=[0,0,0];this.requireState_(r.GluTesselator.tessState_.T_IN_CONTOUR),this.emptyCache&&(this.emptyCache_(),this.lastEdge_=null);for(var o=0;o<3;++o){var s=t[o];s<-r.GLU_TESS_MAX_COORD&&(s=-r.GLU_TESS_MAX_COORD,i=!0),s>r.GLU_TESS_MAX_COORD&&(s=r.GLU_TESS_MAX_COORD,i=!0),n[o]=s}if(i&&this.callErrorOrErrorData(r.errorType.GLU_TESS_COORD_TOO_LARGE),null===this.mesh){if(this.cacheCount<r.TESS_MAX_CACHE)return void this.cacheVertex_(n,e);this.emptyCache_()}this.addVertex_(n,e)},r.GluTesselator.prototype.gluTessBeginPolygon=function(t){this.requireState_(r.GluTesselator.tessState_.T_DORMANT),this.state=r.GluTesselator.tessState_.T_IN_POLYGON,this.cacheCount=0,this.emptyCache=!1,this.mesh=null,this.polygonData_=t},r.GluTesselator.prototype.gluTessBeginContour=function(){this.requireState_(r.GluTesselator.tessState_.T_IN_POLYGON),this.state=r.GluTesselator.tessState_.T_IN_CONTOUR,this.lastEdge_=null,this.cacheCount>0&&(this.emptyCache=!0)},r.GluTesselator.prototype.gluTessEndContour=function(){this.requireState_(r.GluTesselator.tessState_.T_IN_CONTOUR),this.state=r.GluTesselator.tessState_.T_IN_POLYGON},r.GluTesselator.prototype.gluTessEndPolygon=function(){if(this.requireState_(r.GluTesselator.tessState_.T_IN_POLYGON),this.state=r.GluTesselator.tessState_.T_DORMANT,null===this.mesh&&this.emptyCache_(),r.normal.projectPolygon(this),r.sweep.computeInterior(this),!this.fatalError){var t=this.mesh;if(this.boundaryOnly?r.tessmono.setWindingNumber(t,1,!0):r.tessmono.tessellateInterior(t),this.mesh.checkMesh(),this.callBegin_||this.callEnd_||this.callVertex_||this.callEdgeFlag_||this.callBeginData_||this.callEndData_||this.callVertexData_||this.callEdgeFlagData_)if(this.boundaryOnly)r.render.renderBoundary(this,this.mesh);else{var e=!(!this.callEdgeFlag_&&!this.callEdgeFlagData_);r.render.renderMesh(this,this.mesh,e)}if(this.callMesh_)return r.tessmono.discardExterior(this.mesh),this.callMesh_(this.mesh),this.mesh=null,void(this.polygonData_=null)}r.mesh.deleteMesh(this.mesh),this.polygonData_=null,this.mesh=null},r.GluTesselator.prototype.makeDormant_=function(){this.mesh&&r.mesh.deleteMesh(this.mesh),this.state=r.GluTesselator.tessState_.T_DORMANT,this.lastEdge_=null,this.mesh=null},r.GluTesselator.prototype.requireState_=function(t){this.state!==t&&this.gotoState_(t)},r.GluTesselator.prototype.gotoState_=function(t){for(;this.state!==t;)if(this.state<t)switch(this.state){case r.GluTesselator.tessState_.T_DORMANT:this.callErrorOrErrorData(r.errorType.GLU_TESS_MISSING_BEGIN_POLYGON),this.gluTessBeginPolygon(null);break;case r.GluTesselator.tessState_.T_IN_POLYGON:this.callErrorOrErrorData(r.errorType.GLU_TESS_MISSING_BEGIN_CONTOUR),this.gluTessBeginContour()}else switch(this.state){case r.GluTesselator.tessState_.T_IN_CONTOUR:this.callErrorOrErrorData(r.errorType.GLU_TESS_MISSING_END_CONTOUR),this.gluTessEndContour();break;case r.GluTesselator.tessState_.T_IN_POLYGON:this.callErrorOrErrorData(r.errorType.GLU_TESS_MISSING_END_POLYGON),this.makeDormant_()}},r.GluTesselator.prototype.addVertex_=function(t,e){var i=this.lastEdge_;null===i?(i=r.mesh.makeEdge(this.mesh),r.mesh.meshSplice(i,i.sym)):(r.mesh.splitEdge(i),i=i.lNext),i.org.data=e,i.org.coords[0]=t[0],i.org.coords[1]=t[1],i.org.coords[2]=t[2],i.winding=1,i.sym.winding=-1,this.lastEdge_=i},r.GluTesselator.prototype.cacheVertex_=function(t,e){var i=this.cache[this.cacheCount];i.data=e,i.coords[0]=t[0],i.coords[1]=t[1],i.coords[2]=t[2],++this.cacheCount},r.GluTesselator.prototype.emptyCache_=function(){this.mesh=new r.GluMesh;for(var t=0;t<this.cacheCount;t++){var e=this.cache[t];this.addVertex_(e.coords,e.data)}this.cacheCount=0,this.emptyCache=!1},r.GluTesselator.prototype.callBeginOrBeginData=function(t){this.callBeginData_?this.callBeginData_(t,this.polygonData_):this.callBegin_&&this.callBegin_(t)},r.GluTesselator.prototype.callVertexOrVertexData=function(t){this.callVertexData_?this.callVertexData_(t,this.polygonData_):this.callVertex_&&this.callVertex_(t)},r.GluTesselator.prototype.callEdgeFlagOrEdgeFlagData=function(t){this.callEdgeFlagData_?this.callEdgeFlagData_(t,this.polygonData_):this.callEdgeFlag_&&this.callEdgeFlag_(t)},r.GluTesselator.prototype.callEndOrEndData=function(){this.callEndData_?this.callEndData_(this.polygonData_):this.callEnd_&&this.callEnd_()},r.GluTesselator.prototype.callCombineOrCombineData=function(t,e,i){var r;return this.callCombineData_?r=this.callCombineData_(t,e,i,this.polygonData_):this.callCombine_&&(r=this.callCombine_(t,e,i)),void 0===r&&(r=null),r},r.GluTesselator.prototype.callErrorOrErrorData=function(t){this.callErrorData_?this.callErrorData_(t,this.polygonData_):this.callError_&&this.callError_(t)},r.GluFace=function(t,e){this.next=t||this,this.prev=e||this,this.anEdge=null,this.data=null,this.inside=!1},r.GluHalfEdge=function(t){this.next=t||this,this.sym=null,this.oNext=null,this.lNext=null,this.org=null,this.lFace=null,this.activeRegion=null,this.winding=0},r.GluHalfEdge.prototype.rFace=function(){return this.sym.lFace},r.GluHalfEdge.prototype.dst=function(){return this.sym.org},r.GluHalfEdge.prototype.oPrev=function(){return this.sym.lNext},r.GluHalfEdge.prototype.lPrev=function(){return this.oNext.sym},r.GluHalfEdge.prototype.dPrev=function(){return this.lNext.sym},r.GluHalfEdge.prototype.rPrev=function(){return this.sym.oNext},r.GluHalfEdge.prototype.dNext=function(){return this.rPrev().sym},r.GluHalfEdge.prototype.rNext=function(){return this.oPrev().sym},r.GluMesh=function(){this.vHead=new r.GluVertex,this.fHead=new r.GluFace,this.eHead=new r.GluHalfEdge,this.eHeadSym=new r.GluHalfEdge,this.eHead.sym=this.eHeadSym,this.eHeadSym.sym=this.eHead},r.GluMesh.prototype.checkMesh=function(){if(r.DEBUG){var t,e,i=this.fHead,n=this.vHead,o=this.eHead,s=i;for(s=i;(e=s.next)!==i;s=e){t=e.anEdge;do t=t.lNext;while(t!==e.anEdge)}var a,l=n;for(l=n;(a=l.next)!==n;l=a){t=a.anEdge;do t=t.oNext;while(t!==a.anEdge)}var h=o;for(h=o;(t=h.next)!==o;h=t);}},r.GluVertex=function(t,e){this.next=t||this,this.prev=e||this,this.anEdge=null,this.data=null,this.coords=[0,0,0],this.s=0,this.t=0,this.pqHandle=null},r.PQHandleElem=function(){this.key=null,this.node=0},r.PQHandleElem.realloc=function(t,e){var i=new Array(e),n=0;if(null!==t)for(;n<t.length;n++)i[n]=t[n];for(;n<e;n++)i[n]=new r.PQHandleElem;return i},r.PQNode=function(){this.handle=0},r.PQNode.realloc=function(t,e){var i=new Array(e),n=0;if(null!==t)for(;n<t.length;n++)i[n]=t[n];for(;n<e;n++)i[n]=new r.PQNode;return i},r.PriorityQ=function(t){this.keys_=r.PriorityQ.prototype.PQKeyRealloc_(null,r.PriorityQ.INIT_SIZE_),this.order_=null,this.size_=0,this.max_=r.PriorityQ.INIT_SIZE_,this.initialized_=!1,this.leq_=t,this.heap_=new r.PriorityQHeap(this.leq_)},r.PriorityQ.INIT_SIZE_=32,r.PriorityQ.prototype.deleteQ=function(){this.heap_.deleteHeap(),this.heap_=null,this.order_=null,this.keys_=null},r.PriorityQ.prototype.init=function(){this.order_=[];for(var t=0;t<this.size_;t++)this.order_[t]=t;var e=function(t,e){return function(i,r){return e(t[i],t[r])?1:-1}}(this.keys_,this.leq_);if(this.order_.sort(e),this.max_=this.size_,this.initialized_=!0,this.heap_.init(),r.DEBUG){var i=0,n=i+this.size_-1;for(t=i;t<n;++t);}},r.PriorityQ.prototype.insert=function(t){if(this.initialized_)return this.heap_.insert(t);var e=this.size_;return++this.size_>=this.max_&&(this.max_*=2,this.keys_=r.PriorityQ.prototype.PQKeyRealloc_(this.keys_,this.max_)),this.keys_[e]=t,-(e+1)},r.PriorityQ.prototype.PQKeyRealloc_=function(t,e){var i=new Array(e),r=0;if(null!==t)for(;r<t.length;r++)i[r]=t[r];for(;r<e;r++)i[r]=null;return i},r.PriorityQ.prototype.keyLessThan_=function(t,e){var i=this.keys_[t],r=this.keys_[e];return!this.leq_(r,i)},r.PriorityQ.prototype.keyGreaterThan_=function(t,e){var i=this.keys_[t],r=this.keys_[e];return!this.leq_(i,r)},r.PriorityQ.prototype.extractMin=function(){if(0===this.size_)return this.heap_.extractMin();var t=this.keys_[this.order_[this.size_-1]];if(!this.heap_.isEmpty()){var e=this.heap_.minimum();if(this.leq_(e,t))return this.heap_.extractMin()}do--this.size_;while(this.size_>0&&null===this.keys_[this.order_[this.size_-1]]);return t},r.PriorityQ.prototype.minimum=function(){if(0===this.size_)return this.heap_.minimum();var t=this.keys_[this.order_[this.size_-1]];if(!this.heap_.isEmpty()){var e=this.heap_.minimum();if(this.leq_(e,t))return e}return t},r.PriorityQ.prototype.isEmpty_=function(){return 0===this.size_&&this.heap_.isEmpty()},r.PriorityQ.prototype.remove=function(t){if(t>=0)return void this.heap_.remove(t);for(t=-(t+1),this.keys_[t]=null;this.size_>0&&null===this.keys_[this.order_[this.size_-1]];)--this.size_},r.PriorityQHeap=function(t){this.nodes_=r.PQNode.realloc(null,r.PriorityQHeap.INIT_SIZE_+1),this.handles_=r.PQHandleElem.realloc(null,r.PriorityQHeap.INIT_SIZE_+1),this.size_=0,this.max_=r.PriorityQHeap.INIT_SIZE_,this.freeList_=0,this.initialized_=!1,this.leq_=t,this.nodes_[1].handle=1},r.PriorityQHeap.INIT_SIZE_=32,r.PriorityQHeap.prototype.deleteHeap=function(){this.handles_=null,this.nodes_=null},r.PriorityQHeap.prototype.init=function(){for(var t=this.size_;t>=1;--t)this.floatDown_(t);this.initialized_=!0},r.PriorityQHeap.prototype.insert=function(t){var e=++this.size_;2*e>this.max_&&(this.max_*=2,this.nodes_=r.PQNode.realloc(this.nodes_,this.max_+1),this.handles_=r.PQHandleElem.realloc(this.handles_,this.max_+1));var i;return 0===this.freeList_?i=e:(i=this.freeList_,this.freeList_=this.handles_[i].node),this.nodes_[e].handle=i,this.handles_[i].node=e,this.handles_[i].key=t,this.initialized_&&this.floatUp_(e),i},r.PriorityQHeap.prototype.isEmpty=function(){return 0===this.size_},r.PriorityQHeap.prototype.minimum=function(){return this.handles_[this.nodes_[1].handle].key},r.PriorityQHeap.prototype.extractMin=function(){var t=this.nodes_,e=this.handles_,i=t[1].handle,r=e[i].key;return this.size_>0&&(t[1].handle=t[this.size_].handle,e[t[1].handle].node=1,e[i].key=null,e[i].node=this.freeList_,this.freeList_=i,--this.size_>0&&this.floatDown_(1)),r},r.PriorityQHeap.prototype.remove=function(t){var e=this.nodes_,i=this.handles_,r=i[t].node;e[r].handle=e[this.size_].handle,i[e[r].handle].node=r,r<=--this.size_&&(r<=1||this.leq_(i[e[r>>1].handle].key,i[e[r].handle].key)?this.floatDown_(r):this.floatUp_(r)),i[t].key=null,i[t].node=this.freeList_,this.freeList_=t},r.PriorityQHeap.prototype.floatDown_=function(t){for(var e=this.nodes_,i=this.handles_,r=e[t].handle;;){var n=t<<1;n<this.size_&&this.leq_(i[e[n+1].handle].key,i[e[n].handle].key)&&++n;var o=e[n].handle;if(n>this.size_||this.leq_(i[r].key,i[o].key)){e[t].handle=r,i[r].node=t;break}e[t].handle=o,i[o].node=t,t=n}},r.PriorityQHeap.prototype.floatUp_=function(t){for(var e=this.nodes_,i=this.handles_,r=e[t].handle;;){var n=t>>1,o=e[n].handle;if(0===n||this.leq_(i[o].key,i[r].key)){e[t].handle=r,i[r].node=t;break}e[t].handle=o,i[o].node=t,t=n}},r.ActiveRegion=function(){this.eUp=null,this.nodeUp=null,this.windingNumber=0,this.inside=!1,this.sentinel=!1,this.dirty=!1,this.fixUpperEdge=!1},r.ActiveRegion.prototype.regionBelow=function(){return this.nodeUp.getPredecessor().getKey()},r.ActiveRegion.prototype.regionAbove=function(){return this.nodeUp.getSuccessor().getKey()},"undefined"!=typeof module&&(module.exports=r),i("util/libtess",function(){}),i("shapes/Polygon",["../shapes/AbstractShape","../error/ArgumentError","../shaders/BasicTextureProgram","../geom/BoundingBox","../util/Color","../util/ImageSource","../geom/Location","../util/Logger","../geom/Matrix","../pick/PickedObject","../geom/Position","../shapes/ShapeAttributes","../shapes/SurfacePolygon","../geom/Vec2","../geom/Vec3","../util/libtess"],function(t,e,i,n,o,s,a,l,h,u,c,d,p,f,g,m){
"use strict";var E=function(i,r){if(!i)throw new e(l.logMessage(l.LEVEL_SEVERE,"Polygon","constructor","missingBoundaries"));t.call(this,r),i.length>0&&i[0].latitude&&(i=[i],this._boundariesSpecifiedSimply=!0),this._boundaries=i,this._textureCoordinates=null,this.referencePosition=this.determineReferencePosition(this._boundaries),this._extrude=!1,this.scratchPoint=new g(0,0,0)};return E.prototype=Object.create(t.prototype),Object.defineProperties(E.prototype,{boundaries:{get:function(){return this._boundariesSpecifiedSimply?this._boundaries[0]:this._boundaries},set:function(t){if(!t)throw new e(l.logMessage(l.LEVEL_SEVERE,"Polygon","boundaries","missingBoundaries"));t.length>0&&t[0].latitude&&(t=[t],this._boundariesSpecifiedSimply=!0),this._boundaries=t,this.referencePosition=this.determineReferencePosition(this._boundaries),this.reset()}},textureCoordinates:{get:function(){return this._textureCoordinates},set:function(t){this._textureCoordinates=t,this.reset()}},extrude:{get:function(){return this._extrude},set:function(t){this._extrude=t,this.reset()}}}),E.prototype.determineReferencePosition=function(t){return t.length>0&&t[0].length>2?t[0][0]:null},E.prototype.mustGenerateGeometry=function(t){return!this.currentData.boundaryPoints||(this.currentData.drawInterior!==this.activeAttributes.drawInterior||this.altitudeMode!==WorldWind.ABSOLUTE&&this.currentData.isExpired)},E.prototype.hasCapTexture=function(){return this.textureCoordinates&&this.capImageSource()},E.prototype.capImageSource=function(){return this.activeAttributes.imageSource?"string"==typeof this.activeAttributes.imageSource||this.activeAttributes.imageSource instanceof s?this.activeAttributes.imageSource:Array.isArray(this.activeAttributes.imageSource)&&this.activeAttributes.imageSource[0]&&("string"==typeof this.activeAttributes.imageSource[0]||this.activeAttributes.imageSource instanceof s)?this.activeAttributes.imageSource[0]:null:null},E.prototype.hasSideTextures=function(){return this.activeAttributes.imageSource&&Array.isArray(this.activeAttributes.imageSource)&&this.activeAttributes.imageSource.length>1},E.prototype.sideImageSource=function(t){if(0===t||2===this.activeAttributes.imageSource.length)return this.activeAttributes.imageSource[1];var e=this.activeAttributes.imageSource.length-1;return t=Math.min(t+1,e),this.activeAttributes.imageSource[t]},E.prototype.createSurfaceShape=function(){return new p(this.boundaries,null)},E.prototype.doMakeOrderedRenderable=function(t){if(!this.referencePosition)return null;if(!this.activeAttributes.drawInterior&&!this.activeAttributes.drawOutline)return null;if(!this.mustGenerateGeometry(t))return this;var e=this.currentData,i=e.referencePoint;t.surfacePointForMode(this.referencePosition.latitude,this.referencePosition.longitude,this.referencePosition.altitude,this._altitudeMode,i),e.transformationMatrix.setToTranslation(i[0],i[1],i[2]);for(var r=[],o=0;o<this._boundaries.length;o++)r[o]=this._boundaries[o].slice(0),r[o].push(this._boundaries[o][0]);var s=this.computeBoundaryPoints(t,r);if(this.activeAttributes.drawInterior){var a=this.tessellatePolygon(t,s);if(a){e.capTriangles=new Float32Array(a.length);for(var l=0,h=a.length;l<h;l++)e.capTriangles[l]=a[l]}}if(e.boundaryPoints=s,e.drawInterior=this.activeAttributes.drawInterior,this.resetExpiration(e),e.refreshBuffers=!0,e.extent||(e.extent=new n),1===s.length)e.extent.setToPoints(s[0]);else{var u=[];for(o=0;o<s.length;o++)for(var c=0;c<s[o].length;c++)u.push(s[o][c]);e.extent.setToPoints(u)}return e.extent.translate(e.referencePoint),this},E.prototype.computeBoundaryPoints=function(t,e){for(var i,r,n,o,s=Number.MAX_VALUE,a=t.navigatorState.eyePoint,l=[],h=this._extrude?6:3,u=new g(0,0,0),c=0;c<e.length;c++){i=(this._extrude?2:1)*e[c].length,l[c]=new Float32Array(3*i);for(var d=0,p=e[c].length;d<p;d++)r=e[c][d],t.surfacePointForMode(r.latitude,r.longitude,r.altitude,this.altitudeMode,u),o=u.distanceToSquared(a),o<s&&(s=o),u.subtract(this.currentData.referencePoint),n=h*d,l[c][n]=u[0],l[c][n+1]=u[1],l[c][n+2]=u[2],this._extrude&&(t.surfacePointForMode(r.latitude,r.longitude,0,WorldWind.CLAMP_TO_GROUND,u),o=u.distanceToSquared(a),o<s&&(s=o),u.subtract(this.currentData.referencePoint),l[c][n+3]=u[0],l[c][n+4]=u[1],l[c][n+5]=u[2])}return this.currentData.eyeDistance=Math.sqrt(s),l},E.prototype.tessellatePolygon=function(t,e){var i,n,o=[],s=0,a=this._extrude?6:3,h=this.hasCapTexture();this.polygonTessellator||(this.polygonTessellator=new r.GluTesselator,this.polygonTessellator.gluTessCallback(r.gluEnum.GLU_TESS_VERTEX_DATA,function(t,e){e[e.length]=t[0],e[e.length]=t[1],e[e.length]=t[2],h&&(e[e.length]=t[3],e[e.length]=t[4])}),this.polygonTessellator.gluTessCallback(r.gluEnum.GLU_TESS_COMBINE,function(t,e,i){var r=[t[0],t[1],t[2]];if(h)for(var n=3;n<=4;n++){for(var o=0,s=0;s<4;s++)i[s]>0&&(o+=i[s]*e[s][n]);r[n]=o}return r}),this.polygonTessellator.gluTessCallback(r.gluEnum.GLU_TESS_ERROR,function(t){s=t,l.logMessage(l.LEVEL_WARNING,"Polygon","tessellatePolygon","Tessellation error "+t+".")})),n=g.computeBufferNormal(e[0],a),n||(n=new g(0,0,0),t.globe.surfaceNormalAtLocation(this.referencePosition.latitude,this.referencePosition.longitude,n)),this.polygonTessellator.gluTessNormal(n[0],n[1],n[2]),this.currentData.capNormal=n,this.polygonTessellator.gluTessBeginPolygon(o);for(var u=0;u<e.length;u++){var c=0;this.polygonTessellator.gluTessBeginContour();for(var d=e[u],p=0;p<d.length;p+=a)i=[d[p],d[p+1],d[p+2]],h&&(c<this.textureCoordinates[u].length?(i[3]=this.textureCoordinates[u][c][0],i[4]=this.textureCoordinates[u][c][1]):(i[3]=this.textureCoordinates[u][0][0],i[4]=this.textureCoordinates[u][1][1]),++c),this.polygonTessellator.gluTessVertex(i,i);this.polygonTessellator.gluTessEndContour()}return this.polygonTessellator.gluTessEndPolygon(),0===s?o:null},E.prototype.mustDrawVerticals=function(t){return this._extrude&&this.activeAttributes.drawOutline&&this.activeAttributes.drawVerticals&&this.altitudeMode!==WorldWind.CLAMP_TO_GROUND},E.prototype.doRenderOrdered=function(t){var e,i=this.currentData;if(t.pickingMode&&(e=t.uniquePickColor()),this.activeAttributes.drawInterior&&i.capTriangles&&i.capTriangles.length>0&&this.drawCap(t,e),this._extrude&&this.activeAttributes.drawInterior&&this.drawSides(t,e),this.activeAttributes.drawOutline&&this.drawOutline(t,e),i.refreshBuffers=!1,t.pickingMode){var r=new u(e,this.pickDelegate?this.pickDelegate:this,null,t.currentLayer,!1);t.resolvePick(r)}},E.prototype.drawCap=function(t,e){var i,r,n,o,s,a,l=t.currentGlContext,h=t.currentProgram,u=this.currentData,c=u.refreshBuffers,d=!!this.hasCapTexture(),p=this.activeAttributes.applyLighting,f=u.capTriangles.length/(d?5:3);h.loadTextureEnabled(l,!1),this.applyMvpMatrix(t),u.capVboCacheKey||(u.capVboCacheKey=t.gpuResourceCache.generateCacheKey()),i=t.gpuResourceCache.resourceForKey(u.capVboCacheKey),i||(i=l.createBuffer(),t.gpuResourceCache.putResource(u.capVboCacheKey,i,4*u.capTriangles.length),c=!0),l.bindBuffer(l.ARRAY_BUFFER,i),c&&(a=p?this.makeCapBufferWithNormals():u.capTriangles,l.bufferData(l.ARRAY_BUFFER,a,l.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1)),n=this.activeAttributes.interiorColor,r=n.alpha*t.currentLayer.opacity,l.depthMask(r>=1||t.pickingMode),h.loadColor(l,t.pickingMode?e:n),h.loadOpacity(l,t.pickingMode?r>0?1:0:r),o=12+(d?8:0)+(p?12:0),d&&!t.pickingMode&&(this.activeTexture=t.gpuResourceCache.resourceForKey(this.capImageSource()),this.activeTexture||(this.activeTexture=t.gpuResourceCache.retrieveTexture(t.currentGlContext,this.capImageSource())),s=this.activeTexture&&this.activeTexture.bind(t),s&&(h.loadTextureEnabled(l,!0),l.enableVertexAttribArray(h.vertexTexCoordLocation),l.vertexAttribPointer(h.vertexTexCoordLocation,2,l.FLOAT,!1,o,12),h.loadTextureUnit(l,l.TEXTURE0),h.loadModulateColor(l,t.pickingMode))),p&&!t.pickingMode&&(h.loadApplyLighting(l,!0),l.enableVertexAttribArray(h.normalVectorLocation),l.vertexAttribPointer(h.normalVectorLocation,3,l.FLOAT,!1,o,o-12)),l.vertexAttribPointer(h.vertexPointLocation,3,l.FLOAT,!1,o,0),l.drawArrays(l.TRIANGLES,0,f)},E.prototype.makeCapBufferWithNormals=function(){for(var t=this.currentData,e=t.capNormal,i=this.hasCapTexture()?5:3,r=i+3,n=t.capTriangles.length/i,o=t.capTriangles,s=new Float32Array(n*r),a=0,l=0;l<n;l++){for(var h=0;h<i;h++)s[a++]=o[l*i+h];s[a++]=e[0],s[a++]=e[1],s[a++]=e[2]}return s},E.prototype.drawSides=function(t,e){var i,r,n,o,s,a,l=t.currentGlContext,h=t.currentProgram,u=this.currentData,c=u.refreshBuffers,d=this.hasSideTextures(),p=this.activeAttributes.applyLighting,f=3+(d?2:0)+(p?3:0),g=4*f;a=0;for(var m=0;m<u.boundaryPoints.length;m++)a+=u.boundaryPoints[m].length/6-1;if(u.sidesVboCacheKey||(u.sidesVboCacheKey=t.gpuResourceCache.generateCacheKey()),i=t.gpuResourceCache.resourceForKey(u.sidesVboCacheKey),!i||c?(s=this.makeSidesBuffer(a),u.numSideVertices=s.length/f,i||(i=l.createBuffer()),t.gpuResourceCache.putResource(u.sidesVboCacheKey,i,4*s.length),l.bindBuffer(l.ARRAY_BUFFER,i),l.bufferData(l.ARRAY_BUFFER,s,l.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1)):l.bindBuffer(l.ARRAY_BUFFER,i),n=this.activeAttributes.interiorColor,r=n.alpha*t.currentLayer.opacity,l.depthMask(r>=1||t.pickingMode),h.loadColor(l,t.pickingMode?e:n),h.loadOpacity(l,t.pickingMode?r>0?1:0:r),d&&!t.pickingMode){this.activeTexture=t.gpuResourceCache.resourceForKey(this.capImageSource()),this.activeTexture||(this.activeTexture=t.gpuResourceCache.retrieveTexture(t.currentGlContext,this.capImageSource())),p?(h.loadApplyLighting(l,!0),l.enableVertexAttribArray(h.normalVectorLocation)):h.loadApplyLighting(l,!1);for(var E=0;E<a;E++){var y=this.sideImageSource(E),_=t.gpuResourceCache.resourceForKey(y),v=6*E*g;y&&!_&&(_=t.gpuResourceCache.retrieveTexture(t.currentGlContext,y)),o=_&&_.bind(t),o?(h.loadTextureEnabled(l,!0),h.loadTextureUnit(l,l.TEXTURE0),l.enableVertexAttribArray(h.vertexTexCoordLocation),l.vertexAttribPointer(h.vertexTexCoordLocation,2,l.FLOAT,!1,g,v+12)):(h.loadTextureEnabled(l,!1),l.disableVertexAttribArray(h.vertexTexCoordLocation)),p&&l.vertexAttribPointer(h.normalVectorLocation,3,l.FLOAT,!1,g,v+20),l.vertexAttribPointer(h.vertexPointLocation,3,l.FLOAT,!1,g,v),l.drawArrays(l.TRIANGLES,0,6)}}else h.loadTextureEnabled(l,!1),p&&!t.pickingMode?(h.loadApplyLighting(l,!0),l.enableVertexAttribArray(h.normalVectorLocation),l.vertexAttribPointer(h.normalVectorLocation,3,l.FLOAT,!1,g,g-12)):h.loadApplyLighting(l,!1),l.vertexAttribPointer(h.vertexPointLocation,3,l.FLOAT,!1,g,0),l.drawArrays(l.TRIANGLES,0,u.numSideVertices)},E.prototype.makeSidesBuffer=function(t){var e,i,r,n,o,s,a,l,h,u,c,d=this.currentData,p=this.hasSideTextures(),m=this.activeAttributes.applyLighting,E=3+(p?2:0)+(m?3:0);r=2*t*3*E,e=new Float32Array(r),i=0,n=new g(0,0,0),o=new g(0,0,0),s=new g(0,0,0),a=new g(0,0,0),p?(l=new f(0,1),h=new f(0,0),u=new f(1,1),c=new f(1,0)):l=h=u=c=null;for(var y=0;y<d.boundaryPoints.length;y++)for(var _,v=d.boundaryPoints[y],b=0;b<v.length-6;b+=6)n[0]=v[b],n[1]=v[b+1],n[2]=v[b+2],o[0]=v[b+3],o[1]=v[b+4],o[2]=v[b+5],s[0]=v[b+6],s[1]=v[b+7],s[2]=v[b+8],a[0]=v[b+9],a[1]=v[b+10],a[2]=v[b+11],_=m?g.computeTriangleNormal(n,o,s):null,this.addVertexToBuffer(n,l,_,e,i),i+=E,this.addVertexToBuffer(o,h,_,e,i),i+=E,this.addVertexToBuffer(s,u,_,e,i),i+=E,this.addVertexToBuffer(o,h,_,e,i),i+=E,this.addVertexToBuffer(a,c,_,e,i),i+=E,this.addVertexToBuffer(s,u,_,e,i),i+=E;return e},E.prototype.addVertexToBuffer=function(t,e,i,r,n){r[n++]=t[0],r[n++]=t[1],r[n++]=t[2],e&&(r[n++]=e[0],r[n++]=e[1]),i&&(r[n++]=i[0],r[n++]=i[1],r[n]=i[2])},E.prototype.drawOutline=function(t,e){var i,r,n,o,s,a,l=t.currentGlContext,h=t.currentProgram,u=this.currentData,c=u.refreshBuffers;h.loadTextureEnabled(l,!1),h.loadApplyLighting(l,!1),this.hasCapTexture()&&l.disableVertexAttribArray(h.vertexTexCoordLocation),this.activeAttributes.applyLighting&&l.disableVertexAttribArray(h.normalVectorLocation),u.boundaryVboCacheKeys||(this.currentData.boundaryVboCacheKeys=[]),this.applyMvpMatrixForOutline(t),h.loadTextureEnabled(l,!1),l.disableVertexAttribArray(h.vertexTexCoordLocation);for(var d=0;d<u.boundaryPoints.length;d++)i=u.boundaryPoints[d].length/3,u.boundaryVboCacheKeys[d]||(u.boundaryVboCacheKeys[d]=t.gpuResourceCache.generateCacheKey()),r=t.gpuResourceCache.resourceForKey(u.boundaryVboCacheKeys[d]),r||(r=l.createBuffer(),t.gpuResourceCache.putResource(u.boundaryVboCacheKeys[d],r,12*i),c=!0),l.bindBuffer(l.ARRAY_BUFFER,r),c&&(l.bufferData(l.ARRAY_BUFFER,u.boundaryPoints[d],l.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1)),o=this.activeAttributes.outlineColor,n=o.alpha*t.currentLayer.opacity,l.depthMask(n>=1||t.pickingMode),h.loadColor(l,t.pickingMode?e:o),h.loadOpacity(l,t.pickingMode?1:n),l.lineWidth(this.activeAttributes.outlineWidth),this._extrude?(s=24,a=i/2):(s=12,a=i),l.vertexAttribPointer(h.vertexPointLocation,3,l.FLOAT,!1,s,0),l.drawArrays(l.LINE_STRIP,0,a),this.mustDrawVerticals(t)&&(l.vertexAttribPointer(h.vertexPointLocation,3,l.FLOAT,!1,0,0),l.drawArrays(l.LINES,0,i-2))},E.prototype.beginDrawing=function(t){var e=t.currentGlContext;this.activeAttributes.drawInterior&&e.disable(e.CULL_FACE),t.findAndBindProgram(i),e.enableVertexAttribArray(t.currentProgram.vertexPointLocation);var r=!t.pickMode&&this.activeAttributes.applyLighting;r&&t.currentProgram.loadModelviewInverse(e,t.navigatorState.modelviewNormalTransform)},E.prototype.endDrawing=function(t){var e=t.currentGlContext;e.disableVertexAttribArray(t.currentProgram.vertexPointLocation),e.disableVertexAttribArray(t.currentProgram.normalVectorLocation),e.depthMask(!0),e.lineWidth(1),e.enable(e.CULL_FACE)},E}),i("shapes/SurfacePolyline",["../error/ArgumentError","../util/Logger","../shapes/ShapeAttributes","../shapes/SurfaceShape"],function(t,e,i,r){"use strict";var n=function(i,n){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfacePolyline","constructor","The specified locations array is null or undefined."));r.call(this,n),this._boundaries=i,this._isInteriorInhibited=!0};return n.prototype=Object.create(r.prototype),n.staticStateKey=function(t){var e=r.staticStateKey(t);return e},n.prototype.computeStateKey=function(){return n.staticStateKey(this)},n}),i("formats/geojson/GeoJSONParser",["../../error/ArgumentError","../../util/Color","./GeoJSONConstants","./GeoJSONCRS","./GeoJSONFeature","./GeoJSONFeatureCollection","./GeoJSONGeometry","./GeoJSONGeometryCollection","./GeoJSONGeometryLineString","./GeoJSONGeometryMultiLineString","./GeoJSONGeometryMultiPoint","./GeoJSONGeometryMultiPolygon","./GeoJSONGeometryPoint","./GeoJSONGeometryPolygon","../../geom/Location","../../util/Logger","../../shapes/Placemark","../../shapes/PlacemarkAttributes","../../shapes/Polygon","../../geom/Position","../../util/proj4-src","../../layer/RenderableLayer","../../shapes/ShapeAttributes","../../shapes/SurfacePolygon","../../shapes/SurfacePolyline"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b,S,T,L){"use strict";var w=function(e){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","constructor","missingDataSource"));this._dataSource=e,this._geoJSONObject=null,this._geoJSONType=null,this._crs=null,this._layer=null,this._parserCompletionCallback=null,this._shapeConfigurationCallback=this.defaultShapeConfigurationCallback,this.defaultPlacemarkAttributes=new E(null),this.defaultShapeAttributes=new S(null),this.setProj4jsAliases()};return Object.defineProperties(w.prototype,{dataSource:{get:function(){return this._dataSource}},geoJSONObject:{get:function(){return this._geoJSONObject}},geoJSONType:{get:function(){return this._geoJSONType}},crs:{get:function(){return this._crs}},layer:{get:function(){return this._layer}},parserCompletionCallback:{get:function(){return this._parserCompletionCallback}},shapeConfigurationCallback:{get:function(){return this._shapeConfigurationCallback}}}),w.prototype.load=function(t,e,i){t&&(this._parserCompletionCallback=t),e&&(this._shapeConfigurationCallback=e),this._layer=i||new b,this.isDataSourceJson()?this.parse(this.dataSource):this.requestUrl(this.dataSource)},w.prototype.defaultShapeConfigurationCallback=function(t,e){var i={},r=e.name||e.Name||e.NAME;return r&&(i.name=r),t.isPointType()||t.isMultiPointType()?i.attributes=this.defaultPlacemarkAttributes:t.isLineStringType()||t.isMultiLineStringType()?i.attributes=this.defaultShapeAttributes:(t.isPolygonType()||t.isMultiPolygonType())&&(i.attributes=this.defaultShapeAttributes),i},w.prototype.requestUrl=function(t){var e=new XMLHttpRequest;e.open("GET",t,!0),e.responseType="text",e.onreadystatechange=function(){4===e.readyState&&(200===e.status?this.parse(e.response):g.log(g.LEVEL_WARNING,"GeoJSON retrieval failed ("+e.statusText+"): "+t))}.bind(this),e.onerror=function(){g.log(g.LEVEL_WARNING,"GeoJSON retrieval failed: "+t)},e.ontimeout=function(){g.log(g.LEVEL_WARNING,"GeoJSON retrieval timed out: "+t)},e.send(null)},w.prototype.parse=function(e){try{this._geoJSONObject=JSON.parse(e)}catch(t){g.logMessage(g.LEVEL_SEVERE,"GeoJSON","parse","invalidGeoJSONObject")}finally{if(this.geoJSONObject){if("[object Array]"===Object.prototype.toString.call(this.geoJSONObject))throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","parse","invalidGeoJSONObjectLength"));if(!this.geoJSONObject.hasOwnProperty(i.FIELD_TYPE))throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","parse","missingGeoJSONType"));this.setGeoJSONType(),this.setGeoJSONCRS(),this._parserCompletionCallback&&"function"==typeof this._parserCompletionCallback&&this._parserCompletionCallback(this.layer)}}},w.prototype.setGeoJSONCRS=function(){if(this.geoJSONObject[i.FIELD_CRS]){this._crs=new r(this.geoJSONObject[i.FIELD_CRS][i.FIELD_TYPE],this.geoJSONObject[i.FIELD_CRS][i.FIELD_PROPERTIES]);var t=function(){this.addRenderablesForGeoJSON(this.layer)}.bind(this);this.crs.setCRSString(t)}else this.addRenderablesForGeoJSON(this.layer)},w.prototype.addRenderablesForGeoJSON=function(e){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForGeoJSON","missingLayer"));switch(this.geoJSONType){case i.TYPE_FEATURE:var r=new n(this.geoJSONObject[i.FIELD_GEOMETRY],this.geoJSONObject[i.FIELD_PROPERTIES],this.geoJSONObject[i.FIELD_ID],this.geoJSONObject[i.FIELD_BBOX]);this.addRenderablesForFeature(e,r);break;case i.TYPE_FEATURE_COLLECTION:var s=new o(this.geoJSONObject[i.FIELD_FEATURES],this.geoJSONObject[i.FIELD_BBOX]);this.addRenderablesForFeatureCollection(e,s);break;case i.TYPE_GEOMETRY_COLLECTION:var l=new a(this.geoJSONObject[i.FIELD_GEOMETRIES],this.geoJSONObject[i.FIELD_BBOX]);this.addRenderablesForGeometryCollection(e,l,null);break;default:this.addRenderablesForGeometry(e,this.geoJSONObject,null)}},w.prototype.addRenderablesForGeometry=function(e,r,n){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForGeometry","missingLayer"));if(!r)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForGeometry","missingGeometry"));switch(r[i.FIELD_TYPE]){case i.TYPE_POINT:var o=new d(r[i.FIELD_COORDINATES],r[i.FIELD_TYPE],r[i.FIELD_BBOX]);this.addRenderablesForPoint(e,o,n?n:null);break;case i.TYPE_MULTI_POINT:var s=new u(r[i.FIELD_COORDINATES],r[i.FIELD_TYPE],r[i.FIELD_BBOX]);this.addRenderablesForMultiPoint(e,s,n?n:null);break;case i.TYPE_LINE_STRING:var a=new l(r[i.FIELD_COORDINATES],r[i.FIELD_TYPE],r[i.FIELD_BBOX]);this.addRenderablesForLineString(e,a,n?n:null);break;case i.TYPE_MULTI_LINE_STRING:var f=new h(r[i.FIELD_COORDINATES],r[i.FIELD_TYPE],r[i.FIELD_BBOX]);this.addRenderablesForMultiLineString(e,f,n?n:null);break;case i.TYPE_POLYGON:var m=new p(r[i.FIELD_COORDINATES],r[i.FIELD_TYPE],r[i.FIELD_BBOX]);this.addRenderablesForPolygon(e,m,n?n:null);break;case i.TYPE_MULTI_POLYGON:var E=new c(r[i.FIELD_COORDINATES],r[i.FIELD_TYPE],r[i.FIELD_BBOX]);this.addRenderablesForMultiPolygon(e,E,n?n:null)}},w.prototype.addRenderablesForPoint=function(e,i,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForPoint","missingLayer"));if(!i)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForPoint","missingGeometry"));var n=this.shapeConfigurationCallback(i,r);if(!this.crs||this.crs.isCRSSupported()){var o=i.coordinates[0],s=i.coordinates[1],a=i.coordinates[2]?i.coordinates[2]:0,l=this.getReprojectedIfRequired(s,o,this.crs),h=new _(l[1],l[0],a),u=new m(h,!1,n&&n.attributes?n.attributes:null);u.altitudeMode=WorldWind.RELATIVE_TO_GROUND,n&&n.name&&(u.label=n.name),n.highlightAttributes&&(u.highlightAttributes=n.highlightAttributes),n&&n.pickDelegate&&(u.pickDelegate=n.pickDelegate),n&&n.userProperties&&(u.userProperties=n.userProperties),e.addRenderable(u)}},w.prototype.addRenderablesForMultiPoint=function(e,i,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForMultiPoint","missingLayer"));if(!i)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForMultiPoint","missingGeometry"));var n=this.shapeConfigurationCallback(i,r);if(!this.crs||this.crs.isCRSSupported())for(var o=0,s=i.coordinates.length;o<s;o+=1){var a=i.coordinates[o][0],l=i.coordinates[o][1],h=i.coordinates[o][2]?i.coordinates[o][2]:0,u=this.getReprojectedIfRequired(l,a,this.crs),c=new _(u[1],u[0],h),d=new m(c,!1,n&&n.attributes?n.attributes:null);d.altitudeMode=WorldWind.RELATIVE_TO_GROUND,n&&n.name&&(d.label=n.name),n.highlightAttributes&&(d.highlightAttributes=n.highlightAttributes),n&&n.pickDelegate&&(d.pickDelegate=n.pickDelegate),n&&n.userProperties&&(d.userProperties=n.userProperties),e.addRenderable(d)}},w.prototype.addRenderablesForLineString=function(e,i,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForLineString","missingLayer"));if(!i)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForLineString","missingGeometry"));var n=this.shapeConfigurationCallback(i,r);if(!this.crs||this.crs.isCRSSupported()){for(var o=[],s=0,a=i.coordinates;s<a.length;s++){var l=a[s][0],h=a[s][1],u=this.getReprojectedIfRequired(h,l,this.crs),c=new f(u[1],u[0]);o.push(c)}var d;d=new L(o,n&&n.attributes?n.attributes:null),n.highlightAttributes&&(d.highlightAttributes=n.highlightAttributes),n&&n.pickDelegate&&(d.pickDelegate=n.pickDelegate),n&&n.userProperties&&(d.userProperties=n.userProperties),e.addRenderable(d)}},w.prototype.addRenderablesForMultiLineString=function(e,i,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForMultiLineString","missingLayer"));if(!i)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForMultiLineString","missingGeometry"));var n=this.shapeConfigurationCallback(i,r);if(!this.crs||this.crs.isCRSSupported())for(var o=0,s=i.coordinates;o<s.length;o++){for(var a=[],l=0,h=s[o];l<h.length;l++){var u=h[l][0],c=h[l][1],d=this.getReprojectedIfRequired(c,u,this.crs),p=new f(d[1],d[0]);a.push(p)}var m;m=new L(a,n&&n.attributes?n.attributes:null),n.highlightAttributes&&(m.highlightAttributes=n.highlightAttributes),n&&n.pickDelegate&&(m.pickDelegate=n.pickDelegate),n&&n.userProperties&&(m.userProperties=n.userProperties),e.addRenderable(m)}},w.prototype.addRenderablesForPolygon=function(e,i,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForPolygon","missingLayer"));if(!i)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForPolygon","missingGeometry"));var n=this.shapeConfigurationCallback(i,r);if(!this.crs||this.crs.isCRSSupported())for(var o=0,s=i.coordinates;o<s.length;o++){for(var a=[],l=0,h=s[o];l<h.length;l++){var u=h[l][0],c=h[l][1],d=this.getReprojectedIfRequired(c,u,this.crs),p=new f(d[1],d[0]);a.push(p)}var m;m=new T(a,n&&n.attributes?n.attributes:null),n.highlightAttributes&&(m.highlightAttributes=n.highlightAttributes),n&&n.pickDelegate&&(m.pickDelegate=n.pickDelegate),n&&n.userProperties&&(m.userProperties=n.userProperties),e.addRenderable(m)}},w.prototype.addRenderablesForMultiPolygon=function(e,i,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForMultiPolygon","missingLayer"));if(!i)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForMultiPolygon","missingGeometry"));var n=this.shapeConfigurationCallback(i,r);if(!this.crs||this.crs.isCRSSupported())for(var o=0,s=i.coordinates;o<s.length;o++){for(var a=[],l=0;l<s[o].length;l++){for(var h=[],u=0,c=s[o][l];u<c.length;u++){var d=c[u][0],p=c[u][1],m=this.getReprojectedIfRequired(p,d,this.crs),E=new f(m[1],m[0]);h.push(E)}a.push(h)}var y;y=new T(a,n&&n.attributes?n.attributes:null),n.highlightAttributes&&(y.highlightAttributes=n.highlightAttributes),n&&n.pickDelegate&&(y.pickDelegate=n.pickDelegate),n&&n.userProperties&&(y.userProperties=n.userProperties),e.addRenderable(y)}},w.prototype.addRenderablesForGeometryCollection=function(e,r,n){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForGeometryCollection","missingLayer"));if(!r)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForGeometryCollection","missingGeometryCollection"));for(var o=0,s=r.geometries;o<s.length;o++)s[o].hasOwnProperty(i.FIELD_TYPE)&&this.addRenderablesForGeometry(e,s[o],n)},w.prototype.addRenderablesForFeature=function(e,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForFeature","missingLayer"));if(!r)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForFeature","missingFeature"));if(r.geometry.type===i.TYPE_GEOMETRY_COLLECTION){var n=new a(r.geometry.geometries,r.bbox);this.addRenderablesForGeometryCollection(e,n,r.properties)}else this.addRenderablesForGeometry(e,r.geometry,r.properties)},w.prototype.addRenderablesForFeatureCollection=function(e,r){if(!e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForFeatureCollection","missingLayer"));if(!r)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","addRenderablesForFeatureCollection","missingFeatureCollection"));if(r.features.length>0)for(var o=0;o<r.features.length;o++){var s=new n(r.features[o][i.FIELD_GEOMETRY],r.features[o][i.FIELD_PROPERTIES],r.features[o][i.FIELD_ID],r.features[o][i.FIELD_BBOX]);this.addRenderablesForFeature(e,s)}},w.prototype.setGeoJSONType=function(){switch(this.geoJSONObject[i.FIELD_TYPE]){case i.TYPE_POINT:this._geoJSONType=i.TYPE_POINT;break;case i.TYPE_MULTI_POINT:this._geoJSONType=i.TYPE_MULTI_POINT;break;case i.TYPE_LINE_STRING:this._geoJSONType=i.TYPE_LINE_STRING;break;case i.TYPE_MULTI_LINE_STRING:this._geoJSONType=i.TYPE_MULTI_LINE_STRING;break;case i.TYPE_POLYGON:this._geoJSONType=i.TYPE_POLYGON;break;case i.TYPE_MULTI_POLYGON:this._geoJSONType=i.TYPE_MULTI_POLYGON;break;case i.TYPE_GEOMETRY_COLLECTION:this._geoJSONType=i.TYPE_GEOMETRY_COLLECTION;break;case i.TYPE_FEATURE:this._geoJSONType=i.TYPE_FEATURE;break;case i.TYPE_FEATURE_COLLECTION:this._geoJSONType=i.TYPE_FEATURE_COLLECTION;break;default:throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","setGeoJSONType","invalidGeoJSONType"))}},w.prototype.getReprojectedIfRequired=function(e,r,n){if(!e&&0!==e)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","getReprojectedIfRequired","missingLatitude"));if(!r&&0!==r)throw new t(g.logMessage(g.LEVEL_SEVERE,"GeoJSON","getReprojectedIfRequired","missingLongitude"));return!n||n.isDefault()?[r,e]:v(n.projectionString,i.EPSG4326_CRS,[r,e])},w.prototype.setProj4jsAliases=function(){v.defs([["urn:ogc:def:crs:OGC:1.3:CRS84",v.defs("EPSG:4326")],["urn:ogc:def:crs:EPSG::3857",v.defs("EPSG:3857")]])},w.prototype.isDataSourceJson=function(){try{JSON.parse(this.dataSource)}catch(t){return!1}return!0},w}),i("formats/geotiff/GeoTiffConstants",[],function(){"use strict";var t={Tag:{MODEL_PIXEL_SCALE:33550,MODEL_TRANSFORMATION:34264,MODEL_TIEPOINT:33922,GEO_KEY_DIRECTORY:34735,GEO_DOUBLE_PARAMS:34736,GEO_ASCII_PARAMS:34737,GDAL_NODATA:42113,GDAL_METADATA:42112},Key:{GTModelTypeGeoKey:1024,GTRasterTypeGeoKey:1025,GTCitationGeoKey:1026,GeographicTypeGeoKey:2048,GeogCitationGeoKey:2049,GeogGeodeticDatumGeoKey:2050,GeogPrimeMeridianGeoKey:2051,GeogLinearUnitsGeoKey:2052,GeogLinearUnitSizeGeoKey:2053,GeogAngularUnitsGeoKey:2054,GeogAngularUnitSizeGeoKey:2055,GeogEllipsoidGeoKey:2056,GeogSemiMajorAxisGeoKey:2057,GeogSemiMinorAxisGeoKey:2058,GeogInvFlatteningGeoKey:2059,GeogAzimuthUnitsGeoKey:2060,GeogPrimeMeridianLongGeoKey:2061,GeogTOWGS84GeoKey:2062,ProjectedCSTypeGeoKey:3072,PCSCitationGeoKey:3073,ProjectionGeoKey:3074,ProjCoordTransGeoKey:3075,ProjLinearUnitsGeoKey:3076,ProjLinearUnitSizeGeoKey:3077,ProjStdParallel1GeoKey:3078,ProjStdParallel2GeoKey:3079,ProjNatOriginLongGeoKey:3080,ProjNatOriginLatGeoKey:3081,ProjFalseEastingGeoKey:3082,ProjFalseNorthingGeoKey:3083,ProjFalseOriginLongGeoKey:3084,ProjFalseOriginLatGeoKey:3085,ProjFalseOriginEastingGeoKey:3086,ProjFalseOriginNorthingGeoKey:3087,ProjCenterLongGeoKey:3088,ProjCenterLatGeoKey:3089,ProjCenterEastingGeoKey:3090,ProjCenterNorthingGeoKey:3091,ProjScaleAtNatOriginGeoKey:3092,ProjScaleAtCenterGeoKey:3093,ProjAzimuthAngleGeoKey:3094,ProjStraightVertPoleLongGeoKey:3095,VerticalCSTypeGeoKey:4096,VerticalCitationGeoKey:4097,VerticalDatumGeoKey:4098,VerticalUnitsGeoKey:4099}};return t}),i("formats/geotiff/GeoTiffKeyEntry",["../../error/AbstractError","../../error/ArgumentError","./GeoTiffConstants","../../util/Logger"],function(t,e,i,r){"use strict";var n=function(t,i,n,o){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"GeoTiffKeyEntry","constructor","missingKeyId"));if(null===i||void 0===i)throw new e(r.logMessage(r.LEVEL_SEVERE,"GeoTiffKeyEntry","constructor","missingTiffTagLocation"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"GeoTiffKeyEntry","constructor","missingCount"));if(null===o||void 0===o)throw new e(r.logMessage(r.LEVEL_SEVERE,"GeoTiffKeyEntry","constructor","missingValueOffset"));this._keyId=t,this._tiffTagLocation=i,this._count=n,this._valueOffset=o};return Object.defineProperties(n.prototype,{keyId:{get:function(){return this._keyId}},tiffTagLocation:{get:function(){return this._tiffTagLocation}},count:{get:function(){return this._count}},valueOffset:{get:function(){return this._valueOffset}}}),n.prototype.getGeoKeyValue=function(t,e){var r;if(0===this.tiffTagLocation)r=this.valueOffset;else if(this.tiffTagLocation===i.Tag.GEO_ASCII_PARAMS){var n="";if(e){for(var o=this.valueOffset;o<this.count-1;o++)n+=e[o];"|"!=e[this.count-1]&&(n+=e[this.count-1]),r=n}}else this.tiffTagLocation===i.Tag.GEO_DOUBLE_PARAMS&&t&&(r=t[this.valueOffset]);return r},n}),i("formats/geotiff/GeoTiffMetadata",[],function(){"use strict";var t=function(){this._bitsPerSample=null,this._colorMap=null,this._compression=null,this._extraSamples=null,this._imageLength=null,this._imageWidth=null,this._maxSampleValue=null,this._minSampleValue=null,this._orientation=0,this._photometricInterpretation=null,this._planarConfiguration=null,this._resolutionUnit=null,this._rowsPerStrip=null,this._samplesPerPixel=null,this._sampleFormat=null,this._software=null,this._stripByteCounts=null,this._stripOffsets=null,this._tileByteCounts=null,this._tileOffsets=null,this._tileLength=null,this._tileWidth=null,this._xResolution=null,this._yResolution=null,this._geoAsciiParams=null,this._geoDoubleParams=null,this._geoKeyDirectory=null,this._modelPixelScale=null,this._modelTiepoint=null,this._modelTransformation=null,this._noData=null,this._bbox=null,this._gtModelTypeGeoKey=null,this._gtRasterTypeGeoKey=null,this._gtCitationGeoKey=null,this._geographicTypeGeoKey=null,this._geogCitationGeoKey=null,this._geogAngularUnitsGeoKey=null,this._geogAngularUnitSizeGeoKey=null,this._geogSemiMajorAxisGeoKey=null,this._geogInvFlatteningGeoKey=null,this._projectedCSType=null};return Object.defineProperties(t.prototype,{bitsPerSample:{get:function(){return this._bitsPerSample},set:function(t){this._bitsPerSample=t}},colorMap:{get:function(){return this._colorMap},set:function(t){this._colorMap=t}},compression:{get:function(){return this._compression},set:function(t){this._compression=t}},extraSamples:{get:function(){return this._extraSamples},set:function(t){this._extraSamples=t}},imageLength:{get:function(){return this._imageLength},set:function(t){this._imageLength=t}},imageWidth:{get:function(){return this._imageWidth;
},set:function(t){this._imageWidth=t}},maxSampleValue:{get:function(){return this._maxSampleValue},set:function(t){this._maxSampleValue=t}},minSampleValue:{get:function(){return this._minSampleValue},set:function(t){this._minSampleValue=t}},orientation:{get:function(){return this._orientation},set:function(t){this._orientation=t}},photometricInterpretation:{get:function(){return this._photometricInterpretation},set:function(t){this._photometricInterpretation=t}},planarConfiguration:{get:function(){return this._planarConfiguration},set:function(t){this._planarConfiguration=t}},resolutionUnit:{get:function(){return this._resolutionUnit},set:function(t){this._resolutionUnit=t}},rowsPerStrip:{get:function(){return this._rowsPerStrip},set:function(t){this._rowsPerStrip=t}},samplesPerPixel:{get:function(){return this._samplesPerPixel},set:function(t){this._samplesPerPixel=t}},sampleFormat:{get:function(){return this._sampleFormat},set:function(t){this._sampleFormat=t}},software:{get:function(){return this._software},set:function(t){this._software=t}},stripByteCounts:{get:function(){return this._stripByteCounts},set:function(t){this._stripByteCounts=t}},stripOffsets:{get:function(){return this._stripOffsets},set:function(t){this._stripOffsets=t}},tileByteCounts:{get:function(){return this._tileByteCounts},set:function(t){this._tileByteCounts=t}},tileOffsets:{get:function(){return this._tileOffsets},set:function(t){this._tileOffsets=t}},tileLength:{get:function(){return this._tileLength},set:function(t){this._tileLength=t}},tileWidth:{get:function(){return this._tileWidth},set:function(t){this._tileWidth=t}},geoAsciiParams:{get:function(){return this._geoAsciiParams},set:function(t){this._geoAsciiParams=t}},geoDoubleParams:{get:function(){return this._geoDoubleParams},set:function(t){this._geoDoubleParams=t}},geoKeyDirectory:{get:function(){return this._geoKeyDirectory},set:function(t){this._geoKeyDirectory=t}},modelPixelScale:{get:function(){return this._modelPixelScale},set:function(t){this._modelPixelScale=t}},modelTiepoint:{get:function(){return this._modelTiepoint},set:function(t){this._modelTiepoint=t}},modelTransformation:{get:function(){return this._modelTransformation},set:function(t){this._modelTransformation=t}},noData:{get:function(){return this._noData},set:function(t){this._noData=t}},bbox:{get:function(){return this._bbox},set:function(t){this._bbox=t}},gtModelTypeGeoKey:{get:function(){return this._gtModelTypeGeoKey},set:function(t){this._gtModelTypeGeoKey=t}},gtRasterTypeGeoKey:{get:function(){return this._gtRasterTypeGeoKey},set:function(t){this._gtRasterTypeGeoKey=t}},gtCitationGeoKey:{get:function(){return this._gtCitationGeoKey},set:function(t){this._gtCitationGeoKey=t}},geographicTypeGeoKey:{get:function(){return this._geographicTypeGeoKey},set:function(t){this._geographicTypeGeoKey=t}},geogCitationGeoKey:{get:function(){return this._geogCitationGeoKey},set:function(t){this._geogCitationGeoKey=t}},geogAngularUnitsGeoKey:{get:function(){return this._geogAngularUnitsGeoKey},set:function(t){this._geogAngularUnitsGeoKey=t}},geogAngularUnitSizeGeoKey:{get:function(){return this._geogAngularUnitSizeGeoKey},set:function(t){this._geogAngularUnitSizeGeoKey=t}},geogSemiMajorAxisGeoKey:{get:function(){return this._geogSemiMajorAxisGeoKey},set:function(t){this._geogSemiMajorAxisGeoKey=t}},geogInvFlatteningGeoKey:{get:function(){return this._geogInvFlatteningGeoKey},set:function(t){this._geogInvFlatteningGeoKey=t}},projectedCSType:{get:function(){return this._projectedCSType},set:function(t){this._projectedCSType=t}},xResolution:{get:function(){return this._xResolution},set:function(t){this._xResolution=t}},yResolution:{get:function(){return this._yResolution},set:function(t){this._yResolution=t}}}),t}),i("formats/geotiff/TiffConstants",[],function(){"use strict";var t={Tag:{NEW_SUBFILE_TYPE:254,SUBFILE_TYPE:255,IMAGE_WIDTH:256,IMAGE_LENGTH:257,BITS_PER_SAMPLE:258,COMPRESSION:259,PHOTOMETRIC_INTERPRETATION:262,THRESHHOLDING:263,CELL_WIDTH:264,CELL_LENGTH:265,FILL_ORDER:266,DOCUMENT_NAME:269,IMAGE_DESCRIPTION:270,MAKE:271,MODEL:272,STRIP_OFFSETS:273,ORIENTATION:274,SAMPLES_PER_PIXEL:277,ROWS_PER_STRIP:278,STRIP_BYTE_COUNTS:279,MIN_SAMPLE_VALUE:280,MAX_SAMPLE_VALUE:281,X_RESOLUTION:282,Y_RESOLUTION:283,PLANAR_CONFIGURATION:284,PAGE_NAME:285,X_POSITION:286,Y_POSITION:287,FREE_OFFSETS:288,FREE_BYTE_COUNTS:289,GRAY_RESPONSE_UNIT:290,GRAY_RESPONSE_CURVE:291,T4_OPTIONS:292,T6_PTIONS:293,RESOLUTION_UNIT:296,PAGE_NUMBER:297,TRANSFER_FUNCTION:301,SOFTWARE:305,DATE_TIME:306,ARTIST:315,HOST_COMPUTER:316,PREDICTOR:317,WHITE_POINT:318,PRIMARY_CHROMATICITIES:319,COLOR_MAP:320,HALFTONE_HINTS:321,TILE_WIDTH:322,TILE_LENGTH:323,TILE_OFFSETS:324,TILE_BYTE_COUNTS:325,INK_SET:332,INK_NAMES:333,NUMBER_OF_INKS:334,DOT_RANGE:336,TARGET_PRINTER:337,EXTRA_SAMPLES:338,SAMPLE_FORMAT:339,S_MIN_SAMPLE_VALUE:340,S_MAX_SAMPLE_VALUE:341,TRANSFER_RANGE:342,JPEG_PROC:512,JPEG_INTERCHANGE_FORMAT:513,JPEG_INTERCHANGE_FORMAT_LENGTH:514,JPEG_RESTART_INTERVAL:515,JPEG_LOSSLESS_PREDICTORS:517,JPEG_POINT_TRANSFORMS:518,JPEG_Q_TABLES:519,JPEG_DC_TABLES:520,JPEG_AC_TABLES:521,Y_Cb_Cr_COEFFICIENTS:529,Y_Cb_Cr_SUB_SAMPLING:530,Y_Cb_Cr_POSITIONING:531,REFERENCE_BLACK_WHITE:532,COPYRIGHT:33432},Compression:{UNCOMPRESSED:1,CCITT_1D:2,GROUP_3_FAX:3,GROUP_4_FAX:4,LZW:5,JPEG:6,PACK_BITS:32773},Orientation:{Row0_IS_TOP__Col0_IS_LHS:1,Row0_IS_TOP__Col0_IS_RHS:2,Row0_IS_BOTTOM__Col0_IS_RHS:3,Row0_IS_BOTTOM__Col0_IS_LHS:4,Row0_IS_LHS__Col0_IS_TOP:5,Row0_IS_RHS__Col0_IS_TOP:6,Row0_IS_RHS__Col0_IS_BOTTOM:7,Row0_IS_LHS__Col0_IS_BOTTOM:8},PhotometricInterpretation:{WHITE_IS_ZERO:0,BLACK_IS_ZERO:1,RGB:2,RGB_PALETTE:3,TRANSPARENCY_MASK:4,CMYK:5,Y_Cb_Cr:6,CIE_LAB:7},PlanarConfiguration:{CHUNKY:1,PLANAR:2},ResolutionUnit:{NONE:1,INCH:2,CENTIMETER:3},SampleFormat:{UNSIGNED:1,SIGNED:2,IEEE_FLOAT:3,UNDEFINED:4,DEFAULT:1},Type:{BYTE:1,ASCII:2,SHORT:3,LONG:4,RATIONAL:5,SBYTE:6,UNDEFINED:7,SSHORT:8,SLONG:9,SRATIONAL:10,FLOAT:11,DOUBLE:12}};return t}),i("formats/geotiff/GeoTiffUtil",["../../error/ArgumentError","../../util/Logger","./TiffConstants"],function(t,e,i){"use strict";var r={getBytes:function(i,r,n,o,s){if(n<=0)throw new t(e.logMessage(e.LEVEL_SEVERE,"GeoTiffReader","getBytes","noBytesRequested"));if(n<=1)return s?i.getInt8(r,o):i.getUint8(r,o);if(n<=2)return s?i.getInt16(r,o):i.getUint16(r,o);if(n<=3)return s?i.getInt32(r,o)>>>8:i.getUint32(r,o)>>>8;if(n<=4)return s?i.getInt32(r,o):i.getUint32(r,o);if(n<=8)return i.getFloat64(r,o);throw new t(e.logMessage(e.LEVEL_SEVERE,"GeoTiffReader","getBytes","tooManyBytesRequested"))},getSampleBytes:function(t,r,n,o,s){var a;switch(o){case i.SampleFormat.UNSIGNED:a=this.getBytes(t,r,n,s,!1);break;case i.SampleFormat.SIGNED:a=this.getBytes(t,r,n,s,!0);break;case i.SampleFormat.IEEE_FLOAT:3==n?a=t.getFloat32(r,s)>>>8:4==n?a=t.getFloat32(r,s):8==n?a=t.getFloat64(r,s):e.log(e.LEVEL_WARNING,"Do not attempt to parse the data  not handled: "+n);break;case i.SampleFormat.UNDEFINED:default:a=this.getBytes(t,r,n,s,!1)}return a},canvasToTiffImage:function(t){var e=new Image;return e.src=t.toDataURL(),e},getRGBAFillValue:function(t,e,i,r){return"undefined"==typeof r&&(r=1),"rgba("+t+", "+e+", "+i+", "+r+")"},getTagValueAsString:function(t,e){for(var i in t)if(t[i]===e)return i},clampColorSample:function(t,e){var i=Math.pow(2,8-e);return Math.floor(t*i+(i-1))},clampColorSampleForElevation:function(t,e,i){var r=255/(i-e);return Math.round(r*(t-e))},getMinMaxGeotiffSamples:function(t,e){for(var i=1/0,r=-(1/0),n=0;n<t.length;n++)for(var o=0;o<t[n].length;o++)for(var s=0;s<t[n][o].length;s++)t[n][o][s]!=e&&(t[n][o][s]>r&&(r=t[n][o][s]),t[n][o][s]<i&&(i=t[n][o][s]));return{max:r,min:i}}};return r}),i("formats/geotiff/TiffIFDEntry",["../../error/AbstractError","../../error/ArgumentError","./GeoTiffUtil","../../util/Logger","./TiffConstants"],function(t,e,i,r,n){"use strict";var o=function(t,i,n,o,s,a){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"TiffIFDEntry","constructor","missingTag"));if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"TiffIFDEntry","constructor","missingType"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"TiffIFDEntry","constructor","missingCount"));if(null===o||void 0===o)throw new e(r.logMessage(r.LEVEL_SEVERE,"TiffIFDEntry","constructor","missingValueOffset"));if(!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"TiffIFDEntry","constructor","missingGeoTiffData"));if(null===a||void 0===a)throw new e(r.logMessage(r.LEVEL_SEVERE,"TiffIFDEntry","constructor","missingIsLittleEndian"));this._tag=t,this._type=i,this._count=n,this._valueOffset=o,this._geoTiffData=s,this._isLittleEndian=a};return Object.defineProperties(o.prototype,{tag:{get:function(){return this._tag}},type:{get:function(){return this._type}},count:{get:function(){return this._count}},valueOffset:{get:function(){return this._valueOffset}},geoTiffData:{get:function(){return this._geoTiffData}},isLittleEndian:{get:function(){return this._isLittleEndian}}}),o.prototype.getIFDTypeLength=function(){switch(this.type){case n.Type.BYTE:case n.Type.ASCII:case n.Type.SBYTE:case n.Type.UNDEFINED:return 1;case n.Type.SHORT:case n.Type.SSHORT:return 2;case n.Type.LONG:case n.Type.SLONG:case n.Type.FLOAT:return 4;case n.Type.RATIONAL:case n.Type.SRATIONAL:case n.Type.DOUBLE:return 8;default:return-1}},o.prototype.getIFDEntryValue=function(){var e=[],o=null,s=this.getIFDTypeLength(),a=s*this.count;if(a<=4)o=this.isLittleEndian===!1?this.valueOffset>>>8*(4-s):this.valueOffset,e.push(o);else for(var l=0;l<this.count;l++){var h=s*l;if(s>=8)if(this.type===n.Type.RATIONAL||this.type===n.Type.SRATIONAL)e.push(i.getBytes(this.geoTiffData,this.valueOffset+h,4,this.isLittleEndian)),e.push(i.getBytes(this.geoTiffData,this.valueOffset+h+4,4,this.isLittleEndian));else{if(this.type!==n.Type.DOUBLE)throw new t(r.logMessage(r.LEVEL_SEVERE,"TiffIFDEntry","parse","invalidTypeOfIFD"));e.push(i.getBytes(this.geoTiffData,this.valueOffset+h,8,this.isLittleEndian))}else e.push(i.getBytes(this.geoTiffData,this.valueOffset+h,s,this.isLittleEndian))}return this.type===n.Type.ASCII?(e.forEach(function(t,e,i){0===t?i.splice(e,1):i[e]=String.fromCharCode(t)}),e.join("")):e},o}),i("formats/geotiff/GeoTiffReader",["../../error/AbstractError","../../error/ArgumentError","./GeoTiffConstants","./GeoTiffKeyEntry","./GeoTiffMetadata","./GeoTiffUtil","../../geom/Location","../../geom/Sector","../../util/Logger","../../util/proj4-src","./TiffConstants","./TiffIFDEntry","../../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h,u,c,d){"use strict";var p=function(t){if(!t)throw new e(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","constructor","missingUrl"));this._url=t,this._isLittleEndian=!1,this._imageFileDirectories=[],this._geoTiffData=null,this._metadata=new n};return Object.defineProperties(p.prototype,{url:{get:function(){return this._url}},isLittleEndian:{get:function(){return this._isLittleEndian}},imageFileDirectories:{get:function(){return this._imageFileDirectories}},geoTiffData:{get:function(){return this._geoTiffData}},metadata:{get:function(){return this._metadata}}}),p.prototype.requestUrl=function(t,e){var i=new XMLHttpRequest;i.open("GET",t,!0),i.responseType="arraybuffer",i.onreadystatechange=function(){if(4===i.readyState)if(200===i.status){var r=i.response;r&&(this.parse(r),e())}else l.log(l.LEVEL_WARNING,"GeoTiff retrieval failed ("+i.statusText+"): "+t)}.bind(this),i.onerror=function(){l.log(l.LEVEL_WARNING,"GeoTiff retrieval failed: "+t)},i.ontimeout=function(){l.log(l.LEVEL_WARNING,"GeoTiff retrieval timed out: "+t)},i.send(null)},p.prototype.parse=function(e){if(this._geoTiffData=new DataView(e),this.getEndianness(),!this.isTiffFileType())throw new t(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","parse","invalidTiffFileType"));var i=o.getBytes(this.geoTiffData,4,4,this.isLittleEndian);this.parseImageFileDirectory(i),this.getMetadataFromImageFileDirectory(),this.parseGeoKeys(),this.setBBox()},p.prototype.getEndianness=function(){var e=o.getBytes(this.geoTiffData,0,2,this.isLittleEndian);if(18761===e)this._isLittleEndian=!0;else{if(19789!==e)throw new t(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","getEndianness","invalidByteOrderValue"));this._isLittleEndian=!1}},p.prototype.isTiffFileType=function(){var t=o.getBytes(this.geoTiffData,2,2,this.isLittleEndian);return 42===t},p.prototype.isGeoTiff=function(){return!!this.getIFDByTag(i.Tag.GEO_KEY_DIRECTORY)},p.prototype.readAsImage=function(t){this.requestUrl(this.url,function(){var e=this.metadata.bitsPerSample,i=this.metadata.samplesPerPixel,r=this.metadata.photometricInterpretation,n=this.metadata.imageLength,o=this.metadata.imageWidth;if(this.metadata.colorMap)var s=this.metadata.colorMap,a=Math.pow(2,e[0]);var l=document.createElement("canvas");l.width=o,l.height=n;var h=l.getContext("2d");if(this.metadata.stripOffsets){var u=this.parseStrips(!1);if(this.metadata.rowsPerStrip)var c=this.metadata.rowsPerStrip;else var c=n;for(var d=u.length,p=0,f=c,g=n%c,m=0===g?c:g,E=0;E<d;E++){E+1===d&&(f=m);for(var y=u[E].length,_=p*E,v=0,b=0;b<y;v++)for(var S=0;S<o;S++,b++){var T=u[E][b];h.fillStyle=this.getFillStyle(T,r,e,i,s,a),h.fillRect(S,_+v,1,1)}p=c}}else if(this.metadata.tileOffsets)for(var L=this.parseTiles(!1),w=this.metadata.tileWidth,x=this.metadata.tileLength,R=Math.ceil(o/w),v=0;v<n;v++)for(var S=0;S<o;S++){var M=Math.floor(S/w),C=Math.floor(v/x),A=C*R+M,P=S%w,O=v%x,I=O*w+P,T=L[A][I];h.fillStyle=this.getFillStyle(T,r,e,i,s,a),h.fillRect(S,v,1,1)}this._geoTiffData=null,t(l)}.bind(this))},p.prototype.getFillStyle=function(t,e,i,r,n,s){var a=0,h=0,c=0,d=1;switch(this.metadata.noData&&t[0]==this.metadata.noData&&(d=0),e){case u.PhotometricInterpretation.WHITE_IS_ZERO:var p=Math.pow(2,i)-1;t[0]=p-t[0];case u.PhotometricInterpretation.BLACK_IS_ZERO:a=h=c=o.clampColorSample(t[0],i[0]);break;case u.PhotometricInterpretation.RGB:if(a=o.clampColorSample(t[0],i[0]),h=o.clampColorSample(t[1],i[1]),c=o.clampColorSample(t[2],i[2]),4===r&&2===this.metadata.extraSamples[0]){var f=Math.pow(2,i[3]);d=t[3]/f}break;case u.PhotometricInterpretation.RGB_PALETTE:if(n){var g=t[0];a=o.clampColorSample(n[g],16),h=o.clampColorSample(n[s+g],16),c=o.clampColorSample(n[2*s+g],16)}break;case u.PhotometricInterpretation.TRANSPARENCY_MASK:l.log(l.LEVEL_WARNING,"Photometric interpretation not yet implemented: TRANSPARENCY_MASK");break;case u.PhotometricInterpretation.CMYK:l.log(l.LEVEL_WARNING,"Photometric interpretation not yet implemented: CMYK");break;case u.PhotometricInterpretation.Y_Cb_Cr:l.log(l.LEVEL_WARNING,"Photometric interpretation not yet implemented: Y_Cb_Cr");break;case u.PhotometricInterpretation.CIE_LAB:l.log(l.LEVEL_WARNING,"Photometric interpretation not yet implemented: CIE_LAB");break;default:l.log("Unknown photometric interpretation: "+e)}return o.getRGBAFillValue(a,h,c,d)},p.prototype.createTypedElevationArray=function(){var t,e=[],i=this.metadata.bitsPerSample[0];if(this.metadata.stripOffsets)for(var r=this.parseStrips(!0),n=0;n<r.length;n++)e=e.concat(r[n]);else if(this.metadata.tileOffsets)for(var o=this.parseTiles(!0),s=this.metadata.imageWidth,a=this.metadata.imageLength,l=this.metadata.tileWidth,h=this.metadata.tileLength,c=Math.ceil(s/l),d=0;d<a;d++)for(var p=0;p<s;p++){var f=Math.floor(p/l),g=Math.floor(d/h),m=g*c+f,E=p%l,y=d%h,_=y*l+E,v=o[m][_];e.push(v)}if(this.metadata.sampleFormat)var b=this.metadata.sampleFormat[0];else var b=u.SampleFormat.UNSIGNED;switch(i){case 8:t=b===u.SampleFormat.SIGNED?new Int8Array(e):new Uint8Array(e);break;case 16:t=b===u.SampleFormat.SIGNED?new Int16Array(e):new Uint16Array(e);break;case 32:t=b===u.SampleFormat.SIGNED?new Int32Array(e):b===u.SampleFormat.IEEE_FLOAT?new Float32Array(e):new Uint32Array(e);break;case 64:t=new Float64Array(e)}return t},p.prototype.readAsData=function(t){this.requestUrl(this.url,function(){t(this.createTypedElevationArray())}.bind(this))},p.prototype.parseStrips=function(t){var e=this.metadata.samplesPerPixel,i=this.metadata.bitsPerSample,r=this.metadata.stripOffsets,n=this.metadata.stripByteCounts,o=this.metadata.compression;if(this.metadata.sampleFormat)var s=this.metadata.sampleFormat;else var s=u.SampleFormat.UNSIGNED;for(var a=e*i[0],l=a/8,h=[],c=0;c<r.length;c++){var d=r[c],p=n[c];h[c]=this.parseBlock(t,o,l,p,d,i,s)}return h},p.prototype.parseBlock=function(t,e,i,r,n,s,a){var h=[];switch(e){case u.Compression.UNCOMPRESSED:for(var c=0,d=i;c<r;c+=d){for(var p=0,f=[];p<s.length;p++){var g=s[p]/8,m=p*g;f.push(o.getSampleBytes(this.geoTiffData,n+c+m,g,a[p],this.isLittleEndian))}t?h.push(f[0]):h.push(f)}break;case u.Compression.CCITT_1D:l.log(l.LEVEL_WARNING,"Compression type not yet implemented: CCITT_1D");break;case u.Compression.GROUP_3_FAX:l.log(l.LEVEL_WARNING,"Compression type not yet implemented: GROUP_3_FAX");break;case u.Compression.GROUP_4_FAX:l.log(l.LEVEL_WARNING,"Compression type not yet implemented: GROUP_4_FAX");break;case u.Compression.LZW:l.log(l.LEVEL_WARNING,"Compression type not yet implemented: LZW");break;case u.Compression.JPEG:l.log(l.LEVEL_WARNING,"Compression type not yet implemented: JPEG");break;case u.Compression.PACK_BITS:if(this.metadata.tileOffsets)var E=this.metadata.tileWidth,y=this.metadata.tileWidth,_=new ArrayBuffer(E*y*i);else var v=this.metadata.rowsPerStrip,b=this.metadata.imageWidth,_=new ArrayBuffer(v*b*i);for(var S=new DataView(_),T=!0,f=[],L=0,w=0,x=0,c=0;c<r;c+=1)if(T){L=1,w=1,T=!1;var R=this.geoTiffData.getInt8(n+c,this.isLittleEndian);R>=0&&R<=127?L=R+1:R>=-127&&R<=-1?w=-R+1:T=!0}else{for(var M=o.getBytes(this.geoTiffData,n+c,1,this.isLittleEndian),C=0;C<w;C++)S.setInt8(x,M),x++;L--,0===L&&(T=!0)}for(var c=0,d=i;c<_.byteLength;c+=d){for(var p=0,f=[];p<s.length;p++){var g=s[p]/8,m=p*g;f.push(o.getSampleBytes(S,c+m,g,a[p],this.isLittleEndian))}t?h.push(f[0]):h.push(f)}}return h},p.prototype.parseTiles=function(t){var e=this.metadata.samplesPerPixel,i=this.metadata.bitsPerSample,r=this.metadata.compression;if(this.metadata.sampleFormat)var n=this.metadata.sampleFormat;else{var n=new Array(e);d.fillArray(n,u.SampleFormat.UNSIGNED)}for(var o=e*i[0],s=o/8,a=this.metadata.tileWidth,l=this.metadata.tileLength,h=this.metadata.tileOffsets,c=this.metadata.tileByteCounts,p=this.metadata.imageLength,f=this.metadata.imageWidth,g=Math.ceil(f/a),m=Math.ceil(p/l),E=[],y=0;y<m;y++)for(var _=0;_<g;_++){var v=g*y+_,b=h[v],S=c[v];E[v]=this.parseBlock(t,r,s,S,b,i,n)}return E},p.prototype.geoTiffImageToPCS=function(t,i){if(null===t||void 0===t)throw new e(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","geoTiffImageToPCS","missingXValue"));if(null===i||void 0===i)throw new e(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","geoTiffImageToPCS","missingYValue"));var r=[t,i],n=this.metadata.modelTiepoint,o=this.metadata.modelPixelScale,a=this.metadata.modelTransformation,u=n?n.length:0,c=o?o.length:0,d=a?a.length:0;if(u>6&&0===c);else if(16===d){var p=t,f=i;t=p*a[0]+f*a[1]+a[3],i=p*a[4]+f*a[5]+a[7],r=[t,i]}else c<3||u<6?r=[t,i]:(t=(t-n[0])*o[0]+n[3],i=(i-n[1])*(-1*o[1])+n[4],r=[t,i]);return h.defs([["EPSG:26771","+proj=tmerc +lat_0=36.66666666666666 +lon_0=-88.33333333333333 +k=0.9999749999999999 +x_0=152400.3048006096 +y_0=0 +ellps=clrk66 +datum=NAD27 +to_meter=0.3048006096012192 +no_defs "],["EPSG:32633","+proj=utm +zone=33 +datum=WGS84 +units=m +no_defs"]]),this.metadata.projectedCSType&&(r=h("EPSG:"+this.metadata.projectedCSType,"EPSG:4326",r)),new s(r[1],r[0])},p.prototype.setBBox=function(){var t=this.geoTiffImageToPCS(0,0),e=this.geoTiffImageToPCS(this.metadata.imageWidth,0),i=this.geoTiffImageToPCS(0,this.metadata.imageLength);this.geoTiffImageToPCS(this.metadata.imageWidth,this.metadata.imageLength);this.metadata.bbox=new a(i.latitude,t.latitude,t.longitude,e.longitude)},p.prototype.getMetadataFromImageFileDirectory=function(){for(var t=0;t<this.imageFileDirectories[0].length;t++)switch(this.imageFileDirectories[0][t].tag){case u.Tag.BITS_PER_SAMPLE:this.metadata.bitsPerSample=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.COLOR_MAP:this.metadata.colorMap=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.COMPRESSION:this.metadata.compression=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.EXTRA_SAMPLES:this.metadata.extraSamples=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.IMAGE_LENGTH:this.metadata.imageLength=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.IMAGE_WIDTH:this.metadata.imageWidth=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.MAX_SAMPLE_VALUE:this.metadata.maxSampleValue=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.MIN_SAMPLE_VALUE:this.metadata.minSampleValue=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.ORIENTATION:this.metadata.orientation=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.PHOTOMETRIC_INTERPRETATION:this.metadata.photometricInterpretation=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.PLANAR_CONFIGURATION:this.metadata.planarConfiguration=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.ROWS_PER_STRIP:this.metadata.rowsPerStrip=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.RESOLUTION_UNIT:this.metadata.resolutionUnit=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.SAMPLES_PER_PIXEL:this.metadata.samplesPerPixel=this.imageFileDirectories[0][t].getIFDEntryValue()[0];break;case u.Tag.SAMPLE_FORMAT:this.metadata.sampleFormat=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.SOFTWARE:this.metadata.software=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.STRIP_BYTE_COUNTS:this.metadata.stripByteCounts=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.STRIP_OFFSETS:this.metadata.stripOffsets=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.TILE_BYTE_COUNTS:this.metadata.tileByteCounts=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.TILE_OFFSETS:this.metadata.tileOffsets=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.TILE_LENGTH:this.metadata.tileLength=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.TILE_WIDTH:this.metadata.tileWidth=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.X_RESOLUTION:this.metadata.xResolution=this.imageFileDirectories[0][t].getIFDEntryValue();break;case u.Tag.Y_RESOLUTION:this.metadata.tileWidth=this.imageFileDirectories[0][t].getIFDEntryValue();break;case i.Tag.GEO_ASCII_PARAMS:this.metadata.geoAsciiParams=this.imageFileDirectories[0][t].getIFDEntryValue();break;case i.Tag.GEO_DOUBLE_PARAMS:this.metadata.geoDubleParams=this.imageFileDirectories[0][t].getIFDEntryValue();break;case i.Tag.GEO_KEY_DIRECTORY:this.metadata.geoKeyDirectory=this.imageFileDirectories[0][t].getIFDEntryValue();break;case i.Tag.MODEL_PIXEL_SCALE:this.metadata.modelPixelScale=this.imageFileDirectories[0][t].getIFDEntryValue();break;case i.Tag.MODEL_TIEPOINT:this.metadata.modelTiepoint=this.imageFileDirectories[0][t].getIFDEntryValue();break;case i.Tag.GDAL_NODATA:this.metadata.noData=this.imageFileDirectories[0][t].getIFDEntryValue();break;default:l.log(l.LEVEL_WARNING,"Ignored GeoTiff tag: "+this.imageFileDirectories[0][t].tag)}},p.prototype.getMetadataFromGeoKeys=function(){for(var t=0;t<this.geoKeys.length;t++){var e=o.getTagValueAsString(i.Key,this.geoKeys[t].keyId);e?this._metadata.geotiff.geoKeys[e]=this.geoKeys[t].getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams):l.log(l.LEVEL_WARNING,"Unknown GeoTiff key: "+this.geoKeys[t].keyId)}},p.prototype.parseGeoKeys=function(){if(!this.isGeoTiff())throw new t(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","parse","invalidGeoTiffFile"));var e=this.metadata.geoKeyDirectory;if(!e)throw new t(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","parseGeoKeys","missingGeoKeyDirectoryTag"));for(var n=(e[0],e[1],e[2],e[3]),o=0;o<n;o++){var s=e[4+4*o],a=e[5+4*o],h=e[6+4*o],u=e[7+4*o];switch(s){case i.Key.GTModelTypeGeoKey:this.metadata.gtModelTypeGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GTRasterTypeGeoKey:this.metadata.gtRasterTypeGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GTCitationGeoKey:this.metadata.gtCitationGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GeographicTypeGeoKey:this.metadata.geographicTypeGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GeogCitationGeoKey:this.metadata.geogCitationGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GeogAngularUnitsGeoKey:this.metadata.geogAngularUnitsGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GeogAngularUnitSizeGeoKey:this.metadata.geogAngularUnitSizeGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GeogSemiMajorAxisGeoKey:this.metadata.geogSemiMajorAxisGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.GeogInvFlatteningGeoKey:this.metadata.geogInvFlatteningGeoKey=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;case i.Key.ProjectedCSTypeGeoKey:this.metadata.projectedCSType=new r(s,a,h,u).getGeoKeyValue(this.metadata.geoDoubleParams,this.metadata.geoAsciiParams);break;default:l.log(l.LEVEL_WARNING,"Ignored GeoTiff key: "+s)}}},p.prototype.parseImageFileDirectory=function(t){if(!t)throw new e(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","parseImageFileDirectory","missingOffset"));for(var i=o.getBytes(this.geoTiffData,t,2,this.isLittleEndian),r=[],n=t+2,s=0;s<i;n+=12,s++){var a=o.getBytes(this.geoTiffData,n,2,this.isLittleEndian),h=o.getBytes(this.geoTiffData,n+2,2,this.isLittleEndian),u=o.getBytes(this.geoTiffData,n+4,4,this.isLittleEndian),d=o.getBytes(this.geoTiffData,n+8,4,this.isLittleEndian);r.push(new c(a,h,u,d,this.geoTiffData,this.isLittleEndian))}this._imageFileDirectories.push(r);var p=o.getBytes(this.geoTiffData,n,4,this.isLittleEndian);0!==p&&this.parseImageFileDirectory(p)},p.prototype.getIFDByTag=function(t){if(!t)throw new e(l.logMessage(l.LEVEL_SEVERE,"GeoTiffReader","getIFDByTag","missingTag"));for(var i=0;i<this.imageFileDirectories[0].length;i++)if(this.imageFileDirectories[0][i].tag===t)return this.imageFileDirectories[0][i];return null},p}),i("projections/ProjectionEquirectangular",["../geom/Angle","../error/ArgumentError","../projections/GeographicProjection","../util/Logger","../geom/Vec3"],function(t,e,i,r,n){"use strict";var o=function(){i.call(this,"Equirectangular",!0,null)};return o.prototype=Object.create(i.prototype),Object.defineProperties(o.prototype,{stateKey:{get:function(){return"projection equirectangular "}}}),o.prototype.geographicToCartesian=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","geographicToCartesian","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","geographicToCartesian","missingResult"));return l[0]=i.equatorialRadius*o*t.DEGREES_TO_RADIANS+(a?a[0]:0),l[1]=i.equatorialRadius*n*t.DEGREES_TO_RADIANS,l[2]=s,l},o.prototype.geographicToCartesianGrid=function(i,o,s,a,l,h,u,c){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","geographicToCartesianGrid","missingGlobe"));if(!o)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","geographicToCartesianGrid","missingSector"));if(!l||l.length<s*a)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","geographicToCartesianGrid","The specified elevations array is null, undefined or insufficient length"));if(!c)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","geographicToCartesianGrid","missingResult"));var d,p,f,g,m,E=i.equatorialRadius,y=o.minLatitude*t.DEGREES_TO_RADIANS,_=o.maxLatitude*t.DEGREES_TO_RADIANS,v=o.minLongitude*t.DEGREES_TO_RADIANS,b=o.maxLongitude*t.DEGREES_TO_RADIANS,S=(_-y)/(s>1?s-1:1),T=(b-v)/(a>1?a-1:1),L=h?h:new n(0,0,0),w=u?u[0]:0,x=0,R=0;for(d=0,f=y;d<s;d++,f+=S)for(d===s-1&&(f=_),m=E*f-L[1],p=0,g=v;p<a;p++,g+=T)p===a-1&&(g=b),c[R++]=E*g-L[0]+w,c[R++]=m,c[R++]=l[x++]-L[2];return c},o.prototype.cartesianToGeographic=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","cartesianToGeographic","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionEquirectangular","cartesianToGeographic","missingResult"));return l.latitude=o/i.equatorialRadius*t.RADIANS_TO_DEGREES,l.longitude=(n-(a?a[0]:0))/i.equatorialRadius*t.RADIANS_TO_DEGREES,l.altitude=s,l},o}),i("globe/ZeroElevationModel",["../error/ArgumentError","../globe/ElevationModel","../geom/Location","../util/Logger","../geom/Sector"],function(t,e,i,r,n){"use strict";var o=function(){e.call(this,n.FULL_SPHERE,new i(45,45),1," "," ",150,150),this.displayName="Zero Elevations",this.timestamp=Date.now(),this.minElevation=0,this.maxElevation=0};return o.prototype=Object.create(e.prototype),o.prototype.minAndMaxElevationsForSector=function(t){return[0,0]},o.prototype.elevationAtLocation=function(t,e){return 0},o.prototype.elevationsForGrid=function(e,i,n,o,s){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"ZeroElevationModel","elevationsForSector","missingSector"));if(i<=0||n<=0)throw new t(r.logMessage(r.LEVEL_SEVERE,"ZeroElevationModel","elevationsForSector","numLat or numLon is less than 1"));if(!s||s.length<i*n)throw new t(r.logMessage(r.LEVEL_SEVERE,"ZeroElevationModel","elevationsForSector","missingArray"));for(var a=0,l=s.length;a<l;a++)s[a]=0;return 0},o}),i("globe/Globe2D",["../globe/Globe","../projections/ProjectionEquirectangular","../globe/ZeroElevationModel"],function(t,e,i){"use strict";var r=function(){t.call(this,new i,new e)};return r.prototype=Object.create(t.prototype),r}),i("util/GoToAnimator",["../geom/Location","../util/Logger","../geom/Position","../geom/Vec3"],function(t,e,i,r){"use strict";var n=function(t){if(!t)throw new ArgumentError(e.logMessage(e.LEVEL_SEVERE,"GoToAnimator","constructor","missingWorldWindow"));this.wwd=t,this.animationFrequency=20,this.travelTime=3e3,this.cancelled=!1};return n.prototype.cancel=function(){this.cancelled=!0},n.prototype.goTo=function(n,o){if(!n)throw new ArgumentError(e.logMessage(e.LEVEL_SEVERE,"GoToAnimator","goTo","missingPosition"));this.completionCallback=o,this.cancelled=!1,this.targetPosition=new i(n.latitude,n.longitude,n.altitude||this.wwd.navigator.range),this.startPosition=new i(this.wwd.navigator.lookAtLocation.latitude,this.wwd.navigator.lookAtLocation.longitude,this.wwd.navigator.range),this.startTime=Date.now();var s,a=this.travelTime,l=t.greatCircleDistance(this.startPosition,this.targetPosition),h=this.wwd.globe.computePointFromLocation(this.startPosition.latitude,this.startPosition.longitude,new r(0,0,0)),u=this.wwd.globe.computePointFromLocation(this.targetPosition.latitude,this.targetPosition.longitude,new r(0,0,0));this.maxAltitude=h.distanceTo(u);var c=this.wwd.navigator.currentState().pixelSizeAtDistance(this.startPosition.altitude)*this.wwd.canvas.clientWidth/this.wwd.globe.equatorialRadius;l<=2*c&&(this.maxAltitude=this.startPosition.altitude),this.maxAltitudeReachedTime=this.maxAltitude<=this.wwd.navigator.range?Date.now():null,this.maxAltitude>this.startPosition.altitude?(s=Math.max(0,this.maxAltitude-this.startPosition.altitude),s+=Math.abs(this.targetPosition.altitude-this.maxAltitude)):s=Math.abs(this.targetPosition.altitude-this.startPosition.altitude);var d=Math.max(l,s/this.wwd.globe.equatorialRadius);if(0!==d){d<2*c&&(a=Math.min(d/c*this.travelTime,this.travelTime)),a=Math.max(1,a),this.panVelocity=l/a,this.rangeVelocity=s/a;var p=this,f=function(){
return p.cancelled?void(p.completionCallback&&p.completionCallback(p)):void(p.update()?setTimeout(f,p.animationFrequency):p.completionCallback&&p.completionCallback(p))};setTimeout(f,this.animationFrequency)}},n.prototype.update=function(){var t=new i(this.wwd.navigator.lookAtLocation.latitude,this.wwd.navigator.lookAtLocation.longitude,this.wwd.navigator.range),e=this.updateRange(t);return e=this.updateLocation(t)||e,this.wwd.redraw(),e},n.prototype.updateRange=function(t){var e,i,r=!1;return this.maxAltitudeReachedTime?(i=Date.now()-this.maxAltitudeReachedTime,this.maxAltitude>this.targetPosition.altitude?(e=this.maxAltitude-this.rangeVelocity*i,e=Math.max(e,this.targetPosition.altitude)):(e=this.maxAltitude+this.rangeVelocity*i,e=Math.min(e,this.targetPosition.altitude)),this.wwd.navigator.range=e,r=Math.abs(this.wwd.navigator.range-this.targetPosition.altitude)>1):(i=Date.now()-this.startTime,e=Math.min(this.startPosition.altitude+this.rangeVelocity*i,this.maxAltitude),Math.abs(this.wwd.navigator.range-e)<1&&(this.maxAltitudeReachedTime=Date.now()),this.wwd.navigator.range=e,r=!0),r},n.prototype.updateLocation=function(e){var i=Date.now()-this.startTime,r=t.greatCircleDistance(this.startPosition,e),n=t.greatCircleDistance(e,this.targetPosition),o=t.greatCircleAzimuth(e,this.targetPosition),s=this.panVelocity*i,a=Math.min(s-r,n),l=t.greatCircleLocation(e,o,a,new t(0,0)),h=!1;return this.wwd.navigator.lookAtLocation.latitude=l.latitude,this.wwd.navigator.lookAtLocation.longitude=l.longitude,a<1/this.wwd.globe.equatorialRadius&&(h=!0),!h},n}),i("util/HighlightController",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"HighlightController","constructor","missingWorldWindow"));this.worldWindow=i;var r=[],n=function(t){for(var e=t.clientX,n=t.clientY,o=r.length>0,s=0;s<r.length;s++)r[s].highlighted=!1;r=[];var a=i.pick(i.canvasCoordinates(e,n));if(a.objects.length>0&&(o=!0),a.objects.length>0)for(var l=0;l<a.objects.length;l++)a.objects[l].isTerrain||(a.objects[l].userObject.highlighted=!0,r.push(a.objects[l].userObject));o&&i.redraw()};this.worldWindow.addEventListener("mousemove",n);new WorldWind.TapRecognizer(this.worldWindow,n)};return i}),i("formats/kml/KmlElements",[],function(){"use strict";var t={keys:{},addKey:function(t,e){this.keys[t]=e},getKey:function(t){return this.keys[t]}};return t}),i("formats/kml/util/Attribute",[],function(){"use strict";var t=function(t,e){this.node=t,this.name=e};return t.prototype.value=function(){return this.node.attributes&&this.node.attributes.getNamedItem(this.name)&&this.node.attributes.getNamedItem(this.name).value||null},t.prototype.exists=function(){return null!=this.value()},t.prototype.save=function(t){this.node.setAttribute(this.name,t)},t}),i("formats/kml/util/NodeTransformers",["./Attribute","../KmlElements","../../../geom/Position","../../../util/WWUtil"],function(t,e,i,r){function n(t){var e;return null!=t&&t.childNodes[0]?e=t.childNodes[0].nodeValue:null!=t&&(e=""),e}var o=function(){};return o.string=function(t){return String(n(t))},o.number=function(t){return Number(n(t))},o.boolean=function(t){return r.transformToBoolean(n(t))},o.date=function(t){return r.date(n(t))},o.kmlObject=function(t,i,r){var n=t.nodeName,o=e.getKey(n);return o?new o({objectNode:t,parent:i,controls:r}):null},o.linearRing=function(t,i,r){var n=e.getKey("LinearRing");if(!n)return null;var o=null;return Array.prototype.forEach.call(t.childNodes,function(t){t.nodeName.toUpperCase()=="LinearRing".toUpperCase()&&(o=t)}),new n({objectNode:o,parent:i,controls:r})},o.positions=function(t){var e=[],r=n(t).trim().replace(/\s+/g," ").split(" ");return r.forEach(function(t){t=t.split(","),e.push(new i(Number(t[1]),Number(t[0]),Number(t[2]||0)))}),e},o.attribute=function(e){return function(i){return new t(i,e).value()}},o}),i("formats/kml/util/KmlElementsFactory",["./NodeTransformers"],function(t){"use strict";var e=function(t){this.options=t||{},this.options.controls=this.options.controls||[]};e.prototype.specific=function(t,e){var i=t.node,r=null,n=this;return[].forEach.call(i.childNodes,function(i){i.nodeName==e.name&&(r=e.transformer(i,t,n.options.controls))}),r},e.prototype.any=function(e,i){var r=e.node,n=null,o=this;return[].forEach.call(r.childNodes,function(r){i.name.indexOf(r.nodeName)!=-1&&(n=t.kmlObject(r,e,o.options.controls))}),n},e.prototype.all=function(e){var i=e.node,r=[],n=this;return[].forEach.call(i.childNodes,function(i){var o=t.kmlObject(i,e,n.options.controls);o&&r.push(o)}),r};var i=new e;return e.applicationWide=function(){return i},e}),i("formats/kml/util/TreeKeyValueCache",[],function(){"use strict";var t=function(t,e){if(String.prototype.startsWith)return t.startsWith(e);var i=0;return t.substr(i,e.length)===e},e=function(){this.map={}};e.prototype.add=function(t,e,i){this.map[t]||(this.map[t]={}),this.map[t][e]=i},e.prototype.value=function(e,i){if(!this.map[e])return null;if(i.indexOf("#")==-1){var r=this.level(e);for(var n in r)if(r.hasOwnProperty(n)&&t(n,i))return r[n]}return this.map[e][i]||null},e.prototype.level=function(t){return this.map[t]},e.prototype.remove=function(t,e){delete this.map[t][e]};var i=new e;return e.applicationLevelCache=function(){return i},e}),i("formats/kml/util/KmlElementsFactoryCached",["./Attribute","./KmlElementsFactory","./TreeKeyValueCache","../../../util/WWUtil"],function(t,e,i,r){"use strict";var n=function(t){this.internalFactory=new e(t),this.cache=i.applicationLevelCache()};n.prototype.all=function(t){var e=t.node,i=this.cache.level(this.cacheKey(t.node,"All"));if(i){var r=[];for(var n in i)i.hasOwnProperty(n)&&r.push(i[n]);return r}var o=this.internalFactory.all(t);if(o&&o.length){var s=this;o.forEach(function(t){s.cache.add(s.cacheKey(e,"All"),s.cacheKey(t.node),t)})}return o},n.prototype.specific=function(t,e){var i=t.node,r=e.name;e.attribute&&(r=e.attribute+r);var n=this.cache.value(this.cacheKey(i),r);if(n)return n;var o=this.internalFactory.specific(t,e);return o&&o.node?this.cache.add(this.cacheKey(i),this.cacheKey(o.node),o):o&&this.cache.add(this.cacheKey(i),r,o),o},n.prototype.any=function(t,e){var i,r=t.node,n=this,o=null;if(e.name.forEach(function(t){i=n.cache.value(n.cacheKey(r),t),i&&(o=i)}),o)return o;var s=this.internalFactory.any(t,e);return s&&this.cache.add(n.cacheKey(r),n.cacheKey(s.node),s),s},n.prototype.cacheKey=function(e,i){var n=new t(e,"id");n.exists()||n.save(r.guid());var o=e.nodeName+"#"+n.value();return i&&(o=i+o),o};var o=new n;return n.applicationWide=function(){return o},n}),function(){"use strict";function t(t){return"function"==typeof t||"object"==typeof t&&null!==t}function r(t){return"function"==typeof t}function n(t){return"object"==typeof t&&null!==t}function o(t){j=t}function s(t){H=t}function a(){return function(){process.nextTick(d)}}function l(){return function(){U(d)}}function h(){var t=0,e=new J(d),i=document.createTextNode("");return e.observe(i,{characterData:!0}),function(){i.data=t=++t%2}}function u(){var t=new MessageChannel;return t.port1.onmessage=d,function(){t.port2.postMessage(0)}}function c(){return function(){setTimeout(d,1)}}function d(){for(var t=0;t<q;t+=2){var e=$[t],i=$[t+1];e(i),$[t]=void 0,$[t+1]=void 0}q=0}function p(){try{var t=e,i=t("vertx");return U=i.runOnLoop||i.runOnContext,l()}catch(t){return c()}}function f(){}function g(){return new TypeError("You cannot resolve a promise with itself")}function m(){return new TypeError("A promises callback cannot return that same promise.")}function E(t){try{return t.then}catch(t){return rt.error=t,rt}}function y(t,e,i,r){try{t.call(e,i,r)}catch(t){return t}}function _(t,e,i){H(function(t){var r=!1,n=y(i,e,function(i){r||(r=!0,e!==i?S(t,i):L(t,i))},function(e){r||(r=!0,w(t,e))},"Settle: "+(t._label||" unknown promise"));!r&&n&&(r=!0,w(t,n))},t)}function v(t,e){e._state===et?L(t,e._result):e._state===it?w(t,e._result):x(e,void 0,function(e){S(t,e)},function(e){w(t,e)})}function b(t,e){if(e.constructor===t.constructor)v(t,e);else{var i=E(e);i===rt?w(t,rt.error):void 0===i?L(t,e):r(i)?_(t,e,i):L(t,e)}}function S(e,i){e===i?w(e,g()):t(i)?b(e,i):L(e,i)}function T(t){t._onerror&&t._onerror(t._result),R(t)}function L(t,e){t._state===tt&&(t._result=e,t._state=et,0!==t._subscribers.length&&H(R,t))}function w(t,e){t._state===tt&&(t._state=it,t._result=e,H(T,t))}function x(t,e,i,r){var n=t._subscribers,o=n.length;t._onerror=null,n[o]=e,n[o+et]=i,n[o+it]=r,0===o&&t._state&&H(R,t)}function R(t){var e=t._subscribers,i=t._state;if(0!==e.length){for(var r,n,o=t._result,s=0;s<e.length;s+=3)r=e[s],n=e[s+i],r?A(i,r,n,o):n(o);t._subscribers.length=0}}function M(){this.error=null}function C(t,e){try{return t(e)}catch(t){return nt.error=t,nt}}function A(t,e,i,n){var o,s,a,l,h=r(i);if(h){if(o=C(i,n),o===nt?(l=!0,s=o.error,o=null):a=!0,e===o)return void w(e,m())}else o=n,a=!0;e._state!==tt||(h&&a?S(e,o):l?w(e,s):t===et?L(e,o):t===it&&w(e,o))}function P(t,e){try{e(function(e){S(t,e)},function(e){w(t,e)})}catch(e){w(t,e)}}function O(t,e){var i=this;i._instanceConstructor=t,i.promise=new t(f),i._validateInput(e)?(i._input=e,i.length=e.length,i._remaining=e.length,i._init(),0===i.length?L(i.promise,i._result):(i.length=i.length||0,i._enumerate(),0===i._remaining&&L(i.promise,i._result))):w(i.promise,i._validationError())}function I(t){return new ot(this,t).promise}function N(t){function e(t){S(n,t)}function i(t){w(n,t)}var r=this,n=new r(f);if(!z(t))return w(n,new TypeError("You must pass an array to race.")),n;for(var o=t.length,s=0;n._state===tt&&s<o;s++)x(r.resolve(t[s]),void 0,e,i);return n}function D(t){var e=this;if(t&&"object"==typeof t&&t.constructor===e)return t;var i=new e(f);return S(i,t),i}function V(t){var e=this,i=new e(f);return w(i,t),i}function k(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}function F(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}function G(t){this._id=ut++,this._state=void 0,this._result=void 0,this._subscribers=[],f!==t&&(r(t)||k(),this instanceof G||F(),P(this,t))}function W(){var t;if("undefined"!=typeof ft)t=ft;else if("undefined"!=typeof self)t=self;else try{t=Function("return this")()}catch(t){throw new Error("polyfill failed because global object is unavailable in this environment")}var e=t.Promise;e&&"[object Promise]"===Object.prototype.toString.call(e.resolve())&&!e.cast||(t.Promise=ct)}var B;B=Array.isArray?Array.isArray:function(t){return"[object Array]"===Object.prototype.toString.call(t)};var U,j,K,z=B,q=0,H=({}.toString,function(t,e){$[q]=t,$[q+1]=e,q+=2,2===q&&(j?j(d):K())}),Y="undefined"!=typeof window?window:void 0,X=Y||{},J=X.MutationObserver||X.WebKitMutationObserver,Z="undefined"!=typeof process&&"[object process]"==={}.toString.call(process),Q="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel,$=new Array(1e3);K=Z?a():J?h():Q?u():void 0===Y&&"function"==typeof e?p():c();var tt=void 0,et=1,it=2,rt=new M,nt=new M;O.prototype._validateInput=function(t){return z(t)},O.prototype._validationError=function(){return new Error("Array Methods must be provided an Array")},O.prototype._init=function(){this._result=new Array(this.length)};var ot=O;O.prototype._enumerate=function(){for(var t=this,e=t.length,i=t.promise,r=t._input,n=0;i._state===tt&&n<e;n++)t._eachEntry(r[n],n)},O.prototype._eachEntry=function(t,e){var i=this,r=i._instanceConstructor;n(t)?t.constructor===r&&t._state!==tt?(t._onerror=null,i._settledAt(t._state,e,t._result)):i._willSettleAt(r.resolve(t),e):(i._remaining--,i._result[e]=t)},O.prototype._settledAt=function(t,e,i){var r=this,n=r.promise;n._state===tt&&(r._remaining--,t===it?w(n,i):r._result[e]=i),0===r._remaining&&L(n,r._result)},O.prototype._willSettleAt=function(t,e){var i=this;x(t,void 0,function(t){i._settledAt(et,e,t)},function(t){i._settledAt(it,e,t)})};var st=I,at=N,lt=D,ht=V,ut=0,ct=G;G.all=st,G.race=at,G.resolve=lt,G.reject=ht,G._setScheduler=o,G._setAsap=s,G._asap=H,G.prototype={constructor:G,then:function(t,e){var i=this,r=i._state;if(r===et&&!t||r===it&&!e)return this;var n=new this.constructor(f),o=i._result;if(r){var s=arguments[r-1];H(function(){A(r,n,s,o)})}else x(i,n,t,e);return n},catch:function(t){return this.then(null,t)}};var dt=W,pt={Promise:ct,polyfill:dt};"function"==typeof i&&i.amd?i("util/es6-promise",[],function(){return pt}):"undefined"!=typeof module&&module.exports?module.exports=pt:"undefined"!=typeof this&&(this.ES6Promise=pt);var ft={};dt()}.call(this),i("util/Promise",["./es6-promise"],function(t){"use strict";return window.Promise?window.Promise:t.Promise}),i("formats/kml/KmlObject",["../../error/ArgumentError","./util/Attribute","./KmlElements","./util/KmlElementsFactoryCached","../../util/Logger","../../util/Promise","../../render/Renderable"],function(t,e,i,r,n,o,s){"use strict";var a=function(e){if(s.call(this),e=e||{},!e.objectNode)throw new t(n.logMessage(n.LEVEL_SEVERE,"KmlObject","constructor","Passed node isn't defined."));this._node=e.objectNode,this._cache={},this._controls=e.controls||[],this._factory=new r({controls:this._controls}),this.hook(this._controls,e)};return a.prototype=Object.create(s.prototype),Object.defineProperties(a.prototype,{id:{get:function(){return new e(this.node,"id").value()}},node:{get:function(){return this._node}}}),a.prototype.hook=function(t,e){var i=this;t.forEach(function(t){t.hook(i,e)})},a.prototype.render=function(t){},a.prototype.getTagNames=function(){return[]},a}),i("formats/kml/util/ImagePyramid",["../KmlElements","../KmlObject","../util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlTileSize:{get:function(){return this._factory.specific(this,{name:"tileSize",transformer:i.number})}},kmlMaxWidth:{get:function(){return this._factory.specific(this,{name:"maxWidth",transformer:i.number})}},kmlMaxHeight:{get:function(){return this._factory.specific(this,{name:"maxHeight",transformer:i.number})}},kmlGridOrigin:{get:function(){return this._factory.specific(this,{name:"gridOrigin",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["ImagePyramid"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/util/ItemIcon",["./../KmlElements","../KmlObject","./NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlState:{get:function(){return this._factory.specific(this,{name:"state",transformer:i.string})}},kmlHref:{get:function(){return this._factory.specific(this,{name:"href",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["ItemIcon"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlTimePrimitive",["./KmlObject"],function(t){"use strict";var e=function(e){t.call(this,e)};return e.prototype=Object.create(t.prototype),e.prototype.timeRange=function(){var t,e;return this.kmlBegin&&(e=t=this.kmlBegin.valueOf()),this.kmlEnd&&(e=this.kmlEnd.valueOf(),t||(t=e)),this.kmlWhen&&(e=t=this.kmlWhen.valueOf()),{from:t,to:e}},e.prototype.getTagNames=function(){return["TimeSpan","TimeStamp"]},e}),i("formats/kml/KmlAbstractView",["./KmlObject","./KmlElements","./KmlTimePrimitive"],function(t,e,i){"use strict";var r=function(e){t.call(this,e)};return r.prototype=Object.create(t.prototype),Object.defineProperties(r.prototype,{kmlTimePrimitive:{get:function(){return this._factory.any(this,{name:i.prototype.getTagNames()})}}}),r.prototype.getTagNames=function(){return["Camera","LookAt"]},r}),i("formats/kml/styles/KmlSubStyle",["./../KmlObject"],function(t){"use strict";var e=function(e){t.call(this,e)};return e.prototype=Object.create(t.prototype),e.prototype.getTagNames=function(){return["LineStyle","PolyStyle","IconStyle","LabelStyle","BalloonStyle","ListStyle"]},e}),i("formats/kml/styles/KmlBalloonStyle",["../KmlElements","./KmlSubStyle","../util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlBgColor:{get:function(){return this._factory.specific(this,{name:"bgColor",transformer:i.string})}},kmlTextColor:{get:function(){return this._factory.specific(this,{name:"textColor",transformer:i.string})}},kmlText:{get:function(){return this._factory.specific(this,{name:"text",transformer:i.string})}},kmlDisplayMode:{get:function(){return this._factory.specific(this,{name:"displayMode",transformer:i.string})}}}),r.update=function(){},r.prototype.getTagNames=function(){return["BalloonStyle"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlCamera",["./KmlElements","./KmlAbstractView","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlLongitude:{get:function(){return this._factory.specific(this,{name:"longitude",transformer:i.string})}},kmlLatitude:{get:function(){return this._factory.specific(this,{name:"latitude",transformer:i.string})}},kmlAltitude:{get:function(){return this._factory.specific(this,{name:"altitude",transformer:i.string})}},kmlHeading:{get:function(){return this._factory.specific(this,{name:"heading",transformer:i.string})}},kmlTilt:{get:function(){return this._factory.specific(this,{name:"tilt",transformer:i.string})}},kmlRoll:{get:function(){return this._factory.specific(this,{name:"roll",transformer:i.string})}},kmlAltitudeMode:{get:function(){return this._factory.specific(this,{name:"altitudeMode",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["Camera"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/styles/KmlColorStyle",["./KmlSubStyle","../util/NodeTransformers"],function(t,e){"use strict";var i=function(e){t.call(this,e)};return i.prototype=Object.create(t.prototype),Object.defineProperties(i.prototype,{kmlColor:{get:function(){return this._factory.specific(this,{name:"color",transformer:e.string})}},kmlColorMode:{get:function(){return this._factory.specific(this,{name:"colorMode",transformer:e.string})}}}),i.prototype.getTagNames=function(){return["LineStyle","PolyStyle","IconStyle","LabelStyle"]},i}),!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof i&&i.amd)i("util/jszip",[],t);else{var e;"undefined"!=typeof window?e=window:"undefined"!=typeof global?e=global:"undefined"!=typeof self&&(e=self),e.JSZip=t()}}(function(){return function t(i,r,n){function o(a,l){if(!r[a]){if(!i[a]){var h="function"==typeof e&&e;if(!l&&h)return h(a,!0);if(s)return s(a,!0);throw new Error("Cannot find module '"+a+"'")}var u=r[a]={exports:{}};i[a][0].call(u.exports,function(t){var e=i[a][1][t];return o(e?e:t)},u,u.exports,t,i,r,n)}return r[a].exports}for(var s="function"==typeof e&&e,a=0;a<n.length;a++)o(n[a]);return o}({1:[function(t,e,i){"use strict";var r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";i.encode=function(t,e){for(var i,n,o,s,a,l,h,u="",c=0;c<t.length;)i=t.charCodeAt(c++),n=t.charCodeAt(c++),o=t.charCodeAt(c++),s=i>>2,a=(3&i)<<4|n>>4,l=(15&n)<<2|o>>6,h=63&o,isNaN(n)?l=h=64:isNaN(o)&&(h=64),u=u+r.charAt(s)+r.charAt(a)+r.charAt(l)+r.charAt(h);return u},i.decode=function(t,e){var i,n,o,s,a,l,h,u="",c=0;for(t=t.replace(/[^A-Za-z0-9\+\/\=]/g,"");c<t.length;)s=r.indexOf(t.charAt(c++)),a=r.indexOf(t.charAt(c++)),l=r.indexOf(t.charAt(c++)),h=r.indexOf(t.charAt(c++)),i=s<<2|a>>4,n=(15&a)<<4|l>>2,o=(3&l)<<6|h,u+=String.fromCharCode(i),64!=l&&(u+=String.fromCharCode(n)),64!=h&&(u+=String.fromCharCode(o));return u}},{}],2:[function(t,e,i){"use strict";function r(){this.compressedSize=0,this.uncompressedSize=0,this.crc32=0,this.compressionMethod=null,this.compressedContent=null}r.prototype={getContent:function(){return null},getCompressedContent:function(){return null}},e.exports=r},{}],3:[function(t,e,i){"use strict";i.STORE={magic:"\0\0",compress:function(t,e){return t},uncompress:function(t){return t},compressInputType:null,uncompressInputType:null},i.DEFLATE=t("./flate")},{"./flate":8}],4:[function(t,e,i){"use strict";var r=t("./utils"),n=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918e3,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117];e.exports=function(t,e){if("undefined"==typeof t||!t.length)return 0;var i="string"!==r.getTypeOf(t);"undefined"==typeof e&&(e=0);var o=0,s=0,a=0;e^=-1;for(var l=0,h=t.length;l<h;l++)a=i?t[l]:t.charCodeAt(l),s=255&(e^a),o=n[s],e=e>>>8^o;return e^-1}},{"./utils":21}],5:[function(t,e,i){"use strict";function r(t){this.data=null,this.length=0,this.index=0}var n=t("./utils");r.prototype={checkOffset:function(t){this.checkIndex(this.index+t)},checkIndex:function(t){if(this.length<t||t<0)throw new Error("End of data reached (data length = "+this.length+", asked index = "+t+"). Corrupted zip ?")},setIndex:function(t){this.checkIndex(t),this.index=t},skip:function(t){this.setIndex(this.index+t)},byteAt:function(t){},readInt:function(t){var e,i=0;for(this.checkOffset(t),e=this.index+t-1;e>=this.index;e--)i=(i<<8)+this.byteAt(e);return this.index+=t,i},readString:function(t){return n.transformTo("string",this.readData(t))},readData:function(t){},lastIndexOfSignature:function(t){},readDate:function(){var t=this.readInt(4);return new Date((t>>25&127)+1980,(t>>21&15)-1,t>>16&31,t>>11&31,t>>5&63,(31&t)<<1)}},e.exports=r},{"./utils":21}],6:[function(t,e,i){"use strict";i.base64=!1,i.binary=!1,i.dir=!1,i.createFolders=!1,i.date=null,i.compression=null,i.compressionOptions=null,i.comment=null,i.unixPermissions=null,i.dosPermissions=null},{}],7:[function(t,e,i){"use strict";var r=t("./utils");i.string2binary=function(t){return r.string2binary(t)},i.string2Uint8Array=function(t){return r.transformTo("uint8array",t)},i.uint8Array2String=function(t){return r.transformTo("string",t)},i.string2Blob=function(t){var e=r.transformTo("arraybuffer",t);return r.arrayBuffer2Blob(e)},i.arrayBuffer2Blob=function(t){return r.arrayBuffer2Blob(t)},i.transformTo=function(t,e){return r.transformTo(t,e)},i.getTypeOf=function(t){return r.getTypeOf(t)},i.checkSupport=function(t){return r.checkSupport(t)},i.MAX_VALUE_16BITS=r.MAX_VALUE_16BITS,i.MAX_VALUE_32BITS=r.MAX_VALUE_32BITS,i.pretty=function(t){return r.pretty(t)},i.findCompression=function(t){return r.findCompression(t)},i.isRegExp=function(t){return r.isRegExp(t)}},{"./utils":21}],8:[function(t,e,i){"use strict";var r="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Uint32Array,n=t("pako");i.uncompressInputType=r?"uint8array":"array",i.compressInputType=r?"uint8array":"array",i.magic="\b\0",i.compress=function(t,e){return n.deflateRaw(t,{level:e.level||-1})},i.uncompress=function(t){return n.inflateRaw(t)}},{pako:24}],9:[function(t,e,i){"use strict";function r(t,e){return this instanceof r?(this.files={},this.comment=null,this.root="",t&&this.load(t,e),void(this.clone=function(){var t=new r;for(var e in this)"function"!=typeof this[e]&&(t[e]=this[e]);return t})):new r(t,e)}var n=t("./base64");r.prototype=t("./object"),r.prototype.load=t("./load"),r.support=t("./support"),r.defaults=t("./defaults"),r.utils=t("./deprecatedPublicUtils"),r.base64={encode:function(t){return n.encode(t)},decode:function(t){return n.decode(t)}},r.compressions=t("./compressions"),e.exports=r},{"./base64":1,"./compressions":3,"./defaults":6,"./deprecatedPublicUtils":7,"./load":10,"./object":13,"./support":17}],10:[function(t,e,i){"use strict";var r=t("./base64"),n=t("./zipEntries");e.exports=function(t,e){var i,o,s,a;for(e=e||{},e.base64&&(t=r.decode(t)),o=new n(t,e),i=o.files,s=0;s<i.length;s++)a=i[s],this.file(a.fileName,a.decompressed,{binary:!0,optimizedBinaryString:!0,date:a.date,dir:a.dir,comment:a.fileComment.length?a.fileComment:null,unixPermissions:a.unixPermissions,dosPermissions:a.dosPermissions,createFolders:e.createFolders});return o.zipComment.length&&(this.comment=o.zipComment),this}},{"./base64":1,"./zipEntries":22}],11:[function(t,e,i){(function(t){"use strict";e.exports=function(e,i){return new t(e,i)},e.exports.test=function(e){return t.isBuffer(e)}}).call(this,"undefined"!=typeof Buffer?Buffer:void 0)},{}],12:[function(t,e,i){"use strict";function r(t){this.data=t,this.length=this.data.length,this.index=0}var n=t("./uint8ArrayReader");r.prototype=new n,r.prototype.readData=function(t){this.checkOffset(t);var e=this.data.slice(this.index,this.index+t);return this.index+=t,e},e.exports=r},{"./uint8ArrayReader":18}],13:[function(t,e,i){"use strict";var r=t("./support"),n=t("./utils"),o=t("./crc32"),s=t("./signature"),a=t("./defaults"),l=t("./base64"),h=t("./compressions"),u=t("./compressedObject"),c=t("./nodeBuffer"),d=t("./utf8"),p=t("./stringWriter"),f=t("./uint8ArrayWriter"),g=function(t){if(t._data instanceof u&&(t._data=t._data.getContent(),t.options.binary=!0,t.options.base64=!1,"uint8array"===n.getTypeOf(t._data))){var e=t._data;t._data=new Uint8Array(e.length),0!==e.length&&t._data.set(e,0)}return t._data},m=function(t){var e=g(t),i=n.getTypeOf(e);return"string"===i?!t.options.binary&&r.nodebuffer?c(e,"utf-8"):t.asBinary():e},E=function(t){var e=g(this);return null===e||"undefined"==typeof e?"":(this.options.base64&&(e=l.decode(e)),e=t&&this.options.binary?A.utf8decode(e):n.transformTo("string",e),t||this.options.binary||(e=n.transformTo("string",A.utf8encode(e))),e)},y=function(t,e,i){this.name=t,this.dir=i.dir,this.date=i.date,this.comment=i.comment,this.unixPermissions=i.unixPermissions,this.dosPermissions=i.dosPermissions,this._data=e,this.options=i,this._initialMetadata={dir:i.dir,date:i.date}};y.prototype={asText:function(){return E.call(this,!0)},asBinary:function(){return E.call(this,!1)},asNodeBuffer:function(){var t=m(this);return n.transformTo("nodebuffer",t)},asUint8Array:function(){var t=m(this);return n.transformTo("uint8array",t)},asArrayBuffer:function(){return this.asUint8Array().buffer}};var _=function(t,e){var i,r="";for(i=0;i<e;i++)r+=String.fromCharCode(255&t),t>>>=8;return r},v=function(){var t,e,i={};for(t=0;t<arguments.length;t++)for(e in arguments[t])arguments[t].hasOwnProperty(e)&&"undefined"==typeof i[e]&&(i[e]=arguments[t][e]);return i},b=function(t){return t=t||{},t.base64!==!0||null!==t.binary&&void 0!==t.binary||(t.binary=!0),t=v(t,a),t.date=t.date||new Date,null!==t.compression&&(t.compression=t.compression.toUpperCase()),t},S=function(t,e,i){var r,o=n.getTypeOf(e);if(i=b(i),"string"==typeof i.unixPermissions&&(i.unixPermissions=parseInt(i.unixPermissions,8)),i.unixPermissions&&16384&i.unixPermissions&&(i.dir=!0),i.dosPermissions&&16&i.dosPermissions&&(i.dir=!0),i.dir&&(t=L(t)),i.createFolders&&(r=T(t))&&w.call(this,r,!0),i.dir||null===e||"undefined"==typeof e)i.base64=!1,i.binary=!1,e=null,o=null;else if("string"===o)i.binary&&!i.base64&&i.optimizedBinaryString!==!0&&(e=n.string2binary(e));else{if(i.base64=!1,i.binary=!0,!(o||e instanceof u))throw new Error("The data of '"+t+"' is in an unsupported format !");"arraybuffer"===o&&(e=n.transformTo("uint8array",e))}var s=new y(t,e,i);return this.files[t]=s,s},T=function(t){"/"==t.slice(-1)&&(t=t.substring(0,t.length-1));var e=t.lastIndexOf("/");return e>0?t.substring(0,e):""},L=function(t){return"/"!=t.slice(-1)&&(t+="/"),t},w=function(t,e){return e="undefined"!=typeof e&&e,t=L(t),this.files[t]||S.call(this,t,null,{dir:!0,createFolders:e}),this.files[t]},x=function(t,e,i){var r,s=new u;return t._data instanceof u?(s.uncompressedSize=t._data.uncompressedSize,s.crc32=t._data.crc32,0===s.uncompressedSize||t.dir?(e=h.STORE,s.compressedContent="",s.crc32=0):t._data.compressionMethod===e.magic?s.compressedContent=t._data.getCompressedContent():(r=t._data.getContent(),s.compressedContent=e.compress(n.transformTo(e.compressInputType,r),i))):(r=m(t),r&&0!==r.length&&!t.dir||(e=h.STORE,r=""),s.uncompressedSize=r.length,s.crc32=o(r),s.compressedContent=e.compress(n.transformTo(e.compressInputType,r),i)),s.compressedSize=s.compressedContent.length,s.compressionMethod=e.magic,s},R=function(t,e){var i=t;return t||(i=e?16893:33204),(65535&i)<<16},M=function(t,e){return 63&(t||0)},C=function(t,e,i,r,a){var l,h,u,c,p=(i.compressedContent,n.transformTo("string",d.utf8encode(e.name))),f=e.comment||"",g=n.transformTo("string",d.utf8encode(f)),m=p.length!==e.name.length,E=g.length!==f.length,y=e.options,v="",b="",S="";u=e._initialMetadata.dir!==e.dir?e.dir:y.dir,c=e._initialMetadata.date!==e.date?e.date:y.date;var T=0,L=0;u&&(T|=16),"UNIX"===a?(L=798,T|=R(e.unixPermissions,u)):(L=20,T|=M(e.dosPermissions,u)),l=c.getHours(),l<<=6,l|=c.getMinutes(),l<<=5,l|=c.getSeconds()/2,h=c.getFullYear()-1980,h<<=4,h|=c.getMonth()+1,h<<=5,h|=c.getDate(),m&&(b=_(1,1)+_(o(p),4)+p,v+="up"+_(b.length,2)+b),E&&(S=_(1,1)+_(this.crc32(g),4)+g,v+="uc"+_(S.length,2)+S);var w="";w+="\n\0",w+=m||E?"\0\b":"\0\0",w+=i.compressionMethod,w+=_(l,2),w+=_(h,2),w+=_(i.crc32,4),w+=_(i.compressedSize,4),w+=_(i.uncompressedSize,4),w+=_(p.length,2),w+=_(v.length,2);var x=s.LOCAL_FILE_HEADER+w+p+v,C=s.CENTRAL_FILE_HEADER+_(L,2)+w+_(g.length,2)+"\0\0\0\0"+_(T,4)+_(r,4)+p+v+g;return{fileRecord:x,dirRecord:C,compressedObject:i}},A={load:function(t,e){
throw new Error("Load method is not defined. Is the file jszip-load.js included ?")},filter:function(t){var e,i,r,n,o=[];for(e in this.files)this.files.hasOwnProperty(e)&&(r=this.files[e],n=new y(r.name,r._data,v(r.options)),i=e.slice(this.root.length,e.length),e.slice(0,this.root.length)===this.root&&t(i,n)&&o.push(n));return o},file:function(t,e,i){if(1===arguments.length){if(n.isRegExp(t)){var r=t;return this.filter(function(t,e){return!e.dir&&r.test(t)})}return this.filter(function(e,i){return!i.dir&&e===t})[0]||null}return t=this.root+t,S.call(this,t,e,i),this},folder:function(t){if(!t)return this;if(n.isRegExp(t))return this.filter(function(e,i){return i.dir&&t.test(e)});var e=this.root+t,i=w.call(this,e),r=this.clone();return r.root=i.name,r},remove:function(t){t=this.root+t;var e=this.files[t];if(e||("/"!=t.slice(-1)&&(t+="/"),e=this.files[t]),e&&!e.dir)delete this.files[t];else for(var i=this.filter(function(e,i){return i.name.slice(0,t.length)===t}),r=0;r<i.length;r++)delete this.files[i[r].name];return this},generate:function(t){t=v(t||{},{base64:!0,compression:"STORE",compressionOptions:null,type:"base64",platform:"DOS",comment:null,mimeType:"application/zip"}),n.checkSupport(t.type),"darwin"!==t.platform&&"freebsd"!==t.platform&&"linux"!==t.platform&&"sunos"!==t.platform||(t.platform="UNIX"),"win32"===t.platform&&(t.platform="DOS");var e,i,r=[],o=0,a=0,u=n.transformTo("string",this.utf8encode(t.comment||this.comment||""));for(var c in this.files)if(this.files.hasOwnProperty(c)){var d=this.files[c],g=d.options.compression||t.compression.toUpperCase(),m=h[g];if(!m)throw new Error(g+" is not a valid compression method !");var E=d.options.compressionOptions||t.compressionOptions||{},y=x.call(this,d,m,E),b=C.call(this,c,d,y,o,t.platform);o+=b.fileRecord.length+y.compressedSize,a+=b.dirRecord.length,r.push(b)}var S="";S=s.CENTRAL_DIRECTORY_END+"\0\0\0\0"+_(r.length,2)+_(r.length,2)+_(a,4)+_(o,4)+_(u.length,2)+u;var T=t.type.toLowerCase();for(e="uint8array"===T||"arraybuffer"===T||"blob"===T||"nodebuffer"===T?new f(o+a+S.length):new p(o+a+S.length),i=0;i<r.length;i++)e.append(r[i].fileRecord),e.append(r[i].compressedObject.compressedContent);for(i=0;i<r.length;i++)e.append(r[i].dirRecord);e.append(S);var L=e.finalize();switch(t.type.toLowerCase()){case"uint8array":case"arraybuffer":case"nodebuffer":return n.transformTo(t.type.toLowerCase(),L);case"blob":return n.arrayBuffer2Blob(n.transformTo("arraybuffer",L),t.mimeType);case"base64":return t.base64?l.encode(L):L;default:return L}},crc32:function(t,e){return o(t,e)},utf8encode:function(t){return n.transformTo("string",d.utf8encode(t))},utf8decode:function(t){return d.utf8decode(t)}};e.exports=A},{"./base64":1,"./compressedObject":2,"./compressions":3,"./crc32":4,"./defaults":6,"./nodeBuffer":11,"./signature":14,"./stringWriter":16,"./support":17,"./uint8ArrayWriter":19,"./utf8":20,"./utils":21}],14:[function(t,e,i){"use strict";i.LOCAL_FILE_HEADER="PK",i.CENTRAL_FILE_HEADER="PK",i.CENTRAL_DIRECTORY_END="PK",i.ZIP64_CENTRAL_DIRECTORY_LOCATOR="PK",i.ZIP64_CENTRAL_DIRECTORY_END="PK",i.DATA_DESCRIPTOR="PK\b"},{}],15:[function(t,e,i){"use strict";function r(t,e){this.data=t,e||(this.data=o.string2binary(this.data)),this.length=this.data.length,this.index=0}var n=t("./dataReader"),o=t("./utils");r.prototype=new n,r.prototype.byteAt=function(t){return this.data.charCodeAt(t)},r.prototype.lastIndexOfSignature=function(t){return this.data.lastIndexOf(t)},r.prototype.readData=function(t){this.checkOffset(t);var e=this.data.slice(this.index,this.index+t);return this.index+=t,e},e.exports=r},{"./dataReader":5,"./utils":21}],16:[function(t,e,i){"use strict";var r=t("./utils"),n=function(){this.data=[]};n.prototype={append:function(t){t=r.transformTo("string",t),this.data.push(t)},finalize:function(){return this.data.join("")}},e.exports=n},{"./utils":21}],17:[function(t,e,i){(function(t){"use strict";if(i.base64=!0,i.array=!0,i.string=!0,i.arraybuffer="undefined"!=typeof ArrayBuffer&&"undefined"!=typeof Uint8Array,i.nodebuffer="undefined"!=typeof t,i.uint8array="undefined"!=typeof Uint8Array,"undefined"==typeof ArrayBuffer)i.blob=!1;else{var e=new ArrayBuffer(0);try{i.blob=0===new Blob([e],{type:"application/zip"}).size}catch(t){try{var r=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder,n=new r;n.append(e),i.blob=0===n.getBlob("application/zip").size}catch(t){i.blob=!1}}}}).call(this,"undefined"!=typeof Buffer?Buffer:void 0)},{}],18:[function(t,e,i){"use strict";function r(t){t&&(this.data=t,this.length=this.data.length,this.index=0)}var n=t("./dataReader");r.prototype=new n,r.prototype.byteAt=function(t){return this.data[t]},r.prototype.lastIndexOfSignature=function(t){for(var e=t.charCodeAt(0),i=t.charCodeAt(1),r=t.charCodeAt(2),n=t.charCodeAt(3),o=this.length-4;o>=0;--o)if(this.data[o]===e&&this.data[o+1]===i&&this.data[o+2]===r&&this.data[o+3]===n)return o;return-1},r.prototype.readData=function(t){if(this.checkOffset(t),0===t)return new Uint8Array(0);var e=this.data.subarray(this.index,this.index+t);return this.index+=t,e},e.exports=r},{"./dataReader":5}],19:[function(t,e,i){"use strict";var r=t("./utils"),n=function(t){this.data=new Uint8Array(t),this.index=0};n.prototype={append:function(t){0!==t.length&&(t=r.transformTo("uint8array",t),this.data.set(t,this.index),this.index+=t.length)},finalize:function(){return this.data}},e.exports=n},{"./utils":21}],20:[function(t,e,i){"use strict";for(var r=t("./utils"),n=t("./support"),o=t("./nodeBuffer"),s=new Array(256),a=0;a<256;a++)s[a]=a>=252?6:a>=248?5:a>=240?4:a>=224?3:a>=192?2:1;s[254]=s[254]=1;var l=function(t){var e,i,r,o,s,a=t.length,l=0;for(o=0;o<a;o++)i=t.charCodeAt(o),55296===(64512&i)&&o+1<a&&(r=t.charCodeAt(o+1),56320===(64512&r)&&(i=65536+(i-55296<<10)+(r-56320),o++)),l+=i<128?1:i<2048?2:i<65536?3:4;for(e=n.uint8array?new Uint8Array(l):new Array(l),s=0,o=0;s<l;o++)i=t.charCodeAt(o),55296===(64512&i)&&o+1<a&&(r=t.charCodeAt(o+1),56320===(64512&r)&&(i=65536+(i-55296<<10)+(r-56320),o++)),i<128?e[s++]=i:i<2048?(e[s++]=192|i>>>6,e[s++]=128|63&i):i<65536?(e[s++]=224|i>>>12,e[s++]=128|i>>>6&63,e[s++]=128|63&i):(e[s++]=240|i>>>18,e[s++]=128|i>>>12&63,e[s++]=128|i>>>6&63,e[s++]=128|63&i);return e},h=function(t,e){var i;for(e=e||t.length,e>t.length&&(e=t.length),i=e-1;i>=0&&128===(192&t[i]);)i--;return i<0?e:0===i?e:i+s[t[i]]>e?i:e},u=function(t){var e,i,n,o,a=t.length,l=new Array(2*a);for(i=0,e=0;e<a;)if(n=t[e++],n<128)l[i++]=n;else if(o=s[n],o>4)l[i++]=65533,e+=o-1;else{for(n&=2===o?31:3===o?15:7;o>1&&e<a;)n=n<<6|63&t[e++],o--;o>1?l[i++]=65533:n<65536?l[i++]=n:(n-=65536,l[i++]=55296|n>>10&1023,l[i++]=56320|1023&n)}return l.length!==i&&(l.subarray?l=l.subarray(0,i):l.length=i),r.applyFromCharCode(l)};i.utf8encode=function(t){return n.nodebuffer?o(t,"utf-8"):l(t)},i.utf8decode=function(t){if(n.nodebuffer)return r.transformTo("nodebuffer",t).toString("utf-8");t=r.transformTo(n.uint8array?"uint8array":"array",t);for(var e=[],i=0,o=t.length,s=65536;i<o;){var a=h(t,Math.min(i+s,o));n.uint8array?e.push(u(t.subarray(i,a))):e.push(u(t.slice(i,a))),i=a}return e.join("")}},{"./nodeBuffer":11,"./support":17,"./utils":21}],21:[function(t,e,i){"use strict";function r(t){return t}function n(t,e){for(var i=0;i<t.length;++i)e[i]=255&t.charCodeAt(i);return e}function o(t){var e=65536,r=[],n=t.length,o=i.getTypeOf(t),s=0,a=!0;try{switch(o){case"uint8array":String.fromCharCode.apply(null,new Uint8Array(0));break;case"nodebuffer":String.fromCharCode.apply(null,h(0))}}catch(t){a=!1}if(!a){for(var l="",u=0;u<t.length;u++)l+=String.fromCharCode(t[u]);return l}for(;s<n&&e>1;)try{"array"===o||"nodebuffer"===o?r.push(String.fromCharCode.apply(null,t.slice(s,Math.min(s+e,n)))):r.push(String.fromCharCode.apply(null,t.subarray(s,Math.min(s+e,n)))),s+=e}catch(t){e=Math.floor(e/2)}return r.join("")}function s(t,e){for(var i=0;i<t.length;i++)e[i]=t[i];return e}var a=t("./support"),l=t("./compressions"),h=t("./nodeBuffer");i.string2binary=function(t){for(var e="",i=0;i<t.length;i++)e+=String.fromCharCode(255&t.charCodeAt(i));return e},i.arrayBuffer2Blob=function(t,e){i.checkSupport("blob"),e=e||"application/zip";try{return new Blob([t],{type:e})}catch(i){try{var r=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder,n=new r;return n.append(t),n.getBlob(e)}catch(t){throw new Error("Bug : can't construct the Blob.")}}},i.applyFromCharCode=o;var u={};u.string={string:r,array:function(t){return n(t,new Array(t.length))},arraybuffer:function(t){return u.string.uint8array(t).buffer},uint8array:function(t){return n(t,new Uint8Array(t.length))},nodebuffer:function(t){return n(t,h(t.length))}},u.array={string:o,array:r,arraybuffer:function(t){return new Uint8Array(t).buffer},uint8array:function(t){return new Uint8Array(t)},nodebuffer:function(t){return h(t)}},u.arraybuffer={string:function(t){return o(new Uint8Array(t))},array:function(t){return s(new Uint8Array(t),new Array(t.byteLength))},arraybuffer:r,uint8array:function(t){return new Uint8Array(t)},nodebuffer:function(t){return h(new Uint8Array(t))}},u.uint8array={string:o,array:function(t){return s(t,new Array(t.length))},arraybuffer:function(t){return t.buffer},uint8array:r,nodebuffer:function(t){return h(t)}},u.nodebuffer={string:o,array:function(t){return s(t,new Array(t.length))},arraybuffer:function(t){return u.nodebuffer.uint8array(t).buffer},uint8array:function(t){return s(t,new Uint8Array(t.length))},nodebuffer:r},i.transformTo=function(t,e){if(e||(e=""),!t)return e;i.checkSupport(t);var r=i.getTypeOf(e),n=u[r][t](e);return n},i.getTypeOf=function(t){return"string"==typeof t?"string":"[object Array]"===Object.prototype.toString.call(t)?"array":a.nodebuffer&&h.test(t)?"nodebuffer":a.uint8array&&t instanceof Uint8Array?"uint8array":a.arraybuffer&&t instanceof ArrayBuffer?"arraybuffer":void 0},i.checkSupport=function(t){var e=a[t.toLowerCase()];if(!e)throw new Error(t+" is not supported by this browser")},i.MAX_VALUE_16BITS=65535,i.MAX_VALUE_32BITS=-1,i.pretty=function(t){var e,i,r="";for(i=0;i<(t||"").length;i++)e=t.charCodeAt(i),r+="\\x"+(e<16?"0":"")+e.toString(16).toUpperCase();return r},i.findCompression=function(t){for(var e in l)if(l.hasOwnProperty(e)&&l[e].magic===t)return l[e];return null},i.isRegExp=function(t){return"[object RegExp]"===Object.prototype.toString.call(t)}},{"./compressions":3,"./nodeBuffer":11,"./support":17}],22:[function(t,e,i){"use strict";function r(t,e){this.files=[],this.loadOptions=e,t&&this.load(t)}var n=t("./stringReader"),o=t("./nodeBufferReader"),s=t("./uint8ArrayReader"),a=t("./utils"),l=t("./signature"),h=t("./zipEntry"),u=t("./support"),c=t("./object");r.prototype={checkSignature:function(t){var e=this.reader.readString(4);if(e!==t)throw new Error("Corrupted zip or bug : unexpected signature ("+a.pretty(e)+", expected "+a.pretty(t)+")")},readBlockEndOfCentral:function(){this.diskNumber=this.reader.readInt(2),this.diskWithCentralDirStart=this.reader.readInt(2),this.centralDirRecordsOnThisDisk=this.reader.readInt(2),this.centralDirRecords=this.reader.readInt(2),this.centralDirSize=this.reader.readInt(4),this.centralDirOffset=this.reader.readInt(4),this.zipCommentLength=this.reader.readInt(2),this.zipComment=this.reader.readString(this.zipCommentLength),this.zipComment=c.utf8decode(this.zipComment)},readBlockZip64EndOfCentral:function(){this.zip64EndOfCentralSize=this.reader.readInt(8),this.versionMadeBy=this.reader.readString(2),this.versionNeeded=this.reader.readInt(2),this.diskNumber=this.reader.readInt(4),this.diskWithCentralDirStart=this.reader.readInt(4),this.centralDirRecordsOnThisDisk=this.reader.readInt(8),this.centralDirRecords=this.reader.readInt(8),this.centralDirSize=this.reader.readInt(8),this.centralDirOffset=this.reader.readInt(8),this.zip64ExtensibleData={};for(var t,e,i,r=this.zip64EndOfCentralSize-44,n=0;n<r;)t=this.reader.readInt(2),e=this.reader.readInt(4),i=this.reader.readString(e),this.zip64ExtensibleData[t]={id:t,length:e,value:i}},readBlockZip64EndOfCentralLocator:function(){if(this.diskWithZip64CentralDirStart=this.reader.readInt(4),this.relativeOffsetEndOfZip64CentralDir=this.reader.readInt(8),this.disksCount=this.reader.readInt(4),this.disksCount>1)throw new Error("Multi-volumes zip are not supported")},readLocalFiles:function(){var t,e;for(t=0;t<this.files.length;t++)e=this.files[t],this.reader.setIndex(e.localHeaderOffset),this.checkSignature(l.LOCAL_FILE_HEADER),e.readLocalPart(this.reader),e.handleUTF8(),e.processAttributes()},readCentralDir:function(){var t;for(this.reader.setIndex(this.centralDirOffset);this.reader.readString(4)===l.CENTRAL_FILE_HEADER;)t=new h({zip64:this.zip64},this.loadOptions),t.readCentralPart(this.reader),this.files.push(t)},readEndOfCentral:function(){var t=this.reader.lastIndexOfSignature(l.CENTRAL_DIRECTORY_END);if(t===-1){var e=!0;try{this.reader.setIndex(0),this.checkSignature(l.LOCAL_FILE_HEADER),e=!1}catch(t){}throw e?new Error("Can't find end of central directory : is this a zip file ? If it is, see http://stuk.github.io/jszip/documentation/howto/read_zip.html"):new Error("Corrupted zip : can't find end of central directory")}if(this.reader.setIndex(t),this.checkSignature(l.CENTRAL_DIRECTORY_END),this.readBlockEndOfCentral(),this.diskNumber===a.MAX_VALUE_16BITS||this.diskWithCentralDirStart===a.MAX_VALUE_16BITS||this.centralDirRecordsOnThisDisk===a.MAX_VALUE_16BITS||this.centralDirRecords===a.MAX_VALUE_16BITS||this.centralDirSize===a.MAX_VALUE_32BITS||this.centralDirOffset===a.MAX_VALUE_32BITS){if(this.zip64=!0,t=this.reader.lastIndexOfSignature(l.ZIP64_CENTRAL_DIRECTORY_LOCATOR),t===-1)throw new Error("Corrupted zip : can't find the ZIP64 end of central directory locator");this.reader.setIndex(t),this.checkSignature(l.ZIP64_CENTRAL_DIRECTORY_LOCATOR),this.readBlockZip64EndOfCentralLocator(),this.reader.setIndex(this.relativeOffsetEndOfZip64CentralDir),this.checkSignature(l.ZIP64_CENTRAL_DIRECTORY_END),this.readBlockZip64EndOfCentral()}},prepareReader:function(t){var e=a.getTypeOf(t);"string"!==e||u.uint8array?"nodebuffer"===e?this.reader=new o(t):this.reader=new s(a.transformTo("uint8array",t)):this.reader=new n(t,this.loadOptions.optimizedBinaryString)},load:function(t){this.prepareReader(t),this.readEndOfCentral(),this.readCentralDir(),this.readLocalFiles()}},e.exports=r},{"./nodeBufferReader":12,"./object":13,"./signature":14,"./stringReader":15,"./support":17,"./uint8ArrayReader":18,"./utils":21,"./zipEntry":23}],23:[function(t,e,i){"use strict";function r(t,e){this.options=t,this.loadOptions=e}var n=t("./stringReader"),o=t("./utils"),s=t("./compressedObject"),a=t("./object"),l=0,h=3;r.prototype={isEncrypted:function(){return 1===(1&this.bitFlag)},useUTF8:function(){return 2048===(2048&this.bitFlag)},prepareCompressedContent:function(t,e,i){return function(){var r=t.index;t.setIndex(e);var n=t.readData(i);return t.setIndex(r),n}},prepareContent:function(t,e,i,r,n){return function(){var t=o.transformTo(r.uncompressInputType,this.getCompressedContent()),e=r.uncompress(t);if(e.length!==n)throw new Error("Bug : uncompressed data size mismatch");return e}},readLocalPart:function(t){var e,i;if(t.skip(22),this.fileNameLength=t.readInt(2),i=t.readInt(2),this.fileName=t.readString(this.fileNameLength),t.skip(i),this.compressedSize==-1||this.uncompressedSize==-1)throw new Error("Bug or corrupted zip : didn't get enough informations from the central directory (compressedSize == -1 || uncompressedSize == -1)");if(e=o.findCompression(this.compressionMethod),null===e)throw new Error("Corrupted zip : compression "+o.pretty(this.compressionMethod)+" unknown (inner file : "+this.fileName+")");if(this.decompressed=new s,this.decompressed.compressedSize=this.compressedSize,this.decompressed.uncompressedSize=this.uncompressedSize,this.decompressed.crc32=this.crc32,this.decompressed.compressionMethod=this.compressionMethod,this.decompressed.getCompressedContent=this.prepareCompressedContent(t,t.index,this.compressedSize,e),this.decompressed.getContent=this.prepareContent(t,t.index,this.compressedSize,e,this.uncompressedSize),this.loadOptions.checkCRC32&&(this.decompressed=o.transformTo("string",this.decompressed.getContent()),a.crc32(this.decompressed)!==this.crc32))throw new Error("Corrupted zip : CRC32 mismatch")},readCentralPart:function(t){if(this.versionMadeBy=t.readInt(2),this.versionNeeded=t.readInt(2),this.bitFlag=t.readInt(2),this.compressionMethod=t.readString(2),this.date=t.readDate(),this.crc32=t.readInt(4),this.compressedSize=t.readInt(4),this.uncompressedSize=t.readInt(4),this.fileNameLength=t.readInt(2),this.extraFieldsLength=t.readInt(2),this.fileCommentLength=t.readInt(2),this.diskNumberStart=t.readInt(2),this.internalFileAttributes=t.readInt(2),this.externalFileAttributes=t.readInt(4),this.localHeaderOffset=t.readInt(4),this.isEncrypted())throw new Error("Encrypted zip are not supported");this.fileName=t.readString(this.fileNameLength),this.readExtraFields(t),this.parseZIP64ExtraField(t),this.fileComment=t.readString(this.fileCommentLength)},processAttributes:function(){this.unixPermissions=null,this.dosPermissions=null;var t=this.versionMadeBy>>8;this.dir=!!(16&this.externalFileAttributes),t===l&&(this.dosPermissions=63&this.externalFileAttributes),t===h&&(this.unixPermissions=this.externalFileAttributes>>16&65535),this.dir||"/"!==this.fileName.slice(-1)||(this.dir=!0)},parseZIP64ExtraField:function(t){if(this.extraFields[1]){var e=new n(this.extraFields[1].value);this.uncompressedSize===o.MAX_VALUE_32BITS&&(this.uncompressedSize=e.readInt(8)),this.compressedSize===o.MAX_VALUE_32BITS&&(this.compressedSize=e.readInt(8)),this.localHeaderOffset===o.MAX_VALUE_32BITS&&(this.localHeaderOffset=e.readInt(8)),this.diskNumberStart===o.MAX_VALUE_32BITS&&(this.diskNumberStart=e.readInt(4))}},readExtraFields:function(t){var e,i,r,n=t.index;for(this.extraFields=this.extraFields||{};t.index<n+this.extraFieldsLength;)e=t.readInt(2),i=t.readInt(2),r=t.readString(i),this.extraFields[e]={id:e,length:i,value:r}},handleUTF8:function(){if(this.useUTF8())this.fileName=a.utf8decode(this.fileName),this.fileComment=a.utf8decode(this.fileComment);else{var t=this.findExtraFieldUnicodePath();null!==t&&(this.fileName=t);var e=this.findExtraFieldUnicodeComment();null!==e&&(this.fileComment=e)}},findExtraFieldUnicodePath:function(){var t=this.extraFields[28789];if(t){var e=new n(t.value);return 1!==e.readInt(1)?null:a.crc32(this.fileName)!==e.readInt(4)?null:a.utf8decode(e.readString(t.length-5))}return null},findExtraFieldUnicodeComment:function(){var t=this.extraFields[25461];if(t){var e=new n(t.value);return 1!==e.readInt(1)?null:a.crc32(this.fileComment)!==e.readInt(4)?null:a.utf8decode(e.readString(t.length-5))}return null}},e.exports=r},{"./compressedObject":2,"./object":13,"./stringReader":15,"./utils":21}],24:[function(t,e,i){var r=t("./lib/utils/common").assign,n=t("./lib/deflate"),o=t("./lib/inflate"),s=t("./lib/zlib/constants"),a={};r(a,n,o,s),e.exports=a},{"./lib/deflate":25,"./lib/inflate":26,"./lib/utils/common":27,"./lib/zlib/constants":30}],25:[function(t,e,i){"use strict";function r(t,e){var i=new y(e);if(i.push(t,!0),i.err)throw i.msg;return i.result}function n(t,e){return e=e||{},e.raw=!0,r(t,e)}function o(t,e){return e=e||{},e.gzip=!0,r(t,e)}var s=t("./zlib/deflate.js"),a=t("./utils/common"),l=t("./utils/strings"),h=t("./zlib/messages"),u=t("./zlib/zstream"),c=0,d=4,p=0,f=1,g=-1,m=0,E=8,y=function(t){this.options=a.assign({level:g,method:E,chunkSize:16384,windowBits:15,memLevel:8,strategy:m,to:""},t||{});var e=this.options;e.raw&&e.windowBits>0?e.windowBits=-e.windowBits:e.gzip&&e.windowBits>0&&e.windowBits<16&&(e.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new u,this.strm.avail_out=0;var i=s.deflateInit2(this.strm,e.level,e.method,e.windowBits,e.memLevel,e.strategy);if(i!==p)throw new Error(h[i]);e.header&&s.deflateSetHeader(this.strm,e.header)};y.prototype.push=function(t,e){var i,r,n=this.strm,o=this.options.chunkSize;if(this.ended)return!1;r=e===~~e?e:e===!0?d:c,"string"==typeof t?n.input=l.string2buf(t):n.input=t,n.next_in=0,n.avail_in=n.input.length;do{if(0===n.avail_out&&(n.output=new a.Buf8(o),n.next_out=0,n.avail_out=o),i=s.deflate(n,r),i!==f&&i!==p)return this.onEnd(i),this.ended=!0,!1;(0===n.avail_out||0===n.avail_in&&r===d)&&("string"===this.options.to?this.onData(l.buf2binstring(a.shrinkBuf(n.output,n.next_out))):this.onData(a.shrinkBuf(n.output,n.next_out)))}while((n.avail_in>0||0===n.avail_out)&&i!==f);return r!==d||(i=s.deflateEnd(this.strm),this.onEnd(i),this.ended=!0,i===p)},y.prototype.onData=function(t){this.chunks.push(t)},y.prototype.onEnd=function(t){t===p&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=a.flattenChunks(this.chunks)),this.chunks=[],this.err=t,this.msg=this.strm.msg},i.Deflate=y,i.deflate=r,i.deflateRaw=n,i.gzip=o},{"./utils/common":27,"./utils/strings":28,"./zlib/deflate.js":32,"./zlib/messages":37,"./zlib/zstream":39}],26:[function(t,e,i){"use strict";function r(t,e){var i=new d(e);if(i.push(t,!0),i.err)throw i.msg;return i.result}function n(t,e){return e=e||{},e.raw=!0,r(t,e)}var o=t("./zlib/inflate.js"),s=t("./utils/common"),a=t("./utils/strings"),l=t("./zlib/constants"),h=t("./zlib/messages"),u=t("./zlib/zstream"),c=t("./zlib/gzheader"),d=function(t){this.options=s.assign({chunkSize:16384,windowBits:0,to:""},t||{});var e=this.options;e.raw&&e.windowBits>=0&&e.windowBits<16&&(e.windowBits=-e.windowBits,0===e.windowBits&&(e.windowBits=-15)),!(e.windowBits>=0&&e.windowBits<16)||t&&t.windowBits||(e.windowBits+=32),e.windowBits>15&&e.windowBits<48&&0===(15&e.windowBits)&&(e.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new u,this.strm.avail_out=0;var i=o.inflateInit2(this.strm,e.windowBits);if(i!==l.Z_OK)throw new Error(h[i]);this.header=new c,o.inflateGetHeader(this.strm,this.header)};d.prototype.push=function(t,e){var i,r,n,h,u,c=this.strm,d=this.options.chunkSize;if(this.ended)return!1;r=e===~~e?e:e===!0?l.Z_FINISH:l.Z_NO_FLUSH,"string"==typeof t?c.input=a.binstring2buf(t):c.input=t,c.next_in=0,c.avail_in=c.input.length;do{if(0===c.avail_out&&(c.output=new s.Buf8(d),c.next_out=0,c.avail_out=d),i=o.inflate(c,l.Z_NO_FLUSH),i!==l.Z_STREAM_END&&i!==l.Z_OK)return this.onEnd(i),this.ended=!0,!1;c.next_out&&(0===c.avail_out||i===l.Z_STREAM_END||0===c.avail_in&&r===l.Z_FINISH)&&("string"===this.options.to?(n=a.utf8border(c.output,c.next_out),h=c.next_out-n,u=a.buf2string(c.output,n),c.next_out=h,c.avail_out=d-h,h&&s.arraySet(c.output,c.output,n,h,0),this.onData(u)):this.onData(s.shrinkBuf(c.output,c.next_out)))}while(c.avail_in>0&&i!==l.Z_STREAM_END);return i===l.Z_STREAM_END&&(r=l.Z_FINISH),r!==l.Z_FINISH||(i=o.inflateEnd(this.strm),this.onEnd(i),this.ended=!0,i===l.Z_OK)},d.prototype.onData=function(t){this.chunks.push(t)},d.prototype.onEnd=function(t){t===l.Z_OK&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=s.flattenChunks(this.chunks)),this.chunks=[],this.err=t,this.msg=this.strm.msg},i.Inflate=d,i.inflate=r,i.inflateRaw=n,i.ungzip=r},{"./utils/common":27,"./utils/strings":28,"./zlib/constants":30,"./zlib/gzheader":33,"./zlib/inflate.js":35,"./zlib/messages":37,"./zlib/zstream":39}],27:[function(t,e,i){"use strict";var r="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Int32Array;i.assign=function(t){for(var e=Array.prototype.slice.call(arguments,1);e.length;){var i=e.shift();if(i){if("object"!=typeof i)throw new TypeError(i+"must be non-object");for(var r in i)i.hasOwnProperty(r)&&(t[r]=i[r])}}return t},i.shrinkBuf=function(t,e){return t.length===e?t:t.subarray?t.subarray(0,e):(t.length=e,t)};var n={arraySet:function(t,e,i,r,n){if(e.subarray&&t.subarray)return void t.set(e.subarray(i,i+r),n);for(var o=0;o<r;o++)t[n+o]=e[i+o]},flattenChunks:function(t){var e,i,r,n,o,s;for(r=0,e=0,i=t.length;e<i;e++)r+=t[e].length;for(s=new Uint8Array(r),n=0,e=0,i=t.length;e<i;e++)o=t[e],s.set(o,n),n+=o.length;return s}},o={arraySet:function(t,e,i,r,n){for(var o=0;o<r;o++)t[n+o]=e[i+o]},flattenChunks:function(t){return[].concat.apply([],t)}};i.setTyped=function(t){t?(i.Buf8=Uint8Array,i.Buf16=Uint16Array,i.Buf32=Int32Array,i.assign(i,n)):(i.Buf8=Array,i.Buf16=Array,i.Buf32=Array,i.assign(i,o))},i.setTyped(r)},{}],28:[function(t,e,i){function r(t,e){if(e<65537&&(t.subarray&&s||!t.subarray&&o))return String.fromCharCode.apply(null,n.shrinkBuf(t,e));for(var i="",r=0;r<e;r++)i+=String.fromCharCode(t[r]);return i}var n=t("./common"),o=!0,s=!0;try{String.fromCharCode.apply(null,[0])}catch(t){o=!1}try{String.fromCharCode.apply(null,new Uint8Array(1))}catch(t){s=!1}for(var a=new n.Buf8(256),l=0;l<256;l++)a[l]=l>=252?6:l>=248?5:l>=240?4:l>=224?3:l>=192?2:1;a[254]=a[254]=1,i.string2buf=function(t){var e,i,r,o,s,a=t.length,l=0;for(o=0;o<a;o++)i=t.charCodeAt(o),55296===(64512&i)&&o+1<a&&(r=t.charCodeAt(o+1),56320===(64512&r)&&(i=65536+(i-55296<<10)+(r-56320),o++)),l+=i<128?1:i<2048?2:i<65536?3:4;for(e=new n.Buf8(l),s=0,o=0;s<l;o++)i=t.charCodeAt(o),55296===(64512&i)&&o+1<a&&(r=t.charCodeAt(o+1),56320===(64512&r)&&(i=65536+(i-55296<<10)+(r-56320),o++)),i<128?e[s++]=i:i<2048?(e[s++]=192|i>>>6,e[s++]=128|63&i):i<65536?(e[s++]=224|i>>>12,e[s++]=128|i>>>6&63,e[s++]=128|63&i):(e[s++]=240|i>>>18,e[s++]=128|i>>>12&63,e[s++]=128|i>>>6&63,e[s++]=128|63&i);return e},i.buf2binstring=function(t){return r(t,t.length)},i.binstring2buf=function(t){for(var e=new n.Buf8(t.length),i=0,r=e.length;i<r;i++)e[i]=t.charCodeAt(i);return e},i.buf2string=function(t,e){var i,n,o,s,l=e||t.length,h=new Array(2*l);for(n=0,i=0;i<l;)if(o=t[i++],o<128)h[n++]=o;else if(s=a[o],s>4)h[n++]=65533,i+=s-1;else{for(o&=2===s?31:3===s?15:7;s>1&&i<l;)o=o<<6|63&t[i++],s--;s>1?h[n++]=65533:o<65536?h[n++]=o:(o-=65536,h[n++]=55296|o>>10&1023,h[n++]=56320|1023&o)}return r(h,n)},i.utf8border=function(t,e){var i;for(e=e||t.length,e>t.length&&(e=t.length),i=e-1;i>=0&&128===(192&t[i]);)i--;return i<0?e:0===i?e:i+a[t[i]]>e?i:e}},{"./common":27}],29:[function(t,e,i){"use strict";function r(t,e,i,r){for(var n=65535&t|0,o=t>>>16&65535|0,s=0;0!==i;){s=i>2e3?2e3:i,i-=s;do n=n+e[r++]|0,o=o+n|0;while(--s);n%=65521,o%=65521}return n|o<<16|0}e.exports=r},{}],30:[function(t,e,i){e.exports={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8}},{}],31:[function(t,e,i){"use strict";function r(){for(var t,e=[],i=0;i<256;i++){t=i;for(var r=0;r<8;r++)t=1&t?3988292384^t>>>1:t>>>1;e[i]=t}return e}function n(t,e,i,r){var n=o,s=r+i;t^=-1;for(var a=r;a<s;a++)t=t>>>8^n[255&(t^e[a])];return t^-1}var o=r();e.exports=n},{}],32:[function(t,e,i){"use strict";function r(t,e){return t.msg=O[e],e}function n(t){return(t<<1)-(t>4?9:0)}function o(t){for(var e=t.length;--e>=0;)t[e]=0}function s(t){var e=t.state,i=e.pending;i>t.avail_out&&(i=t.avail_out),0!==i&&(M.arraySet(t.output,e.pending_buf,e.pending_out,i,t.next_out),t.next_out+=i,e.pending_out+=i,t.total_out+=i,t.avail_out-=i,e.pending-=i,0===e.pending&&(e.pending_out=0))}function a(t,e){C._tr_flush_block(t,t.block_start>=0?t.block_start:-1,t.strstart-t.block_start,e),t.block_start=t.strstart,s(t.strm)}function l(t,e){t.pending_buf[t.pending++]=e}function h(t,e){t.pending_buf[t.pending++]=e>>>8&255,t.pending_buf[t.pending++]=255&e}function u(t,e,i,r){var n=t.avail_in;return n>r&&(n=r),0===n?0:(t.avail_in-=n,M.arraySet(e,t.input,t.next_in,n,i),1===t.state.wrap?t.adler=A(t.adler,e,n,i):2===t.state.wrap&&(t.adler=P(t.adler,e,n,i)),t.next_in+=n,t.total_in+=n,n)}function c(t,e){var i,r,n=t.max_chain_length,o=t.strstart,s=t.prev_length,a=t.nice_match,l=t.strstart>t.w_size-ht?t.strstart-(t.w_size-ht):0,h=t.window,u=t.w_mask,c=t.prev,d=t.strstart+lt,p=h[o+s-1],f=h[o+s];t.prev_length>=t.good_match&&(n>>=2),a>t.lookahead&&(a=t.lookahead);do if(i=e,h[i+s]===f&&h[i+s-1]===p&&h[i]===h[o]&&h[++i]===h[o+1]){o+=2,i++;do;while(h[++o]===h[++i]&&h[++o]===h[++i]&&h[++o]===h[++i]&&h[++o]===h[++i]&&h[++o]===h[++i]&&h[++o]===h[++i]&&h[++o]===h[++i]&&h[++o]===h[++i]&&o<d);if(r=lt-(d-o),o=d-lt,r>s){if(t.match_start=e,s=r,r>=a)break;p=h[o+s-1],f=h[o+s]}}while((e=c[e&u])>l&&0!==--n);return s<=t.lookahead?s:t.lookahead}function d(t){var e,i,r,n,o,s=t.w_size;do{if(n=t.window_size-t.lookahead-t.strstart,t.strstart>=s+(s-ht)){M.arraySet(t.window,t.window,s,s,0),t.match_start-=s,t.strstart-=s,t.block_start-=s,i=t.hash_size,e=i;do r=t.head[--e],t.head[e]=r>=s?r-s:0;while(--i);i=s,e=i;do r=t.prev[--e],t.prev[e]=r>=s?r-s:0;while(--i);n+=s}if(0===t.strm.avail_in)break;if(i=u(t.strm,t.window,t.strstart+t.lookahead,n),t.lookahead+=i,t.lookahead+t.insert>=at)for(o=t.strstart-t.insert,t.ins_h=t.window[o],t.ins_h=(t.ins_h<<t.hash_shift^t.window[o+1])&t.hash_mask;t.insert&&(t.ins_h=(t.ins_h<<t.hash_shift^t.window[o+at-1])&t.hash_mask,t.prev[o&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=o,o++,t.insert--,!(t.lookahead+t.insert<at)););}while(t.lookahead<ht&&0!==t.strm.avail_in)}function p(t,e){var i=65535;for(i>t.pending_buf_size-5&&(i=t.pending_buf_size-5);;){if(t.lookahead<=1){if(d(t),0===t.lookahead&&e===I)return yt;if(0===t.lookahead)break}t.strstart+=t.lookahead,t.lookahead=0;var r=t.block_start+i;if((0===t.strstart||t.strstart>=r)&&(t.lookahead=t.strstart-r,t.strstart=r,a(t,!1),0===t.strm.avail_out))return yt;if(t.strstart-t.block_start>=t.w_size-ht&&(a(t,!1),0===t.strm.avail_out))return yt}return t.insert=0,e===V?(a(t,!0),0===t.strm.avail_out?vt:bt):t.strstart>t.block_start&&(a(t,!1),0===t.strm.avail_out)?yt:yt}function f(t,e){for(var i,r;;){if(t.lookahead<ht){if(d(t),t.lookahead<ht&&e===I)return yt;if(0===t.lookahead)break}if(i=0,t.lookahead>=at&&(t.ins_h=(t.ins_h<<t.hash_shift^t.window[t.strstart+at-1])&t.hash_mask,i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart),0!==i&&t.strstart-i<=t.w_size-ht&&(t.match_length=c(t,i)),t.match_length>=at)if(r=C._tr_tally(t,t.strstart-t.match_start,t.match_length-at),t.lookahead-=t.match_length,t.match_length<=t.max_lazy_match&&t.lookahead>=at){t.match_length--;do t.strstart++,t.ins_h=(t.ins_h<<t.hash_shift^t.window[t.strstart+at-1])&t.hash_mask,i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart;while(0!==--t.match_length);t.strstart++}else t.strstart+=t.match_length,t.match_length=0,t.ins_h=t.window[t.strstart],t.ins_h=(t.ins_h<<t.hash_shift^t.window[t.strstart+1])&t.hash_mask;else r=C._tr_tally(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++;if(r&&(a(t,!1),0===t.strm.avail_out))return yt}return t.insert=t.strstart<at-1?t.strstart:at-1,e===V?(a(t,!0),0===t.strm.avail_out?vt:bt):t.last_lit&&(a(t,!1),0===t.strm.avail_out)?yt:_t}function g(t,e){for(var i,r,n;;){if(t.lookahead<ht){if(d(t),t.lookahead<ht&&e===I)return yt;if(0===t.lookahead)break}if(i=0,t.lookahead>=at&&(t.ins_h=(t.ins_h<<t.hash_shift^t.window[t.strstart+at-1])&t.hash_mask,i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart),t.prev_length=t.match_length,t.prev_match=t.match_start,t.match_length=at-1,0!==i&&t.prev_length<t.max_lazy_match&&t.strstart-i<=t.w_size-ht&&(t.match_length=c(t,i),t.match_length<=5&&(t.strategy===K||t.match_length===at&&t.strstart-t.match_start>4096)&&(t.match_length=at-1)),t.prev_length>=at&&t.match_length<=t.prev_length){n=t.strstart+t.lookahead-at,r=C._tr_tally(t,t.strstart-1-t.prev_match,t.prev_length-at),t.lookahead-=t.prev_length-1,t.prev_length-=2;do++t.strstart<=n&&(t.ins_h=(t.ins_h<<t.hash_shift^t.window[t.strstart+at-1])&t.hash_mask,i=t.prev[t.strstart&t.w_mask]=t.head[t.ins_h],t.head[t.ins_h]=t.strstart);while(0!==--t.prev_length);if(t.match_available=0,t.match_length=at-1,t.strstart++,r&&(a(t,!1),0===t.strm.avail_out))return yt}else if(t.match_available){if(r=C._tr_tally(t,0,t.window[t.strstart-1]),
r&&a(t,!1),t.strstart++,t.lookahead--,0===t.strm.avail_out)return yt}else t.match_available=1,t.strstart++,t.lookahead--}return t.match_available&&(r=C._tr_tally(t,0,t.window[t.strstart-1]),t.match_available=0),t.insert=t.strstart<at-1?t.strstart:at-1,e===V?(a(t,!0),0===t.strm.avail_out?vt:bt):t.last_lit&&(a(t,!1),0===t.strm.avail_out)?yt:_t}function m(t,e){for(var i,r,n,o,s=t.window;;){if(t.lookahead<=lt){if(d(t),t.lookahead<=lt&&e===I)return yt;if(0===t.lookahead)break}if(t.match_length=0,t.lookahead>=at&&t.strstart>0&&(n=t.strstart-1,r=s[n],r===s[++n]&&r===s[++n]&&r===s[++n])){o=t.strstart+lt;do;while(r===s[++n]&&r===s[++n]&&r===s[++n]&&r===s[++n]&&r===s[++n]&&r===s[++n]&&r===s[++n]&&r===s[++n]&&n<o);t.match_length=lt-(o-n),t.match_length>t.lookahead&&(t.match_length=t.lookahead)}if(t.match_length>=at?(i=C._tr_tally(t,1,t.match_length-at),t.lookahead-=t.match_length,t.strstart+=t.match_length,t.match_length=0):(i=C._tr_tally(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++),i&&(a(t,!1),0===t.strm.avail_out))return yt}return t.insert=0,e===V?(a(t,!0),0===t.strm.avail_out?vt:bt):t.last_lit&&(a(t,!1),0===t.strm.avail_out)?yt:_t}function E(t,e){for(var i;;){if(0===t.lookahead&&(d(t),0===t.lookahead)){if(e===I)return yt;break}if(t.match_length=0,i=C._tr_tally(t,0,t.window[t.strstart]),t.lookahead--,t.strstart++,i&&(a(t,!1),0===t.strm.avail_out))return yt}return t.insert=0,e===V?(a(t,!0),0===t.strm.avail_out?vt:bt):t.last_lit&&(a(t,!1),0===t.strm.avail_out)?yt:_t}function y(t){t.window_size=2*t.w_size,o(t.head),t.max_lazy_match=R[t.level].max_lazy,t.good_match=R[t.level].good_length,t.nice_match=R[t.level].nice_length,t.max_chain_length=R[t.level].max_chain,t.strstart=0,t.block_start=0,t.lookahead=0,t.insert=0,t.match_length=t.prev_length=at-1,t.match_available=0,t.ins_h=0}function _(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=J,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new M.Buf16(2*ot),this.dyn_dtree=new M.Buf16(2*(2*rt+1)),this.bl_tree=new M.Buf16(2*(2*nt+1)),o(this.dyn_ltree),o(this.dyn_dtree),o(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new M.Buf16(st+1),this.heap=new M.Buf16(2*it+1),o(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new M.Buf16(2*it+1),o(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}function v(t){var e;return t&&t.state?(t.total_in=t.total_out=0,t.data_type=X,e=t.state,e.pending=0,e.pending_out=0,e.wrap<0&&(e.wrap=-e.wrap),e.status=e.wrap?ct:mt,t.adler=2===e.wrap?0:1,e.last_flush=I,C._tr_init(e),F):r(t,W)}function b(t){var e=v(t);return e===F&&y(t.state),e}function S(t,e){return t&&t.state?2!==t.state.wrap?W:(t.state.gzhead=e,F):W}function T(t,e,i,n,o,s){if(!t)return W;var a=1;if(e===j&&(e=6),n<0?(a=0,n=-n):n>15&&(a=2,n-=16),o<1||o>Z||i!==J||n<8||n>15||e<0||e>9||s<0||s>H)return r(t,W);8===n&&(n=9);var l=new _;return t.state=l,l.strm=t,l.wrap=a,l.gzhead=null,l.w_bits=n,l.w_size=1<<l.w_bits,l.w_mask=l.w_size-1,l.hash_bits=o+7,l.hash_size=1<<l.hash_bits,l.hash_mask=l.hash_size-1,l.hash_shift=~~((l.hash_bits+at-1)/at),l.window=new M.Buf8(2*l.w_size),l.head=new M.Buf16(l.hash_size),l.prev=new M.Buf16(l.w_size),l.lit_bufsize=1<<o+6,l.pending_buf_size=4*l.lit_bufsize,l.pending_buf=new M.Buf8(l.pending_buf_size),l.d_buf=l.lit_bufsize>>1,l.l_buf=3*l.lit_bufsize,l.level=e,l.strategy=s,l.method=i,b(t)}function L(t,e){return T(t,e,J,Q,$,Y)}function w(t,e){var i,a,u,c;if(!t||!t.state||e>k||e<0)return t?r(t,W):W;if(a=t.state,!t.output||!t.input&&0!==t.avail_in||a.status===Et&&e!==V)return r(t,0===t.avail_out?U:W);if(a.strm=t,i=a.last_flush,a.last_flush=e,a.status===ct)if(2===a.wrap)t.adler=0,l(a,31),l(a,139),l(a,8),a.gzhead?(l(a,(a.gzhead.text?1:0)+(a.gzhead.hcrc?2:0)+(a.gzhead.extra?4:0)+(a.gzhead.name?8:0)+(a.gzhead.comment?16:0)),l(a,255&a.gzhead.time),l(a,a.gzhead.time>>8&255),l(a,a.gzhead.time>>16&255),l(a,a.gzhead.time>>24&255),l(a,9===a.level?2:a.strategy>=z||a.level<2?4:0),l(a,255&a.gzhead.os),a.gzhead.extra&&a.gzhead.extra.length&&(l(a,255&a.gzhead.extra.length),l(a,a.gzhead.extra.length>>8&255)),a.gzhead.hcrc&&(t.adler=P(t.adler,a.pending_buf,a.pending,0)),a.gzindex=0,a.status=dt):(l(a,0),l(a,0),l(a,0),l(a,0),l(a,0),l(a,9===a.level?2:a.strategy>=z||a.level<2?4:0),l(a,St),a.status=mt);else{var d=J+(a.w_bits-8<<4)<<8,p=-1;p=a.strategy>=z||a.level<2?0:a.level<6?1:6===a.level?2:3,d|=p<<6,0!==a.strstart&&(d|=ut),d+=31-d%31,a.status=mt,h(a,d),0!==a.strstart&&(h(a,t.adler>>>16),h(a,65535&t.adler)),t.adler=1}if(a.status===dt)if(a.gzhead.extra){for(u=a.pending;a.gzindex<(65535&a.gzhead.extra.length)&&(a.pending!==a.pending_buf_size||(a.gzhead.hcrc&&a.pending>u&&(t.adler=P(t.adler,a.pending_buf,a.pending-u,u)),s(t),u=a.pending,a.pending!==a.pending_buf_size));)l(a,255&a.gzhead.extra[a.gzindex]),a.gzindex++;a.gzhead.hcrc&&a.pending>u&&(t.adler=P(t.adler,a.pending_buf,a.pending-u,u)),a.gzindex===a.gzhead.extra.length&&(a.gzindex=0,a.status=pt)}else a.status=pt;if(a.status===pt)if(a.gzhead.name){u=a.pending;do{if(a.pending===a.pending_buf_size&&(a.gzhead.hcrc&&a.pending>u&&(t.adler=P(t.adler,a.pending_buf,a.pending-u,u)),s(t),u=a.pending,a.pending===a.pending_buf_size)){c=1;break}c=a.gzindex<a.gzhead.name.length?255&a.gzhead.name.charCodeAt(a.gzindex++):0,l(a,c)}while(0!==c);a.gzhead.hcrc&&a.pending>u&&(t.adler=P(t.adler,a.pending_buf,a.pending-u,u)),0===c&&(a.gzindex=0,a.status=ft)}else a.status=ft;if(a.status===ft)if(a.gzhead.comment){u=a.pending;do{if(a.pending===a.pending_buf_size&&(a.gzhead.hcrc&&a.pending>u&&(t.adler=P(t.adler,a.pending_buf,a.pending-u,u)),s(t),u=a.pending,a.pending===a.pending_buf_size)){c=1;break}c=a.gzindex<a.gzhead.comment.length?255&a.gzhead.comment.charCodeAt(a.gzindex++):0,l(a,c)}while(0!==c);a.gzhead.hcrc&&a.pending>u&&(t.adler=P(t.adler,a.pending_buf,a.pending-u,u)),0===c&&(a.status=gt)}else a.status=gt;if(a.status===gt&&(a.gzhead.hcrc?(a.pending+2>a.pending_buf_size&&s(t),a.pending+2<=a.pending_buf_size&&(l(a,255&t.adler),l(a,t.adler>>8&255),t.adler=0,a.status=mt)):a.status=mt),0!==a.pending){if(s(t),0===t.avail_out)return a.last_flush=-1,F}else if(0===t.avail_in&&n(e)<=n(i)&&e!==V)return r(t,U);if(a.status===Et&&0!==t.avail_in)return r(t,U);if(0!==t.avail_in||0!==a.lookahead||e!==I&&a.status!==Et){var f=a.strategy===z?E(a,e):a.strategy===q?m(a,e):R[a.level].func(a,e);if(f!==vt&&f!==bt||(a.status=Et),f===yt||f===vt)return 0===t.avail_out&&(a.last_flush=-1),F;if(f===_t&&(e===N?C._tr_align(a):e!==k&&(C._tr_stored_block(a,0,0,!1),e===D&&(o(a.head),0===a.lookahead&&(a.strstart=0,a.block_start=0,a.insert=0))),s(t),0===t.avail_out))return a.last_flush=-1,F}return e!==V?F:a.wrap<=0?G:(2===a.wrap?(l(a,255&t.adler),l(a,t.adler>>8&255),l(a,t.adler>>16&255),l(a,t.adler>>24&255),l(a,255&t.total_in),l(a,t.total_in>>8&255),l(a,t.total_in>>16&255),l(a,t.total_in>>24&255)):(h(a,t.adler>>>16),h(a,65535&t.adler)),s(t),a.wrap>0&&(a.wrap=-a.wrap),0!==a.pending?F:G)}function x(t){var e;return t&&t.state?(e=t.state.status,e!==ct&&e!==dt&&e!==pt&&e!==ft&&e!==gt&&e!==mt&&e!==Et?r(t,W):(t.state=null,e===mt?r(t,B):F)):W}var R,M=t("../utils/common"),C=t("./trees"),A=t("./adler32"),P=t("./crc32"),O=t("./messages"),I=0,N=1,D=3,V=4,k=5,F=0,G=1,W=-2,B=-3,U=-5,j=-1,K=1,z=2,q=3,H=4,Y=0,X=2,J=8,Z=9,Q=15,$=8,tt=29,et=256,it=et+1+tt,rt=30,nt=19,ot=2*it+1,st=15,at=3,lt=258,ht=lt+at+1,ut=32,ct=42,dt=69,pt=73,ft=91,gt=103,mt=113,Et=666,yt=1,_t=2,vt=3,bt=4,St=3,Tt=function(t,e,i,r,n){this.good_length=t,this.max_lazy=e,this.nice_length=i,this.max_chain=r,this.func=n};R=[new Tt(0,0,0,0,p),new Tt(4,4,8,4,f),new Tt(4,5,16,8,f),new Tt(4,6,32,32,f),new Tt(4,4,16,16,g),new Tt(8,16,32,32,g),new Tt(8,16,128,128,g),new Tt(8,32,128,256,g),new Tt(32,128,258,1024,g),new Tt(32,258,258,4096,g)],i.deflateInit=L,i.deflateInit2=T,i.deflateReset=b,i.deflateResetKeep=v,i.deflateSetHeader=S,i.deflate=w,i.deflateEnd=x,i.deflateInfo="pako deflate (from Nodeca project)"},{"../utils/common":27,"./adler32":29,"./crc32":31,"./messages":37,"./trees":38}],33:[function(t,e,i){"use strict";function r(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1}e.exports=r},{}],34:[function(t,e,i){"use strict";var r=30,n=12;e.exports=function(t,e){var i,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b,S,T,L,w,x,R,M;i=t.state,o=t.next_in,R=t.input,s=o+(t.avail_in-5),a=t.next_out,M=t.output,l=a-(e-t.avail_out),h=a+(t.avail_out-257),u=i.dmax,c=i.wsize,d=i.whave,p=i.wnext,f=i.window,g=i.hold,m=i.bits,E=i.lencode,y=i.distcode,_=(1<<i.lenbits)-1,v=(1<<i.distbits)-1;t:do{m<15&&(g+=R[o++]<<m,m+=8,g+=R[o++]<<m,m+=8),b=E[g&_];e:for(;;){if(S=b>>>24,g>>>=S,m-=S,S=b>>>16&255,0===S)M[a++]=65535&b;else{if(!(16&S)){if(0===(64&S)){b=E[(65535&b)+(g&(1<<S)-1)];continue e}if(32&S){i.mode=n;break t}t.msg="invalid literal/length code",i.mode=r;break t}T=65535&b,S&=15,S&&(m<S&&(g+=R[o++]<<m,m+=8),T+=g&(1<<S)-1,g>>>=S,m-=S),m<15&&(g+=R[o++]<<m,m+=8,g+=R[o++]<<m,m+=8),b=y[g&v];i:for(;;){if(S=b>>>24,g>>>=S,m-=S,S=b>>>16&255,!(16&S)){if(0===(64&S)){b=y[(65535&b)+(g&(1<<S)-1)];continue i}t.msg="invalid distance code",i.mode=r;break t}if(L=65535&b,S&=15,m<S&&(g+=R[o++]<<m,m+=8,m<S&&(g+=R[o++]<<m,m+=8)),L+=g&(1<<S)-1,L>u){t.msg="invalid distance too far back",i.mode=r;break t}if(g>>>=S,m-=S,S=a-l,L>S){if(S=L-S,S>d&&i.sane){t.msg="invalid distance too far back",i.mode=r;break t}if(w=0,x=f,0===p){if(w+=c-S,S<T){T-=S;do M[a++]=f[w++];while(--S);w=a-L,x=M}}else if(p<S){if(w+=c+p-S,S-=p,S<T){T-=S;do M[a++]=f[w++];while(--S);if(w=0,p<T){S=p,T-=S;do M[a++]=f[w++];while(--S);w=a-L,x=M}}}else if(w+=p-S,S<T){T-=S;do M[a++]=f[w++];while(--S);w=a-L,x=M}for(;T>2;)M[a++]=x[w++],M[a++]=x[w++],M[a++]=x[w++],T-=3;T&&(M[a++]=x[w++],T>1&&(M[a++]=x[w++]))}else{w=a-L;do M[a++]=M[w++],M[a++]=M[w++],M[a++]=M[w++],T-=3;while(T>2);T&&(M[a++]=M[w++],T>1&&(M[a++]=M[w++]))}break}}break}}while(o<s&&a<h);T=m>>3,o-=T,m-=T<<3,g&=(1<<m)-1,t.next_in=o,t.next_out=a,t.avail_in=o<s?5+(s-o):5-(o-s),t.avail_out=a<h?257+(h-a):257-(a-h),i.hold=g,i.bits=m}},{}],35:[function(t,e,i){"use strict";function r(t){return(t>>>24&255)+(t>>>8&65280)+((65280&t)<<8)+((255&t)<<24)}function n(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new E.Buf16(320),this.work=new E.Buf16(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0}function o(t){var e;return t&&t.state?(e=t.state,t.total_in=t.total_out=e.total=0,t.msg="",e.wrap&&(t.adler=1&e.wrap),e.mode=V,e.last=0,e.havedict=0,e.dmax=32768,e.head=null,e.hold=0,e.bits=0,e.lencode=e.lendyn=new E.Buf32(ft),e.distcode=e.distdyn=new E.Buf32(gt),e.sane=1,e.back=-1,M):P}function s(t){var e;return t&&t.state?(e=t.state,e.wsize=0,e.whave=0,e.wnext=0,o(t)):P}function a(t,e){var i,r;return t&&t.state?(r=t.state,e<0?(i=0,e=-e):(i=(e>>4)+1,e<48&&(e&=15)),e&&(e<8||e>15)?P:(null!==r.window&&r.wbits!==e&&(r.window=null),r.wrap=i,r.wbits=e,s(t))):P}function l(t,e){var i,r;return t?(r=new n,t.state=r,r.window=null,i=a(t,e),i!==M&&(t.state=null),i):P}function h(t){return l(t,Et)}function u(t){if(yt){var e;for(g=new E.Buf32(512),m=new E.Buf32(32),e=0;e<144;)t.lens[e++]=8;for(;e<256;)t.lens[e++]=9;for(;e<280;)t.lens[e++]=7;for(;e<288;)t.lens[e++]=8;for(b(T,t.lens,0,288,g,0,t.work,{bits:9}),e=0;e<32;)t.lens[e++]=5;b(L,t.lens,0,32,m,0,t.work,{bits:5}),yt=!1}t.lencode=g,t.lenbits=9,t.distcode=m,t.distbits=5}function c(t,e,i,r){var n,o=t.state;return null===o.window&&(o.wsize=1<<o.wbits,o.wnext=0,o.whave=0,o.window=new E.Buf8(o.wsize)),r>=o.wsize?(E.arraySet(o.window,e,i-o.wsize,o.wsize,0),o.wnext=0,o.whave=o.wsize):(n=o.wsize-o.wnext,n>r&&(n=r),E.arraySet(o.window,e,i-r,n,o.wnext),r-=n,r?(E.arraySet(o.window,e,i-r,r,0),o.wnext=r,o.whave=o.wsize):(o.wnext+=n,o.wnext===o.wsize&&(o.wnext=0),o.whave<o.wsize&&(o.whave+=n))),0}function d(t,e){var i,n,o,s,a,l,h,d,p,f,g,m,ft,gt,mt,Et,yt,_t,vt,bt,St,Tt,Lt,wt,xt=0,Rt=new E.Buf8(4),Mt=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];if(!t||!t.state||!t.output||!t.input&&0!==t.avail_in)return P;i=t.state,i.mode===H&&(i.mode=Y),a=t.next_out,o=t.output,h=t.avail_out,s=t.next_in,n=t.input,l=t.avail_in,d=i.hold,p=i.bits,f=l,g=h,Tt=M;t:for(;;)switch(i.mode){case V:if(0===i.wrap){i.mode=Y;break}for(;p<16;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(2&i.wrap&&35615===d){i.check=0,Rt[0]=255&d,Rt[1]=d>>>8&255,i.check=_(i.check,Rt,2,0),d=0,p=0,i.mode=k;break}if(i.flags=0,i.head&&(i.head.done=!1),!(1&i.wrap)||(((255&d)<<8)+(d>>8))%31){t.msg="incorrect header check",i.mode=ct;break}if((15&d)!==D){t.msg="unknown compression method",i.mode=ct;break}if(d>>>=4,p-=4,St=(15&d)+8,0===i.wbits)i.wbits=St;else if(St>i.wbits){t.msg="invalid window size",i.mode=ct;break}i.dmax=1<<St,t.adler=i.check=1,i.mode=512&d?z:H,d=0,p=0;break;case k:for(;p<16;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(i.flags=d,(255&i.flags)!==D){t.msg="unknown compression method",i.mode=ct;break}if(57344&i.flags){t.msg="unknown header flags set",i.mode=ct;break}i.head&&(i.head.text=d>>8&1),512&i.flags&&(Rt[0]=255&d,Rt[1]=d>>>8&255,i.check=_(i.check,Rt,2,0)),d=0,p=0,i.mode=F;case F:for(;p<32;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}i.head&&(i.head.time=d),512&i.flags&&(Rt[0]=255&d,Rt[1]=d>>>8&255,Rt[2]=d>>>16&255,Rt[3]=d>>>24&255,i.check=_(i.check,Rt,4,0)),d=0,p=0,i.mode=G;case G:for(;p<16;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}i.head&&(i.head.xflags=255&d,i.head.os=d>>8),512&i.flags&&(Rt[0]=255&d,Rt[1]=d>>>8&255,i.check=_(i.check,Rt,2,0)),d=0,p=0,i.mode=W;case W:if(1024&i.flags){for(;p<16;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}i.length=d,i.head&&(i.head.extra_len=d),512&i.flags&&(Rt[0]=255&d,Rt[1]=d>>>8&255,i.check=_(i.check,Rt,2,0)),d=0,p=0}else i.head&&(i.head.extra=null);i.mode=B;case B:if(1024&i.flags&&(m=i.length,m>l&&(m=l),m&&(i.head&&(St=i.head.extra_len-i.length,i.head.extra||(i.head.extra=new Array(i.head.extra_len)),E.arraySet(i.head.extra,n,s,m,St)),512&i.flags&&(i.check=_(i.check,n,m,s)),l-=m,s+=m,i.length-=m),i.length))break t;i.length=0,i.mode=U;case U:if(2048&i.flags){if(0===l)break t;m=0;do St=n[s+m++],i.head&&St&&i.length<65536&&(i.head.name+=String.fromCharCode(St));while(St&&m<l);if(512&i.flags&&(i.check=_(i.check,n,m,s)),l-=m,s+=m,St)break t}else i.head&&(i.head.name=null);i.length=0,i.mode=j;case j:if(4096&i.flags){if(0===l)break t;m=0;do St=n[s+m++],i.head&&St&&i.length<65536&&(i.head.comment+=String.fromCharCode(St));while(St&&m<l);if(512&i.flags&&(i.check=_(i.check,n,m,s)),l-=m,s+=m,St)break t}else i.head&&(i.head.comment=null);i.mode=K;case K:if(512&i.flags){for(;p<16;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(d!==(65535&i.check)){t.msg="header crc mismatch",i.mode=ct;break}d=0,p=0}i.head&&(i.head.hcrc=i.flags>>9&1,i.head.done=!0),t.adler=i.check=0,i.mode=H;break;case z:for(;p<32;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}t.adler=i.check=r(d),d=0,p=0,i.mode=q;case q:if(0===i.havedict)return t.next_out=a,t.avail_out=h,t.next_in=s,t.avail_in=l,i.hold=d,i.bits=p,A;t.adler=i.check=1,i.mode=H;case H:if(e===x||e===R)break t;case Y:if(i.last){d>>>=7&p,p-=7&p,i.mode=lt;break}for(;p<3;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}switch(i.last=1&d,d>>>=1,p-=1,3&d){case 0:i.mode=X;break;case 1:if(u(i),i.mode=et,e===R){d>>>=2,p-=2;break t}break;case 2:i.mode=Q;break;case 3:t.msg="invalid block type",i.mode=ct}d>>>=2,p-=2;break;case X:for(d>>>=7&p,p-=7&p;p<32;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if((65535&d)!==(d>>>16^65535)){t.msg="invalid stored block lengths",i.mode=ct;break}if(i.length=65535&d,d=0,p=0,i.mode=J,e===R)break t;case J:i.mode=Z;case Z:if(m=i.length){if(m>l&&(m=l),m>h&&(m=h),0===m)break t;E.arraySet(o,n,s,m,a),l-=m,s+=m,h-=m,a+=m,i.length-=m;break}i.mode=H;break;case Q:for(;p<14;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(i.nlen=(31&d)+257,d>>>=5,p-=5,i.ndist=(31&d)+1,d>>>=5,p-=5,i.ncode=(15&d)+4,d>>>=4,p-=4,i.nlen>286||i.ndist>30){t.msg="too many length or distance symbols",i.mode=ct;break}i.have=0,i.mode=$;case $:for(;i.have<i.ncode;){for(;p<3;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}i.lens[Mt[i.have++]]=7&d,d>>>=3,p-=3}for(;i.have<19;)i.lens[Mt[i.have++]]=0;if(i.lencode=i.lendyn,i.lenbits=7,Lt={bits:i.lenbits},Tt=b(S,i.lens,0,19,i.lencode,0,i.work,Lt),i.lenbits=Lt.bits,Tt){t.msg="invalid code lengths set",i.mode=ct;break}i.have=0,i.mode=tt;case tt:for(;i.have<i.nlen+i.ndist;){for(;xt=i.lencode[d&(1<<i.lenbits)-1],mt=xt>>>24,Et=xt>>>16&255,yt=65535&xt,!(mt<=p);){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(yt<16)d>>>=mt,p-=mt,i.lens[i.have++]=yt;else{if(16===yt){for(wt=mt+2;p<wt;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(d>>>=mt,p-=mt,0===i.have){t.msg="invalid bit length repeat",i.mode=ct;break}St=i.lens[i.have-1],m=3+(3&d),d>>>=2,p-=2}else if(17===yt){for(wt=mt+3;p<wt;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}d>>>=mt,p-=mt,St=0,m=3+(7&d),d>>>=3,p-=3}else{for(wt=mt+7;p<wt;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}d>>>=mt,p-=mt,St=0,m=11+(127&d),d>>>=7,p-=7}if(i.have+m>i.nlen+i.ndist){t.msg="invalid bit length repeat",i.mode=ct;break}for(;m--;)i.lens[i.have++]=St}}if(i.mode===ct)break;if(0===i.lens[256]){t.msg="invalid code -- missing end-of-block",i.mode=ct;break}if(i.lenbits=9,Lt={bits:i.lenbits},Tt=b(T,i.lens,0,i.nlen,i.lencode,0,i.work,Lt),i.lenbits=Lt.bits,Tt){t.msg="invalid literal/lengths set",i.mode=ct;break}if(i.distbits=6,i.distcode=i.distdyn,Lt={bits:i.distbits},Tt=b(L,i.lens,i.nlen,i.ndist,i.distcode,0,i.work,Lt),i.distbits=Lt.bits,Tt){t.msg="invalid distances set",i.mode=ct;break}if(i.mode=et,e===R)break t;case et:i.mode=it;case it:if(l>=6&&h>=258){t.next_out=a,t.avail_out=h,t.next_in=s,t.avail_in=l,i.hold=d,i.bits=p,v(t,g),a=t.next_out,o=t.output,h=t.avail_out,s=t.next_in,n=t.input,l=t.avail_in,d=i.hold,p=i.bits,i.mode===H&&(i.back=-1);break}for(i.back=0;xt=i.lencode[d&(1<<i.lenbits)-1],mt=xt>>>24,Et=xt>>>16&255,yt=65535&xt,!(mt<=p);){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(Et&&0===(240&Et)){for(_t=mt,vt=Et,bt=yt;xt=i.lencode[bt+((d&(1<<_t+vt)-1)>>_t)],mt=xt>>>24,Et=xt>>>16&255,yt=65535&xt,!(_t+mt<=p);){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}d>>>=_t,p-=_t,i.back+=_t}if(d>>>=mt,p-=mt,i.back+=mt,i.length=yt,0===Et){i.mode=at;break}if(32&Et){i.back=-1,i.mode=H;break}if(64&Et){t.msg="invalid literal/length code",i.mode=ct;break}i.extra=15&Et,i.mode=rt;case rt:if(i.extra){for(wt=i.extra;p<wt;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}i.length+=d&(1<<i.extra)-1,d>>>=i.extra,p-=i.extra,i.back+=i.extra}i.was=i.length,i.mode=nt;case nt:for(;xt=i.distcode[d&(1<<i.distbits)-1],mt=xt>>>24,Et=xt>>>16&255,yt=65535&xt,!(mt<=p);){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(0===(240&Et)){for(_t=mt,vt=Et,bt=yt;xt=i.distcode[bt+((d&(1<<_t+vt)-1)>>_t)],mt=xt>>>24,Et=xt>>>16&255,yt=65535&xt,!(_t+mt<=p);){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}d>>>=_t,p-=_t,i.back+=_t}if(d>>>=mt,p-=mt,i.back+=mt,64&Et){t.msg="invalid distance code",i.mode=ct;break}i.offset=yt,i.extra=15&Et,i.mode=ot;case ot:if(i.extra){for(wt=i.extra;p<wt;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}i.offset+=d&(1<<i.extra)-1,d>>>=i.extra,p-=i.extra,i.back+=i.extra}if(i.offset>i.dmax){t.msg="invalid distance too far back",i.mode=ct;break}i.mode=st;case st:if(0===h)break t;if(m=g-h,i.offset>m){if(m=i.offset-m,m>i.whave&&i.sane){t.msg="invalid distance too far back",i.mode=ct;break}m>i.wnext?(m-=i.wnext,ft=i.wsize-m):ft=i.wnext-m,m>i.length&&(m=i.length),gt=i.window}else gt=o,ft=a-i.offset,m=i.length;m>h&&(m=h),h-=m,i.length-=m;do o[a++]=gt[ft++];while(--m);0===i.length&&(i.mode=it);break;case at:if(0===h)break t;o[a++]=i.length,h--,i.mode=it;break;case lt:if(i.wrap){for(;p<32;){if(0===l)break t;l--,d|=n[s++]<<p,p+=8}if(g-=h,t.total_out+=g,i.total+=g,g&&(t.adler=i.check=i.flags?_(i.check,o,g,a-g):y(i.check,o,g,a-g)),g=h,(i.flags?d:r(d))!==i.check){t.msg="incorrect data check",i.mode=ct;break}d=0,p=0}i.mode=ht;case ht:if(i.wrap&&i.flags){for(;p<32;){if(0===l)break t;l--,d+=n[s++]<<p,p+=8}if(d!==(4294967295&i.total)){t.msg="incorrect length check",i.mode=ct;break}d=0,p=0}i.mode=ut;case ut:Tt=C;break t;case ct:Tt=O;break t;case dt:return I;case pt:default:return P}return t.next_out=a,t.avail_out=h,t.next_in=s,t.avail_in=l,i.hold=d,i.bits=p,(i.wsize||g!==t.avail_out&&i.mode<ct&&(i.mode<lt||e!==w))&&c(t,t.output,t.next_out,g-t.avail_out)?(i.mode=dt,I):(f-=t.avail_in,g-=t.avail_out,t.total_in+=f,t.total_out+=g,i.total+=g,i.wrap&&g&&(t.adler=i.check=i.flags?_(i.check,o,g,t.next_out-g):y(i.check,o,g,t.next_out-g)),t.data_type=i.bits+(i.last?64:0)+(i.mode===H?128:0)+(i.mode===et||i.mode===J?256:0),(0===f&&0===g||e===w)&&Tt===M&&(Tt=N),Tt)}function p(t){if(!t||!t.state)return P;var e=t.state;return e.window&&(e.window=null),t.state=null,M}function f(t,e){var i;return t&&t.state?(i=t.state,0===(2&i.wrap)?P:(i.head=e,e.done=!1,M)):P}var g,m,E=t("../utils/common"),y=t("./adler32"),_=t("./crc32"),v=t("./inffast"),b=t("./inftrees"),S=0,T=1,L=2,w=4,x=5,R=6,M=0,C=1,A=2,P=-2,O=-3,I=-4,N=-5,D=8,V=1,k=2,F=3,G=4,W=5,B=6,U=7,j=8,K=9,z=10,q=11,H=12,Y=13,X=14,J=15,Z=16,Q=17,$=18,tt=19,et=20,it=21,rt=22,nt=23,ot=24,st=25,at=26,lt=27,ht=28,ut=29,ct=30,dt=31,pt=32,ft=852,gt=592,mt=15,Et=mt,yt=!0;i.inflateReset=s,i.inflateReset2=a,i.inflateResetKeep=o,i.inflateInit=h,i.inflateInit2=l,i.inflate=d,i.inflateEnd=p,i.inflateGetHeader=f,i.inflateInfo="pako inflate (from Nodeca project)"},{"../utils/common":27,"./adler32":29,"./crc32":31,"./inffast":34,"./inftrees":36}],36:[function(t,e,i){"use strict";var r=t("../utils/common"),n=15,o=852,s=592,a=0,l=1,h=2,u=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],c=[16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78],d=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0],p=[16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64];e.exports=function(t,e,i,f,g,m,E,y){var _,v,b,S,T,L,w,x,R,M=y.bits,C=0,A=0,P=0,O=0,I=0,N=0,D=0,V=0,k=0,F=0,G=null,W=0,B=new r.Buf16(n+1),U=new r.Buf16(n+1),j=null,K=0;for(C=0;C<=n;C++)B[C]=0;for(A=0;A<f;A++)B[e[i+A]]++;for(I=M,O=n;O>=1&&0===B[O];O--);if(I>O&&(I=O),0===O)return g[m++]=20971520,g[m++]=20971520,y.bits=1,0;for(P=1;P<O&&0===B[P];P++);for(I<P&&(I=P),V=1,C=1;C<=n;C++)if(V<<=1,V-=B[C],V<0)return-1;if(V>0&&(t===a||1!==O))return-1;for(U[1]=0,C=1;C<n;C++)U[C+1]=U[C]+B[C];for(A=0;A<f;A++)0!==e[i+A]&&(E[U[e[i+A]]++]=A);if(t===a?(G=j=E,L=19):t===l?(G=u,W-=257,j=c,K-=257,L=256):(G=d,j=p,L=-1),F=0,A=0,C=P,T=m,N=I,D=0,b=-1,k=1<<I,S=k-1,t===l&&k>o||t===h&&k>s)return 1;for(var z=0;;){z++,w=C-D,E[A]<L?(x=0,R=E[A]):E[A]>L?(x=j[K+E[A]],R=G[W+E[A]]):(x=96,R=0),_=1<<C-D,v=1<<N,P=v;do v-=_,g[T+(F>>D)+v]=w<<24|x<<16|R|0;while(0!==v);for(_=1<<C-1;F&_;)_>>=1;if(0!==_?(F&=_-1,F+=_):F=0,A++,0===--B[C]){if(C===O)break;C=e[i+E[A]]}if(C>I&&(F&S)!==b){for(0===D&&(D=I),T+=P,N=C-D,V=1<<N;N+D<O&&(V-=B[N+D],!(V<=0));)N++,V<<=1;if(k+=1<<N,t===l&&k>o||t===h&&k>s)return 1;b=F&S,g[b]=I<<24|N<<16|T-m|0}}return 0!==F&&(g[T+F]=C-D<<24|64<<16|0),y.bits=I,0}},{"../utils/common":27}],37:[function(t,e,i){"use strict";e.exports={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"}},{}],38:[function(t,e,i){"use strict";function r(t){for(var e=t.length;--e>=0;)t[e]=0}function n(t){return t<256?st[t]:st[256+(t>>>7)]}function o(t,e){t.pending_buf[t.pending++]=255&e,t.pending_buf[t.pending++]=e>>>8&255}function s(t,e,i){t.bi_valid>H-i?(t.bi_buf|=e<<t.bi_valid&65535,o(t,t.bi_buf),t.bi_buf=e>>H-t.bi_valid,t.bi_valid+=i-H):(t.bi_buf|=e<<t.bi_valid&65535,t.bi_valid+=i)}function a(t,e,i){s(t,i[2*e],i[2*e+1])}function l(t,e){var i=0;do i|=1&t,t>>>=1,i<<=1;while(--e>0);return i>>>1}function h(t){16===t.bi_valid?(o(t,t.bi_buf),t.bi_buf=0,t.bi_valid=0):t.bi_valid>=8&&(t.pending_buf[t.pending++]=255&t.bi_buf,t.bi_buf>>=8,t.bi_valid-=8)}function u(t,e){var i,r,n,o,s,a,l=e.dyn_tree,h=e.max_code,u=e.stat_desc.static_tree,c=e.stat_desc.has_stree,d=e.stat_desc.extra_bits,p=e.stat_desc.extra_base,f=e.stat_desc.max_length,g=0;for(o=0;o<=q;o++)t.bl_count[o]=0;for(l[2*t.heap[t.heap_max]+1]=0,i=t.heap_max+1;i<z;i++)r=t.heap[i],o=l[2*l[2*r+1]+1]+1,o>f&&(o=f,g++),l[2*r+1]=o,r>h||(t.bl_count[o]++,s=0,r>=p&&(s=d[r-p]),a=l[2*r],t.opt_len+=a*(o+s),c&&(t.static_len+=a*(u[2*r+1]+s)));if(0!==g){do{for(o=f-1;0===t.bl_count[o];)o--;t.bl_count[o]--,t.bl_count[o+1]+=2,t.bl_count[f]--,g-=2}while(g>0);for(o=f;0!==o;o--)for(r=t.bl_count[o];0!==r;)n=t.heap[--i],n>h||(l[2*n+1]!==o&&(t.opt_len+=(o-l[2*n+1])*l[2*n],l[2*n+1]=o),r--)}}function c(t,e,i){var r,n,o=new Array(q+1),s=0;for(r=1;r<=q;r++)o[r]=s=s+i[r-1]<<1;for(n=0;n<=e;n++){var a=t[2*n+1];0!==a&&(t[2*n]=l(o[a]++,a))}}function d(){var t,e,i,r,n,o=new Array(q+1);for(i=0,r=0;r<W-1;r++)for(lt[r]=i,t=0;t<1<<$[r];t++)at[i++]=r;for(at[i-1]=r,n=0,r=0;r<16;r++)for(ht[r]=n,t=0;t<1<<tt[r];t++)st[n++]=r;for(n>>=7;r<j;r++)for(ht[r]=n<<7,t=0;t<1<<tt[r]-7;t++)st[256+n++]=r;for(e=0;e<=q;e++)o[e]=0;for(t=0;t<=143;)nt[2*t+1]=8,t++,o[8]++;for(;t<=255;)nt[2*t+1]=9,t++,o[9]++;for(;t<=279;)nt[2*t+1]=7,t++,o[7]++;for(;t<=287;)nt[2*t+1]=8,t++,o[8]++;for(c(nt,U+1,o),t=0;t<j;t++)ot[2*t+1]=5,ot[2*t]=l(t,5);ut=new pt(nt,$,B+1,U,q),ct=new pt(ot,tt,0,j,q),dt=new pt(new Array(0),et,0,K,Y)}function p(t){var e;for(e=0;e<U;e++)t.dyn_ltree[2*e]=0;for(e=0;e<j;e++)t.dyn_dtree[2*e]=0;for(e=0;e<K;e++)t.bl_tree[2*e]=0;t.dyn_ltree[2*X]=1,t.opt_len=t.static_len=0,t.last_lit=t.matches=0}function f(t){t.bi_valid>8?o(t,t.bi_buf):t.bi_valid>0&&(t.pending_buf[t.pending++]=t.bi_buf),t.bi_buf=0,t.bi_valid=0}function g(t,e,i,r){f(t),r&&(o(t,i),o(t,~i)),A.arraySet(t.pending_buf,t.window,e,i,t.pending),t.pending+=i}function m(t,e,i,r){var n=2*e,o=2*i;return t[n]<t[o]||t[n]===t[o]&&r[e]<=r[i]}function E(t,e,i){for(var r=t.heap[i],n=i<<1;n<=t.heap_len&&(n<t.heap_len&&m(e,t.heap[n+1],t.heap[n],t.depth)&&n++,!m(e,r,t.heap[n],t.depth));)t.heap[i]=t.heap[n],i=n,n<<=1;t.heap[i]=r}function y(t,e,i){var r,o,l,h,u=0;if(0!==t.last_lit)do r=t.pending_buf[t.d_buf+2*u]<<8|t.pending_buf[t.d_buf+2*u+1],o=t.pending_buf[t.l_buf+u],u++,0===r?a(t,o,e):(l=at[o],a(t,l+B+1,e),h=$[l],0!==h&&(o-=lt[l],s(t,o,h)),r--,l=n(r),a(t,l,i),h=tt[l],0!==h&&(r-=ht[l],s(t,r,h)));while(u<t.last_lit);a(t,X,e)}function _(t,e){var i,r,n,o=e.dyn_tree,s=e.stat_desc.static_tree,a=e.stat_desc.has_stree,l=e.stat_desc.elems,h=-1;for(t.heap_len=0,t.heap_max=z,i=0;i<l;i++)0!==o[2*i]?(t.heap[++t.heap_len]=h=i,t.depth[i]=0):o[2*i+1]=0;for(;t.heap_len<2;)n=t.heap[++t.heap_len]=h<2?++h:0,o[2*n]=1,t.depth[n]=0,t.opt_len--,a&&(t.static_len-=s[2*n+1]);for(e.max_code=h,i=t.heap_len>>1;i>=1;i--)E(t,o,i);n=l;do i=t.heap[1],t.heap[1]=t.heap[t.heap_len--],E(t,o,1),r=t.heap[1],t.heap[--t.heap_max]=i,t.heap[--t.heap_max]=r,o[2*n]=o[2*i]+o[2*r],t.depth[n]=(t.depth[i]>=t.depth[r]?t.depth[i]:t.depth[r])+1,o[2*i+1]=o[2*r+1]=n,t.heap[1]=n++,E(t,o,1);while(t.heap_len>=2);t.heap[--t.heap_max]=t.heap[1],u(t,e),c(o,h,t.bl_count)}function v(t,e,i){var r,n,o=-1,s=e[1],a=0,l=7,h=4;for(0===s&&(l=138,h=3),e[2*(i+1)+1]=65535,r=0;r<=i;r++)n=s,s=e[2*(r+1)+1],++a<l&&n===s||(a<h?t.bl_tree[2*n]+=a:0!==n?(n!==o&&t.bl_tree[2*n]++,t.bl_tree[2*J]++):a<=10?t.bl_tree[2*Z]++:t.bl_tree[2*Q]++,a=0,o=n,0===s?(l=138,h=3):n===s?(l=6,h=3):(l=7,h=4))}function b(t,e,i){var r,n,o=-1,l=e[1],h=0,u=7,c=4;for(0===l&&(u=138,c=3),r=0;r<=i;r++)if(n=l,l=e[2*(r+1)+1],!(++h<u&&n===l)){if(h<c){do a(t,n,t.bl_tree);while(0!==--h)}else 0!==n?(n!==o&&(a(t,n,t.bl_tree),h--),a(t,J,t.bl_tree),s(t,h-3,2)):h<=10?(a(t,Z,t.bl_tree),s(t,h-3,3)):(a(t,Q,t.bl_tree),s(t,h-11,7));h=0,o=n,0===l?(u=138,c=3):n===l?(u=6,c=3):(u=7,c=4)}}function S(t){var e;for(v(t,t.dyn_ltree,t.l_desc.max_code),v(t,t.dyn_dtree,t.d_desc.max_code),_(t,t.bl_desc),e=K-1;e>=3&&0===t.bl_tree[2*it[e]+1];e--);return t.opt_len+=3*(e+1)+5+5+4,e}function T(t,e,i,r){var n;for(s(t,e-257,5),s(t,i-1,5),s(t,r-4,4),n=0;n<r;n++)s(t,t.bl_tree[2*it[n]+1],3);b(t,t.dyn_ltree,e-1),b(t,t.dyn_dtree,i-1)}function L(t){var e,i=4093624447;for(e=0;e<=31;e++,i>>>=1)if(1&i&&0!==t.dyn_ltree[2*e])return O;if(0!==t.dyn_ltree[18]||0!==t.dyn_ltree[20]||0!==t.dyn_ltree[26])return I;for(e=32;e<B;e++)if(0!==t.dyn_ltree[2*e])return I;return O}function w(t){gt||(d(),gt=!0),t.l_desc=new ft(t.dyn_ltree,ut),t.d_desc=new ft(t.dyn_dtree,ct),t.bl_desc=new ft(t.bl_tree,dt),t.bi_buf=0,t.bi_valid=0,p(t)}function x(t,e,i,r){s(t,(D<<1)+(r?1:0),3),g(t,e,i,!0)}function R(t){s(t,V<<1,3),a(t,X,nt),h(t)}function M(t,e,i,r){var n,o,a=0;t.level>0?(t.strm.data_type===N&&(t.strm.data_type=L(t)),_(t,t.l_desc),_(t,t.d_desc),a=S(t),n=t.opt_len+3+7>>>3,o=t.static_len+3+7>>>3,o<=n&&(n=o)):n=o=i+5,i+4<=n&&e!==-1?x(t,e,i,r):t.strategy===P||o===n?(s(t,(V<<1)+(r?1:0),3),y(t,nt,ot)):(s(t,(k<<1)+(r?1:0),3),T(t,t.l_desc.max_code+1,t.d_desc.max_code+1,a+1),y(t,t.dyn_ltree,t.dyn_dtree)),p(t),r&&f(t)}function C(t,e,i){return t.pending_buf[t.d_buf+2*t.last_lit]=e>>>8&255,t.pending_buf[t.d_buf+2*t.last_lit+1]=255&e,t.pending_buf[t.l_buf+t.last_lit]=255&i,t.last_lit++,0===e?t.dyn_ltree[2*i]++:(t.matches++,e--,t.dyn_ltree[2*(at[i]+B+1)]++,t.dyn_dtree[2*n(e)]++),t.last_lit===t.lit_bufsize-1}var A=t("../utils/common"),P=4,O=0,I=1,N=2,D=0,V=1,k=2,F=3,G=258,W=29,B=256,U=B+1+W,j=30,K=19,z=2*U+1,q=15,H=16,Y=7,X=256,J=16,Z=17,Q=18,$=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],tt=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],et=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],it=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],rt=512,nt=new Array(2*(U+2));r(nt);var ot=new Array(2*j);r(ot);var st=new Array(rt);r(st);var at=new Array(G-F+1);r(at);var lt=new Array(W);r(lt);var ht=new Array(j);r(ht);var ut,ct,dt,pt=function(t,e,i,r,n){this.static_tree=t,this.extra_bits=e,this.extra_base=i,this.elems=r,this.max_length=n,this.has_stree=t&&t.length},ft=function(t,e){this.dyn_tree=t,this.max_code=0,this.stat_desc=e},gt=!1;i._tr_init=w,i._tr_stored_block=x,i._tr_flush_block=M,i._tr_tally=C,i._tr_align=R},{"../utils/common":27}],39:[function(t,e,i){"use strict";function r(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0}e.exports=r},{}]},{},[9])(9)}),i("formats/kml/KmlFileCache",[],function(){"use strict";var t=function(){this._rootFile=null,this._map={}};return t.prototype.retrieve=function(t){if(0==t.indexOf("#")||null==t||0!=t.indexOf("http"))return this._rootFile;var e=t;return t.indexOf("#")!=-1&&(e=t.substr(0,t.indexOf("#")-1)),this._map[e]?this._map[e]:null},t.prototype.add=function(t,e){this._rootFile?this._map[t]=e:this._rootFile=e},t}),i("formats/kml/styles/KmlStyleSelector",["./../KmlObject"],function(t){"use strict";var e=function(e){t.call(this,e)};return e.prototype=Object.create(t.prototype),e.prototype.getTagNames=function(){return["Style","StyleMap"]},e}),i("formats/kml/styles/KmlPolyStyle",["../../../util/Color","./KmlColorStyle","./../KmlElements","../util/NodeTransformers"],function(t,e,i,r){"use strict";var n=function(t){e.call(this,t)};return n.prototype=Object.create(e.prototype),Object.defineProperties(n.prototype,{kmlFill:{get:function(){return this._factory.specific(this,{
name:"fill",transformer:r.boolean})}},kmlOutline:{get:function(){return this._factory.specific(this,{name:"outline",transformer:r.boolean})}}}),n.update=function(e,i){e=e||{};var r=i||{};return r._drawInterior=e.kmlFill||!0,r._drawOutline=e.kmlOutline||!1,r._outlineColor=i._outlineColor||t.WHITE,r._interiorColor=e.kmlColor&&t.colorFromKmlHex(e.kmlColor)||t.WHITE,r._colorMode=e.kmlColorMode||"normal",r},n.prototype.getTagNames=function(){return["PolyStyle"]},i.addKey(n.prototype.getTagNames()[0],n),n}),i("formats/kml/KmlLink",["./KmlElements","./KmlObject","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t),this.onChangeListeners=[]};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlHref:{get:function(){return this._factory.specific(this,{name:"href",transformer:i.string})}},kmlRefreshMode:{get:function(){return this._factory.specific(this,{name:"refreshMode",transformer:i.string})}},kmlRefreshInterval:{get:function(){return this._factory.specific(this,{name:"refreshInterval",transformer:i.number})}},kmlViewRefreshMode:{get:function(){return this._factory.specific(this,{name:"viewRefreshMode",transformer:i.string})}},kmlViewRefreshTime:{get:function(){return this._factory.specific(this,{name:"viewRefreshTime",transformer:i.number})}},kmlViewBoundScale:{get:function(){return this._factory.specific(this,{name:"viewBoundScale",transformer:i.number})}},kmlViewFormat:{get:function(){return this._factory.specific(this,{name:"viewFormat",transformer:i.string})}},kmlHttpQuery:{get:function(){return this._factory.specific(this,{name:"httpQuery",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["Link"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlIcon",["./KmlLink","./KmlElements","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(e){t.call(this,e)};return r.prototype=Object.create(t.prototype),Object.defineProperties(r.prototype,{kmlX:{get:function(){return this._factory.specific(this,{name:"gx:x",transformer:i.number})}},kmlY:{get:function(){return this._factory.specific(this,{name:"gx:y",transformer:i.number})}},kmlW:{get:function(){return this._factory.specific(this,{name:"gx:w",transformer:i.number})}},kmlH:{get:function(){return this._factory.specific(this,{name:"gx:h",transformer:i.number})}}}),r.prototype.getTagNames=function(){return["Icon"]},e.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/styles/KmlIconStyle",["./KmlColorStyle","./../KmlElements","../KmlIcon","../util/NodeTransformers"],function(t,e,i,r){"use strict";var n=function(e){t.call(this,e)};return n.prototype=Object.create(t.prototype),Object.defineProperties(n.prototype,{kmlScale:{get:function(){return this._factory.specific(this,{name:"scale",transformer:r.number})}},kmlHeading:{get:function(){return this._factory.specific(this,{name:"heading",transformer:r.number})}},kmlIcon:{get:function(){return this._factory.any(this,{name:i.prototype.getTagNames()})}},kmlHotSpotX:{get:function(){return this._factory.specific(this,{name:"hotSpot",transformer:r.attribute("x")})}},kmlHotSpotY:{get:function(){return this._factory.specific(this,{name:"hotSpot",transformer:r.attribute("y")})}},kmlHotSpotXUnits:{get:function(){return this._factory.specific(this,{name:"hotSpot",transformer:r.attribute("xunits")})}},kmlHotSpotYUnits:{get:function(){return this._factory.specific(this,{name:"hotSpot",transformer:r.attribute("yunits")})}}}),n.update=function(t,e){t=t||{};var i=e||{};return i._imageScale=t.kmlScale||1,i._imageSource=t.kmlIcon&&t.kmlIcon.kmlHref||null,i},n.prototype.getTagNames=function(){return["IconStyle"]},e.addKey(n.prototype.getTagNames()[0],n),n}),i("formats/kml/styles/KmlLabelStyle",["./KmlColorStyle","../KmlElements","../util/NodeTransformers"],function(t,e,i){"use strict";var r=function(e){t.call(this,e)};return r.prototype=Object.create(t.prototype),Object.defineProperties(r.prototype,{kmlScale:{get:function(){return this._factory.specific(this,{name:"scale",transformer:i.number})}}}),r.update=function(){},r.prototype.getTagNames=function(){return["LabelStyle"]},e.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/styles/KmlLineStyle",["../../../util/Color","./KmlColorStyle","./../KmlElements","../util/NodeTransformers"],function(t,e,i,r){"use strict";var n=function(t){e.call(this,t)};return n.prototype=Object.create(e.prototype),Object.defineProperties(n.prototype,{kmlWidth:{get:function(){return this._factory.specific(this,{name:"width",transformer:r.number})}},kmlOuterColor:{get:function(){return this._factory.specific(this,{name:"gx:outerColor",transformer:r.string})}},kmlOuterWidth:{get:function(){return this._factory.specific(this,{name:"gx:outerWidth",transformer:r.number})}},kmlPhysicalWidth:{get:function(){return this._factory.specific(this,{name:"gx:physicalWidth",transformer:r.number})}},kmlLabelVisibility:{get:function(){return this._factory.specific(this,{name:"gx:labelVisibility",transformer:r.boolean})}}}),n.update=function(e,i){var r=i||{};return e=e||{},r._outlineColor=e.kmlColor&&t.colorFromKmlHex(e.kmlColor)||t.WHITE,r._outlineWidth=e.kmlWidth||10,r},n.prototype.getTagNames=function(){return["LineStyle"]},i.addKey(n.prototype.getTagNames()[0],n),n}),i("formats/kml/styles/KmlListStyle",["../util/ItemIcon","../KmlElements","./KmlSubStyle","../util/NodeTransformers"],function(t,e,i,r){"use strict";var n=function(t){i.call(this,t)};return n.prototype=Object.create(i.prototype),Object.defineProperties(n.prototype,{kmlBgColor:{get:function(){return this._factory.specific(this,{name:"bgColor",transformer:r.string})}},kmlListItemType:{get:function(){return this._factory.specific(this,{name:"listItemType",transformer:r.string})}},kmlItemIcon:{get:function(){return this._factory.any(this,{name:t.prototype.getTagNames()})}}}),n.update=function(t){},n.prototype.getTagNames=function(){return["ListStyle"]},e.addKey(n.prototype.getTagNames()[0],n),n}),i("formats/kml/styles/KmlStyle",["../../../util/Color","../../../util/Font","./KmlStyleSelector","./../KmlElements","./KmlPolyStyle","./KmlIconStyle","./KmlLabelStyle","./KmlLineStyle","./KmlListStyle","./KmlBalloonStyle","../../../util/Offset","../../../util/Promise","../../../shapes/ShapeAttributes","../../../shapes/TextAttributes"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p){"use strict";var f=function(t){i.call(this,t)};return f.prototype=Object.create(i.prototype),Object.defineProperties(f.prototype,{kmlIconStyle:{get:function(){return this._factory.any(this,{name:o.prototype.getTagNames()})}},kmlLabelStyle:{get:function(){return this._factory.any(this,{name:s.prototype.getTagNames()})}},kmlLineStyle:{get:function(){return this._factory.any(this,{name:a.prototype.getTagNames()})}},kmlPolyStyle:{get:function(){return this._factory.any(this,{name:n.prototype.getTagNames()})}},kmlBalloonStyle:{get:function(){return this._factory.any(this,{name:h.prototype.getTagNames()})}},kmlListStyle:{get:function(){return this._factory.any(this,{name:l.prototype.getTagNames()})}}}),f.prototype.generate=function(t){t=t||{};var e=this||{};return e.kmlIconStyle&&o.update(e.kmlIconStyle,t),e.kmlListStyle&&l.update(e.kmlListStyle,t),e.kmlBalloonStyle&&h.update(e.kmlBalloonStyle,t),e.kmlLabelStyle&&s.update(e.kmlLabelStyle,t),e.kmlPolyStyle&&n.update(e.kmlPolyStyle,t),e.kmlLineStyle&&a.update(e.kmlLineStyle,t),t},f.prototype.getStyle=function(){var t=this;return new c(function(e){window.setTimeout(function(){e(t)},0)})},f.prototype.getTagNames=function(){return["Style"]},r.addKey(f.prototype.getTagNames()[0],f),f.placemarkAttributes=function(e){return e=e||{},e._imageColor=e._imageColor||new t(1,1,1,1),e._imageOffset=e._imageOffset||new u(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,.5),e._imageScale=e._imageScale||1,e._imageSource=e._imageSource||null,e._depthTest=e._depthTest||!0,e._labelAttributes=e._labelAttributes||new p(f.textAttributes()),e._drawLeaderLine=e._drawLeaderLine||!1,e._leaderLineAttributes=e._leaderLineAttributes||new d(f.shapeAttributes()),e},f.textAttributes=function(i){return i=i||{},i._color=i._color||new t(1,1,1,1),i._font=i._font||new e(14),i._offset=i._offset||new u(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,0),i._scale=i._scale||1,i._depthTest=i._depthTest||!1,i},f.shapeAttributes=function(e){return e=e||{},e._drawInterior=e._drawInterior||!0,e._drawOutline=e._drawOutline||!0,e._enableLighting=e._enableLighting||!1,e._interiorColor=e._interiorColor||t.WHITE,e._outlineColor=e._outlineColor||t.RED,e._outlineWidth=e._outlineWidth||1,e._outlineStippleFactor=e._outlineStippleFactor||0,e._outlineStipplePattern=e._outlineStipplePattern||61680,e._imageSource=e._imageSource||null,e._depthTest=e._depthTest||!0,e._drawVerticals=e._drawVerticals||!1,e._applyLighting=e._applyLighting||!1,e},f}),i("formats/kml/util/StyleResolver",["../KmlFile","../../../util/Logger"],function(t,e){"use strict";var i=function(t){this._fileCache=t};return i.prototype.handleRemoteStyle=function(t,i,r,n,o){t?this.handleStyleUrl(t,r,n,o):i?this.handleStyleSelector(i,r,n):e.logMessage(e.LEVEL_WARNING,"StyleResolver","handleRemoteStyle","Style was null.")},i.prototype.handleStyleUrl=function(t,e,i,r){r=this.handlePromiseOfFile(t,r),r.then(function(r){r.resolveStyle(t).then(function(t){t.isMap?t.resolve(e,i):e({normal:t,highlight:null})})})},i.prototype.handlePromiseOfFile=function(t,e){return e||(e=this._fileCache.retrieve(t),e||(e=new WorldWind.KmlFile({url:t}),this._fileCache.add(e))),e},i.prototype.handleStyleSelector=function(t,e,i){t.isMap?t.resolve(e,i):window.setTimeout(function(){e({normal:t,highlight:null})},0)},i}),i("formats/kml/util/Pair",["./../KmlElements","../KmlObject","../styles/KmlStyleSelector","./NodeTransformers","../../../util/Promise","../util/StyleResolver"],function(t,e,i,r,n,o){"use strict";var s=function(t){e.call(this,t)};return s.prototype=Object.create(e.prototype),Object.defineProperties(s.prototype,{kmlKey:{get:function(){return this._factory.specific(this,{name:"key",transformer:r.string})}},kmlStyleUrl:{get:function(){return this._factory.specific(this,{name:"styleUrl",transformer:r.string})}},kmlStyleSelector:{get:function(){return this._factory.any(this,{name:i.prototype.getTagNames()})}}}),s.prototype.getTagNames=function(){return["Pair"]},s.prototype.getStyle=function(){var t=this;return new n(function(e,i){window.setTimeout(function(){o.handleRemoteStyle(t.kmlStyleUrl,t.kmlStyleSelector,e,i)},0)})},t.addKey(s.prototype.getTagNames()[0],s),s}),i("formats/kml/styles/KmlStyleMap",["../KmlElements","./KmlSubStyle","../util/Pair","../../../util/Promise"],function(t,e,i,r){"use strict";var n=function(t){e.call(this,t)};return n.prototype=Object.create(e.prototype),Object.defineProperties(n.prototype,{kmlPairs:{get:function(){return this._factory.all(this)}},isMap:{get:function(){return!0}}}),n.prototype.resolve=function(t){var e=this,i={},n=[],o=e.kmlPairs;o.forEach(function(t){var e=t.kmlKey,r=t.getStyle();n.push(r),r.then(function(t){i[e]=t.normal})});var s=r.all(n);s.then(function(){i.normal||(i.normal=null),i.highlight||(i.highlight=null),t(i)})},n.prototype.getTagNames=function(){return["StyleMap"]},t.addKey(n.prototype.getTagNames()[0],n),n}),i("formats/kml/KmlTimeSpan",["./KmlElements","./KmlTimePrimitive","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){t.isTimeSpan=!0,e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlBegin:{get:function(){return this._factory.specific(this,{name:"begin",transformer:i.date})}},kmlEnd:{get:function(){return this._factory.specific(this,{name:"end",transformer:i.date})}}}),r.prototype.getTagNames=function(){return["TimeSpan"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlTimeStamp",["./KmlElements","./KmlTimePrimitive","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){t.isTimeStamp=!0,e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlWhen:{get:function(){return this._factory.specific(this,{name:"when",transformer:i.date})}}}),r.prototype.getTagNames=function(){return["TimeStamp"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/util/RefreshListener",[],function(){var t=function(){this.currentActiveEvents=[]};return t.prototype.addEvent=function(t){var e=this;setTimeout(function(){e.currentActiveEvents.push(t)},t.time)},t.prototype.getActiveEvents=function(){var t=this.currentActiveEvents.slice();return this.currentActiveEvents=[],t},t.Event=function(t,e,i){this.type=t,this.payload=i,this.time=e},t}),i("formats/kml/util/RemoteFile",["../../../error/ArgumentError","../../../util/Logger","../../../util/Promise"],function(t,e,i){"use strict";var r=function(i){if(!i.ajax&&!i.zip)throw new t(e.logMessage(e.LEVEL_SEVERE,"RemoteDocument","constructor","Invalid option for retrieval specified. Use either ajax or zip option."));this.options=i};return r.prototype.get=function(){var i=this.options;if(i.ajax)return this.ajax(i.url,i);if(i.zip)return i.responseType=i.responseType||"arraybuffer",this.ajax(i.url,i);throw new t(e.logMessage(e.LEVEL_SEVERE,"RemoteDocument","constructor","Invalid option for retrieval specified. Use either ajax or zip option."))},r.prototype.ajax=function(t,r){return new i(function(i,n){var o=new XMLHttpRequest;o.open("GET",t,!0),r.responseType&&(o.responseType=r.responseType),o.onreadystatechange=function(){if(4===o.readyState)if(200===o.status){var r=this.responseText;i({text:r,headers:o.getAllResponseHeaders()})}else e.log(e.LEVEL_WARNING,"KmlFile retrieval failed ("+o.statusText+"): "+t)},o.onerror=function(){e.log(e.LEVEL_WARNING,"Remote file retrieval failed: "+t),n()}.bind(this),o.ontimeout=function(){e.log(e.LEVEL_WARNING,"Remote file retrieval timed out: "+t),n()}.bind(this),o.send(null)})},r}),i("util/XmlDocument",["../error/ArgumentError","../util/Logger"],function(t,e){var i=function(t){this._document=t};return i.prototype.dom=function(){if(DOMParser){var i=new DOMParser,r=i.parseFromString(this._document,"text/xml");if(r.getElementsByTagName("parsererror").length||!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"XmlDocument","dom","Invalid XML document. "+r.getElementsByTagName("parsererror")[0].innerHTML));return r}var n=new ActiveXObject("Microsoft.XMLDOM");return n.async=!1,n.loadXML(text),n},i.isValid=function(t){try{return new i(t).dom(),!0}catch(t){return!1}},i}),i("formats/kml/KmlFile",["../../error/ArgumentError","../../util/jszip","./KmlElements","./KmlFileCache","./KmlObject","./styles/KmlStyle","./styles/KmlStyleMap","./KmlTimeSpan","./KmlTimeStamp","../../util/Logger","../../util/Promise","./util/RefreshListener","./util/RemoteFile","./util/StyleResolver","../../util/XmlDocument"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f){"use strict";var g=function(i,o){var s=this;if(!i)throw new t(h.logMessage(h.LEVEL_SEVERE,"KmlFile","constructor","invalidDocumentPassed"));this._controls=o||null,this._fileCache=new r,this._styleResolver=new p(this._fileCache),this._listener=new c,this._headers=null;var a;return a=new u(function(t){var r=s.requestRemote(i);r.then(function(r){var a,l=r.text;if(s._headers=r.headers,i.indexOf(".kmz")==-1)a=l;else{var h=new e;h.load(l),h.files.forEach(function(t){t.endsWith(".kml")&&null==a&&(a=t.asText())})}s._document=new f(a).dom(),n.call(s,{objectNode:s._document.documentElement,controls:o}),window.setTimeout(function(){t(s)},0)})}),this._fileCache.add(i,a),a};return g.prototype=Object.create(n.prototype),Object.defineProperties(g.prototype,{shapes:{get:function(){return this._factory.all(this)}}}),g.prototype.render=function(t,e){var i=this;e=e||{},this.shapes.forEach(function(r){r.render(t,{lastStyle:e.lastStyle||null,lastVisibility:e.lastVisibility||null,currentTimeInterval:e.currentTimeInterval||null,regionInvisible:e.regionInvisible||null,fileCache:i._fileCache,styleResolver:i._styleResolver,listener:i._listener,activeEvents:i._listener.getActiveEvents()})})},g.prototype.requestRemote=function(t){var e={};return e.url=t,t.endsWith&&t.endsWith(".kmz")||t.indexOf(".kmz")!=-1?e.zip=!0:e.ajax=!0,new d(e).get()},g.prototype.resolveStyle=function(t){var e=this,i=t.substring(t.indexOf("#")+1,t.length);return new u(function(t,r){var n;n=e._document.querySelector?e._document.querySelector("*[id='"+i+"']"):e._document.getElementById(i),n&&null!=n||r(),n.nodeName==o.prototype.getTagNames()[0]?t(new o({objectNode:n})):n.nodeName==s.prototype.getTagNames()[0]?t(new s({objectNode:n})):h.logMessage(h.LEVEL_WARNING,"KmlFile","resolveStyle","Style must contain either Style node or StyleMap node.")})},g.prototype.getExpired=function(){var t=new Date(this._headers.getRequestHeader("Expires")),e=new Date;return e.getTime-t.getTime()},g}),i("formats/kml/KmlLatLonAltBox",["./KmlElements","./KmlObject","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlNorth:{get:function(){return this._factory.specific(this,{name:"north",transformer:i.number})}},kmlSouth:{get:function(){return this._factory.specific(this,{name:"south",transformer:i.number})}},kmlEast:{get:function(){return this._factory.specific(this,{name:"east",transformer:i.number})}},kmlWest:{get:function(){return this._factory.specific(this,{name:"west",transformer:i.number})}},kmlMinAltitude:{get:function(){return this._factory.specific(this,{name:"minAltitude",transformer:i.number})}},kmlMaxAltitude:{get:function(){return this._factory.specific(this,{name:"maxAltitude",transformer:i.number})}}}),r.prototype.getTagNames=function(){return["LatLonAltBox"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlLod",["./KmlElements","./KmlObject","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlMinLodPixels:{get:function(){return this._factory.specific(this,{name:"minLodPixels",transformer:i.number})}},kmlMaxLodPixels:{get:function(){return this._factory.specific(this,{name:"maxLodPixels",transformer:i.number})}},kmlMinFadeExtent:{get:function(){return this._factory.specific(this,{name:"minFadeExtent",transformer:i.number})}},kmlMaxFadeExtent:{get:function(){return this._factory.specific(this,{name:"maxFadeExtent",transformer:i.number})}}}),r.prototype.getTagNames=function(){return["Lod"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlRegion",["../../geom/BoundingBox","../../util/Color","./KmlElements","./KmlLatLonAltBox","./KmlLod","./KmlObject","./styles/KmlStyle","./util/NodeTransformers","../../geom/Sector"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(t){o.call(this,t)};return h.prototype=Object.create(o.prototype),Object.defineProperties(h.prototype,{kmlLatLonAltBox:{get:function(){return this._factory.specific(this,{name:r.prototype.getTagNames(),transformer:a.kmlObject})}},kmlLod:{get:function(){return this._factory.specific(this,{name:n.prototype.getTagNames(),transformer:a.kmlObject})}}}),h.prototype.intersectsVisible=function(e){var i=this.kmlLatLonAltBox,r=new t;return r.setToSector(new l(i.kmlSouth,i.kmlNorth,i.kmlWest,i.kmlEast),e.globe,i.kmlMinAltitude,i.kmlMaxAltitude),r.intersectsFrustum(e.navigatorState.frustumInModelCoordinates)&&(!i.kmlMinAltitude||e.eyePosition.altitude>i.kmlMinAltitude)&&(!i.kmlMaxAltitude||e.eyePosition.altitude<i.kmlMaxAltitude)},h.prototype.getTagNames=function(){return["Region"]},i.addKey(h.prototype.getTagNames()[0],h),h}),i("formats/kml/features/KmlFeature",["./../KmlObject","../KmlAbstractView","../KmlFile","../styles/KmlStyleMap","../styles/KmlStyleSelector","../KmlRegion","../KmlTimePrimitive","../util/NodeTransformers","../../../util/Promise"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(e){this.isFeature=e.isFeature=!0,t.call(this,e),this._pStyle=null,this.controlledVisibility=null};return h.prototype=Object.create(t.prototype),Object.defineProperties(h.prototype,{style:{get:function(){return this._pStyle}},kmlName:{get:function(){return this._factory.specific(this,{name:"name",transformer:a.string})}},kmlVisibility:{get:function(){return this._factory.specific(this,{name:"visibility",transformer:a.boolean})}},kmlOpen:{get:function(){return this._factory.specific(this,{name:"open",transformer:a.boolean})}},kmlAddress:{get:function(){return this._factory.specific(this,{name:"address",transformer:a.string})}},kmlPhoneNumber:{get:function(){return this._factory.specific(this,{name:"phoneNumber",transformer:a.string})}},kmlDescription:{get:function(){return this._factory.specific(this,{name:"description",transformer:a.string})}},kmlStyleUrl:{get:function(){return this._factory.specific(this,{name:"styleUrl",transformer:a.string})}},kmlSnippet:{get:function(){return this._factory.specific(this,{name:"Snippet",transformer:a.string})}},kmlAbstractView:{get:function(){return this._factory.any(this,{name:e.prototype.getTagNames()})}},kmlTimePrimitive:{get:function(){return this._factory.any(this,{name:s.prototype.getTagNames()})}},kmlStyleSelector:{get:function(){return this._factory.any(this,{name:n.prototype.getTagNames()})}},kmlRegion:{get:function(){return this._factory.any(this,{name:o.prototype.getTagNames()})}}}),h.prototype.render=function(e,i){t.prototype.render.call(this,e,i),this.solveStyle(e,i),this.solveVisibility(e,i)},h.prototype.solveStyle=function(t,e){this.getStyle(t,e),null!=this.style&&(e.lastStyle=this.style)},h.prototype.solveRegion=function(t){return!this.kmlRegion||this.kmlRegion.intersectsVisible(t)},h.prototype.solveVisibility=function(t,e){var i=e.lastVisibility!==!1,r=this.solveTimeVisibility(t),n=this.solveRegion(t),o=this.kmlVisibility!==!1,s=this.controlledVisibility!==!1;this.enabled=i&&r&&n&&o&&s,e.lastVisibility=this.enabled,this._renderable&&(this._renderable.enabled=this.enabled)},h.prototype.solveTimeVisibility=function(t){var e=this.kmlTimePrimitive&&this.kmlTimePrimitive.timeRange();if(t.currentLayer.currentTimeInterval&&e){var i=t.currentLayer.currentTimeInterval[0],r=t.currentLayer.currentTimeInterval[1];if(e&&(e.from<i||e.from>r||e.to>r))return!1}return!0},h.prototype.getStyle=function(t,e){if(!this._pStyle&&(this.kmlStyleUrl||this.kmlStyleSelector)){var i=this;new l(function(t,r){window.setTimeout(function(){e.styleResolver.handleRemoteStyle(i.kmlStyleUrl,i.kmlStyleSelector,t,r)},0)}).then(function(e){i._pStyle=e,t.redrawRequested=!0})}},h.prototype.getTagNames=function(){return["NetworkLink","Placemark","PhotoOverlay","ScreenOverlay","GroundOverlay","Folder","Document"]},h}),i("formats/kml/features/KmlContainer",["./KmlFeature"],function(t){"use strict";var e=function(e){t.call(this,e)};return e.prototype=Object.create(t.prototype),Object.defineProperties(e.prototype,{kmlShapes:{get:function(){var t=this._factory.all(this);return t.filter(function(t){return t.isFeature})}}}),e.prototype.render=function(e,i){t.prototype.render.call(this,e,i);var r=this;this.kmlShapes.forEach(function(t){t.render(e,{lastStyle:i.lastStyle,lastVisibility:r.enabled,currentTimeInterval:i.currentTimeInterval,regionInvisible:i.regionInvisible,fileCache:i.fileCache,styleResolver:i.styleResolver,listener:i.listener,activeEvents:i.activeEvents})})},e.prototype.getTagNames=function(){return["Folder","Document"]},e}),i("formats/kml/util/Schema",["./../KmlElements","../KmlObject"],function(t,e){"use strict";var i=function(t){e.call(this,t)};return i.prototype=Object.create(e.prototype),i.prototype.getTagNames=function(){return["Schema"]},t.addKey(i.prototype.getTagNames()[0],i),i}),i("formats/kml/features/KmlDocument",["./KmlContainer","../KmlElements","./KmlFeature","../util/Schema"],function(t,e,i,r){"use strict";var n=function(e){t.call(this,e)};return n.prototype=Object.create(t.prototype),Object.defineProperties(n.prototype,{kmlSchemas:{get:function(){var t=this._factory.all(this);return t.filter(function(t){return t instanceof r})}}}),n.prototype.getTagNames=function(){return["Document"]},e.addKey(n.prototype.getTagNames()[0],n),n}),i("formats/kml/features/KmlFolder",["./KmlContainer","./../KmlElements"],function(t,e){"use strict";var i=function(e){t.call(this,e)};return i.prototype=Object.create(t.prototype),i.prototype.getTagNames=function(){return["Folder"]},e.addKey(i.prototype.getTagNames()[0],i),i}),i("formats/kml/geom/KmlGeometry",["../KmlObject"],function(t){"use strict";var e=function(e){t.call(this,e),this._renderable=null};return e.prototype=Object.create(t.prototype),e.prototype.render=function(e,i){t.prototype.render.call(this,e,i),this.enabled=i.lastVisibility},e.prototype.getTagNames=e.getTagNames=function(){return["Point","LinearRing","LineString","MultiGeometry","Polygon"]},e}),i("formats/kml/KmlLatLonBox",["./KmlElements","./KmlObject","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlNorth:{get:function(){return this._factory.specific(this,{name:"north",transformer:i.number})}},kmlSouth:{get:function(){return this._factory.specific(this,{name:"south",transformer:i.number})}},kmlEast:{get:function(){return this._factory.specific(this,{name:"east",transformer:i.number})}},kmlWest:{get:function(){return this._factory.specific(this,{name:"west",transformer:i.number})}},kmlRotation:{get:function(){return this._factory.specific(this,{name:"rotation",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["LatLonBox"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlLatLonQuad",["./KmlElements","./KmlObject","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlCoordinates:{get:function(){return this._factory.specific(this,{name:"coordinates",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["gx:LatLonQuad"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/features/KmlOverlay",["./KmlFeature","./../KmlIcon","../util/NodeTransformers"],function(t,e,i){"use strict";var r=function(e){t.call(this,e)};return r.prototype=Object.create(t.prototype),Object.defineProperties(r.prototype,{kmlColor:{get:function(){return this._factory.specific(this,{name:"color",transformer:i.string})}},kmlDrawOrder:{get:function(){return this._factory.specific(this,{name:"drawOrder",transformer:i.string})}},kmlIcon:{get:function(){return this._factory.any(this,{name:e.prototype.getTagNames()})}}}),r.prototype.getTagNames=function(){return["PhotoOverlay","ScreenOverlay","GroundOverlay"]},r}),i("formats/kml/features/KmlGroundOverlay",["./../KmlElements","./KmlFeature","../KmlLatLonBox","../KmlLatLonQuad","./KmlOverlay","../util/NodeTransformers","../../../geom/Sector","../../../shapes/SurfaceImage"],function(t,e,i,r,n,o,s,a){"use strict";var l=function(t){this.isGroundOverlay=!0,n.call(this,t)};return l.prototype=Object.create(n.prototype),Object.defineProperties(l.prototype,{kmlAltitude:{get:function(){return this._factory.specific(this,{name:"altitude",transformer:o.string})}},kmlAltitudeMode:{get:function(){return this._factory.specific(this,{name:"altitudeMode",transformer:o.string})}},kmlLatLonBox:{get:function(){return this._factory.any(this,{name:i.prototype.getTagNames()})}},kmlLatLonQuad:{get:function(){return this._factory.any(this,{name:r.prototype.getTagNames()})}}}),l.prototype.render=function(t,i){e.prototype.render.call(this,t,i),!this._renderable&&this.enabled&&this.kmlIcon&&this.kmlLatLonBox&&(this._renderable=new a(new s(this.kmlLatLonBox.kmlSouth,this.kmlLatLonBox.kmlNorth,this.kmlLatLonBox.kmlWest,this.kmlLatLonBox.kmlEast),this.kmlIcon.kmlHref),t.redrawRequested=!0),this._renderable&&this._renderable.render(t)},l.prototype.getTagNames=function(){return["GroundOverlay"]},t.addKey(l.prototype.getTagNames()[0],l),l}),i("shapes/Path",["../shapes/AbstractShape","../error/ArgumentError","../shaders/BasicTextureProgram","../geom/BoundingBox","../util/Color","../geom/Location","../util/Logger","../geom/Matrix","../pick/PickedObject","../geom/Position","../shapes/ShapeAttributes","../shapes/SurfacePolyline","../geom/Vec2","../geom/Vec3"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p){"use strict";var f=function(i,r){if(!i)throw new e(s.logMessage(s.LEVEL_SEVERE,"Path","constructor","missingPositions"));t.call(this,r),this._positions=i,this._pathType=WorldWind.GREAT_CIRCLE,this._terrainConformance=10,this._numSubSegments=10,this.referencePosition=this.determineReferencePosition(this._positions),this.scratchPoint=new p(0,0,0)};return f.prototype=Object.create(t.prototype),Object.defineProperties(f.prototype,{positions:{get:function(){return this._positions},set:function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Path","constructor","missingPositions"));this._positions=t,this.referencePosition=this.determineReferencePosition(this._positions),this.reset()}},followTerrain:{get:function(){return this._followTerrain},set:function(t){this._followTerrain=t,this.reset()}},terrainConformance:{get:function(){return this._terrainConformance},set:function(t){this._terrainConformance=t,this.reset()}},numSubSegments:{get:function(){return this._numSubSegments},set:function(t){this._numSubSegments=t>=0?t:0,this.reset()}},pathType:{get:function(){return this._pathType},set:function(t){this._pathType=t,this.reset()}},extrude:{get:function(){return this._extrude},set:function(t){this._extrude=t,this.reset()}}}),f.prototype.determineReferencePosition=function(t){return t.length>0?t[0]:null},f.prototype.mustGenerateGeometry=function(t){return!this.currentData.tessellatedPoints||(this.currentData.drawInterior!==this.activeAttributes.drawInterior||this.currentData.drawVerticals!==this.activeAttributes.drawVerticals||(!this.followTerrain&&this.currentData.numSubSegments!==this.numSubSegments||(!(!this.followTerrain||this.currentData.terrainConformance===this.terrainConformance)||this.altitudeMode!==WorldWind.ABSOLUTE&&this.currentData.isExpired)))},f.prototype.createSurfaceShape=function(){return new c(this.positions,null)},f.prototype.doMakeOrderedRenderable=function(t){if(!this.referencePosition)return null;if(!this.mustGenerateGeometry(t))return this;var e=this.currentData.referencePoint;t.surfacePointForMode(this.referencePosition.latitude,this.referencePosition.longitude,this.referencePosition.altitude,this._altitudeMode,e),this.currentData.transformationMatrix.setToTranslation(e[0],e[1],e[2]);var i=this.makeTessellatedPositions(t);if(i.length<2)return null;var n=this.computeRenderedPath(t,i);return this.currentData.tessellatedPoints=n,this.currentData.drawInterior=this.activeAttributes.drawInterior,this.currentData.drawVerticals=this.activeAttributes.drawVerticals,this.currentData.numSubSegments=this.numSubSegments,this.currentData.terrainConformance=this.terrainConformance,this.resetExpiration(this.currentData),this.currentData.fillVbo=!0,this.currentData.extent||(this.currentData.extent=new r),this.currentData.extent.setToPoints(n),this.currentData.extent.translate(this.currentData.referencePoint),this},f.prototype.makeTessellatedPositions=function(t){var e,i,r,n=[],o=t.navigatorState,s=this.mustDrawVerticals(t),a=new p(0,0,0),l=new p(0,0,0),h=this._positions[0];s&&(this.currentData.verticalIndices=new Int16Array(2*this.positions.length),this.currentData.verticalIndices[0]=0,this.currentData.verticalIndices[1]=1),n.push(h),t.surfacePointForMode(h.latitude,h.longitude,h.altitude,this._altitudeMode,a);for(var u=1,c=this._positions.length;u<c;u++)if(e=this._positions[u],t.surfacePointForMode(e.latitude,e.longitude,e.altitude,this._altitudeMode,l),i=o.eyePoint.distanceTo(a),r=o.pixelSizeAtDistance(i),a.distanceTo(l)<8*r&&this.altitudeMode!==WorldWind.ABSOLUTE?n.push(e):this.makeSegment(t,h,e,a,l,n),h=e,a.copy(l),s){var d=2*(n.length-1);this.currentData.verticalIndices[2*u]=d,
this.currentData.verticalIndices[2*u+1]=d+1}return n},f.prototype.makeSegment=function(t,e,i,r,n,s){var a,l,u,c,d,p,f=t.navigatorState,g=f.eyePoint,m=new o(0,0),E=0;if(this._pathType===WorldWind.LINEAR&&!this._followTerrain)return void(r.equals(n)||s.push(i));if(u=this._pathType===WorldWind.LINEAR?o.linearDistance(e,i):this._pathType===WorldWind.RHUMB_LINE?o.rhumbDistance(e,i):o.greatCircleDistance(e,i),this._altitudeMode!==WorldWind.CLAMP_TO_GROUND&&(E=.5*(e.altitude+i.altitude)),a=u*(t.globe.equatorialRadius+E*t.verticalExaggeration),!(a<=0)){for(l=this._pathType===WorldWind.LINEAR?o.linearAzimuth(e,i):this._pathType===WorldWind.RHUMB_LINE?o.rhumbAzimuth(e,i):o.greatCircleAzimuth(e,i),this.scratchPoint.copy(r),c=0,d=0;c<1&&(d+=this._followTerrain?this._terrainConformance*f.pixelSizeAtDistance(this.scratchPoint.distanceTo(g)):a/this._numSubSegments,!(a<d||a-d<1e-9));)c=d/a,p=c*u,this._pathType===WorldWind.LINEAR?o.linearLocation(e,l,p,m):this._pathType===WorldWind.RHUMB_LINE?o.rhumbLocation(e,l,p,m):o.greatCircleLocation(e,l,p,m),m.altitude=(1-c)*e.altitude+c*i.altitude,s.push(new h(m.latitude,m.longitude,m.altitude)),this._followTerrain&&t.surfacePointForMode(m.latitude,m.longitude,m.altitude,WorldWind.CLAMP_TO_GROUND,this.scratchPoint);s.push(i)}},f.prototype.computeRenderedPath=function(t,e){var i,r,n,o,s=this.mustDrawInterior(t)||this.mustDrawVerticals(t),a=Number.MAX_VALUE,l=t.navigatorState.eyePoint,h=(s?2:1)*e.length,u=new Float32Array(3*h),c=s?6:3,d=new p(0,0,0);i=this._followTerrain&&this.altitudeMode!==WorldWind.CLAMP_TO_GROUND?WorldWind.RELATIVE_TO_GROUND:this.altitudeMode;for(var f=0,g=e.length;f<g;f++)r=e[f],t.surfacePointForMode(r.latitude,r.longitude,r.altitude,i,d),o=d.distanceToSquared(l),o<a&&(a=o),d.subtract(this.currentData.referencePoint),n=c*f,u[n]=d[0],u[n+1]=d[1],u[n+2]=d[2],s&&(t.surfacePointForMode(r.latitude,r.longitude,0,WorldWind.CLAMP_TO_GROUND,d),o=d.distanceToSquared(l),o<a&&(a=o),d.subtract(this.currentData.referencePoint),u[n+3]=d[0],u[n+4]=d[1],u[n+5]=d[2]);return this.currentData.pointBufferHasExtrusionPoints=s,this.currentData.eyeDistance=Math.sqrt(a),u},f.prototype.mustDrawInterior=function(t){return this.activeAttributes.drawInterior&&this._extrude&&this._altitudeMode!==WorldWind.CLAMP_TO_GROUND},f.prototype.mustDrawVerticals=function(t){return this.activeAttributes.drawOutline&&this.activeAttributes.drawVerticals&&this.altitudeMode!==WorldWind.CLAMP_TO_GROUND},f.prototype.doRenderOrdered=function(t){var e,i,r,n,o,s,a=t.currentGlContext,h=t.currentProgram,u=this.currentData,c=u.tessellatedPoints.length/3;if(this.applyMvpMatrix(t),u.vboCacheKey||(u.vboCacheKey=t.gpuResourceCache.generateCacheKey()),e=t.gpuResourceCache.resourceForKey(u.vboCacheKey),e||(e=a.createBuffer(),t.gpuResourceCache.putResource(this.currentData.vboCacheKey,e,4*u.tessellatedPoints.length),u.fillVbo=!0),a.bindBuffer(a.ARRAY_BUFFER,e),u.fillVbo&&(a.bufferData(a.ARRAY_BUFFER,u.tessellatedPoints,a.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1)),h.loadTextureEnabled(a,!1),t.pickingMode&&(n=t.uniquePickColor()),this.mustDrawInterior(t)&&(r=this.activeAttributes.interiorColor,i=r.alpha*t.currentLayer.opacity,i<1&&!t.pickingMode&&a.depthMask(!1),h.loadColor(a,t.pickingMode?n:r),h.loadOpacity(a,t.pickingMode?i>0?1:0:i),a.vertexAttribPointer(h.vertexPointLocation,3,a.FLOAT,!1,0,0),a.drawArrays(a.TRIANGLE_STRIP,0,c)),this.activeAttributes.drawOutline&&((this.mustDrawVerticals(t)&&this.mustDrawInterior(t)||this.altitudeMode===WorldWind.CLAMP_TO_GROUND)&&this.applyMvpMatrixForOutline(t),r=this.activeAttributes.outlineColor,i=r.alpha*t.currentLayer.opacity,i<1&&!t.pickingMode&&a.depthMask(!1),h.loadColor(a,t.pickingMode?n:r),h.loadOpacity(a,t.pickingMode?1:i),a.lineWidth(this.activeAttributes.outlineWidth),this.currentData.pointBufferHasExtrusionPoints?(o=24,s=c/2):(o=12,s=c),a.vertexAttribPointer(h.vertexPointLocation,3,a.FLOAT,!1,o,0),a.drawArrays(a.LINE_STRIP,0,s),this.mustDrawVerticals(t)&&(u.verticalIndicesVboCacheKey||(u.verticalIndicesVboCacheKey=t.gpuResourceCache.generateCacheKey()),e=t.gpuResourceCache.resourceForKey(u.verticalIndicesVboCacheKey),e||(e=a.createBuffer(),t.gpuResourceCache.putResource(u.verticalIndicesVboCacheKey,e,4*u.verticalIndices.length),u.fillVbo=!0),a.bindBuffer(a.ELEMENT_ARRAY_BUFFER,e),u.fillVbo&&(a.bufferData(a.ELEMENT_ARRAY_BUFFER,u.verticalIndices,a.STATIC_DRAW),t.frameStatistics.incrementVboLoadCount(1)),a.vertexAttribPointer(h.vertexPointLocation,3,a.FLOAT,!1,0,0),a.drawElements(a.LINES,u.verticalIndices.length,a.UNSIGNED_SHORT,0))),u.fillVbo=!1,t.pickingMode){var d=new l(n,this.pickDelegate?this.pickDelegate:this,null,t.currentLayer,!1);t.resolvePick(d)}},f.prototype.beginDrawing=function(t){var e=t.currentGlContext;this.mustDrawInterior(t)&&e.disable(e.CULL_FACE),t.findAndBindProgram(i),e.enableVertexAttribArray(t.currentProgram.vertexPointLocation)},f.prototype.endDrawing=function(t){var e=t.currentGlContext;e.disableVertexAttribArray(t.currentProgram.vertexPointLocation),e.depthMask(!0),e.lineWidth(1),e.enable(e.CULL_FACE)},f}),i("formats/kml/geom/KmlLineString",["../../../util/Color","../KmlElements","./KmlGeometry","../styles/KmlStyle","../../../geom/Location","../util/NodeTransformers","../../../shapes/Path","../../../geom/Position","../../../shapes/ShapeAttributes","../../../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h){"use strict";var u=function(t){i.call(this,t),this._style=null};return u.prototype=Object.create(i.prototype),Object.defineProperties(u.prototype,{kmlExtrude:{get:function(){return this._factory.specific(this,{name:"extrude",transformer:o.boolean})||!1}},kmlTessellate:{get:function(){return this._factory.specific(this,{name:"tessellate",transformer:o.boolean})||!1}},kmlAltitudeMode:{get:function(){return this._factory.specific(this,{name:"altitudeMode",transformer:o.string})||WorldWind.ABSOLUTE}},kmlPositions:{get:function(){return this._factory.specific(this,{name:"coordinates",transformer:o.positions})}},kmlCenter:{get:function(){var t=this.kmlPositions,e=0,i=0,r=0;return t.forEach(function(t){e+=t.latitude,i+=t.longitude,r+=t.altitude}),new a(e/this.kmlPositions.length,i/this.kmlPositions.length,r/this.kmlPositions.length)}}}),u.prototype.createPath=function(t){this._renderable=new s(this.prepareLocations(),this.prepareAttributes(t.normal)),this.moveValidProperties()},u.prototype.render=function(t,e){i.prototype.render.call(this,t,e),e.lastStyle&&!this._renderable&&(this.createPath(e.lastStyle),t.redrawRequested=!0),this._renderable&&(this._renderable.enabled=this.enabled,this._renderable.render(t))},u.prototype.prepareAttributes=function(t){var e=t&&t.generate()||{};return e._applyLighting=!0,e._drawOutline=!0,e._drawInterior=!0,e._drawVerticals=this.kmlExtrude||!1,e._outlineStippleFactor=0,e._outlineStipplePattern=61680,e._enableLighting=!0,new l(r.shapeAttributes(e))},u.prototype.prepareLocations=function(){return this.kmlPositions},u.prototype.moveValidProperties=function(){this._renderable.extrude=this.kmlExtrude||!1,this._renderable.altitudeMode=this.kmlAltitudeMode||WorldWind.ABSOLUTE,this._renderable.tesselate=this.kmlTesselate||!1},u.prototype.equals=function(t){if(!t)return!1;var e=h.arrayEquals(t.kmlPositions,this.kmlPositions);return e&&t.kmlExtrude==this.kmlExtrude&&t.kmlTessellate==this.kmlTessellate&&t.kmlAltitudeMode==this.kmlAltitudeMode},u.prototype.getTagNames=function(){return["LineString"]},e.addKey(u.prototype.getTagNames()[0],u),u}),i("formats/kml/geom/KmlLinearRing",["./KmlLineString","../KmlElements"],function(t,e){"use strict";var i=function(e){t.call(this,e)};return i.prototype=Object.create(t.prototype),i.prototype.getTagNames=function(){return["LinearRing"]},e.addKey(i.prototype.getTagNames()[0],i),i}),i("formats/kml/KmlLocation",["./KmlElements","./KmlObject","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlLongitude:{get:function(){return this._factory.specific(this,{name:"longitude",transformer:i.string})}},kmlLatitude:{get:function(){return this._factory.specific(this,{name:"latitude",transformer:i.string})}},kmlAltitude:{get:function(){return this._factory.specific(this,{name:"altitude",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["Location"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/KmlLookAt",["./KmlAbstractView","./KmlElements","./util/NodeTransformers","../../geom/Position"],function(t,e,i,r){"use strict";var n=function(e){t.call(this,e)};return n.prototype=Object.create(t.prototype),Object.defineProperties(n.prototype,{kmlLongitude:{get:function(){return this._factory.specific(this,{name:"longitude",transformer:i.number})}},kmlLatitude:{get:function(){return this._factory.specific(this,{name:"latitude",transformer:i.number})}},kmlAltitude:{get:function(){return this._factory.specific(this,{name:"altitude",transformer:i.number})}},kmlHeading:{get:function(){return this._factory.specific(this,{name:"heading",transformer:i.number})}},kmlTilt:{get:function(){return this._factory.specific(this,{name:"tilt",transformer:i.number})}},kmlRange:{get:function(){return this._factory.specific(this,{name:"range",transformer:i.number})}},kmlAltitudeMode:{get:function(){return this._factory.specific(this,{name:"altitudeMode",transformer:i.string})}}}),n.prototype.update=function(t){if(t.wwd){var e=this.kmlAltitude||4e3;t.wwd.goTo(new r(this.kmlLatitude,this.kmlLongitude,e))}},n.prototype.getTagNames=function(){return["LookAt"]},e.addKey(n.prototype.getTagNames()[0],n),n}),i("formats/kml/geom/KmlMultiGeometry",["./../KmlElements","./KmlGeometry","../../../geom/Position"],function(t,e,i){"use strict";var r=function(t){e.call(this,t),this._style=t.style};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlShapes:{get:function(){return this._factory.all(this)}},kmlCenter:{get:function(){var t=this.kmlShapes.map(function(t){return t.kmlCenter}),e=0,r=0,n=0;return t.forEach(function(t){e+=t.latitude,r+=t.longitude,n+=t.altitude}),new i(e/t.length,r/t.length,n/t.length)}}}),r.prototype.render=function(t){e.prototype.render.call(this,t),this.kmlShapes.forEach(function(e){e.render(t)})},r.prototype.getTagNames=function(){return["MultiGeometry"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/features/KmlNetworkLink",["./../KmlElements","./KmlFeature","../KmlFile","../KmlLink","../util/NodeTransformers","../util/RefreshListener"],function(t,e,i,r,n,o){"use strict";var s="refreshNetworkLinkEvent",a=function(t){e.call(this,t),this.isFeature=!0,this.resolvedFile=null,this.displayed=!1,this.isDownloading=!1};return a.prototype=Object.create(e.prototype),Object.defineProperties(a.prototype,{kmlRefreshVisibility:{get:function(){return this._factory.specific(this,{name:"refreshVisibility",transformer:n.boolean})}},kmlFlyToView:{get:function(){return this._factory.specific(this,{name:"flyToView",transformer:n.boolean})}},kmlLink:{get:function(){return this._factory.any(this,{name:r.prototype.getTagNames()})}}}),a.prototype.getTagNames=function(){return["NetworkLink"]},a.prototype.render=function(t,r){if(e.prototype.render.call(this,t,r),r.lastVisibility||this.displayed){if(!this.isDownloading&&!this.resolvedFile){this.isDownloading=!0;var n=this;new i(n.buildUrl()).then(function(t){n.resolvedFile=t,n.isDownloading=!1,n.fireEvent(r)})}this.resolvedFile&&!this.displayed&&(this.resolvedFile.render(t,r),this.handleRefresh(r))}},a.prototype.buildUrl=function(){return this.kmlLink.kmlHref},a.prototype.handleRefresh=function(t){var e=t.activeEvents;if(e=e.filter(function(t){return t.type==s}),e.length>0){var r=this;new i(r.buildUrl()).then(function(e){r.resolvedFile=e,r.fireEvent(t)})}},a.prototype.fireEvent=function(t){var e=0;if("onInterval"==this.kmlLink.kmlRefreshMode)e=1e3*this.kmlLink.kmlRefreshInterval;else{if("onExpire"!=this.kmlLink.kmlRefreshMode)return;if(!this.resolvedFile)return;e=this.resolvedFile.getExpired()}t.listener.addEvent(new o.Event(s,e,null))},t.addKey(a.prototype.getTagNames()[0],a),a}),i("formats/kml/KmlOrientation",["./KmlElements","./KmlObject","./util/NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlHeading:{get:function(){return this._factory.specific(this,{name:"heading",transformer:i.number})}},kmlTilt:{get:function(){return this._factory.specific(this,{name:"tilt",transformer:i.number})}},kmlRoll:{get:function(){return this._factory.specific(this,{name:"roll",transformer:i.number})}}}),r.prototype.getTagNames=function(){return["Orientation"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/geom/KmlPoint",["../../../util/Color","../KmlElements","./KmlGeometry","../../../geom/Location","../util/NodeTransformers","../../../shapes/Polygon","../../../geom/Position"],function(t,e,i,r,n,o,s){"use strict";var a=function(t){i.call(this,t),this._shape=null};return a.prototype=Object.create(i.prototype),Object.defineProperties(a.prototype,{kmlPosition:{get:function(){var t=this._factory.specific(this,{name:"coordinates",transformer:n.string}).split(",");return new s(t[1],t[0],t[2]||0)}},kmlExtrude:{get:function(){return this._factory.specific(this,{name:"extrude",transformer:n.boolean})}},kmlAltitudeMode:{get:function(){return this._factory.specific(this,{name:"altitudeMode",transformer:n.string})}},kmlCenter:{get:function(){return this.kmlPosition}}}),a.prototype.getTagNames=function(){return["Point"]},e.addKey(a.prototype.getTagNames()[0],a),a}),i("formats/kml/util/ViewVolume",["../KmlElements","../KmlObject","./NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlLeftFov:{get:function(){return this._factory.specific(this,{name:"leftFov",transformer:i.number})}},kmlRightFov:{get:function(){return this._factory.specific(this,{name:"rightFov",transformer:i.number})}},kmlBottomFov:{get:function(){return this._factory.specific(this,{name:"bottomFov",transformer:i.number})}},kmlTopFov:{get:function(){return this._factory.specific(this,{name:"topFov",transformer:i.number})}},kmlNear:{get:function(){return this._factory.specific(this,{name:"near",transformer:i.string})}}}),r.prototype.getTagNames=function(){return["ViewVolume"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("formats/kml/features/KmlPhotoOverlay",["../util/ImagePyramid","./../KmlElements","./KmlOverlay","../geom/KmlPoint","../util/NodeTransformers","../util/ViewVolume"],function(t,e,i,r,n,o){"use strict";var s=function(t){i.call(this,t)};return s.prototype=Object.create(i.prototype),Object.defineProperties(s.prototype,{kmlRotation:{get:function(){return this._factory.specific(this,{name:"rotation",transformer:n.string})}},kmlShape:{get:function(){return this._factory.specific(this,{name:"shape",transformer:n.string})}},kmlPoint:{get:function(){return this._factory.any(this,{name:r.prototype.getTagNames()})}},kmlViewVolume:{get:function(){return this._factory.any(this,{name:o.prototype.getTagNames()})}},kmlImagePyramid:{get:function(){return this._factory.any(this,{name:t.prototype.getTagNames()})}}}),s.prototype.getTagNames=function(){return["PhotoOverlay"]},e.addKey(s.prototype.getTagNames[0],s),s}),i("formats/kml/features/KmlPlacemark",["./../KmlElements","./KmlFeature","../geom/KmlGeometry","../styles/KmlStyle","../KmlTimeSpan","../KmlTimeStamp","../../../shapes/PlacemarkAttributes","../../../shapes/Placemark","../../../util/Color","../../../shapes/ShapeAttributes","../../../shapes/TextAttributes","../../../util/Offset","../../../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h,u,c,d){"use strict";var p=function(t){e.call(this,t)};return p.prototype=Object.create(e.prototype),Object.defineProperties(p.prototype,{kmlGeometry:{get:function(){return this._factory.any(this,{name:i.prototype.getTagNames()})}}}),p.prototype.render=function(t,i){e.prototype.render.call(this,t,i),i=d.clone(i),i.lastStyle&&!this._renderable&&this.kmlGeometry&&(this._renderable=new a(this.kmlGeometry.kmlCenter,!1,this.prepareAttributes(i.lastStyle.normal)),this.moveValidProperties(),t.redrawRequested=!0),this._renderable&&this.kmlGeometry&&(this.kmlGeometry.render(t,i),this._renderable.render(t))},p.prototype.prepareAttributes=function(t){var e=t&&t.generate()||{normal:{},highlight:{}},i=new s(r.placemarkAttributes(e));return i.imageOffset=new c(WorldWind.OFFSET_FRACTION,.3,WorldWind.OFFSET_FRACTION,0),i.imageColor=l.WHITE,i.labelAttributes=new u(r.textAttributes({_offset:new c(WorldWind.OFFSET_FRACTION,.5,WorldWind.OFFSET_FRACTION,1),_color:l.YELLOW})),i.drawLeaderLine=!0,i.leaderLineAttributes=new h(r.shapeAttributes({outlineColor:l.RED})),i},p.prototype.moveValidProperties=function(){this._renderable.label=this.kmlName||"",this._renderable.altitudeMode=this.kmlAltitudeMode||WorldWind.RELATIVE_TO_GROUND,this._renderable.enableLeaderLinePicking=!0},p.prototype.getTagNames=function(){return["Placemark"]},t.addKey(p.prototype.getTagNames()[0],p),p}),i("formats/kml/geom/KmlPolygon",["../../../util/Color","../KmlElements","./KmlGeometry","./KmlLinearRing","../styles/KmlStyle","../../../geom/Location","../util/NodeTransformers","../../../shapes/Polygon","../../../shapes/ShapeAttributes"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(t){i.call(this,t),this.initialized=!1};return h.prototype=Object.create(i.prototype),Object.defineProperties(h.prototype,{kmlExtrude:{get:function(){return this._factory.specific(this,{name:"extrude",transformer:s.boolean})}},kmlTessellate:{get:function(){return this._factory.specific(this,{name:"tessellate",transformer:s.boolean})}},kmlAltitudeMode:{get:function(){return this._factory.specific(this,{name:"altitudeMode",transformer:s.string})}},kmlOuterBoundary:{get:function(){return this._factory.specific(this,{name:"outerBoundaryIs",transformer:s.linearRing})}},kmlInnerBoundary:{get:function(){return this._factory.specific(this,{name:"innerBoundaryIs",transformer:s.linearRing})}},kmlCenter:{get:function(){return this.kmlOuterBoundary.kmlCenter}}}),h.prototype.createPolygon=function(t){this._renderable=new a(this.prepareLocations(),this.prepareAttributes(t.normal)),this.moveValidProperties()},h.prototype.render=function(t,e){i.prototype.render.call(this,t,e),e.lastStyle&&!this._renderable&&(this.createPolygon(e.lastStyle),t.redrawRequested=!0),this._renderable&&(this._renderable.enabled=this.enabled,this._renderable.render(t))},h.prototype.moveValidProperties=function(){this._renderable.extrude=this.kmlExtrude||!0,this._renderable.altitudeMode=this.kmlAltitudeMode||WorldWind.CLAMP_TO_GROUND},h.prototype.prepareAttributes=function(t){var e=t&&t.generate()||{};return e._drawVerticals=this.kmlExtrude||!1,e._applyLighting=!0,e._depthTest=!0,e._outlineStippleFactor=0,e._outlineStipplePattern=61680,e._enableLighting=!0,new l(n.shapeAttributes(e))},h.prototype.prepareLocations=function(){var t=[];return null!=this.kmlInnerBoundary?(t[0]=this.kmlInnerBoundary.kmlPositions,t[1]=this.kmlOuterBoundary.kmlPositions):t=this.kmlOuterBoundary.kmlPositions,t},h.prototype.getStyle=function(){return this._style},h.prototype.getTagNames=function(){return["Polygon"]},e.addKey(h.prototype.getTagNames()[0],h),h}),i("formats/kml/features/KmlScreenOverlay",["./../KmlElements","./KmlFeature","./KmlOverlay","../util/NodeTransformers","../../../util/Offset","../../../shapes/ScreenImage","../../../util/WWUtil"],function(t,e,i,r,n,o,s){"use strict";var a=function(t){i.call(this,t),console.log("Create Screen Overlay",this)};return a.prototype=Object.create(i.prototype),Object.defineProperties(a.prototype,{kmlRotation:{get:function(){return this._factory.specific(this,{name:"rotation",transformer:r.number})}},kmlOverlayXYx:{get:function(){return this._factory.specific(this,{name:"overlayXY",transformer:r.attribute("x"),attribute:"kmlOverlayXYx"})}},kmlOverlayXYy:{get:function(){return this._factory.specific(this,{name:"overlayXY",transformer:r.attribute("y"),attribute:"kmlOverlayXYy"})}},kmlOverlayXYxunits:{get:function(){return this._factory.specific(this,{name:"overlayXY",transformer:r.attribute("xunits"),attribute:"kmlOverlayXYxunits"})}},kmlOverlayXYyunits:{get:function(){return this._factory.specific(this,{name:"overlayXY",transformer:r.attribute("yunits"),attribute:"kmlOverlayXYyunits"})}},kmlScreenXYx:{get:function(){return this._factory.specific(this,{name:"screenXY",transformer:r.attribute("x"),attribute:"kmlScreenXYx"})}},kmlScreenXYy:{get:function(){return this._factory.specific(this,{name:"screenXY",transformer:r.attribute("y"),attribute:"kmlScreenXYy"})}},kmlScreenXYxunits:{get:function(){return this._factory.specific(this,{name:"screenXY",transformer:r.attribute("xunits"),attribute:"kmlScreenXYxunits"})}},kmlScreenXYyunits:{get:function(){return this._factory.specific(this,{name:"screenXY",transformer:r.attribute("yunits"),attribute:"kmlScreenXYyunits"})}},kmlRotationXYx:{get:function(){return this._factory.specific(this,{name:"rotationXY",transformer:r.attribute("x"),attribute:"kmlRotationXYx"})}},kmlRotationXYy:{get:function(){return this._factory.specific(this,{name:"rotationXY",transformer:r.attribute("y"),attribute:"kmlRotationXYy"})}},kmlRotationXYxunits:{get:function(){return this._factory.specific(this,{name:"rotationXY",transformer:r.attribute("xunits"),attribute:"kmlRotationXYxunits"})}},kmlRotationXYyunits:{get:function(){return this._factory.specific(this,{name:"rotationXY",transformer:r.attribute("yunits"),attribute:"kmlRotationXYyunits"})}},kmlSizex:{get:function(){return this._factory.specific(this,{name:"size",transformer:r.attribute("x"),attribute:"kmlSizex"})}},kmlSizey:{get:function(){return this._factory.specific(this,{name:"size",transformer:r.attribute("y"),attribute:"kmlSizey"})}},kmlSizexunits:{get:function(){return this._factory.specific(this,{name:"size",transformer:r.attribute("xunits"),attribute:"kmlSizexunits"})}},kmlSizeyunits:{get:function(){return this._factory.specific(this,{name:"size",transformer:r.attribute("yunits"),attribute:"kmlSizeyunits"})}}}),a.prototype.render=function(t,i){e.prototype.render.call(this,t,i),this._renderable||this.kmlIcon&&(this._renderable=new o(new n(this.kmlScreenXYxunits,this.kmlScreenXYx,this.kmlScreenXYyunits,this.kmlScreenXYy),this.kmlIcon.kmlHref),this._renderable.imageOffset=new n(this.kmlOverlayXYxunits,this.kmlOverlayXYx,this.kmlOverlayXYyunits,this.kmlOverlayXYy),t.redrawRequested=!0),this._renderable&&this._renderable.render(t)},a.prototype.getTagNames=function(){return["ScreenOverlay"]},t.addKey(a.prototype.getTagNames()[0],a),a}),i("formats/kml/features/KmlTour",["./../KmlElements","./KmlFeature"],function(t,e){"use strict";var i=function(t){e.call(this,t)};return i.prototype=Object.create(e.prototype),i.prototype.getTagNames=function(){return["gx:Tour"]},t.addKey(i.prototype.getTagNames()[0],i),i}),i("formats/kml/geom/KmlTrack",["./../KmlElements","./KmlGeometry"],function(t,e){"use strict";var i=function(t){e.call(this,t)};return i.prototype=Object.create(e.prototype),i.prototype.getTagNames=function(){return["gx:Track"]},t.addKey(i.prototype.getTagNames()[0],i),i}),i("layer/LandsatRestLayer",["../error/ArgumentError","../geom/Location","../util/Logger","../geom/Sector","../layer/TiledImageLayer","../util/LevelRowColumnUrlBuilder","../util/WWUtil"],function(t,e,i,r,n,o,s){"use strict";var a=function(t,i,a){var l=s.urlPath(t+"/"+i);n.call(this,r.FULL_SPHERE,new e(36,36),10,"image/png",l,512,512),this.displayName=a,this.pickEnabled=!1,this.urlBuilder=new o(t,i)};return a.prototype=Object.create(n.prototype),a}),i("navigate/Navigator",["../error/ArgumentError","../util/Logger","../geom/Matrix","../navigate/NavigatorState","../geom/Position","../error/UnsupportedOperationError","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a){"use strict";var l=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"Navigator","constructor","missingWorldWindow"));this.worldWindow=i,this.heading=0,this.tilt=0,this.roll=0,this.nearDistance=1,this.farDistance=1e7};return l.prototype.currentState=function(){throw new o(e.logMessage(e.LEVEL_SEVERE,"Navigator","currentState","abstractInvocation"))},l.prototype.currentStateForModelview=function(o){if(!o)throw new t(e.logMessage(e.LEVEL_SEVERE,"Navigator","currentStateForModelview","missingMatrix"));var l,h,u=this.worldWindow.globe,c=a.max(u.equatorialRadius,u.polarRadius),d=o.extractEyePoint(new s(0,0,0)),p=u.computePositionFromPoint(d[0],d[1],d[2],new n(0,0,0)),f=this.worldWindow.viewport,g=this.worldWindow.depthBits,m=i.fromIdentity();return this.farDistance=a.horizonDistanceForGlobeRadius(c,p.altitude),this.farDistance<1e3&&(this.farDistance=1e3),this.nearDistance=a.perspectiveNearDistanceForFarDistance(this.farDistance,10,g),l=p.altitude-u.elevationAtLocation(p.latitude,p.longitude),l>0&&(h=a.perspectiveNearDistance(f.width,f.height,l),this.nearDistance>h&&(this.nearDistance=h)),this.nearDistance<1&&(this.nearDistance=1),m.setToPerspectiveProjection(f.width,f.height,this.nearDistance,this.farDistance),new r(o,m,f,this.heading,this.tilt)},l}),i("gesture/PanRecognizer",["../gesture/GestureRecognizer"],function(t){"use strict";var e=function(e,i){t.call(this,e,i),this.minNumberOfTouches=1,this.maxNumberOfTouches=Number.MAX_VALUE,this.interpretDistance=20};return e.prototype=Object.create(t.prototype),e.prototype.mouseDown=function(t){this.state==WorldWind.POSSIBLE&&(this.state=WorldWind.FAILED)},e.prototype.touchMove=function(t){this.state==WorldWind.POSSIBLE?this.shouldInterpret()&&(this.shouldRecognize()?this.state=WorldWind.BEGAN:this.state=WorldWind.FAILED):this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.CHANGED)},e.prototype.touchEnd=function(t){0==this.touchCount&&(this.state==WorldWind.POSSIBLE?this.state=WorldWind.FAILED:this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.ENDED))},e.prototype.touchCancel=function(t){0==this.touchCount&&(this.state==WorldWind.POSSIBLE?this.state=WorldWind.FAILED:this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.CANCELLED))},e.prototype.prepareToRecognize=function(){this.translationX=0,this.translationY=0},e.prototype.shouldInterpret=function(){var t=this.translationX,e=this.translationY,i=Math.sqrt(t*t+e*e);return i>this.interpretDistance},e.prototype.shouldRecognize=function(){var t=this.touchCount;return 0!=t&&t>=this.minNumberOfTouches&&t<=this.maxNumberOfTouches},e}),i("gesture/PinchRecognizer",["../gesture/GestureRecognizer"],function(t){"use strict";var e=function(e,i){t.call(this,e,i),this._scale=1,this._offsetScale=1,this.referenceDistance=0,this.interpretThreshold=20,this.weight=.4,this.pinchTouches=[]};return e.prototype=Object.create(t.prototype),Object.defineProperties(e.prototype,{scale:{get:function(){return this._scale*this._offsetScale}}}),e.prototype.reset=function(){t.prototype.reset.call(this),this._scale=1,this._offsetScale=1,this.referenceDistance=0,this.pinchTouches=[]},e.prototype.mouseDown=function(t){this.state==WorldWind.POSSIBLE&&(this.state=WorldWind.FAILED)},e.prototype.touchStart=function(t){this.pinchTouches.length<2&&2==this.pinchTouches.push(t)&&(this.referenceDistance=this.currentPinchDistance(),this._offsetScale*=this._scale,this._scale=1)},e.prototype.touchMove=function(t){if(2==this.pinchTouches.length)if(this.state==WorldWind.POSSIBLE)this.shouldRecognize()&&(this.state=WorldWind.BEGAN);else if(this.state==WorldWind.BEGAN||this.state==WorldWind.CHANGED){var e=this.currentPinchDistance(),i=Math.abs(e/this.referenceDistance),r=this.weight;this._scale=this._scale*(1-r)+i*r,this.state=WorldWind.CHANGED}},e.prototype.touchEnd=function(t){var e=this.pinchTouches.indexOf(t);e!=-1&&this.pinchTouches.splice(e,1),0==this.touchCount&&(this.state==WorldWind.POSSIBLE?this.state=WorldWind.FAILED:this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.ENDED))},e.prototype.touchCancel=function(t){var e=this.pinchTouches.indexOf(t);e!=-1&&this.pinchTouches.splice(e,1),0==this.touchCount&&(this.state==WorldWind.POSSIBLE?this.state=WorldWind.FAILED:this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.CANCELLED))},e.prototype.prepareToRecognize=function(){this.referenceDistance=this.currentPinchDistance(),this._scale=1},e.prototype.shouldRecognize=function(){var t=this.currentPinchDistance();return Math.abs(t-this.referenceDistance)>this.interpretThreshold},e.prototype.currentPinchDistance=function(){var t=this.pinchTouches[0],e=this.pinchTouches[1],i=t.clientX-e.clientX,r=t.clientY-e.clientY;return Math.sqrt(i*i+r*r)},e}),i("gesture/RotationRecognizer",["../geom/Angle","../gesture/GestureRecognizer"],function(t,e){"use strict";var i=function(t,i){e.call(this,t,i),this._rotation=0,this._offsetRotation=0,this.referenceAngle=0,this.interpretThreshold=20,this.weight=.4,this.rotationTouches=[]};return i.prototype=Object.create(e.prototype),Object.defineProperties(i.prototype,{rotation:{get:function(){return this._rotation+this._offsetRotation}}}),i.prototype.reset=function(){e.prototype.reset.call(this),this._rotation=0,this._offsetRotation=0,this.referenceAngle=0,this.rotationTouches=[]},i.prototype.mouseDown=function(t){this.state==WorldWind.POSSIBLE&&(this.state=WorldWind.FAILED)},i.prototype.touchStart=function(t){this.rotationTouches.length<2&&2==this.rotationTouches.push(t)&&(this.referenceAngle=this.currentTouchAngle(),this._offsetRotation+=this._rotation,this._rotation=0)},i.prototype.touchMove=function(e){if(2==this.rotationTouches.length)if(this.state==WorldWind.POSSIBLE)this.shouldRecognize()&&(this.state=WorldWind.BEGAN);else if(this.state==WorldWind.BEGAN||this.state==WorldWind.CHANGED){var i=this.currentTouchAngle(),r=t.normalizedDegrees(i-this.referenceAngle),n=this.weight;this._rotation=this._rotation*(1-n)+r*n,this.state=WorldWind.CHANGED}},i.prototype.touchEnd=function(t){var e=this.rotationTouches.indexOf(t);e!=-1&&this.rotationTouches.splice(e,1),0==this.touchCount&&(this.state==WorldWind.POSSIBLE?this.state=WorldWind.FAILED:this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.ENDED))},i.prototype.touchCancel=function(t){var e=this.rotationTouches.indexOf(t);e!=-1&&(this.rotationTouches.splice(e,1),0==this.touchCount&&(this.state==WorldWind.POSSIBLE?this.state=WorldWind.FAILED:this.state!=WorldWind.BEGAN&&this.state!=WorldWind.CHANGED||(this.state=WorldWind.CANCELLED)))},i.prototype.prepareToRecognize=function(){this.referenceAngle=this.currentTouchAngle(),this._rotation=0},i.prototype.shouldRecognize=function(){var e=this.currentTouchAngle(),i=t.normalizedDegrees(e-this.referenceAngle);return Math.abs(i)>this.interpretThreshold},i.prototype.currentTouchAngle=function(){var e=this.rotationTouches[0],i=this.rotationTouches[1],r=e.clientX-i.clientX,n=e.clientY-i.clientY;return Math.atan2(n,r)*t.RADIANS_TO_DEGREES},i}),i("gesture/TiltRecognizer",["../gesture/PanRecognizer"],function(t){"use strict";var e=function(e,i){t.call(this,e,i),this.maxTouchDistance=250,this.maxTouchDivergence=50};return e.LEFT=1,e.RIGHT=2,e.UP=4,e.DOWN=8,e.prototype=Object.create(t.prototype),e.prototype.shouldInterpret=function(){for(var t=0,e=this.touchCount;t<e;t++){var i=this.touch(t),r=i.translationX,n=i.translationY,o=Math.sqrt(r*r+n*n);if(o>this.interpretDistance)return!0}return!1},e.prototype.shouldRecognize=function(){var t=this.touchCount;if(t<2)return!1;var i=this.touch(0),r=this.touch(1),n=i.clientX-r.clientX,o=i.clientY-r.clientY,s=Math.sqrt(n*n+o*o);if(s>this.maxTouchDistance)return!1;var a=i.translationX-r.translationX,l=i.translationY-r.translationY,h=Math.sqrt(a*a+l*l);if(h>this.maxTouchDivergence)return!1;var u=e.UP|e.DOWN,c=this.touchDirection(i)&u,d=this.touchDirection(r)&u;return 0!=(c&d)},e.prototype.touchDirection=function(t){var i=t.translationX,r=t.translationY,n=0;
return Math.abs(i)>Math.abs(r)?(n|=i<0?e.LEFT:0,n|=i>0?e.RIGHT:0):(n|=r<0?e.UP:0,n|=r>0?e.DOWN:0),n},e}),i("navigate/LookAtNavigator",["../geom/Angle","../gesture/DragRecognizer","../geom/Frustum","../gesture/GestureRecognizer","../geom/Line","../geom/Location","../util/Logger","../geom/Matrix","../navigate/Navigator","../gesture/PanRecognizer","../gesture/PinchRecognizer","../geom/Position","../gesture/RotationRecognizer","../gesture/TiltRecognizer","../geom/Vec2","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m){"use strict";var E=function(t){function i(t){t.preventDefault()}l.call(this,t),t.addEventListener("mousedown",i),t.addEventListener("touchstart",i),t.addEventListener("contextmenu",i),t.addEventListener("wheel",i),window.PointerEvent&&t.canvas.style.setProperty("touch-action","none"),this.lookAtLocation=new o(30,-110),this.range=1e7,this.enable2DLimits=!0;var r=this;this.primaryDragRecognizer=new e(t,function(t){r.handlePanOrDrag(t)}),this.secondaryDragRecognizer=new e(t,function(t){r.handleSecondaryDrag(t)}),this.secondaryDragRecognizer.button=2,this.panRecognizer=new h(t,function(t){r.handlePanOrDrag(t)}),this.pinchRecognizer=new u(t,function(t){r.handlePinch(t)}),this.rotationRecognizer=new d(t,function(t){r.handleRotation(t)}),this.tiltRecognizer=new p(t,function(t){r.handleTilt(t)}),t.addEventListener("wheel",function(t){r.handleWheelEvent(t)}),this.panRecognizer.recognizeSimultaneouslyWith(this.pinchRecognizer),this.panRecognizer.recognizeSimultaneouslyWith(this.rotationRecognizer),this.pinchRecognizer.recognizeSimultaneouslyWith(this.rotationRecognizer),this.panRecognizer.requireRecognizerToFail(this.tiltRecognizer),this.pinchRecognizer.requireRecognizerToFail(this.tiltRecognizer),this.rotationRecognizer.requireRecognizerToFail(this.tiltRecognizer),this.beginPoint=new f(0,0),this.lastPoint=new f(0,0),this.beginHeading=0,this.beginTilt=0,this.beginRange=0,this.lastRotation=0};return E.prototype=Object.create(l.prototype),E.prototype.currentState=function(){this.applyLimits();var t=this.worldWindow.globe,e=new c(this.lookAtLocation.latitude,this.lookAtLocation.longitude,0),i=a.fromIdentity();return i.multiplyByLookAtModelview(e,this.range,this.heading,this.tilt,this.roll,t),this.currentStateForModelview(i)},E.prototype.handlePanOrDrag=function(t){this.worldWindow.globe.is2D()?this.handlePanOrDrag2D(t):this.handlePanOrDrag3D(t)},E.prototype.handlePanOrDrag3D=function(e){var i=e.state,r=e.translationX,n=e.translationY;if(i==WorldWind.BEGAN)this.lastPoint.set(0,0);else if(i==WorldWind.CHANGED){var o=this.worldWindow.canvas,s=this.worldWindow.globe,a=m.max(s.equatorialRadius,s.polarRadius),l=m.max(1,this.range),h=m.perspectivePixelSize(o.clientWidth,o.clientHeight,l),u=(n-this.lastPoint[1])*h,c=-(r-this.lastPoint[0])*h,d=u/a*t.RADIANS_TO_DEGREES,p=c/a*t.RADIANS_TO_DEGREES,f=Math.sin(this.heading*t.DEGREES_TO_RADIANS),g=Math.cos(this.heading*t.DEGREES_TO_RADIANS);this.lookAtLocation.latitude+=d*g-p*f,this.lookAtLocation.longitude+=d*f+p*g,this.lastPoint.set(r,n),this.applyLimits(),this.worldWindow.redraw()}},E.prototype.handlePanOrDrag2D=function(t){var e=t.state,i=t.clientX,r=t.clientY,n=t.translationX,o=t.translationY;if(e==WorldWind.BEGAN)this.beginPoint.set(i,r),this.lastPoint.set(i,r);else if(e==WorldWind.CHANGED){var s=this.lastPoint[0],l=this.lastPoint[1],h=this.beginPoint[0]+n,u=this.beginPoint[1]+o;this.lastPoint.set(h,u);var c=this.currentState(),d=this.worldWindow.globe,p=c.rayFromScreenPoint(this.worldWindow.canvasCoordinates(s,l)),f=new g(0,0,0),m=new g(0,0,0),E=new g(0,0,0);if(!d.intersectsLine(p,f))return;if(p=c.rayFromScreenPoint(this.worldWindow.canvasCoordinates(h,u)),!d.intersectsLine(p,m))return;var y=a.fromIdentity();if(y.copy(c.modelview),y.multiplyByTranslation(m[0]-f[0],m[1]-f[1],m[2]-f[2]),y.extractEyePoint(p.origin),y.extractForwardVector(p.direction),!d.intersectsLine(p,E))return;var _=y.extractViewingParameters(E,this.roll,d,{});this.lookAtLocation.copy(_.origin),this.range=_.range,this.heading=_.heading,this.tilt=_.tilt,this.roll=_.roll,this.applyLimits(),this.worldWindow.redraw()}},E.prototype.handleSecondaryDrag=function(t){var e=t.state,i=t.translationX,r=t.translationY;if(e==WorldWind.BEGAN)this.beginHeading=this.heading,this.beginTilt=this.tilt;else if(e==WorldWind.CHANGED){var n=180*i/this.worldWindow.canvas.clientWidth,o=90*r/this.worldWindow.canvas.clientHeight;this.heading=this.beginHeading+n,this.tilt=this.beginTilt+o,this.applyLimits(),this.worldWindow.redraw()}},E.prototype.handlePinch=function(t){var e=t.state,i=t.scale;e==WorldWind.BEGAN?this.beginRange=this.range:e==WorldWind.CHANGED&&0!=i&&(this.range=this.beginRange/i,this.applyLimits(),this.worldWindow.redraw())},E.prototype.handleRotation=function(t){var e=t.state,i=t.rotation;e==WorldWind.BEGAN?this.lastRotation=0:e==WorldWind.CHANGED&&(this.heading-=i-this.lastRotation,this.lastRotation=i,this.applyLimits(),this.worldWindow.redraw())},E.prototype.handleTilt=function(t){var e=t.state,i=t.translationY;if(e==WorldWind.BEGAN)this.beginTilt=this.tilt;else if(e==WorldWind.CHANGED){var r=-90*i/this.worldWindow.canvas.clientHeight;this.tilt=this.beginTilt+r,this.applyLimits(),this.worldWindow.redraw()}},E.prototype.handleWheelEvent=function(t){var e;t.deltaMode==WheelEvent.DOM_DELTA_PIXEL?e=t.deltaY:t.deltaMode==WheelEvent.DOM_DELTA_LINE?e=40*t.deltaY:t.deltaMode==WheelEvent.DOM_DELTA_PAGE&&(e=400*t.deltaY);var i=1+e/1e3;this.range*=i,this.applyLimits(),this.worldWindow.redraw()},E.prototype.applyLimits=function(){if(this.lookAtLocation.latitude=m.clamp(this.lookAtLocation.latitude,-90,90),this.lookAtLocation.longitude=t.normalizedDegreesLongitude(this.lookAtLocation.longitude),this.range=m.clamp(this.range,1,Number.MAX_VALUE),this.heading=t.normalizedDegrees(this.heading),this.tilt=m.clamp(this.tilt,0,90),this.roll=t.normalizedDegrees(this.roll),this.worldWindow.globe.is2D()&&this.enable2DLimits){var e=2*Math.PI*this.worldWindow.globe.equatorialRadius;this.range=m.clamp(this.range,1,e),this.tilt=0}},E}),i("cache/MemoryCacheListener",["../util/Logger","../error/UnsupportedOperationError"],function(t,e){"use strict";var i=function(){};return i.prototype.entryRemoved=function(i,r){throw new e(t.logMessage(t.LEVEL_SEVERE,"MemoryCacheListener","entryRemoved","abstractInvocation"))},i.prototype.removalError=function(i,r,n){throw new e(t.logMessage(t.LEVEL_SEVERE,"MemoryCacheListener","removalError","abstractInvocation"))},i}),i("util/NominatimGeocoder",["../util/Logger"],function(t){"use strict";var e=function(){this.service="http://open.mapquestapi.com/nominatim/v1/search/"};return e.prototype.lookup=function(t,e,i){var r=this.service+t.replace(" ","%20")+"?format=json",n=new XMLHttpRequest,o=this;r+="&key="+(i||"lUvVRchXGGDh5Xwk3oidrXeIDAAevOUS"),n.open("GET",r,!0),n.onreadystatechange=function(){if(4===n.readyState&&200===n.status){var t=JSON.parse(n.responseText);e(o,t)}},n.send(null)},e}),i("layer/OpenStreetMapImageLayer",["../geom/Angle","../util/Color","../geom/Location","../geom/Sector","../layer/MercatorTiledImageLayer"],function(t,e,i,r,n){"use strict";var o=function(t){this.imageSize=256,t=t||"Open Street Map",n.call(this,new r(-85.05,85.05,-180,180),new i(85.05,180),19,"image/png",t,this.imageSize,this.imageSize),this.displayName=t,this.pickEnabled=!1,this.destCanvas=document.createElement("canvas"),this.destContext=this.destCanvas.getContext("2d"),this.urlBuilder={urlForTile:function(t,e){return"http://otile1.mqcdn.com/tiles/1.0.0/osm/"+(t.level.levelNumber+1)+"/"+t.column+"/"+t.row+".png"}}};return o.prototype=Object.create(n.prototype),o.prototype.doRender=function(t){n.prototype.doRender.call(this,t),this.inCurrentFrame&&(t.screenCreditController.addStringCredit("©OpenStreetMap",e.DARK_GRAY),t.screenCreditController.addStringCredit("Tiles Courtesy of MapQuest",e.DARK_GRAY))},o.prototype.createTopLevelTiles=function(t){this.topLevelTiles=[],this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),0,0)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),0,1)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),1,0)),this.topLevelTiles.push(this.createTile(null,this.levels.firstLevel(),1,1))},o.prototype.mapSizeForLevel=function(t){return 256<<t+1},o}),i("projections/ProjectionGnomonic",["../geom/Angle","../error/ArgumentError","../projections/GeographicProjection","../util/Logger","../geom/Sector","../util/WWMath"],function(t,e,i,r,n,o){"use strict";var s=function(t){this.north=!("South"===t);var e=this.north?new n(30,90,-180,180):new n(-90,-30,-180,180);i.call(this,"Polar Gnomonic",!1,e),this._pole=t,this.displayName=this.north?"North Gnomonic":"South Gnomonic",this._stateKey="projection polar gnomonic "+this._pole+" "};return s.prototype=Object.create(i.prototype),Object.defineProperties(s.prototype,{pole:{get:function(){return this._pole},set:function(t){this._pole=t,this.north=!("South"===this._pole),this.projectionLimits=this.north?new n(30,90,-180,180):new n(-90,-30,-180,180),this._stateKey="projection polar gnomonic "+this._pole+" "}},stateKey:{get:function(){return this._stateKey}}}),s.prototype.geographicToCartesian=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","geographicToCartesian","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","geographicToCartesian","missingResult"));if(this.north&&90===n||!this.north&&n===-90)l[0]=0,l[1]=0,l[2]=s;else{var h=this.north?1:-1,u=i.equatorialRadius/Math.tan(n*t.DEGREES_TO_RADIANS);l[0]=u*Math.sin(o*t.DEGREES_TO_RADIANS)*h,l[1]=u*-Math.cos(o*t.DEGREES_TO_RADIANS),l[2]=s}return l},s.prototype.geographicToCartesianGrid=function(i,n,s,a,l,h,u,c){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","geographicToCartesianGrid","missingGlobe"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","geographicToCartesianGrid","missingSector"));if(!l||l.length<s*a)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","geographicToCartesianGrid","The specified elevations array is null, undefined or insufficient length"));if(!c)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","geographicToCartesianGrid","missingResult"));var d,p,f,g,m,E,y=n.minLatitude*t.DEGREES_TO_RADIANS,_=n.maxLatitude*t.DEGREES_TO_RADIANS,v=n.minLongitude*t.DEGREES_TO_RADIANS,b=n.maxLongitude*t.DEGREES_TO_RADIANS,S=(_-y)/(s>1?s-1:1),T=(b-v)/(a>1?a-1:1),L=this.projectionLimits.minLatitude*t.DEGREES_TO_RADIANS,w=this.projectionLimits.maxLatitude*t.DEGREES_TO_RADIANS,x=this.north?1:-1,R=h?h:new Vec3(0,0,0),M=0,C=0;for(d=0,f=y;d<s;d++,f+=S)for(d===s-1&&(f=_),m=o.clamp(f,L,w),E=i.equatorialRadius/Math.tan(m),(this.north&&m===Math.PI/2||!this.north&&m===-Math.PI/2)&&(E=0),p=0,g=v;p<a;p++,g+=T)p===a-1&&(g=b),c[C++]=E*Math.sin(g)*x-R[0],c[C++]=E*-Math.cos(g)-R[1],c[C++]=l[M++]-R[2];return c},s.prototype.cartesianToGeographic=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","cartesianToGeographic","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","cartesianToGeographic","missingResult"));var h,u=Math.sqrt(n*n+o*o);return u<1e-4?(l.latitude=this.north?90:-90,l.longitude=0,l.altitude=s):(h=Math.atan2(u,i.equatorialRadius),h>Math.PI&&(h=Math.PI),l.latitude=Math.asin(Math.cos(h)*(this.north?1:-1))*t.RADIANS_TO_DEGREES,l.longitude=Math.atan2(n,o*(this.north?-1:1))*t.RADIANS_TO_DEGREES,l.altitude=s),l},s.prototype.northTangentAtLocation=function(i,n,o,s){if(!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","northTangentAtLocation","missingResult"));return s[0]=Math.sin(o*t.DEGREES_TO_RADIANS)*(this.north?-1:1),s[1]=Math.cos(o*t.DEGREES_TO_RADIANS),s[2]=0,s},s.prototype.northTangentAtPoint=function(t,i,n,o,s,a){if(!a)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionGnomonic","northTangentAtLocation","missingResult"));var l=Math.sqrt(i*i+n*n);return l<1e-4?(a[0]=0,a[1]=1,a[2]=0):(a[0]=i/l*(this.north?-1:1),a[1]=n/l*(this.north?-1:1),a[2]=0),a},s}),i("projections/ProjectionMercator",["../geom/Angle","../error/ArgumentError","../projections/GeographicProjection","../util/Logger","../geom/Sector","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s){"use strict";var a=function(){i.call(this,"Mercator",!0,new n(-78,78,-180,180))};return a.prototype=Object.create(i.prototype),a.prototype.geographicToCartesian=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","geographicToCartesian","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","geographicToCartesian","missingResult"));n>this.projectionLimits.maxLatitude&&(n=this.projectionLimits.maxLatitude),n<this.projectionLimits.minLatitude&&(n=this.projectionLimits.minLatitude);var h=Math.sqrt(i.eccentricitySquared),u=Math.sin(n*t.DEGREES_TO_RADIANS),c=(1+u)/(1-u)*Math.pow((1-h*u)/(1+h*u),h);return l[0]=i.equatorialRadius*o*t.DEGREES_TO_RADIANS+(a?a[0]:0),l[1]=.5*i.equatorialRadius*Math.log(c),l[2]=s,l},Object.defineProperties(a.prototype,{stateKey:{get:function(){return"projection mercator "}}}),a.prototype.geographicToCartesianGrid=function(i,n,a,l,h,u,c,d){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","geographicToCartesianGrid","missingGlobe"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","geographicToCartesianGrid","missingSector"));if(!h||h.length<a*l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","geographicToCartesianGrid","The specified elevations array is null, undefined or insufficient length"));if(!d)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","geographicToCartesianGrid","missingResult"));var p,f,g,m,E,y,_,v,b=i.equatorialRadius,S=Math.sqrt(i.eccentricitySquared),T=n.minLatitude*t.DEGREES_TO_RADIANS,L=n.maxLatitude*t.DEGREES_TO_RADIANS,w=n.minLongitude*t.DEGREES_TO_RADIANS,x=n.maxLongitude*t.DEGREES_TO_RADIANS,R=(L-T)/(a>1?a-1:1),M=(x-w)/(l>1?l-1:1),C=this.projectionLimits.minLatitude*t.DEGREES_TO_RADIANS,A=this.projectionLimits.maxLatitude*t.DEGREES_TO_RADIANS,P=u?u:new o(0,0,0),O=c?c[0]:0,I=0,N=0;for(p=0,g=T;p<a;p++,g+=R)for(p===a-1&&(g=L),E=s.clamp(g,C,A),y=Math.sin(E),_=(1+y)/(1-y)*Math.pow((1-S*y)/(1+S*y),S),v=b*Math.log(_)*.5-P[1],f=0,m=w;f<l;f++,m+=M)f===l-1&&(m=x),d[N++]=b*m-P[0]+O,d[N++]=v,d[N++]=h[I++]-P[2];return d},a.prototype.cartesianToGeographic=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","cartesianToGeographic","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionMercator","cartesianToGeographic","missingResult"));var h=i.eccentricitySquared,u=h*h,c=u*h,d=c*h,p=Math.pow(Math.E,-o/i.equatorialRadius),f=Math.PI/2-2*Math.atan(p),g=h/2+5*u/24+c/12+13*d/360,m=7*u/48+29*c/240+811*d/11520,E=7*c/120+81*d/1120,y=4279*d/161280,_=f-m+y,v=g-3*E,b=2*m-8*y,S=4*E,T=8*y,L=Math.sin(2*f),w=_+L*(v+L*(b+L*(S+T*L)));return l.latitude=w*t.RADIANS_TO_DEGREES,l.longitude=(n-(a?a[0]:0))/i.equatorialRadius*t.RADIANS_TO_DEGREES,l.altitude=s,l},a}),i("projections/ProjectionPolarEquidistant",["../geom/Angle","../error/ArgumentError","../projections/GeographicProjection","../util/Logger"],function(t,e,i,r){"use strict";var n=function(t){i.call(this,"Polar Equidistant",!1,null),this._pole=t,this.north=!("South"===t),this.displayName=this.north?"North Polar":"South Polar",this._stateKey="projection polar equidistant "+this._pole+" "};return n.prototype=Object.create(i.prototype),Object.defineProperties(n.prototype,{pole:{get:function(){return this._pole},set:function(t){this._pole=t,this.north=!("South"===this._pole),this._stateKey="projection polar equidistant "+this._pole+" "}},stateKey:{get:function(){return this._stateKey}}}),n.prototype.geographicToCartesian=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","geographicToCartesian","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","geographicToCartesian","missingResult"));if(this.north&&90===n||!this.north&&n===-90)l[0]=0,l[1]=0,l[2]=s;else{var h=this.north?-1:1,u=i.equatorialRadius*(Math.PI/2+n*t.DEGREES_TO_RADIANS*h);l[0]=u*Math.sin(o*t.DEGREES_TO_RADIANS),l[1]=u*Math.cos(o*t.DEGREES_TO_RADIANS)*h,l[2]=s}return l},n.prototype.geographicToCartesianGrid=function(i,n,o,s,a,l,h,u){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","geographicToCartesianGrid","missingGlobe"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","geographicToCartesianGrid","missingSector"));if(!a||a.length<o*s)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","geographicToCartesianGrid","The specified elevations array is null, undefined or insufficient length"));if(!u)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","geographicToCartesianGrid","missingResult"));var c,d,p,f,g,m=i.equatorialRadius,E=n.minLatitude*t.DEGREES_TO_RADIANS,y=n.maxLatitude*t.DEGREES_TO_RADIANS,_=n.minLongitude*t.DEGREES_TO_RADIANS,v=n.maxLongitude*t.DEGREES_TO_RADIANS,b=(y-E)/(o>1?o-1:1),S=(v-_)/(s>1?s-1:1),T=this.north?-1:1,L=l?l:new Vec3(0,0,0),w=Math.PI/2,x=0,R=0,M=new Float64Array(s),C=new Float64Array(s);for(d=0,f=_;d<s;d++,f+=S)d===s-1&&(f=v),M[d]=Math.cos(f),C[d]=Math.sin(f);for(c=0,p=E;c<o;c++,p+=b)for(c===o-1&&(p=y),g=m*(w+p*T),(this.north&&p===w||!this.north&&p===-w)&&(g=0),d=0;d<s;d++)u[R++]=g*C[d]-L[0],u[R++]=g*M[d]*T-L[1],u[R++]=a[x++]-L[2];return u},n.prototype.cartesianToGeographic=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","cartesianToGeographic","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","cartesianToGeographic","missingResult"));var h,u=Math.sqrt(n*n+o*o);return u<1e-4?(l.latitude=this.north?90:-90,l.longitude=0,l.altitude=s):(h=u/i.equatorialRadius,h>Math.PI&&(h=Math.PI),l.latitude=Math.asin(Math.cos(h)*(this.north?1:-1))*t.RADIANS_TO_DEGREES,l.longitude=Math.atan2(n,o*(this.north?-1:1))*t.RADIANS_TO_DEGREES,l.altitude=s),l},n.prototype.northTangentAtLocation=function(i,n,o,s){if(!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","northTangentAtLocation","missingResult"));return s[0]=Math.sin(o*t.DEGREES_TO_RADIANS)*(this.north?-1:1),s[1]=Math.cos(o*t.DEGREES_TO_RADIANS),s[2]=0,s},n.prototype.northTangentAtPoint=function(t,i,n,o,s,a){if(!a)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","northTangentAtLocation","missingResult"));var l=Math.sqrt(i*i+n*n);return l<1e-4?(a[0]=0,a[1]=1,a[2]=0):(a[0]=i/l*(this.north?-1:1),a[1]=n/l*(this.north?-1:1),a[2]=0),a},n}),i("projections/ProjectionUPS",["../geom/Angle","../error/ArgumentError","../projections/GeographicProjection","../util/Logger","../geom/Sector","../geom/Vec3","../util/WWMath"],function(t,e,i,r,n,o,s){"use strict";var a=function(t){this.north=!("South"===t);var e=this.north?new n(0,90,-180,180):new n(-90,0,-180,180);i.call(this,"Uniform Polar Stereographic",!1,e),this._pole=t,this.displayName=this.north?"North UPS":"South UPS",this._stateKey="projection ups "+this._pole+" "};return a.prototype=Object.create(i.prototype),Object.defineProperties(a.prototype,{pole:{get:function(){return this._pole},set:function(t){this._pole=t,this.north=!("South"===this._pole),this.projectionLimits=this.north?new n(0,90,-180,180):new n(-90,0,-180,180),this._stateKey="projection ups "+this._pole+" "}},stateKey:{get:function(){return this._stateKey}}}),a.prototype.geographicToCartesian=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","geographicToCartesian","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","geographicToCartesian","missingResult"));if(this.north&&90===n||!this.north&&n===-90)l[0]=0,l[1]=0,l[2]=s;else{var h,u,c,d=this.north?1:-1,p=n*t.DEGREES_TO_RADIANS,f=o*t.DEGREES_TO_RADIANS,g=.994,m=Math.sqrt(i.eccentricitySquared),E=Math.sqrt(Math.pow(1+m,1+m)*Math.pow(1-m,1-m));(this.north&&p<0||!this.north&&p>0)&&(p=0),h=Math.sin(p*d),u=Math.sqrt((1-h)/(1+h)*Math.pow((1+m*h)/(1-m*h),m)),c=2*i.equatorialRadius*g*u/E,l[0]=c*Math.sin(f),l[1]=-c*Math.cos(f)*d,l[2]=s}return l},a.prototype.geographicToCartesianGrid=function(i,n,a,l,h,u,c,d){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","geographicToCartesianGrid","missingGlobe"));if(!n)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","geographicToCartesianGrid","missingSector"));if(!h||h.length<a*l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","geographicToCartesianGrid","The specified elevations array is null, undefined or insufficient length"));if(!d)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","geographicToCartesianGrid","missingResult"));var p,f,g,m,E,y,_,v,b=i.equatorialRadius,S=n.minLatitude*t.DEGREES_TO_RADIANS,T=n.maxLatitude*t.DEGREES_TO_RADIANS,L=n.minLongitude*t.DEGREES_TO_RADIANS,w=n.maxLongitude*t.DEGREES_TO_RADIANS,x=(T-S)/(a>1?a-1:1),R=(w-L)/(l>1?l-1:1),M=this.projectionLimits.minLatitude*t.DEGREES_TO_RADIANS,C=this.projectionLimits.maxLatitude*t.DEGREES_TO_RADIANS,A=.994,P=Math.sqrt(i.eccentricitySquared),O=Math.sqrt(Math.pow(1+P,1+P)*Math.pow(1-P,1-P)),I=this.north?1:-1,N=u?u:new o(0,0,0),D=0,V=0;for(p=0,g=S;p<a;p++,g+=x)for(p===a-1&&(g=T),E=s.clamp(g,M,C),y=Math.sin(E*I),_=Math.sqrt((1-y)/(1+y)*Math.pow((1+P*y)/(1-P*y),P)),v=2*b*A*_/O,f=0,m=L;f<l;f++,m+=R)f===l-1&&(m=w),d[V++]=v*Math.sin(m)-N[0],d[V++]=-v*Math.cos(m)*I-N[1],d[V++]=h[D++]-N[2];return d},a.prototype.cartesianToGeographic=function(i,n,o,s,a,l){if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","cartesianToGeographic","missingGlobe"));if(!l)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","cartesianToGeographic","missingResult"));var h=Math.atan2(n,o*(this.north?-1:1)),u=.994,c=Math.sqrt(i.eccentricitySquared),d=Math.sqrt(n*n+o*o),p=Math.sqrt(Math.pow(1+c,1+c)*Math.pow(1-c,1-c)),f=d*p/(2*i.equatorialRadius*u),g=i.eccentricitySquared,m=g*g,E=m*g,y=E*g,_=Math.PI/2-2*Math.atan(f),v=g/2+5*m/24+E/12+13*y/360,b=7*m/48+29*E/240+811*y/11520,S=7*E/120+81*y/1120,T=4279*y/161280,L=_-b+T,w=v-3*S,x=2*b-8*T,R=4*S,M=8*T,C=Math.sin(2*_),A=L+C*(w+C*(x+C*(R+M*C)));return A*=this.north?1:-1,l.latitude=A*t.RADIANS_TO_DEGREES,l.longitude=h*t.RADIANS_TO_DEGREES,l.altitude=s,l},a.prototype.northTangentAtLocation=function(i,n,o,s){if(!s)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionUPS","northTangentAtLocation","missingResult"));return s[0]=Math.sin(o*t.DEGREES_TO_RADIANS)*(this.north?-1:1),s[1]=Math.cos(o*t.DEGREES_TO_RADIANS),s[2]=0,s},a.prototype.northTangentAtPoint=function(t,i,n,o,s,a){if(!a)throw new e(r.logMessage(r.LEVEL_SEVERE,"ProjectionPolarEquidistant","northTangentAtLocation","missingResult"));var l=Math.sqrt(i*i+n*n);return l<1e-4?(a[0]=0,a[1]=1,a[2]=0):(a[0]=i/l*(this.north?-1:1),a[1]=n/l*(this.north?-1:1),a[2]=0),a},a}),i("formats/kml/util/Scale",["./../KmlElements","../KmlObject","./NodeTransformers"],function(t,e,i){"use strict";var r=function(t){e.call(this,t)};return r.prototype=Object.create(e.prototype),Object.defineProperties(r.prototype,{kmlX:{get:function(){return this._factory.specific(this,{name:"x",transformer:i.number})}},kmlY:{get:function(){return this._factory.specific(this,{name:"y",transformer:i.number})}},kmlZ:{get:function(){return this._factory.specific(this,{name:"z",transformer:i.number})}}}),r.prototype.getTagNames=function(){return["Scale"]},t.addKey(r.prototype.getTagNames()[0],r),r}),i("util/ByteBuffer",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(r){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"ByteBuffer","constructor","missingArray"));this.array=r,this.data=new DataView(r),this.position=0,this._order=i.LITTLE_ENDIAN};return i.prototype.getByte=function(){var t=this.data.getUint8(this.position);return this.position+=i.BYTE_SIZE,t},i.prototype.getByteArray=function(t){var e=new Uint8Array(this.array,this.position,t);return this.position+=i.BYTE_SIZE*t,e},i.prototype.getInt16=function(){var t=this.data.getInt16(this.position,this._order);return this.position+=i.INT16_SIZE,t},i.prototype.getInt16Array=function(t){var e=new Int16Array(this.array,this.position,t);return this.position+=i.INT16_SIZE*t,e},i.prototype.getInt32=function(){var t=this.data.getInt32(this.position,this._order);return this.position+=i.INT32_SIZE,t},i.prototype.getInt32Array=function(t){var e=new Int32Array(this.array,this.position,t);return this.position+=i.INT32_SIZE*t,e},i.prototype.getFloat=function(){var t=this.data.getFloat32(this.position,this._order);return this.position+=i.FLOAT_SIZE,t},i.prototype.getFloatArray=function(t){var e=new Float32Array(this.array,this.position,t);return this.position+=i.FLOAT_SIZE*t,e},i.prototype.getDouble=function(){var t=this.data.getFloat64(this.position,this._order);return this.position+=i.DOUBLE_SIZE,t},i.prototype.getDoubleArray=function(t){var e;if(this.position%8!=0){var r=this.array.slice(this.position,this.position+t*i.DOUBLE_SIZE);e=new Float64Array(r)}else e=new Float64Array(this.array,this.position,t);return this.position+=i.DOUBLE_SIZE*t,e},i.prototype.skipBytes=function(t){this.position+=t*i.BYTE_SIZE},i.prototype.skipInt16s=function(t){this.position+=t*i.INT16_SIZE},i.prototype.skipInt32s=function(t){this.position+=t*i.INT32_SIZE},i.prototype.skipFloats=function(t){this.position+=t*i.FLOAT_SIZE},i.prototype.skipDoubles=function(t){this.position+=t*i.DOUBLE_SIZE},i.prototype.seek=function(t){this.position=t},i.prototype.order=function(t){this._order=t},i.prototype.limit=function(){return this.data.byteLength},i.prototype.hasRemaining=function(){return this.position<this.data.byteLength},i.BIG_ENDIAN=!1,i.LITTLE_ENDIAN=!0,i.BYTE_SIZE=1,i.INT16_SIZE=2,i.INT32_SIZE=4,i.FLOAT_SIZE=4,i.DOUBLE_SIZE=8,i}),i("formats/shapefile/DBaseField",["../../error/ArgumentError","../../util/ByteBuffer","../../formats/shapefile/DBaseFile","../../util/Logger"],function(t,e,i,r){"use strict";var n=function(e,i){if(!e)throw new t(r.logMessage(r.LEVEL_SEVERE,"DBaseField","constructor","missingAttributeName"));if(!i)throw new t(r.logMessage(r.LEVEL_SEVERE,"DBaseField","constructor","missingBuffer"));this.name=null,this.type=null,this.typeCode=-1,this.length=-1,this.decimals=-1,this.readFieldDescriptor(e,i)};return n.prototype.getName=function(){return this.name},n.prototype.getType=function(){return this.type},n.prototype.getLength=function(){return this.length},n.prototype.getDecimals=function(){return this.decimals},n.prototype.readFieldDescriptor=function(t,i){i.order(e.LITTLE_ENDIAN);var o=i.position;if(this.name=t.readNullTerminatedString(i,n.FIELD_NAME_LENGTH),i.seek(o+n.FIELD_NAME_LENGTH),this.typeCode=String.fromCharCode(i.getByte()),this.type=n.getFieldType(this.typeCode),null==this.type)throw new Error(r.log(r.LEVEL_SEVERE,"Shapefile dBase encountered unsupported field type: "+this.typeCode));i.skipBytes(4),this.length=i.getByte(),this.decimals=i.getByte(),i.seek(o+n.FIELD_DESCRIPTOR_LENGTH)},n.getFieldType=function(t){switch(t){case"C":return n.TYPE_CHAR;case"D":return n.TYPE_DATE;case"F":return n.TYPE_NUMBER;case"L":return n.TYPE_BOOLEAN;case"N":return n.TYPE_NUMBER;default:return null}},n.prototype.toString=function(){return this.name+"("+this.typeCode+")"},n.TYPE_CHAR="DBase.FieldTypeChar",n.TYPE_NUMBER="DBase.FieldTypeNumber",n.TYPE_DATE="DBase.FieldTypeDate",n.TYPE_BOOLEAN="DBase.FieldTypeBoolean",n.FIELD_NAME_LENGTH=11,n.FIELD_DESCRIPTOR_LENGTH=32,n}),i("formats/shapefile/DBaseRecord",["../../error/ArgumentError","../../util/ByteBuffer","../../formats/shapefile/DBaseField","../../formats/shapefile/DBaseFile","../../util/Logger"],function(t,e,i,r,n){"use strict";var o=function(e,i,r){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"DBaseRecord","constructor","missingAttributeName"));if(!i)throw new t(n.logMessage(n.LEVEL_SEVERE,"DBaseRecord","constructor","missingBuffer"));this.deleted=!1,this.recordNumber=r,this.values=null,this.readFromBuffer(e,i,r)};return o.prototype.isDeleted=function(){return this.deleted},o.prototype.getRecordNumber=function(){return this.recordNumber},o.prototype.readFromBuffer=function(t,r,o){r.order(e.LITTLE_ENDIAN),this.recordNumber=o;var s=r.getByte();this.deleted=42==s;var a=t.getFields();this.values={};for(var l=0,h=a.length;l<h;l+=1){var u=a[l],c=u.getName(),d=t.readNullTerminatedString(r,u.getLength()).trim();try{if(u.getType()==i.TYPE_BOOLEAN){var p=d.charAt(0);this.values[c]="t"==p||"T"==p||"Y"==p||"y"==p}else u.getType()==i.TYPE_CHAR?this.values[c]=d:u.getType()==i.TYPE_DATE?this.values[c]=new Date(d):u.getType()==i.TYPE_NUMBER&&(this.values[c]=+d)}catch(t){n.log(n.LEVEL_WARNING,"Shapefile attribute parsing error:"+u.toString()+" -> "+d.toString()+" ["+t+"]")}}},o}),i("formats/shapefile/DBaseFile",["../../error/ArgumentError","../../util/ByteBuffer","../../formats/shapefile/DBaseField","../../formats/shapefile/DBaseRecord","../../util/Logger"],function(t,e,i,r,n){"use strict";var o=function(e){if(!e)throw new t(n.logMessage(n.LEVEL_SEVERE,"DBaseFile","constructor","missingUrl"));this.url=e,this.header=null,this.fields=null,this.buffer=null,this.boolean=!0,this.numRecordsRead=0,this._completionCallback=null};return o.prototype.getLastModificationDate=function(){return this.header.lastModificationDate},o.prototype.getNumberOfRecords=function(){return this.header.numberOfRecords},o.prototype.getHeaderLength=function(){return this.header.headerLength},o.prototype.getRecordLength=function(){return this.header.recordLength},o.prototype.getNumberOfFields=function(){return(this.header.headerLength-1-o.FIXED_HEADER_LENGTH)/o.FIELD_DESCRIPTOR_LENGTH},o.prototype.getFields=function(){return this.fields},o.prototype.hasNext=function(){return this.numRecordsRead<this.header.numberOfRecords},o.prototype.nextRecord=function(){return this.numRecordsRead>=this.getNumberOfRecords()?null:this.readNextRecord(this._buffer,++this.numRecordsRead)},o.prototype.load=function(t){this._completionCallback=t,this.requestUrl(this.url)},o.prototype.requestUrl=function(t){var i=new XMLHttpRequest;i.open("GET",t,!0),i.responseType="arraybuffer",i.onreadystatechange=function(){4===i.readyState&&(200===i.status?(this._buffer=new e(i.response),this.parse(),this._completionCallback&&this._completionCallback(this)):(n.log(n.LEVEL_WARNING,"DBaseFile retrieval failed ("+i.statusText+"): "+t),this._completionCallback&&this._completionCallback(this)))}.bind(this),i.onerror=function(){n.log(n.LEVEL_WARNING,"DBaseFile retrieval failed: "+t),this._completionCallback&&this._completionCallback(this)},i.ontimeout=function(){n.log(n.LEVEL_WARNING,"DBaseFile retrieval timed out: "+t),this._completionCallback&&this._completionCallback(this)},i.send(null)},o.prototype.parse=function(){this.header=this.readHeader(this._buffer),this.fields=this.readFieldDescriptors(this._buffer,this.getNumberOfFields())},o.prototype.readHeader=function(t){var i=t.position;t.order(e.LITTLE_ENDIAN);var r=t.getByte();if(r>5)throw new Error("???");var n=t.getByte(),s=t.getByte(),a=t.getByte(),l=t.getInt32(),h=t.getInt16(),u=t.getInt16(),c={year:1900+n,month:s-1,day:a},d={fileCode:r,lastModificationDate:c,numberOfRecords:l,headerLength:h,recordLength:u};return t.seek(i+o.FIXED_HEADER_LENGTH),d},o.prototype.readFieldDescriptors=function(t,e){for(var r=t.position,n=[],s=0;s<e;s+=1)n[s]=new i(this,t);var a=this.header.headerLength-o.FIXED_HEADER_LENGTH;return t.seek(r+a),n},o.prototype.readNextRecord=function(t,e){return new r(this,t,e)},o.prototype.readNullTerminatedString=function(t,e){if(e<=0)return 0;for(var i="",r=0;r<e;r+=1){var n=t.getByte();if(0==n)break;i+=String.fromCharCode(n)}return this.isStringEmpty(i)?"":i},o.prototype.isStringEmpty=function(t){return t.length<=0||o.isStringFilled(t,32)||o.isStringFilled(t,42)},o.isStringFilled=function(t,e){if(t.length<=0)return!1;for(var i=0;i<t.length;i++)if(t.charAt(i)!=e)return!1;return!0},o.FIXED_HEADER_LENGTH=32,o.FIELD_DESCRIPTOR_LENGTH=32,
o}),i("formats/shapefile/PrjFile",["../../error/ArgumentError","../../util/Logger","../../error/NotYetImplementedError"],function(t,e,i){"use strict";var r=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"DBaseFile","constructor","missingUrl"));this._url=i,this._completionCallback=null,this._params=null};return Object.defineProperties(r.prototype,{url:{get:function(){return this._url}},coordinateSystem:{get:function(){return this.params?this.params[r.COORDINATE_SYSTEM]:null}},params:{get:function(){return this._params}}}),r.prototype.load=function(t){this._completionCallback=t,this.requestUrl(this._url)},r.prototype.requestUrl=function(t){var i=new XMLHttpRequest;i.open("GET",t,!0),i.responseType="arraybuffer",i.onreadystatechange=function(){if(4===i.readyState){if(200===i.status){var r=String.fromCharCode.apply(null,new Uint8Array(i.response));this._params=this.decodeOGCCoordinateSystem(r)}else e.log(e.LEVEL_WARNING,"PrjFile retrieval failed ("+i.statusText+"): "+t);this._completionCallback&&this._completionCallback(this)}}.bind(this),i.onerror=function(){e.log(e.LEVEL_WARNING,"PrjFile retrieval failed: "+t),this._completionCallback&&this._completionCallback(this)}.bind(this),i.ontimeout=function(){e.log(e.LEVEL_WARNING,"PrjFile retrieval timed out: "+t),this._completionCallback&&this._completionCallback(this)}.bind(this),i.send(null)},r.prototype.decodeOGCCoordinateSystem=function(n){n||new t(e.logMessage(e.LEVEL_SEVERE,"PrjFile","decodeOGCCoordinateSystem","missingText"));var o={};if(n=n.trim().toUpperCase(),r.GEOGCS_WKT_PATTERN.test(n))o[r.COORDINATE_SYSTEM]=r.COORDINATE_SYSTEM_GEOGRAPHIC;else{var s=n.match(r.PROJCS_WKT_PATTERN);if(s)throw o[PrfFile.COORDINATE_SYSTEM]=r.COORDINATE_SYSTEM_PROJECTED,new i(e.log(e.LEVEL_SEVERE,"PrjFile implementation  for projected coordinate systems in incomplete."));o[r.COORDINATE_SYSTEM]=r.COORDINATE_SYSTEM_UNKNOWN}return o},r.prototype.isUnknownCoordinateSystem=function(){return!this.params||this.params.coordinateSystem===r.COORDINATE_SYSTEM_UNKNOWN},r.prototype.isKnownCoordinateSystem=function(){return!!this.params&&this.params.coordinateSystem!==r.COORDINATE_SYSTEM_UNKNOWN},r.prototype.isGeographicCoordinateSystem=function(){return!!this.params&&this.params.coordinateSystem===r.COORDINATE_SYSTEM_GEOGRAPHIC},r.prototype.isProjectedCoordinateSystem=function(){return!!this.params&&this.params.coordinateSystem===r.COORDINATE_SYSTEM_PROJECTED},r.GEOGCS_WKT_PATTERN=new RegExp("\\{*GEOGCS[\\[\\(](.*)[\\]\\)]\\}*"),r.PROJCS_WKT_PATTERN=new RegExp("\\{*PROJCS[\\[\\(](.*)[\\]\\)]\\}*"),r.UTM_NAME_WKT_PATTERN=new RegExp(".*UTM.*ZONE.*?(\\d+).*?([\\w\\s]+).*?"),r.COORDINATE_SYSTEM="Coordinate_system",r.COORDINATE_SYSTEM_GEOGRAPHIC="Coordinate_system_geographic",r.COORDINATE_SYSTEM_PROJECTED="Coordinate_system_projected",r.COORDINATE_SYSTEM_UNKNOWN="Coordinate_system_unknown",r.PROJECTION_NAME="Projection_name",r.PROJECTION_UTM="Projection_UTM",r.PROJECTION_ZONE="Projection_zone",r.PROJECTION_HEMISPHERE="Projection_hemisphere",r.PROJECTION_HEMISPHERE_NORTH="Projection_hemisphere_north",r.PROJECTION_HEMISPHERE_SOUTH="Projection_hemisphere_south",r}),i("formats/shapefile/ShapefileRecord",["../../geom/Angle","../../error/ArgumentError","../../util/ByteBuffer","../../geom/Location","../../util/Logger","../../formats/shapefile/Shapefile"],function(t,e,i,r,n,o){"use strict";var s=function(t,i){if(!t)throw new e(n.logMessage(n.LEVEL_SEVERE,"ShapefileRecord","constructor","The specified shapefile is null or undefined"));if(!i)throw new e(n.logMessage(n.LEVEL_SEVERE,"ShapefileRecord","constructor","The specified buffer is null or undefined"));this._shapefile=t,this._recordNumber=-1,this._attributes={},this._numberOfParts=0,this._firstPartNumber=0,this._lastPartNumber=0,this._numberOfPoints=0,this._boundingRectangle=[],this._zRange=null,this._zValues=null,this._mRange=null,this._mValues=null,this._contentLengthInBytes=-1,this._buffer=i,this._isNormalized=!1,this._parts=[],this.readRecord()};return Object.defineProperties(s.prototype,{shapefile:{get:function(){return this._shapefile}},recordNumber:{get:function(){return this._recordNumber}},attributes:{get:function(){return this._attributes}},numberOfParts:{get:function(){return this._numberOfParts}},firstPartNumber:{get:function(){return this._firstPartNumber}},lastPartNumber:{get:function(){return this._lastPartNumber}},numberOfPoints:{get:function(){return this._numberOfPoints}},boundingRectangle:{get:function(){return this._boundingRectangle}},zRange:{get:function(){return this._zRange}},zValues:{get:function(){return this._zValues}},mRange:{get:function(){return this._mRange}},mValues:{get:function(){return this._mValues}}}),s.prototype.pointBuffer=function(t){return t>=0&&t<this._parts.length?this._parts[t]:null},s.prototype.readRecord=function(){this.readHeader(),this._buffer.order(i.LITTLE_ENDIAN);var t=this._buffer.getInt32(),e=this.shapefile.getShapeType(t);this.validateShapeType(e),this.readContents()},s.prototype.readHeader=function(){this._buffer.order(i.BIG_ENDIAN),this._recordNumber=this._buffer.getInt32(),this._contentLengthInBytes=2*this._buffer.getInt32()},s.prototype.validateShapeType=function(t){if(t!==this.shapefile.NULL&&t!==this.shapefile.shapeType)throw new Error(n.log(n.LEVEL_SEVERE,"Shapefile record is not supported."))},s.prototype.readNullContents=function(){this._numberOfParts=0,this._numberOfPoints=0,this._parts=null,this._boundingRectangle=null,this._buffer.seek(this._contentLengthInBytes-i.INT32_SIZE)},s.prototype.readPointContents=function(){this._numberOfParts=1,this._firstPartNumber=0,this._lastPartNumber=this._numberOfParts-1,this._numberOfPoints=1,this._parts=[this._buffer.getDoubleArray(2)];var t=this._parts[0][1],e=this._parts[0][0];this._boundingRectangle=[t,t,e,e],this.isZType()&&this.readZ(!0),this.isMeasureType()&&this.readOptionalMeasures(!0)},s.prototype.readPolylineContents=function(){var t=this.shapefile.readBoundingRectangle(this._buffer);if(this._boundingRectangle=t.coords,this._isNormalized=t.isNormalized,this._numberOfParts=this._buffer.getInt32(),this._firstPartNumber=0,this._lastPartNumber=this._numberOfParts-1,this._numberOfPoints=this._buffer.getInt32(),this._numberOfParts>0&&this._numberOfPoints>0)for(var e=this._buffer.getInt32Array(this.numberOfParts),i=0;i<this.numberOfParts;i+=1){var r=i==this.numberOfParts-1?this._numberOfPoints-e[i]:e[i+1]-e[i];this._parts[i]=this._buffer.getDoubleArray(2*r),s.normalizeLocations(this._parts[i])}this.isZType()&&this.readZ(!1),this.isMeasureType()&&this.readOptionalMeasures(!1)},s.prototype.readMultiPointContents=function(){var t=this.shapefile.readBoundingRectangle(this._buffer);this._boundingRectangle=t.coords,this._isNormalized=t.isNormalized,this._numberOfParts=1,this._numberOfPoints=this._buffer.getInt32(),this._parts=[this._buffer.getDoubleArray(2*this._numberOfPoints)],s.normalizeLocations(this._parts[0]),this.isZType()&&this.readZ(!1),this.isMeasureType()&&this.readOptionalMeasures(!1)},s.prototype.readZ=function(t){if(t){this._zValues=this._buffer.getDoubleArray(1);var e=this._zValues[0];this._zRange=[e,e]}else this._zRange=this._buffer.getDoubleArray(2),this._zValues=this._buffer.getDoubleArray(this.numberOfPoints)},s.prototype.readOptionalMeasures=function(t){if(this._buffer.hasRemaining()&&this._buffer.limit()-this._buffer.position>=8*this.numberOfPoints)if(t){this._mValues=this._buffer.getDoubleArray(1);var e=this._mValues[0];this._mRange=[e,e]}else this._mRange=this._buffer.getDoubleArray(2),this._mValues=this._buffer.getDoubleArray(this.numberOfPoints)},s.normalizeLocations=function(e){for(var i=0,r=e.length;i<r;i+=2){var n=e[i],o=e[i+1];e[i]=t.normalizedDegreesLongitude(n),e[i+1]=t.normalizedDegreesLatitude(o)}},s.prototype.isPointType=function(){return this.shapefile.isPointType()},s.prototype.isMultiPointType=function(){return this.shapefile.isMultiPointType()},s.prototype.isPolylineType=function(){return this.shapefile.isPolylineType()},s.prototype.isPolygonType=function(){return this.shapefile.isPolygonType()},s.prototype.isZType=function(){return this.shapefile.isZType()},s.prototype.isMeasureType=function(){return this.shapefile.isMeasureType()},s.prototype.setAttributes=function(t){this._attributes=t},s.RECORD_HEADER_LENGTH=8,s}),i("formats/shapefile/ShapefileRecordMultiPoint",["../../util/ByteBuffer","../../formats/shapefile/Shapefile","../../formats/shapefile/ShapefileRecord"],function(t,e,i){"use strict";var r=function(t,e){i.call(this,t,e)};return r.prototype=Object.create(i.prototype),r.prototype.readContents=function(){this.readMultiPointContents()},r}),i("formats/shapefile/ShapefileRecordNull",["../../formats/shapefile/Shapefile","../../formats/shapefile/ShapefileRecord"],function(t,e){"use strict";var i=function(t,i){e.call(this,t,i)};return i.prototype=Object.create(e.prototype),i.prototype.readContents=function(){this.readNullContents()},i}),i("formats/shapefile/ShapefileRecordPoint",["../../formats/shapefile/Shapefile","../../formats/shapefile/ShapefileRecord"],function(t,e){"use strict";var i=function(t,i){e.call(this,t,i)};return i.prototype=Object.create(e.prototype),i.prototype.readContents=function(){this.readPointContents()},i}),i("formats/shapefile/ShapefileRecordPolygon",["../../formats/shapefile/Shapefile","../../formats/shapefile/ShapefileRecord"],function(t,e){"use strict";var i=function(t,i){e.call(this,t,i)};return i.prototype=Object.create(e.prototype),i.prototype.readContents=function(){this.readPolylineContents()},i}),i("formats/shapefile/ShapefileRecordPolyline",["../../formats/shapefile/Shapefile","../../formats/shapefile/ShapefileRecord"],function(t,e){"use strict";var i=function(t,i){e.call(this,t,i)};return i.prototype=Object.create(e.prototype),i.prototype.readContents=function(){this.readPolylineContents()},i}),i("formats/shapefile/Shapefile",["../../geom/Angle","../../error/ArgumentError","../../util/ByteBuffer","../../util/Color","../../formats/shapefile/DBaseFile","../../geom/Location","../../util/Logger","../../error/NotYetImplementedError","../../shapes/Path","../../shapes/Placemark","../../shapes/PlacemarkAttributes","../../shapes/Polygon","../../geom/Position","../../formats/shapefile/PrjFile","../../layer/RenderableLayer","../../shapes/ShapeAttributes","../../formats/shapefile/ShapefileRecord","../../formats/shapefile/ShapefileRecordMultiPoint","../../formats/shapefile/ShapefileRecordNull","../../formats/shapefile/ShapefileRecordPoint","../../formats/shapefile/ShapefileRecordPolygon","../../formats/shapefile/ShapefileRecordPolyline","../../shapes/SurfacePolygon","../../shapes/SurfacePolyline"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b,S,T){"use strict";var L=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Shapefile","constructor","missingUrl"));this._url=t,this._shapeType=null,this._layer=null,this._shapeConfigurationCallback=this.defaultShapeConfigurationCallback,this._parserCompletionCallback=this.defaultParserCompletionCallback,this._buffer=null,this.attributeFile=new n(t.replace(".shp",".dbf")),this.projectionFile=new p(t.replace(".shp",".prj")),this.defaultPlacemarkAttributes=new u(null),this.defaultShapeAttributes=new g(null)};return Object.defineProperties(L.prototype,{url:{get:function(){return this._url}},shapeType:{get:function(){return this._shapeType}},layer:{get:function(){return this._layer}},parserCompletionCallback:{get:function(){return this._parserCompletionCallback}},shapeConfigurationCallback:{get:function(){return this._shapeConfigurationCallback}}}),L.prototype.load=function(t,e,i){t&&(this._parserCompletionCallback=t),e&&(this._shapeConfigurationCallback=e),this._layer=i||new f;var r=function(){var t=function(){this.requestUrl(this.url)}.bind(this);this.attributeFile.load(t)}.bind(this);this.projectionFile.load(r)},L.prototype.defaultParserCompletionCallback=function(t){this.addRenderablesForShapefile(this.layer)},L.prototype.defaultShapeConfigurationCallback=function(t,e){var i={},r=t.values.name||t.values.Name||t.values.NAME;if(r&&(i.name=r),e.isPointType())i.attributes=this.defaultPlacemarkAttributes;else if(e.isMultiPointType())i.attributes=this.defaultPlacemarkAttributes;else if(e.isPolylineType())i.attributes=this.defaultShapeAttributes;else if(e.isPolygonType()){i.attributes=this.defaultShapeAttributes;var n=t.values.height||t.values.Height||t.values.HEIGHT;n&&(i.height=n)}return i},L.prototype.addRenderablesForShapefile=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Shapefile","addRenderablesForShapefile","missingLayer"));this.isPointType()?this.addRenderablesForPoints(t):this.isMultiPointType()?this.addRenderablesForMultiPoints(t):this.isPolylineType()?this.addRenderablesForPolylines(t):this.isPolygonType()&&this.addRenderablesForPolygons(t)},L.prototype.addRenderablesForPoints=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Shapefile","addRenderablesForPoints","missingLayer"));for(var i=this.next();i;i=this.next()){var r=this.shapeConfigurationCallback(i.attributes,i),n=r&&r.altitude?r.altitude:0;if(r)for(var o=0,a=i.numberOfParts;o<a;o+=1)for(var l=i.pointBuffer(o),u=0,c=l.length;u<c;u+=2){var p=l[u],f=l[u+1],g=new d(f,p,n),m=new h(g,!1,r.attributes);m.altitudeMode=r.altitudeMode||WorldWind.RELATIVE_TO_GROUND,r.highlightAttributes&&(m.highlightAttributes=r.highlightAttributes),r.name&&(m.label=r.name),r.pickDelegate&&(m.pickDelegate=r.pickDelegate),r.userProperties&&(m.userProperties=r.userProperties),t.addRenderable(m)}}},L.prototype.addRenderablesForMultiPoints=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Shapefile","addRenderablesForMultiPoints","missingLayer"));for(var i=this.next();i;i=this.next()){var r=this.shapeConfigurationCallback(i.attributes,i),n=r&&r.altitude?r.altitude:0;if(r)for(var o=0,a=i.numberOfParts;o<a;o+=1)for(var l=i.pointBuffer(o),u=0,c=l.length;u<c;u+=2){var p=l[u],f=l[u+1],g=new d(f,p,n),m=new h(g,!1,r.attributes);m.altitudeMode=r.altitudeMode||WorldWind.RELATIVE_TO_GROUND,r.highlightAttributes&&(m.highlightAttributes=r.highlightAttributes),r.name&&(m.label=r.name),r.pickDelegate&&(m.pickDelegate=r.pickDelegate),r.userProperties&&(m.userProperties=r.userProperties),t.addRenderable(m)}}},L.prototype.addRenderablesForPolylines=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Shapefile","addRenderablesForPolylines","missingLayer"));for(var i=this.next();i;i=this.next()){var r=this.shapeConfigurationCallback(i.attributes,i),n=r&&r.altitude?r.altitude:0;if(r)for(var a=0,h=i.numberOfParts;a<h;a+=1){for(var u=i.pointBuffer(a),c=[],p=0,f=u.length;p<f;p+=2){var g=u[p],m=u[p+1],E=n?new d(m,g,n):new o(m,g);c.push(E)}var y;n?(y=new l(c,r.attributes),y.altitudeMode=r.altitudeMode||WorldWind.RELATIVE_TO_GROUND):y=new T(c,r.attributes),r.highlightAttributes&&(y.highlightAttributes=r.highlightAttributes),r.name&&(y.displayName=r.name),r.pickDelegate&&(y.pickDelegate=r.pickDelegate),r.userProperties&&(y.userProperties=r.userProperties),t.addRenderable(y)}}},L.prototype.addRenderablesForPolygons=function(t){if(!t)throw new e(s.logMessage(s.LEVEL_SEVERE,"Shapefile","addRenderablesForPolygons","missingLayer"));for(var i=this.next();i;i=this.next()){for(var r,n=this.shapeConfigurationCallback(i.attributes,i),a=[],l=n.height,h=n.altitude,u=0,p=i.numberOfParts;u<p;u+=1){for(var f=i.pointBuffer(u),g=[],m=0,E=f.length-2;m<E;m+=2){var y=f[m],_=f[m+1];r=l?new d(_,y,l):h?new d(_,y,h):new o(_,y),g.push(r)}a.push(g)}var v;l?(v=new c(a,n.attributes),v.extrude=!0,v.altitudeMode=n.altitudeMode||WorldWind.RELATIVE_TO_GROUND):h?(v=new c(a,n.attributes),v.altitudeMode=n.altitudeMode||WorldWind.RELATIVE_TO_GROUND):v=new S(a,n.attributes),n.highlightAttributes&&(v.highlightAttributes=n.highlightAttributes),n.name&&(v.displayName=n.name),n.pickDelegate&&(v.pickDelegate=n.pickDelegate),n.userProperties&&(v.userProperties=n.userProperties),t.addRenderable(v)}},L.prototype.next=function(){for(;this._buffer.position<this._buffer.limit();){var t=this.readRecord(this._buffer);if(!(t instanceof y))return t}return null},L.prototype.requestUrl=function(t){var e=new XMLHttpRequest;e.open("GET",t,!0),e.responseType="arraybuffer",e.onreadystatechange=function(){4===e.readyState&&(200===e.status?(this._buffer=new i(e.response),this.parse()):s.log(s.LEVEL_WARNING,"Shapefile retrieval failed ("+e.statusText+"): "+t),this._parserCompletionCallback&&this._parserCompletionCallback(this))}.bind(this),e.onerror=function(){s.log(s.LEVEL_WARNING,"Shapefile retrieval failed: "+t),this._parserCompletionCallback&&this._parserCompletionCallback(this)},e.ontimeout=function(){s.log(s.LEVEL_WARNING,"Shapefile retrieval timed out: "+t),this._parserCompletionCallback&&this._parserCompletionCallback(this)},e.send(null)},L.prototype.parse=function(){try{var t=this.readHeader(this._buffer);this._shapeType=t.shapeType}catch(t){console.log(t)}finally{}},L.prototype.readHeader=function(t){t.order(i.BIG_ENDIAN);var e=t.getInt32();if(e!=L.FILE_CODE)throw new Error(s.log(s.LEVEL_SEVERE,"Shapefile header is invalid"));t.skipInt32s(5);var r=t.getInt32();t.order(i.LITTLE_ENDIAN);var n=t.getInt32(),o=t.getInt32(),a=this.readBoundingRectangle(t),l=this.getShapeType(o);if(null==l)throw new Error(s.log(s.LEVEL_SEVERE,"Shapefile type is unsupported: "+o.toString()));var h={fileLength:2*r,version:n,shapeType:l,boundingRectangle:a.coords,normalizePoints:a.isNormalized};return t.skipDoubles(4),h},L.prototype.readBoundingRectangle=function(t){return this.projectionFile?this.projectionFile.isGeographicCoordinateSystem()?this.readGeographicBoundingRectangle(t):this.projectionFile.isProjectedCoordinateSystem()?this.readProjectedBoundingRectangle(t):this.readUnspecifiedBoundingRectangle(t):this.readUnspecifiedBoundingRectangle(t)},L.prototype.readUnspecifiedBoundingRectangle=function(t){var e=this.readBoundingRectangleCoordinates(t);return{coords:e,isNormalized:!1}},L.prototype.readGeographicBoundingRectangle=function(e){var i=this.readBoundingRectangleCoordinates(e),r=!1,n=0;return i[0]<-90&&(n=t.normalizedDegreesLatitude(i[0]),i[0]=90,r=!0,i[1]<n&&(i[1]=n)),i[1]>90&&(n=t.normalizedDegreesLatitude(i[1]),i[1]=90,r=!0,i[0]>n&&(i[0]=n)),(i[2]<-180||i[3]>180)&&(i[2]=-180,i[3]=180,r=!0),{coords:i,isNormalized:r}},L.prototype.readProjectedBoundingRectangle=function(t){throw new a(s.log(s.LEVEL_SEVERE,"Shapefile.readProjectedBoundingRectangle() not yet implemented"))},L.prototype.readBoundingRectangleCoordinates=function(t){var e=t.getDouble(),i=t.getDouble(),r=t.getDouble(),n=t.getDouble();return[i,n,e,r]},L.prototype.readRecord=function(t){var e=this.createRecord(t);if(null!=e&&null!=this.attributeFile&&this.attributeFile.hasNext()){var i=this.attributeFile.nextRecord();e.setAttributes(i)}return e},L.prototype.createRecord=function(t){return this.isNullType()?this.createNull(t):this.isPointType()?this.createPoint(t):this.isMultiPointType()?this.createMultiPoint(t):this.isPolygonType()?this.createPolygon(t):this.isPolylineType()?this.createPolyline(t):null},L.prototype.createNull=function(t){return new y(this,t)},L.prototype.createPoint=function(t){return new _(this,t)},L.prototype.createMultiPoint=function(t){return new E(this,t)},L.prototype.createPolyline=function(t){return new b(this,t)},L.prototype.createPolygon=function(t){return new v(this,t)},L.prototype.getShapeType=function(t){switch(t){case 0:return L.NULL;case 1:return L.POINT;case 3:return L.POLYLINE;case 5:return L.POLYGON;case 8:return L.MULTI_POINT;case 11:return L.POINT_Z;case 13:return L.POLYLINE_Z;case 15:return L.POLYGON_Z;case 18:return L.MULTI_POINT_Z;case 21:return L.POINT_M;case 23:return L.POLYLINE_M;case 25:return L.POLYGON_M;case 28:return L.MULTI_POINT_M;default:return null}},L.prototype.isMeasureType=function(){return L.measureTypes.hasOwnProperty(this._shapeType)},L.prototype.isZType=function(){return L.zTypes.hasOwnProperty(this._shapeType)},L.prototype.isNullType=function(){return this._shapeType===L.NULL},L.prototype.isPointType=function(){return L.pointTypes.hasOwnProperty(this._shapeType)},L.prototype.isMultiPointType=function(){return L.multiPointTypes.hasOwnProperty(this._shapeType)},L.prototype.isPolylineType=function(){return L.polylineTypes.hasOwnProperty(this._shapeType)},L.prototype.isPolygonType=function(){return L.polygonTypes.hasOwnProperty(this._shapeType)},L.NULL="null",L.POINT="point",L.MULTI_POINT="multiPoint",L.POLYLINE="polyline",L.POLYGON="polygon",L.POINT_M=L.POINT+"M",L.MULTI_POINT_M=L.MULTI_POINT+"M",L.POLYLINE_M=L.POLYLINE+"M",L.POLYGON_M=L.POLYGON+"M",L.POINT_Z=L.POINT+"Z",L.MULTI_POINT_Z=L.MULTI_POINT+"Z",L.POLYLINE_Z=L.POLYLINE+"Z",L.POLYGON_Z=L.POLYGON+"Z",L.SHAPE_MULTI_PATCH="multiPatch",L.measureTypes={pointM:L.POINT_M,pointZ:L.POINT_Z,multiPointM:L.MULTI_POINT_M,multiPointZ:L.MULTI_POINT_Z,polylineM:L.POLYLINE_M,polylineZ:L.POLYLINE_Z,polygonM:L.POLYGON_M,polygonZ:L.POLYGON_Z},L.zTypes={pointZ:L.POINT_Z,multiPointZ:L.MULTI_POINT_Z,polylineZ:L.POLYLINE_Z,polygonZ:L.POLYGON_Z},L.pointTypes={point:L.POINT,pointZ:L.POINT_Z,pointM:L.POINT_M},L.multiPointTypes={multiPoint:L.MULTI_POINT,multiPointZ:L.MULTI_POINT_Z,multiPointM:L.MULTI_POINT_M},L.polylineTypes={polyline:L.POLYLINE,polylineZ:L.POLYLINE_Z,polylineM:L.POLYLINE_M},L.polygonTypes={polygon:L.POLYGON,polygonZ:L.POLYGON_Z,polygonM:L.POLYGON_M},L.FILE_CODE=9994,L}),i("layer/ShowTessellationLayer",["../shaders/BasicProgram","../layer/Layer"],function(t,e){"use strict";var i=function(){e.call(this,"Show Tessellation"),this.enableTerrainGeometry=!0,this.enableTerrainExtent=!1};return i.prototype=Object.create(e.prototype),i.prototype.doRender=function(t){try{this.beginRendering(t),this.enableTerrainGeometry&&this.drawTerrainGeometry(t),this.enableTerrainExtent&&this.drawTerrainExtent(t)}finally{this.endRendering(t)}},i.prototype.beginRendering=function(t){var e=t.currentGlContext;e.depthMask(!1)},i.prototype.endRendering=function(t){var e=t.currentGlContext;e.depthMask(!0)},i.prototype.drawTerrainGeometry=function(e){if(e.terrain&&e.terrain.tessellator){var i,r,n=e.currentGlContext,o=e.terrain,s=o.tessellator,a=o.surfaceGeometry;try{i=e.findAndBindProgram(t),s.beginRendering(e);for(var l=0,h=a.length;l<h;l++)r=a[l],s.beginRenderingTile(e,r),i.loadColorComponents(n,1,1,1,.3),s.renderWireframeTile(e,r),i.loadColorComponents(n,1,0,0,.6),s.renderTileOutline(e,r),s.endRenderingTile(e,r)}finally{s.endRendering(e)}}},i.prototype.drawTerrainExtent=function(t){for(var e,i=t.terrain.surfaceGeometry,r=0,n=i.length;r<n;r++)e=i[r],e.extent.render(t)},i}),i("shapes/SurfaceEllipse",["../geom/Angle","../error/ArgumentError","../geom/Location","../util/Logger","../shapes/ShapeAttributes","../shapes/SurfaceShape","../util/WWMath"],function(t,e,i,r,n,o,s){"use strict";var a=function(t,i,n,s,l){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"SurfaceEllipse","constructor","missingLocation"));if(i<0||n<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"SurfaceEllipse","constructor","Radius is negative."));o.call(this,l),this._center=t,this._majorRadius=i,this._minorRadius=n,this._heading=s,this._intervals=a.DEFAULT_NUM_INTERVALS};return a.prototype=Object.create(o.prototype),Object.defineProperties(a.prototype,{center:{get:function(){return this._center},set:function(t){this.stateKeyInvalid=!0,this._center=t}},majorRadius:{get:function(){return this._majorRadius},set:function(t){this.stateKeyInvalid=!0,this._majorRadius=t}},minorRadius:{get:function(){return this._minorRadius},set:function(t){this.stateKeyInvalid=!0,this._minorRadius=t}},heading:{get:function(){return this._heading},set:function(t){this.stateKeyInvalid=!0,this._heading=t}},intervals:{get:function(){return this._intervals},set:function(t){this.stateKeyInvalid=!0,this._intervals=t}}}),a.staticStateKey=function(t){var e=o.staticStateKey(t);return e+" ce "+t.center.toString()+" ma "+t.majorRadius.toString()+" mi "+t.minorRadius.toString()+" he "+t.heading.toString()+" in "+t.intervals.toString()},a.prototype.computeStateKey=function(){return a.staticStateKey(this)},a.prototype.computeBoundaries=function(e){if(0==this.majorRadius&&0==this.minorRadius)return null;var r=e.globe,n=1+Math.max(a.MIN_NUM_INTERVALS,this.intervals),o=2*Math.PI/(n-1),l=r.radiusAt(this.center.latitude,this.center.longitude);this._boundaries=new Array(n);for(var h=0;h<n;h++){var u=h!=n-1?h*o:0,c=this.majorRadius*Math.cos(u),d=this.minorRadius*Math.sin(u),p=Math.sqrt(c*c+d*d),f=Math.PI/2-(Math.acos(c/p)*s.signum(d)-this.heading*t.DEGREES_TO_RADIANS);this._boundaries[h]=i.greatCircleLocation(this.center,f*t.RADIANS_TO_DEGREES,p/l,new i(0,0))}},a.MIN_NUM_INTERVALS=8,a.DEFAULT_NUM_INTERVALS=64,a}),i("shapes/SurfaceCircle",["../error/ArgumentError","../util/Logger","../shapes/ShapeAttributes","../shapes/SurfaceEllipse"],function(t,e,i,r){"use strict";var n=function(i,n,o){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfaceCircle","constructor","missingLocation"));if(n<0)throw new t(e.logMessage(e.LEVEL_SEVERE,"SurfaceCircle","constructor","Radius is negative"));r.call(this,i,n,n,0,o),this._radius=n};return n.prototype=Object.create(r.prototype),Object.defineProperties(n.prototype,{radius:{get:function(){return this._radius},set:function(t){this.stateKeyInvalid=!0,this._radius=t}}}),n.staticStateKey=function(t){var e=r.staticStateKey(t);return e+" ra "+t.radius.toString()},n.prototype.computeStateKey=function(){return n.staticStateKey(this)},n}),i("shapes/SurfaceRectangle",["../geom/Angle","../error/ArgumentError","../geom/Location","../util/Logger","../shapes/ShapeAttributes","../shapes/SurfaceShape","../util/WWMath"],function(t,e,i,r,n,o,s){"use strict";var a=function(t,i,n,s,a){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"SurfaceRectangle","constructor","missingLocation"));if(i<0||n<0)throw new e(r.logMessage(r.LEVEL_SEVERE,"SurfaceRectangle","constructor","Size is negative."));o.call(this,a),this._center=t,this._width=i,this._height=n,this._heading=s};return a.prototype=Object.create(o.prototype),Object.defineProperties(a.prototype,{center:{get:function(){return this._center},set:function(t){this.stateKeyInvalid=!0,this._center=t}},width:{get:function(){return this._width},set:function(t){this.stateKeyInvalid=!0,this._width=t}},height:{get:function(){return this._height},set:function(t){this.stateKeyInvalid=!0,this._height=t}},heading:{get:function(){return this._heading},set:function(t){this.stateKeyInvalid=!0,this._heading=t}}}),a.staticStateKey=function(t){var e=o.staticStateKey(t);return e+" ce "+t.center.toString()+" wi "+t.width.toString()+" he "+t.height.toString()+" hd "+t.heading.toString()},a.prototype.computeStateKey=function(){return a.staticStateKey(this)},a.prototype.computeBoundaries=function(t){var e=.5*this.width,i=.5*this.height,r=t.globe.radiusAt(this.center.latitude,this.center.longitude);this._boundaries=new Array(4),this.addLocation(0,-e,-i,r),this.addLocation(1,e,-i,r),this.addLocation(2,e,i,r),this.addLocation(3,-e,i,r)},a.prototype.addLocation=function(e,r,n,o){var a=Math.sqrt(r*r+n*n),l=Math.PI/2-(Math.acos(r/a)*s.signum(n)-this.heading*t.DEGREES_TO_RADIANS);this._boundaries[e]=i.greatCircleLocation(this.center,l*t.RADIANS_TO_DEGREES,a/o,new i(0,0))},a}),i("render/SurfaceRenderable",["../util/Logger","../error/UnsupportedOperationError"],function(t,e){"use strict";var i=function(){throw this.displayName="Renderable",this.enabled=!0,new e(t.logMessage(t.LEVEL_SEVERE,"SurfaceRenderable","constructor","abstractInvocation"))};return i.prototype.renderSurface=function(i){throw new e(t.logMessage(t.LEVEL_SEVERE,"SurfaceRenderable","renderSurface","abstractInvocation"))},i}),i("shapes/SurfaceSector",["../error/ArgumentError","../geom/Location","../util/Logger","../shapes/ShapeAttributes","../shapes/SurfaceShape"],function(t,e,i,r,n){"use strict";var o=function(e,r){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"SurfaceSector","constructor","missingSector"));n.call(this,r),this._sector=e};return o.prototype=Object.create(n.prototype),o.staticStateKey=function(t){var e=n.staticStateKey(t);return e},o.prototype.computeStateKey=function(){return o.staticStateKey(this)},o.prototype.computeBoundaries=function(t){var i=this._sector;this._boundaries=new Array(4),this._boundaries[0]=new e(i.minLatitude,i.minLongitude),this._boundaries[1]=new e(i.maxLatitude,i.minLongitude),this._boundaries[2]=new e(i.maxLatitude,i.maxLongitude),this._boundaries[3]=new e(i.minLatitude,i.maxLongitude)},o}),i("gesture/TapRecognizer",["../gesture/GestureRecognizer"],function(t){"use strict";var e=function(e,i){t.call(this,e,i),this.numberOfTaps=1,this.numberOfTouches=1,this.maxTouchMovement=20,this.maxTapDuration=500,this.maxTapInterval=400,this.taps=[],this.timeout=null};return e.prototype=Object.create(t.prototype),e.prototype.reset=function(){t.prototype.reset.call(this),this.taps=[],this.cancelFailAfterDelay()},e.prototype.mouseDown=function(t){this.state==WorldWind.POSSIBLE&&(this.state=WorldWind.FAILED)},e.prototype.touchStart=function(t){if(this.state==WorldWind.POSSIBLE){var e;this.touchCount>this.numberOfTouches?this.state=WorldWind.FAILED:1==this.touchCount?(e={touchCount:this.touchCount,clientX:this.clientX,clientY:this.clientY},this.taps.push(e),this.failAfterDelay(this.maxTapDuration)):(e=this.taps[this.taps.length-1],e.touchCount=this.touchCount,e.clientX=this.clientX,e.clientY=this.clientY)}},e.prototype.touchMove=function(t){if(this.state==WorldWind.POSSIBLE){var e=this.translationX,i=this.translationY,r=Math.sqrt(e*e+i*i);r>this.maxTouchMovement&&(this.state=WorldWind.FAILED)}},e.prototype.touchEnd=function(t){if(this.state==WorldWind.POSSIBLE&&0==this.touchCount){var e=this.taps.length,i=this.taps[e-1];i.touchCount!=this.numberOfTouches?this.state=WorldWind.FAILED:e==this.numberOfTaps?(this.clientX=this.taps[0].clientX,this.clientY=this.taps[0].clientY,this.state=WorldWind.RECOGNIZED):this.failAfterDelay(this.maxTapInterval)}},e.prototype.touchCancel=function(t){this.state==WorldWind.POSSIBLE&&(this.state=WorldWind.FAILED)},e.prototype.failAfterDelay=function(t){var e=this;e.timeout&&window.clearTimeout(e.timeout),e.timeout=window.setTimeout(function(){e.timeout=null,e.state==WorldWind.POSSIBLE&&(e.state=WorldWind.FAILED)},t)},e.prototype.cancelFailAfterDelay=function(){var t=this;t.timeout&&(window.clearTimeout(t.timeout),t.timeout=null)},e}),i("layer/TectonicPlatesLayer",["../error/ArgumentError","../util/Color","../geom/Location","../util/Logger","../layer/RenderableLayer","../shapes/ShapeAttributes","../shapes/SurfacePolygon"],function(t,e,i,r,n,o,s){"use strict";var a=function(t){n.call(this,"Tectonic Plates"),t?this._attributes=t:(this._attributes=new o(null),this._attributes.drawInterior=!1,this._attributes.drawOutline=!0,this._attributes.outlineColor=e.RED),this.loadPlateData()};return a.prototype=Object.create(n.prototype),Object.defineProperties(s.prototype,{attributes:{get:function(){return this._attributes},set:function(t){t&&this.renderables.map(function(e,i,r){e.attributes=t})}}}),a.prototype.loadPlateData=function(){var t="http://worldwindserver.net/webworldwind/data/TectonicPlates.json",e=new XMLHttpRequest;e.open("GET",t,!0),e.onreadystatechange=function(){4===e.readyState&&(200===e.status?this.parse(e.responseText):r.log(r.LEVEL_WARNING,"Tectonic plate data retrieval failed ("+e.statusText+"): "+t))}.bind(this),e.onerror=function(){r.log(r.LEVEL_WARNING,"Tectonic plate data retrieval failed: "+t)},e.ontimeout=function(){r.log(r.LEVEL_WARNING,"Tectonic plate data retrieval timed out: "+t)},e.send(null)},a.prototype.parse=function(t){var e=JSON.parse(t),r=this;e.features.map(function(t,e,n){var o=[];t.geometry.coordinates.map(function(t,e,r){o.push(new i(t[1],t[0]))});var a=new s(o,r._attributes);r.addRenderable(a)})},a}),i("util/TileFactory",["../util/Logger","../error/UnsupportedOperationError"],function(t,e){"use strict";var i=function(){};return i.prototype.createTile=function(i,r,n,o){throw new e(t.logMessage(t.LEVEL_SEVERE,"TileFactory","createTile","abstractInvocation"))},i}),i("shapes/TriangleMesh",["../shapes/AbstractMesh","../error/ArgumentError","../shaders/BasicTextureProgram","../geom/BoundingBox","../util/Color","../util/ImageSource","../geom/Location","../util/Logger","../geom/Matrix","../pick/PickedObject","../geom/Position","../shapes/ShapeAttributes","../shapes/SurfacePolygon","../geom/Vec2","../geom/Vec3"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f){
"use strict";var g=function(i,r,n){if(!i)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","constructor","missingPositions"));if(i.length<1)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","constructor","missingPositions"));if(i.length>65536)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","constructor","Too many positions. Must be fewer than 65537. Use TriangleMesh.split to split the shape."));if(!r)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","constructor","Indices array is null or undefined"));if(r.length<3)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","constructor","Too few indices."));t.call(this,n),this._positions=i,this._indices=r,this.referencePosition=this._positions[0]};return g.prototype=Object.create(t.prototype),Object.defineProperties(g.prototype,{positions:{get:function(){return this._positions},set:function(t){if(!t)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","positions","missingPositions"));this._positions=t,this.referencePosition=this._positions[0],this.reset()}},indices:{get:function(){return this._indices},set:function(t){if(!t)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","indices","Indices array is null or undefined"));this._indices=t,this.meshIndices=null,this.reset()}},outlineIndices:{get:function(){return this._outlineIndices},set:function(t){this._outlineIndices=t,this.meshOutlineIndices=null,this.reset()}},textureCoordinates:{get:function(){return this._textureCoordinates},set:function(t){if(t&&t.length!=this._positions.length)throw new e(a.logMessage(a.LEVEL_SEVERE,"TriangleMesh","textureCoordinates","Number of texture coordinates is inconsistent with the currently specified positions."));this._textureCoordinates=t,this.reset(),this.texCoords=null}}}),g.prototype.createSurfaceShape=function(){if(this._outlineIndices){for(var t=[],e=0;e<this._outlineIndices.length;e++)t.push(this._positions[this._outlineIndices[e]]);return new d(t,null)}return null},g.prototype.computeMeshPoints=function(t,e){for(var i,r,n=Number.MAX_VALUE,o=t.navigatorState.eyePoint,s=new Float32Array(3*this._positions.length),a=new f(0,0,0),l=0,h=0;h<this._positions.length;h++)i=this._positions[h],t.surfacePointForMode(i.latitude,i.longitude,i.altitude*this._altitudeScale,this.altitudeMode,a),r=a.distanceToSquared(o),r<n&&(n=r),a.subtract(this.currentData.referencePoint),s[l++]=a[0],s[l++]=a[1],s[l++]=a[2];return e.eyeDistance=Math.sqrt(n),s},g.prototype.computeTexCoords=function(){if(this._textureCoordinates){for(var t=new Float32Array(2*this._textureCoordinates.length),e=0,i=0,r=this._textureCoordinates.length;i<r;i++){var n=this._textureCoordinates[i];t[e++]=n[0],t[e++]=n[1]}return t}return null},g.prototype.computeMeshIndices=function(){for(var t=new Uint16Array(this._indices.length),e=0,i=this._indices.length;e<i;e++)t[e]=this._indices[e];return t},g.prototype.computeOutlineIndices=function(){if(this._outlineIndices){for(var t=new Uint16Array(this._outlineIndices.length),e=0;e<this._outlineIndices.length;e++)t[e]=this._outlineIndices[e];return t}return null},g.split=function(t,e,i,r){for(var n,o,s=[],a=[],l=[],h=[],u=[],c=0;c<=e.length;c++){if(c===e.length||s.length>65533&&l.length%3===0){if(s.length>0){var d={positions:s,indices:l};if(i&&(d.textureCoords=a),r){for(var p=[],f=0;f<r.length;f++)n=r[f],o=h[n],o&&p.push(h[r[f]]);d.outlineIndices=p}u.push(d)}if(c===e.length)break;s=[],l=[],h=[]}n=e[c],o=h[n],o||(o=s.length,h[n]=o,s.push(t[n]),i&&a.push(i[n])),l.push(o)}return u},g}),i("layer/ViewControlsLayer",["../geom/Angle","../error/ArgumentError","../layer/Layer","../geom/Location","../util/Logger","../util/Offset","../shapes/ScreenImage","../geom/Vec2","../util/WWUtil"],function(t,e,i,r,n,o,s,a,l){"use strict";var h=function(t){if(!t)throw new e(n.logMessage(n.LEVEL_SEVERE,"ViewControlsLayer","constructor","missingWorldWindow"));i.call(this,"View Controls"),this.wwd=t,this.placement=new o(WorldWind.OFFSET_FRACTION,0,WorldWind.OFFSET_FRACTION,0),this.alignment=new o(WorldWind.OFFSET_FRACTION,0,WorldWind.OFFSET_FRACTION,0),this.exaggerationIncrement=.01,this.zoomIncrement=.04,this.headingIncrement=1,this.tiltIncrement=1,this.fieldOfViewIncrement=.1,this.panIncrement=.001,this._inactiveOpacity=.5,this._activeOpacity=1;var r=new o(WorldWind.OFFSET_PIXELS,0,WorldWind.OFFSET_PIXELS,0),l=WorldWind.configuration.baseUrl+"images/view/";this.panControl=new s(r.clone(),l+"view-pan-64x64.png"),this.zoomInControl=new s(r.clone(),l+"view-zoom-in-32x32.png"),this.zoomOutControl=new s(r.clone(),l+"view-zoom-out-32x32.png"),this.headingLeftControl=new s(r.clone(),l+"view-heading-left-32x32.png"),this.headingRightControl=new s(r.clone(),l+"view-heading-right-32x32.png"),this.tiltUpControl=new s(r.clone(),l+"view-pitch-up-32x32.png"),this.tiltDownControl=new s(r.clone(),l+"view-pitch-down-32x32.png"),this.exaggerationUpControl=new s(r.clone(),l+"view-elevation-up-32x32.png"),this.exaggerationDownControl=new s(r.clone(),l+"view-elevation-down-32x32.png"),this.fovNarrowControl=new s(r.clone(),l+"view-fov-narrow-32x32.png"),this.fovWideControl=new s(r.clone(),l+"view-fov-wide-32x32.png"),this.fovNarrowControl.enabled=!1,this.fovWideControl.enabled=!1,this.controls=[this.panControl,this.zoomInControl,this.zoomOutControl,this.headingLeftControl,this.headingRightControl,this.tiltUpControl,this.tiltDownControl,this.exaggerationUpControl,this.exaggerationDownControl,this.fovNarrowControl,this.fovWideControl];for(var h=0;h<this.controls.length;h++)this.controls[h].imageOffset=r.clone(),this.controls[h].opacity=this._inactiveOpacity,this.controls[h]===this.panControl?this.controls[h].size=64:this.controls[h].size=32;this.panControlCenter=new a(0,0),this.isTouchDevice=!1,this.pickEnabled=!1,this.setupInteraction()};return h.prototype=Object.create(i.prototype),Object.defineProperties(h.prototype,{showPanControl:{get:function(){return this.panControl.enabled},set:function(t){this.panControl.enabled=t}},showZoomControl:{get:function(){return this.zoomInControl.enabled},set:function(t){this.zoomInControl.enabled=t,this.zoomOutControl.enabled=t}},showHeadingControl:{get:function(){return this.headingLeftControl.enabled},set:function(t){this.headingLeftControl.enabled=t,this.headingRightControl.enabled=t}},showTiltControl:{get:function(){return this.tiltUpControl.enabled},set:function(t){this.tiltUpControl.enabled=t,this.tiltDownControl.enabled=t}},showExaggerationControl:{get:function(){return this.exaggerationUpControl.enabled},set:function(t){this.exaggerationUpControl.enabled=t,this.exaggerationDownControl.enabled=t}},showFieldOfViewControl:{get:function(){return this.fovNarrowControl.enabled},set:function(t){this.fovNarrowControl.enabled=t,this.fovWideControl.enabled=t}},inactiveOpacity:{get:function(){return this._inactiveOpacity},set:function(t){this._inactiveOpacity=t;for(var e=0;e<this.controls.length;e++)this.controls[e].opacity=t}},activeOpacity:{get:function(){return this._activeOpacity},set:function(t){this._activeOpacity=t;for(var e=0;e<this.controls.length;e++)this.controls[e].opacity=t}}}),h.prototype.doRender=function(t){var e,i,r,n,o=0,s=64;this.inCurrentFrame=!1,this.showPanControl&&(o+=this.panControl.size,this.inCurrentFrame=!0),this.showZoomControl&&(o+=this.zoomInControl.size,this.inCurrentFrame=!0),this.showHeadingControl&&(o+=this.headingLeftControl.size,this.inCurrentFrame=!0),this.showTiltControl&&(o+=this.tiltDownControl.size,this.inCurrentFrame=!0),this.showExaggerationControl&&(o+=this.exaggerationDownControl.size,this.inCurrentFrame=!0),this.showFieldOfViewControl&&(o+=this.fovNarrowControl.size,this.inCurrentFrame=!0),i=this.placement.offsetForSize(t.navigatorState.viewport.width,t.navigatorState.viewport.height),e=this.alignment.offsetForSize(o,s),r=i[0]-e[0],n=i[1]-e[1],this.showPanControl&&(this.panControl.screenOffset.x=r,this.panControl.screenOffset.y=n,this.panControl.render(t),this.panControlCenter[0]=r+this.panControl.size/2,this.panControlCenter[1]=n+this.panControl.size/2,r+=this.panControl.size),this.showZoomControl&&(this.zoomOutControl.screenOffset.x=r,this.zoomOutControl.screenOffset.y=n,this.zoomInControl.screenOffset.x=r,this.zoomInControl.screenOffset.y=n+this.zoomOutControl.size,this.zoomOutControl.render(t),this.zoomInControl.render(t),r+=this.zoomOutControl.size),this.showHeadingControl&&(this.headingRightControl.screenOffset.x=r,this.headingRightControl.screenOffset.y=n,this.headingLeftControl.screenOffset.x=r,this.headingLeftControl.screenOffset.y=n+this.headingLeftControl.size,this.headingRightControl.render(t),this.headingLeftControl.render(t),r+=this.headingLeftControl.size),this.showTiltControl&&(this.tiltDownControl.screenOffset.x=r,this.tiltDownControl.screenOffset.y=n,this.tiltUpControl.screenOffset.x=r,this.tiltUpControl.screenOffset.y=n+this.tiltDownControl.size,this.tiltDownControl.render(t),this.tiltUpControl.render(t),r+=this.tiltDownControl.size),this.showExaggerationControl&&(this.exaggerationDownControl.screenOffset.x=r,this.exaggerationDownControl.screenOffset.y=n,this.exaggerationUpControl.screenOffset.x=r,this.exaggerationUpControl.screenOffset.y=n+this.exaggerationDownControl.size,this.exaggerationUpControl.render(t),this.exaggerationDownControl.render(t),r+=this.exaggerationDownControl.size),this.showFieldOfViewControl&&(this.fovNarrowControl.screenOffset.x=r,this.fovNarrowControl.screenOffset.y=n,this.fovWideControl.screenOffset.x=r,this.fovWideControl.screenOffset.y=n+this.fovNarrowControl.size,this.fovNarrowControl.render(t),this.fovWideControl.render(t))},h.prototype.setupInteraction=function(){var t=this.wwd,e=this,i=function(i){if(e.enabled&&!e.isTouchDevice){var r,n;e.highlightedControl&&(e.highlight(e.highlightedControl,!1),e.wwd.redraw()),i.type&&"mouseup"===i.type&&1===i.which&&e.activeControl?(e.activeControl=null,e.activeOperation=null,i.preventDefault()):(e.activeOperation?(e.activeOperation.call(e,i,null),i.preventDefault()):(r=e.pickControl(t.canvasCoordinates(i.clientX,i.clientY)),n=e.determineOperation(i,r),n&&n.call(e,i,r)),e.handleHighlight(i,r),e.wwd.redraw())}};t.addEventListener("mousedown",i),t.addEventListener("mouseup",i),t.addEventListener("mousemove",i),window.addEventListener("mouseup",i),window.addEventListener("mousemove",i);var r=function(i){if(this.isTouchDevice=!0,e.enabled){if(e.highlightedControl&&(e.highlight(e.highlightedControl,!1),e.wwd.redraw()),!i.type||"touchend"!==i.type&&"touchcancel"!==i.type)if(e.activeOperation)e.activeOperation.call(e,i,null),i.preventDefault();else{var r,n,o=i.changedTouches.item(0);r=e.pickControl(t.canvasCoordinates(o.clientX,o.clientY)),n=e.determineOperation(i,r),n&&n.call(e,i,r)}else e.activeControl&&e.isCurrentTouch(i)&&(e.activeControl=null,e.activeOperation=null,i.preventDefault());e.handleHighlight(i,r),e.wwd.redraw()}};t.addEventListener("touchstart",r),t.addEventListener("touchend",r),t.addEventListener("touchcancel",r),t.addEventListener("touchmove",r)},h.prototype.isControl=function(t){for(var e=0;e<this.controls.length;e++)if(this.controls[e]==t)return!0;return!1},h.prototype.pickControl=function(t){for(var e,i=t[0],r=this.wwd.canvas.height-t[1],n=0;n<this.controls.length;n++)if(e=this.controls[n],e.enabled&&i>=e.screenOffset.x&&i<=e.screenOffset.x+e.size&&r>=e.screenOffset.y&&r<=e.screenOffset.y+e.size)return e;return null},h.prototype.determineOperation=function(t,e){var i=null;return e&&e instanceof s&&(e===this.panControl?i=this.handlePan:e===this.zoomInControl||e===this.zoomOutControl?i=this.handleZoom:e===this.headingLeftControl||e===this.headingRightControl?i=this.handleHeading:e===this.tiltUpControl||e===this.tiltDownControl?i=this.handleTilt:e===this.exaggerationUpControl||e===this.exaggerationDownControl?i=this.handleExaggeration:e!==this.fovNarrowControl&&e!==this.fovWideControl||(i=this.handleFov)),i},h.prototype.isCurrentTouch=function(t){for(var e=0;e<t.changedTouches.length;e++)if(t.changedTouches.item(e).identifier===this.currentTouchId)return!0;return!1},h.prototype.handlePan=function(e,i){if("mousedown"===e.type||"mousemove"===e.type)this.currentEventPoint=this.wwd.canvasCoordinates(e.clientX,e.clientY);else if("touchstart"===e.type||"touchmove"===e.type){var n=e.changedTouches.item(0);this.currentEventPoint=this.wwd.canvasCoordinates(n.clientX,n.clientY)}if("mousedown"===e.type&&1===e.which||"touchstart"===e.type){this.activeControl=i,this.activeOperation=this.handlePan,e.preventDefault(),"touchstart"===e.type&&(this.currentTouchId=e.changedTouches.item(0).identifier);var o=this,s=function(){if(o.activeControl){var e=o.panControlCenter[0]-o.currentEventPoint[0],i=o.panControlCenter[1]-(o.wwd.viewport.height-o.currentEventPoint[1]),n=o.wwd.navigator.lookAtLocation.latitude,a=o.wwd.navigator.lookAtLocation.longitude,l=o.panIncrement*(o.wwd.navigator.range/o.wwd.globe.radiusAt(n,a)),h=o.wwd.navigator.heading+Math.atan2(e,i)*t.RADIANS_TO_DEGREES,u=l*Math.sqrt(e*e+i*i);r.greatCircleLocation(o.wwd.navigator.lookAtLocation,h,-u,o.wwd.navigator.lookAtLocation),o.wwd.redraw(),setTimeout(s,50)}};setTimeout(s,50)}},h.prototype.handleZoom=function(t,e){if("mousedown"===t.type&&1===t.which||"touchstart"===t.type){this.activeControl=e,this.activeOperation=this.handleZoom,t.preventDefault(),"touchstart"===t.type&&(this.currentTouchId=t.changedTouches.item(0).identifier);var i=this,r=function(){i.activeControl&&(i.activeControl===i.zoomInControl?i.wwd.navigator.range*=1-i.zoomIncrement:i.activeControl===i.zoomOutControl&&(i.wwd.navigator.range*=1+i.zoomIncrement),i.wwd.redraw(),setTimeout(r,50))};setTimeout(r,50)}},h.prototype.handleHeading=function(t,e){if("mousedown"===t.type&&1===t.which||"touchstart"===t.type){this.activeControl=e,this.activeOperation=this.handleHeading,t.preventDefault(),"touchstart"===t.type&&(this.currentTouchId=t.changedTouches.item(0).identifier);var i=this,r=function(){i.activeControl&&(i.activeControl===i.headingLeftControl?i.wwd.navigator.heading+=i.headingIncrement:i.activeControl===i.headingRightControl&&(i.wwd.navigator.heading-=i.headingIncrement),i.wwd.redraw(),setTimeout(r,50))};setTimeout(r,50)}},h.prototype.handleTilt=function(t,e){if("mousedown"===t.type&&1===t.which||"touchstart"===t.type){this.activeControl=e,this.activeOperation=this.handleTilt,t.preventDefault(),"touchstart"===t.type&&(this.currentTouchId=t.changedTouches.item(0).identifier);var i=this,r=function(){i.activeControl&&(i.activeControl===i.tiltUpControl?i.wwd.navigator.tilt=Math.max(0,i.wwd.navigator.tilt-i.tiltIncrement):i.activeControl===i.tiltDownControl&&(i.wwd.navigator.tilt=Math.min(90,i.wwd.navigator.tilt+i.tiltIncrement)),i.wwd.redraw(),setTimeout(r,50))};setTimeout(r,50)}},h.prototype.handleExaggeration=function(t,e){if("mousedown"===t.type&&1===t.which||"touchstart"===t.type){this.activeControl=e,this.activeOperation=this.handleExaggeration,t.preventDefault(),"touchstart"===t.type&&(this.currentTouchId=t.changedTouches.item(0).identifier);var i=this,r=function(){i.activeControl&&(i.activeControl===i.exaggerationUpControl?i.wwd.verticalExaggeration+=i.exaggerationIncrement:i.activeControl===i.exaggerationDownControl&&(i.wwd.verticalExaggeration=Math.max(1,i.wwd.verticalExaggeration-i.exaggerationIncrement)),i.wwd.redraw(),setTimeout(r,50))};setTimeout(r,50)}},h.prototype.handleFov=function(t,e){if("mousedown"===t.type&&1===t.which||"touchstart"===t.type){this.activeControl=e,this.activeOperation=this.handleFov,t.preventDefault(),"touchstart"===t.type&&(this.currentTouchId=t.changedTouches.item(0).identifier);var i=this,r=function(){i.activeControl&&(i.activeControl===i.fovWideControl?i.wwd.navigator.fieldOfView=Math.max(90,i.wwd.navigator.fieldOfView+i.fieldOfViewIncrement):i.activeControl===i.fovNarrowControl&&(i.wwd.navigator.fieldOfView=Math.min(0,i.wwd.navigator.fieldOfView-i.fieldOfViewIncrement)),i.wwd.redraw(),setTimeout(r,50))};setTimeout(r,50)}},h.prototype.handleHighlight=function(t,e){this.activeControl?this.highlight(this.activeControl,!0):e&&this.isControl(e)&&this.highlight(e,!0)},h.prototype.highlight=function(t,e){t.opacity=e?this._activeOpacity:this._inactiveOpacity,e?this.highlightedControl=t:this.highlightedControl=null},h}),i("util/WcsTileUrlBuilder",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i,r,n){if(!i||0===i.length)throw new t(e.logMessage(e.LEVEL_SEVERE,"WcsTileUrlBuilder","constructor","The WCS service address is missing."));if(!r||0===r.length)throw new t(e.logMessage(e.LEVEL_SEVERE,"WcsTileUrlBuilder","constructor","The WCS coverage name is missing."));this.serviceAddress=i,this.coverageName=r,this.wcsVersion=n&&n.length>0?n:"1.0.0",this.crs="EPSG:4326"};return i.prototype.urlForTile=function(r,n){if(!r)throw new t(e.logMessage(e.LEVEL_SEVERE,"WcsUrlBuilder","urlForTile","missingTile"));if(!n)throw new t(e.logMessage(e.LEVEL_SEVERE,"WcsUrlBuilder","urlForTile","The coverage format is null or undefined."));var o=r.sector,s=i.fixGetCoverageString(this.serviceAddress);return s.search(/service=wcs/i)<0&&(s+="service=WCS"),s+="&request=GetCoverage",s=s+"&version="+this.wcsVersion,s=s+"&coverage="+this.coverageName,s=s+"&format="+n,s=s+"&width="+r.tileWidth,s=s+"&height="+r.tileHeight,s=s+"&crs="+this.crs,s+="&bbox=",s=s+o.minLongitude+","+o.minLatitude+",",s=s+o.maxLongitude+","+o.maxLatitude,s=s.replace(" ","%20")},i.fixGetCoverageString=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"WcsTileUrlBuilder","fixGetCoverageString","The specified service address is null or undefined."));var r=i.indexOf("?");return r<0?i+="?":r!==i.length-1&&(r=i.search(/&$/),r<0&&(i+="&")),i},i}),i("ogc/OwsLanguageString",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"LanguageString","constructor","missingDomElement"));this.value=i.textContent;var r=i.getAttribute("lang");r&&(this.lang=r)};return i}),i("ogc/OwsConstraint",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"OwsConstraint","constructor","missingDomElement"));this.name=i.getAttribute("name");for(var r=i.children,n=0;n<r.length;n++){var o=r[n];if("AllowedValues"===o.localName){this.allowedValues=this.allowedValues||[];for(var s=0;s<o.children.length;s++)"Value"===o.children[s].localName&&this.allowedValues.push(o.children[s].textContent)}else"AnyValue"===o.localName?this.anyValue=!0:"NoValues"===o.localName&&(this.noValues=!0)}};return i}),i("ogc/OwsOperationsMetadata",["../error/ArgumentError","../util/Logger","../ogc/OwsConstraint"],function(t,e,i){"use strict";var r=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"OwsOperationsMetadata","constructor","missingDomElement"));for(var n=i.children,o=0;o<n.length;o++){var s=n[o];"Operation"===s.localName&&(this.operation=this.operation||[],this.operation.push(r.assembleOperation(s)))}};return r.assembleOperation=function(t){var e={};e.name=t.getAttribute("name");for(var i=t.children,n=0;n<i.length;n++){var o=i[n];"DCP"===o.localName&&(e.dcp=e.dcp||[],e.dcp.push(r.assembleDcp(o)))}return e},r.assembleDcp=function(t){for(var e={},i=t.children,n=0;n<i.length;n++){var o=i[n];"HTTP"===o.localName&&(e.http=r.assembleHttp(o))}return e},r.assembleHttp=function(t){for(var e={},i=t.children,n=0;n<i.length;n++){var o=i[n];"Get"===o.localName&&(e.get=e.get||[],e.get.push(r.assembleGet(o)))}return e},r.assembleGet=function(t){var e={};e.href=t.getAttribute("xlink:href");for(var r=t.children,n=0;n<r.length;n++){var o=r[n];"Constraint"===o.localName&&(e.constraint=e.constraint||[],e.constraint.push(new i(o)))}return e},r}),i("ogc/OwsServiceIdentification",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"OwsServiceIdentification","constructor","missingDomElement"));for(var r=i.children,n=0;n<r.length;n++){var o=r[n];"ServiceType"===o.localName?this.serviceType=o.textContent:"ServiceTypeVersion"===o.localName?this.serviceTypeVersion=o.textContent:"Profile"===o.localName?(this.profile=this.profiles||[],this.profile.push(o.textContent)):"Title"===o.localName?(this.title=this.title||[],this.title.push(o.textContent)):"Abstract"===o.localName?(this.abstract=this.title||[],this.abstract.push(o.textContent)):"Fees"===o.localName?this.fees=o.textContent:"AccessConstraints"===o.localName&&(this.accessConstraints=this.accessConstraints||[],this.accessConstraints.push(o.textContent))}};return i}),i("ogc/OwsServiceProvider",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"OwsServiceProvider","constructor","missingDomElement"));for(var r=i.children,n=0;n<r.length;n++){var o=r[n];"ProviderName"===o.localName?this.providerName=o.textContent:"ProviderSite"===o.localName&&(this.providerSite=o.getAttribute("xlink:href"))}};return i}),i("ogc/WfsCapabilities",["../error/ArgumentError","../util/Logger","../ogc/OwsLanguageString","../ogc/OwsOperationsMetadata","../ogc/OwsServiceIdentification","../ogc/OwsServiceProvider"],function(t,e,i,r,n,o){"use strict";var s=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"WfsCapabilities","constructor","No XML DOM specified."));this.assembleDocument(i)};return s.prototype.assembleDocument=function(t){var e=t.documentElement;this.version=e.getAttribute("version"),this.updateSequence=e.getAttribute("updateSequence");for(var i=e.children||e.childNodes,s=0;s<i.length;s++){var a=i[s];"ServiceIdentification"===a.localName?this.serviceIdentification=new n(a):"ServiceProvider"===a.localName?this.serviceProvider=new o(a):"OperationsMetadata"===a.localName?this.operationsMetadata=new r(a):"FeatureTypeList"===a.localName?this.featureTypeList=this.assembleFeatureTypeList(a):"Filter_Capabilities"===a.localName&&(this.filterCapabilities=this.assembleFilterCapabilities(a))}},s.prototype.assembleFeatureTypeList=function(t){for(var i={},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];if("Operations"==o.localName){i.operations=i.operations||[];try{i.operations=s.assembleOperations(o)}catch(t){e.logMessage(e.LEVEL_SEVERE,"WfsCapabilities","constructor","Exception reading WFS operations description: "+t.message)}}else if("FeatureType"==o.localName){i.featureType=i.featureType||[];try{i.featureType.push(s.assembleFeatureType(o))}catch(t){e.logMessage(e.LEVEL_SEVERE,"WfsCapabilities","constructor","Exception reading WFS operations description: "+t.message)}}}return i},s.prototype.assembleFilterCapabilities=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Conformance"===n.localName?e.conformance=s.assembleConformance(n):"Id_Capabilities"===n.localName?e.idCapabilities=s.assembleIdCapabilities(n):"Scalar_Capabilities"===n.localName?e.scalarCapabilities=s.assembleScalarCapabilities(n):"Spatial_Capabilities"===n.localName?e.spatialCapabilities=s.assembleSpatialCapabilities(n):"Functions"===n.localName&&(e.functions=s.assembleFunctions(n))}return e},s.assembleOperations=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Operation"==n.localName&&e.push(n.textContent)}return e},s.assembleFeatureType=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Name"==n.localName?e.name=n.textContent:"Title"==n.localName?e.title=n.textContent:"Abstract"==n.localName?e.abstract=n.textContent:"Keywords"==n.localName?(e.keywords=e.keywords||[],e.keywords=s.assembleKeywords(n)):"DefaultSRS"==n.localName?e.defaultSRS=n.textContent:"OtherSRS"==n.localName?(e.otherSRS=e.otherSRS||[],e.otherSRS.push(n.textContent)):"WGS84BoundingBox"==n.localName?e.wgs84BoundingBox=s.assembleBoundingBox(n):"DefaultCRS"==n.localName?e.defaultCRS=n.textContent:"OtherCRS"==n.localName?(e.otherCRS=e.otherCRS||[],e.otherCRS.push(n.textContent)):"OutputFormats"==n.localName?e.outputFormats=s.assembleOutputFormats(n):"MetadataURL"==n.localName&&(e.metadataUrl=s.assembleMetadataUrl(n))}return e},s.assembleBoundingBox=function(t){var e={},i=t.getAttribute("crs");i&&(e.crs=i);for(var r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];if("LowerCorner"===o.localName){var s=o.textContent.split(" ");e.lowerCorner=[parseFloat(s[0]),parseFloat(s[1])]}else if("UpperCorner"===o.localName){var a=o.textContent.split(" ");e.upperCorner=[parseFloat(a[0]),parseFloat(a[1])]}}return e},s.assembleOutputFormats=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Format"===n.localName&&e.push(n.textContent)}return e},s.assembleMetadataUrl=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];e.format=n.getAttribute("format"),e.type=n.getAttribute("type")}return outputFormats},s.assembleKeywords=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Keyword"===n.localName&&e.push(n.textContent)}return e},s.assembleConformance=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];if("Constraint"===n.localName){var o;o=s.assembleConstraint(n),o.name=n.getAttribute("name"),e.push(o)}}return e},s.assembleConstraint=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"DefaultValue"===n.localName&&(e.defaultValue=n.textContent)}return e},s.assembleIdCapabilities=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"ResourceIdentifier"===n.localName&&(e.resourceIdentifier=n.getAttribute("name"))}return e},s.assembleScalarCapabilities=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"ComparisonOperators"===n.localName?e.comparisonOperators=s.assembleComparisonOperators(n):"ArithmeticOperators"===n.localName&&(e.arithmeticOperators=s.assembleArithmeticOperators(n))}return e},s.assembleComparisonOperators=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"ComparisonOperator"===n.localName&&e.push(n.textContent)}return e},s.assembleArithmeticOperators=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Functions"===n.localName&&(e.functions=s.assembleArithmeticFunctions(n))}return e},s.assembleArithmeticFunctions=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"FunctionNames"===n.localName&&(e=s.assembleFunctionNames(n))}return e},s.assembleFunctionNames=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];if("FunctionName"===n.localName){var o={name:n.textContent,nArgs:n.getAttribute("nArgs")};e.push(o)}}return e},s.assembleSpatialCapabilities=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"GeometryOperands"===n.localName?e.geometryOperands=s.assembleGeometryOperands(n):"SpatialOperators"===n.localName&&(e.spatialOperators=s.assembleSpatialOperators(n))}return e},s.assembleGeometryOperands=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"GeometryOperand"===n.localName&&e.push(n.getAttribute("name"))}return e},s.assembleSpatialOperators=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"SpatialOperator"===n.localName&&e.push(n.getAttribute("name"))}return e},s.assembleFunctions=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Function"===n.localName&&e.push(s.assembleFunction(n))}return e},s.assembleFunction=function(t){var e={};e.name=t.getAttribute("name");for(var i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Returns"===n.localName?e.returns=n.textContent:"Arguments"===n.localName&&(e.arguments=s.assembleArguments(n))}return e},s.assembleArguments=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Argument"===n.localName&&e.push(s.assembleArgument(n))}return e},s.assembleArgument=function(t){var e={};e.name=t.getAttribute("name");for(var i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Type"===n.localName&&(e.type=n.textContent)}return e},s}),i("ogc/WmsLayerCapabilities",["../error/ArgumentError","../util/Logger"],function(t,e){"use strict";var i=function(i,r){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsLayerCapabilities","constructor","Layer element is null or undefined."));this.parent=r,this.layers,this.name,this.title,this.abstract,this.keywordList,this.identifiers,this.metadataUrls,this.dataUrls,this.featureListUrls,this.assembleLayer(i)};return Object.defineProperties(i.prototype,{capability:{get:function(){for(var t=this;t&&t instanceof i;)t=t.parent;return t}},queryable:{get:function(){return i.replace(this,"_queryable")}},cascaded:{get:function(){return i.replace(this,"_cascaded")}},opaque:{get:function(){return i.replace(this,"_opaque")}},noSubsets:{get:function(){return i.replace(this,"_noSubsets")}},fixedWidth:{get:function(){return i.replace(this,"_fixedWidth")}},fixedHeight:{get:function(){return i.replace(this,"_fixedHeight")}},styles:{get:function(){return i.accumulate(this,"_styles",[])}},crses:{get:function(){return i.accumulate(this,"_crses",[])}},srses:{get:function(){return i.accumulate(this,"_srses",[])}},geographicBoundingBox:{get:function(){return i.replace(this,"_geographicBoundingBox")}},latLonBoundingBox:{get:function(){return i.replace(this,"_latLonBoundingBox")}},boundingBoxes:{get:function(){return i.replace(this,"_boundingBoxes")}},dimensions:{get:function(){for(var t=[],e=this;e&&e instanceof i;)e._dimensions&&e._dimensions.length>0&&e._dimensions.forEach(function(e){var i=e.name,r=!0;t.forEach(function(t){t.name===i&&(r=!1)}),r&&t.push(e)}),e=e.parent;return t.length>0?t:void 0}},extents:{get:function(){for(var t=[],e=this;e&&e instanceof i;)e._extents&&e._extents.length>0&&e._extents.forEach(function(e){var i=e.name,r=!0;t.forEach(function(t){t.name===i&&(r=!1)}),r&&t.push(e)}),e=e.parent;return t.length>0?t:void 0}},attribution:{get:function(){return i.replace(this,"_attribution")}},authorityUrls:{get:function(){return i.accumulate(this,"_authorityUrls",[])}},minScaleDenominator:{get:function(){return i.replace(this,"_minScaleDenominator")}},maxScaleDenominator:{get:function(){return i.replace(this,"_maxScaleDenominator")}},scaleHint:{get:function(){return i.replace(this,"_scaleHint")}}}),i.accumulate=function(t,e,r){for(;t&&t instanceof i;){var n=t[e];if(n)for(var o=0;o<n.length;o++)r.push(n[o]);t=t.parent}return r.length>0?r:null},i.replace=function(t,e){for(;t&&t instanceof i;){var r=t[e];if(r)return r;t=t.parent}},i.prototype.assembleLayer=function(t){var e,r;e=t.getAttribute("queryable"),e&&(this._queryable="1"===e||"true"===e),e=t.getAttribute("opaque"),e&&(this._opaque="1"===e||"true"===e),e=t.getAttribute("noSubsets"),e&&(this._noSubsets="1"===e||"true"===e),e=t.getAttribute("cascaded"),e&&(this._cascaded=parseInt("10")),e=t.getAttribute("fixedWidth"),e&&(this._fixedWidth=parseInt("10")),e=t.getAttribute("fixedHeight"),e&&(this._fixedHeight=parseInt("10"));var n=t.children||t.childNodes;for(r=0;r<n.length;r++){var o=n[r];if("Layer"===o.localName)this.layers||(this.layers=[]),this.layers.push(new i(o,this));else if("Name"===o.localName)this.name=o.textContent;else if("Title"===o.localName)this.title=o.textContent;else if("Abstract"===o.localName)this.abstract=o.textContent;else if("KeywordList"===o.localName){this.keywordList=this.keywordList||[];for(var s=o.children||o.childNodes,a=0;a<s.length;a++){var l=s[a];"Keyword"===l.localName&&this.keywordList.push(l.textContent)}}else"Style"===o.localName?(this._styles||(this._styles=[]),this._styles.push(i.assembleStyle(o))):"CRS"===o.localName?(this._crses||(this._crses=[]),this._crses.push(o.textContent)):"SRS"===o.localName?(this._srses||(this._srses=[]),this._srses.push(o.textContent)):"EX_GeographicBoundingBox"===o.localName?this._geographicBoundingBox=i.assembleGeographicBoundingBox(o):"LatLonBoundingBox"===o.localName?this._geographicBoundingBox=i.assembleLatLonBoundingBox(o):"BoundingBox"===o.localName?(this._boundingBoxes||(this._boundingBoxes=[]),
this._boundingBoxes.push(i.assembleBoundingBox(o))):"Dimension"===o.localName?(this._dimensions||(this._dimensions=[]),this._dimensions.push(i.assembleDimension(o))):"Extent"===o.localName?(this._extents||(this._extents=[]),this._extents.push(i.assembleDimension(o))):"Attribution"===o.localName?this._attribution=i.assembleAttribution(o):"AuthorityURL"===o.localName?(this._authorityUrls||(this._authorityUrls=[]),this._authorityUrls.push(i.assembleAuthorityUrl(o))):"Identifier"===o.localName?(this.identifiers||(this.identifiers=[]),this.identifiers.push(i.assembleIdentifier(o))):"MetadataURL"===o.localName?(this.metadataUrls||(this.metadataUrls=[]),this.metadataUrls.push(i.assembleMetadataUrl(o))):"DataURL"===o.localName?(this.dataUrls||(this.dataUrls=[]),this.dataUrls.push(i.assembleUrl(o))):"FeatureListURL"===o.localName?(this.featureListUrls||(this.featureListUrls=[]),this.featureListUrls.push(i.assembleUrl(o))):"MinScaleDenominator"===o.localName?this._minScaleDenominator=parseFloat(o.textContent):"MaxScaleDenominator"===o.localName?this._maxScaleDenominator=parseFloat(o.textContent):"ScaleHint"===o.localName&&(this._scaleHint={},this._scaleHint.min=i.getFloatAttribute(o,"min"),this._scaleHint.max=i.getFloatAttribute(o,"max"))}},i.assembleStyle=function(t){for(var e={},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];"Name"===o.localName?e.name=o.textContent:"Title"===o.localName?e.title=o.textContent:"Abstract"===o.localName?e.abstract=o.textContent:"LegendURL"===o.localName?(e.legendUrls||(e.legendUrls=[]),e.legendUrls.push(i.assembleLegendUrl(o))):"StyleSheetURL"===o.localName?e.styleSheetUrl=i.assembleUrl(o):"StyleURL"===o.localName&&(e.styleUrl=i.assembleUrl(o))}return e},i.assembleGeographicBoundingBox=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"westBoundLongitude"===n.localName?e.westBoundLongitude=parseFloat(n.textContent):"eastBoundLongitude"===n.localName?e.eastBoundLongitude=parseFloat(n.textContent):"southBoundLatitude"===n.localName?e.southBoundLatitude=parseFloat(n.textContent):"northBoundLatitude"===n.localName&&(e.northBoundLatitude=parseFloat(n.textContent))}return e},i.assembleLatLonBoundingBox=function(t){var e={};return e.minx=i.getFloatAttribute(t,"minx"),e.miny=i.getFloatAttribute(t,"miny"),e.maxx=i.getFloatAttribute(t,"maxx"),e.maxy=i.getFloatAttribute(t,"maxy"),e},i.assembleBoundingBox=function(t){var e={};return e.crs=t.getAttribute("CRS"),e.minx=i.getFloatAttribute(t,"minx"),e.miny=i.getFloatAttribute(t,"miny"),e.maxx=i.getFloatAttribute(t,"maxx"),e.maxy=i.getFloatAttribute(t,"maxy"),e.resx=i.getFloatAttribute(t,"resx"),e.resy=i.getFloatAttribute(t,"resy"),e},i.assembleDimension=function(t){var e={};return e.name=t.getAttribute("name"),e.units=t.getAttribute("units"),e.unitSymbol=t.getAttribute("unitSymbol"),e.default=t.getAttribute("default"),e.multipleValues=t.getAttribute("multipleValues"),e.multipleValues&&(e.multipleValues="true"===e.multipleValues||"1"===e.multipleValues),e.nearestValue=t.getAttribute("nearestValue"),e.nearestValue&&(e.nearestValue="true"===e.nearestValue||"1"===e.nearestValue),e.current=t.getAttribute("current"),e.current&&(e.current="true"===e.current||"1"===e.current),e.content=t.textContent,e},i.assembleAttribution=function(t){for(var e={},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];"Title"===o.localName?e.title=o.textContent:"OnlineResource"===o.localName?e.url=o.getAttribute("xlink:href"):"LogoUrul"===o.localName&&(e.logoUrl=i.assembleLogoUrl(o))}return e},i.assembleAuthorityUrl=function(t){var e={};e.name=t.getAttribute("name");for(var i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"OnlineResource"===n.localName&&(e.url=n.getAttribute("xlink:href"))}return e},i.assembleIdentifier=function(t){var e={};return e.authority=t.getAttribute("authority"),e.content=t.textContent,e},i.assembleMetadataUrl=function(t){var e={};e.type=t.getAttribute("type");for(var i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Format"===n.localName?e.format=n.textContent:"OnlineResource"===n.localName&&(e.url=n.getAttribute("xlink:href"))}return e},i.assembleLegendUrl=function(t){var e={};e.width=i.getIntegerAttribute(t,"width"),e.height=i.getIntegerAttribute(t,"height");for(var r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];"Format"===o.localName?e.format=o.textContent:"OnlineResource"===o.localName&&(e.url=o.getAttribute("xlink:href"))}return e},i.assembleLogoUrl=function(t){var e={};e.width=i.getIntegerAttribute(t,"width"),e.height=i.getIntegerAttribute(t,"height");for(var r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];"Format"===o.localName?e.format=o.textContent:"OnlineResource"===o.localName&&(e.url=o.getAttribute("xlink:href"))}return e},i.assembleUrl=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Format"===n.localName?e.format=n.textContent:"OnlineResource"===n.localName&&(e.url=n.getAttribute("xlink:href"))}return e},i.getIntegerAttribute=function(t,e){var i=t.getAttribute(e);return i=i?parseInt(i):void 0},i.getFloatAttribute=function(t,e){var i=t.getAttribute(e);return i=i?parseFloat(i):void 0},i}),i("ogc/WmsCapabilities",["../error/ArgumentError","../util/Logger","../ogc/WmsLayerCapabilities"],function(t,e,i){"use strict";var r=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmsCapabilities","constructor","No XML DOM specified."));this.assembleDocument(i)};return r.prototype.assembleDocument=function(t){var e=t.documentElement;this.version=e.getAttribute("version"),this.updateSequence=e.getAttribute("updateSequence");for(var i=e.children||e.childNodes,r=0;r<i.length;r++){var n=i[r];"Service"===n.localName?this.service=this.assembleService(n):"Capability"===n.localName&&(this.capability=this.assembleCapability(n))}},r.prototype.assembleService=function(t){for(var e={capsDoc:this},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Name"===n.localName?e.name=n.textContent:"Title"===n.localName?e.title=n.textContent:"Abstract"===n.localName?e.abstract=n.textContent:"KeywordList"===n.localName?e.keywordList=this.assembleKeywordList(n):"OnlineResource"===n.localName?e.onlineResource=n.getAttribute("xlink:href"):"Fees"===n.localName?e.fees=n.textContent:"AccessConstraints"===n.localName?e.accessConstraints=n.textContent:"LayerLimit"==n.localName?e.layerLimit=parseInt(n.textContent):"MaxWidth"==n.localName?e.maxWidth=parseInt(n.textContent):"MaxHeight"==n.localName?e.maxHeight=parseInt(n.textContent):"ContactInformation"===n.localName&&(e.contactInformation=this.assembleContactInformation(n))}return e},r.prototype.assembleKeywordList=function(t){for(var e=[],i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Keyword"===n.localName&&e.push(n.textContent)}return e},r.prototype.assembleContactInformation=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"ContactPersonPrimary"===n.localName?e.contactPersonPrimary=this.assembleContactPersonPrimary(n):"ContactPosition"===n.localName?e.contactPosition=n.textContent:"ContactVoiceTelephone"===n.localName?e.contactVoiceTelephone=n.textContent:"ContactFacsimileTelephone"===n.localName?e.contactFacsimileTelephone=n.textContent:"ContactElectronicMailAddress"===n.localName?e.contactElectronicMailAddress=n.textContent:"ContactAddress"===n.localName&&(e.contactAddress=this.assembleContactAddress(n))}return e},r.prototype.assembleContactPersonPrimary=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"ContactPerson"===n.localName?e.contactPerson=n.textContent:"ContactOrganization"===n.localName&&(e.contactOrganization=n.textContent)}return e},r.prototype.assembleContactAddress=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"AddressType"===n.localName?e.addressType=n.textContent:"Address"===n.localName?e.address=n.textContent:"City"===n.localName?e.city=n.textContent:"StateOrProvince"===n.localName?e.stateOrProvince=n.textContent:"PostCode"===n.localName?e.postCode=n.textContent:"Country"===n.localName&&(e.country=n.textContent)}return e},r.prototype.assembleCapability=function(t){for(var e={capsDoc:this},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];"Request"===o.localName?e.request=this.assembleRequests(o):"Exception"===o.localName?e.exception=this.assembleException(o):"Layer"===o.localName&&(e.layers=e.layers||[],e.layers.push(new i(o,e)))}return e},r.prototype.assembleRequests=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"GetCapabilities"===n.localName?e.getCapabilities=this.assembleRequest(n):"GetMap"===n.localName?e.getMap=this.assembleRequest(n):"GetFeatureInfo"===n.localName&&(e.getFeatureInfo=this.assembleRequest(n))}return e},r.prototype.assembleRequest=function(t){for(var e={name:t.localName},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];if("Format"===n.localName)e.formats=e.formats||[],e.formats.push(n.textContent);else if("DCPType"===n.localName)for(var o=n.children||n.childNodes,s=0;s<o.length;s++){var a=o[s];if("HTTP"===a.localName)for(var l=a.children||a.childNodes,h=0;h<l.length;h++){var u=l[h];if("Get"===u.localName)for(var c=u.children||u.childNodes,d=0;d<c.length;d++){var p=c[d];"OnlineResource"===p.localName&&(e.url=p.getAttribute("xlink:href"))}}}}return e},r.prototype.assembleException=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"Format"===n.localName&&(e.formats=e.formats||[],e.formats.push(n.textContent))}return e},r}),i("layer/WmsLayer",["../error/ArgumentError","../geom/Location","../util/Logger","../util/PeriodicTimeSequence","../geom/Sector","../layer/TiledImageLayer","../util/WmsUrlBuilder"],function(t,e,i,r,n,o,s){"use strict";var a=function(e,r){if(!e)throw new t(i.logMessage(i.LEVEL_SEVERE,"WmsLayer","constructor","No configuration specified."));var n=e.service+e.layerNames+e.styleNames;r&&(n+=r),o.call(this,e.sector,e.levelZeroDelta,e.numLevels,e.format,n,e.size,e.size),this.displayName=e.title,this.pickEnabled=!1,this.urlBuilder=new s(e.service,e.layerNames,e.styleNames,e.version,r),e.coordinateSystem&&(this.urlBuilder.crs=e.coordinateSystem),this.timeString=r};return a.prototype=Object.create(o.prototype),a.formLayerConfiguration=function(t){var i={title:t.title,version:t.capability.capsDoc.version},r=t.geographicBoundingBox||t.latLonBoundingBox;r&&r.westBoundLongitude?i.sector=new n(r.southBoundLatitude,r.northBoundLatitude,r.westBoundLongitude,r.eastBoundLongitude):r&&r.minx?i.sector=new n(r.miny,r.maxy,r.minx,r.maxx):i.sector=n.FULL_SPHERE,i.levelZeroDelta=new e(36,36),i.numLevels=19,i.size=256,i.layerNames=t.name;var o=t.capability.request.getMap,s=o.formats;s.indexOf("image/png")>=0?i.format="image/png":s.indexOf("image/jpeg")>=0?i.format="image/jpeg":s.indexOf("image/tiff")>=0?i.format="image/tiff":s.indexOf("image/gif")>=0&&(i.format="image/gif"),i.service=o.url;var l=t.crses;l||(l=t.srses),l&&(l.indexOf("EPSG:4326")>=0||l.indexOf("epsg:4326")>=0?i.coordinateSystem="EPSG:4326":(l.indexOf("CRS84")>=0||l.indexOf("CRS:84")>=0)&&(i.coordinateSystem="CRS:84"));var h=a.parseTimeDimensions(t);return h&&h.length>0&&(i.timeSequences=h),i},a.parseTimeDimensions=function(t){var e=t.extents||t.dimensions,i=null;if(e){i=[];for(var n=0;n<e.length;n++){var o=e[n];if("time"===o.name.toLowerCase()&&(!o.units||"iso8601"===o.units.toLowerCase()))for(var s=o.content.split(","),a=0;a<s.length;a++){var l=s[a],h=l.split("/");1===h.length?i.push(new Date(l)):3===h.length&&i.push(new r(l))}}}return i},a}),i("layer/WmsTimeDimensionedLayer",["../error/ArgumentError","../layer/Layer","../util/Logger","../layer/WmsLayer"],function(t,e,i,r){"use strict";var n=function(r){if(!r)throw new t(i.logMessage(i.LEVEL_SEVERE,"WmsTimeDimensionedLayer","constructor","No configuration specified."));e.call(this,"WMS Time Dimensioned Layer"),this.config=r,this.displayName=r.title,this.pickEnabled=!1,this.layers={}};return n.prototype=Object.create(e.prototype),n.prototype.doRender=function(t){if(this.time){var e=this.time.toISOString(),i=this.layers[e];i||(i=new r(this.config,e),this.layers[e]=i),i.opacity=this.opacity,i.doRender(t),this.inCurrentFrame=i.inCurrentFrame}},n}),i("ogc/WmtsLayerCapabilities",["../error/ArgumentError","../util/Logger","../ogc/OwsLanguageString","../ogc/WmsCapabilities"],function(t,e,i,r){"use strict";var n=function(i,r){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmtsLayerCapabilities","constructor","missingDomElement"));this.capabilities=r,this.identifier,this.title,this.abstract,this.keywords,this.wgs84BoundingBox,this.boundingBox,this.styles,this.formats,this.infoFormat,this.dimension,this.metadata,this.tileMatrixSetLink,this.resourceUrl,this.assembleLayer(i)};return n.prototype.assembleLayer=function(t){for(var e=t.children||t.childNodes,r=0;r<e.length;r++){var o=e[r];"Identifier"===o.localName?this.identifier=o.textContent:"Title"===o.localName?(this.title=this.title||[],this.title.push(new i(o))):"Abstract"===o.localName?(this.abstract=this.abstract||[],this.abstract.push(new i(o))):"WGS84BoundingBox"===o.localName?this.wgs84BoundingBox=n.assembleBoundingBox(o):"BoundingBox"===o.localName?(this.boundingBox=this.boundingBox||[],this.boundingBox.push(n.assembleBoundingBox(o))):"Style"===o.localName?(this.style=this.style||[],this.style.push(n.assembleStyle(o))):"Format"===o.localName?(this.format=this.format||[],this.format.push(o.textContent)):"InfoFormat"===o.localName?(this.infoFormat=this.infoFormat||[],this.infoFormat.push(o.textContent)):"Dimension"===o.localName?(this.dimension=this.dimension||[],this.dimension.push(n.assembleDimension(o))):"Metadata"===o.localName?(this.metadata=this.metadata||[],this.metadata.push(n.assembleMetadata(o))):"ResourceURL"===o.localName?(this.resourceUrl=this.resourceUrl||[],this.resourceUrl.push(n.assembleResourceUrl(o))):"TileMatrixSetLink"===o.localName&&(this.tileMatrixSetLink=this.tileMatrixSetLink||[],this.tileMatrixSetLink.push(n.assembleTileMatrixSetLink(o)))}},n.assembleStyle=function(t){var e={};e.isDefault=t.getAttribute("isDefault");for(var r=t.children||t.childNodes,o=0;o<r.length;o++){var s=r[o];"Identifier"===s.localName?e.identifier=s.textContent:"Title"===s.localName?(e.title=e.title||[],e.title.push(new i(s))):"Abstract"===s.localName?(e.abstract=e.abstract||[],e.abstract.push(new i(s))):"LegendURL"===s.localName&&(e.legendUrl=e.legendUrl||[],e.legendUrl.push(n.assembleLegendUrl(s)))}return e},n.assembleBoundingBox=function(t){var e={},i=t.getAttribute("crs");i&&(e.crs=i);for(var r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];if("LowerCorner"===o.localName){var s=o.textContent.split(" ");e.lowerCorner=[parseFloat(s[0]),parseFloat(s[1])]}else if("UpperCorner"===o.localName){var a=o.textContent.split(" ");e.upperCorner=[parseFloat(a[0]),parseFloat(a[1])]}}return e},n.assembleDimension=function(t){for(var e={},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];"Identifier"===o.localName?e.identifier=o.textContent:"Title"===o.localName?(e.title=e.title||[],e.title.push(new i(o))):"Abstract"===o.localName?(e.abstract=e.abstract||[],e.abstract.push(new i(o))):"UOM"===o.localName?e.uom={name:o.getAttribute("name"),reference:o.getAttribute("reference")}:"UnitSymbol"==o.localName?e.unitSymbol=o.textContent:"Default"===o.localName?e.default=o.textContent:"Current"===o.localName?e.current="true"===o.textContent:"Value"===o.localName&&(e.value=e.value||[],e.value.push(o.textContent))}return e},n.assembleMetadata=function(t){var e={};return e},n.assembleResourceUrl=function(t){var e={};return e.format=t.getAttribute("format"),e.resourceType=t.getAttribute("resourceType"),e.template=t.getAttribute("template"),e},n.assembleLegendUrl=function(t){var e={};return e.format=t.getAttribute("format"),e.minScaleDenominator=t.getAttribute("minScaleDenominator"),e.maxScaleDenominator=t.getAttribute("maxScaleDenominator"),e.href=t.getAttribute("xlink:href"),e.width=t.getAttribute("width"),e.height=t.getAttribute("height"),e},n.assembleTileMatrixSetLink=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var o=i[r];"TileMatrixSet"===o.localName?e.tileMatrixSet=o.textContent:"TileMatrixSetLimits"===o.localName&&(e.tileMatrixSetLimits=n.assembleTileMatrixSetLimits(o))}return e},n.assembleTileMatrixSetLimits=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var o=i[r];"TileMatrixLimits"===o.localName&&(e.tileMatrixLimits=e.tileMatrixLimits||[],e.tileMatrixLimits.push(n.assembleTileMatrixLimits(o)))}return e},n.assembleTileMatrixLimits=function(t){for(var e={},i=t.children||t.childNodes,r=0;r<i.length;r++){var n=i[r];"TileMatrix"===n.localName?e.tileMatrix=n.textContent:"MinTileRow"===n.localName?e.minTileRow=parseInt(n.textContent):"MaxTileRow"===n.localName?e.maxTileRow=parseInt(n.textContent):"MinTileCol"===n.localName?e.minTileCol=parseInt(n.textContent):"maxTileCol"===n.localName&&(e.maxTileCol=parseInt(n.textContent))}return e},n}),i("ogc/WmtsCapabilities",["../error/ArgumentError","../util/Logger","../ogc/OwsLanguageString","../ogc/OwsOperationsMetadata","../ogc/OwsServiceIdentification","../ogc/OwsServiceProvider","../ogc/WmsCapabilities","../ogc/WmtsLayerCapabilities"],function(t,e,i,r,n,o,s,a){"use strict";var l=function(i){if(!i)throw new t(e.logMessage(e.LEVEL_SEVERE,"WmtsCapabilities","constructor","No XML DOM specified."));this.assembleDocument(i)};return l.prototype.assembleDocument=function(t){var e=t.documentElement;this.version=e.getAttribute("version"),this.updateSequence=e.getAttribute("updateSequence");for(var i=e.children||e.childNodes,s=0;s<i.length;s++){var a=i[s];"ServiceIdentification"===a.localName?this.serviceIdentification=new n(a):"ServiceProvider"===a.localName?this.serviceProvider=new o(a):"OperationsMetadata"===a.localName?this.operationsMetadata=new r(a):"Contents"===a.localName&&(this.contents=this.assembleContents(a))}this.resolveTileMatrixSetLinks()},l.prototype.assembleContents=function(t){for(var i={},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];if("Layer"===o.localName){i.layer=i.layer||[];try{i.layer.push(new a(o,this))}catch(t){e.logMessage(e.LEVEL_SEVERE,"WmtsCapabilities","constructor","Exception reading WMTS layer description: "+t.message)}}else if("TileMatrixSet"===o.localName){i.tileMatrixSet=i.tileMatrixSet||[];try{i.tileMatrixSet.push(l.assembleTileMatrixSet(o))}catch(t){e.logMessage(e.LEVEL_SEVERE,"WmtsCapabilities","constructor","Exception reading WMTS tile matrix set description: "+t.message)}}}return i},l.assembleTileMatrixSet=function(t){for(var e={},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];"Identifier"===o.localName?e.identifier=o.textContent:"SupportedCRS"===o.localName?e.supportedCRS=o.textContent:"WellKnownScaleSet"===o.localName?e.wellKnownScaleSet=o.textContent:"BoundingBox"===o.localName?e.boundingBox=a.assembleBoundingBox(o):"TileMatrix"===o.localName?(e.tileMatrix=e.tileMatrix||[],e.tileMatrix.push(l.assembleTileMatrix(o))):"Title"===o.localName?(e.title=e.title||[],e.title.push(new i(o))):"Abstract"===o.localName&&(e.abstract=e.abstract||[],e.abstract.push(new i(o)))}for(var s=0;s<e.tileMatrix.length;s++)e.tileMatrix[s].levelNumber=s;return e},l.assembleTileMatrix=function(t){for(var e={},r=t.children||t.childNodes,n=0;n<r.length;n++){var o=r[n];if("Identifier"===o.localName)e.identifier=o.textContent;else if("Title"===o.localName)e.title=tileMatrixSet.title||[],e.title.push(new i(o));else if("Abstract"===o.localName)e.abstract=tileMatrixSet.abstract||[],e.abstract.push(new i(o));else if("ScaleDenominator"===o.localName)e.scaleDenominator=parseFloat(o.textContent);else if("TileWidth"===o.localName)e.tileWidth=parseFloat(o.textContent);else if("TileHeight"===o.localName)e.tileHeight=parseFloat(o.textContent);else if("MatrixWidth"===o.localName)e.matrixWidth=parseFloat(o.textContent);else if("MatrixHeight"===o.localName)e.matrixHeight=parseFloat(o.textContent);else if("TopLeftCorner"===o.localName){var s=o.textContent.split(" ");e.topLeftCorner=[parseFloat(s[0]),parseFloat(s[1])]}}return e},l.prototype.resolveTileMatrixSetLinks=function(){for(var t=0;t<this.contents.layer.length;t++)for(var e=this.contents.layer[t],i=0;i<e.tileMatrixSetLink.length;i++)for(var r=e.tileMatrixSetLink[i],n=0;n<this.contents.tileMatrixSet.length;n++)if(this.contents.tileMatrixSet[n].identifier===r.tileMatrixSet){r.tileMatrixSetRef=this.contents.tileMatrixSet[n];break}},l.prototype.getGetTileKvpAddress=function(){for(var t=0;t<this.operationsMetadata.operation.length;t++){var e=this.operationsMetadata.operation[t];if("GetTile"===e.name)return e.dcp[0].http.get[0].href}return null},l}),i("layer/WmtsLayerTile",["../geom/Angle","../error/ArgumentError","../geom/BoundingBox","../util/Logger","../geom/Vec3","../util/WWUtil"],function(t,e,i,r,n,o){"use strict";var s=function(e,i,r,n,o){this.sector=e,this.tileMatrix=i,this.row=r,this.column=n,this.imagePath=o,this.texelSize=e.deltaLatitude()*t.DEGREES_TO_RADIANS/i.tileHeight,this.tileKey=i.levelNumber.toString()+"."+r.toString()+"."+n.toString(),this.gpuCacheKey=o};return s.prototype.isEqual=function(t){return!!t&&(!!t.tileKey&&this.tileKey==t.tileKey)},s.prototype.distanceTo=function(t){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"Tile","distanceTo","missingVector"));for(var i,n,o,s=t[0],a=t[1],l=t[2],h=this.samplePoints,u=Number.POSITIVE_INFINITY,c=0,d=h.length;c<d;c+=3)i=s-h[c],n=a-h[c+1],o=l-h[c+2],u=Math.min(u,i*i+n*n+o*o);return Math.sqrt(u)},s.prototype.subdivide=function(t,i){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"WmtsLayerTile","subdivide","The specified tile matrix is null or undefined."));if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"WmtsLayerTile","subdivide","The specified tile factory is null or undefined."));var n,o,s,a,l=[];return n=t.matrixHeight/this.tileMatrix.matrixHeight,o=t.matrixWidth/this.tileMatrix.matrixWidth,s=n*this.row,a=o*this.column,l.push(i.createTile(t,s,a)),s=n*this.row,a=o*this.column+1,l.push(i.createTile(t,s,a)),s=n*this.row+1,a=o*this.column,l.push(i.createTile(t,s,a)),s=n*this.row+1,a=o*this.column+1,l.push(i.createTile(t,s,a)),l},s.prototype.subdivideToCache=function(t,i,n){if(!t)throw new e(r.logMessage(r.LEVEL_SEVERE,"Tile","subdivideToCache","The specified tile matrix is null or undefined."));if(!i)throw new e(r.logMessage(r.LEVEL_SEVERE,"Tile","subdivideToCache","The specified tile factory is null or undefined."));var o=n?n.entryForKey(this.tileKey):null;return o||(o=this.subdivide(t,i),o&&n&&n.putEntry(this.tileKey,o,o.length)),o},s.prototype.mustSubdivide=function(t,e){var i=t.globe.equatorialRadius*this.texelSize,r=this.distanceTo(t.navigatorState.eyePoint),n=t.navigatorState.pixelSizeAtDistance(r);return i>Math.max(e*n,.5)},s.prototype.update=function(t){var e=t.globe.elevationTimestamp(),i=t.verticalExaggeration,r=t.globeStateKey;this.updateTimestamp==e&&this.updateVerticalExaggeration==i&&this.updateGlobeStateKey==r||(this.doUpdate(t),t.frameStatistics.incrementTileUpdateCount(1),this.updateTimestamp=e,this.updateVerticalExaggeration=i,this.updateGlobeStateKey=r)},s.prototype.doUpdate=function(t){var e=t.globe,r=t.verticalExaggeration,s=e.minAndMaxElevationsForSector(this.sector),a=s?s[0]*r:0,l=s?s[1]*r:0;a==l&&(a=l+10),this.extent||(this.extent=new i),this.extent.setToSector(this.sector,e,a,l),this.samplePoints||(this.sampleElevations=new Float64Array(9),this.samplePoints=new Float64Array(3*this.sampleElevations.length)),o.fillArray(this.sampleElevations,.5*(a+l)),e.computePointsForGrid(this.sector,3,3,this.sampleElevations,n.ZERO,this.samplePoints),this.referencePoint||(this.referencePoint=new n(0,0,0)),e.computePointFromPosition(this.sector.centroidLatitude(),this.sector.centroidLongitude(),0,this.referencePoint)},s.prototype.bind=function(t){var e=t.gpuResourceCache.resourceForKey(this.gpuCacheKey);return!(!e||!e.bind(t))||!!this.fallbackTile&&this.fallbackTile.bind(t)},s.prototype.applyInternalTransform=function(t,e){},s}),i("layer/WmtsLayer",["../util/AbsentResourceList","../error/ArgumentError","../util/Logger","../geom/Sector","../layer/Layer","../cache/MemoryCache","../render/Texture","../util/WmsUrlBuilder","../layer/WmtsLayerTile","../util/WWMath","../util/WWUtil"],function(t,e,i,r,n,o,s,a,l,h,u){"use strict";var c=function(s,l,h){if(!s)throw new e(i.logMessage(i.LEVEL_SEVERE,"WmtsLayer","constructor","No layer configuration specified."));n.call(this,"WMTS Layer"),this.layerIdentifier=s.identifier,this.styleIdentifier=l,this.timeString=h;var u=s.format;if(u.indexOf("image/png")>=0?this.imageFormat="image/png":u.indexOf("image/jpeg")>=0?this.imageFormat="image/jpeg":u.indexOf("image/tiff")>=0?this.imageFormat="image/tiff":u.indexOf("image/gif")>=0?this.imageFormat="image/gif":this.imageFormat=u[0],!this.imageFormat)throw new e(i.logMessage(i.LEVEL_SEVERE,"WmtsLayer","constructor","Layer does not provide a supported image format."));if(s.resourceUrl&&s.resourceUrl.length>1){for(var d=0;d<s.resourceUrl.length;d++)if(this.imageFormat===s.resourceUrl[d].format){this.resourceUrl=s.resourceUrl[d].template;break}}else this.serviceUrl=s.capabilities.getGetTileKvpAddress(),this.serviceUrl&&(this.serviceUrl=a.fixGetMapString(this.serviceUrl));if(!this.resourceUrl&&!this.serviceUrl)throw new e(i.logMessage(i.LEVEL_SEVERE,"WmtsLayer","constructor","No resource URL or KVP GetTile service URL specified in WMTS capabilities."));if(this.styleIdentifier){for(var p=!1,d=0;d<s.style.length;d++)if(s.style[d].identifier===this.styleIdentifier){p=!0;break}p||(i.logMessage(i.LEVEL_WARNING,"WmtsLayer","constructor","The specified style identifier is not available. The server's default style will be used."),this.styleIdentifier=null)}if(!this.styleIdentifier)for(d=0;d<s.style.length;d++)if(s.style[d].isDefault){this.styleIdentifier=s.style[d].identifier;break}this.styleIdentifier||i.logMessage(i.LEVEL_WARNING,"WmtsLayer","constructor","No default style available. A style will not be specified in tile requests.");var f,g=null,m=null;for(d=0;d<s.tileMatrixSetLink.length;d++)f=s.tileMatrixSetLink[d].tileMatrixSetRef,c.isEpsg4326Crs(f.supportedCRS)?g=g||f:c.isEpsg3857Crs(f.supportedCRS)&&(m=m||f);if(this.tileMatrixSet=g||m,!this.tileMatrixSet)throw new e(i.logMessage(i.LEVEL_SEVERE,"WmtsLayer","constructor","No supported Tile Matrix Set could be found."));if(s.wgs84BoundingBox)this.sector=new r(s.wgs84BoundingBox.lowerCorner[1],s.wgs84BoundingBox.upperCorner[1],s.wgs84BoundingBox.lowerCorner[0],s.wgs84BoundingBox.upperCorner[0]);else if(this.tileMatrixSet.boundingBox&&WmtsLayerCapabilities.isEpsg4326Crs(this.tileMatrixSet.boundingBox.crs))this.sector=new r(this.tileMatrixSet.boundingBox.lowerCorner[1],this.tileMatrixSet.boundingBox.upperCorner[1],this.tileMatrixSet.boundingBox.lowerCorner[0],this.tileMatrixSet.boundingBox.upperCorner[0]);else if(WmtsLayerCapabilities.isEpsg4326Crs(this.tileMatrixSet.supportedCRS))throw new e(i.logMessage(i.LEVEL_SEVERE,"WmtsLayer","constructor","No EPSG:4326 bounding box was specified in the layer or tile matrix set capabilities."));this.cachePath=(this.resourceUrl||this.serviceUrl)+this.layerIdentifier+this.styleIdentifier+this.tileMatrixSet.identifier,h&&(this.cachePath=this.cachePath+h),s.title.length>0?this.displayName=s.title[0].value:this.displayName=s.identifier,this.pickEnabled=!1,this.currentTiles=[],this.currentTilesInvalid=!0,this.tileCache=new o(500,400),this.currentRetrievals=[],this.absentResourceList=new t(3,5e4),this.pickEnabled=!1,this.detailControl=1.75};return c.prototype=Object.create(n.prototype),c.prototype.doRender=function(t){t.terrain&&(!this.currentTilesInvalid&&this.lasTtMVP&&t.navigatorState.modelviewProjection.equals(this.lasTtMVP)&&t.globeStateKey==this.lastGlobeStateKey||(this.currentTilesInvalid=!1,this.assembleTiles(t)),this.lasTtMVP=t.navigatorState.modelviewProjection,this.lastGlobeStateKey=t.globeStateKey,this.currentTiles.length>0&&(t.surfaceTileRenderer.renderTiles(t,this.currentTiles,this.opacity),t.frameStatistics.incrementImageTileCount(this.currentTiles.length),this.inCurrentFrame=!0))},c.prototype.isLayerInView=function(t){return t.terrain&&t.terrain.sector&&t.terrain.sector.intersects(this.sector)},c.prototype.isTileVisible=function(t,e){return!(t.globe.projectionLimits&&!e.sector.overlaps(t.globe.projectionLimits))&&e.extent.intersectsFrustum(t.navigatorState.frustumInModelCoordinates)},c.prototype.assembleTiles=function(t){this.currentTiles=[],this.topLevelTiles&&0!==this.topLevelTiles.length||this.createTopLevelTiles(t);for(var e=0,i=this.topLevelTiles.length;e<i;e++){var r=this.topLevelTiles[e];r.update(t),this.currentAncestorTile=null,this.isTileVisible(t,r)&&this.addTileOrDescendants(t,r)}},c.prototype.addTileOrDescendants=function(t,e){if(this.tileMeetsRenderingCriteria(t,e))return void this.addTile(t,e);var i=null;try{(this.isTileTextureInMemory(t,e)||0===e.tileMatrix.levelNumber)&&(i=this.currentAncestorTile,this.currentAncestorTile=e);for(var r=this.tileMatrixSet.tileMatrix[e.tileMatrix.levelNumber+1],n=e.subdivideToCache(r,this,this.tileCache),o=0,s=n.length;o<s;o++){var a=n[o];a.update(t),this.sector.intersects(a.sector)&&this.isTileVisible(t,a)&&this.addTileOrDescendants(t,a)}}finally{i&&(this.currentAncestorTile=i)}},c.prototype.addTile=function(t,e){e.fallbackTile=null;var i=t.gpuResourceCache.resourceForKey(e.imagePath);return i?(this.currentTiles.push(e),void(this.expiration&&this.isTextureExpired(i)&&this.retrieveTileImage(t,e))):(this.retrieveTileImage(t,e),void(this.currentAncestorTile&&this.isTileTextureInMemory(t,this.currentAncestorTile)&&this.currentTiles.push(this.currentAncestorTile)))},c.prototype.isTextureExpired=function(t){return this.expiration&&t.creationTime.getTime()<=this.expiration.getTime()},c.prototype.isTileTextureInMemory=function(t,e){return t.gpuResourceCache.containsResource(e.imagePath)},c.prototype.tileMeetsRenderingCriteria=function(t,e){var i=this.detailControl;return(e.sector.minLatitude>=75||e.sector.maxLatitude<=-75)&&(i*=1.2),e.tileMatrix.levelNumber===this.tileMatrixSet.tileMatrix.length-1||!e.mustSubdivide(t,i)},c.prototype.retrieveTileImage=function(t,e){if(this.currentRetrievals.indexOf(e.imagePath)<0){if(this.absentResourceList.isResourceAbsent(e.imagePath))return;var r=this.resourceUrlForTile(e,this.imageFormat),n=new Image,o=e.imagePath,s=t.gpuResourceCache,a=t.currentGlContext.canvas,l=this;if(!r)return void(this.currentTilesInvalid=!0);n.onload=function(){i.log(i.LEVEL_INFO,"Image retrieval succeeded: "+r);var h=l.createTexture(t,e,n);if(l.removeFromCurrentRetrievals(o),h){s.putResource(o,h,h.size),l.currentTilesInvalid=!0,l.absentResourceList.unmarkResourceAbsent(o);var u=document.createEvent("Event");u.initEvent(WorldWind.REDRAW_EVENT_TYPE,!0,!0),a.dispatchEvent(u)}},n.onerror=function(){l.removeFromCurrentRetrievals(o),l.absentResourceList.markResourceAbsent(o),i.log(i.LEVEL_WARNING,"Image retrieval failed: "+r)},this.currentRetrievals.push(o),n.crossOrigin="anonymous",n.src=r}},c.prototype.resourceUrlForTile=function(t,e){var i;return this.resourceUrl?(i=this.resourceUrl.replace("{Style}",this.styleIdentifier).replace("{TileMatrixSet}",this.tileMatrixSet.identifier).replace("{TileMatrix}",t.tileMatrix.identifier).replace("{TileCol}",t.column).replace("{TileRow}",t.row),this.timeString&&i.replace("{Time}",this.timeString)):(i=this.serviceUrl+"service=WMTS&request=GetTile&version=1.0.0",i+="&Layer="+this.layerIdentifier,this.styleIdentifier&&(i+="&Style="+this.styleIdentifier),i+="&Format="+e,this.timeString&&(i+="&Time="+this.timeString),i+="&TileMatrixSet="+this.tileMatrixSet.identifier,i+="&TileMatrix="+t.tileMatrix.identifier,i+="&TileRow="+t.row,i+="&TileCol="+t.column),i},c.prototype.removeFromCurrentRetrievals=function(t){var e=this.currentRetrievals.indexOf(t);e>-1&&this.currentRetrievals.splice(e,1)},c.prototype.createTopLevelTiles=function(t){var e=this.tileMatrixSet.tileMatrix[0];this.topLevelTiles=[];for(var i=0;i<e.matrixHeight;i++)for(var r=0;r<e.matrixWidth;r++)this.topLevelTiles.push(this.createTile(e,i,r));
},c.prototype.createTile=function(t,e,i){return c.isEpsg4326Crs(this.tileMatrixSet.supportedCRS)?this.createTile4326(t,e,i):c.isEpsg3857Crs(this.tileMatrixSet.supportedCRS)?this.createTile3857(t,e,i):void 0},c.prototype.createTile4326=function(t,e,i){var n=this.sector.deltaLatitude()/t.matrixHeight,o=this.sector.deltaLongitude()/t.matrixWidth,s=t.topLeftCorner[0]-e*n,a=s-n,l=t.topLeftCorner[1]+o*i,h=l+o,u=new r(a,s,l,h);return this.makeTile(u,t,e,i)},c.prototype.createTile3857=function(t,e,i){t.mapWidth||this.computeTileMatrixValues3857(t);var n,o,s,a,l,u,c=h.clamp(i*t.tileWidth-.5,0,t.mapWidth),d=h.clamp(e*t.tileHeight-.5,0,t.mapHeight),p=h.clamp(c+t.tileWidth+.5,0,t.mapWidth),f=h.clamp(d+t.tileHeight+.5,0,t.mapHeight);n=c/t.mapWidth,o=f/t.mapHeight,a=t.topLeftCorner[0]+n*t.tileMatrixDeltaX,s=t.topLeftCorner[1]-o*t.tileMatrixDeltaY;var g=h.epsg3857ToEpsg4326(a,s);n=p/t.mapWidth,o=d/t.mapHeight,u=t.topLeftCorner[0]+n*t.tileMatrixDeltaX,l=t.topLeftCorner[1]-o*t.tileMatrixDeltaY;var m=h.epsg3857ToEpsg4326(u,l),E=new r(g[0],m[0],g[1],m[1]);return this.makeTile(E,t,e,i)},c.prototype.computeTileMatrixValues3857=function(t){var e=28e-5*t.scaleDenominator,i=t.tileWidth*e,r=t.tileHeight*e,n=t.topLeftCorner[0]+i*t.matrixWidth,o=t.topLeftCorner[1]-r*t.matrixHeight,s=[n,o],a=t.topLeftCorner;t.tileMatrixDeltaX=s[0]-a[0],t.tileMatrixDeltaY=a[1]-s[1],t.mapWidth=t.tileWidth*t.matrixWidth,t.mapHeight=t.tileHeight*t.matrixHeight},c.prototype.makeTile=function(t,e,i,r){var n=this.cachePath+"-layer/"+e.identifier+"/"+i+"/"+r+"."+u.suffixForMimeType(this.imageFormat);return new l(t,e,i,r,n)},c.prototype.createTexture=function(t,e,i){return c.isEpsg4326Crs(this.tileMatrixSet.supportedCRS)?new s(t.currentGlContext,i):c.isEpsg3857Crs(this.tileMatrixSet.supportedCRS)?this.createTexture3857(t,e,i):void 0},c.prototype.createTexture3857=function(t,e,i){this.destCanvas||(this.destCanvas=document.createElement("canvas"),this.destContext=this.destCanvas.getContext("2d"));var r,n,o,a,l,u,c,d,p=t.canvas2D,f=t.ctx2D,g=this.destCanvas,m=this.destContext,E=m.createImageData(i.width,i.height),y=e.sector,_=h.gudermannianInverse(y.minLatitude),v=h.gudermannianInverse(y.maxLatitude);p.width=i.width,p.height=i.height,g.width=i.width,g.height=i.height,f.drawImage(i,0,0,i.width,i.height),r=f.getImageData(0,0,i.width,i.height);for(var b=0;b<1;b++)for(var S=0;S<i.height;S++){c=1-S/(i.height-1),n=c*y.deltaLatitude()+y.minLatitude,o=h.gudermannianInverse(n),d=1-(o-_)/(v-_),d=h.clamp(d,0,1),a=Math.floor(d*(i.height-1));for(var T=0;T<i.width;T++)l=4*(T+a*i.width),u=4*(T+S*i.width),E.data[u]=r.data[l],E.data[u+1]=r.data[l+1],E.data[u+2]=r.data[l+2],E.data[u+3]=r.data[l+3]}return m.putImageData(E,0,0),new s(t.currentGlContext,g)},c.isEpsg4326Crs=function(t){return t.indexOf("EPSG")>=0&&t.indexOf("4326")>=0},c.isEpsg3857Crs=function(t){return t.indexOf("EPSG")>=0&&(t.indexOf("3857")>=0||t.indexOf("900913")>=0)},c}),i("WorldWindow",["./error/ArgumentError","./render/DrawContext","./globe/EarthElevationModel","./util/FrameStatistics","./globe/Globe","./globe/Globe2D","./util/GoToAnimator","./cache/GpuResourceCache","./util/Logger","./navigate/LookAtNavigator","./navigate/NavigatorState","./pick/PickedObjectList","./geom/Rectangle","./geom/Sector","./shapes/SurfaceShape","./shapes/SurfaceShapeTileBuilder","./globe/Terrain","./geom/Vec2"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m,E){"use strict";var y=function(o,a){function u(t){m.handleContextLost(t)}function c(t){m.handleContextRestored(t)}function p(t){m.handleRedrawEvent(t)}if(!window.WebGLRenderingContext)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","constructor","The specified canvas does not support WebGL."));var f=document.getElementById(o);if(!f)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","constructor","The specified canvas name is not in the document."));var g=this.createContext(f);this.drawContext=new e(g),this.eventListeners={},this.redrawRequested=!0,this.redrawRequestId=null,this.canvas=f,this.depthBits=g.getParameter(g.DEPTH_BITS),this.viewport=new d(0,0,g.drawingBufferWidth,g.drawingBufferHeight),this.globe=new n(a||new i),this.layers=[],this.navigator=new h(this),this.verticalExaggeration=1,this.deepPicking=!1,this.subsurfaceMode=!1,this.surfaceOpacity=1,this.frameStatistics=new r,this.goToAnimator=new s(this),this._redrawCallbacks=[],this._orderedRenderingFilters=[function(t){m.declutter(t,1)},function(t){m.declutter(t,2)}],this.pixelScale=1;var m=this;this.canvas.addEventListener("webglcontextlost",u,!1),this.canvas.addEventListener("webglcontextrestored",c,!1),this.canvas.addEventListener(WorldWind.REDRAW_EVENT_TYPE,p,!1),window.addEventListener(WorldWind.REDRAW_EVENT_TYPE,p,!1),this.animationFrameLoop()};return Object.defineProperties(y.prototype,{orderedRenderingFilters:{get:function(){return this._orderedRenderingFilters}},redrawCallbacks:{get:function(){return this._redrawCallbacks}}}),y.prototype.canvasCoordinates=function(t,e){var i=this.canvas.getBoundingClientRect(),r=t-(i.left+this.canvas.clientLeft),n=e-(i.top+this.canvas.clientTop);return new E(r,n)},y.prototype.addEventListener=function(e,i){if(!e)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","addEventListener","missingType"));if(!i)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","addEventListener","missingListener"));var r=this,n=this.eventListeners[e];n||(n={listeners:[],callback:function(t){t.worldWindow=r;for(var e=0,i=n.listeners.length;e<i;e++)n.listeners[e](t)}},this.eventListeners[e]=n);var o=n.listeners.indexOf(i);o==-1&&(n.listeners.splice(0,0,i),1==n.listeners.length&&this.canvas.addEventListener(e,n.callback,!1))},y.prototype.removeEventListener=function(e,i){if(!e)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","removeEventListener","missingType"));if(!i)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","removeEventListener","missingListener"));var r=this.eventListeners[e];if(r){var n=r.listeners.indexOf(i);n!=-1&&(r.listeners.splice(n,1),0==r.listeners.length&&this.canvas.removeEventListener(e,r.callback,!1))}},y.prototype.redraw=function(){this.redrawRequested=!0},y.prototype.pick=function(e){if(!e)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","pick","missingPoint"));return this.drawContext.currentGlContext.isContextLost()?new c:(this.resize(),this.resetDrawContext(),this.drawContext.pickingMode=!0,this.drawContext.pickPoint=e,this.drawFrame(),this.drawContext.objectsAtPickPoint)},y.prototype.pickTerrain=function(e){if(!e)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","pickTerrain","missingPoint"));return this.drawContext.currentGlContext.isContextLost()?new c:(this.resize(),this.resetDrawContext(),this.drawContext.pickingMode=!0,this.drawContext.pickTerrainOnly=!0,this.drawContext.pickPoint=e,this.drawFrame(),this.drawContext.objectsAtPickPoint)},y.prototype.pickShapesInRegion=function(e){if(!e)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","pickShapesInRegion","missingRectangle"));return this.drawContext.currentGlContext.isContextLost()?new c:(this.resize(),this.resetDrawContext(),this.drawContext.pickingMode=!0,this.drawContext.regionPicking=!0,this.drawContext.pickRectangle=new d(e.x,this.canvas.height-e.y,e.width,e.height),this.drawFrame(),this.drawContext.objectsAtPickPoint)},y.prototype.createContext=function(t){var e={antialias:!1,stencil:!0},i=t.getContext("webgl",e);i||(i=t.getContext("experimental-webgl",e));var r=i.getContextAttributes();return this.hasStencilBuffer=r.stencil,i},y.prototype.handleContextLost=function(t){l.log(l.LEVEL_INFO,"WebGL context event: "+t.statusMessage),t.preventDefault(),this.drawContext.contextLost(),window.cancelAnimationFrame(this.redrawRequestId)},y.prototype.handleContextRestored=function(t){l.log(l.LEVEL_INFO,"WebGL context event: "+t.statusMessage),this.drawContext.contextRestored(),this.redraw(),this.animationFrameLoop()},y.prototype.handleRedrawEvent=function(t){this.redraw()},y.prototype.animationFrameLoop=function(){function t(){e.animationFrameLoop()}this.redrawIfNeeded();var e=this;this.redrawRequestId=window.requestAnimationFrame(t)},y.prototype.redrawIfNeeded=function(){if(this.resize(),this.redrawRequested)try{this.redrawRequested=!1,this.drawContext.previousRedrawTimestamp=this.drawContext.timestamp,this.callRedrawCallbacks(WorldWind.BEFORE_REDRAW),this.resetDrawContext(),this.drawFrame()}catch(t){l.logMessage(l.LEVEL_SEVERE,"WorldWindow","redrawIfNeeded","Exception occurred during redrawing.\n"+t.toString())}finally{this.callRedrawCallbacks(WorldWind.AFTER_REDRAW),this.drawContext.redrawRequested&&(this.redrawRequested=!0)}},y.prototype.resize=function(){var t=this.drawContext.currentGlContext,e=t.canvas.clientWidth*this.pixelScale,i=t.canvas.clientHeight*this.pixelScale;t.canvas.width==e&&t.canvas.height==i||(t.canvas.width=e,t.canvas.height=i,t.viewport(0,0,t.drawingBufferWidth,t.drawingBufferHeight),this.viewport=new d(0,0,t.drawingBufferWidth,t.drawingBufferHeight),this.redrawRequested=!0)},y.prototype.resetDrawContext=function(){this.globe.offset=0;var t=this.drawContext;t.reset(),t.globe=this.globe,t.layers=this.layers,t.navigatorState=this.navigator.currentState(),t.verticalExaggeration=this.verticalExaggeration,t.surfaceOpacity=this.surfaceOpacity,t.deepPicking=this.deepPicking,t.frameStatistics=this.frameStatistics,t.pixelScale=this.pixelScale,t.update()},y.prototype.drawFrame=function(){try{this.drawContext.frameStatistics.beginFrame(),this.beginFrame(),this.drawContext.globe.is2D()&&this.drawContext.globe.continuous?this.do2DContiguousRepaint():this.doNormalRepaint()}finally{this.endFrame(),this.drawContext.frameStatistics.endFrame()}},y.prototype.doNormalRepaint=function(){this.createTerrain(),this.clearFrame(),this.deferOrderedRendering=!1,this.drawContext.pickingMode?this.drawContext.makePickFrustum()&&(this.doPick(),this.resolvePick()):(this.doDraw(),this.subsurfaceMode&&this.hasStencilBuffer&&(this.redrawSurface(),this.drawScreenRenderables()))},y.prototype.do2DContiguousRepaint=function(){this.createTerrain2DContiguous(),this.clearFrame(),this.drawContext.pickingMode?this.drawContext.makePickFrustum()&&(this.pick2DContiguous(),this.resolvePick()):this.draw2DContiguous()},y.prototype.resolvePick=function(){this.drawContext.pickTerrainOnly?this.resolveTerrainPick():this.drawContext.regionPicking?this.resolveRegionPick():this.resolveTopPick()},y.prototype.beginFrame=function(){var t=this.drawContext.currentGlContext;t.enable(t.BLEND),t.enable(t.CULL_FACE),t.enable(t.DEPTH_TEST),t.blendFunc(t.ONE,t.ONE_MINUS_SRC_ALPHA),t.depthFunc(t.LEQUAL),this.drawContext.pickingMode&&(this.drawContext.makePickFramebuffer(),this.drawContext.bindFramebuffer(this.drawContext.pickFramebuffer))},y.prototype.endFrame=function(){var t=this.drawContext.currentGlContext;t.disable(t.BLEND),t.disable(t.CULL_FACE),t.disable(t.DEPTH_TEST),t.blendFunc(t.ONE,t.ZERO),t.depthFunc(t.LESS),t.clearColor(0,0,0,1),this.drawContext.bindFramebuffer(null),this.drawContext.bindProgram(null)},y.prototype.clearFrame=function(){var t=this.drawContext,e=t.currentGlContext;e.clearColor(t.clearColor.red,t.clearColor.green,t.clearColor.blue,t.clearColor.alpha),e.clear(e.COLOR_BUFFER_BIT|e.DEPTH_BUFFER_BIT)},y.prototype.doDraw=function(){this.drawContext.renderShapes=!0,this.subsurfaceMode&&this.hasStencilBuffer?(this.drawContext.currentGlContext.disable(this.drawContext.currentGlContext.STENCIL_TEST),this.drawContext.surfaceShapeTileBuilder.clear(),this.drawLayers(!0),this.drawSurfaceRenderables(),this.drawContext.surfaceShapeTileBuilder.doRender(this.drawContext),this.deferOrderedRendering||(this.drawContext.currentGlContext.clear(this.drawContext.currentGlContext.DEPTH_BUFFER_BIT|this.drawContext.currentGlContext.STENCIL_BUFFER_BIT),this.drawContext.currentGlContext.enable(this.drawContext.currentGlContext.STENCIL_TEST),this.drawContext.currentGlContext.stencilFunc(this.drawContext.currentGlContext.ALWAYS,1,1),this.drawContext.currentGlContext.stencilOp(this.drawContext.currentGlContext.REPLACE,this.drawContext.currentGlContext.REPLACE,this.drawContext.currentGlContext.REPLACE),this.drawOrderedRenderables(),this.drawContext.screenCreditController.drawCredits(this.drawContext))):(this.drawContext.surfaceShapeTileBuilder.clear(),this.drawLayers(!0),this.drawSurfaceRenderables(),this.drawContext.surfaceShapeTileBuilder.doRender(this.drawContext),this.deferOrderedRendering||(this.drawOrderedRenderables(),this.drawScreenRenderables()),this.drawContext.screenCreditController.drawCredits(this.drawContext))},y.prototype.redrawSurface=function(){this.drawContext.currentGlContext.enable(this.drawContext.currentGlContext.STENCIL_TEST),this.drawContext.currentGlContext.stencilFunc(this.drawContext.currentGlContext.EQUAL,1,1),this.drawContext.currentGlContext.stencilOp(this.drawContext.currentGlContext.KEEP,this.drawContext.currentGlContext.KEEP,this.drawContext.currentGlContext.KEEP),this.drawContext.surfaceShapeTileBuilder.clear(),this.drawLayers(!1),this.drawSurfaceRenderables(),this.drawContext.surfaceShapeTileBuilder.doRender(this.drawContext),this.drawContext.currentGlContext.disable(this.drawContext.currentGlContext.STENCIL_TEST)},y.prototype.doPick=function(){this.drawContext.terrain&&this.drawContext.terrain.pick(this.drawContext),this.drawContext.pickTerrainOnly||(this.subsurfaceMode&&this.hasStencilBuffer?(this.drawContext.currentGlContext.disable(this.drawContext.currentGlContext.STENCIL_TEST),this.drawContext.surfaceShapeTileBuilder.clear(),this.drawLayers(!0),this.drawSurfaceRenderables(),this.drawContext.surfaceShapeTileBuilder.doRender(this.drawContext),this.deferOrderedRendering||(this.drawContext.currentGlContext.clear(this.drawContext.currentGlContext.DEPTH_BUFFER_BIT|this.drawContext.currentGlContext.STENCIL_BUFFER_BIT),this.drawContext.currentGlContext.enable(this.drawContext.currentGlContext.STENCIL_TEST),this.drawContext.currentGlContext.stencilFunc(this.drawContext.currentGlContext.ALWAYS,1,1),this.drawContext.currentGlContext.stencilOp(this.drawContext.currentGlContext.REPLACE,this.drawContext.currentGlContext.REPLACE,this.drawContext.currentGlContext.REPLACE),this.drawOrderedRenderables(),this.drawContext.terrain.pick(this.drawContext),this.drawScreenRenderables())):(this.drawContext.surfaceShapeTileBuilder.clear(),this.drawLayers(!0),this.drawSurfaceRenderables(),this.drawContext.surfaceShapeTileBuilder.doRender(this.drawContext),this.deferOrderedRendering||(this.drawOrderedRenderables(),this.drawScreenRenderables())))},y.prototype.createTerrain=function(){var t=this.drawContext;t.terrain=this.globe.tessellator.tessellate(t),t.frameStatistics.setTerrainTileCount(t.terrain?t.terrain.surfaceGeometry.length:0)},y.prototype.makeCurrent=function(t){var e=this.drawContext;switch(e.globe.offset=t,e.globeStateKey=e.globe.stateKey,t){case-1:e.terrain=this.terrainLeft;break;case 0:e.terrain=this.terrainCenter;break;case 1:e.terrain=this.terrainRight}},y.prototype.createTerrain2DContiguous=function(){var t=this.drawContext;this.terrainCenter=null,t.globe.offset=0,t.globeStateKey=t.globe.stateKey,t.globe.intersectsFrustum(t.navigatorState.frustumInModelCoordinates)&&(this.terrainCenter=t.globe.tessellator.tessellate(t)),this.terrainRight=null,t.globe.offset=1,t.globeStateKey=t.globe.stateKey,t.globe.intersectsFrustum(t.navigatorState.frustumInModelCoordinates)&&(this.terrainRight=t.globe.tessellator.tessellate(t)),this.terrainLeft=null,t.globe.offset=-1,t.globeStateKey=t.globe.stateKey,t.globe.intersectsFrustum(t.navigatorState.frustumInModelCoordinates)&&(this.terrainLeft=t.globe.tessellator.tessellate(t))},y.prototype.draw2DContiguous=function(){var t="";this.terrainCenter&&(t+=" 0 ",this.makeCurrent(0),this.deferOrderedRendering=this.terrainLeft||this.terrainRight,this.doDraw()),this.terrainRight&&(t+=" 1 ",this.makeCurrent(1),this.deferOrderedRendering=this.terrainLeft||this.terrainLeft,this.doDraw()),this.deferOrderedRendering=!1,this.terrainLeft&&(t+=" -1 ",this.makeCurrent(-1),this.doDraw()),this.subsurfaceMode&&this.hasStencilBuffer&&(this.deferOrderedRendering=!0,this.terrainCenter&&(t+=" 0 ",this.makeCurrent(0),this.redrawSurface()),this.terrainRight&&(t+=" 1 ",this.makeCurrent(1),this.redrawSurface()),this.terrainLeft&&(t+=" -1 ",this.makeCurrent(-1),this.redrawSurface())),this.drawScreenRenderables()},y.prototype.pick2DContiguous=function(){this.terrainCenter&&(this.makeCurrent(0),this.deferOrderedRendering=this.terrainLeft||this.terrainRight,this.doPick()),this.terrainRight&&(this.makeCurrent(1),this.deferOrderedRendering=this.terrainLeft||this.terrainLeft,this.doPick()),this.deferOrderedRendering=!1,this.terrainLeft&&(this.makeCurrent(-1),this.doPick())},y.prototype.drawLayers=function(t){var e,i=Date.now(),r=this.drawContext,n=r.layers;r.accumulateOrderedRenderables=t;for(var o=0,s=n.length;o<s;o++)if(e=n[o]){r.currentLayer=e;try{e.render(r)}catch(t){l.log(l.LEVEL_SEVERE,"Error while rendering layer "+e.displayName+".\n"+t.toString())}}var a=Date.now();r.frameStatistics.layerRenderingTime=a-i},y.prototype.addLayer=function(t){this.layers.push(t)},y.prototype.removeLayer=function(t){if(t){for(var e=-1,i=0,r=this.layers.length;i<r;i++)if(this.layers[i]==t){e=i;break}e>=0&&this.layers.splice(e,1)}},y.prototype.insertLayer=function(t,e){e&&this.layers.splice(t,0,e)},y.prototype.drawSurfaceRenderables=function(){var t,e=this.drawContext;for(e.reverseSurfaceRenderables();t=e.popSurfaceRenderable();)try{t.renderSurface(e)}catch(t){l.logMessage(l.LEVEL_WARNING,"WorldWindow","drawSurfaceRenderables","Error while rendering a surface renderable.\n"+t.message)}},y.prototype.drawOrderedRenderables=function(){var t,e=Date.now(),i=this.drawContext;if(i.sortOrderedRenderables(),this._orderedRenderingFilters)for(var r=0;r<this._orderedRenderingFilters.length;r++)this._orderedRenderingFilters[r](this.drawContext);for(i.orderedRenderingMode=!0;t=i.popOrderedRenderable();)try{t.renderOrdered(i)}catch(t){l.logMessage(l.LEVEL_WARNING,"WorldWindow","drawOrderedRenderables","Error while rendering an ordered renderable.\n"+t.message)}i.orderedRenderingMode=!1,i.frameStatistics.orderedRenderingTime=Date.now()-e},y.prototype.drawScreenRenderables=function(){for(var t,e=this.drawContext;t=e.nextScreenRenderable();)try{t.renderOrdered(e)}catch(t){l.logMessage(l.LEVEL_WARNING,"WorldWindow","drawOrderedRenderables","Error while rendering a screen renderable.\n"+t.message)}},y.prototype.resolveTopPick=function(){if(0!=this.drawContext.objectsAtPickPoint.objects.length){var t=this.drawContext.objectsAtPickPoint,e=this.drawContext.readPickColor(this.drawContext.pickPoint),i=null,r=null;if(e){for(var n=0,o=t.objects.length;n<o;n++){var s=t.objects[n];if(s.isTerrain&&(r=s),s.color.equals(e)&&(s.isOnTop=!0,i=s,r))break}this.drawContext.deepPicking||(t.clear(),i&&t.add(i),r&&r!=i&&t.add(r))}else t.clear()}},y.prototype.resolveTerrainPick=function(){for(var t,e=this.drawContext.objectsAtPickPoint,i=0,r=e.objects.length;i<r;i++)if(t=e.objects[i],t.isTerrain){t.isOnTop=!0;break}},y.prototype.resolveRegionPick=function(){if(0!=this.drawContext.objectsAtPickPoint.objects.length)for(var t,e,i=this.drawContext.objectsAtPickPoint,r=this.drawContext.readPickColors(this.drawContext.pickRectangle),n=0,o=i.objects.length;n<o;n++)if(t=i.objects[n]){var s=t.color.toByteString();e=r[s],e?t.isOnTop=!0:t.userObject instanceof f&&(i.objects.splice(n,1),n-=1)}},y.prototype.callRedrawCallbacks=function(t){for(var e=0,i=this._redrawCallbacks.length;e<i;e++)try{this._redrawCallbacks[e](this,t)}catch(t){l.log(l.LEVEL_SEVERE,"Exception calling redraw callback.\n"+t.toString())}},y.prototype.goTo=function(t,e){this.goToAnimator.goTo(t,e)},y.prototype.declutter=function(e,i){if(!i)throw new t(l.logMessage(l.LEVEL_SEVERE,"WorldWindow","declutter","Group ID is null, undefined or 0."));for(var r=[],n=0;n<e.orderedRenderables.length;n++){var o=e.orderedRenderables[n].orderedRenderable;o.declutterGroup===i&&r.push(o)}for(var s=[],a=0;a<r.length;a++){var h=r[a],u=h.screenBounds;u&&u.intersectsRectangles(s)?h.targetVisibility=0:(h.targetVisibility=1,u&&s.push(u))}},y}),i("util/WWMessage",[],function(){"use strict";var t=function(t,e){this.type=t,this.source=e};return t}),i("WorldWind",["./error/AbstractError","./geom/Angle","./shapes/Annotation","./shapes/AnnotationAttributes","./error/ArgumentError","./layer/AtmosphereLayer","./shaders/AtmosphereProgram","./shaders/BasicProgram","./shaders/BasicTextureProgram","./util/BasicTimeSequence","./layer/BingAerialLayer","./layer/BingAerialWithLabelsLayer","./layer/BingRoadsLayer","./layer/BingWMSLayer","./layer/BlueMarbleLayer","./layer/BMNGLandsatLayer","./layer/BMNGLayer","./layer/BMNGOneImageLayer","./geom/BoundingBox","./gesture/ClickRecognizer","./formats/collada/ColladaLoader","./util/Color","./shapes/Compass","./layer/CompassLayer","./layer/CoordinatesDisplayLayer","./util/Date","./layer/DigitalGlobeTiledImageLayer","./gesture/DragRecognizer","./render/DrawContext","./globe/EarthElevationModel","./globe/EarthRestElevationModel","./globe/ElevationModel","./util/Font","./util/FrameStatistics","./layer/FrameStatisticsLayer","./render/FramebufferTexture","./render/FramebufferTile","./render/FramebufferTileController","./geom/Frustum","./shapes/GeographicMesh","./projections/GeographicProjection","./shapes/GeographicText","./formats/geojson/GeoJSONGeometry","./formats/geojson/GeoJSONGeometryCollection","./formats/geojson/GeoJSONGeometryLineString","./formats/geojson/GeoJSONGeometryMultiLineString","./formats/geojson/GeoJSONGeometryMultiPoint","./formats/geojson/GeoJSONGeometryMultiPolygon","./formats/geojson/GeoJSONGeometryPoint","./formats/geojson/GeoJSONGeometryPolygon","./formats/geojson/GeoJSONParser","./formats/geotiff/GeoTiffReader","./gesture/GestureRecognizer","./globe/Globe","./globe/Globe2D","./util/GoToAnimator","./shaders/GpuProgram","./cache/GpuResourceCache","./shaders/GpuShader","./shaders/GroundProgram","./util/HighlightController","./formats/kml/util/ImagePyramid","./util/ImageSource","./render/ImageTile","./util/Insets","./formats/kml/util/ItemIcon","./formats/kml/KmlAbstractView","./formats/kml/styles/KmlBalloonStyle","./formats/kml/KmlCamera","./formats/kml/styles/KmlColorStyle","./formats/kml/features/KmlContainer","./formats/kml/features/KmlDocument","./formats/kml/KmlElements","./formats/kml/features/KmlFeature","./formats/kml/KmlFile","./formats/kml/features/KmlFolder","./formats/kml/geom/KmlGeometry","./formats/kml/features/KmlGroundOverlay","./formats/kml/KmlIcon","./formats/kml/styles/KmlIconStyle","./formats/kml/styles/KmlLabelStyle","./formats/kml/KmlLatLonAltBox","./formats/kml/KmlLatLonBox","./formats/kml/KmlLatLonQuad","./formats/kml/geom/KmlLinearRing","./formats/kml/geom/KmlLineString","./formats/kml/styles/KmlLineStyle","./formats/kml/KmlLink","./formats/kml/styles/KmlListStyle","./formats/kml/KmlLocation","./formats/kml/KmlLod","./formats/kml/KmlLookAt","./formats/kml/geom/KmlMultiGeometry","./formats/kml/features/KmlNetworkLink","./formats/kml/KmlObject","./formats/kml/KmlOrientation","./formats/kml/features/KmlOverlay","./formats/kml/features/KmlPhotoOverlay","./formats/kml/features/KmlPlacemark","./formats/kml/geom/KmlPoint","./formats/kml/geom/KmlPolygon","./formats/kml/styles/KmlPolyStyle","./formats/kml/KmlRegion","./formats/kml/features/KmlScreenOverlay","./formats/kml/styles/KmlStyle","./formats/kml/styles/KmlStyleMap","./formats/kml/styles/KmlStyleSelector","./formats/kml/styles/KmlSubStyle","./formats/kml/KmlTimePrimitive","./formats/kml/KmlTimeSpan","./formats/kml/KmlTimeStamp","./formats/kml/features/KmlTour","./formats/kml/geom/KmlTrack","./layer/LandsatRestLayer","./layer/Layer","./util/Level","./util/LevelRowColumnUrlBuilder","./util/LevelSet","./geom/Line","./geom/Location","./util/Logger","./navigate/LookAtNavigator","./geom/Matrix","./cache/MemoryCache","./cache/MemoryCacheListener","./layer/MercatorTiledImageLayer","./navigate/Navigator","./navigate/NavigatorState","./util/NominatimGeocoder","./error/NotYetImplementedError","./util/Offset","./layer/OpenStreetMapImageLayer","./formats/kml/util/Pair","./gesture/PanRecognizer","./shapes/Path","./util/PeriodicTimeSequence","./pick/PickedObject","./pick/PickedObjectList","./gesture/PinchRecognizer","./shapes/Placemark","./shapes/PlacemarkAttributes","./geom/Plane","./shapes/Polygon","./geom/Position","./projections/ProjectionEquirectangular","./projections/ProjectionGnomonic","./projections/ProjectionMercator","./projections/ProjectionPolarEquidistant","./projections/ProjectionUPS","./projections/ProjectionWgs84","./geom/Rectangle","./render/Renderable","./layer/RenderableLayer","./layer/RestTiledImageLayer","./gesture/RotationRecognizer","./formats/kml/util/Scale","./formats/kml/util/Schema","./shapes/ScreenImage","./shapes/ScreenText","./geom/Sector","./shapes/ShapeAttributes","./formats/shapefile/Shapefile","./layer/ShowTessellationLayer","./shaders/SkyProgram","./shapes/SurfaceImage","./shapes/SurfaceCircle","./shapes/SurfaceEllipse","./shapes/SurfacePolygon","./shapes/SurfacePolyline","./shapes/SurfaceRectangle","./render/SurfaceRenderable","./shapes/SurfaceSector","./shapes/SurfaceShape","./shapes/SurfaceShapeTile","./shapes/SurfaceShapeTileBuilder","./render/SurfaceTile","./render/SurfaceTileRenderer","./shaders/SurfaceTileRendererProgram","./gesture/TapRecognizer","./layer/TectonicPlatesLayer","./globe/Terrain","./globe/TerrainTile","./globe/TerrainTileList","./globe/Tessellator","./shapes/Text","./shapes/TextAttributes","./render/TextSupport","./render/Texture","./render/TextureTile","./util/Tile","./layer/TiledImageLayer","./util/TileFactory","./gesture/TiltRecognizer","./gesture/Touch","./shapes/TriangleMesh","./error/UnsupportedOperationError","./geom/Vec2","./geom/Vec3","./layer/ViewControlsLayer","./formats/kml/util/ViewVolume","./util/WcsTileUrlBuilder","./ogc/WfsCapabilities","./ogc/WmsCapabilities","./layer/WmsLayer","./ogc/WmsLayerCapabilities","./layer/WmsTimeDimensionedLayer","./util/WmsUrlBuilder","./ogc/WmtsCapabilities","./layer/WmtsLayer","./ogc/WmtsLayerCapabilities","./WorldWindow","./util/WWMath","./util/WWMessage","./util/WWUtil","./util/XmlDocument","./globe/ZeroElevationModel"],function(t,e,i,r,n,o,s,a,l,h,u,c,d,p,f,g,m,E,y,_,v,b,S,T,L,w,x,R,M,C,A,P,O,I,N,D,V,k,F,G,W,B,U,j,K,z,q,H,Y,X,J,Z,Q,$,tt,et,it,rt,nt,ot,st,at,lt,ht,ut,ct,dt,pt,ft,gt,mt,Et,yt,_t,vt,bt,St,Tt,Lt,wt,xt,Rt,Mt,Ct,At,Pt,Ot,It,Nt,Dt,Vt,kt,Ft,Gt,Wt,Bt,Ut,jt,Kt,zt,qt,Ht,Yt,Xt,Jt,Zt,Qt,$t,te,ee,ie,re,ne,oe,se,ae,le,he,ue,ce,de,pe,fe,ge,me,Ee,ye,_e,ve,be,Se,Te,Le,we,xe,Re,Me,Ce,Ae,Pe,Oe,Ie,Ne,De,Ve,ke,Fe,Ge,We,Be,Ue,je,Ke,ze,qe,He,Ye,Xe,Je,Ze,Qe,$e,ti,ei,ii,ri,ni,oi,si,ai,li,hi,ui,ci,di,pi,fi,gi,mi,Ei,yi,_i,vi,bi,Si,Ti,Li,wi,xi,Ri,Mi,Ci,Ai,Pi,Oi,Ii,Ni,Di,Vi,ki,Fi,Gi,Wi,Bi,Ui,ji,Ki,zi,qi,Hi,Yi,Xi,Ji,Zi,Qi,$i){"use strict";var tr={VERSION:"0.0.0",ABSOLUTE:"absolute",AFTER_REDRAW:"afterRedraw",BEFORE_REDRAW:"beforeRedraw",BEGAN:"began",CANCELLED:"cancelled",CHANGED:"changed",CLAMP_TO_GROUND:"clampToGround",EARTH_RADIUS:6371e3,EAST:"east",ENDED:"ended",FAILED:"failed",GREAT_CIRCLE:"greatCircle",LINEAR:"linear",MULTI_POINT:"multiPoint",NORTH:"north",NULL:"null",OFFSET_FRACTION:"fraction",OFFSET_INSET_PIXELS:"insetPixels",OFFSET_PIXELS:"pixels",POINT:"point",POLYLINE:"polyline",POLYGON:"polygon",POSSIBLE:"possible",RECOGNIZED:"recognized",REDRAW_EVENT_TYPE:"WorldWindRedraw",RELATIVE_TO_GLOBE:"relativeToGlobe",RELATIVE_TO_GROUND:"relativeToGround",RELATIVE_TO_SCREEN:"relativeToScreen",RHUMB_LINE:"rhumbLine",SOUTH:"south",WEST:"west"};return tr.AbstractError=t,tr.Angle=e,tr.Annotation=i,tr.AnnotationAttributes=r,tr.ArgumentError=n,tr.AtmosphereLayer=o,tr.AtmosphereProgram=s,tr.BasicProgram=a,tr.BasicTextureProgram=l,tr.BasicTimeSequence=h,tr.BingAerialLayer=u,tr.BingAerialWithLabelsLayer=c,tr.BingRoadsLayer=d,tr.BingWMSLayer=p,tr.BlueMarbleLayer=f,tr.BMNGLandsatLayer=g,tr.BMNGLayer=m,tr.BMNGOneImageLayer=E,tr.BoundingBox=y,tr.ClickRecognizer=_,tr.ColladaLoader=v,tr.Color=b,tr.Compass=S,tr.CompassLayer=T,tr.CoordinatesDisplayLayer=L,tr.DateWW=w,tr.DigitalGlobeTiledImageLayer=x,tr.DragRecognizer=R,tr.DrawContext=M,tr.EarthElevationModel=C,tr.EarthRestElevationModel=A,tr.ElevationModel=P,tr.Font=O,tr.FrameStatistics=I,tr.FrameStatisticsLayer=N,tr.FramebufferTexture=D,tr.FramebufferTile=V,tr.FramebufferTileController=k,tr.Frustum=F,tr.GeographicMesh=G,tr.GeographicProjection=W,tr.GeographicText=B,tr.GeoJSONGeometry=U,tr.GeoJSONGeometryCollection=j,tr.GeoJSONGeometryLineString=K,tr.GeoJSONGeometryMultiLineString=z,tr.GeoJSONGeometryMultiPoint=q,tr.GeoJSONGeometryMultiPolygon=H,tr.GeoJSONGeometryPoint=Y,tr.GeoJSONGeometryPolygon=X,tr.GeoJSONParser=J,tr.GeoTiffReader=Z,tr.GestureRecognizer=Q,tr.Globe=$,tr.Globe2D=tt,tr.GoToAnimator=et,tr.GpuProgram=it,tr.GpuResourceCache=rt,tr.GpuShader=nt,tr.GroundProgram=ot,tr.HighlightController=st,tr.ImageSource=lt,tr.ImageTile=ht,tr.Insets=ut,tr.KmlFile=vt,tr.LandsatRestLayer=oe,tr.Layer=se,tr.Level=ae,tr.LevelRowColumnUrlBuilder=le,tr.LevelSet=he,tr.Line=ue,tr.Location=ce,tr.Logger=de,tr.LookAtNavigator=pe,tr.Matrix=fe,tr.MemoryCache=ge,tr.MemoryCacheListener=me,tr.MercatorTiledImageLayer=Ee,tr.Navigator=ye,tr.NavigatorState=_e,tr.NominatimGeocoder=ve,tr.NotYetImplementedError=be,tr.Offset=Se,tr.OpenStreetMapImageLayer=Te,tr.PanRecognizer=we,tr.Path=xe,tr.PeriodicTimeSequence=Re,tr.PickedObject=Me,tr.PickedObjectList=Ce,tr.PinchRecognizer=Ae,tr.Placemark=Pe,tr.PlacemarkAttributes=Oe,tr.Plane=Ie,tr.Polygon=Ne,tr.Position=De,tr.ProjectionEquirectangular=Ve,tr.ProjectionGnomonic=ke,tr.ProjectionMercator=Fe,tr.ProjectionPolarEquidistant=Ge,tr.ProjectionUPS=We,tr.ProjectionWgs84=Be,tr.Rectangle=Ue,tr.Renderable=je,tr.RenderableLayer=Ke,tr.RestTiledImageLayer=ze,tr.RotationRecognizer=qe,tr.ScreenText=Je,tr.ScreenImage=Xe,tr.Sector=Ze,tr.ShapeAttributes=Qe,tr.Shapefile=$e,tr.ShowTessellationLayer=ti,tr.SkyProgram=ei,tr.SurfaceImage=ii,tr.SurfaceCircle=ri,tr.SurfaceEllipse=ni,tr.SurfacePolygon=oi,tr.SurfacePolyline=si,tr.SurfaceRectangle=ai,tr.SurfaceRenderable=li,tr.SurfaceSector=hi,tr.SurfaceShape=ui,tr.SurfaceShapeTile=ci,tr.SurfaceShapeTileBuilder=di,tr.SurfaceTile=pi,tr.SurfaceTileRenderer=fi,tr.SurfaceTileRendererProgram=gi,tr.TapRecognizer=mi,tr.TectonicPlatesLayer=Ei,tr.Terrain=yi,tr.TerrainTile=_i,tr.TerrainTileList=vi,tr.Tessellator=bi,tr.Text=Si,tr.TextAttributes=Ti,tr.TextSupport=Li,tr.Texture=wi,tr.TextureTile=xi,tr.Tile=Ri,tr.TiledImageLayer=Mi,tr.TileFactory=Ci,tr.TiltRecognizer=Ai,tr.Touch=Pi,tr.TriangleMesh=Oi,tr.UnsupportedOperationError=Ii,tr.Vec2=Ni,tr.Vec3=Di,tr.ViewControlsLayer=Vi,tr.WcsTileUrlBuilder=Fi,tr.WfsCapabilities=Gi,tr.WmsCapabilities=Wi,tr.WmsLayer=Bi,tr.WmsLayerCapabilities=Ui,tr.WmsTimeDimensionedLayer=ji,tr.WmsUrlBuilder=Ki,tr.WmtsCapabilities=zi,tr.WmtsLayer=qi,tr.WmtsLayerCapabilities=Hi,tr.WWMath=Xi,tr.WWMessage=Ji,tr.WWUtil=Zi,tr.WorldWindow=Yi,tr.ZeroElevationModel=$i,tr.configuration={gpuCacheSize:25e7,baseUrl:Zi.worldwindlibLocation()||Zi.currentUrlSansFilePart()+"/../"},tr.BingMapsKey=null,window.WorldWind=tr,tr}),e("WorldWind")});